#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 4225
#define SYMBOL_COUNT 155
#define ALIAS_COUNT 2
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 15
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  sym_regex = 10,
  anon_sym_for = 11,
  anon_sym_in = 12,
  anon_sym_LPAREN_LPAREN = 13,
  anon_sym_RPAREN_RPAREN = 14,
  anon_sym_SEMI = 15,
  anon_sym_while = 16,
  anon_sym_do = 17,
  anon_sym_done = 18,
  anon_sym_if = 19,
  anon_sym_then = 20,
  anon_sym_fi = 21,
  anon_sym_elif = 22,
  anon_sym_else = 23,
  anon_sym_case = 24,
  anon_sym_esac = 25,
  anon_sym_PIPE = 26,
  anon_sym_RPAREN = 27,
  anon_sym_SEMI_SEMI = 28,
  anon_sym_function = 29,
  anon_sym_LPAREN = 30,
  anon_sym_LBRACE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_PIPE_AMP = 33,
  anon_sym_AMP_AMP = 34,
  anon_sym_PIPE_PIPE = 35,
  anon_sym_BANG = 36,
  anon_sym_LBRACK = 37,
  anon_sym_RBRACK = 38,
  anon_sym_LBRACK_LBRACK = 39,
  anon_sym_RBRACK_RBRACK = 40,
  anon_sym_declare = 41,
  anon_sym_typeset = 42,
  anon_sym_export = 43,
  anon_sym_readonly = 44,
  anon_sym_local = 45,
  anon_sym_unset = 46,
  anon_sym_unsetenv = 47,
  anon_sym_EQ_TILDE = 48,
  anon_sym_EQ_EQ = 49,
  anon_sym_EQ = 50,
  anon_sym_PLUS_EQ = 51,
  anon_sym_LT = 52,
  anon_sym_GT = 53,
  anon_sym_GT_GT = 54,
  anon_sym_AMP_GT = 55,
  anon_sym_AMP_GT_GT = 56,
  anon_sym_LT_AMP = 57,
  anon_sym_GT_AMP = 58,
  anon_sym_LT_LT = 59,
  anon_sym_LT_LT_DASH = 60,
  anon_sym_LT_LT_LT = 61,
  anon_sym_BANG_EQ = 62,
  anon_sym_PLUS = 63,
  anon_sym_DASH = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_LT_EQ = 66,
  anon_sym_GT_EQ = 67,
  anon_sym_PLUS_PLUS = 68,
  anon_sym_DASH_DASH = 69,
  sym__special_characters = 70,
  anon_sym_DQUOTE = 71,
  anon_sym_DOLLAR = 72,
  sym__string_content = 73,
  sym_raw_string = 74,
  anon_sym_POUND = 75,
  anon_sym_DOLLAR_LBRACE = 76,
  anon_sym_SLASH = 77,
  anon_sym_COLON = 78,
  anon_sym_COLON_QMARK = 79,
  anon_sym_COLON_DASH = 80,
  anon_sym_PERCENT = 81,
  anon_sym_DOLLAR_LPAREN = 82,
  anon_sym_BQUOTE = 83,
  anon_sym_LT_LPAREN = 84,
  anon_sym_GT_LPAREN = 85,
  sym_comment = 86,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 87,
  anon_sym_STAR = 88,
  anon_sym_AT = 89,
  anon_sym_QMARK = 90,
  anon_sym_0 = 91,
  anon_sym__ = 92,
  sym_word = 93,
  sym_test_operator = 94,
  anon_sym_LF = 95,
  anon_sym_AMP = 96,
  sym_program = 97,
  sym__statements = 98,
  sym__terminated_statement = 99,
  sym_redirected_statement = 100,
  sym_for_statement = 101,
  sym_c_style_for_statement = 102,
  sym_while_statement = 103,
  sym_do_group = 104,
  sym_if_statement = 105,
  sym_elif_clause = 106,
  sym_else_clause = 107,
  sym_case_statement = 108,
  sym_case_item = 109,
  sym_last_case_item = 110,
  sym_function_definition = 111,
  sym_compound_statement = 112,
  sym_subshell = 113,
  sym_pipeline = 114,
  sym_list = 115,
  sym_negated_command = 116,
  sym_test_command = 117,
  sym_declaration_command = 118,
  sym_unset_command = 119,
  sym_command = 120,
  sym_command_name = 121,
  sym_variable_assignment = 122,
  sym_subscript = 123,
  sym_file_redirect = 124,
  sym_heredoc_redirect = 125,
  sym_heredoc_body = 126,
  sym_herestring_redirect = 127,
  sym__expression = 128,
  sym_binary_expression = 129,
  sym_unary_expression = 130,
  sym_postfix_expression = 131,
  sym_parenthesized_expression = 132,
  sym_concatenation = 133,
  sym_string = 134,
  sym_array = 135,
  sym_simple_expansion = 136,
  sym_string_expansion = 137,
  sym_expansion = 138,
  sym_command_substitution = 139,
  sym_process_substitution = 140,
  aux_sym__statements_repeat1 = 141,
  aux_sym_redirected_statement_repeat1 = 142,
  aux_sym_for_statement_repeat1 = 143,
  aux_sym_if_statement_repeat1 = 144,
  aux_sym_case_statement_repeat1 = 145,
  aux_sym_case_item_repeat1 = 146,
  aux_sym_declaration_command_repeat1 = 147,
  aux_sym_unset_command_repeat1 = 148,
  aux_sym_command_repeat1 = 149,
  aux_sym_command_repeat2 = 150,
  aux_sym_heredoc_body_repeat1 = 151,
  aux_sym_concatenation_repeat1 = 152,
  aux_sym_string_repeat1 = 153,
  aux_sym_expansion_repeat1 = 154,
  alias_sym_special_variable_name = 155,
  alias_sym_word = 156,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [sym_regex] = "regex",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_SEMI] = ";",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR] = "$",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "variable_name",
  [anon_sym_STAR] = "special_variable_name",
  [anon_sym_AT] = "special_variable_name",
  [anon_sym_QMARK] = "special_variable_name",
  [anon_sym_0] = "special_variable_name",
  [anon_sym__] = "special_variable_name",
  [sym_word] = "word",
  [sym_test_operator] = "test_operator",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_redirected_statement] = "redirected_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_redirected_statement_repeat1] = "redirected_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_redirected_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_redirected_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [1] = alias_sym_word,
  },
  [3] = {
    [1] = alias_sym_special_variable_name,
  },
  [4] = {
    [2] = alias_sym_word,
  },
  [5] = {
    [2] = alias_sym_special_variable_name,
  },
  [6] = {
    [3] = alias_sym_word,
  },
  [7] = {
    [4] = alias_sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '+')
        ADVANCE(22);
      if (lookahead == '-')
        ADVANCE(25);
      if (lookahead == '/')
        ADVANCE(29);
      if (lookahead == '0')
        ADVANCE(30);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(36);
      if (lookahead == '=')
        ADVANCE(43);
      if (lookahead == '>')
        ADVANCE(46);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(55);
      if (lookahead == ']')
        ADVANCE(56);
      if (lookahead == '_')
        ADVANCE(58);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == 'i')
        ADVANCE(71);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      ADVANCE(5);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 4:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 16:
      if (lookahead == '\'')
        ADVANCE(17);
      if (lookahead != 0)
        ADVANCE(16);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '(')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(26);
      if (lookahead == '=')
        ADVANCE(27);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(32);
      if (lookahead == '?')
        ADVANCE(33);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '<')
        ADVANCE(39);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(40);
      if (lookahead == '<')
        ADVANCE(41);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '(')
        ADVANCE(48);
      if (lookahead == '=')
        ADVANCE(49);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 55:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(61);
      if (lookahead == 's')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(62);
      if (lookahead == 's')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(75);
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 78:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(83);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(78);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(79);
      END_STATE();
    case 80:
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '(')
        ADVANCE(48);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 83:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(78);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      END_STATE();
    case 85:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(86);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '=')
        ADVANCE(89);
      if (lookahead == '[')
        ADVANCE(90);
      if (lookahead == '\\')
        SKIP(91);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(85);
      END_STATE();
    case 86:
      if (lookahead == '=')
        ADVANCE(87);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 88:
      if (lookahead == ';')
        ADVANCE(35);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 91:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(85);
      END_STATE();
    case 92:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '(')
        ADVANCE(93);
      if (lookahead == '\\')
        SKIP(94);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 93:
      if (lookahead == '(')
        ADVANCE(19);
      END_STATE();
    case 94:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(92);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 96:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(101);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(96);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 99:
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 100:
      if (lookahead == '(')
        ADVANCE(48);
      END_STATE();
    case 101:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(96);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 102:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(103);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(102);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 103:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(102);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 104:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(105);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 105:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 106:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(107);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(106);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 107:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(106);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 108:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(110);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '<')
        ADVANCE(39);
      END_STATE();
    case 110:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(108);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 112:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(114);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 114:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 115:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(116);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\\')
        ADVANCE(120);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(121);
      if (lookahead != 0)
        ADVANCE(117);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(117);
      if (lookahead == '\\')
        ADVANCE(119);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(117);
      END_STATE();
    case 118:
      if (lookahead == '\n')
        ADVANCE(117);
      if (lookahead != 0)
        ADVANCE(117);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n')
        ADVANCE(117);
      if (lookahead != 0)
        ADVANCE(116);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(121);
      if (lookahead != 0)
        ADVANCE(117);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(116);
      if (lookahead == '\\')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(121);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(117);
      END_STATE();
    case 122:
      if (lookahead == '!')
        ADVANCE(123);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '-')
        ADVANCE(126);
      if (lookahead == '0')
        ADVANCE(127);
      if (lookahead == '?')
        ADVANCE(128);
      if (lookahead == '@')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(130);
      if (lookahead == '_')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 130:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 132:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 133:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 134:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '\\')
        SKIP(135);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 135:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 136:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(139);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '<')
        ADVANCE(39);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 139:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      END_STATE();
    case 140:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(141);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 141:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 142:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(143);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 143:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 144:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(145);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 145:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(148);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(146);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 148:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(146);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 149:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(150);
      if (lookahead == 'i')
        ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(149);
      END_STATE();
    case 150:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(149);
      END_STATE();
    case 151:
      if (lookahead == 'n')
        ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 153:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(170);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(153);
      END_STATE();
    case 154:
      if (lookahead == '=')
        ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 156:
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 157:
      if (lookahead == ')')
        ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(87);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(162);
      if (lookahead == '=')
        ADVANCE(163);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(164);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(167);
      if (lookahead == '~')
        ADVANCE(168);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(49);
      END_STATE();
    case 170:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(153);
      END_STATE();
    case 171:
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 172:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '\\')
        SKIP(173);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      END_STATE();
    case 173:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      END_STATE();
    case 174:
      if (lookahead == 'o')
        ADVANCE(175);
      END_STATE();
    case 175:
      if (lookahead == 'n')
        ADVANCE(176);
      END_STATE();
    case 176:
      if (lookahead == 'e')
        ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 178:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(179);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 179:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(181);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 181:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 182:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(183);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      END_STATE();
    case 183:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      END_STATE();
    case 184:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(185);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 185:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 186:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(187);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      END_STATE();
    case 187:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      END_STATE();
    case 188:
      if (lookahead == 'l')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(194);
      END_STATE();
    case 189:
      if (lookahead == 'i')
        ADVANCE(190);
      if (lookahead == 's')
        ADVANCE(192);
      END_STATE();
    case 190:
      if (lookahead == 'f')
        ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 192:
      if (lookahead == 'e')
        ADVANCE(193);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 194:
      if (lookahead == 'a')
        ADVANCE(195);
      END_STATE();
    case 195:
      if (lookahead == 'c')
        ADVANCE(196);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 197:
      if (lookahead == 'i')
        ADVANCE(198);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(200);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 200:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 201:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(202);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 202:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 203:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(204);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 204:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 205:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(206);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      END_STATE();
    case 206:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(208);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 208:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 209:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 210:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 212:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == ']')
        ADVANCE(214);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 213:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 214:
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 215:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(216);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 216:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 217:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '-')
        ADVANCE(126);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == '?')
        ADVANCE(128);
      if (lookahead == '@')
        ADVANCE(129);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == '_')
        ADVANCE(222);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      if (lookahead != 0 &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(117);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        ADVANCE(221);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (lookahead != 0)
        ADVANCE(117);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '-')
        ADVANCE(126);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == '?')
        ADVANCE(128);
      if (lookahead == '@')
        ADVANCE(129);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == '_')
        ADVANCE(222);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(117);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 223:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '-')
        ADVANCE(126);
      if (lookahead == '0')
        ADVANCE(127);
      if (lookahead == '?')
        ADVANCE(128);
      if (lookahead == '@')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '_')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 224:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      END_STATE();
    case 225:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '/')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '=')
        ADVANCE(227);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(228);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 228:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 229:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 230:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 231:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(232);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 232:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 233:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(234);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if ((lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 234:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 235:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(236);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      END_STATE();
    case 236:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      END_STATE();
    case 237:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(238);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 238:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 239:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(240);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 240:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(242);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 243:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 244:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(245);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      END_STATE();
    case 245:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      END_STATE();
    case 246:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(247);
      if (lookahead == ']')
        ADVANCE(214);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 248:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(249);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(250);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 249:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'o')
        ADVANCE(251);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(253);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 254:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(255);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(256);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 255:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 257:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 258:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 259:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(260);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 260:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 261:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '=')
        ADVANCE(227);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(262);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 262:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 263:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '+')
        ADVANCE(86);
      if (lookahead == '=')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(264);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      END_STATE();
    case 264:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      END_STATE();
    case 265:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(266);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(265);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 266:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(265);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(268);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(267);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 268:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(267);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 269:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(270);
      if (lookahead == '|')
        ADVANCE(271);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(269);
      END_STATE();
    case 270:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(269);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 272:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(273);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(274);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 273:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'o')
        ADVANCE(275);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(276);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(277);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 278:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(279);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(250);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(278);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 279:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(278);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 280:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(281);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(250);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(280);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 281:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(280);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 282:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(283);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(282);
      END_STATE();
    case 283:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(282);
      END_STATE();
    case 284:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(285);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(250);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(284);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 285:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(284);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 286:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(287);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 287:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 288:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(289);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(290);
      if (lookahead == 'f')
        ADVANCE(296);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(288);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 289:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(288);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(294);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(295);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 298:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(299);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(256);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 299:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 300:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(301);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(256);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(300);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 301:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(300);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 302:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(303);
      if (lookahead == 'e')
        ADVANCE(304);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(302);
      END_STATE();
    case 303:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(302);
      END_STATE();
    case 304:
      if (lookahead == 'l')
        ADVANCE(189);
      END_STATE();
    case 305:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(306);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(256);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 306:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 307:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(308);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(309);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 308:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 310:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ';')
        ADVANCE(311);
      if (lookahead == '\\')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 312:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 313:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(314);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      END_STATE();
    case 314:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      END_STATE();
    case 315:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(296);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(315);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 316:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(315);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 317:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(318);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 318:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 319:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(320);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(319);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 320:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(319);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 321:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(322);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(321);
      END_STATE();
    case 322:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(321);
      END_STATE();
    case 323:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(324);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 324:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 325:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(326);
      if (lookahead == 'e')
        ADVANCE(304);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(325);
      END_STATE();
    case 326:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(325);
      END_STATE();
    case 327:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '\\')
        SKIP(328);
      if (lookahead == '|')
        ADVANCE(329);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(327);
      END_STATE();
    case 328:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(327);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 330:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(331);
      if (lookahead == 'e')
        ADVANCE(332);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      END_STATE();
    case 331:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      END_STATE();
    case 332:
      if (lookahead == 's')
        ADVANCE(194);
      END_STATE();
    case 333:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(334);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(309);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 334:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 335:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(336);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(335);
      END_STATE();
    case 336:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(335);
      END_STATE();
    case 337:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(338);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(339);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 338:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(337);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(340);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(342);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 343:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(344);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(309);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(343);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 344:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(343);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 345:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(346);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(309);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(345);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 346:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(345);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 347:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(348);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(309);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(347);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 348:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(347);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 349:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(350);
      if (lookahead == 'e')
        ADVANCE(332);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      END_STATE();
    case 350:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'c')
        ADVANCE(1);
      if (lookahead == 'd')
        ADVANCE(5);
      if (lookahead == 'e')
        ADVANCE(13);
      if (lookahead == 'f')
        ADVANCE(19);
      if (lookahead == 'i')
        ADVANCE(29);
      if (lookahead == 'l')
        ADVANCE(31);
      if (lookahead == 'r')
        ADVANCE(36);
      if (lookahead == 't')
        ADVANCE(44);
      if (lookahead == 'u')
        ADVANCE(54);
      if (lookahead == 'w')
        ADVANCE(62);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 5:
      if (lookahead == 'e')
        ADVANCE(6);
      if (lookahead == 'o')
        ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'l')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'a')
        ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == 'r')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 13:
      if (lookahead == 'x')
        ADVANCE(14);
      END_STATE();
    case 14:
      if (lookahead == 'p')
        ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == 'o')
        ADVANCE(16);
      END_STATE();
    case 16:
      if (lookahead == 'r')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 't')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 19:
      if (lookahead == 'o')
        ADVANCE(20);
      if (lookahead == 'u')
        ADVANCE(22);
      END_STATE();
    case 20:
      if (lookahead == 'r')
        ADVANCE(21);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 22:
      if (lookahead == 'n')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'c')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 't')
        ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == 'i')
        ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 'n')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 29:
      if (lookahead == 'f')
        ADVANCE(30);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 31:
      if (lookahead == 'o')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 'c')
        ADVANCE(33);
      END_STATE();
    case 33:
      if (lookahead == 'a')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'l')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 36:
      if (lookahead == 'e')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 'a')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'd')
        ADVANCE(39);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 'n')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'y')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 44:
      if (lookahead == 'h')
        ADVANCE(45);
      if (lookahead == 'y')
        ADVANCE(48);
      END_STATE();
    case 45:
      if (lookahead == 'e')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'n')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 48:
      if (lookahead == 'p')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'e')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 's')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'e')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 't')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 54:
      if (lookahead == 'n')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 's')
        ADVANCE(56);
      END_STATE();
    case 56:
      if (lookahead == 'e')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == 't')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'n')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'v')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    case 62:
      if (lookahead == 'h')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 'i')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'l')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'e')
        ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 78, .external_lex_state = 2},
  [2] = {.lex_state = 78},
  [3] = {.lex_state = 85},
  [4] = {.lex_state = 92},
  [5] = {.lex_state = 96},
  [6] = {.lex_state = 78, .external_lex_state = 2},
  [7] = {.lex_state = 78, .external_lex_state = 2},
  [8] = {.lex_state = 102},
  [9] = {.lex_state = 102},
  [10] = {.lex_state = 78, .external_lex_state = 2},
  [11] = {.lex_state = 104, .external_lex_state = 3},
  [12] = {.lex_state = 106, .external_lex_state = 2},
  [13] = {.lex_state = 96},
  [14] = {.lex_state = 96},
  [15] = {.lex_state = 108, .external_lex_state = 4},
  [16] = {.lex_state = 108, .external_lex_state = 5},
  [17] = {.lex_state = 102},
  [18] = {.lex_state = 112, .external_lex_state = 6},
  [19] = {.lex_state = 115},
  [20] = {.lex_state = 122},
  [21] = {.lex_state = 112, .external_lex_state = 6},
  [22] = {.lex_state = 122, .external_lex_state = 7},
  [23] = {.lex_state = 78, .external_lex_state = 2},
  [24] = {.lex_state = 78, .external_lex_state = 2},
  [25] = {.lex_state = 78, .external_lex_state = 2},
  [26] = {.lex_state = 132, .external_lex_state = 6},
  [27] = {.lex_state = 134},
  [28] = {.lex_state = 134},
  [29] = {.lex_state = 136, .external_lex_state = 5},
  [30] = {.lex_state = 112, .external_lex_state = 5},
  [31] = {.lex_state = 140, .external_lex_state = 4},
  [32] = {.lex_state = 85},
  [33] = {.lex_state = 142, .external_lex_state = 5},
  [34] = {.lex_state = 78, .external_lex_state = 2},
  [35] = {.lex_state = 102, .external_lex_state = 2},
  [36] = {.lex_state = 102},
  [37] = {.lex_state = 102},
  [38] = {.lex_state = 144, .external_lex_state = 8},
  [39] = {.lex_state = 146, .external_lex_state = 9},
  [40] = {.lex_state = 149, .external_lex_state = 9},
  [41] = {.lex_state = 96},
  [42] = {.lex_state = 96},
  [43] = {.lex_state = 153, .external_lex_state = 10},
  [44] = {.lex_state = 115},
  [45] = {.lex_state = 122},
  [46] = {.lex_state = 153, .external_lex_state = 10},
  [47] = {.lex_state = 122, .external_lex_state = 7},
  [48] = {.lex_state = 78, .external_lex_state = 2},
  [49] = {.lex_state = 78, .external_lex_state = 2},
  [50] = {.lex_state = 78, .external_lex_state = 2},
  [51] = {.lex_state = 153},
  [52] = {.lex_state = 85},
  [53] = {.lex_state = 92},
  [54] = {.lex_state = 96},
  [55] = {.lex_state = 78, .external_lex_state = 2},
  [56] = {.lex_state = 78, .external_lex_state = 2},
  [57] = {.lex_state = 102},
  [58] = {.lex_state = 102},
  [59] = {.lex_state = 78, .external_lex_state = 2},
  [60] = {.lex_state = 104, .external_lex_state = 3},
  [61] = {.lex_state = 106, .external_lex_state = 2},
  [62] = {.lex_state = 96},
  [63] = {.lex_state = 96},
  [64] = {.lex_state = 108, .external_lex_state = 11},
  [65] = {.lex_state = 108, .external_lex_state = 12},
  [66] = {.lex_state = 112, .external_lex_state = 13},
  [67] = {.lex_state = 115},
  [68] = {.lex_state = 122},
  [69] = {.lex_state = 112, .external_lex_state = 13},
  [70] = {.lex_state = 122, .external_lex_state = 7},
  [71] = {.lex_state = 78, .external_lex_state = 2},
  [72] = {.lex_state = 78, .external_lex_state = 2},
  [73] = {.lex_state = 78, .external_lex_state = 2},
  [74] = {.lex_state = 132, .external_lex_state = 13},
  [75] = {.lex_state = 102},
  [76] = {.lex_state = 136, .external_lex_state = 12},
  [77] = {.lex_state = 112, .external_lex_state = 12},
  [78] = {.lex_state = 140, .external_lex_state = 11},
  [79] = {.lex_state = 85},
  [80] = {.lex_state = 112, .external_lex_state = 12},
  [81] = {.lex_state = 102, .external_lex_state = 2},
  [82] = {.lex_state = 102},
  [83] = {.lex_state = 149, .external_lex_state = 14},
  [84] = {.lex_state = 115},
  [85] = {.lex_state = 122},
  [86] = {.lex_state = 149, .external_lex_state = 14},
  [87] = {.lex_state = 122, .external_lex_state = 7},
  [88] = {.lex_state = 78, .external_lex_state = 2},
  [89] = {.lex_state = 78, .external_lex_state = 2},
  [90] = {.lex_state = 78, .external_lex_state = 2},
  [91] = {.lex_state = 149, .external_lex_state = 9},
  [92] = {.lex_state = 172},
  [93] = {.lex_state = 85},
  [94] = {.lex_state = 106, .external_lex_state = 2},
  [95] = {.lex_state = 178, .external_lex_state = 4},
  [96] = {.lex_state = 178, .external_lex_state = 5},
  [97] = {.lex_state = 142, .external_lex_state = 6},
  [98] = {.lex_state = 142, .external_lex_state = 6},
  [99] = {.lex_state = 180, .external_lex_state = 6},
  [100] = {.lex_state = 85},
  [101] = {.lex_state = 182, .external_lex_state = 5},
  [102] = {.lex_state = 142, .external_lex_state = 5},
  [103] = {.lex_state = 184, .external_lex_state = 4},
  [104] = {.lex_state = 85},
  [105] = {.lex_state = 78, .external_lex_state = 2},
  [106] = {.lex_state = 102, .external_lex_state = 2},
  [107] = {.lex_state = 85},
  [108] = {.lex_state = 92},
  [109] = {.lex_state = 96},
  [110] = {.lex_state = 78, .external_lex_state = 2},
  [111] = {.lex_state = 78, .external_lex_state = 2},
  [112] = {.lex_state = 102},
  [113] = {.lex_state = 102},
  [114] = {.lex_state = 78, .external_lex_state = 2},
  [115] = {.lex_state = 104, .external_lex_state = 3},
  [116] = {.lex_state = 186, .external_lex_state = 5},
  [117] = {.lex_state = 106, .external_lex_state = 2},
  [118] = {.lex_state = 96},
  [119] = {.lex_state = 96},
  [120] = {.lex_state = 199, .external_lex_state = 15},
  [121] = {.lex_state = 199, .external_lex_state = 16},
  [122] = {.lex_state = 201, .external_lex_state = 17},
  [123] = {.lex_state = 115},
  [124] = {.lex_state = 122},
  [125] = {.lex_state = 201, .external_lex_state = 17},
  [126] = {.lex_state = 122, .external_lex_state = 7},
  [127] = {.lex_state = 78, .external_lex_state = 2},
  [128] = {.lex_state = 78, .external_lex_state = 2},
  [129] = {.lex_state = 78, .external_lex_state = 2},
  [130] = {.lex_state = 203, .external_lex_state = 17},
  [131] = {.lex_state = 92, .external_lex_state = 18},
  [132] = {.lex_state = 205, .external_lex_state = 16},
  [133] = {.lex_state = 201, .external_lex_state = 16},
  [134] = {.lex_state = 207, .external_lex_state = 15},
  [135] = {.lex_state = 85},
  [136] = {.lex_state = 201, .external_lex_state = 16},
  [137] = {.lex_state = 78, .external_lex_state = 2},
  [138] = {.lex_state = 102, .external_lex_state = 2},
  [139] = {.lex_state = 85},
  [140] = {.lex_state = 186, .external_lex_state = 5},
  [141] = {.lex_state = 85},
  [142] = {.lex_state = 96},
  [143] = {.lex_state = 96},
  [144] = {.lex_state = 209, .external_lex_state = 19},
  [145] = {.lex_state = 115},
  [146] = {.lex_state = 122},
  [147] = {.lex_state = 209, .external_lex_state = 19},
  [148] = {.lex_state = 122, .external_lex_state = 7},
  [149] = {.lex_state = 78, .external_lex_state = 2},
  [150] = {.lex_state = 78, .external_lex_state = 2},
  [151] = {.lex_state = 78, .external_lex_state = 2},
  [152] = {.lex_state = 209, .external_lex_state = 20},
  [153] = {.lex_state = 96},
  [154] = {.lex_state = 212, .external_lex_state = 10},
  [155] = {.lex_state = 212, .external_lex_state = 10},
  [156] = {.lex_state = 212},
  [157] = {.lex_state = 85},
  [158] = {.lex_state = 108, .external_lex_state = 21},
  [159] = {.lex_state = 115},
  [160] = {.lex_state = 122},
  [161] = {.lex_state = 108, .external_lex_state = 21},
  [162] = {.lex_state = 122, .external_lex_state = 7},
  [163] = {.lex_state = 78, .external_lex_state = 2},
  [164] = {.lex_state = 78, .external_lex_state = 2},
  [165] = {.lex_state = 78, .external_lex_state = 2},
  [166] = {.lex_state = 85},
  [167] = {.lex_state = 108, .external_lex_state = 4},
  [168] = {.lex_state = 108, .external_lex_state = 6},
  [169] = {.lex_state = 115},
  [170] = {.lex_state = 122},
  [171] = {.lex_state = 108, .external_lex_state = 6},
  [172] = {.lex_state = 122, .external_lex_state = 7},
  [173] = {.lex_state = 78, .external_lex_state = 2},
  [174] = {.lex_state = 78, .external_lex_state = 2},
  [175] = {.lex_state = 78, .external_lex_state = 2},
  [176] = {.lex_state = 108, .external_lex_state = 5},
  [177] = {.lex_state = 102, .external_lex_state = 22},
  [178] = {.lex_state = 115},
  [179] = {.lex_state = 122},
  [180] = {.lex_state = 102, .external_lex_state = 22},
  [181] = {.lex_state = 122, .external_lex_state = 7},
  [182] = {.lex_state = 78, .external_lex_state = 2},
  [183] = {.lex_state = 78, .external_lex_state = 2},
  [184] = {.lex_state = 78, .external_lex_state = 2},
  [185] = {.lex_state = 215, .external_lex_state = 2},
  [186] = {.lex_state = 102},
  [187] = {.lex_state = 112, .external_lex_state = 6},
  [188] = {.lex_state = 142, .external_lex_state = 6},
  [189] = {.lex_state = 217},
  [190] = {.lex_state = 115, .external_lex_state = 10},
  [191] = {.lex_state = 122, .external_lex_state = 7},
  [192] = {.lex_state = 78, .external_lex_state = 2},
  [193] = {.lex_state = 78, .external_lex_state = 2},
  [194] = {.lex_state = 115},
  [195] = {.lex_state = 142, .external_lex_state = 6},
  [196] = {.lex_state = 142, .external_lex_state = 6},
  [197] = {.lex_state = 142, .external_lex_state = 6},
  [198] = {.lex_state = 85},
  [199] = {.lex_state = 223, .external_lex_state = 7},
  [200] = {.lex_state = 225, .external_lex_state = 18},
  [201] = {.lex_state = 225, .external_lex_state = 18},
  [202] = {.lex_state = 78},
  [203] = {.lex_state = 102},
  [204] = {.lex_state = 85},
  [205] = {.lex_state = 215, .external_lex_state = 2},
  [206] = {.lex_state = 85},
  [207] = {.lex_state = 106, .external_lex_state = 2},
  [208] = {.lex_state = 108, .external_lex_state = 4},
  [209] = {.lex_state = 108, .external_lex_state = 5},
  [210] = {.lex_state = 112, .external_lex_state = 6},
  [211] = {.lex_state = 112, .external_lex_state = 6},
  [212] = {.lex_state = 132, .external_lex_state = 6},
  [213] = {.lex_state = 78},
  [214] = {.lex_state = 229, .external_lex_state = 5},
  [215] = {.lex_state = 112, .external_lex_state = 5},
  [216] = {.lex_state = 140, .external_lex_state = 4},
  [217] = {.lex_state = 85},
  [218] = {.lex_state = 78, .external_lex_state = 2},
  [219] = {.lex_state = 102, .external_lex_state = 2},
  [220] = {.lex_state = 85},
  [221] = {.lex_state = 85},
  [222] = {.lex_state = 231, .external_lex_state = 9},
  [223] = {.lex_state = 96, .external_lex_state = 23},
  [224] = {.lex_state = 78},
  [225] = {.lex_state = 233, .external_lex_state = 2},
  [226] = {.lex_state = 78, .external_lex_state = 2},
  [227] = {.lex_state = 78, .external_lex_state = 2},
  [228] = {.lex_state = 102},
  [229] = {.lex_state = 78, .external_lex_state = 24},
  [230] = {.lex_state = 102},
  [231] = {.lex_state = 235, .external_lex_state = 9},
  [232] = {.lex_state = 136, .external_lex_state = 5},
  [233] = {.lex_state = 237, .external_lex_state = 25},
  [234] = {.lex_state = 112, .external_lex_state = 6},
  [235] = {.lex_state = 112, .external_lex_state = 6},
  [236] = {.lex_state = 112, .external_lex_state = 5},
  [237] = {.lex_state = 136, .external_lex_state = 5},
  [238] = {.lex_state = 140, .external_lex_state = 4},
  [239] = {.lex_state = 78, .external_lex_state = 2},
  [240] = {.lex_state = 112, .external_lex_state = 5},
  [241] = {.lex_state = 102, .external_lex_state = 2},
  [242] = {.lex_state = 102, .external_lex_state = 22},
  [243] = {.lex_state = 102, .external_lex_state = 22},
  [244] = {.lex_state = 215, .external_lex_state = 2},
  [245] = {.lex_state = 239, .external_lex_state = 19},
  [246] = {.lex_state = 239, .external_lex_state = 19},
  [247] = {.lex_state = 239, .external_lex_state = 19},
  [248] = {.lex_state = 184, .external_lex_state = 4},
  [249] = {.lex_state = 215},
  [250] = {.lex_state = 140, .external_lex_state = 21},
  [251] = {.lex_state = 115},
  [252] = {.lex_state = 122},
  [253] = {.lex_state = 140, .external_lex_state = 21},
  [254] = {.lex_state = 122, .external_lex_state = 7},
  [255] = {.lex_state = 78, .external_lex_state = 2},
  [256] = {.lex_state = 78, .external_lex_state = 2},
  [257] = {.lex_state = 78, .external_lex_state = 2},
  [258] = {.lex_state = 146, .external_lex_state = 9},
  [259] = {.lex_state = 96},
  [260] = {.lex_state = 96},
  [261] = {.lex_state = 241, .external_lex_state = 14},
  [262] = {.lex_state = 115},
  [263] = {.lex_state = 122},
  [264] = {.lex_state = 241, .external_lex_state = 14},
  [265] = {.lex_state = 122, .external_lex_state = 7},
  [266] = {.lex_state = 78, .external_lex_state = 2},
  [267] = {.lex_state = 78, .external_lex_state = 2},
  [268] = {.lex_state = 78, .external_lex_state = 2},
  [269] = {.lex_state = 241, .external_lex_state = 9},
  [270] = {.lex_state = 102},
  [271] = {.lex_state = 102},
  [272] = {.lex_state = 96},
  [273] = {.lex_state = 96},
  [274] = {.lex_state = 244, .external_lex_state = 10},
  [275] = {.lex_state = 115},
  [276] = {.lex_state = 122},
  [277] = {.lex_state = 244, .external_lex_state = 10},
  [278] = {.lex_state = 122, .external_lex_state = 7},
  [279] = {.lex_state = 78, .external_lex_state = 2},
  [280] = {.lex_state = 78, .external_lex_state = 2},
  [281] = {.lex_state = 78, .external_lex_state = 2},
  [282] = {.lex_state = 244},
  [283] = {.lex_state = 153},
  [284] = {.lex_state = 102},
  [285] = {.lex_state = 153, .external_lex_state = 10},
  [286] = {.lex_state = 246, .external_lex_state = 10},
  [287] = {.lex_state = 217},
  [288] = {.lex_state = 115},
  [289] = {.lex_state = 246, .external_lex_state = 10},
  [290] = {.lex_state = 246, .external_lex_state = 10},
  [291] = {.lex_state = 246, .external_lex_state = 10},
  [292] = {.lex_state = 85},
  [293] = {.lex_state = 223, .external_lex_state = 7},
  [294] = {.lex_state = 225, .external_lex_state = 18},
  [295] = {.lex_state = 225, .external_lex_state = 18},
  [296] = {.lex_state = 85},
  [297] = {.lex_state = 215, .external_lex_state = 2},
  [298] = {.lex_state = 78},
  [299] = {.lex_state = 85},
  [300] = {.lex_state = 186, .external_lex_state = 5},
  [301] = {.lex_state = 96},
  [302] = {.lex_state = 96, .external_lex_state = 25},
  [303] = {.lex_state = 246},
  [304] = {.lex_state = 144, .external_lex_state = 8},
  [305] = {.lex_state = 146, .external_lex_state = 9},
  [306] = {.lex_state = 149, .external_lex_state = 9},
  [307] = {.lex_state = 153},
  [308] = {.lex_state = 102},
  [309] = {.lex_state = 102},
  [310] = {.lex_state = 149, .external_lex_state = 14},
  [311] = {.lex_state = 149, .external_lex_state = 14},
  [312] = {.lex_state = 149, .external_lex_state = 9},
  [313] = {.lex_state = 172},
  [314] = {.lex_state = 85},
  [315] = {.lex_state = 136, .external_lex_state = 12},
  [316] = {.lex_state = 92, .external_lex_state = 18},
  [317] = {.lex_state = 136, .external_lex_state = 12},
  [318] = {.lex_state = 209, .external_lex_state = 20},
  [319] = {.lex_state = 212},
  [320] = {.lex_state = 85},
  [321] = {.lex_state = 108, .external_lex_state = 26},
  [322] = {.lex_state = 115},
  [323] = {.lex_state = 122},
  [324] = {.lex_state = 108, .external_lex_state = 26},
  [325] = {.lex_state = 122, .external_lex_state = 7},
  [326] = {.lex_state = 78, .external_lex_state = 2},
  [327] = {.lex_state = 78, .external_lex_state = 2},
  [328] = {.lex_state = 78, .external_lex_state = 2},
  [329] = {.lex_state = 85},
  [330] = {.lex_state = 108, .external_lex_state = 11},
  [331] = {.lex_state = 108, .external_lex_state = 13},
  [332] = {.lex_state = 115},
  [333] = {.lex_state = 122},
  [334] = {.lex_state = 108, .external_lex_state = 13},
  [335] = {.lex_state = 122, .external_lex_state = 7},
  [336] = {.lex_state = 78, .external_lex_state = 2},
  [337] = {.lex_state = 78, .external_lex_state = 2},
  [338] = {.lex_state = 78, .external_lex_state = 2},
  [339] = {.lex_state = 108, .external_lex_state = 12},
  [340] = {.lex_state = 102},
  [341] = {.lex_state = 112, .external_lex_state = 13},
  [342] = {.lex_state = 112, .external_lex_state = 13},
  [343] = {.lex_state = 217},
  [344] = {.lex_state = 115},
  [345] = {.lex_state = 112, .external_lex_state = 13},
  [346] = {.lex_state = 112, .external_lex_state = 13},
  [347] = {.lex_state = 112, .external_lex_state = 13},
  [348] = {.lex_state = 85},
  [349] = {.lex_state = 223, .external_lex_state = 7},
  [350] = {.lex_state = 225, .external_lex_state = 18},
  [351] = {.lex_state = 225, .external_lex_state = 18},
  [352] = {.lex_state = 85},
  [353] = {.lex_state = 215, .external_lex_state = 2},
  [354] = {.lex_state = 78},
  [355] = {.lex_state = 85},
  [356] = {.lex_state = 85},
  [357] = {.lex_state = 248, .external_lex_state = 2},
  [358] = {.lex_state = 186, .external_lex_state = 5},
  [359] = {.lex_state = 78},
  [360] = {.lex_state = 102},
  [361] = {.lex_state = 78, .external_lex_state = 2},
  [362] = {.lex_state = 78, .external_lex_state = 2},
  [363] = {.lex_state = 102},
  [364] = {.lex_state = 78, .external_lex_state = 24},
  [365] = {.lex_state = 102},
  [366] = {.lex_state = 136, .external_lex_state = 12},
  [367] = {.lex_state = 237, .external_lex_state = 25},
  [368] = {.lex_state = 112, .external_lex_state = 13},
  [369] = {.lex_state = 112, .external_lex_state = 13},
  [370] = {.lex_state = 112, .external_lex_state = 12},
  [371] = {.lex_state = 112, .external_lex_state = 12},
  [372] = {.lex_state = 254, .external_lex_state = 2},
  [373] = {.lex_state = 102},
  [374] = {.lex_state = 146, .external_lex_state = 9},
  [375] = {.lex_state = 149},
  [376] = {.lex_state = 149, .external_lex_state = 14},
  [377] = {.lex_state = 149, .external_lex_state = 14},
  [378] = {.lex_state = 217},
  [379] = {.lex_state = 115},
  [380] = {.lex_state = 149, .external_lex_state = 14},
  [381] = {.lex_state = 149, .external_lex_state = 14},
  [382] = {.lex_state = 149, .external_lex_state = 14},
  [383] = {.lex_state = 146, .external_lex_state = 9},
  [384] = {.lex_state = 149},
  [385] = {.lex_state = 85},
  [386] = {.lex_state = 223, .external_lex_state = 7},
  [387] = {.lex_state = 225, .external_lex_state = 18},
  [388] = {.lex_state = 225, .external_lex_state = 18},
  [389] = {.lex_state = 85},
  [390] = {.lex_state = 215, .external_lex_state = 2},
  [391] = {.lex_state = 78},
  [392] = {.lex_state = 85},
  [393] = {.lex_state = 85},
  [394] = {.lex_state = 186, .external_lex_state = 5},
  [395] = {.lex_state = 144, .external_lex_state = 8},
  [396] = {.lex_state = 85},
  [397] = {.lex_state = 178, .external_lex_state = 21},
  [398] = {.lex_state = 178, .external_lex_state = 21},
  [399] = {.lex_state = 85},
  [400] = {.lex_state = 178, .external_lex_state = 4},
  [401] = {.lex_state = 178, .external_lex_state = 6},
  [402] = {.lex_state = 178, .external_lex_state = 6},
  [403] = {.lex_state = 178, .external_lex_state = 5},
  [404] = {.lex_state = 142, .external_lex_state = 6},
  [405] = {.lex_state = 186, .external_lex_state = 5},
  [406] = {.lex_state = 78},
  [407] = {.lex_state = 78, .external_lex_state = 2},
  [408] = {.lex_state = 78, .external_lex_state = 2},
  [409] = {.lex_state = 102},
  [410] = {.lex_state = 102},
  [411] = {.lex_state = 182, .external_lex_state = 5},
  [412] = {.lex_state = 237, .external_lex_state = 25},
  [413] = {.lex_state = 142, .external_lex_state = 6},
  [414] = {.lex_state = 142, .external_lex_state = 6},
  [415] = {.lex_state = 142, .external_lex_state = 5},
  [416] = {.lex_state = 182, .external_lex_state = 5},
  [417] = {.lex_state = 184, .external_lex_state = 4},
  [418] = {.lex_state = 142, .external_lex_state = 5},
  [419] = {.lex_state = 144, .external_lex_state = 8},
  [420] = {.lex_state = 146, .external_lex_state = 9},
  [421] = {.lex_state = 149, .external_lex_state = 9},
  [422] = {.lex_state = 153},
  [423] = {.lex_state = 102},
  [424] = {.lex_state = 102},
  [425] = {.lex_state = 149, .external_lex_state = 14},
  [426] = {.lex_state = 149, .external_lex_state = 14},
  [427] = {.lex_state = 149, .external_lex_state = 9},
  [428] = {.lex_state = 172},
  [429] = {.lex_state = 85},
  [430] = {.lex_state = 205, .external_lex_state = 16},
  [431] = {.lex_state = 92, .external_lex_state = 18},
  [432] = {.lex_state = 205, .external_lex_state = 16},
  [433] = {.lex_state = 209, .external_lex_state = 20},
  [434] = {.lex_state = 212},
  [435] = {.lex_state = 85},
  [436] = {.lex_state = 199, .external_lex_state = 27},
  [437] = {.lex_state = 115},
  [438] = {.lex_state = 122},
  [439] = {.lex_state = 199, .external_lex_state = 27},
  [440] = {.lex_state = 122, .external_lex_state = 7},
  [441] = {.lex_state = 78, .external_lex_state = 2},
  [442] = {.lex_state = 78, .external_lex_state = 2},
  [443] = {.lex_state = 78, .external_lex_state = 2},
  [444] = {.lex_state = 85},
  [445] = {.lex_state = 199, .external_lex_state = 15},
  [446] = {.lex_state = 199, .external_lex_state = 17},
  [447] = {.lex_state = 115},
  [448] = {.lex_state = 122},
  [449] = {.lex_state = 199, .external_lex_state = 17},
  [450] = {.lex_state = 122, .external_lex_state = 7},
  [451] = {.lex_state = 78, .external_lex_state = 2},
  [452] = {.lex_state = 78, .external_lex_state = 2},
  [453] = {.lex_state = 78, .external_lex_state = 2},
  [454] = {.lex_state = 199, .external_lex_state = 16},
  [455] = {.lex_state = 102},
  [456] = {.lex_state = 201, .external_lex_state = 17},
  [457] = {.lex_state = 201, .external_lex_state = 17},
  [458] = {.lex_state = 217},
  [459] = {.lex_state = 115},
  [460] = {.lex_state = 201, .external_lex_state = 17},
  [461] = {.lex_state = 201, .external_lex_state = 17},
  [462] = {.lex_state = 201, .external_lex_state = 17},
  [463] = {.lex_state = 85},
  [464] = {.lex_state = 223, .external_lex_state = 7},
  [465] = {.lex_state = 225, .external_lex_state = 18},
  [466] = {.lex_state = 225, .external_lex_state = 18},
  [467] = {.lex_state = 85},
  [468] = {.lex_state = 215, .external_lex_state = 2},
  [469] = {.lex_state = 78},
  [470] = {.lex_state = 85},
  [471] = {.lex_state = 85},
  [472] = {.lex_state = 186, .external_lex_state = 5},
  [473] = {.lex_state = 257, .external_lex_state = 28},
  [474] = {.lex_state = 96, .external_lex_state = 23},
  [475] = {.lex_state = 78},
  [476] = {.lex_state = 104, .external_lex_state = 3},
  [477] = {.lex_state = 78, .external_lex_state = 2},
  [478] = {.lex_state = 78, .external_lex_state = 2},
  [479] = {.lex_state = 102},
  [480] = {.lex_state = 78, .external_lex_state = 24},
  [481] = {.lex_state = 102},
  [482] = {.lex_state = 257, .external_lex_state = 28},
  [483] = {.lex_state = 205, .external_lex_state = 16},
  [484] = {.lex_state = 237, .external_lex_state = 25},
  [485] = {.lex_state = 201, .external_lex_state = 17},
  [486] = {.lex_state = 201, .external_lex_state = 17},
  [487] = {.lex_state = 201, .external_lex_state = 16},
  [488] = {.lex_state = 205, .external_lex_state = 16},
  [489] = {.lex_state = 207, .external_lex_state = 15},
  [490] = {.lex_state = 201, .external_lex_state = 16},
  [491] = {.lex_state = 144, .external_lex_state = 8},
  [492] = {.lex_state = 244},
  [493] = {.lex_state = 209, .external_lex_state = 20},
  [494] = {.lex_state = 102},
  [495] = {.lex_state = 209, .external_lex_state = 19},
  [496] = {.lex_state = 209, .external_lex_state = 19},
  [497] = {.lex_state = 217},
  [498] = {.lex_state = 115},
  [499] = {.lex_state = 209, .external_lex_state = 19},
  [500] = {.lex_state = 209, .external_lex_state = 19},
  [501] = {.lex_state = 209, .external_lex_state = 19},
  [502] = {.lex_state = 85},
  [503] = {.lex_state = 223, .external_lex_state = 7},
  [504] = {.lex_state = 225, .external_lex_state = 18},
  [505] = {.lex_state = 225, .external_lex_state = 18},
  [506] = {.lex_state = 85},
  [507] = {.lex_state = 215, .external_lex_state = 2},
  [508] = {.lex_state = 78},
  [509] = {.lex_state = 85},
  [510] = {.lex_state = 96},
  [511] = {.lex_state = 96, .external_lex_state = 25},
  [512] = {.lex_state = 209, .external_lex_state = 20},
  [513] = {.lex_state = 212},
  [514] = {.lex_state = 212, .external_lex_state = 10},
  [515] = {.lex_state = 96},
  [516] = {.lex_state = 96, .external_lex_state = 25},
  [517] = {.lex_state = 144, .external_lex_state = 8},
  [518] = {.lex_state = 102},
  [519] = {.lex_state = 108, .external_lex_state = 21},
  [520] = {.lex_state = 178, .external_lex_state = 21},
  [521] = {.lex_state = 217},
  [522] = {.lex_state = 115},
  [523] = {.lex_state = 178, .external_lex_state = 21},
  [524] = {.lex_state = 178, .external_lex_state = 21},
  [525] = {.lex_state = 178, .external_lex_state = 21},
  [526] = {.lex_state = 85},
  [527] = {.lex_state = 223, .external_lex_state = 7},
  [528] = {.lex_state = 225, .external_lex_state = 18},
  [529] = {.lex_state = 225, .external_lex_state = 18},
  [530] = {.lex_state = 85},
  [531] = {.lex_state = 215, .external_lex_state = 2},
  [532] = {.lex_state = 78},
  [533] = {.lex_state = 85},
  [534] = {.lex_state = 108, .external_lex_state = 4},
  [535] = {.lex_state = 102},
  [536] = {.lex_state = 108, .external_lex_state = 6},
  [537] = {.lex_state = 178, .external_lex_state = 6},
  [538] = {.lex_state = 217},
  [539] = {.lex_state = 115},
  [540] = {.lex_state = 178, .external_lex_state = 6},
  [541] = {.lex_state = 178, .external_lex_state = 6},
  [542] = {.lex_state = 178, .external_lex_state = 6},
  [543] = {.lex_state = 85},
  [544] = {.lex_state = 223, .external_lex_state = 7},
  [545] = {.lex_state = 225, .external_lex_state = 18},
  [546] = {.lex_state = 225, .external_lex_state = 18},
  [547] = {.lex_state = 85},
  [548] = {.lex_state = 215, .external_lex_state = 2},
  [549] = {.lex_state = 78},
  [550] = {.lex_state = 85},
  [551] = {.lex_state = 108, .external_lex_state = 5},
  [552] = {.lex_state = 102},
  [553] = {.lex_state = 102, .external_lex_state = 22},
  [554] = {.lex_state = 215, .external_lex_state = 22},
  [555] = {.lex_state = 217},
  [556] = {.lex_state = 115},
  [557] = {.lex_state = 215, .external_lex_state = 22},
  [558] = {.lex_state = 215, .external_lex_state = 22},
  [559] = {.lex_state = 215, .external_lex_state = 22},
  [560] = {.lex_state = 85},
  [561] = {.lex_state = 223, .external_lex_state = 7},
  [562] = {.lex_state = 225, .external_lex_state = 18},
  [563] = {.lex_state = 225, .external_lex_state = 18},
  [564] = {.lex_state = 85},
  [565] = {.lex_state = 215, .external_lex_state = 2},
  [566] = {.lex_state = 78},
  [567] = {.lex_state = 85},
  [568] = {.lex_state = 142, .external_lex_state = 6},
  [569] = {.lex_state = 112, .external_lex_state = 6},
  [570] = {.lex_state = 115, .external_lex_state = 10},
  [571] = {.lex_state = 142, .external_lex_state = 6},
  [572] = {.lex_state = 115, .external_lex_state = 10},
  [573] = {.lex_state = 115, .external_lex_state = 10},
  [574] = {.lex_state = 115},
  [575] = {.lex_state = 85},
  [576] = {.lex_state = 223, .external_lex_state = 7},
  [577] = {.lex_state = 225, .external_lex_state = 18},
  [578] = {.lex_state = 225, .external_lex_state = 18},
  [579] = {.lex_state = 85},
  [580] = {.lex_state = 215, .external_lex_state = 2},
  [581] = {.lex_state = 78},
  [582] = {.lex_state = 217},
  [583] = {.lex_state = 115},
  [584] = {.lex_state = 102},
  [585] = {.lex_state = 259, .external_lex_state = 18},
  [586] = {.lex_state = 85},
  [587] = {.lex_state = 225, .external_lex_state = 18},
  [588] = {.lex_state = 225, .external_lex_state = 18},
  [589] = {.lex_state = 142, .external_lex_state = 6},
  [590] = {.lex_state = 261, .external_lex_state = 29},
  [591] = {.lex_state = 115},
  [592] = {.lex_state = 122},
  [593] = {.lex_state = 261, .external_lex_state = 29},
  [594] = {.lex_state = 122, .external_lex_state = 7},
  [595] = {.lex_state = 261, .external_lex_state = 30},
  [596] = {.lex_state = 78, .external_lex_state = 2},
  [597] = {.lex_state = 78, .external_lex_state = 2},
  [598] = {.lex_state = 78, .external_lex_state = 2},
  [599] = {.lex_state = 261, .external_lex_state = 18},
  [600] = {.lex_state = 142, .external_lex_state = 6},
  [601] = {.lex_state = 261, .external_lex_state = 30},
  [602] = {.lex_state = 261, .external_lex_state = 18},
  [603] = {.lex_state = 102},
  [604] = {.lex_state = 215, .external_lex_state = 22},
  [605] = {.lex_state = 215, .external_lex_state = 22},
  [606] = {.lex_state = 142, .external_lex_state = 6},
  [607] = {.lex_state = 144, .external_lex_state = 8},
  [608] = {.lex_state = 85},
  [609] = {.lex_state = 108, .external_lex_state = 21},
  [610] = {.lex_state = 108, .external_lex_state = 21},
  [611] = {.lex_state = 85},
  [612] = {.lex_state = 108, .external_lex_state = 4},
  [613] = {.lex_state = 108, .external_lex_state = 6},
  [614] = {.lex_state = 108, .external_lex_state = 6},
  [615] = {.lex_state = 108, .external_lex_state = 5},
  [616] = {.lex_state = 112, .external_lex_state = 6},
  [617] = {.lex_state = 78},
  [618] = {.lex_state = 78, .external_lex_state = 2},
  [619] = {.lex_state = 78, .external_lex_state = 2},
  [620] = {.lex_state = 78, .external_lex_state = 2},
  [621] = {.lex_state = 102},
  [622] = {.lex_state = 102},
  [623] = {.lex_state = 146, .external_lex_state = 9},
  [624] = {.lex_state = 229, .external_lex_state = 5},
  [625] = {.lex_state = 237, .external_lex_state = 25},
  [626] = {.lex_state = 112, .external_lex_state = 6},
  [627] = {.lex_state = 112, .external_lex_state = 6},
  [628] = {.lex_state = 112, .external_lex_state = 5},
  [629] = {.lex_state = 229, .external_lex_state = 5},
  [630] = {.lex_state = 140, .external_lex_state = 4},
  [631] = {.lex_state = 112, .external_lex_state = 5},
  [632] = {.lex_state = 142, .external_lex_state = 6},
  [633] = {.lex_state = 78},
  [634] = {.lex_state = 231, .external_lex_state = 9},
  [635] = {.lex_state = 122},
  [636] = {.lex_state = 122, .external_lex_state = 7},
  [637] = {.lex_state = 78, .external_lex_state = 2},
  [638] = {.lex_state = 78, .external_lex_state = 2},
  [639] = {.lex_state = 96, .external_lex_state = 23},
  [640] = {.lex_state = 102},
  [641] = {.lex_state = 136, .external_lex_state = 5},
  [642] = {.lex_state = 140, .external_lex_state = 4},
  [643] = {.lex_state = 136, .external_lex_state = 5},
  [644] = {.lex_state = 140, .external_lex_state = 4},
  [645] = {.lex_state = 136, .external_lex_state = 6},
  [646] = {.lex_state = 136, .external_lex_state = 6},
  [647] = {.lex_state = 186, .external_lex_state = 5},
  [648] = {.lex_state = 186, .external_lex_state = 5},
  [649] = {.lex_state = 136, .external_lex_state = 6},
  [650] = {.lex_state = 136, .external_lex_state = 6},
  [651] = {.lex_state = 186, .external_lex_state = 5},
  [652] = {.lex_state = 233, .external_lex_state = 2},
  [653] = {.lex_state = 136, .external_lex_state = 5},
  [654] = {.lex_state = 142, .external_lex_state = 5},
  [655] = {.lex_state = 112, .external_lex_state = 6},
  [656] = {.lex_state = 112, .external_lex_state = 6},
  [657] = {.lex_state = 112, .external_lex_state = 5},
  [658] = {.lex_state = 233, .external_lex_state = 2},
  [659] = {.lex_state = 235, .external_lex_state = 9},
  [660] = {.lex_state = 106, .external_lex_state = 2},
  [661] = {.lex_state = 108, .external_lex_state = 4},
  [662] = {.lex_state = 108, .external_lex_state = 5},
  [663] = {.lex_state = 136, .external_lex_state = 5},
  [664] = {.lex_state = 112, .external_lex_state = 5},
  [665] = {.lex_state = 140, .external_lex_state = 4},
  [666] = {.lex_state = 102, .external_lex_state = 2},
  [667] = {.lex_state = 112, .external_lex_state = 5},
  [668] = {.lex_state = 239, .external_lex_state = 20},
  [669] = {.lex_state = 263, .external_lex_state = 10},
  [670] = {.lex_state = 239, .external_lex_state = 19},
  [671] = {.lex_state = 239, .external_lex_state = 20},
  [672] = {.lex_state = 263, .external_lex_state = 10},
  [673] = {.lex_state = 209, .external_lex_state = 20},
  [674] = {.lex_state = 184, .external_lex_state = 4},
  [675] = {.lex_state = 215, .external_lex_state = 10},
  [676] = {.lex_state = 115},
  [677] = {.lex_state = 122},
  [678] = {.lex_state = 215, .external_lex_state = 10},
  [679] = {.lex_state = 122, .external_lex_state = 7},
  [680] = {.lex_state = 78, .external_lex_state = 2},
  [681] = {.lex_state = 78, .external_lex_state = 2},
  [682] = {.lex_state = 78, .external_lex_state = 2},
  [683] = {.lex_state = 215},
  [684] = {.lex_state = 102},
  [685] = {.lex_state = 140, .external_lex_state = 21},
  [686] = {.lex_state = 184, .external_lex_state = 21},
  [687] = {.lex_state = 217},
  [688] = {.lex_state = 115},
  [689] = {.lex_state = 184, .external_lex_state = 21},
  [690] = {.lex_state = 184, .external_lex_state = 21},
  [691] = {.lex_state = 184, .external_lex_state = 21},
  [692] = {.lex_state = 85},
  [693] = {.lex_state = 223, .external_lex_state = 7},
  [694] = {.lex_state = 225, .external_lex_state = 18},
  [695] = {.lex_state = 225, .external_lex_state = 18},
  [696] = {.lex_state = 85},
  [697] = {.lex_state = 215, .external_lex_state = 2},
  [698] = {.lex_state = 78},
  [699] = {.lex_state = 85},
  [700] = {.lex_state = 265},
  [701] = {.lex_state = 241, .external_lex_state = 9},
  [702] = {.lex_state = 244},
  [703] = {.lex_state = 241, .external_lex_state = 9},
  [704] = {.lex_state = 102},
  [705] = {.lex_state = 241, .external_lex_state = 14},
  [706] = {.lex_state = 241, .external_lex_state = 14},
  [707] = {.lex_state = 217},
  [708] = {.lex_state = 115},
  [709] = {.lex_state = 241, .external_lex_state = 14},
  [710] = {.lex_state = 241, .external_lex_state = 14},
  [711] = {.lex_state = 241, .external_lex_state = 14},
  [712] = {.lex_state = 85},
  [713] = {.lex_state = 223, .external_lex_state = 7},
  [714] = {.lex_state = 225, .external_lex_state = 18},
  [715] = {.lex_state = 225, .external_lex_state = 18},
  [716] = {.lex_state = 85},
  [717] = {.lex_state = 215, .external_lex_state = 2},
  [718] = {.lex_state = 78},
  [719] = {.lex_state = 85},
  [720] = {.lex_state = 146, .external_lex_state = 9},
  [721] = {.lex_state = 96},
  [722] = {.lex_state = 96, .external_lex_state = 25},
  [723] = {.lex_state = 241, .external_lex_state = 9},
  [724] = {.lex_state = 267, .external_lex_state = 14},
  [725] = {.lex_state = 115},
  [726] = {.lex_state = 122},
  [727] = {.lex_state = 267, .external_lex_state = 14},
  [728] = {.lex_state = 122, .external_lex_state = 7},
  [729] = {.lex_state = 78, .external_lex_state = 2},
  [730] = {.lex_state = 78, .external_lex_state = 2},
  [731] = {.lex_state = 78, .external_lex_state = 2},
  [732] = {.lex_state = 267, .external_lex_state = 9},
  [733] = {.lex_state = 186, .external_lex_state = 5},
  [734] = {.lex_state = 244},
  [735] = {.lex_state = 244},
  [736] = {.lex_state = 102},
  [737] = {.lex_state = 244, .external_lex_state = 10},
  [738] = {.lex_state = 269, .external_lex_state = 10},
  [739] = {.lex_state = 217},
  [740] = {.lex_state = 115},
  [741] = {.lex_state = 269, .external_lex_state = 10},
  [742] = {.lex_state = 269, .external_lex_state = 10},
  [743] = {.lex_state = 269, .external_lex_state = 10},
  [744] = {.lex_state = 85},
  [745] = {.lex_state = 223, .external_lex_state = 7},
  [746] = {.lex_state = 225, .external_lex_state = 18},
  [747] = {.lex_state = 225, .external_lex_state = 18},
  [748] = {.lex_state = 85},
  [749] = {.lex_state = 215, .external_lex_state = 2},
  [750] = {.lex_state = 78},
  [751] = {.lex_state = 85},
  [752] = {.lex_state = 246},
  [753] = {.lex_state = 96},
  [754] = {.lex_state = 96, .external_lex_state = 25},
  [755] = {.lex_state = 244},
  [756] = {.lex_state = 246, .external_lex_state = 10},
  [757] = {.lex_state = 153, .external_lex_state = 10},
  [758] = {.lex_state = 246, .external_lex_state = 10},
  [759] = {.lex_state = 217},
  [760] = {.lex_state = 259, .external_lex_state = 18},
  [761] = {.lex_state = 85},
  [762] = {.lex_state = 225, .external_lex_state = 18},
  [763] = {.lex_state = 225, .external_lex_state = 18},
  [764] = {.lex_state = 246, .external_lex_state = 10},
  [765] = {.lex_state = 261, .external_lex_state = 30},
  [766] = {.lex_state = 261, .external_lex_state = 18},
  [767] = {.lex_state = 246, .external_lex_state = 10},
  [768] = {.lex_state = 261, .external_lex_state = 30},
  [769] = {.lex_state = 261, .external_lex_state = 18},
  [770] = {.lex_state = 246, .external_lex_state = 10},
  [771] = {.lex_state = 246, .external_lex_state = 10},
  [772] = {.lex_state = 246},
  [773] = {.lex_state = 246},
  [774] = {.lex_state = 140, .external_lex_state = 11},
  [775] = {.lex_state = 215},
  [776] = {.lex_state = 140, .external_lex_state = 26},
  [777] = {.lex_state = 115},
  [778] = {.lex_state = 122},
  [779] = {.lex_state = 140, .external_lex_state = 26},
  [780] = {.lex_state = 122, .external_lex_state = 7},
  [781] = {.lex_state = 78, .external_lex_state = 2},
  [782] = {.lex_state = 78, .external_lex_state = 2},
  [783] = {.lex_state = 78, .external_lex_state = 2},
  [784] = {.lex_state = 146, .external_lex_state = 9},
  [785] = {.lex_state = 241, .external_lex_state = 9},
  [786] = {.lex_state = 102},
  [787] = {.lex_state = 102},
  [788] = {.lex_state = 136, .external_lex_state = 12},
  [789] = {.lex_state = 248, .external_lex_state = 2},
  [790] = {.lex_state = 136, .external_lex_state = 12},
  [791] = {.lex_state = 254, .external_lex_state = 2},
  [792] = {.lex_state = 146, .external_lex_state = 9},
  [793] = {.lex_state = 149},
  [794] = {.lex_state = 146, .external_lex_state = 9},
  [795] = {.lex_state = 149},
  [796] = {.lex_state = 85},
  [797] = {.lex_state = 136, .external_lex_state = 12},
  [798] = {.lex_state = 136, .external_lex_state = 12},
  [799] = {.lex_state = 136, .external_lex_state = 12},
  [800] = {.lex_state = 144, .external_lex_state = 8},
  [801] = {.lex_state = 102},
  [802] = {.lex_state = 108, .external_lex_state = 26},
  [803] = {.lex_state = 108, .external_lex_state = 26},
  [804] = {.lex_state = 217},
  [805] = {.lex_state = 115},
  [806] = {.lex_state = 108, .external_lex_state = 26},
  [807] = {.lex_state = 108, .external_lex_state = 26},
  [808] = {.lex_state = 108, .external_lex_state = 26},
  [809] = {.lex_state = 85},
  [810] = {.lex_state = 223, .external_lex_state = 7},
  [811] = {.lex_state = 225, .external_lex_state = 18},
  [812] = {.lex_state = 225, .external_lex_state = 18},
  [813] = {.lex_state = 85},
  [814] = {.lex_state = 215, .external_lex_state = 2},
  [815] = {.lex_state = 78},
  [816] = {.lex_state = 85},
  [817] = {.lex_state = 108, .external_lex_state = 11},
  [818] = {.lex_state = 102},
  [819] = {.lex_state = 108, .external_lex_state = 13},
  [820] = {.lex_state = 108, .external_lex_state = 13},
  [821] = {.lex_state = 217},
  [822] = {.lex_state = 115},
  [823] = {.lex_state = 108, .external_lex_state = 13},
  [824] = {.lex_state = 108, .external_lex_state = 13},
  [825] = {.lex_state = 108, .external_lex_state = 13},
  [826] = {.lex_state = 85},
  [827] = {.lex_state = 223, .external_lex_state = 7},
  [828] = {.lex_state = 225, .external_lex_state = 18},
  [829] = {.lex_state = 225, .external_lex_state = 18},
  [830] = {.lex_state = 85},
  [831] = {.lex_state = 215, .external_lex_state = 2},
  [832] = {.lex_state = 78},
  [833] = {.lex_state = 85},
  [834] = {.lex_state = 108, .external_lex_state = 12},
  [835] = {.lex_state = 112, .external_lex_state = 13},
  [836] = {.lex_state = 112, .external_lex_state = 13},
  [837] = {.lex_state = 112, .external_lex_state = 13},
  [838] = {.lex_state = 217},
  [839] = {.lex_state = 259, .external_lex_state = 18},
  [840] = {.lex_state = 85},
  [841] = {.lex_state = 225, .external_lex_state = 18},
  [842] = {.lex_state = 225, .external_lex_state = 18},
  [843] = {.lex_state = 112, .external_lex_state = 13},
  [844] = {.lex_state = 261, .external_lex_state = 30},
  [845] = {.lex_state = 261, .external_lex_state = 18},
  [846] = {.lex_state = 112, .external_lex_state = 13},
  [847] = {.lex_state = 261, .external_lex_state = 30},
  [848] = {.lex_state = 261, .external_lex_state = 18},
  [849] = {.lex_state = 112, .external_lex_state = 13},
  [850] = {.lex_state = 112, .external_lex_state = 13},
  [851] = {.lex_state = 78},
  [852] = {.lex_state = 85},
  [853] = {.lex_state = 186, .external_lex_state = 5},
  [854] = {.lex_state = 106, .external_lex_state = 2},
  [855] = {.lex_state = 272, .external_lex_state = 4},
  [856] = {.lex_state = 272, .external_lex_state = 5},
  [857] = {.lex_state = 278, .external_lex_state = 6},
  [858] = {.lex_state = 115},
  [859] = {.lex_state = 122},
  [860] = {.lex_state = 278, .external_lex_state = 6},
  [861] = {.lex_state = 122, .external_lex_state = 7},
  [862] = {.lex_state = 78, .external_lex_state = 2},
  [863] = {.lex_state = 78, .external_lex_state = 2},
  [864] = {.lex_state = 78, .external_lex_state = 2},
  [865] = {.lex_state = 280, .external_lex_state = 6},
  [866] = {.lex_state = 172},
  [867] = {.lex_state = 282, .external_lex_state = 5},
  [868] = {.lex_state = 278, .external_lex_state = 5},
  [869] = {.lex_state = 284, .external_lex_state = 4},
  [870] = {.lex_state = 85},
  [871] = {.lex_state = 278, .external_lex_state = 5},
  [872] = {.lex_state = 78, .external_lex_state = 2},
  [873] = {.lex_state = 102, .external_lex_state = 2},
  [874] = {.lex_state = 102},
  [875] = {.lex_state = 136, .external_lex_state = 12},
  [876] = {.lex_state = 140, .external_lex_state = 11},
  [877] = {.lex_state = 136, .external_lex_state = 12},
  [878] = {.lex_state = 140, .external_lex_state = 11},
  [879] = {.lex_state = 136, .external_lex_state = 13},
  [880] = {.lex_state = 136, .external_lex_state = 13},
  [881] = {.lex_state = 136, .external_lex_state = 12},
  [882] = {.lex_state = 136, .external_lex_state = 12},
  [883] = {.lex_state = 136, .external_lex_state = 13},
  [884] = {.lex_state = 136, .external_lex_state = 13},
  [885] = {.lex_state = 136, .external_lex_state = 12},
  [886] = {.lex_state = 136, .external_lex_state = 12},
  [887] = {.lex_state = 112, .external_lex_state = 12},
  [888] = {.lex_state = 112, .external_lex_state = 13},
  [889] = {.lex_state = 112, .external_lex_state = 13},
  [890] = {.lex_state = 112, .external_lex_state = 12},
  [891] = {.lex_state = 112, .external_lex_state = 12},
  [892] = {.lex_state = 85},
  [893] = {.lex_state = 186, .external_lex_state = 5},
  [894] = {.lex_state = 78, .external_lex_state = 2},
  [895] = {.lex_state = 286, .external_lex_state = 2},
  [896] = {.lex_state = 106, .external_lex_state = 2},
  [897] = {.lex_state = 288, .external_lex_state = 4},
  [898] = {.lex_state = 288, .external_lex_state = 5},
  [899] = {.lex_state = 298, .external_lex_state = 6},
  [900] = {.lex_state = 115},
  [901] = {.lex_state = 122},
  [902] = {.lex_state = 298, .external_lex_state = 6},
  [903] = {.lex_state = 122, .external_lex_state = 7},
  [904] = {.lex_state = 78, .external_lex_state = 2},
  [905] = {.lex_state = 78, .external_lex_state = 2},
  [906] = {.lex_state = 78, .external_lex_state = 2},
  [907] = {.lex_state = 300, .external_lex_state = 6},
  [908] = {.lex_state = 302},
  [909] = {.lex_state = 302, .external_lex_state = 5},
  [910] = {.lex_state = 302},
  [911] = {.lex_state = 298, .external_lex_state = 5},
  [912] = {.lex_state = 305, .external_lex_state = 4},
  [913] = {.lex_state = 85},
  [914] = {.lex_state = 298, .external_lex_state = 5},
  [915] = {.lex_state = 78, .external_lex_state = 2},
  [916] = {.lex_state = 302},
  [917] = {.lex_state = 102, .external_lex_state = 2},
  [918] = {.lex_state = 149, .external_lex_state = 14},
  [919] = {.lex_state = 307},
  [920] = {.lex_state = 146, .external_lex_state = 9},
  [921] = {.lex_state = 149, .external_lex_state = 14},
  [922] = {.lex_state = 149, .external_lex_state = 14},
  [923] = {.lex_state = 217},
  [924] = {.lex_state = 307},
  [925] = {.lex_state = 146, .external_lex_state = 9},
  [926] = {.lex_state = 259, .external_lex_state = 18},
  [927] = {.lex_state = 85},
  [928] = {.lex_state = 225, .external_lex_state = 18},
  [929] = {.lex_state = 225, .external_lex_state = 18},
  [930] = {.lex_state = 149, .external_lex_state = 14},
  [931] = {.lex_state = 261, .external_lex_state = 30},
  [932] = {.lex_state = 261, .external_lex_state = 18},
  [933] = {.lex_state = 149, .external_lex_state = 14},
  [934] = {.lex_state = 261, .external_lex_state = 30},
  [935] = {.lex_state = 261, .external_lex_state = 18},
  [936] = {.lex_state = 149, .external_lex_state = 14},
  [937] = {.lex_state = 149, .external_lex_state = 14},
  [938] = {.lex_state = 78},
  [939] = {.lex_state = 184, .external_lex_state = 21},
  [940] = {.lex_state = 184, .external_lex_state = 21},
  [941] = {.lex_state = 144, .external_lex_state = 8},
  [942] = {.lex_state = 178, .external_lex_state = 21},
  [943] = {.lex_state = 178, .external_lex_state = 4},
  [944] = {.lex_state = 178, .external_lex_state = 6},
  [945] = {.lex_state = 178, .external_lex_state = 5},
  [946] = {.lex_state = 142, .external_lex_state = 6},
  [947] = {.lex_state = 102},
  [948] = {.lex_state = 182, .external_lex_state = 5},
  [949] = {.lex_state = 184, .external_lex_state = 4},
  [950] = {.lex_state = 182, .external_lex_state = 5},
  [951] = {.lex_state = 184, .external_lex_state = 4},
  [952] = {.lex_state = 182, .external_lex_state = 6},
  [953] = {.lex_state = 182, .external_lex_state = 6},
  [954] = {.lex_state = 182, .external_lex_state = 6},
  [955] = {.lex_state = 182, .external_lex_state = 6},
  [956] = {.lex_state = 182, .external_lex_state = 5},
  [957] = {.lex_state = 142, .external_lex_state = 6},
  [958] = {.lex_state = 142, .external_lex_state = 6},
  [959] = {.lex_state = 142, .external_lex_state = 5},
  [960] = {.lex_state = 142, .external_lex_state = 5},
  [961] = {.lex_state = 207, .external_lex_state = 15},
  [962] = {.lex_state = 215},
  [963] = {.lex_state = 207, .external_lex_state = 27},
  [964] = {.lex_state = 115},
  [965] = {.lex_state = 122},
  [966] = {.lex_state = 207, .external_lex_state = 27},
  [967] = {.lex_state = 122, .external_lex_state = 7},
  [968] = {.lex_state = 78, .external_lex_state = 2},
  [969] = {.lex_state = 78, .external_lex_state = 2},
  [970] = {.lex_state = 78, .external_lex_state = 2},
  [971] = {.lex_state = 146, .external_lex_state = 9},
  [972] = {.lex_state = 241, .external_lex_state = 9},
  [973] = {.lex_state = 102},
  [974] = {.lex_state = 102},
  [975] = {.lex_state = 205, .external_lex_state = 16},
  [976] = {.lex_state = 248, .external_lex_state = 2},
  [977] = {.lex_state = 205, .external_lex_state = 16},
  [978] = {.lex_state = 254, .external_lex_state = 2},
  [979] = {.lex_state = 146, .external_lex_state = 9},
  [980] = {.lex_state = 149},
  [981] = {.lex_state = 146, .external_lex_state = 9},
  [982] = {.lex_state = 149},
  [983] = {.lex_state = 85},
  [984] = {.lex_state = 205, .external_lex_state = 16},
  [985] = {.lex_state = 205, .external_lex_state = 16},
  [986] = {.lex_state = 205, .external_lex_state = 16},
  [987] = {.lex_state = 144, .external_lex_state = 8},
  [988] = {.lex_state = 102},
  [989] = {.lex_state = 199, .external_lex_state = 27},
  [990] = {.lex_state = 199, .external_lex_state = 27},
  [991] = {.lex_state = 217},
  [992] = {.lex_state = 115},
  [993] = {.lex_state = 199, .external_lex_state = 27},
  [994] = {.lex_state = 199, .external_lex_state = 27},
  [995] = {.lex_state = 199, .external_lex_state = 27},
  [996] = {.lex_state = 85},
  [997] = {.lex_state = 223, .external_lex_state = 7},
  [998] = {.lex_state = 225, .external_lex_state = 18},
  [999] = {.lex_state = 225, .external_lex_state = 18},
  [1000] = {.lex_state = 85},
  [1001] = {.lex_state = 215, .external_lex_state = 2},
  [1002] = {.lex_state = 78},
  [1003] = {.lex_state = 85},
  [1004] = {.lex_state = 199, .external_lex_state = 15},
  [1005] = {.lex_state = 102},
  [1006] = {.lex_state = 199, .external_lex_state = 17},
  [1007] = {.lex_state = 199, .external_lex_state = 17},
  [1008] = {.lex_state = 217},
  [1009] = {.lex_state = 115},
  [1010] = {.lex_state = 199, .external_lex_state = 17},
  [1011] = {.lex_state = 199, .external_lex_state = 17},
  [1012] = {.lex_state = 199, .external_lex_state = 17},
  [1013] = {.lex_state = 85},
  [1014] = {.lex_state = 223, .external_lex_state = 7},
  [1015] = {.lex_state = 225, .external_lex_state = 18},
  [1016] = {.lex_state = 225, .external_lex_state = 18},
  [1017] = {.lex_state = 85},
  [1018] = {.lex_state = 215, .external_lex_state = 2},
  [1019] = {.lex_state = 78},
  [1020] = {.lex_state = 85},
  [1021] = {.lex_state = 199, .external_lex_state = 16},
  [1022] = {.lex_state = 201, .external_lex_state = 17},
  [1023] = {.lex_state = 201, .external_lex_state = 17},
  [1024] = {.lex_state = 201, .external_lex_state = 17},
  [1025] = {.lex_state = 217},
  [1026] = {.lex_state = 259, .external_lex_state = 18},
  [1027] = {.lex_state = 85},
  [1028] = {.lex_state = 225, .external_lex_state = 18},
  [1029] = {.lex_state = 225, .external_lex_state = 18},
  [1030] = {.lex_state = 201, .external_lex_state = 17},
  [1031] = {.lex_state = 261, .external_lex_state = 30},
  [1032] = {.lex_state = 261, .external_lex_state = 18},
  [1033] = {.lex_state = 201, .external_lex_state = 17},
  [1034] = {.lex_state = 261, .external_lex_state = 30},
  [1035] = {.lex_state = 261, .external_lex_state = 18},
  [1036] = {.lex_state = 201, .external_lex_state = 17},
  [1037] = {.lex_state = 201, .external_lex_state = 17},
  [1038] = {.lex_state = 78},
  [1039] = {.lex_state = 257, .external_lex_state = 28},
  [1040] = {.lex_state = 96, .external_lex_state = 23},
  [1041] = {.lex_state = 102},
  [1042] = {.lex_state = 205, .external_lex_state = 16},
  [1043] = {.lex_state = 207, .external_lex_state = 15},
  [1044] = {.lex_state = 205, .external_lex_state = 16},
  [1045] = {.lex_state = 207, .external_lex_state = 15},
  [1046] = {.lex_state = 205, .external_lex_state = 17},
  [1047] = {.lex_state = 205, .external_lex_state = 17},
  [1048] = {.lex_state = 205, .external_lex_state = 16},
  [1049] = {.lex_state = 205, .external_lex_state = 16},
  [1050] = {.lex_state = 205, .external_lex_state = 17},
  [1051] = {.lex_state = 205, .external_lex_state = 17},
  [1052] = {.lex_state = 205, .external_lex_state = 16},
  [1053] = {.lex_state = 104, .external_lex_state = 3},
  [1054] = {.lex_state = 205, .external_lex_state = 16},
  [1055] = {.lex_state = 201, .external_lex_state = 16},
  [1056] = {.lex_state = 201, .external_lex_state = 17},
  [1057] = {.lex_state = 201, .external_lex_state = 17},
  [1058] = {.lex_state = 201, .external_lex_state = 16},
  [1059] = {.lex_state = 104, .external_lex_state = 3},
  [1060] = {.lex_state = 257, .external_lex_state = 28},
  [1061] = {.lex_state = 201, .external_lex_state = 16},
  [1062] = {.lex_state = 102, .external_lex_state = 2},
  [1063] = {.lex_state = 215},
  [1064] = {.lex_state = 102, .external_lex_state = 22},
  [1065] = {.lex_state = 102, .external_lex_state = 22},
  [1066] = {.lex_state = 209, .external_lex_state = 20},
  [1067] = {.lex_state = 209, .external_lex_state = 19},
  [1068] = {.lex_state = 209, .external_lex_state = 19},
  [1069] = {.lex_state = 209, .external_lex_state = 19},
  [1070] = {.lex_state = 217},
  [1071] = {.lex_state = 259, .external_lex_state = 18},
  [1072] = {.lex_state = 85},
  [1073] = {.lex_state = 225, .external_lex_state = 18},
  [1074] = {.lex_state = 225, .external_lex_state = 18},
  [1075] = {.lex_state = 209, .external_lex_state = 19},
  [1076] = {.lex_state = 261, .external_lex_state = 30},
  [1077] = {.lex_state = 261, .external_lex_state = 18},
  [1078] = {.lex_state = 209, .external_lex_state = 19},
  [1079] = {.lex_state = 261, .external_lex_state = 30},
  [1080] = {.lex_state = 261, .external_lex_state = 18},
  [1081] = {.lex_state = 209, .external_lex_state = 19},
  [1082] = {.lex_state = 209, .external_lex_state = 19},
  [1083] = {.lex_state = 209, .external_lex_state = 20},
  [1084] = {.lex_state = 209, .external_lex_state = 20},
  [1085] = {.lex_state = 212, .external_lex_state = 10},
  [1086] = {.lex_state = 178, .external_lex_state = 4},
  [1087] = {.lex_state = 215},
  [1088] = {.lex_state = 108, .external_lex_state = 21},
  [1089] = {.lex_state = 108, .external_lex_state = 21},
  [1090] = {.lex_state = 178, .external_lex_state = 21},
  [1091] = {.lex_state = 108, .external_lex_state = 21},
  [1092] = {.lex_state = 178, .external_lex_state = 21},
  [1093] = {.lex_state = 217},
  [1094] = {.lex_state = 259, .external_lex_state = 18},
  [1095] = {.lex_state = 85},
  [1096] = {.lex_state = 225, .external_lex_state = 18},
  [1097] = {.lex_state = 225, .external_lex_state = 18},
  [1098] = {.lex_state = 178, .external_lex_state = 21},
  [1099] = {.lex_state = 261, .external_lex_state = 30},
  [1100] = {.lex_state = 261, .external_lex_state = 18},
  [1101] = {.lex_state = 178, .external_lex_state = 21},
  [1102] = {.lex_state = 261, .external_lex_state = 30},
  [1103] = {.lex_state = 261, .external_lex_state = 18},
  [1104] = {.lex_state = 178, .external_lex_state = 21},
  [1105] = {.lex_state = 178, .external_lex_state = 21},
  [1106] = {.lex_state = 178, .external_lex_state = 6},
  [1107] = {.lex_state = 108, .external_lex_state = 6},
  [1108] = {.lex_state = 178, .external_lex_state = 6},
  [1109] = {.lex_state = 217},
  [1110] = {.lex_state = 259, .external_lex_state = 18},
  [1111] = {.lex_state = 85},
  [1112] = {.lex_state = 225, .external_lex_state = 18},
  [1113] = {.lex_state = 225, .external_lex_state = 18},
  [1114] = {.lex_state = 178, .external_lex_state = 6},
  [1115] = {.lex_state = 261, .external_lex_state = 30},
  [1116] = {.lex_state = 261, .external_lex_state = 18},
  [1117] = {.lex_state = 178, .external_lex_state = 6},
  [1118] = {.lex_state = 261, .external_lex_state = 30},
  [1119] = {.lex_state = 261, .external_lex_state = 18},
  [1120] = {.lex_state = 178, .external_lex_state = 6},
  [1121] = {.lex_state = 178, .external_lex_state = 6},
  [1122] = {.lex_state = 215, .external_lex_state = 22},
  [1123] = {.lex_state = 102, .external_lex_state = 22},
  [1124] = {.lex_state = 215, .external_lex_state = 22},
  [1125] = {.lex_state = 217},
  [1126] = {.lex_state = 259, .external_lex_state = 18},
  [1127] = {.lex_state = 85},
  [1128] = {.lex_state = 225, .external_lex_state = 18},
  [1129] = {.lex_state = 225, .external_lex_state = 18},
  [1130] = {.lex_state = 215, .external_lex_state = 22},
  [1131] = {.lex_state = 261, .external_lex_state = 30},
  [1132] = {.lex_state = 261, .external_lex_state = 18},
  [1133] = {.lex_state = 215, .external_lex_state = 22},
  [1134] = {.lex_state = 261, .external_lex_state = 30},
  [1135] = {.lex_state = 261, .external_lex_state = 18},
  [1136] = {.lex_state = 215, .external_lex_state = 22},
  [1137] = {.lex_state = 215, .external_lex_state = 22},
  [1138] = {.lex_state = 115},
  [1139] = {.lex_state = 259, .external_lex_state = 18},
  [1140] = {.lex_state = 85},
  [1141] = {.lex_state = 225, .external_lex_state = 18},
  [1142] = {.lex_state = 225, .external_lex_state = 18},
  [1143] = {.lex_state = 115, .external_lex_state = 10},
  [1144] = {.lex_state = 261, .external_lex_state = 30},
  [1145] = {.lex_state = 261, .external_lex_state = 18},
  [1146] = {.lex_state = 115, .external_lex_state = 10},
  [1147] = {.lex_state = 261, .external_lex_state = 30},
  [1148] = {.lex_state = 261, .external_lex_state = 18},
  [1149] = {.lex_state = 115, .external_lex_state = 10},
  [1150] = {.lex_state = 142, .external_lex_state = 6},
  [1151] = {.lex_state = 217},
  [1152] = {.lex_state = 239, .external_lex_state = 19},
  [1153] = {.lex_state = 239, .external_lex_state = 19},
  [1154] = {.lex_state = 239, .external_lex_state = 19},
  [1155] = {.lex_state = 142, .external_lex_state = 6},
  [1156] = {.lex_state = 92, .external_lex_state = 29},
  [1157] = {.lex_state = 115},
  [1158] = {.lex_state = 122},
  [1159] = {.lex_state = 92, .external_lex_state = 29},
  [1160] = {.lex_state = 122, .external_lex_state = 7},
  [1161] = {.lex_state = 78, .external_lex_state = 2},
  [1162] = {.lex_state = 78, .external_lex_state = 2},
  [1163] = {.lex_state = 78, .external_lex_state = 2},
  [1164] = {.lex_state = 92, .external_lex_state = 18},
  [1165] = {.lex_state = 259, .external_lex_state = 18},
  [1166] = {.lex_state = 142, .external_lex_state = 6},
  [1167] = {.lex_state = 261, .external_lex_state = 30},
  [1168] = {.lex_state = 261, .external_lex_state = 18},
  [1169] = {.lex_state = 261, .external_lex_state = 30},
  [1170] = {.lex_state = 261, .external_lex_state = 18},
  [1171] = {.lex_state = 102},
  [1172] = {.lex_state = 261, .external_lex_state = 29},
  [1173] = {.lex_state = 261, .external_lex_state = 29},
  [1174] = {.lex_state = 217},
  [1175] = {.lex_state = 115},
  [1176] = {.lex_state = 261, .external_lex_state = 29},
  [1177] = {.lex_state = 261, .external_lex_state = 29},
  [1178] = {.lex_state = 261, .external_lex_state = 29},
  [1179] = {.lex_state = 85},
  [1180] = {.lex_state = 223, .external_lex_state = 7},
  [1181] = {.lex_state = 225, .external_lex_state = 18},
  [1182] = {.lex_state = 225, .external_lex_state = 18},
  [1183] = {.lex_state = 261, .external_lex_state = 18},
  [1184] = {.lex_state = 142, .external_lex_state = 6},
  [1185] = {.lex_state = 261, .external_lex_state = 18},
  [1186] = {.lex_state = 85},
  [1187] = {.lex_state = 215, .external_lex_state = 2},
  [1188] = {.lex_state = 78},
  [1189] = {.lex_state = 85},
  [1190] = {.lex_state = 261, .external_lex_state = 18},
  [1191] = {.lex_state = 261, .external_lex_state = 18},
  [1192] = {.lex_state = 215, .external_lex_state = 22},
  [1193] = {.lex_state = 215, .external_lex_state = 22},
  [1194] = {.lex_state = 215, .external_lex_state = 22},
  [1195] = {.lex_state = 140, .external_lex_state = 21},
  [1196] = {.lex_state = 140, .external_lex_state = 21},
  [1197] = {.lex_state = 144, .external_lex_state = 8},
  [1198] = {.lex_state = 108, .external_lex_state = 21},
  [1199] = {.lex_state = 108, .external_lex_state = 4},
  [1200] = {.lex_state = 108, .external_lex_state = 6},
  [1201] = {.lex_state = 108, .external_lex_state = 5},
  [1202] = {.lex_state = 112, .external_lex_state = 6},
  [1203] = {.lex_state = 102},
  [1204] = {.lex_state = 229, .external_lex_state = 5},
  [1205] = {.lex_state = 140, .external_lex_state = 4},
  [1206] = {.lex_state = 229, .external_lex_state = 5},
  [1207] = {.lex_state = 140, .external_lex_state = 4},
  [1208] = {.lex_state = 229, .external_lex_state = 6},
  [1209] = {.lex_state = 229, .external_lex_state = 6},
  [1210] = {.lex_state = 229, .external_lex_state = 6},
  [1211] = {.lex_state = 229, .external_lex_state = 6},
  [1212] = {.lex_state = 78, .external_lex_state = 2},
  [1213] = {.lex_state = 229, .external_lex_state = 5},
  [1214] = {.lex_state = 112, .external_lex_state = 6},
  [1215] = {.lex_state = 112, .external_lex_state = 6},
  [1216] = {.lex_state = 112, .external_lex_state = 5},
  [1217] = {.lex_state = 78, .external_lex_state = 2},
  [1218] = {.lex_state = 146, .external_lex_state = 9},
  [1219] = {.lex_state = 112, .external_lex_state = 5},
  [1220] = {.lex_state = 186, .external_lex_state = 5},
  [1221] = {.lex_state = 96, .external_lex_state = 23},
  [1222] = {.lex_state = 96, .external_lex_state = 23},
  [1223] = {.lex_state = 85},
  [1224] = {.lex_state = 223, .external_lex_state = 7},
  [1225] = {.lex_state = 225, .external_lex_state = 18},
  [1226] = {.lex_state = 225, .external_lex_state = 18},
  [1227] = {.lex_state = 85},
  [1228] = {.lex_state = 215, .external_lex_state = 2},
  [1229] = {.lex_state = 78},
  [1230] = {.lex_state = 231, .external_lex_state = 9},
  [1231] = {.lex_state = 96, .external_lex_state = 23},
  [1232] = {.lex_state = 136, .external_lex_state = 6},
  [1233] = {.lex_state = 136, .external_lex_state = 6},
  [1234] = {.lex_state = 186, .external_lex_state = 5},
  [1235] = {.lex_state = 136, .external_lex_state = 6},
  [1236] = {.lex_state = 233, .external_lex_state = 2},
  [1237] = {.lex_state = 108, .external_lex_state = 4},
  [1238] = {.lex_state = 108, .external_lex_state = 5},
  [1239] = {.lex_state = 78},
  [1240] = {.lex_state = 78, .external_lex_state = 2},
  [1241] = {.lex_state = 78, .external_lex_state = 2},
  [1242] = {.lex_state = 78, .external_lex_state = 2},
  [1243] = {.lex_state = 102},
  [1244] = {.lex_state = 102},
  [1245] = {.lex_state = 146, .external_lex_state = 9},
  [1246] = {.lex_state = 136, .external_lex_state = 5},
  [1247] = {.lex_state = 112, .external_lex_state = 5},
  [1248] = {.lex_state = 112, .external_lex_state = 5},
  [1249] = {.lex_state = 263, .external_lex_state = 10},
  [1250] = {.lex_state = 85},
  [1251] = {.lex_state = 239, .external_lex_state = 19},
  [1252] = {.lex_state = 263, .external_lex_state = 10},
  [1253] = {.lex_state = 85},
  [1254] = {.lex_state = 102},
  [1255] = {.lex_state = 215, .external_lex_state = 10},
  [1256] = {.lex_state = 215, .external_lex_state = 10},
  [1257] = {.lex_state = 217},
  [1258] = {.lex_state = 115},
  [1259] = {.lex_state = 215, .external_lex_state = 10},
  [1260] = {.lex_state = 215, .external_lex_state = 10},
  [1261] = {.lex_state = 215, .external_lex_state = 10},
  [1262] = {.lex_state = 85},
  [1263] = {.lex_state = 223, .external_lex_state = 7},
  [1264] = {.lex_state = 225, .external_lex_state = 18},
  [1265] = {.lex_state = 225, .external_lex_state = 18},
  [1266] = {.lex_state = 85},
  [1267] = {.lex_state = 215, .external_lex_state = 2},
  [1268] = {.lex_state = 78},
  [1269] = {.lex_state = 85},
  [1270] = {.lex_state = 184, .external_lex_state = 4},
  [1271] = {.lex_state = 215},
  [1272] = {.lex_state = 184, .external_lex_state = 21},
  [1273] = {.lex_state = 140, .external_lex_state = 21},
  [1274] = {.lex_state = 184, .external_lex_state = 21},
  [1275] = {.lex_state = 217},
  [1276] = {.lex_state = 259, .external_lex_state = 18},
  [1277] = {.lex_state = 85},
  [1278] = {.lex_state = 225, .external_lex_state = 18},
  [1279] = {.lex_state = 225, .external_lex_state = 18},
  [1280] = {.lex_state = 184, .external_lex_state = 21},
  [1281] = {.lex_state = 261, .external_lex_state = 30},
  [1282] = {.lex_state = 261, .external_lex_state = 18},
  [1283] = {.lex_state = 184, .external_lex_state = 21},
  [1284] = {.lex_state = 261, .external_lex_state = 30},
  [1285] = {.lex_state = 261, .external_lex_state = 18},
  [1286] = {.lex_state = 184, .external_lex_state = 21},
  [1287] = {.lex_state = 184, .external_lex_state = 21},
  [1288] = {.lex_state = 310},
  [1289] = {.lex_state = 153},
  [1290] = {.lex_state = 265},
  [1291] = {.lex_state = 241, .external_lex_state = 9},
  [1292] = {.lex_state = 241, .external_lex_state = 14},
  [1293] = {.lex_state = 241, .external_lex_state = 14},
  [1294] = {.lex_state = 241, .external_lex_state = 14},
  [1295] = {.lex_state = 217},
  [1296] = {.lex_state = 259, .external_lex_state = 18},
  [1297] = {.lex_state = 85},
  [1298] = {.lex_state = 225, .external_lex_state = 18},
  [1299] = {.lex_state = 225, .external_lex_state = 18},
  [1300] = {.lex_state = 241, .external_lex_state = 14},
  [1301] = {.lex_state = 261, .external_lex_state = 30},
  [1302] = {.lex_state = 261, .external_lex_state = 18},
  [1303] = {.lex_state = 241, .external_lex_state = 14},
  [1304] = {.lex_state = 261, .external_lex_state = 30},
  [1305] = {.lex_state = 261, .external_lex_state = 18},
  [1306] = {.lex_state = 241, .external_lex_state = 14},
  [1307] = {.lex_state = 241, .external_lex_state = 14},
  [1308] = {.lex_state = 241, .external_lex_state = 9},
  [1309] = {.lex_state = 241, .external_lex_state = 9},
  [1310] = {.lex_state = 241, .external_lex_state = 9},
  [1311] = {.lex_state = 102},
  [1312] = {.lex_state = 267, .external_lex_state = 14},
  [1313] = {.lex_state = 267, .external_lex_state = 14},
  [1314] = {.lex_state = 217},
  [1315] = {.lex_state = 115},
  [1316] = {.lex_state = 267, .external_lex_state = 14},
  [1317] = {.lex_state = 267, .external_lex_state = 14},
  [1318] = {.lex_state = 267, .external_lex_state = 14},
  [1319] = {.lex_state = 85},
  [1320] = {.lex_state = 223, .external_lex_state = 7},
  [1321] = {.lex_state = 225, .external_lex_state = 18},
  [1322] = {.lex_state = 225, .external_lex_state = 18},
  [1323] = {.lex_state = 85},
  [1324] = {.lex_state = 215, .external_lex_state = 2},
  [1325] = {.lex_state = 78},
  [1326] = {.lex_state = 85},
  [1327] = {.lex_state = 102},
  [1328] = {.lex_state = 267, .external_lex_state = 9},
  [1329] = {.lex_state = 244},
  [1330] = {.lex_state = 269, .external_lex_state = 10},
  [1331] = {.lex_state = 244, .external_lex_state = 10},
  [1332] = {.lex_state = 269, .external_lex_state = 10},
  [1333] = {.lex_state = 217},
  [1334] = {.lex_state = 259, .external_lex_state = 18},
  [1335] = {.lex_state = 85},
  [1336] = {.lex_state = 225, .external_lex_state = 18},
  [1337] = {.lex_state = 225, .external_lex_state = 18},
  [1338] = {.lex_state = 269, .external_lex_state = 10},
  [1339] = {.lex_state = 261, .external_lex_state = 30},
  [1340] = {.lex_state = 261, .external_lex_state = 18},
  [1341] = {.lex_state = 269, .external_lex_state = 10},
  [1342] = {.lex_state = 261, .external_lex_state = 30},
  [1343] = {.lex_state = 261, .external_lex_state = 18},
  [1344] = {.lex_state = 269, .external_lex_state = 10},
  [1345] = {.lex_state = 269, .external_lex_state = 10},
  [1346] = {.lex_state = 244},
  [1347] = {.lex_state = 244},
  [1348] = {.lex_state = 246, .external_lex_state = 10},
  [1349] = {.lex_state = 246, .external_lex_state = 10},
  [1350] = {.lex_state = 92, .external_lex_state = 29},
  [1351] = {.lex_state = 92, .external_lex_state = 29},
  [1352] = {.lex_state = 92, .external_lex_state = 18},
  [1353] = {.lex_state = 259, .external_lex_state = 18},
  [1354] = {.lex_state = 246, .external_lex_state = 10},
  [1355] = {.lex_state = 261, .external_lex_state = 30},
  [1356] = {.lex_state = 261, .external_lex_state = 18},
  [1357] = {.lex_state = 261, .external_lex_state = 30},
  [1358] = {.lex_state = 261, .external_lex_state = 18},
  [1359] = {.lex_state = 261, .external_lex_state = 18},
  [1360] = {.lex_state = 246, .external_lex_state = 10},
  [1361] = {.lex_state = 261, .external_lex_state = 18},
  [1362] = {.lex_state = 261, .external_lex_state = 18},
  [1363] = {.lex_state = 140, .external_lex_state = 11},
  [1364] = {.lex_state = 215},
  [1365] = {.lex_state = 102},
  [1366] = {.lex_state = 140, .external_lex_state = 26},
  [1367] = {.lex_state = 140, .external_lex_state = 26},
  [1368] = {.lex_state = 217},
  [1369] = {.lex_state = 115},
  [1370] = {.lex_state = 140, .external_lex_state = 26},
  [1371] = {.lex_state = 140, .external_lex_state = 26},
  [1372] = {.lex_state = 140, .external_lex_state = 26},
  [1373] = {.lex_state = 85},
  [1374] = {.lex_state = 223, .external_lex_state = 7},
  [1375] = {.lex_state = 225, .external_lex_state = 18},
  [1376] = {.lex_state = 225, .external_lex_state = 18},
  [1377] = {.lex_state = 85},
  [1378] = {.lex_state = 215, .external_lex_state = 2},
  [1379] = {.lex_state = 78},
  [1380] = {.lex_state = 85},
  [1381] = {.lex_state = 265},
  [1382] = {.lex_state = 241, .external_lex_state = 9},
  [1383] = {.lex_state = 146, .external_lex_state = 9},
  [1384] = {.lex_state = 267, .external_lex_state = 9},
  [1385] = {.lex_state = 136, .external_lex_state = 12},
  [1386] = {.lex_state = 136, .external_lex_state = 12},
  [1387] = {.lex_state = 172},
  [1388] = {.lex_state = 136, .external_lex_state = 12},
  [1389] = {.lex_state = 302},
  [1390] = {.lex_state = 302},
  [1391] = {.lex_state = 302},
  [1392] = {.lex_state = 307},
  [1393] = {.lex_state = 146, .external_lex_state = 9},
  [1394] = {.lex_state = 307},
  [1395] = {.lex_state = 146, .external_lex_state = 9},
  [1396] = {.lex_state = 78},
  [1397] = {.lex_state = 108, .external_lex_state = 11},
  [1398] = {.lex_state = 215},
  [1399] = {.lex_state = 108, .external_lex_state = 26},
  [1400] = {.lex_state = 108, .external_lex_state = 26},
  [1401] = {.lex_state = 108, .external_lex_state = 26},
  [1402] = {.lex_state = 108, .external_lex_state = 26},
  [1403] = {.lex_state = 108, .external_lex_state = 26},
  [1404] = {.lex_state = 217},
  [1405] = {.lex_state = 259, .external_lex_state = 18},
  [1406] = {.lex_state = 85},
  [1407] = {.lex_state = 225, .external_lex_state = 18},
  [1408] = {.lex_state = 225, .external_lex_state = 18},
  [1409] = {.lex_state = 108, .external_lex_state = 26},
  [1410] = {.lex_state = 261, .external_lex_state = 30},
  [1411] = {.lex_state = 261, .external_lex_state = 18},
  [1412] = {.lex_state = 108, .external_lex_state = 26},
  [1413] = {.lex_state = 261, .external_lex_state = 30},
  [1414] = {.lex_state = 261, .external_lex_state = 18},
  [1415] = {.lex_state = 108, .external_lex_state = 26},
  [1416] = {.lex_state = 108, .external_lex_state = 26},
  [1417] = {.lex_state = 108, .external_lex_state = 13},
  [1418] = {.lex_state = 108, .external_lex_state = 13},
  [1419] = {.lex_state = 108, .external_lex_state = 13},
  [1420] = {.lex_state = 217},
  [1421] = {.lex_state = 259, .external_lex_state = 18},
  [1422] = {.lex_state = 85},
  [1423] = {.lex_state = 225, .external_lex_state = 18},
  [1424] = {.lex_state = 225, .external_lex_state = 18},
  [1425] = {.lex_state = 108, .external_lex_state = 13},
  [1426] = {.lex_state = 261, .external_lex_state = 30},
  [1427] = {.lex_state = 261, .external_lex_state = 18},
  [1428] = {.lex_state = 108, .external_lex_state = 13},
  [1429] = {.lex_state = 261, .external_lex_state = 30},
  [1430] = {.lex_state = 261, .external_lex_state = 18},
  [1431] = {.lex_state = 108, .external_lex_state = 13},
  [1432] = {.lex_state = 108, .external_lex_state = 13},
  [1433] = {.lex_state = 112, .external_lex_state = 13},
  [1434] = {.lex_state = 112, .external_lex_state = 13},
  [1435] = {.lex_state = 92, .external_lex_state = 29},
  [1436] = {.lex_state = 92, .external_lex_state = 29},
  [1437] = {.lex_state = 92, .external_lex_state = 18},
  [1438] = {.lex_state = 259, .external_lex_state = 18},
  [1439] = {.lex_state = 112, .external_lex_state = 13},
  [1440] = {.lex_state = 261, .external_lex_state = 30},
  [1441] = {.lex_state = 261, .external_lex_state = 18},
  [1442] = {.lex_state = 261, .external_lex_state = 30},
  [1443] = {.lex_state = 261, .external_lex_state = 18},
  [1444] = {.lex_state = 261, .external_lex_state = 18},
  [1445] = {.lex_state = 112, .external_lex_state = 13},
  [1446] = {.lex_state = 261, .external_lex_state = 18},
  [1447] = {.lex_state = 261, .external_lex_state = 18},
  [1448] = {.lex_state = 136, .external_lex_state = 12},
  [1449] = {.lex_state = 144, .external_lex_state = 8},
  [1450] = {.lex_state = 85},
  [1451] = {.lex_state = 272, .external_lex_state = 21},
  [1452] = {.lex_state = 115},
  [1453] = {.lex_state = 122},
  [1454] = {.lex_state = 272, .external_lex_state = 21},
  [1455] = {.lex_state = 122, .external_lex_state = 7},
  [1456] = {.lex_state = 78, .external_lex_state = 2},
  [1457] = {.lex_state = 78, .external_lex_state = 2},
  [1458] = {.lex_state = 78, .external_lex_state = 2},
  [1459] = {.lex_state = 85},
  [1460] = {.lex_state = 272, .external_lex_state = 4},
  [1461] = {.lex_state = 272, .external_lex_state = 6},
  [1462] = {.lex_state = 115},
  [1463] = {.lex_state = 122},
  [1464] = {.lex_state = 272, .external_lex_state = 6},
  [1465] = {.lex_state = 122, .external_lex_state = 7},
  [1466] = {.lex_state = 78, .external_lex_state = 2},
  [1467] = {.lex_state = 78, .external_lex_state = 2},
  [1468] = {.lex_state = 78, .external_lex_state = 2},
  [1469] = {.lex_state = 272, .external_lex_state = 5},
  [1470] = {.lex_state = 102},
  [1471] = {.lex_state = 278, .external_lex_state = 6},
  [1472] = {.lex_state = 278, .external_lex_state = 6},
  [1473] = {.lex_state = 217},
  [1474] = {.lex_state = 115},
  [1475] = {.lex_state = 278, .external_lex_state = 6},
  [1476] = {.lex_state = 278, .external_lex_state = 6},
  [1477] = {.lex_state = 278, .external_lex_state = 6},
  [1478] = {.lex_state = 85},
  [1479] = {.lex_state = 223, .external_lex_state = 7},
  [1480] = {.lex_state = 225, .external_lex_state = 18},
  [1481] = {.lex_state = 225, .external_lex_state = 18},
  [1482] = {.lex_state = 85},
  [1483] = {.lex_state = 215, .external_lex_state = 2},
  [1484] = {.lex_state = 78},
  [1485] = {.lex_state = 85},
  [1486] = {.lex_state = 186, .external_lex_state = 5},
  [1487] = {.lex_state = 78},
  [1488] = {.lex_state = 248, .external_lex_state = 2},
  [1489] = {.lex_state = 78, .external_lex_state = 2},
  [1490] = {.lex_state = 78, .external_lex_state = 2},
  [1491] = {.lex_state = 102},
  [1492] = {.lex_state = 102},
  [1493] = {.lex_state = 313, .external_lex_state = 9},
  [1494] = {.lex_state = 282, .external_lex_state = 5},
  [1495] = {.lex_state = 237, .external_lex_state = 25},
  [1496] = {.lex_state = 278, .external_lex_state = 6},
  [1497] = {.lex_state = 278, .external_lex_state = 6},
  [1498] = {.lex_state = 278, .external_lex_state = 5},
  [1499] = {.lex_state = 282, .external_lex_state = 5},
  [1500] = {.lex_state = 284, .external_lex_state = 4},
  [1501] = {.lex_state = 278, .external_lex_state = 5},
  [1502] = {.lex_state = 136, .external_lex_state = 13},
  [1503] = {.lex_state = 136, .external_lex_state = 13},
  [1504] = {.lex_state = 136, .external_lex_state = 12},
  [1505] = {.lex_state = 136, .external_lex_state = 13},
  [1506] = {.lex_state = 144, .external_lex_state = 8},
  [1507] = {.lex_state = 102},
  [1508] = {.lex_state = 85},
  [1509] = {.lex_state = 106, .external_lex_state = 2},
  [1510] = {.lex_state = 315, .external_lex_state = 4},
  [1511] = {.lex_state = 315, .external_lex_state = 5},
  [1512] = {.lex_state = 317, .external_lex_state = 6},
  [1513] = {.lex_state = 115},
  [1514] = {.lex_state = 122},
  [1515] = {.lex_state = 317, .external_lex_state = 6},
  [1516] = {.lex_state = 122, .external_lex_state = 7},
  [1517] = {.lex_state = 78, .external_lex_state = 2},
  [1518] = {.lex_state = 78, .external_lex_state = 2},
  [1519] = {.lex_state = 78, .external_lex_state = 2},
  [1520] = {.lex_state = 319, .external_lex_state = 6},
  [1521] = {.lex_state = 302},
  [1522] = {.lex_state = 321, .external_lex_state = 5},
  [1523] = {.lex_state = 317, .external_lex_state = 5},
  [1524] = {.lex_state = 323, .external_lex_state = 4},
  [1525] = {.lex_state = 85},
  [1526] = {.lex_state = 317, .external_lex_state = 5},
  [1527] = {.lex_state = 78, .external_lex_state = 2},
  [1528] = {.lex_state = 102, .external_lex_state = 2},
  [1529] = {.lex_state = 85},
  [1530] = {.lex_state = 288, .external_lex_state = 21},
  [1531] = {.lex_state = 115},
  [1532] = {.lex_state = 122},
  [1533] = {.lex_state = 288, .external_lex_state = 21},
  [1534] = {.lex_state = 122, .external_lex_state = 7},
  [1535] = {.lex_state = 78, .external_lex_state = 2},
  [1536] = {.lex_state = 78, .external_lex_state = 2},
  [1537] = {.lex_state = 78, .external_lex_state = 2},
  [1538] = {.lex_state = 85},
  [1539] = {.lex_state = 288, .external_lex_state = 4},
  [1540] = {.lex_state = 288, .external_lex_state = 6},
  [1541] = {.lex_state = 115},
  [1542] = {.lex_state = 122},
  [1543] = {.lex_state = 288, .external_lex_state = 6},
  [1544] = {.lex_state = 122, .external_lex_state = 7},
  [1545] = {.lex_state = 78, .external_lex_state = 2},
  [1546] = {.lex_state = 78, .external_lex_state = 2},
  [1547] = {.lex_state = 78, .external_lex_state = 2},
  [1548] = {.lex_state = 288, .external_lex_state = 5},
  [1549] = {.lex_state = 102},
  [1550] = {.lex_state = 298, .external_lex_state = 6},
  [1551] = {.lex_state = 298, .external_lex_state = 6},
  [1552] = {.lex_state = 217},
  [1553] = {.lex_state = 115},
  [1554] = {.lex_state = 298, .external_lex_state = 6},
  [1555] = {.lex_state = 298, .external_lex_state = 6},
  [1556] = {.lex_state = 298, .external_lex_state = 6},
  [1557] = {.lex_state = 85},
  [1558] = {.lex_state = 223, .external_lex_state = 7},
  [1559] = {.lex_state = 225, .external_lex_state = 18},
  [1560] = {.lex_state = 225, .external_lex_state = 18},
  [1561] = {.lex_state = 85},
  [1562] = {.lex_state = 215, .external_lex_state = 2},
  [1563] = {.lex_state = 78},
  [1564] = {.lex_state = 85},
  [1565] = {.lex_state = 186, .external_lex_state = 5},
  [1566] = {.lex_state = 302},
  [1567] = {.lex_state = 302},
  [1568] = {.lex_state = 78},
  [1569] = {.lex_state = 254, .external_lex_state = 2},
  [1570] = {.lex_state = 78, .external_lex_state = 2},
  [1571] = {.lex_state = 78, .external_lex_state = 2},
  [1572] = {.lex_state = 102},
  [1573] = {.lex_state = 102},
  [1574] = {.lex_state = 325, .external_lex_state = 9},
  [1575] = {.lex_state = 302, .external_lex_state = 5},
  [1576] = {.lex_state = 237, .external_lex_state = 25},
  [1577] = {.lex_state = 298, .external_lex_state = 6},
  [1578] = {.lex_state = 298, .external_lex_state = 6},
  [1579] = {.lex_state = 298, .external_lex_state = 5},
  [1580] = {.lex_state = 302, .external_lex_state = 5},
  [1581] = {.lex_state = 305, .external_lex_state = 4},
  [1582] = {.lex_state = 302},
  [1583] = {.lex_state = 298, .external_lex_state = 5},
  [1584] = {.lex_state = 186, .external_lex_state = 5},
  [1585] = {.lex_state = 327, .external_lex_state = 10},
  [1586] = {.lex_state = 327, .external_lex_state = 10},
  [1587] = {.lex_state = 330},
  [1588] = {.lex_state = 327},
  [1589] = {.lex_state = 102},
  [1590] = {.lex_state = 307},
  [1591] = {.lex_state = 149, .external_lex_state = 14},
  [1592] = {.lex_state = 186, .external_lex_state = 5},
  [1593] = {.lex_state = 330},
  [1594] = {.lex_state = 102},
  [1595] = {.lex_state = 307},
  [1596] = {.lex_state = 149, .external_lex_state = 14},
  [1597] = {.lex_state = 92, .external_lex_state = 29},
  [1598] = {.lex_state = 92, .external_lex_state = 29},
  [1599] = {.lex_state = 92, .external_lex_state = 18},
  [1600] = {.lex_state = 259, .external_lex_state = 18},
  [1601] = {.lex_state = 149, .external_lex_state = 14},
  [1602] = {.lex_state = 261, .external_lex_state = 30},
  [1603] = {.lex_state = 261, .external_lex_state = 18},
  [1604] = {.lex_state = 261, .external_lex_state = 30},
  [1605] = {.lex_state = 261, .external_lex_state = 18},
  [1606] = {.lex_state = 261, .external_lex_state = 18},
  [1607] = {.lex_state = 149, .external_lex_state = 14},
  [1608] = {.lex_state = 261, .external_lex_state = 18},
  [1609] = {.lex_state = 261, .external_lex_state = 18},
  [1610] = {.lex_state = 186, .external_lex_state = 5},
  [1611] = {.lex_state = 184, .external_lex_state = 21},
  [1612] = {.lex_state = 178, .external_lex_state = 21},
  [1613] = {.lex_state = 178, .external_lex_state = 21},
  [1614] = {.lex_state = 178, .external_lex_state = 21},
  [1615] = {.lex_state = 178, .external_lex_state = 6},
  [1616] = {.lex_state = 182, .external_lex_state = 6},
  [1617] = {.lex_state = 182, .external_lex_state = 6},
  [1618] = {.lex_state = 182, .external_lex_state = 6},
  [1619] = {.lex_state = 207, .external_lex_state = 15},
  [1620] = {.lex_state = 215},
  [1621] = {.lex_state = 102},
  [1622] = {.lex_state = 207, .external_lex_state = 27},
  [1623] = {.lex_state = 207, .external_lex_state = 27},
  [1624] = {.lex_state = 217},
  [1625] = {.lex_state = 115},
  [1626] = {.lex_state = 207, .external_lex_state = 27},
  [1627] = {.lex_state = 207, .external_lex_state = 27},
  [1628] = {.lex_state = 207, .external_lex_state = 27},
  [1629] = {.lex_state = 85},
  [1630] = {.lex_state = 223, .external_lex_state = 7},
  [1631] = {.lex_state = 225, .external_lex_state = 18},
  [1632] = {.lex_state = 225, .external_lex_state = 18},
  [1633] = {.lex_state = 85},
  [1634] = {.lex_state = 215, .external_lex_state = 2},
  [1635] = {.lex_state = 78},
  [1636] = {.lex_state = 85},
  [1637] = {.lex_state = 265},
  [1638] = {.lex_state = 241, .external_lex_state = 9},
  [1639] = {.lex_state = 146, .external_lex_state = 9},
  [1640] = {.lex_state = 267, .external_lex_state = 9},
  [1641] = {.lex_state = 205, .external_lex_state = 16},
  [1642] = {.lex_state = 205, .external_lex_state = 16},
  [1643] = {.lex_state = 172},
  [1644] = {.lex_state = 205, .external_lex_state = 16},
  [1645] = {.lex_state = 302},
  [1646] = {.lex_state = 302},
  [1647] = {.lex_state = 302},
  [1648] = {.lex_state = 307},
  [1649] = {.lex_state = 146, .external_lex_state = 9},
  [1650] = {.lex_state = 307},
  [1651] = {.lex_state = 146, .external_lex_state = 9},
  [1652] = {.lex_state = 78},
  [1653] = {.lex_state = 199, .external_lex_state = 15},
  [1654] = {.lex_state = 215},
  [1655] = {.lex_state = 199, .external_lex_state = 27},
  [1656] = {.lex_state = 199, .external_lex_state = 27},
  [1657] = {.lex_state = 199, .external_lex_state = 27},
  [1658] = {.lex_state = 199, .external_lex_state = 27},
  [1659] = {.lex_state = 199, .external_lex_state = 27},
  [1660] = {.lex_state = 217},
  [1661] = {.lex_state = 259, .external_lex_state = 18},
  [1662] = {.lex_state = 85},
  [1663] = {.lex_state = 225, .external_lex_state = 18},
  [1664] = {.lex_state = 225, .external_lex_state = 18},
  [1665] = {.lex_state = 199, .external_lex_state = 27},
  [1666] = {.lex_state = 261, .external_lex_state = 30},
  [1667] = {.lex_state = 261, .external_lex_state = 18},
  [1668] = {.lex_state = 199, .external_lex_state = 27},
  [1669] = {.lex_state = 261, .external_lex_state = 30},
  [1670] = {.lex_state = 261, .external_lex_state = 18},
  [1671] = {.lex_state = 199, .external_lex_state = 27},
  [1672] = {.lex_state = 199, .external_lex_state = 27},
  [1673] = {.lex_state = 199, .external_lex_state = 17},
  [1674] = {.lex_state = 199, .external_lex_state = 17},
  [1675] = {.lex_state = 199, .external_lex_state = 17},
  [1676] = {.lex_state = 217},
  [1677] = {.lex_state = 259, .external_lex_state = 18},
  [1678] = {.lex_state = 85},
  [1679] = {.lex_state = 225, .external_lex_state = 18},
  [1680] = {.lex_state = 225, .external_lex_state = 18},
  [1681] = {.lex_state = 199, .external_lex_state = 17},
  [1682] = {.lex_state = 261, .external_lex_state = 30},
  [1683] = {.lex_state = 261, .external_lex_state = 18},
  [1684] = {.lex_state = 199, .external_lex_state = 17},
  [1685] = {.lex_state = 261, .external_lex_state = 30},
  [1686] = {.lex_state = 261, .external_lex_state = 18},
  [1687] = {.lex_state = 199, .external_lex_state = 17},
  [1688] = {.lex_state = 199, .external_lex_state = 17},
  [1689] = {.lex_state = 201, .external_lex_state = 17},
  [1690] = {.lex_state = 201, .external_lex_state = 17},
  [1691] = {.lex_state = 92, .external_lex_state = 29},
  [1692] = {.lex_state = 92, .external_lex_state = 29},
  [1693] = {.lex_state = 92, .external_lex_state = 18},
  [1694] = {.lex_state = 259, .external_lex_state = 18},
  [1695] = {.lex_state = 201, .external_lex_state = 17},
  [1696] = {.lex_state = 261, .external_lex_state = 30},
  [1697] = {.lex_state = 261, .external_lex_state = 18},
  [1698] = {.lex_state = 261, .external_lex_state = 30},
  [1699] = {.lex_state = 261, .external_lex_state = 18},
  [1700] = {.lex_state = 261, .external_lex_state = 18},
  [1701] = {.lex_state = 201, .external_lex_state = 17},
  [1702] = {.lex_state = 261, .external_lex_state = 18},
  [1703] = {.lex_state = 261, .external_lex_state = 18},
  [1704] = {.lex_state = 205, .external_lex_state = 16},
  [1705] = {.lex_state = 257, .external_lex_state = 28},
  [1706] = {.lex_state = 205, .external_lex_state = 17},
  [1707] = {.lex_state = 205, .external_lex_state = 17},
  [1708] = {.lex_state = 205, .external_lex_state = 16},
  [1709] = {.lex_state = 205, .external_lex_state = 17},
  [1710] = {.lex_state = 104, .external_lex_state = 3},
  [1711] = {.lex_state = 102, .external_lex_state = 2},
  [1712] = {.lex_state = 215},
  [1713] = {.lex_state = 209, .external_lex_state = 19},
  [1714] = {.lex_state = 209, .external_lex_state = 19},
  [1715] = {.lex_state = 92, .external_lex_state = 29},
  [1716] = {.lex_state = 92, .external_lex_state = 29},
  [1717] = {.lex_state = 92, .external_lex_state = 18},
  [1718] = {.lex_state = 259, .external_lex_state = 18},
  [1719] = {.lex_state = 209, .external_lex_state = 19},
  [1720] = {.lex_state = 261, .external_lex_state = 30},
  [1721] = {.lex_state = 261, .external_lex_state = 18},
  [1722] = {.lex_state = 261, .external_lex_state = 30},
  [1723] = {.lex_state = 261, .external_lex_state = 18},
  [1724] = {.lex_state = 261, .external_lex_state = 18},
  [1725] = {.lex_state = 209, .external_lex_state = 19},
  [1726] = {.lex_state = 261, .external_lex_state = 18},
  [1727] = {.lex_state = 261, .external_lex_state = 18},
  [1728] = {.lex_state = 178, .external_lex_state = 4},
  [1729] = {.lex_state = 215},
  [1730] = {.lex_state = 178, .external_lex_state = 21},
  [1731] = {.lex_state = 178, .external_lex_state = 21},
  [1732] = {.lex_state = 92, .external_lex_state = 29},
  [1733] = {.lex_state = 92, .external_lex_state = 29},
  [1734] = {.lex_state = 92, .external_lex_state = 18},
  [1735] = {.lex_state = 259, .external_lex_state = 18},
  [1736] = {.lex_state = 178, .external_lex_state = 21},
  [1737] = {.lex_state = 261, .external_lex_state = 30},
  [1738] = {.lex_state = 261, .external_lex_state = 18},
  [1739] = {.lex_state = 261, .external_lex_state = 30},
  [1740] = {.lex_state = 261, .external_lex_state = 18},
  [1741] = {.lex_state = 261, .external_lex_state = 18},
  [1742] = {.lex_state = 178, .external_lex_state = 21},
  [1743] = {.lex_state = 261, .external_lex_state = 18},
  [1744] = {.lex_state = 261, .external_lex_state = 18},
  [1745] = {.lex_state = 178, .external_lex_state = 6},
  [1746] = {.lex_state = 178, .external_lex_state = 6},
  [1747] = {.lex_state = 92, .external_lex_state = 29},
  [1748] = {.lex_state = 92, .external_lex_state = 29},
  [1749] = {.lex_state = 92, .external_lex_state = 18},
  [1750] = {.lex_state = 259, .external_lex_state = 18},
  [1751] = {.lex_state = 178, .external_lex_state = 6},
  [1752] = {.lex_state = 261, .external_lex_state = 30},
  [1753] = {.lex_state = 261, .external_lex_state = 18},
  [1754] = {.lex_state = 261, .external_lex_state = 30},
  [1755] = {.lex_state = 261, .external_lex_state = 18},
  [1756] = {.lex_state = 261, .external_lex_state = 18},
  [1757] = {.lex_state = 178, .external_lex_state = 6},
  [1758] = {.lex_state = 261, .external_lex_state = 18},
  [1759] = {.lex_state = 261, .external_lex_state = 18},
  [1760] = {.lex_state = 215, .external_lex_state = 22},
  [1761] = {.lex_state = 215, .external_lex_state = 22},
  [1762] = {.lex_state = 92, .external_lex_state = 29},
  [1763] = {.lex_state = 92, .external_lex_state = 29},
  [1764] = {.lex_state = 92, .external_lex_state = 18},
  [1765] = {.lex_state = 259, .external_lex_state = 18},
  [1766] = {.lex_state = 215, .external_lex_state = 22},
  [1767] = {.lex_state = 261, .external_lex_state = 30},
  [1768] = {.lex_state = 261, .external_lex_state = 18},
  [1769] = {.lex_state = 261, .external_lex_state = 30},
  [1770] = {.lex_state = 261, .external_lex_state = 18},
  [1771] = {.lex_state = 261, .external_lex_state = 18},
  [1772] = {.lex_state = 215, .external_lex_state = 22},
  [1773] = {.lex_state = 261, .external_lex_state = 18},
  [1774] = {.lex_state = 261, .external_lex_state = 18},
  [1775] = {.lex_state = 115, .external_lex_state = 10},
  [1776] = {.lex_state = 92, .external_lex_state = 29},
  [1777] = {.lex_state = 92, .external_lex_state = 29},
  [1778] = {.lex_state = 92, .external_lex_state = 18},
  [1779] = {.lex_state = 259, .external_lex_state = 18},
  [1780] = {.lex_state = 115, .external_lex_state = 10},
  [1781] = {.lex_state = 261, .external_lex_state = 30},
  [1782] = {.lex_state = 261, .external_lex_state = 18},
  [1783] = {.lex_state = 261, .external_lex_state = 30},
  [1784] = {.lex_state = 261, .external_lex_state = 18},
  [1785] = {.lex_state = 261, .external_lex_state = 18},
  [1786] = {.lex_state = 115, .external_lex_state = 10},
  [1787] = {.lex_state = 261, .external_lex_state = 18},
  [1788] = {.lex_state = 261, .external_lex_state = 18},
  [1789] = {.lex_state = 239, .external_lex_state = 20},
  [1790] = {.lex_state = 225, .external_lex_state = 29},
  [1791] = {.lex_state = 239, .external_lex_state = 20},
  [1792] = {.lex_state = 225, .external_lex_state = 29},
  [1793] = {.lex_state = 209, .external_lex_state = 20},
  [1794] = {.lex_state = 102},
  [1795] = {.lex_state = 142, .external_lex_state = 6},
  [1796] = {.lex_state = 92, .external_lex_state = 29},
  [1797] = {.lex_state = 92, .external_lex_state = 29},
  [1798] = {.lex_state = 217},
  [1799] = {.lex_state = 115},
  [1800] = {.lex_state = 92, .external_lex_state = 29},
  [1801] = {.lex_state = 92, .external_lex_state = 29},
  [1802] = {.lex_state = 92, .external_lex_state = 29},
  [1803] = {.lex_state = 142, .external_lex_state = 6},
  [1804] = {.lex_state = 85},
  [1805] = {.lex_state = 223, .external_lex_state = 7},
  [1806] = {.lex_state = 225, .external_lex_state = 18},
  [1807] = {.lex_state = 225, .external_lex_state = 18},
  [1808] = {.lex_state = 85},
  [1809] = {.lex_state = 215, .external_lex_state = 2},
  [1810] = {.lex_state = 78},
  [1811] = {.lex_state = 85},
  [1812] = {.lex_state = 92, .external_lex_state = 29},
  [1813] = {.lex_state = 92, .external_lex_state = 29},
  [1814] = {.lex_state = 92, .external_lex_state = 18},
  [1815] = {.lex_state = 261, .external_lex_state = 18},
  [1816] = {.lex_state = 142, .external_lex_state = 6},
  [1817] = {.lex_state = 261, .external_lex_state = 18},
  [1818] = {.lex_state = 261, .external_lex_state = 18},
  [1819] = {.lex_state = 261, .external_lex_state = 18},
  [1820] = {.lex_state = 261, .external_lex_state = 29},
  [1821] = {.lex_state = 261, .external_lex_state = 29},
  [1822] = {.lex_state = 261, .external_lex_state = 29},
  [1823] = {.lex_state = 217},
  [1824] = {.lex_state = 259, .external_lex_state = 18},
  [1825] = {.lex_state = 85},
  [1826] = {.lex_state = 225, .external_lex_state = 18},
  [1827] = {.lex_state = 225, .external_lex_state = 18},
  [1828] = {.lex_state = 261, .external_lex_state = 29},
  [1829] = {.lex_state = 261, .external_lex_state = 30},
  [1830] = {.lex_state = 261, .external_lex_state = 18},
  [1831] = {.lex_state = 261, .external_lex_state = 29},
  [1832] = {.lex_state = 261, .external_lex_state = 30},
  [1833] = {.lex_state = 261, .external_lex_state = 18},
  [1834] = {.lex_state = 142, .external_lex_state = 6},
  [1835] = {.lex_state = 261, .external_lex_state = 18},
  [1836] = {.lex_state = 261, .external_lex_state = 29},
  [1837] = {.lex_state = 261, .external_lex_state = 29},
  [1838] = {.lex_state = 215, .external_lex_state = 22},
  [1839] = {.lex_state = 140, .external_lex_state = 21},
  [1840] = {.lex_state = 108, .external_lex_state = 21},
  [1841] = {.lex_state = 108, .external_lex_state = 21},
  [1842] = {.lex_state = 108, .external_lex_state = 21},
  [1843] = {.lex_state = 108, .external_lex_state = 6},
  [1844] = {.lex_state = 229, .external_lex_state = 6},
  [1845] = {.lex_state = 229, .external_lex_state = 6},
  [1846] = {.lex_state = 229, .external_lex_state = 6},
  [1847] = {.lex_state = 78, .external_lex_state = 2},
  [1848] = {.lex_state = 259, .external_lex_state = 18},
  [1849] = {.lex_state = 85},
  [1850] = {.lex_state = 225, .external_lex_state = 18},
  [1851] = {.lex_state = 225, .external_lex_state = 18},
  [1852] = {.lex_state = 96, .external_lex_state = 23},
  [1853] = {.lex_state = 261, .external_lex_state = 30},
  [1854] = {.lex_state = 261, .external_lex_state = 18},
  [1855] = {.lex_state = 96, .external_lex_state = 23},
  [1856] = {.lex_state = 261, .external_lex_state = 30},
  [1857] = {.lex_state = 261, .external_lex_state = 18},
  [1858] = {.lex_state = 96, .external_lex_state = 23},
  [1859] = {.lex_state = 136, .external_lex_state = 6},
  [1860] = {.lex_state = 102},
  [1861] = {.lex_state = 136, .external_lex_state = 5},
  [1862] = {.lex_state = 140, .external_lex_state = 4},
  [1863] = {.lex_state = 136, .external_lex_state = 5},
  [1864] = {.lex_state = 140, .external_lex_state = 4},
  [1865] = {.lex_state = 136, .external_lex_state = 6},
  [1866] = {.lex_state = 136, .external_lex_state = 6},
  [1867] = {.lex_state = 136, .external_lex_state = 6},
  [1868] = {.lex_state = 136, .external_lex_state = 6},
  [1869] = {.lex_state = 78, .external_lex_state = 2},
  [1870] = {.lex_state = 136, .external_lex_state = 5},
  [1871] = {.lex_state = 112, .external_lex_state = 5},
  [1872] = {.lex_state = 85},
  [1873] = {.lex_state = 85},
  [1874] = {.lex_state = 215, .external_lex_state = 10},
  [1875] = {.lex_state = 215, .external_lex_state = 10},
  [1876] = {.lex_state = 215, .external_lex_state = 10},
  [1877] = {.lex_state = 217},
  [1878] = {.lex_state = 259, .external_lex_state = 18},
  [1879] = {.lex_state = 85},
  [1880] = {.lex_state = 225, .external_lex_state = 18},
  [1881] = {.lex_state = 225, .external_lex_state = 18},
  [1882] = {.lex_state = 215, .external_lex_state = 10},
  [1883] = {.lex_state = 261, .external_lex_state = 30},
  [1884] = {.lex_state = 261, .external_lex_state = 18},
  [1885] = {.lex_state = 215, .external_lex_state = 10},
  [1886] = {.lex_state = 261, .external_lex_state = 30},
  [1887] = {.lex_state = 261, .external_lex_state = 18},
  [1888] = {.lex_state = 215, .external_lex_state = 10},
  [1889] = {.lex_state = 215, .external_lex_state = 10},
  [1890] = {.lex_state = 184, .external_lex_state = 21},
  [1891] = {.lex_state = 184, .external_lex_state = 21},
  [1892] = {.lex_state = 92, .external_lex_state = 29},
  [1893] = {.lex_state = 92, .external_lex_state = 29},
  [1894] = {.lex_state = 92, .external_lex_state = 18},
  [1895] = {.lex_state = 259, .external_lex_state = 18},
  [1896] = {.lex_state = 184, .external_lex_state = 21},
  [1897] = {.lex_state = 261, .external_lex_state = 30},
  [1898] = {.lex_state = 261, .external_lex_state = 18},
  [1899] = {.lex_state = 261, .external_lex_state = 30},
  [1900] = {.lex_state = 261, .external_lex_state = 18},
  [1901] = {.lex_state = 261, .external_lex_state = 18},
  [1902] = {.lex_state = 184, .external_lex_state = 21},
  [1903] = {.lex_state = 261, .external_lex_state = 18},
  [1904] = {.lex_state = 261, .external_lex_state = 18},
  [1905] = {.lex_state = 310},
  [1906] = {.lex_state = 186, .external_lex_state = 5},
  [1907] = {.lex_state = 310},
  [1908] = {.lex_state = 153},
  [1909] = {.lex_state = 241, .external_lex_state = 14},
  [1910] = {.lex_state = 241, .external_lex_state = 14},
  [1911] = {.lex_state = 92, .external_lex_state = 29},
  [1912] = {.lex_state = 92, .external_lex_state = 29},
  [1913] = {.lex_state = 92, .external_lex_state = 18},
  [1914] = {.lex_state = 259, .external_lex_state = 18},
  [1915] = {.lex_state = 241, .external_lex_state = 14},
  [1916] = {.lex_state = 261, .external_lex_state = 30},
  [1917] = {.lex_state = 261, .external_lex_state = 18},
  [1918] = {.lex_state = 261, .external_lex_state = 30},
  [1919] = {.lex_state = 261, .external_lex_state = 18},
  [1920] = {.lex_state = 261, .external_lex_state = 18},
  [1921] = {.lex_state = 241, .external_lex_state = 14},
  [1922] = {.lex_state = 261, .external_lex_state = 18},
  [1923] = {.lex_state = 261, .external_lex_state = 18},
  [1924] = {.lex_state = 265},
  [1925] = {.lex_state = 267, .external_lex_state = 14},
  [1926] = {.lex_state = 267, .external_lex_state = 14},
  [1927] = {.lex_state = 267, .external_lex_state = 14},
  [1928] = {.lex_state = 217},
  [1929] = {.lex_state = 259, .external_lex_state = 18},
  [1930] = {.lex_state = 85},
  [1931] = {.lex_state = 225, .external_lex_state = 18},
  [1932] = {.lex_state = 225, .external_lex_state = 18},
  [1933] = {.lex_state = 267, .external_lex_state = 14},
  [1934] = {.lex_state = 261, .external_lex_state = 30},
  [1935] = {.lex_state = 261, .external_lex_state = 18},
  [1936] = {.lex_state = 267, .external_lex_state = 14},
  [1937] = {.lex_state = 261, .external_lex_state = 30},
  [1938] = {.lex_state = 261, .external_lex_state = 18},
  [1939] = {.lex_state = 267, .external_lex_state = 14},
  [1940] = {.lex_state = 267, .external_lex_state = 14},
  [1941] = {.lex_state = 186, .external_lex_state = 5},
  [1942] = {.lex_state = 269, .external_lex_state = 10},
  [1943] = {.lex_state = 269, .external_lex_state = 10},
  [1944] = {.lex_state = 92, .external_lex_state = 29},
  [1945] = {.lex_state = 92, .external_lex_state = 29},
  [1946] = {.lex_state = 92, .external_lex_state = 18},
  [1947] = {.lex_state = 259, .external_lex_state = 18},
  [1948] = {.lex_state = 269, .external_lex_state = 10},
  [1949] = {.lex_state = 261, .external_lex_state = 30},
  [1950] = {.lex_state = 261, .external_lex_state = 18},
  [1951] = {.lex_state = 261, .external_lex_state = 30},
  [1952] = {.lex_state = 261, .external_lex_state = 18},
  [1953] = {.lex_state = 261, .external_lex_state = 18},
  [1954] = {.lex_state = 269, .external_lex_state = 10},
  [1955] = {.lex_state = 261, .external_lex_state = 18},
  [1956] = {.lex_state = 261, .external_lex_state = 18},
  [1957] = {.lex_state = 246, .external_lex_state = 10},
  [1958] = {.lex_state = 246, .external_lex_state = 10},
  [1959] = {.lex_state = 92, .external_lex_state = 29},
  [1960] = {.lex_state = 92, .external_lex_state = 29},
  [1961] = {.lex_state = 92, .external_lex_state = 18},
  [1962] = {.lex_state = 261, .external_lex_state = 18},
  [1963] = {.lex_state = 246, .external_lex_state = 10},
  [1964] = {.lex_state = 261, .external_lex_state = 18},
  [1965] = {.lex_state = 261, .external_lex_state = 18},
  [1966] = {.lex_state = 261, .external_lex_state = 18},
  [1967] = {.lex_state = 246, .external_lex_state = 10},
  [1968] = {.lex_state = 261, .external_lex_state = 18},
  [1969] = {.lex_state = 140, .external_lex_state = 11},
  [1970] = {.lex_state = 140, .external_lex_state = 26},
  [1971] = {.lex_state = 140, .external_lex_state = 26},
  [1972] = {.lex_state = 140, .external_lex_state = 26},
  [1973] = {.lex_state = 217},
  [1974] = {.lex_state = 259, .external_lex_state = 18},
  [1975] = {.lex_state = 85},
  [1976] = {.lex_state = 225, .external_lex_state = 18},
  [1977] = {.lex_state = 225, .external_lex_state = 18},
  [1978] = {.lex_state = 140, .external_lex_state = 26},
  [1979] = {.lex_state = 261, .external_lex_state = 30},
  [1980] = {.lex_state = 261, .external_lex_state = 18},
  [1981] = {.lex_state = 140, .external_lex_state = 26},
  [1982] = {.lex_state = 261, .external_lex_state = 30},
  [1983] = {.lex_state = 261, .external_lex_state = 18},
  [1984] = {.lex_state = 140, .external_lex_state = 26},
  [1985] = {.lex_state = 140, .external_lex_state = 26},
  [1986] = {.lex_state = 310},
  [1987] = {.lex_state = 153},
  [1988] = {.lex_state = 265},
  [1989] = {.lex_state = 241, .external_lex_state = 9},
  [1990] = {.lex_state = 102},
  [1991] = {.lex_state = 136, .external_lex_state = 12},
  [1992] = {.lex_state = 136, .external_lex_state = 12},
  [1993] = {.lex_state = 302},
  [1994] = {.lex_state = 302},
  [1995] = {.lex_state = 136, .external_lex_state = 12},
  [1996] = {.lex_state = 330},
  [1997] = {.lex_state = 102},
  [1998] = {.lex_state = 307},
  [1999] = {.lex_state = 136, .external_lex_state = 12},
  [2000] = {.lex_state = 330},
  [2001] = {.lex_state = 102},
  [2002] = {.lex_state = 307},
  [2003] = {.lex_state = 136, .external_lex_state = 12},
  [2004] = {.lex_state = 108, .external_lex_state = 11},
  [2005] = {.lex_state = 215},
  [2006] = {.lex_state = 108, .external_lex_state = 26},
  [2007] = {.lex_state = 108, .external_lex_state = 26},
  [2008] = {.lex_state = 92, .external_lex_state = 29},
  [2009] = {.lex_state = 92, .external_lex_state = 29},
  [2010] = {.lex_state = 92, .external_lex_state = 18},
  [2011] = {.lex_state = 259, .external_lex_state = 18},
  [2012] = {.lex_state = 108, .external_lex_state = 26},
  [2013] = {.lex_state = 261, .external_lex_state = 30},
  [2014] = {.lex_state = 261, .external_lex_state = 18},
  [2015] = {.lex_state = 261, .external_lex_state = 30},
  [2016] = {.lex_state = 261, .external_lex_state = 18},
  [2017] = {.lex_state = 261, .external_lex_state = 18},
  [2018] = {.lex_state = 108, .external_lex_state = 26},
  [2019] = {.lex_state = 261, .external_lex_state = 18},
  [2020] = {.lex_state = 261, .external_lex_state = 18},
  [2021] = {.lex_state = 108, .external_lex_state = 13},
  [2022] = {.lex_state = 108, .external_lex_state = 13},
  [2023] = {.lex_state = 92, .external_lex_state = 29},
  [2024] = {.lex_state = 92, .external_lex_state = 29},
  [2025] = {.lex_state = 92, .external_lex_state = 18},
  [2026] = {.lex_state = 259, .external_lex_state = 18},
  [2027] = {.lex_state = 108, .external_lex_state = 13},
  [2028] = {.lex_state = 261, .external_lex_state = 30},
  [2029] = {.lex_state = 261, .external_lex_state = 18},
  [2030] = {.lex_state = 261, .external_lex_state = 30},
  [2031] = {.lex_state = 261, .external_lex_state = 18},
  [2032] = {.lex_state = 261, .external_lex_state = 18},
  [2033] = {.lex_state = 108, .external_lex_state = 13},
  [2034] = {.lex_state = 261, .external_lex_state = 18},
  [2035] = {.lex_state = 261, .external_lex_state = 18},
  [2036] = {.lex_state = 112, .external_lex_state = 13},
  [2037] = {.lex_state = 112, .external_lex_state = 13},
  [2038] = {.lex_state = 92, .external_lex_state = 29},
  [2039] = {.lex_state = 92, .external_lex_state = 29},
  [2040] = {.lex_state = 92, .external_lex_state = 18},
  [2041] = {.lex_state = 261, .external_lex_state = 18},
  [2042] = {.lex_state = 112, .external_lex_state = 13},
  [2043] = {.lex_state = 261, .external_lex_state = 18},
  [2044] = {.lex_state = 261, .external_lex_state = 18},
  [2045] = {.lex_state = 261, .external_lex_state = 18},
  [2046] = {.lex_state = 112, .external_lex_state = 13},
  [2047] = {.lex_state = 261, .external_lex_state = 18},
  [2048] = {.lex_state = 284, .external_lex_state = 4},
  [2049] = {.lex_state = 215},
  [2050] = {.lex_state = 284, .external_lex_state = 21},
  [2051] = {.lex_state = 115},
  [2052] = {.lex_state = 122},
  [2053] = {.lex_state = 284, .external_lex_state = 21},
  [2054] = {.lex_state = 122, .external_lex_state = 7},
  [2055] = {.lex_state = 78, .external_lex_state = 2},
  [2056] = {.lex_state = 78, .external_lex_state = 2},
  [2057] = {.lex_state = 78, .external_lex_state = 2},
  [2058] = {.lex_state = 144, .external_lex_state = 8},
  [2059] = {.lex_state = 102},
  [2060] = {.lex_state = 272, .external_lex_state = 21},
  [2061] = {.lex_state = 272, .external_lex_state = 21},
  [2062] = {.lex_state = 217},
  [2063] = {.lex_state = 115},
  [2064] = {.lex_state = 272, .external_lex_state = 21},
  [2065] = {.lex_state = 272, .external_lex_state = 21},
  [2066] = {.lex_state = 272, .external_lex_state = 21},
  [2067] = {.lex_state = 85},
  [2068] = {.lex_state = 223, .external_lex_state = 7},
  [2069] = {.lex_state = 225, .external_lex_state = 18},
  [2070] = {.lex_state = 225, .external_lex_state = 18},
  [2071] = {.lex_state = 85},
  [2072] = {.lex_state = 215, .external_lex_state = 2},
  [2073] = {.lex_state = 78},
  [2074] = {.lex_state = 85},
  [2075] = {.lex_state = 272, .external_lex_state = 4},
  [2076] = {.lex_state = 102},
  [2077] = {.lex_state = 272, .external_lex_state = 6},
  [2078] = {.lex_state = 272, .external_lex_state = 6},
  [2079] = {.lex_state = 217},
  [2080] = {.lex_state = 115},
  [2081] = {.lex_state = 272, .external_lex_state = 6},
  [2082] = {.lex_state = 272, .external_lex_state = 6},
  [2083] = {.lex_state = 272, .external_lex_state = 6},
  [2084] = {.lex_state = 85},
  [2085] = {.lex_state = 223, .external_lex_state = 7},
  [2086] = {.lex_state = 225, .external_lex_state = 18},
  [2087] = {.lex_state = 225, .external_lex_state = 18},
  [2088] = {.lex_state = 85},
  [2089] = {.lex_state = 215, .external_lex_state = 2},
  [2090] = {.lex_state = 78},
  [2091] = {.lex_state = 85},
  [2092] = {.lex_state = 272, .external_lex_state = 5},
  [2093] = {.lex_state = 278, .external_lex_state = 6},
  [2094] = {.lex_state = 278, .external_lex_state = 6},
  [2095] = {.lex_state = 278, .external_lex_state = 6},
  [2096] = {.lex_state = 217},
  [2097] = {.lex_state = 259, .external_lex_state = 18},
  [2098] = {.lex_state = 85},
  [2099] = {.lex_state = 225, .external_lex_state = 18},
  [2100] = {.lex_state = 225, .external_lex_state = 18},
  [2101] = {.lex_state = 278, .external_lex_state = 6},
  [2102] = {.lex_state = 261, .external_lex_state = 30},
  [2103] = {.lex_state = 261, .external_lex_state = 18},
  [2104] = {.lex_state = 278, .external_lex_state = 6},
  [2105] = {.lex_state = 261, .external_lex_state = 30},
  [2106] = {.lex_state = 261, .external_lex_state = 18},
  [2107] = {.lex_state = 278, .external_lex_state = 6},
  [2108] = {.lex_state = 278, .external_lex_state = 6},
  [2109] = {.lex_state = 102},
  [2110] = {.lex_state = 282, .external_lex_state = 5},
  [2111] = {.lex_state = 284, .external_lex_state = 4},
  [2112] = {.lex_state = 282, .external_lex_state = 5},
  [2113] = {.lex_state = 284, .external_lex_state = 4},
  [2114] = {.lex_state = 282, .external_lex_state = 6},
  [2115] = {.lex_state = 115},
  [2116] = {.lex_state = 122},
  [2117] = {.lex_state = 282, .external_lex_state = 6},
  [2118] = {.lex_state = 122, .external_lex_state = 7},
  [2119] = {.lex_state = 78, .external_lex_state = 2},
  [2120] = {.lex_state = 78, .external_lex_state = 2},
  [2121] = {.lex_state = 78, .external_lex_state = 2},
  [2122] = {.lex_state = 282, .external_lex_state = 6},
  [2123] = {.lex_state = 282, .external_lex_state = 6},
  [2124] = {.lex_state = 248, .external_lex_state = 2},
  [2125] = {.lex_state = 282, .external_lex_state = 5},
  [2126] = {.lex_state = 278, .external_lex_state = 5},
  [2127] = {.lex_state = 278, .external_lex_state = 6},
  [2128] = {.lex_state = 278, .external_lex_state = 6},
  [2129] = {.lex_state = 278, .external_lex_state = 5},
  [2130] = {.lex_state = 248, .external_lex_state = 2},
  [2131] = {.lex_state = 313, .external_lex_state = 9},
  [2132] = {.lex_state = 278, .external_lex_state = 5},
  [2133] = {.lex_state = 136, .external_lex_state = 13},
  [2134] = {.lex_state = 305, .external_lex_state = 4},
  [2135] = {.lex_state = 215},
  [2136] = {.lex_state = 305, .external_lex_state = 21},
  [2137] = {.lex_state = 115},
  [2138] = {.lex_state = 122},
  [2139] = {.lex_state = 305, .external_lex_state = 21},
  [2140] = {.lex_state = 122, .external_lex_state = 7},
  [2141] = {.lex_state = 78, .external_lex_state = 2},
  [2142] = {.lex_state = 78, .external_lex_state = 2},
  [2143] = {.lex_state = 78, .external_lex_state = 2},
  [2144] = {.lex_state = 254, .external_lex_state = 2},
  [2145] = {.lex_state = 144, .external_lex_state = 8},
  [2146] = {.lex_state = 85},
  [2147] = {.lex_state = 315, .external_lex_state = 21},
  [2148] = {.lex_state = 115},
  [2149] = {.lex_state = 122},
  [2150] = {.lex_state = 315, .external_lex_state = 21},
  [2151] = {.lex_state = 122, .external_lex_state = 7},
  [2152] = {.lex_state = 78, .external_lex_state = 2},
  [2153] = {.lex_state = 78, .external_lex_state = 2},
  [2154] = {.lex_state = 78, .external_lex_state = 2},
  [2155] = {.lex_state = 85},
  [2156] = {.lex_state = 315, .external_lex_state = 4},
  [2157] = {.lex_state = 315, .external_lex_state = 6},
  [2158] = {.lex_state = 115},
  [2159] = {.lex_state = 122},
  [2160] = {.lex_state = 315, .external_lex_state = 6},
  [2161] = {.lex_state = 122, .external_lex_state = 7},
  [2162] = {.lex_state = 78, .external_lex_state = 2},
  [2163] = {.lex_state = 78, .external_lex_state = 2},
  [2164] = {.lex_state = 78, .external_lex_state = 2},
  [2165] = {.lex_state = 315, .external_lex_state = 5},
  [2166] = {.lex_state = 102},
  [2167] = {.lex_state = 317, .external_lex_state = 6},
  [2168] = {.lex_state = 317, .external_lex_state = 6},
  [2169] = {.lex_state = 217},
  [2170] = {.lex_state = 115},
  [2171] = {.lex_state = 317, .external_lex_state = 6},
  [2172] = {.lex_state = 317, .external_lex_state = 6},
  [2173] = {.lex_state = 317, .external_lex_state = 6},
  [2174] = {.lex_state = 85},
  [2175] = {.lex_state = 223, .external_lex_state = 7},
  [2176] = {.lex_state = 225, .external_lex_state = 18},
  [2177] = {.lex_state = 225, .external_lex_state = 18},
  [2178] = {.lex_state = 85},
  [2179] = {.lex_state = 215, .external_lex_state = 2},
  [2180] = {.lex_state = 78},
  [2181] = {.lex_state = 85},
  [2182] = {.lex_state = 78},
  [2183] = {.lex_state = 286, .external_lex_state = 2},
  [2184] = {.lex_state = 78, .external_lex_state = 2},
  [2185] = {.lex_state = 78, .external_lex_state = 2},
  [2186] = {.lex_state = 102},
  [2187] = {.lex_state = 102},
  [2188] = {.lex_state = 325, .external_lex_state = 9},
  [2189] = {.lex_state = 321, .external_lex_state = 5},
  [2190] = {.lex_state = 237, .external_lex_state = 25},
  [2191] = {.lex_state = 317, .external_lex_state = 6},
  [2192] = {.lex_state = 317, .external_lex_state = 6},
  [2193] = {.lex_state = 317, .external_lex_state = 5},
  [2194] = {.lex_state = 321, .external_lex_state = 5},
  [2195] = {.lex_state = 323, .external_lex_state = 4},
  [2196] = {.lex_state = 317, .external_lex_state = 5},
  [2197] = {.lex_state = 144, .external_lex_state = 8},
  [2198] = {.lex_state = 102},
  [2199] = {.lex_state = 288, .external_lex_state = 21},
  [2200] = {.lex_state = 288, .external_lex_state = 21},
  [2201] = {.lex_state = 217},
  [2202] = {.lex_state = 115},
  [2203] = {.lex_state = 288, .external_lex_state = 21},
  [2204] = {.lex_state = 288, .external_lex_state = 21},
  [2205] = {.lex_state = 288, .external_lex_state = 21},
  [2206] = {.lex_state = 85},
  [2207] = {.lex_state = 223, .external_lex_state = 7},
  [2208] = {.lex_state = 225, .external_lex_state = 18},
  [2209] = {.lex_state = 225, .external_lex_state = 18},
  [2210] = {.lex_state = 85},
  [2211] = {.lex_state = 215, .external_lex_state = 2},
  [2212] = {.lex_state = 78},
  [2213] = {.lex_state = 85},
  [2214] = {.lex_state = 288, .external_lex_state = 4},
  [2215] = {.lex_state = 102},
  [2216] = {.lex_state = 288, .external_lex_state = 6},
  [2217] = {.lex_state = 288, .external_lex_state = 6},
  [2218] = {.lex_state = 217},
  [2219] = {.lex_state = 115},
  [2220] = {.lex_state = 288, .external_lex_state = 6},
  [2221] = {.lex_state = 288, .external_lex_state = 6},
  [2222] = {.lex_state = 288, .external_lex_state = 6},
  [2223] = {.lex_state = 85},
  [2224] = {.lex_state = 223, .external_lex_state = 7},
  [2225] = {.lex_state = 225, .external_lex_state = 18},
  [2226] = {.lex_state = 225, .external_lex_state = 18},
  [2227] = {.lex_state = 85},
  [2228] = {.lex_state = 215, .external_lex_state = 2},
  [2229] = {.lex_state = 78},
  [2230] = {.lex_state = 85},
  [2231] = {.lex_state = 288, .external_lex_state = 5},
  [2232] = {.lex_state = 298, .external_lex_state = 6},
  [2233] = {.lex_state = 298, .external_lex_state = 6},
  [2234] = {.lex_state = 298, .external_lex_state = 6},
  [2235] = {.lex_state = 217},
  [2236] = {.lex_state = 259, .external_lex_state = 18},
  [2237] = {.lex_state = 85},
  [2238] = {.lex_state = 225, .external_lex_state = 18},
  [2239] = {.lex_state = 225, .external_lex_state = 18},
  [2240] = {.lex_state = 298, .external_lex_state = 6},
  [2241] = {.lex_state = 261, .external_lex_state = 30},
  [2242] = {.lex_state = 261, .external_lex_state = 18},
  [2243] = {.lex_state = 298, .external_lex_state = 6},
  [2244] = {.lex_state = 261, .external_lex_state = 30},
  [2245] = {.lex_state = 261, .external_lex_state = 18},
  [2246] = {.lex_state = 298, .external_lex_state = 6},
  [2247] = {.lex_state = 298, .external_lex_state = 6},
  [2248] = {.lex_state = 186, .external_lex_state = 5},
  [2249] = {.lex_state = 302},
  [2250] = {.lex_state = 102},
  [2251] = {.lex_state = 302, .external_lex_state = 5},
  [2252] = {.lex_state = 305, .external_lex_state = 4},
  [2253] = {.lex_state = 302, .external_lex_state = 5},
  [2254] = {.lex_state = 305, .external_lex_state = 4},
  [2255] = {.lex_state = 302, .external_lex_state = 6},
  [2256] = {.lex_state = 302, .external_lex_state = 6},
  [2257] = {.lex_state = 302, .external_lex_state = 6},
  [2258] = {.lex_state = 302, .external_lex_state = 6},
  [2259] = {.lex_state = 254, .external_lex_state = 2},
  [2260] = {.lex_state = 302, .external_lex_state = 5},
  [2261] = {.lex_state = 298, .external_lex_state = 5},
  [2262] = {.lex_state = 298, .external_lex_state = 6},
  [2263] = {.lex_state = 298, .external_lex_state = 6},
  [2264] = {.lex_state = 298, .external_lex_state = 5},
  [2265] = {.lex_state = 254, .external_lex_state = 2},
  [2266] = {.lex_state = 325, .external_lex_state = 9},
  [2267] = {.lex_state = 298, .external_lex_state = 5},
  [2268] = {.lex_state = 102},
  [2269] = {.lex_state = 333, .external_lex_state = 2},
  [2270] = {.lex_state = 327},
  [2271] = {.lex_state = 327, .external_lex_state = 10},
  [2272] = {.lex_state = 333, .external_lex_state = 2},
  [2273] = {.lex_state = 327},
  [2274] = {.lex_state = 186, .external_lex_state = 5},
  [2275] = {.lex_state = 330},
  [2276] = {.lex_state = 102},
  [2277] = {.lex_state = 102},
  [2278] = {.lex_state = 186, .external_lex_state = 5},
  [2279] = {.lex_state = 330},
  [2280] = {.lex_state = 102},
  [2281] = {.lex_state = 149, .external_lex_state = 14},
  [2282] = {.lex_state = 149, .external_lex_state = 14},
  [2283] = {.lex_state = 92, .external_lex_state = 29},
  [2284] = {.lex_state = 92, .external_lex_state = 29},
  [2285] = {.lex_state = 92, .external_lex_state = 18},
  [2286] = {.lex_state = 261, .external_lex_state = 18},
  [2287] = {.lex_state = 149, .external_lex_state = 14},
  [2288] = {.lex_state = 261, .external_lex_state = 18},
  [2289] = {.lex_state = 261, .external_lex_state = 18},
  [2290] = {.lex_state = 261, .external_lex_state = 18},
  [2291] = {.lex_state = 149, .external_lex_state = 14},
  [2292] = {.lex_state = 261, .external_lex_state = 18},
  [2293] = {.lex_state = 184, .external_lex_state = 21},
  [2294] = {.lex_state = 182, .external_lex_state = 6},
  [2295] = {.lex_state = 207, .external_lex_state = 15},
  [2296] = {.lex_state = 207, .external_lex_state = 27},
  [2297] = {.lex_state = 207, .external_lex_state = 27},
  [2298] = {.lex_state = 207, .external_lex_state = 27},
  [2299] = {.lex_state = 217},
  [2300] = {.lex_state = 259, .external_lex_state = 18},
  [2301] = {.lex_state = 85},
  [2302] = {.lex_state = 225, .external_lex_state = 18},
  [2303] = {.lex_state = 225, .external_lex_state = 18},
  [2304] = {.lex_state = 207, .external_lex_state = 27},
  [2305] = {.lex_state = 261, .external_lex_state = 30},
  [2306] = {.lex_state = 261, .external_lex_state = 18},
  [2307] = {.lex_state = 207, .external_lex_state = 27},
  [2308] = {.lex_state = 261, .external_lex_state = 30},
  [2309] = {.lex_state = 261, .external_lex_state = 18},
  [2310] = {.lex_state = 207, .external_lex_state = 27},
  [2311] = {.lex_state = 207, .external_lex_state = 27},
  [2312] = {.lex_state = 310},
  [2313] = {.lex_state = 153},
  [2314] = {.lex_state = 265},
  [2315] = {.lex_state = 241, .external_lex_state = 9},
  [2316] = {.lex_state = 102},
  [2317] = {.lex_state = 205, .external_lex_state = 16},
  [2318] = {.lex_state = 205, .external_lex_state = 16},
  [2319] = {.lex_state = 302},
  [2320] = {.lex_state = 302},
  [2321] = {.lex_state = 205, .external_lex_state = 16},
  [2322] = {.lex_state = 330},
  [2323] = {.lex_state = 102},
  [2324] = {.lex_state = 307},
  [2325] = {.lex_state = 205, .external_lex_state = 16},
  [2326] = {.lex_state = 330},
  [2327] = {.lex_state = 102},
  [2328] = {.lex_state = 307},
  [2329] = {.lex_state = 205, .external_lex_state = 16},
  [2330] = {.lex_state = 199, .external_lex_state = 15},
  [2331] = {.lex_state = 215},
  [2332] = {.lex_state = 199, .external_lex_state = 27},
  [2333] = {.lex_state = 199, .external_lex_state = 27},
  [2334] = {.lex_state = 92, .external_lex_state = 29},
  [2335] = {.lex_state = 92, .external_lex_state = 29},
  [2336] = {.lex_state = 92, .external_lex_state = 18},
  [2337] = {.lex_state = 259, .external_lex_state = 18},
  [2338] = {.lex_state = 199, .external_lex_state = 27},
  [2339] = {.lex_state = 261, .external_lex_state = 30},
  [2340] = {.lex_state = 261, .external_lex_state = 18},
  [2341] = {.lex_state = 261, .external_lex_state = 30},
  [2342] = {.lex_state = 261, .external_lex_state = 18},
  [2343] = {.lex_state = 261, .external_lex_state = 18},
  [2344] = {.lex_state = 199, .external_lex_state = 27},
  [2345] = {.lex_state = 261, .external_lex_state = 18},
  [2346] = {.lex_state = 261, .external_lex_state = 18},
  [2347] = {.lex_state = 199, .external_lex_state = 17},
  [2348] = {.lex_state = 199, .external_lex_state = 17},
  [2349] = {.lex_state = 92, .external_lex_state = 29},
  [2350] = {.lex_state = 92, .external_lex_state = 29},
  [2351] = {.lex_state = 92, .external_lex_state = 18},
  [2352] = {.lex_state = 259, .external_lex_state = 18},
  [2353] = {.lex_state = 199, .external_lex_state = 17},
  [2354] = {.lex_state = 261, .external_lex_state = 30},
  [2355] = {.lex_state = 261, .external_lex_state = 18},
  [2356] = {.lex_state = 261, .external_lex_state = 30},
  [2357] = {.lex_state = 261, .external_lex_state = 18},
  [2358] = {.lex_state = 261, .external_lex_state = 18},
  [2359] = {.lex_state = 199, .external_lex_state = 17},
  [2360] = {.lex_state = 261, .external_lex_state = 18},
  [2361] = {.lex_state = 261, .external_lex_state = 18},
  [2362] = {.lex_state = 201, .external_lex_state = 17},
  [2363] = {.lex_state = 201, .external_lex_state = 17},
  [2364] = {.lex_state = 92, .external_lex_state = 29},
  [2365] = {.lex_state = 92, .external_lex_state = 29},
  [2366] = {.lex_state = 92, .external_lex_state = 18},
  [2367] = {.lex_state = 261, .external_lex_state = 18},
  [2368] = {.lex_state = 201, .external_lex_state = 17},
  [2369] = {.lex_state = 261, .external_lex_state = 18},
  [2370] = {.lex_state = 261, .external_lex_state = 18},
  [2371] = {.lex_state = 261, .external_lex_state = 18},
  [2372] = {.lex_state = 201, .external_lex_state = 17},
  [2373] = {.lex_state = 261, .external_lex_state = 18},
  [2374] = {.lex_state = 205, .external_lex_state = 17},
  [2375] = {.lex_state = 102, .external_lex_state = 2},
  [2376] = {.lex_state = 209, .external_lex_state = 19},
  [2377] = {.lex_state = 209, .external_lex_state = 19},
  [2378] = {.lex_state = 92, .external_lex_state = 29},
  [2379] = {.lex_state = 92, .external_lex_state = 29},
  [2380] = {.lex_state = 92, .external_lex_state = 18},
  [2381] = {.lex_state = 261, .external_lex_state = 18},
  [2382] = {.lex_state = 209, .external_lex_state = 19},
  [2383] = {.lex_state = 261, .external_lex_state = 18},
  [2384] = {.lex_state = 261, .external_lex_state = 18},
  [2385] = {.lex_state = 261, .external_lex_state = 18},
  [2386] = {.lex_state = 209, .external_lex_state = 19},
  [2387] = {.lex_state = 261, .external_lex_state = 18},
  [2388] = {.lex_state = 178, .external_lex_state = 4},
  [2389] = {.lex_state = 178, .external_lex_state = 21},
  [2390] = {.lex_state = 178, .external_lex_state = 21},
  [2391] = {.lex_state = 92, .external_lex_state = 29},
  [2392] = {.lex_state = 92, .external_lex_state = 29},
  [2393] = {.lex_state = 92, .external_lex_state = 18},
  [2394] = {.lex_state = 261, .external_lex_state = 18},
  [2395] = {.lex_state = 178, .external_lex_state = 21},
  [2396] = {.lex_state = 261, .external_lex_state = 18},
  [2397] = {.lex_state = 261, .external_lex_state = 18},
  [2398] = {.lex_state = 261, .external_lex_state = 18},
  [2399] = {.lex_state = 178, .external_lex_state = 21},
  [2400] = {.lex_state = 261, .external_lex_state = 18},
  [2401] = {.lex_state = 178, .external_lex_state = 6},
  [2402] = {.lex_state = 178, .external_lex_state = 6},
  [2403] = {.lex_state = 92, .external_lex_state = 29},
  [2404] = {.lex_state = 92, .external_lex_state = 29},
  [2405] = {.lex_state = 92, .external_lex_state = 18},
  [2406] = {.lex_state = 261, .external_lex_state = 18},
  [2407] = {.lex_state = 178, .external_lex_state = 6},
  [2408] = {.lex_state = 261, .external_lex_state = 18},
  [2409] = {.lex_state = 261, .external_lex_state = 18},
  [2410] = {.lex_state = 261, .external_lex_state = 18},
  [2411] = {.lex_state = 178, .external_lex_state = 6},
  [2412] = {.lex_state = 261, .external_lex_state = 18},
  [2413] = {.lex_state = 215, .external_lex_state = 22},
  [2414] = {.lex_state = 215, .external_lex_state = 22},
  [2415] = {.lex_state = 92, .external_lex_state = 29},
  [2416] = {.lex_state = 92, .external_lex_state = 29},
  [2417] = {.lex_state = 92, .external_lex_state = 18},
  [2418] = {.lex_state = 261, .external_lex_state = 18},
  [2419] = {.lex_state = 215, .external_lex_state = 22},
  [2420] = {.lex_state = 261, .external_lex_state = 18},
  [2421] = {.lex_state = 261, .external_lex_state = 18},
  [2422] = {.lex_state = 261, .external_lex_state = 18},
  [2423] = {.lex_state = 215, .external_lex_state = 22},
  [2424] = {.lex_state = 261, .external_lex_state = 18},
  [2425] = {.lex_state = 115, .external_lex_state = 10},
  [2426] = {.lex_state = 115, .external_lex_state = 10},
  [2427] = {.lex_state = 92, .external_lex_state = 29},
  [2428] = {.lex_state = 92, .external_lex_state = 29},
  [2429] = {.lex_state = 92, .external_lex_state = 18},
  [2430] = {.lex_state = 261, .external_lex_state = 18},
  [2431] = {.lex_state = 115, .external_lex_state = 10},
  [2432] = {.lex_state = 261, .external_lex_state = 18},
  [2433] = {.lex_state = 261, .external_lex_state = 18},
  [2434] = {.lex_state = 261, .external_lex_state = 18},
  [2435] = {.lex_state = 115, .external_lex_state = 10},
  [2436] = {.lex_state = 261, .external_lex_state = 18},
  [2437] = {.lex_state = 225, .external_lex_state = 29},
  [2438] = {.lex_state = 225, .external_lex_state = 18},
  [2439] = {.lex_state = 225, .external_lex_state = 29},
  [2440] = {.lex_state = 225, .external_lex_state = 18},
  [2441] = {.lex_state = 92, .external_lex_state = 29},
  [2442] = {.lex_state = 92, .external_lex_state = 29},
  [2443] = {.lex_state = 92, .external_lex_state = 29},
  [2444] = {.lex_state = 217},
  [2445] = {.lex_state = 259, .external_lex_state = 18},
  [2446] = {.lex_state = 85},
  [2447] = {.lex_state = 225, .external_lex_state = 18},
  [2448] = {.lex_state = 225, .external_lex_state = 18},
  [2449] = {.lex_state = 92, .external_lex_state = 29},
  [2450] = {.lex_state = 261, .external_lex_state = 30},
  [2451] = {.lex_state = 261, .external_lex_state = 18},
  [2452] = {.lex_state = 92, .external_lex_state = 29},
  [2453] = {.lex_state = 261, .external_lex_state = 30},
  [2454] = {.lex_state = 261, .external_lex_state = 18},
  [2455] = {.lex_state = 92, .external_lex_state = 29},
  [2456] = {.lex_state = 92, .external_lex_state = 29},
  [2457] = {.lex_state = 142, .external_lex_state = 6},
  [2458] = {.lex_state = 142, .external_lex_state = 6},
  [2459] = {.lex_state = 142, .external_lex_state = 6},
  [2460] = {.lex_state = 261, .external_lex_state = 18},
  [2461] = {.lex_state = 261, .external_lex_state = 18},
  [2462] = {.lex_state = 261, .external_lex_state = 29},
  [2463] = {.lex_state = 261, .external_lex_state = 29},
  [2464] = {.lex_state = 92, .external_lex_state = 29},
  [2465] = {.lex_state = 92, .external_lex_state = 29},
  [2466] = {.lex_state = 92, .external_lex_state = 18},
  [2467] = {.lex_state = 259, .external_lex_state = 18},
  [2468] = {.lex_state = 261, .external_lex_state = 29},
  [2469] = {.lex_state = 261, .external_lex_state = 30},
  [2470] = {.lex_state = 261, .external_lex_state = 18},
  [2471] = {.lex_state = 261, .external_lex_state = 30},
  [2472] = {.lex_state = 261, .external_lex_state = 18},
  [2473] = {.lex_state = 261, .external_lex_state = 18},
  [2474] = {.lex_state = 261, .external_lex_state = 29},
  [2475] = {.lex_state = 261, .external_lex_state = 18},
  [2476] = {.lex_state = 261, .external_lex_state = 18},
  [2477] = {.lex_state = 142, .external_lex_state = 6},
  [2478] = {.lex_state = 140, .external_lex_state = 21},
  [2479] = {.lex_state = 229, .external_lex_state = 6},
  [2480] = {.lex_state = 96, .external_lex_state = 23},
  [2481] = {.lex_state = 92, .external_lex_state = 29},
  [2482] = {.lex_state = 92, .external_lex_state = 29},
  [2483] = {.lex_state = 92, .external_lex_state = 18},
  [2484] = {.lex_state = 259, .external_lex_state = 18},
  [2485] = {.lex_state = 96, .external_lex_state = 23},
  [2486] = {.lex_state = 261, .external_lex_state = 30},
  [2487] = {.lex_state = 261, .external_lex_state = 18},
  [2488] = {.lex_state = 261, .external_lex_state = 30},
  [2489] = {.lex_state = 261, .external_lex_state = 18},
  [2490] = {.lex_state = 261, .external_lex_state = 18},
  [2491] = {.lex_state = 96, .external_lex_state = 23},
  [2492] = {.lex_state = 261, .external_lex_state = 18},
  [2493] = {.lex_state = 261, .external_lex_state = 18},
  [2494] = {.lex_state = 136, .external_lex_state = 6},
  [2495] = {.lex_state = 136, .external_lex_state = 6},
  [2496] = {.lex_state = 136, .external_lex_state = 6},
  [2497] = {.lex_state = 215, .external_lex_state = 10},
  [2498] = {.lex_state = 215, .external_lex_state = 10},
  [2499] = {.lex_state = 92, .external_lex_state = 29},
  [2500] = {.lex_state = 92, .external_lex_state = 29},
  [2501] = {.lex_state = 92, .external_lex_state = 18},
  [2502] = {.lex_state = 259, .external_lex_state = 18},
  [2503] = {.lex_state = 215, .external_lex_state = 10},
  [2504] = {.lex_state = 261, .external_lex_state = 30},
  [2505] = {.lex_state = 261, .external_lex_state = 18},
  [2506] = {.lex_state = 261, .external_lex_state = 30},
  [2507] = {.lex_state = 261, .external_lex_state = 18},
  [2508] = {.lex_state = 261, .external_lex_state = 18},
  [2509] = {.lex_state = 215, .external_lex_state = 10},
  [2510] = {.lex_state = 261, .external_lex_state = 18},
  [2511] = {.lex_state = 261, .external_lex_state = 18},
  [2512] = {.lex_state = 184, .external_lex_state = 21},
  [2513] = {.lex_state = 184, .external_lex_state = 21},
  [2514] = {.lex_state = 92, .external_lex_state = 29},
  [2515] = {.lex_state = 92, .external_lex_state = 29},
  [2516] = {.lex_state = 92, .external_lex_state = 18},
  [2517] = {.lex_state = 261, .external_lex_state = 18},
  [2518] = {.lex_state = 184, .external_lex_state = 21},
  [2519] = {.lex_state = 261, .external_lex_state = 18},
  [2520] = {.lex_state = 261, .external_lex_state = 18},
  [2521] = {.lex_state = 261, .external_lex_state = 18},
  [2522] = {.lex_state = 184, .external_lex_state = 21},
  [2523] = {.lex_state = 261, .external_lex_state = 18},
  [2524] = {.lex_state = 186, .external_lex_state = 5},
  [2525] = {.lex_state = 310},
  [2526] = {.lex_state = 310},
  [2527] = {.lex_state = 241, .external_lex_state = 14},
  [2528] = {.lex_state = 241, .external_lex_state = 14},
  [2529] = {.lex_state = 92, .external_lex_state = 29},
  [2530] = {.lex_state = 92, .external_lex_state = 29},
  [2531] = {.lex_state = 92, .external_lex_state = 18},
  [2532] = {.lex_state = 261, .external_lex_state = 18},
  [2533] = {.lex_state = 241, .external_lex_state = 14},
  [2534] = {.lex_state = 261, .external_lex_state = 18},
  [2535] = {.lex_state = 261, .external_lex_state = 18},
  [2536] = {.lex_state = 261, .external_lex_state = 18},
  [2537] = {.lex_state = 241, .external_lex_state = 14},
  [2538] = {.lex_state = 261, .external_lex_state = 18},
  [2539] = {.lex_state = 153},
  [2540] = {.lex_state = 267, .external_lex_state = 14},
  [2541] = {.lex_state = 267, .external_lex_state = 14},
  [2542] = {.lex_state = 92, .external_lex_state = 29},
  [2543] = {.lex_state = 92, .external_lex_state = 29},
  [2544] = {.lex_state = 92, .external_lex_state = 18},
  [2545] = {.lex_state = 259, .external_lex_state = 18},
  [2546] = {.lex_state = 267, .external_lex_state = 14},
  [2547] = {.lex_state = 261, .external_lex_state = 30},
  [2548] = {.lex_state = 261, .external_lex_state = 18},
  [2549] = {.lex_state = 261, .external_lex_state = 30},
  [2550] = {.lex_state = 261, .external_lex_state = 18},
  [2551] = {.lex_state = 261, .external_lex_state = 18},
  [2552] = {.lex_state = 267, .external_lex_state = 14},
  [2553] = {.lex_state = 261, .external_lex_state = 18},
  [2554] = {.lex_state = 261, .external_lex_state = 18},
  [2555] = {.lex_state = 269, .external_lex_state = 10},
  [2556] = {.lex_state = 269, .external_lex_state = 10},
  [2557] = {.lex_state = 92, .external_lex_state = 29},
  [2558] = {.lex_state = 92, .external_lex_state = 29},
  [2559] = {.lex_state = 92, .external_lex_state = 18},
  [2560] = {.lex_state = 261, .external_lex_state = 18},
  [2561] = {.lex_state = 269, .external_lex_state = 10},
  [2562] = {.lex_state = 261, .external_lex_state = 18},
  [2563] = {.lex_state = 261, .external_lex_state = 18},
  [2564] = {.lex_state = 261, .external_lex_state = 18},
  [2565] = {.lex_state = 269, .external_lex_state = 10},
  [2566] = {.lex_state = 261, .external_lex_state = 18},
  [2567] = {.lex_state = 246, .external_lex_state = 10},
  [2568] = {.lex_state = 246, .external_lex_state = 10},
  [2569] = {.lex_state = 246, .external_lex_state = 10},
  [2570] = {.lex_state = 261, .external_lex_state = 18},
  [2571] = {.lex_state = 261, .external_lex_state = 18},
  [2572] = {.lex_state = 246, .external_lex_state = 10},
  [2573] = {.lex_state = 140, .external_lex_state = 26},
  [2574] = {.lex_state = 140, .external_lex_state = 26},
  [2575] = {.lex_state = 92, .external_lex_state = 29},
  [2576] = {.lex_state = 92, .external_lex_state = 29},
  [2577] = {.lex_state = 92, .external_lex_state = 18},
  [2578] = {.lex_state = 259, .external_lex_state = 18},
  [2579] = {.lex_state = 140, .external_lex_state = 26},
  [2580] = {.lex_state = 261, .external_lex_state = 30},
  [2581] = {.lex_state = 261, .external_lex_state = 18},
  [2582] = {.lex_state = 261, .external_lex_state = 30},
  [2583] = {.lex_state = 261, .external_lex_state = 18},
  [2584] = {.lex_state = 261, .external_lex_state = 18},
  [2585] = {.lex_state = 140, .external_lex_state = 26},
  [2586] = {.lex_state = 261, .external_lex_state = 18},
  [2587] = {.lex_state = 261, .external_lex_state = 18},
  [2588] = {.lex_state = 310},
  [2589] = {.lex_state = 136, .external_lex_state = 12},
  [2590] = {.lex_state = 310},
  [2591] = {.lex_state = 153},
  [2592] = {.lex_state = 265},
  [2593] = {.lex_state = 136, .external_lex_state = 12},
  [2594] = {.lex_state = 136, .external_lex_state = 12},
  [2595] = {.lex_state = 302},
  [2596] = {.lex_state = 136, .external_lex_state = 12},
  [2597] = {.lex_state = 330},
  [2598] = {.lex_state = 102},
  [2599] = {.lex_state = 136, .external_lex_state = 12},
  [2600] = {.lex_state = 330},
  [2601] = {.lex_state = 102},
  [2602] = {.lex_state = 108, .external_lex_state = 11},
  [2603] = {.lex_state = 108, .external_lex_state = 26},
  [2604] = {.lex_state = 108, .external_lex_state = 26},
  [2605] = {.lex_state = 92, .external_lex_state = 29},
  [2606] = {.lex_state = 92, .external_lex_state = 29},
  [2607] = {.lex_state = 92, .external_lex_state = 18},
  [2608] = {.lex_state = 261, .external_lex_state = 18},
  [2609] = {.lex_state = 108, .external_lex_state = 26},
  [2610] = {.lex_state = 261, .external_lex_state = 18},
  [2611] = {.lex_state = 261, .external_lex_state = 18},
  [2612] = {.lex_state = 261, .external_lex_state = 18},
  [2613] = {.lex_state = 108, .external_lex_state = 26},
  [2614] = {.lex_state = 261, .external_lex_state = 18},
  [2615] = {.lex_state = 108, .external_lex_state = 13},
  [2616] = {.lex_state = 108, .external_lex_state = 13},
  [2617] = {.lex_state = 92, .external_lex_state = 29},
  [2618] = {.lex_state = 92, .external_lex_state = 29},
  [2619] = {.lex_state = 92, .external_lex_state = 18},
  [2620] = {.lex_state = 261, .external_lex_state = 18},
  [2621] = {.lex_state = 108, .external_lex_state = 13},
  [2622] = {.lex_state = 261, .external_lex_state = 18},
  [2623] = {.lex_state = 261, .external_lex_state = 18},
  [2624] = {.lex_state = 261, .external_lex_state = 18},
  [2625] = {.lex_state = 108, .external_lex_state = 13},
  [2626] = {.lex_state = 261, .external_lex_state = 18},
  [2627] = {.lex_state = 112, .external_lex_state = 13},
  [2628] = {.lex_state = 112, .external_lex_state = 13},
  [2629] = {.lex_state = 112, .external_lex_state = 13},
  [2630] = {.lex_state = 261, .external_lex_state = 18},
  [2631] = {.lex_state = 261, .external_lex_state = 18},
  [2632] = {.lex_state = 112, .external_lex_state = 13},
  [2633] = {.lex_state = 284, .external_lex_state = 4},
  [2634] = {.lex_state = 215},
  [2635] = {.lex_state = 102},
  [2636] = {.lex_state = 284, .external_lex_state = 21},
  [2637] = {.lex_state = 284, .external_lex_state = 21},
  [2638] = {.lex_state = 217},
  [2639] = {.lex_state = 115},
  [2640] = {.lex_state = 284, .external_lex_state = 21},
  [2641] = {.lex_state = 284, .external_lex_state = 21},
  [2642] = {.lex_state = 284, .external_lex_state = 21},
  [2643] = {.lex_state = 85},
  [2644] = {.lex_state = 223, .external_lex_state = 7},
  [2645] = {.lex_state = 225, .external_lex_state = 18},
  [2646] = {.lex_state = 225, .external_lex_state = 18},
  [2647] = {.lex_state = 85},
  [2648] = {.lex_state = 215, .external_lex_state = 2},
  [2649] = {.lex_state = 78},
  [2650] = {.lex_state = 85},
  [2651] = {.lex_state = 272, .external_lex_state = 4},
  [2652] = {.lex_state = 215},
  [2653] = {.lex_state = 272, .external_lex_state = 21},
  [2654] = {.lex_state = 272, .external_lex_state = 21},
  [2655] = {.lex_state = 272, .external_lex_state = 21},
  [2656] = {.lex_state = 272, .external_lex_state = 21},
  [2657] = {.lex_state = 272, .external_lex_state = 21},
  [2658] = {.lex_state = 217},
  [2659] = {.lex_state = 259, .external_lex_state = 18},
  [2660] = {.lex_state = 85},
  [2661] = {.lex_state = 225, .external_lex_state = 18},
  [2662] = {.lex_state = 225, .external_lex_state = 18},
  [2663] = {.lex_state = 272, .external_lex_state = 21},
  [2664] = {.lex_state = 261, .external_lex_state = 30},
  [2665] = {.lex_state = 261, .external_lex_state = 18},
  [2666] = {.lex_state = 272, .external_lex_state = 21},
  [2667] = {.lex_state = 261, .external_lex_state = 30},
  [2668] = {.lex_state = 261, .external_lex_state = 18},
  [2669] = {.lex_state = 272, .external_lex_state = 21},
  [2670] = {.lex_state = 272, .external_lex_state = 21},
  [2671] = {.lex_state = 272, .external_lex_state = 6},
  [2672] = {.lex_state = 272, .external_lex_state = 6},
  [2673] = {.lex_state = 272, .external_lex_state = 6},
  [2674] = {.lex_state = 217},
  [2675] = {.lex_state = 259, .external_lex_state = 18},
  [2676] = {.lex_state = 85},
  [2677] = {.lex_state = 225, .external_lex_state = 18},
  [2678] = {.lex_state = 225, .external_lex_state = 18},
  [2679] = {.lex_state = 272, .external_lex_state = 6},
  [2680] = {.lex_state = 261, .external_lex_state = 30},
  [2681] = {.lex_state = 261, .external_lex_state = 18},
  [2682] = {.lex_state = 272, .external_lex_state = 6},
  [2683] = {.lex_state = 261, .external_lex_state = 30},
  [2684] = {.lex_state = 261, .external_lex_state = 18},
  [2685] = {.lex_state = 272, .external_lex_state = 6},
  [2686] = {.lex_state = 272, .external_lex_state = 6},
  [2687] = {.lex_state = 278, .external_lex_state = 6},
  [2688] = {.lex_state = 278, .external_lex_state = 6},
  [2689] = {.lex_state = 92, .external_lex_state = 29},
  [2690] = {.lex_state = 92, .external_lex_state = 29},
  [2691] = {.lex_state = 92, .external_lex_state = 18},
  [2692] = {.lex_state = 259, .external_lex_state = 18},
  [2693] = {.lex_state = 278, .external_lex_state = 6},
  [2694] = {.lex_state = 261, .external_lex_state = 30},
  [2695] = {.lex_state = 261, .external_lex_state = 18},
  [2696] = {.lex_state = 261, .external_lex_state = 30},
  [2697] = {.lex_state = 261, .external_lex_state = 18},
  [2698] = {.lex_state = 261, .external_lex_state = 18},
  [2699] = {.lex_state = 278, .external_lex_state = 6},
  [2700] = {.lex_state = 261, .external_lex_state = 18},
  [2701] = {.lex_state = 261, .external_lex_state = 18},
  [2702] = {.lex_state = 282, .external_lex_state = 6},
  [2703] = {.lex_state = 282, .external_lex_state = 6},
  [2704] = {.lex_state = 102},
  [2705] = {.lex_state = 282, .external_lex_state = 6},
  [2706] = {.lex_state = 335, .external_lex_state = 6},
  [2707] = {.lex_state = 217},
  [2708] = {.lex_state = 115},
  [2709] = {.lex_state = 335, .external_lex_state = 6},
  [2710] = {.lex_state = 335, .external_lex_state = 6},
  [2711] = {.lex_state = 335, .external_lex_state = 6},
  [2712] = {.lex_state = 85},
  [2713] = {.lex_state = 223, .external_lex_state = 7},
  [2714] = {.lex_state = 225, .external_lex_state = 18},
  [2715] = {.lex_state = 225, .external_lex_state = 18},
  [2716] = {.lex_state = 85},
  [2717] = {.lex_state = 215, .external_lex_state = 2},
  [2718] = {.lex_state = 78},
  [2719] = {.lex_state = 85},
  [2720] = {.lex_state = 248, .external_lex_state = 2},
  [2721] = {.lex_state = 305, .external_lex_state = 4},
  [2722] = {.lex_state = 215},
  [2723] = {.lex_state = 102},
  [2724] = {.lex_state = 305, .external_lex_state = 21},
  [2725] = {.lex_state = 305, .external_lex_state = 21},
  [2726] = {.lex_state = 217},
  [2727] = {.lex_state = 115},
  [2728] = {.lex_state = 305, .external_lex_state = 21},
  [2729] = {.lex_state = 305, .external_lex_state = 21},
  [2730] = {.lex_state = 305, .external_lex_state = 21},
  [2731] = {.lex_state = 85},
  [2732] = {.lex_state = 223, .external_lex_state = 7},
  [2733] = {.lex_state = 225, .external_lex_state = 18},
  [2734] = {.lex_state = 225, .external_lex_state = 18},
  [2735] = {.lex_state = 85},
  [2736] = {.lex_state = 215, .external_lex_state = 2},
  [2737] = {.lex_state = 78},
  [2738] = {.lex_state = 85},
  [2739] = {.lex_state = 302},
  [2740] = {.lex_state = 323, .external_lex_state = 4},
  [2741] = {.lex_state = 215},
  [2742] = {.lex_state = 323, .external_lex_state = 21},
  [2743] = {.lex_state = 115},
  [2744] = {.lex_state = 122},
  [2745] = {.lex_state = 323, .external_lex_state = 21},
  [2746] = {.lex_state = 122, .external_lex_state = 7},
  [2747] = {.lex_state = 78, .external_lex_state = 2},
  [2748] = {.lex_state = 78, .external_lex_state = 2},
  [2749] = {.lex_state = 78, .external_lex_state = 2},
  [2750] = {.lex_state = 144, .external_lex_state = 8},
  [2751] = {.lex_state = 102},
  [2752] = {.lex_state = 315, .external_lex_state = 21},
  [2753] = {.lex_state = 315, .external_lex_state = 21},
  [2754] = {.lex_state = 217},
  [2755] = {.lex_state = 115},
  [2756] = {.lex_state = 315, .external_lex_state = 21},
  [2757] = {.lex_state = 315, .external_lex_state = 21},
  [2758] = {.lex_state = 315, .external_lex_state = 21},
  [2759] = {.lex_state = 85},
  [2760] = {.lex_state = 223, .external_lex_state = 7},
  [2761] = {.lex_state = 225, .external_lex_state = 18},
  [2762] = {.lex_state = 225, .external_lex_state = 18},
  [2763] = {.lex_state = 85},
  [2764] = {.lex_state = 215, .external_lex_state = 2},
  [2765] = {.lex_state = 78},
  [2766] = {.lex_state = 85},
  [2767] = {.lex_state = 315, .external_lex_state = 4},
  [2768] = {.lex_state = 102},
  [2769] = {.lex_state = 315, .external_lex_state = 6},
  [2770] = {.lex_state = 315, .external_lex_state = 6},
  [2771] = {.lex_state = 217},
  [2772] = {.lex_state = 115},
  [2773] = {.lex_state = 315, .external_lex_state = 6},
  [2774] = {.lex_state = 315, .external_lex_state = 6},
  [2775] = {.lex_state = 315, .external_lex_state = 6},
  [2776] = {.lex_state = 85},
  [2777] = {.lex_state = 223, .external_lex_state = 7},
  [2778] = {.lex_state = 225, .external_lex_state = 18},
  [2779] = {.lex_state = 225, .external_lex_state = 18},
  [2780] = {.lex_state = 85},
  [2781] = {.lex_state = 215, .external_lex_state = 2},
  [2782] = {.lex_state = 78},
  [2783] = {.lex_state = 85},
  [2784] = {.lex_state = 315, .external_lex_state = 5},
  [2785] = {.lex_state = 317, .external_lex_state = 6},
  [2786] = {.lex_state = 317, .external_lex_state = 6},
  [2787] = {.lex_state = 317, .external_lex_state = 6},
  [2788] = {.lex_state = 217},
  [2789] = {.lex_state = 259, .external_lex_state = 18},
  [2790] = {.lex_state = 85},
  [2791] = {.lex_state = 225, .external_lex_state = 18},
  [2792] = {.lex_state = 225, .external_lex_state = 18},
  [2793] = {.lex_state = 317, .external_lex_state = 6},
  [2794] = {.lex_state = 261, .external_lex_state = 30},
  [2795] = {.lex_state = 261, .external_lex_state = 18},
  [2796] = {.lex_state = 317, .external_lex_state = 6},
  [2797] = {.lex_state = 261, .external_lex_state = 30},
  [2798] = {.lex_state = 261, .external_lex_state = 18},
  [2799] = {.lex_state = 317, .external_lex_state = 6},
  [2800] = {.lex_state = 317, .external_lex_state = 6},
  [2801] = {.lex_state = 102},
  [2802] = {.lex_state = 321, .external_lex_state = 5},
  [2803] = {.lex_state = 323, .external_lex_state = 4},
  [2804] = {.lex_state = 321, .external_lex_state = 5},
  [2805] = {.lex_state = 323, .external_lex_state = 4},
  [2806] = {.lex_state = 321, .external_lex_state = 6},
  [2807] = {.lex_state = 321, .external_lex_state = 6},
  [2808] = {.lex_state = 321, .external_lex_state = 6},
  [2809] = {.lex_state = 321, .external_lex_state = 6},
  [2810] = {.lex_state = 286, .external_lex_state = 2},
  [2811] = {.lex_state = 321, .external_lex_state = 5},
  [2812] = {.lex_state = 317, .external_lex_state = 5},
  [2813] = {.lex_state = 317, .external_lex_state = 6},
  [2814] = {.lex_state = 317, .external_lex_state = 6},
  [2815] = {.lex_state = 317, .external_lex_state = 5},
  [2816] = {.lex_state = 286, .external_lex_state = 2},
  [2817] = {.lex_state = 325, .external_lex_state = 9},
  [2818] = {.lex_state = 317, .external_lex_state = 5},
  [2819] = {.lex_state = 288, .external_lex_state = 4},
  [2820] = {.lex_state = 215},
  [2821] = {.lex_state = 288, .external_lex_state = 21},
  [2822] = {.lex_state = 288, .external_lex_state = 21},
  [2823] = {.lex_state = 288, .external_lex_state = 21},
  [2824] = {.lex_state = 288, .external_lex_state = 21},
  [2825] = {.lex_state = 288, .external_lex_state = 21},
  [2826] = {.lex_state = 217},
  [2827] = {.lex_state = 259, .external_lex_state = 18},
  [2828] = {.lex_state = 85},
  [2829] = {.lex_state = 225, .external_lex_state = 18},
  [2830] = {.lex_state = 225, .external_lex_state = 18},
  [2831] = {.lex_state = 288, .external_lex_state = 21},
  [2832] = {.lex_state = 261, .external_lex_state = 30},
  [2833] = {.lex_state = 261, .external_lex_state = 18},
  [2834] = {.lex_state = 288, .external_lex_state = 21},
  [2835] = {.lex_state = 261, .external_lex_state = 30},
  [2836] = {.lex_state = 261, .external_lex_state = 18},
  [2837] = {.lex_state = 288, .external_lex_state = 21},
  [2838] = {.lex_state = 288, .external_lex_state = 21},
  [2839] = {.lex_state = 288, .external_lex_state = 6},
  [2840] = {.lex_state = 288, .external_lex_state = 6},
  [2841] = {.lex_state = 288, .external_lex_state = 6},
  [2842] = {.lex_state = 217},
  [2843] = {.lex_state = 259, .external_lex_state = 18},
  [2844] = {.lex_state = 85},
  [2845] = {.lex_state = 225, .external_lex_state = 18},
  [2846] = {.lex_state = 225, .external_lex_state = 18},
  [2847] = {.lex_state = 288, .external_lex_state = 6},
  [2848] = {.lex_state = 261, .external_lex_state = 30},
  [2849] = {.lex_state = 261, .external_lex_state = 18},
  [2850] = {.lex_state = 288, .external_lex_state = 6},
  [2851] = {.lex_state = 261, .external_lex_state = 30},
  [2852] = {.lex_state = 261, .external_lex_state = 18},
  [2853] = {.lex_state = 288, .external_lex_state = 6},
  [2854] = {.lex_state = 288, .external_lex_state = 6},
  [2855] = {.lex_state = 298, .external_lex_state = 6},
  [2856] = {.lex_state = 298, .external_lex_state = 6},
  [2857] = {.lex_state = 92, .external_lex_state = 29},
  [2858] = {.lex_state = 92, .external_lex_state = 29},
  [2859] = {.lex_state = 92, .external_lex_state = 18},
  [2860] = {.lex_state = 259, .external_lex_state = 18},
  [2861] = {.lex_state = 298, .external_lex_state = 6},
  [2862] = {.lex_state = 261, .external_lex_state = 30},
  [2863] = {.lex_state = 261, .external_lex_state = 18},
  [2864] = {.lex_state = 261, .external_lex_state = 30},
  [2865] = {.lex_state = 261, .external_lex_state = 18},
  [2866] = {.lex_state = 261, .external_lex_state = 18},
  [2867] = {.lex_state = 298, .external_lex_state = 6},
  [2868] = {.lex_state = 261, .external_lex_state = 18},
  [2869] = {.lex_state = 261, .external_lex_state = 18},
  [2870] = {.lex_state = 186, .external_lex_state = 5},
  [2871] = {.lex_state = 302, .external_lex_state = 6},
  [2872] = {.lex_state = 302, .external_lex_state = 6},
  [2873] = {.lex_state = 302, .external_lex_state = 6},
  [2874] = {.lex_state = 254, .external_lex_state = 2},
  [2875] = {.lex_state = 327, .external_lex_state = 10},
  [2876] = {.lex_state = 327, .external_lex_state = 10},
  [2877] = {.lex_state = 327},
  [2878] = {.lex_state = 85},
  [2879] = {.lex_state = 307},
  [2880] = {.lex_state = 106, .external_lex_state = 2},
  [2881] = {.lex_state = 337, .external_lex_state = 4},
  [2882] = {.lex_state = 337, .external_lex_state = 5},
  [2883] = {.lex_state = 343, .external_lex_state = 6},
  [2884] = {.lex_state = 115},
  [2885] = {.lex_state = 122},
  [2886] = {.lex_state = 343, .external_lex_state = 6},
  [2887] = {.lex_state = 122, .external_lex_state = 7},
  [2888] = {.lex_state = 78, .external_lex_state = 2},
  [2889] = {.lex_state = 78, .external_lex_state = 2},
  [2890] = {.lex_state = 78, .external_lex_state = 2},
  [2891] = {.lex_state = 345, .external_lex_state = 6},
  [2892] = {.lex_state = 330},
  [2893] = {.lex_state = 330, .external_lex_state = 5},
  [2894] = {.lex_state = 343, .external_lex_state = 5},
  [2895] = {.lex_state = 347, .external_lex_state = 4},
  [2896] = {.lex_state = 85},
  [2897] = {.lex_state = 343, .external_lex_state = 5},
  [2898] = {.lex_state = 78, .external_lex_state = 2},
  [2899] = {.lex_state = 102, .external_lex_state = 2},
  [2900] = {.lex_state = 333, .external_lex_state = 2},
  [2901] = {.lex_state = 327},
  [2902] = {.lex_state = 327, .external_lex_state = 10},
  [2903] = {.lex_state = 307},
  [2904] = {.lex_state = 330},
  [2905] = {.lex_state = 333, .external_lex_state = 2},
  [2906] = {.lex_state = 186, .external_lex_state = 5},
  [2907] = {.lex_state = 327, .external_lex_state = 10},
  [2908] = {.lex_state = 327, .external_lex_state = 10},
  [2909] = {.lex_state = 327},
  [2910] = {.lex_state = 330},
  [2911] = {.lex_state = 186, .external_lex_state = 5},
  [2912] = {.lex_state = 330},
  [2913] = {.lex_state = 149, .external_lex_state = 14},
  [2914] = {.lex_state = 149, .external_lex_state = 14},
  [2915] = {.lex_state = 149, .external_lex_state = 14},
  [2916] = {.lex_state = 261, .external_lex_state = 18},
  [2917] = {.lex_state = 261, .external_lex_state = 18},
  [2918] = {.lex_state = 149, .external_lex_state = 14},
  [2919] = {.lex_state = 207, .external_lex_state = 27},
  [2920] = {.lex_state = 207, .external_lex_state = 27},
  [2921] = {.lex_state = 92, .external_lex_state = 29},
  [2922] = {.lex_state = 92, .external_lex_state = 29},
  [2923] = {.lex_state = 92, .external_lex_state = 18},
  [2924] = {.lex_state = 259, .external_lex_state = 18},
  [2925] = {.lex_state = 207, .external_lex_state = 27},
  [2926] = {.lex_state = 261, .external_lex_state = 30},
  [2927] = {.lex_state = 261, .external_lex_state = 18},
  [2928] = {.lex_state = 261, .external_lex_state = 30},
  [2929] = {.lex_state = 261, .external_lex_state = 18},
  [2930] = {.lex_state = 261, .external_lex_state = 18},
  [2931] = {.lex_state = 207, .external_lex_state = 27},
  [2932] = {.lex_state = 261, .external_lex_state = 18},
  [2933] = {.lex_state = 261, .external_lex_state = 18},
  [2934] = {.lex_state = 310},
  [2935] = {.lex_state = 205, .external_lex_state = 16},
  [2936] = {.lex_state = 310},
  [2937] = {.lex_state = 153},
  [2938] = {.lex_state = 265},
  [2939] = {.lex_state = 205, .external_lex_state = 16},
  [2940] = {.lex_state = 205, .external_lex_state = 16},
  [2941] = {.lex_state = 302},
  [2942] = {.lex_state = 205, .external_lex_state = 16},
  [2943] = {.lex_state = 330},
  [2944] = {.lex_state = 102},
  [2945] = {.lex_state = 205, .external_lex_state = 16},
  [2946] = {.lex_state = 330},
  [2947] = {.lex_state = 102},
  [2948] = {.lex_state = 199, .external_lex_state = 15},
  [2949] = {.lex_state = 199, .external_lex_state = 27},
  [2950] = {.lex_state = 199, .external_lex_state = 27},
  [2951] = {.lex_state = 92, .external_lex_state = 29},
  [2952] = {.lex_state = 92, .external_lex_state = 29},
  [2953] = {.lex_state = 92, .external_lex_state = 18},
  [2954] = {.lex_state = 261, .external_lex_state = 18},
  [2955] = {.lex_state = 199, .external_lex_state = 27},
  [2956] = {.lex_state = 261, .external_lex_state = 18},
  [2957] = {.lex_state = 261, .external_lex_state = 18},
  [2958] = {.lex_state = 261, .external_lex_state = 18},
  [2959] = {.lex_state = 199, .external_lex_state = 27},
  [2960] = {.lex_state = 261, .external_lex_state = 18},
  [2961] = {.lex_state = 199, .external_lex_state = 17},
  [2962] = {.lex_state = 199, .external_lex_state = 17},
  [2963] = {.lex_state = 92, .external_lex_state = 29},
  [2964] = {.lex_state = 92, .external_lex_state = 29},
  [2965] = {.lex_state = 92, .external_lex_state = 18},
  [2966] = {.lex_state = 261, .external_lex_state = 18},
  [2967] = {.lex_state = 199, .external_lex_state = 17},
  [2968] = {.lex_state = 261, .external_lex_state = 18},
  [2969] = {.lex_state = 261, .external_lex_state = 18},
  [2970] = {.lex_state = 261, .external_lex_state = 18},
  [2971] = {.lex_state = 199, .external_lex_state = 17},
  [2972] = {.lex_state = 261, .external_lex_state = 18},
  [2973] = {.lex_state = 201, .external_lex_state = 17},
  [2974] = {.lex_state = 201, .external_lex_state = 17},
  [2975] = {.lex_state = 201, .external_lex_state = 17},
  [2976] = {.lex_state = 261, .external_lex_state = 18},
  [2977] = {.lex_state = 261, .external_lex_state = 18},
  [2978] = {.lex_state = 201, .external_lex_state = 17},
  [2979] = {.lex_state = 209, .external_lex_state = 19},
  [2980] = {.lex_state = 209, .external_lex_state = 19},
  [2981] = {.lex_state = 209, .external_lex_state = 19},
  [2982] = {.lex_state = 261, .external_lex_state = 18},
  [2983] = {.lex_state = 261, .external_lex_state = 18},
  [2984] = {.lex_state = 209, .external_lex_state = 19},
  [2985] = {.lex_state = 178, .external_lex_state = 21},
  [2986] = {.lex_state = 178, .external_lex_state = 21},
  [2987] = {.lex_state = 178, .external_lex_state = 21},
  [2988] = {.lex_state = 261, .external_lex_state = 18},
  [2989] = {.lex_state = 261, .external_lex_state = 18},
  [2990] = {.lex_state = 178, .external_lex_state = 21},
  [2991] = {.lex_state = 178, .external_lex_state = 6},
  [2992] = {.lex_state = 178, .external_lex_state = 6},
  [2993] = {.lex_state = 178, .external_lex_state = 6},
  [2994] = {.lex_state = 261, .external_lex_state = 18},
  [2995] = {.lex_state = 261, .external_lex_state = 18},
  [2996] = {.lex_state = 178, .external_lex_state = 6},
  [2997] = {.lex_state = 215, .external_lex_state = 22},
  [2998] = {.lex_state = 215, .external_lex_state = 22},
  [2999] = {.lex_state = 215, .external_lex_state = 22},
  [3000] = {.lex_state = 261, .external_lex_state = 18},
  [3001] = {.lex_state = 261, .external_lex_state = 18},
  [3002] = {.lex_state = 215, .external_lex_state = 22},
  [3003] = {.lex_state = 115, .external_lex_state = 10},
  [3004] = {.lex_state = 115, .external_lex_state = 10},
  [3005] = {.lex_state = 115, .external_lex_state = 10},
  [3006] = {.lex_state = 261, .external_lex_state = 18},
  [3007] = {.lex_state = 261, .external_lex_state = 18},
  [3008] = {.lex_state = 115, .external_lex_state = 10},
  [3009] = {.lex_state = 225, .external_lex_state = 18},
  [3010] = {.lex_state = 225, .external_lex_state = 18},
  [3011] = {.lex_state = 92, .external_lex_state = 29},
  [3012] = {.lex_state = 92, .external_lex_state = 29},
  [3013] = {.lex_state = 92, .external_lex_state = 29},
  [3014] = {.lex_state = 92, .external_lex_state = 29},
  [3015] = {.lex_state = 92, .external_lex_state = 18},
  [3016] = {.lex_state = 259, .external_lex_state = 18},
  [3017] = {.lex_state = 92, .external_lex_state = 29},
  [3018] = {.lex_state = 261, .external_lex_state = 30},
  [3019] = {.lex_state = 261, .external_lex_state = 18},
  [3020] = {.lex_state = 261, .external_lex_state = 30},
  [3021] = {.lex_state = 261, .external_lex_state = 18},
  [3022] = {.lex_state = 261, .external_lex_state = 18},
  [3023] = {.lex_state = 92, .external_lex_state = 29},
  [3024] = {.lex_state = 261, .external_lex_state = 18},
  [3025] = {.lex_state = 261, .external_lex_state = 18},
  [3026] = {.lex_state = 142, .external_lex_state = 6},
  [3027] = {.lex_state = 142, .external_lex_state = 6},
  [3028] = {.lex_state = 261, .external_lex_state = 29},
  [3029] = {.lex_state = 261, .external_lex_state = 29},
  [3030] = {.lex_state = 92, .external_lex_state = 29},
  [3031] = {.lex_state = 92, .external_lex_state = 29},
  [3032] = {.lex_state = 92, .external_lex_state = 18},
  [3033] = {.lex_state = 261, .external_lex_state = 18},
  [3034] = {.lex_state = 261, .external_lex_state = 29},
  [3035] = {.lex_state = 261, .external_lex_state = 18},
  [3036] = {.lex_state = 261, .external_lex_state = 18},
  [3037] = {.lex_state = 261, .external_lex_state = 18},
  [3038] = {.lex_state = 261, .external_lex_state = 29},
  [3039] = {.lex_state = 261, .external_lex_state = 18},
  [3040] = {.lex_state = 96, .external_lex_state = 23},
  [3041] = {.lex_state = 96, .external_lex_state = 23},
  [3042] = {.lex_state = 92, .external_lex_state = 29},
  [3043] = {.lex_state = 92, .external_lex_state = 29},
  [3044] = {.lex_state = 92, .external_lex_state = 18},
  [3045] = {.lex_state = 261, .external_lex_state = 18},
  [3046] = {.lex_state = 96, .external_lex_state = 23},
  [3047] = {.lex_state = 261, .external_lex_state = 18},
  [3048] = {.lex_state = 261, .external_lex_state = 18},
  [3049] = {.lex_state = 261, .external_lex_state = 18},
  [3050] = {.lex_state = 96, .external_lex_state = 23},
  [3051] = {.lex_state = 261, .external_lex_state = 18},
  [3052] = {.lex_state = 136, .external_lex_state = 6},
  [3053] = {.lex_state = 215, .external_lex_state = 10},
  [3054] = {.lex_state = 215, .external_lex_state = 10},
  [3055] = {.lex_state = 92, .external_lex_state = 29},
  [3056] = {.lex_state = 92, .external_lex_state = 29},
  [3057] = {.lex_state = 92, .external_lex_state = 18},
  [3058] = {.lex_state = 261, .external_lex_state = 18},
  [3059] = {.lex_state = 215, .external_lex_state = 10},
  [3060] = {.lex_state = 261, .external_lex_state = 18},
  [3061] = {.lex_state = 261, .external_lex_state = 18},
  [3062] = {.lex_state = 261, .external_lex_state = 18},
  [3063] = {.lex_state = 215, .external_lex_state = 10},
  [3064] = {.lex_state = 261, .external_lex_state = 18},
  [3065] = {.lex_state = 184, .external_lex_state = 21},
  [3066] = {.lex_state = 184, .external_lex_state = 21},
  [3067] = {.lex_state = 184, .external_lex_state = 21},
  [3068] = {.lex_state = 261, .external_lex_state = 18},
  [3069] = {.lex_state = 261, .external_lex_state = 18},
  [3070] = {.lex_state = 184, .external_lex_state = 21},
  [3071] = {.lex_state = 186, .external_lex_state = 5},
  [3072] = {.lex_state = 310},
  [3073] = {.lex_state = 241, .external_lex_state = 14},
  [3074] = {.lex_state = 241, .external_lex_state = 14},
  [3075] = {.lex_state = 241, .external_lex_state = 14},
  [3076] = {.lex_state = 261, .external_lex_state = 18},
  [3077] = {.lex_state = 261, .external_lex_state = 18},
  [3078] = {.lex_state = 241, .external_lex_state = 14},
  [3079] = {.lex_state = 310},
  [3080] = {.lex_state = 267, .external_lex_state = 14},
  [3081] = {.lex_state = 267, .external_lex_state = 14},
  [3082] = {.lex_state = 92, .external_lex_state = 29},
  [3083] = {.lex_state = 92, .external_lex_state = 29},
  [3084] = {.lex_state = 92, .external_lex_state = 18},
  [3085] = {.lex_state = 261, .external_lex_state = 18},
  [3086] = {.lex_state = 267, .external_lex_state = 14},
  [3087] = {.lex_state = 261, .external_lex_state = 18},
  [3088] = {.lex_state = 261, .external_lex_state = 18},
  [3089] = {.lex_state = 261, .external_lex_state = 18},
  [3090] = {.lex_state = 267, .external_lex_state = 14},
  [3091] = {.lex_state = 261, .external_lex_state = 18},
  [3092] = {.lex_state = 269, .external_lex_state = 10},
  [3093] = {.lex_state = 269, .external_lex_state = 10},
  [3094] = {.lex_state = 269, .external_lex_state = 10},
  [3095] = {.lex_state = 261, .external_lex_state = 18},
  [3096] = {.lex_state = 261, .external_lex_state = 18},
  [3097] = {.lex_state = 269, .external_lex_state = 10},
  [3098] = {.lex_state = 246, .external_lex_state = 10},
  [3099] = {.lex_state = 246, .external_lex_state = 10},
  [3100] = {.lex_state = 140, .external_lex_state = 26},
  [3101] = {.lex_state = 140, .external_lex_state = 26},
  [3102] = {.lex_state = 92, .external_lex_state = 29},
  [3103] = {.lex_state = 92, .external_lex_state = 29},
  [3104] = {.lex_state = 92, .external_lex_state = 18},
  [3105] = {.lex_state = 261, .external_lex_state = 18},
  [3106] = {.lex_state = 140, .external_lex_state = 26},
  [3107] = {.lex_state = 261, .external_lex_state = 18},
  [3108] = {.lex_state = 261, .external_lex_state = 18},
  [3109] = {.lex_state = 261, .external_lex_state = 18},
  [3110] = {.lex_state = 140, .external_lex_state = 26},
  [3111] = {.lex_state = 261, .external_lex_state = 18},
  [3112] = {.lex_state = 136, .external_lex_state = 12},
  [3113] = {.lex_state = 310},
  [3114] = {.lex_state = 310},
  [3115] = {.lex_state = 153},
  [3116] = {.lex_state = 136, .external_lex_state = 12},
  [3117] = {.lex_state = 136, .external_lex_state = 12},
  [3118] = {.lex_state = 330},
  [3119] = {.lex_state = 136, .external_lex_state = 12},
  [3120] = {.lex_state = 330},
  [3121] = {.lex_state = 108, .external_lex_state = 26},
  [3122] = {.lex_state = 108, .external_lex_state = 26},
  [3123] = {.lex_state = 108, .external_lex_state = 26},
  [3124] = {.lex_state = 261, .external_lex_state = 18},
  [3125] = {.lex_state = 261, .external_lex_state = 18},
  [3126] = {.lex_state = 108, .external_lex_state = 26},
  [3127] = {.lex_state = 108, .external_lex_state = 13},
  [3128] = {.lex_state = 108, .external_lex_state = 13},
  [3129] = {.lex_state = 108, .external_lex_state = 13},
  [3130] = {.lex_state = 261, .external_lex_state = 18},
  [3131] = {.lex_state = 261, .external_lex_state = 18},
  [3132] = {.lex_state = 108, .external_lex_state = 13},
  [3133] = {.lex_state = 112, .external_lex_state = 13},
  [3134] = {.lex_state = 112, .external_lex_state = 13},
  [3135] = {.lex_state = 284, .external_lex_state = 4},
  [3136] = {.lex_state = 284, .external_lex_state = 21},
  [3137] = {.lex_state = 284, .external_lex_state = 21},
  [3138] = {.lex_state = 284, .external_lex_state = 21},
  [3139] = {.lex_state = 217},
  [3140] = {.lex_state = 259, .external_lex_state = 18},
  [3141] = {.lex_state = 85},
  [3142] = {.lex_state = 225, .external_lex_state = 18},
  [3143] = {.lex_state = 225, .external_lex_state = 18},
  [3144] = {.lex_state = 284, .external_lex_state = 21},
  [3145] = {.lex_state = 261, .external_lex_state = 30},
  [3146] = {.lex_state = 261, .external_lex_state = 18},
  [3147] = {.lex_state = 284, .external_lex_state = 21},
  [3148] = {.lex_state = 261, .external_lex_state = 30},
  [3149] = {.lex_state = 261, .external_lex_state = 18},
  [3150] = {.lex_state = 284, .external_lex_state = 21},
  [3151] = {.lex_state = 284, .external_lex_state = 21},
  [3152] = {.lex_state = 272, .external_lex_state = 4},
  [3153] = {.lex_state = 215},
  [3154] = {.lex_state = 272, .external_lex_state = 21},
  [3155] = {.lex_state = 272, .external_lex_state = 21},
  [3156] = {.lex_state = 92, .external_lex_state = 29},
  [3157] = {.lex_state = 92, .external_lex_state = 29},
  [3158] = {.lex_state = 92, .external_lex_state = 18},
  [3159] = {.lex_state = 259, .external_lex_state = 18},
  [3160] = {.lex_state = 272, .external_lex_state = 21},
  [3161] = {.lex_state = 261, .external_lex_state = 30},
  [3162] = {.lex_state = 261, .external_lex_state = 18},
  [3163] = {.lex_state = 261, .external_lex_state = 30},
  [3164] = {.lex_state = 261, .external_lex_state = 18},
  [3165] = {.lex_state = 261, .external_lex_state = 18},
  [3166] = {.lex_state = 272, .external_lex_state = 21},
  [3167] = {.lex_state = 261, .external_lex_state = 18},
  [3168] = {.lex_state = 261, .external_lex_state = 18},
  [3169] = {.lex_state = 272, .external_lex_state = 6},
  [3170] = {.lex_state = 272, .external_lex_state = 6},
  [3171] = {.lex_state = 92, .external_lex_state = 29},
  [3172] = {.lex_state = 92, .external_lex_state = 29},
  [3173] = {.lex_state = 92, .external_lex_state = 18},
  [3174] = {.lex_state = 259, .external_lex_state = 18},
  [3175] = {.lex_state = 272, .external_lex_state = 6},
  [3176] = {.lex_state = 261, .external_lex_state = 30},
  [3177] = {.lex_state = 261, .external_lex_state = 18},
  [3178] = {.lex_state = 261, .external_lex_state = 30},
  [3179] = {.lex_state = 261, .external_lex_state = 18},
  [3180] = {.lex_state = 261, .external_lex_state = 18},
  [3181] = {.lex_state = 272, .external_lex_state = 6},
  [3182] = {.lex_state = 261, .external_lex_state = 18},
  [3183] = {.lex_state = 261, .external_lex_state = 18},
  [3184] = {.lex_state = 278, .external_lex_state = 6},
  [3185] = {.lex_state = 278, .external_lex_state = 6},
  [3186] = {.lex_state = 92, .external_lex_state = 29},
  [3187] = {.lex_state = 92, .external_lex_state = 29},
  [3188] = {.lex_state = 92, .external_lex_state = 18},
  [3189] = {.lex_state = 261, .external_lex_state = 18},
  [3190] = {.lex_state = 278, .external_lex_state = 6},
  [3191] = {.lex_state = 261, .external_lex_state = 18},
  [3192] = {.lex_state = 261, .external_lex_state = 18},
  [3193] = {.lex_state = 261, .external_lex_state = 18},
  [3194] = {.lex_state = 278, .external_lex_state = 6},
  [3195] = {.lex_state = 261, .external_lex_state = 18},
  [3196] = {.lex_state = 335, .external_lex_state = 6},
  [3197] = {.lex_state = 282, .external_lex_state = 6},
  [3198] = {.lex_state = 335, .external_lex_state = 6},
  [3199] = {.lex_state = 217},
  [3200] = {.lex_state = 259, .external_lex_state = 18},
  [3201] = {.lex_state = 85},
  [3202] = {.lex_state = 225, .external_lex_state = 18},
  [3203] = {.lex_state = 225, .external_lex_state = 18},
  [3204] = {.lex_state = 335, .external_lex_state = 6},
  [3205] = {.lex_state = 261, .external_lex_state = 30},
  [3206] = {.lex_state = 261, .external_lex_state = 18},
  [3207] = {.lex_state = 335, .external_lex_state = 6},
  [3208] = {.lex_state = 261, .external_lex_state = 30},
  [3209] = {.lex_state = 261, .external_lex_state = 18},
  [3210] = {.lex_state = 335, .external_lex_state = 6},
  [3211] = {.lex_state = 335, .external_lex_state = 6},
  [3212] = {.lex_state = 305, .external_lex_state = 4},
  [3213] = {.lex_state = 305, .external_lex_state = 21},
  [3214] = {.lex_state = 305, .external_lex_state = 21},
  [3215] = {.lex_state = 305, .external_lex_state = 21},
  [3216] = {.lex_state = 217},
  [3217] = {.lex_state = 259, .external_lex_state = 18},
  [3218] = {.lex_state = 85},
  [3219] = {.lex_state = 225, .external_lex_state = 18},
  [3220] = {.lex_state = 225, .external_lex_state = 18},
  [3221] = {.lex_state = 305, .external_lex_state = 21},
  [3222] = {.lex_state = 261, .external_lex_state = 30},
  [3223] = {.lex_state = 261, .external_lex_state = 18},
  [3224] = {.lex_state = 305, .external_lex_state = 21},
  [3225] = {.lex_state = 261, .external_lex_state = 30},
  [3226] = {.lex_state = 261, .external_lex_state = 18},
  [3227] = {.lex_state = 305, .external_lex_state = 21},
  [3228] = {.lex_state = 305, .external_lex_state = 21},
  [3229] = {.lex_state = 323, .external_lex_state = 4},
  [3230] = {.lex_state = 215},
  [3231] = {.lex_state = 102},
  [3232] = {.lex_state = 323, .external_lex_state = 21},
  [3233] = {.lex_state = 323, .external_lex_state = 21},
  [3234] = {.lex_state = 217},
  [3235] = {.lex_state = 115},
  [3236] = {.lex_state = 323, .external_lex_state = 21},
  [3237] = {.lex_state = 323, .external_lex_state = 21},
  [3238] = {.lex_state = 323, .external_lex_state = 21},
  [3239] = {.lex_state = 85},
  [3240] = {.lex_state = 223, .external_lex_state = 7},
  [3241] = {.lex_state = 225, .external_lex_state = 18},
  [3242] = {.lex_state = 225, .external_lex_state = 18},
  [3243] = {.lex_state = 85},
  [3244] = {.lex_state = 215, .external_lex_state = 2},
  [3245] = {.lex_state = 78},
  [3246] = {.lex_state = 85},
  [3247] = {.lex_state = 315, .external_lex_state = 4},
  [3248] = {.lex_state = 215},
  [3249] = {.lex_state = 315, .external_lex_state = 21},
  [3250] = {.lex_state = 315, .external_lex_state = 21},
  [3251] = {.lex_state = 315, .external_lex_state = 21},
  [3252] = {.lex_state = 315, .external_lex_state = 21},
  [3253] = {.lex_state = 315, .external_lex_state = 21},
  [3254] = {.lex_state = 217},
  [3255] = {.lex_state = 259, .external_lex_state = 18},
  [3256] = {.lex_state = 85},
  [3257] = {.lex_state = 225, .external_lex_state = 18},
  [3258] = {.lex_state = 225, .external_lex_state = 18},
  [3259] = {.lex_state = 315, .external_lex_state = 21},
  [3260] = {.lex_state = 261, .external_lex_state = 30},
  [3261] = {.lex_state = 261, .external_lex_state = 18},
  [3262] = {.lex_state = 315, .external_lex_state = 21},
  [3263] = {.lex_state = 261, .external_lex_state = 30},
  [3264] = {.lex_state = 261, .external_lex_state = 18},
  [3265] = {.lex_state = 315, .external_lex_state = 21},
  [3266] = {.lex_state = 315, .external_lex_state = 21},
  [3267] = {.lex_state = 315, .external_lex_state = 6},
  [3268] = {.lex_state = 315, .external_lex_state = 6},
  [3269] = {.lex_state = 315, .external_lex_state = 6},
  [3270] = {.lex_state = 217},
  [3271] = {.lex_state = 259, .external_lex_state = 18},
  [3272] = {.lex_state = 85},
  [3273] = {.lex_state = 225, .external_lex_state = 18},
  [3274] = {.lex_state = 225, .external_lex_state = 18},
  [3275] = {.lex_state = 315, .external_lex_state = 6},
  [3276] = {.lex_state = 261, .external_lex_state = 30},
  [3277] = {.lex_state = 261, .external_lex_state = 18},
  [3278] = {.lex_state = 315, .external_lex_state = 6},
  [3279] = {.lex_state = 261, .external_lex_state = 30},
  [3280] = {.lex_state = 261, .external_lex_state = 18},
  [3281] = {.lex_state = 315, .external_lex_state = 6},
  [3282] = {.lex_state = 315, .external_lex_state = 6},
  [3283] = {.lex_state = 317, .external_lex_state = 6},
  [3284] = {.lex_state = 317, .external_lex_state = 6},
  [3285] = {.lex_state = 92, .external_lex_state = 29},
  [3286] = {.lex_state = 92, .external_lex_state = 29},
  [3287] = {.lex_state = 92, .external_lex_state = 18},
  [3288] = {.lex_state = 259, .external_lex_state = 18},
  [3289] = {.lex_state = 317, .external_lex_state = 6},
  [3290] = {.lex_state = 261, .external_lex_state = 30},
  [3291] = {.lex_state = 261, .external_lex_state = 18},
  [3292] = {.lex_state = 261, .external_lex_state = 30},
  [3293] = {.lex_state = 261, .external_lex_state = 18},
  [3294] = {.lex_state = 261, .external_lex_state = 18},
  [3295] = {.lex_state = 317, .external_lex_state = 6},
  [3296] = {.lex_state = 261, .external_lex_state = 18},
  [3297] = {.lex_state = 261, .external_lex_state = 18},
  [3298] = {.lex_state = 321, .external_lex_state = 6},
  [3299] = {.lex_state = 321, .external_lex_state = 6},
  [3300] = {.lex_state = 321, .external_lex_state = 6},
  [3301] = {.lex_state = 286, .external_lex_state = 2},
  [3302] = {.lex_state = 288, .external_lex_state = 4},
  [3303] = {.lex_state = 215},
  [3304] = {.lex_state = 288, .external_lex_state = 21},
  [3305] = {.lex_state = 288, .external_lex_state = 21},
  [3306] = {.lex_state = 92, .external_lex_state = 29},
  [3307] = {.lex_state = 92, .external_lex_state = 29},
  [3308] = {.lex_state = 92, .external_lex_state = 18},
  [3309] = {.lex_state = 259, .external_lex_state = 18},
  [3310] = {.lex_state = 288, .external_lex_state = 21},
  [3311] = {.lex_state = 261, .external_lex_state = 30},
  [3312] = {.lex_state = 261, .external_lex_state = 18},
  [3313] = {.lex_state = 261, .external_lex_state = 30},
  [3314] = {.lex_state = 261, .external_lex_state = 18},
  [3315] = {.lex_state = 261, .external_lex_state = 18},
  [3316] = {.lex_state = 288, .external_lex_state = 21},
  [3317] = {.lex_state = 261, .external_lex_state = 18},
  [3318] = {.lex_state = 261, .external_lex_state = 18},
  [3319] = {.lex_state = 288, .external_lex_state = 6},
  [3320] = {.lex_state = 288, .external_lex_state = 6},
  [3321] = {.lex_state = 92, .external_lex_state = 29},
  [3322] = {.lex_state = 92, .external_lex_state = 29},
  [3323] = {.lex_state = 92, .external_lex_state = 18},
  [3324] = {.lex_state = 259, .external_lex_state = 18},
  [3325] = {.lex_state = 288, .external_lex_state = 6},
  [3326] = {.lex_state = 261, .external_lex_state = 30},
  [3327] = {.lex_state = 261, .external_lex_state = 18},
  [3328] = {.lex_state = 261, .external_lex_state = 30},
  [3329] = {.lex_state = 261, .external_lex_state = 18},
  [3330] = {.lex_state = 261, .external_lex_state = 18},
  [3331] = {.lex_state = 288, .external_lex_state = 6},
  [3332] = {.lex_state = 261, .external_lex_state = 18},
  [3333] = {.lex_state = 261, .external_lex_state = 18},
  [3334] = {.lex_state = 298, .external_lex_state = 6},
  [3335] = {.lex_state = 298, .external_lex_state = 6},
  [3336] = {.lex_state = 92, .external_lex_state = 29},
  [3337] = {.lex_state = 92, .external_lex_state = 29},
  [3338] = {.lex_state = 92, .external_lex_state = 18},
  [3339] = {.lex_state = 261, .external_lex_state = 18},
  [3340] = {.lex_state = 298, .external_lex_state = 6},
  [3341] = {.lex_state = 261, .external_lex_state = 18},
  [3342] = {.lex_state = 261, .external_lex_state = 18},
  [3343] = {.lex_state = 261, .external_lex_state = 18},
  [3344] = {.lex_state = 298, .external_lex_state = 6},
  [3345] = {.lex_state = 261, .external_lex_state = 18},
  [3346] = {.lex_state = 302, .external_lex_state = 6},
  [3347] = {.lex_state = 144, .external_lex_state = 8},
  [3348] = {.lex_state = 85},
  [3349] = {.lex_state = 337, .external_lex_state = 21},
  [3350] = {.lex_state = 115},
  [3351] = {.lex_state = 122},
  [3352] = {.lex_state = 337, .external_lex_state = 21},
  [3353] = {.lex_state = 122, .external_lex_state = 7},
  [3354] = {.lex_state = 78, .external_lex_state = 2},
  [3355] = {.lex_state = 78, .external_lex_state = 2},
  [3356] = {.lex_state = 78, .external_lex_state = 2},
  [3357] = {.lex_state = 85},
  [3358] = {.lex_state = 337, .external_lex_state = 4},
  [3359] = {.lex_state = 337, .external_lex_state = 6},
  [3360] = {.lex_state = 115},
  [3361] = {.lex_state = 122},
  [3362] = {.lex_state = 337, .external_lex_state = 6},
  [3363] = {.lex_state = 122, .external_lex_state = 7},
  [3364] = {.lex_state = 78, .external_lex_state = 2},
  [3365] = {.lex_state = 78, .external_lex_state = 2},
  [3366] = {.lex_state = 78, .external_lex_state = 2},
  [3367] = {.lex_state = 337, .external_lex_state = 5},
  [3368] = {.lex_state = 102},
  [3369] = {.lex_state = 343, .external_lex_state = 6},
  [3370] = {.lex_state = 343, .external_lex_state = 6},
  [3371] = {.lex_state = 217},
  [3372] = {.lex_state = 115},
  [3373] = {.lex_state = 343, .external_lex_state = 6},
  [3374] = {.lex_state = 343, .external_lex_state = 6},
  [3375] = {.lex_state = 343, .external_lex_state = 6},
  [3376] = {.lex_state = 85},
  [3377] = {.lex_state = 223, .external_lex_state = 7},
  [3378] = {.lex_state = 225, .external_lex_state = 18},
  [3379] = {.lex_state = 225, .external_lex_state = 18},
  [3380] = {.lex_state = 85},
  [3381] = {.lex_state = 215, .external_lex_state = 2},
  [3382] = {.lex_state = 78},
  [3383] = {.lex_state = 85},
  [3384] = {.lex_state = 307},
  [3385] = {.lex_state = 78},
  [3386] = {.lex_state = 333, .external_lex_state = 2},
  [3387] = {.lex_state = 78, .external_lex_state = 2},
  [3388] = {.lex_state = 78, .external_lex_state = 2},
  [3389] = {.lex_state = 102},
  [3390] = {.lex_state = 102},
  [3391] = {.lex_state = 349, .external_lex_state = 9},
  [3392] = {.lex_state = 330, .external_lex_state = 5},
  [3393] = {.lex_state = 237, .external_lex_state = 25},
  [3394] = {.lex_state = 343, .external_lex_state = 6},
  [3395] = {.lex_state = 343, .external_lex_state = 6},
  [3396] = {.lex_state = 343, .external_lex_state = 5},
  [3397] = {.lex_state = 330, .external_lex_state = 5},
  [3398] = {.lex_state = 347, .external_lex_state = 4},
  [3399] = {.lex_state = 343, .external_lex_state = 5},
  [3400] = {.lex_state = 330},
  [3401] = {.lex_state = 307},
  [3402] = {.lex_state = 330},
  [3403] = {.lex_state = 233, .external_lex_state = 2},
  [3404] = {.lex_state = 327},
  [3405] = {.lex_state = 233, .external_lex_state = 2},
  [3406] = {.lex_state = 327},
  [3407] = {.lex_state = 186, .external_lex_state = 5},
  [3408] = {.lex_state = 186, .external_lex_state = 5},
  [3409] = {.lex_state = 149, .external_lex_state = 14},
  [3410] = {.lex_state = 149, .external_lex_state = 14},
  [3411] = {.lex_state = 207, .external_lex_state = 27},
  [3412] = {.lex_state = 207, .external_lex_state = 27},
  [3413] = {.lex_state = 92, .external_lex_state = 29},
  [3414] = {.lex_state = 92, .external_lex_state = 29},
  [3415] = {.lex_state = 92, .external_lex_state = 18},
  [3416] = {.lex_state = 261, .external_lex_state = 18},
  [3417] = {.lex_state = 207, .external_lex_state = 27},
  [3418] = {.lex_state = 261, .external_lex_state = 18},
  [3419] = {.lex_state = 261, .external_lex_state = 18},
  [3420] = {.lex_state = 261, .external_lex_state = 18},
  [3421] = {.lex_state = 207, .external_lex_state = 27},
  [3422] = {.lex_state = 261, .external_lex_state = 18},
  [3423] = {.lex_state = 205, .external_lex_state = 16},
  [3424] = {.lex_state = 310},
  [3425] = {.lex_state = 310},
  [3426] = {.lex_state = 153},
  [3427] = {.lex_state = 205, .external_lex_state = 16},
  [3428] = {.lex_state = 205, .external_lex_state = 16},
  [3429] = {.lex_state = 330},
  [3430] = {.lex_state = 205, .external_lex_state = 16},
  [3431] = {.lex_state = 330},
  [3432] = {.lex_state = 199, .external_lex_state = 27},
  [3433] = {.lex_state = 199, .external_lex_state = 27},
  [3434] = {.lex_state = 199, .external_lex_state = 27},
  [3435] = {.lex_state = 261, .external_lex_state = 18},
  [3436] = {.lex_state = 261, .external_lex_state = 18},
  [3437] = {.lex_state = 199, .external_lex_state = 27},
  [3438] = {.lex_state = 199, .external_lex_state = 17},
  [3439] = {.lex_state = 199, .external_lex_state = 17},
  [3440] = {.lex_state = 199, .external_lex_state = 17},
  [3441] = {.lex_state = 261, .external_lex_state = 18},
  [3442] = {.lex_state = 261, .external_lex_state = 18},
  [3443] = {.lex_state = 199, .external_lex_state = 17},
  [3444] = {.lex_state = 201, .external_lex_state = 17},
  [3445] = {.lex_state = 201, .external_lex_state = 17},
  [3446] = {.lex_state = 209, .external_lex_state = 19},
  [3447] = {.lex_state = 209, .external_lex_state = 19},
  [3448] = {.lex_state = 178, .external_lex_state = 21},
  [3449] = {.lex_state = 178, .external_lex_state = 21},
  [3450] = {.lex_state = 178, .external_lex_state = 6},
  [3451] = {.lex_state = 178, .external_lex_state = 6},
  [3452] = {.lex_state = 215, .external_lex_state = 22},
  [3453] = {.lex_state = 215, .external_lex_state = 22},
  [3454] = {.lex_state = 115, .external_lex_state = 10},
  [3455] = {.lex_state = 115, .external_lex_state = 10},
  [3456] = {.lex_state = 92, .external_lex_state = 29},
  [3457] = {.lex_state = 92, .external_lex_state = 29},
  [3458] = {.lex_state = 92, .external_lex_state = 29},
  [3459] = {.lex_state = 92, .external_lex_state = 29},
  [3460] = {.lex_state = 92, .external_lex_state = 18},
  [3461] = {.lex_state = 261, .external_lex_state = 18},
  [3462] = {.lex_state = 92, .external_lex_state = 29},
  [3463] = {.lex_state = 261, .external_lex_state = 18},
  [3464] = {.lex_state = 261, .external_lex_state = 18},
  [3465] = {.lex_state = 261, .external_lex_state = 18},
  [3466] = {.lex_state = 92, .external_lex_state = 29},
  [3467] = {.lex_state = 261, .external_lex_state = 18},
  [3468] = {.lex_state = 261, .external_lex_state = 29},
  [3469] = {.lex_state = 261, .external_lex_state = 29},
  [3470] = {.lex_state = 261, .external_lex_state = 29},
  [3471] = {.lex_state = 261, .external_lex_state = 18},
  [3472] = {.lex_state = 261, .external_lex_state = 18},
  [3473] = {.lex_state = 261, .external_lex_state = 29},
  [3474] = {.lex_state = 96, .external_lex_state = 23},
  [3475] = {.lex_state = 96, .external_lex_state = 23},
  [3476] = {.lex_state = 96, .external_lex_state = 23},
  [3477] = {.lex_state = 261, .external_lex_state = 18},
  [3478] = {.lex_state = 261, .external_lex_state = 18},
  [3479] = {.lex_state = 96, .external_lex_state = 23},
  [3480] = {.lex_state = 215, .external_lex_state = 10},
  [3481] = {.lex_state = 215, .external_lex_state = 10},
  [3482] = {.lex_state = 215, .external_lex_state = 10},
  [3483] = {.lex_state = 261, .external_lex_state = 18},
  [3484] = {.lex_state = 261, .external_lex_state = 18},
  [3485] = {.lex_state = 215, .external_lex_state = 10},
  [3486] = {.lex_state = 184, .external_lex_state = 21},
  [3487] = {.lex_state = 184, .external_lex_state = 21},
  [3488] = {.lex_state = 186, .external_lex_state = 5},
  [3489] = {.lex_state = 241, .external_lex_state = 14},
  [3490] = {.lex_state = 241, .external_lex_state = 14},
  [3491] = {.lex_state = 310},
  [3492] = {.lex_state = 267, .external_lex_state = 14},
  [3493] = {.lex_state = 267, .external_lex_state = 14},
  [3494] = {.lex_state = 267, .external_lex_state = 14},
  [3495] = {.lex_state = 261, .external_lex_state = 18},
  [3496] = {.lex_state = 261, .external_lex_state = 18},
  [3497] = {.lex_state = 267, .external_lex_state = 14},
  [3498] = {.lex_state = 269, .external_lex_state = 10},
  [3499] = {.lex_state = 269, .external_lex_state = 10},
  [3500] = {.lex_state = 140, .external_lex_state = 26},
  [3501] = {.lex_state = 140, .external_lex_state = 26},
  [3502] = {.lex_state = 140, .external_lex_state = 26},
  [3503] = {.lex_state = 261, .external_lex_state = 18},
  [3504] = {.lex_state = 261, .external_lex_state = 18},
  [3505] = {.lex_state = 140, .external_lex_state = 26},
  [3506] = {.lex_state = 136, .external_lex_state = 12},
  [3507] = {.lex_state = 310},
  [3508] = {.lex_state = 310},
  [3509] = {.lex_state = 136, .external_lex_state = 12},
  [3510] = {.lex_state = 136, .external_lex_state = 12},
  [3511] = {.lex_state = 108, .external_lex_state = 26},
  [3512] = {.lex_state = 108, .external_lex_state = 26},
  [3513] = {.lex_state = 108, .external_lex_state = 13},
  [3514] = {.lex_state = 108, .external_lex_state = 13},
  [3515] = {.lex_state = 284, .external_lex_state = 21},
  [3516] = {.lex_state = 284, .external_lex_state = 21},
  [3517] = {.lex_state = 92, .external_lex_state = 29},
  [3518] = {.lex_state = 92, .external_lex_state = 29},
  [3519] = {.lex_state = 92, .external_lex_state = 18},
  [3520] = {.lex_state = 259, .external_lex_state = 18},
  [3521] = {.lex_state = 284, .external_lex_state = 21},
  [3522] = {.lex_state = 261, .external_lex_state = 30},
  [3523] = {.lex_state = 261, .external_lex_state = 18},
  [3524] = {.lex_state = 261, .external_lex_state = 30},
  [3525] = {.lex_state = 261, .external_lex_state = 18},
  [3526] = {.lex_state = 261, .external_lex_state = 18},
  [3527] = {.lex_state = 284, .external_lex_state = 21},
  [3528] = {.lex_state = 261, .external_lex_state = 18},
  [3529] = {.lex_state = 261, .external_lex_state = 18},
  [3530] = {.lex_state = 272, .external_lex_state = 4},
  [3531] = {.lex_state = 272, .external_lex_state = 21},
  [3532] = {.lex_state = 272, .external_lex_state = 21},
  [3533] = {.lex_state = 92, .external_lex_state = 29},
  [3534] = {.lex_state = 92, .external_lex_state = 29},
  [3535] = {.lex_state = 92, .external_lex_state = 18},
  [3536] = {.lex_state = 261, .external_lex_state = 18},
  [3537] = {.lex_state = 272, .external_lex_state = 21},
  [3538] = {.lex_state = 261, .external_lex_state = 18},
  [3539] = {.lex_state = 261, .external_lex_state = 18},
  [3540] = {.lex_state = 261, .external_lex_state = 18},
  [3541] = {.lex_state = 272, .external_lex_state = 21},
  [3542] = {.lex_state = 261, .external_lex_state = 18},
  [3543] = {.lex_state = 272, .external_lex_state = 6},
  [3544] = {.lex_state = 272, .external_lex_state = 6},
  [3545] = {.lex_state = 92, .external_lex_state = 29},
  [3546] = {.lex_state = 92, .external_lex_state = 29},
  [3547] = {.lex_state = 92, .external_lex_state = 18},
  [3548] = {.lex_state = 261, .external_lex_state = 18},
  [3549] = {.lex_state = 272, .external_lex_state = 6},
  [3550] = {.lex_state = 261, .external_lex_state = 18},
  [3551] = {.lex_state = 261, .external_lex_state = 18},
  [3552] = {.lex_state = 261, .external_lex_state = 18},
  [3553] = {.lex_state = 272, .external_lex_state = 6},
  [3554] = {.lex_state = 261, .external_lex_state = 18},
  [3555] = {.lex_state = 278, .external_lex_state = 6},
  [3556] = {.lex_state = 278, .external_lex_state = 6},
  [3557] = {.lex_state = 278, .external_lex_state = 6},
  [3558] = {.lex_state = 261, .external_lex_state = 18},
  [3559] = {.lex_state = 261, .external_lex_state = 18},
  [3560] = {.lex_state = 278, .external_lex_state = 6},
  [3561] = {.lex_state = 335, .external_lex_state = 6},
  [3562] = {.lex_state = 335, .external_lex_state = 6},
  [3563] = {.lex_state = 92, .external_lex_state = 29},
  [3564] = {.lex_state = 92, .external_lex_state = 29},
  [3565] = {.lex_state = 92, .external_lex_state = 18},
  [3566] = {.lex_state = 259, .external_lex_state = 18},
  [3567] = {.lex_state = 335, .external_lex_state = 6},
  [3568] = {.lex_state = 261, .external_lex_state = 30},
  [3569] = {.lex_state = 261, .external_lex_state = 18},
  [3570] = {.lex_state = 261, .external_lex_state = 30},
  [3571] = {.lex_state = 261, .external_lex_state = 18},
  [3572] = {.lex_state = 261, .external_lex_state = 18},
  [3573] = {.lex_state = 335, .external_lex_state = 6},
  [3574] = {.lex_state = 261, .external_lex_state = 18},
  [3575] = {.lex_state = 261, .external_lex_state = 18},
  [3576] = {.lex_state = 305, .external_lex_state = 21},
  [3577] = {.lex_state = 305, .external_lex_state = 21},
  [3578] = {.lex_state = 92, .external_lex_state = 29},
  [3579] = {.lex_state = 92, .external_lex_state = 29},
  [3580] = {.lex_state = 92, .external_lex_state = 18},
  [3581] = {.lex_state = 259, .external_lex_state = 18},
  [3582] = {.lex_state = 305, .external_lex_state = 21},
  [3583] = {.lex_state = 261, .external_lex_state = 30},
  [3584] = {.lex_state = 261, .external_lex_state = 18},
  [3585] = {.lex_state = 261, .external_lex_state = 30},
  [3586] = {.lex_state = 261, .external_lex_state = 18},
  [3587] = {.lex_state = 261, .external_lex_state = 18},
  [3588] = {.lex_state = 305, .external_lex_state = 21},
  [3589] = {.lex_state = 261, .external_lex_state = 18},
  [3590] = {.lex_state = 261, .external_lex_state = 18},
  [3591] = {.lex_state = 323, .external_lex_state = 4},
  [3592] = {.lex_state = 323, .external_lex_state = 21},
  [3593] = {.lex_state = 323, .external_lex_state = 21},
  [3594] = {.lex_state = 323, .external_lex_state = 21},
  [3595] = {.lex_state = 217},
  [3596] = {.lex_state = 259, .external_lex_state = 18},
  [3597] = {.lex_state = 85},
  [3598] = {.lex_state = 225, .external_lex_state = 18},
  [3599] = {.lex_state = 225, .external_lex_state = 18},
  [3600] = {.lex_state = 323, .external_lex_state = 21},
  [3601] = {.lex_state = 261, .external_lex_state = 30},
  [3602] = {.lex_state = 261, .external_lex_state = 18},
  [3603] = {.lex_state = 323, .external_lex_state = 21},
  [3604] = {.lex_state = 261, .external_lex_state = 30},
  [3605] = {.lex_state = 261, .external_lex_state = 18},
  [3606] = {.lex_state = 323, .external_lex_state = 21},
  [3607] = {.lex_state = 323, .external_lex_state = 21},
  [3608] = {.lex_state = 315, .external_lex_state = 4},
  [3609] = {.lex_state = 215},
  [3610] = {.lex_state = 315, .external_lex_state = 21},
  [3611] = {.lex_state = 315, .external_lex_state = 21},
  [3612] = {.lex_state = 92, .external_lex_state = 29},
  [3613] = {.lex_state = 92, .external_lex_state = 29},
  [3614] = {.lex_state = 92, .external_lex_state = 18},
  [3615] = {.lex_state = 259, .external_lex_state = 18},
  [3616] = {.lex_state = 315, .external_lex_state = 21},
  [3617] = {.lex_state = 261, .external_lex_state = 30},
  [3618] = {.lex_state = 261, .external_lex_state = 18},
  [3619] = {.lex_state = 261, .external_lex_state = 30},
  [3620] = {.lex_state = 261, .external_lex_state = 18},
  [3621] = {.lex_state = 261, .external_lex_state = 18},
  [3622] = {.lex_state = 315, .external_lex_state = 21},
  [3623] = {.lex_state = 261, .external_lex_state = 18},
  [3624] = {.lex_state = 261, .external_lex_state = 18},
  [3625] = {.lex_state = 315, .external_lex_state = 6},
  [3626] = {.lex_state = 315, .external_lex_state = 6},
  [3627] = {.lex_state = 92, .external_lex_state = 29},
  [3628] = {.lex_state = 92, .external_lex_state = 29},
  [3629] = {.lex_state = 92, .external_lex_state = 18},
  [3630] = {.lex_state = 259, .external_lex_state = 18},
  [3631] = {.lex_state = 315, .external_lex_state = 6},
  [3632] = {.lex_state = 261, .external_lex_state = 30},
  [3633] = {.lex_state = 261, .external_lex_state = 18},
  [3634] = {.lex_state = 261, .external_lex_state = 30},
  [3635] = {.lex_state = 261, .external_lex_state = 18},
  [3636] = {.lex_state = 261, .external_lex_state = 18},
  [3637] = {.lex_state = 315, .external_lex_state = 6},
  [3638] = {.lex_state = 261, .external_lex_state = 18},
  [3639] = {.lex_state = 261, .external_lex_state = 18},
  [3640] = {.lex_state = 317, .external_lex_state = 6},
  [3641] = {.lex_state = 317, .external_lex_state = 6},
  [3642] = {.lex_state = 92, .external_lex_state = 29},
  [3643] = {.lex_state = 92, .external_lex_state = 29},
  [3644] = {.lex_state = 92, .external_lex_state = 18},
  [3645] = {.lex_state = 261, .external_lex_state = 18},
  [3646] = {.lex_state = 317, .external_lex_state = 6},
  [3647] = {.lex_state = 261, .external_lex_state = 18},
  [3648] = {.lex_state = 261, .external_lex_state = 18},
  [3649] = {.lex_state = 261, .external_lex_state = 18},
  [3650] = {.lex_state = 317, .external_lex_state = 6},
  [3651] = {.lex_state = 261, .external_lex_state = 18},
  [3652] = {.lex_state = 321, .external_lex_state = 6},
  [3653] = {.lex_state = 288, .external_lex_state = 4},
  [3654] = {.lex_state = 288, .external_lex_state = 21},
  [3655] = {.lex_state = 288, .external_lex_state = 21},
  [3656] = {.lex_state = 92, .external_lex_state = 29},
  [3657] = {.lex_state = 92, .external_lex_state = 29},
  [3658] = {.lex_state = 92, .external_lex_state = 18},
  [3659] = {.lex_state = 261, .external_lex_state = 18},
  [3660] = {.lex_state = 288, .external_lex_state = 21},
  [3661] = {.lex_state = 261, .external_lex_state = 18},
  [3662] = {.lex_state = 261, .external_lex_state = 18},
  [3663] = {.lex_state = 261, .external_lex_state = 18},
  [3664] = {.lex_state = 288, .external_lex_state = 21},
  [3665] = {.lex_state = 261, .external_lex_state = 18},
  [3666] = {.lex_state = 288, .external_lex_state = 6},
  [3667] = {.lex_state = 288, .external_lex_state = 6},
  [3668] = {.lex_state = 92, .external_lex_state = 29},
  [3669] = {.lex_state = 92, .external_lex_state = 29},
  [3670] = {.lex_state = 92, .external_lex_state = 18},
  [3671] = {.lex_state = 261, .external_lex_state = 18},
  [3672] = {.lex_state = 288, .external_lex_state = 6},
  [3673] = {.lex_state = 261, .external_lex_state = 18},
  [3674] = {.lex_state = 261, .external_lex_state = 18},
  [3675] = {.lex_state = 261, .external_lex_state = 18},
  [3676] = {.lex_state = 288, .external_lex_state = 6},
  [3677] = {.lex_state = 261, .external_lex_state = 18},
  [3678] = {.lex_state = 298, .external_lex_state = 6},
  [3679] = {.lex_state = 298, .external_lex_state = 6},
  [3680] = {.lex_state = 298, .external_lex_state = 6},
  [3681] = {.lex_state = 261, .external_lex_state = 18},
  [3682] = {.lex_state = 261, .external_lex_state = 18},
  [3683] = {.lex_state = 298, .external_lex_state = 6},
  [3684] = {.lex_state = 347, .external_lex_state = 4},
  [3685] = {.lex_state = 215},
  [3686] = {.lex_state = 347, .external_lex_state = 21},
  [3687] = {.lex_state = 115},
  [3688] = {.lex_state = 122},
  [3689] = {.lex_state = 347, .external_lex_state = 21},
  [3690] = {.lex_state = 122, .external_lex_state = 7},
  [3691] = {.lex_state = 78, .external_lex_state = 2},
  [3692] = {.lex_state = 78, .external_lex_state = 2},
  [3693] = {.lex_state = 78, .external_lex_state = 2},
  [3694] = {.lex_state = 144, .external_lex_state = 8},
  [3695] = {.lex_state = 102},
  [3696] = {.lex_state = 337, .external_lex_state = 21},
  [3697] = {.lex_state = 337, .external_lex_state = 21},
  [3698] = {.lex_state = 217},
  [3699] = {.lex_state = 115},
  [3700] = {.lex_state = 337, .external_lex_state = 21},
  [3701] = {.lex_state = 337, .external_lex_state = 21},
  [3702] = {.lex_state = 337, .external_lex_state = 21},
  [3703] = {.lex_state = 85},
  [3704] = {.lex_state = 223, .external_lex_state = 7},
  [3705] = {.lex_state = 225, .external_lex_state = 18},
  [3706] = {.lex_state = 225, .external_lex_state = 18},
  [3707] = {.lex_state = 85},
  [3708] = {.lex_state = 215, .external_lex_state = 2},
  [3709] = {.lex_state = 78},
  [3710] = {.lex_state = 85},
  [3711] = {.lex_state = 337, .external_lex_state = 4},
  [3712] = {.lex_state = 102},
  [3713] = {.lex_state = 337, .external_lex_state = 6},
  [3714] = {.lex_state = 337, .external_lex_state = 6},
  [3715] = {.lex_state = 217},
  [3716] = {.lex_state = 115},
  [3717] = {.lex_state = 337, .external_lex_state = 6},
  [3718] = {.lex_state = 337, .external_lex_state = 6},
  [3719] = {.lex_state = 337, .external_lex_state = 6},
  [3720] = {.lex_state = 85},
  [3721] = {.lex_state = 223, .external_lex_state = 7},
  [3722] = {.lex_state = 225, .external_lex_state = 18},
  [3723] = {.lex_state = 225, .external_lex_state = 18},
  [3724] = {.lex_state = 85},
  [3725] = {.lex_state = 215, .external_lex_state = 2},
  [3726] = {.lex_state = 78},
  [3727] = {.lex_state = 85},
  [3728] = {.lex_state = 337, .external_lex_state = 5},
  [3729] = {.lex_state = 343, .external_lex_state = 6},
  [3730] = {.lex_state = 343, .external_lex_state = 6},
  [3731] = {.lex_state = 343, .external_lex_state = 6},
  [3732] = {.lex_state = 217},
  [3733] = {.lex_state = 259, .external_lex_state = 18},
  [3734] = {.lex_state = 85},
  [3735] = {.lex_state = 225, .external_lex_state = 18},
  [3736] = {.lex_state = 225, .external_lex_state = 18},
  [3737] = {.lex_state = 343, .external_lex_state = 6},
  [3738] = {.lex_state = 261, .external_lex_state = 30},
  [3739] = {.lex_state = 261, .external_lex_state = 18},
  [3740] = {.lex_state = 343, .external_lex_state = 6},
  [3741] = {.lex_state = 261, .external_lex_state = 30},
  [3742] = {.lex_state = 261, .external_lex_state = 18},
  [3743] = {.lex_state = 343, .external_lex_state = 6},
  [3744] = {.lex_state = 343, .external_lex_state = 6},
  [3745] = {.lex_state = 102},
  [3746] = {.lex_state = 330, .external_lex_state = 5},
  [3747] = {.lex_state = 347, .external_lex_state = 4},
  [3748] = {.lex_state = 330, .external_lex_state = 5},
  [3749] = {.lex_state = 347, .external_lex_state = 4},
  [3750] = {.lex_state = 330, .external_lex_state = 6},
  [3751] = {.lex_state = 330, .external_lex_state = 6},
  [3752] = {.lex_state = 330, .external_lex_state = 6},
  [3753] = {.lex_state = 330, .external_lex_state = 6},
  [3754] = {.lex_state = 333, .external_lex_state = 2},
  [3755] = {.lex_state = 330, .external_lex_state = 5},
  [3756] = {.lex_state = 343, .external_lex_state = 5},
  [3757] = {.lex_state = 343, .external_lex_state = 6},
  [3758] = {.lex_state = 343, .external_lex_state = 6},
  [3759] = {.lex_state = 343, .external_lex_state = 5},
  [3760] = {.lex_state = 333, .external_lex_state = 2},
  [3761] = {.lex_state = 349, .external_lex_state = 9},
  [3762] = {.lex_state = 343, .external_lex_state = 5},
  [3763] = {.lex_state = 307},
  [3764] = {.lex_state = 307},
  [3765] = {.lex_state = 102},
  [3766] = {.lex_state = 85},
  [3767] = {.lex_state = 136, .external_lex_state = 5},
  [3768] = {.lex_state = 140, .external_lex_state = 4},
  [3769] = {.lex_state = 78, .external_lex_state = 2},
  [3770] = {.lex_state = 233, .external_lex_state = 2},
  [3771] = {.lex_state = 102},
  [3772] = {.lex_state = 85},
  [3773] = {.lex_state = 233, .external_lex_state = 2},
  [3774] = {.lex_state = 207, .external_lex_state = 27},
  [3775] = {.lex_state = 207, .external_lex_state = 27},
  [3776] = {.lex_state = 207, .external_lex_state = 27},
  [3777] = {.lex_state = 261, .external_lex_state = 18},
  [3778] = {.lex_state = 261, .external_lex_state = 18},
  [3779] = {.lex_state = 207, .external_lex_state = 27},
  [3780] = {.lex_state = 205, .external_lex_state = 16},
  [3781] = {.lex_state = 310},
  [3782] = {.lex_state = 310},
  [3783] = {.lex_state = 205, .external_lex_state = 16},
  [3784] = {.lex_state = 205, .external_lex_state = 16},
  [3785] = {.lex_state = 199, .external_lex_state = 27},
  [3786] = {.lex_state = 199, .external_lex_state = 27},
  [3787] = {.lex_state = 199, .external_lex_state = 17},
  [3788] = {.lex_state = 199, .external_lex_state = 17},
  [3789] = {.lex_state = 92, .external_lex_state = 29},
  [3790] = {.lex_state = 92, .external_lex_state = 29},
  [3791] = {.lex_state = 92, .external_lex_state = 29},
  [3792] = {.lex_state = 261, .external_lex_state = 18},
  [3793] = {.lex_state = 261, .external_lex_state = 18},
  [3794] = {.lex_state = 92, .external_lex_state = 29},
  [3795] = {.lex_state = 261, .external_lex_state = 29},
  [3796] = {.lex_state = 261, .external_lex_state = 29},
  [3797] = {.lex_state = 96, .external_lex_state = 23},
  [3798] = {.lex_state = 96, .external_lex_state = 23},
  [3799] = {.lex_state = 215, .external_lex_state = 10},
  [3800] = {.lex_state = 215, .external_lex_state = 10},
  [3801] = {.lex_state = 186, .external_lex_state = 5},
  [3802] = {.lex_state = 267, .external_lex_state = 14},
  [3803] = {.lex_state = 267, .external_lex_state = 14},
  [3804] = {.lex_state = 140, .external_lex_state = 26},
  [3805] = {.lex_state = 140, .external_lex_state = 26},
  [3806] = {.lex_state = 136, .external_lex_state = 12},
  [3807] = {.lex_state = 310},
  [3808] = {.lex_state = 284, .external_lex_state = 21},
  [3809] = {.lex_state = 284, .external_lex_state = 21},
  [3810] = {.lex_state = 92, .external_lex_state = 29},
  [3811] = {.lex_state = 92, .external_lex_state = 29},
  [3812] = {.lex_state = 92, .external_lex_state = 18},
  [3813] = {.lex_state = 261, .external_lex_state = 18},
  [3814] = {.lex_state = 284, .external_lex_state = 21},
  [3815] = {.lex_state = 261, .external_lex_state = 18},
  [3816] = {.lex_state = 261, .external_lex_state = 18},
  [3817] = {.lex_state = 261, .external_lex_state = 18},
  [3818] = {.lex_state = 284, .external_lex_state = 21},
  [3819] = {.lex_state = 261, .external_lex_state = 18},
  [3820] = {.lex_state = 272, .external_lex_state = 21},
  [3821] = {.lex_state = 272, .external_lex_state = 21},
  [3822] = {.lex_state = 272, .external_lex_state = 21},
  [3823] = {.lex_state = 261, .external_lex_state = 18},
  [3824] = {.lex_state = 261, .external_lex_state = 18},
  [3825] = {.lex_state = 272, .external_lex_state = 21},
  [3826] = {.lex_state = 272, .external_lex_state = 6},
  [3827] = {.lex_state = 272, .external_lex_state = 6},
  [3828] = {.lex_state = 272, .external_lex_state = 6},
  [3829] = {.lex_state = 261, .external_lex_state = 18},
  [3830] = {.lex_state = 261, .external_lex_state = 18},
  [3831] = {.lex_state = 272, .external_lex_state = 6},
  [3832] = {.lex_state = 278, .external_lex_state = 6},
  [3833] = {.lex_state = 278, .external_lex_state = 6},
  [3834] = {.lex_state = 335, .external_lex_state = 6},
  [3835] = {.lex_state = 335, .external_lex_state = 6},
  [3836] = {.lex_state = 92, .external_lex_state = 29},
  [3837] = {.lex_state = 92, .external_lex_state = 29},
  [3838] = {.lex_state = 92, .external_lex_state = 18},
  [3839] = {.lex_state = 261, .external_lex_state = 18},
  [3840] = {.lex_state = 335, .external_lex_state = 6},
  [3841] = {.lex_state = 261, .external_lex_state = 18},
  [3842] = {.lex_state = 261, .external_lex_state = 18},
  [3843] = {.lex_state = 261, .external_lex_state = 18},
  [3844] = {.lex_state = 335, .external_lex_state = 6},
  [3845] = {.lex_state = 261, .external_lex_state = 18},
  [3846] = {.lex_state = 305, .external_lex_state = 21},
  [3847] = {.lex_state = 305, .external_lex_state = 21},
  [3848] = {.lex_state = 92, .external_lex_state = 29},
  [3849] = {.lex_state = 92, .external_lex_state = 29},
  [3850] = {.lex_state = 92, .external_lex_state = 18},
  [3851] = {.lex_state = 261, .external_lex_state = 18},
  [3852] = {.lex_state = 305, .external_lex_state = 21},
  [3853] = {.lex_state = 261, .external_lex_state = 18},
  [3854] = {.lex_state = 261, .external_lex_state = 18},
  [3855] = {.lex_state = 261, .external_lex_state = 18},
  [3856] = {.lex_state = 305, .external_lex_state = 21},
  [3857] = {.lex_state = 261, .external_lex_state = 18},
  [3858] = {.lex_state = 323, .external_lex_state = 21},
  [3859] = {.lex_state = 323, .external_lex_state = 21},
  [3860] = {.lex_state = 92, .external_lex_state = 29},
  [3861] = {.lex_state = 92, .external_lex_state = 29},
  [3862] = {.lex_state = 92, .external_lex_state = 18},
  [3863] = {.lex_state = 259, .external_lex_state = 18},
  [3864] = {.lex_state = 323, .external_lex_state = 21},
  [3865] = {.lex_state = 261, .external_lex_state = 30},
  [3866] = {.lex_state = 261, .external_lex_state = 18},
  [3867] = {.lex_state = 261, .external_lex_state = 30},
  [3868] = {.lex_state = 261, .external_lex_state = 18},
  [3869] = {.lex_state = 261, .external_lex_state = 18},
  [3870] = {.lex_state = 323, .external_lex_state = 21},
  [3871] = {.lex_state = 261, .external_lex_state = 18},
  [3872] = {.lex_state = 261, .external_lex_state = 18},
  [3873] = {.lex_state = 315, .external_lex_state = 4},
  [3874] = {.lex_state = 315, .external_lex_state = 21},
  [3875] = {.lex_state = 315, .external_lex_state = 21},
  [3876] = {.lex_state = 92, .external_lex_state = 29},
  [3877] = {.lex_state = 92, .external_lex_state = 29},
  [3878] = {.lex_state = 92, .external_lex_state = 18},
  [3879] = {.lex_state = 261, .external_lex_state = 18},
  [3880] = {.lex_state = 315, .external_lex_state = 21},
  [3881] = {.lex_state = 261, .external_lex_state = 18},
  [3882] = {.lex_state = 261, .external_lex_state = 18},
  [3883] = {.lex_state = 261, .external_lex_state = 18},
  [3884] = {.lex_state = 315, .external_lex_state = 21},
  [3885] = {.lex_state = 261, .external_lex_state = 18},
  [3886] = {.lex_state = 315, .external_lex_state = 6},
  [3887] = {.lex_state = 315, .external_lex_state = 6},
  [3888] = {.lex_state = 92, .external_lex_state = 29},
  [3889] = {.lex_state = 92, .external_lex_state = 29},
  [3890] = {.lex_state = 92, .external_lex_state = 18},
  [3891] = {.lex_state = 261, .external_lex_state = 18},
  [3892] = {.lex_state = 315, .external_lex_state = 6},
  [3893] = {.lex_state = 261, .external_lex_state = 18},
  [3894] = {.lex_state = 261, .external_lex_state = 18},
  [3895] = {.lex_state = 261, .external_lex_state = 18},
  [3896] = {.lex_state = 315, .external_lex_state = 6},
  [3897] = {.lex_state = 261, .external_lex_state = 18},
  [3898] = {.lex_state = 317, .external_lex_state = 6},
  [3899] = {.lex_state = 317, .external_lex_state = 6},
  [3900] = {.lex_state = 317, .external_lex_state = 6},
  [3901] = {.lex_state = 261, .external_lex_state = 18},
  [3902] = {.lex_state = 261, .external_lex_state = 18},
  [3903] = {.lex_state = 317, .external_lex_state = 6},
  [3904] = {.lex_state = 288, .external_lex_state = 21},
  [3905] = {.lex_state = 288, .external_lex_state = 21},
  [3906] = {.lex_state = 288, .external_lex_state = 21},
  [3907] = {.lex_state = 261, .external_lex_state = 18},
  [3908] = {.lex_state = 261, .external_lex_state = 18},
  [3909] = {.lex_state = 288, .external_lex_state = 21},
  [3910] = {.lex_state = 288, .external_lex_state = 6},
  [3911] = {.lex_state = 288, .external_lex_state = 6},
  [3912] = {.lex_state = 288, .external_lex_state = 6},
  [3913] = {.lex_state = 261, .external_lex_state = 18},
  [3914] = {.lex_state = 261, .external_lex_state = 18},
  [3915] = {.lex_state = 288, .external_lex_state = 6},
  [3916] = {.lex_state = 298, .external_lex_state = 6},
  [3917] = {.lex_state = 298, .external_lex_state = 6},
  [3918] = {.lex_state = 347, .external_lex_state = 4},
  [3919] = {.lex_state = 215},
  [3920] = {.lex_state = 102},
  [3921] = {.lex_state = 347, .external_lex_state = 21},
  [3922] = {.lex_state = 347, .external_lex_state = 21},
  [3923] = {.lex_state = 217},
  [3924] = {.lex_state = 115},
  [3925] = {.lex_state = 347, .external_lex_state = 21},
  [3926] = {.lex_state = 347, .external_lex_state = 21},
  [3927] = {.lex_state = 347, .external_lex_state = 21},
  [3928] = {.lex_state = 85},
  [3929] = {.lex_state = 223, .external_lex_state = 7},
  [3930] = {.lex_state = 225, .external_lex_state = 18},
  [3931] = {.lex_state = 225, .external_lex_state = 18},
  [3932] = {.lex_state = 85},
  [3933] = {.lex_state = 215, .external_lex_state = 2},
  [3934] = {.lex_state = 78},
  [3935] = {.lex_state = 85},
  [3936] = {.lex_state = 337, .external_lex_state = 4},
  [3937] = {.lex_state = 215},
  [3938] = {.lex_state = 337, .external_lex_state = 21},
  [3939] = {.lex_state = 337, .external_lex_state = 21},
  [3940] = {.lex_state = 337, .external_lex_state = 21},
  [3941] = {.lex_state = 337, .external_lex_state = 21},
  [3942] = {.lex_state = 337, .external_lex_state = 21},
  [3943] = {.lex_state = 217},
  [3944] = {.lex_state = 259, .external_lex_state = 18},
  [3945] = {.lex_state = 85},
  [3946] = {.lex_state = 225, .external_lex_state = 18},
  [3947] = {.lex_state = 225, .external_lex_state = 18},
  [3948] = {.lex_state = 337, .external_lex_state = 21},
  [3949] = {.lex_state = 261, .external_lex_state = 30},
  [3950] = {.lex_state = 261, .external_lex_state = 18},
  [3951] = {.lex_state = 337, .external_lex_state = 21},
  [3952] = {.lex_state = 261, .external_lex_state = 30},
  [3953] = {.lex_state = 261, .external_lex_state = 18},
  [3954] = {.lex_state = 337, .external_lex_state = 21},
  [3955] = {.lex_state = 337, .external_lex_state = 21},
  [3956] = {.lex_state = 337, .external_lex_state = 6},
  [3957] = {.lex_state = 337, .external_lex_state = 6},
  [3958] = {.lex_state = 337, .external_lex_state = 6},
  [3959] = {.lex_state = 217},
  [3960] = {.lex_state = 259, .external_lex_state = 18},
  [3961] = {.lex_state = 85},
  [3962] = {.lex_state = 225, .external_lex_state = 18},
  [3963] = {.lex_state = 225, .external_lex_state = 18},
  [3964] = {.lex_state = 337, .external_lex_state = 6},
  [3965] = {.lex_state = 261, .external_lex_state = 30},
  [3966] = {.lex_state = 261, .external_lex_state = 18},
  [3967] = {.lex_state = 337, .external_lex_state = 6},
  [3968] = {.lex_state = 261, .external_lex_state = 30},
  [3969] = {.lex_state = 261, .external_lex_state = 18},
  [3970] = {.lex_state = 337, .external_lex_state = 6},
  [3971] = {.lex_state = 337, .external_lex_state = 6},
  [3972] = {.lex_state = 343, .external_lex_state = 6},
  [3973] = {.lex_state = 343, .external_lex_state = 6},
  [3974] = {.lex_state = 92, .external_lex_state = 29},
  [3975] = {.lex_state = 92, .external_lex_state = 29},
  [3976] = {.lex_state = 92, .external_lex_state = 18},
  [3977] = {.lex_state = 259, .external_lex_state = 18},
  [3978] = {.lex_state = 343, .external_lex_state = 6},
  [3979] = {.lex_state = 261, .external_lex_state = 30},
  [3980] = {.lex_state = 261, .external_lex_state = 18},
  [3981] = {.lex_state = 261, .external_lex_state = 30},
  [3982] = {.lex_state = 261, .external_lex_state = 18},
  [3983] = {.lex_state = 261, .external_lex_state = 18},
  [3984] = {.lex_state = 343, .external_lex_state = 6},
  [3985] = {.lex_state = 261, .external_lex_state = 18},
  [3986] = {.lex_state = 261, .external_lex_state = 18},
  [3987] = {.lex_state = 330, .external_lex_state = 6},
  [3988] = {.lex_state = 330, .external_lex_state = 6},
  [3989] = {.lex_state = 330, .external_lex_state = 6},
  [3990] = {.lex_state = 333, .external_lex_state = 2},
  [3991] = {.lex_state = 102},
  [3992] = {.lex_state = 146, .external_lex_state = 9},
  [3993] = {.lex_state = 136, .external_lex_state = 5},
  [3994] = {.lex_state = 140, .external_lex_state = 4},
  [3995] = {.lex_state = 85},
  [3996] = {.lex_state = 102},
  [3997] = {.lex_state = 85},
  [3998] = {.lex_state = 207, .external_lex_state = 27},
  [3999] = {.lex_state = 207, .external_lex_state = 27},
  [4000] = {.lex_state = 205, .external_lex_state = 16},
  [4001] = {.lex_state = 310},
  [4002] = {.lex_state = 92, .external_lex_state = 29},
  [4003] = {.lex_state = 92, .external_lex_state = 29},
  [4004] = {.lex_state = 136, .external_lex_state = 12},
  [4005] = {.lex_state = 284, .external_lex_state = 21},
  [4006] = {.lex_state = 284, .external_lex_state = 21},
  [4007] = {.lex_state = 284, .external_lex_state = 21},
  [4008] = {.lex_state = 261, .external_lex_state = 18},
  [4009] = {.lex_state = 261, .external_lex_state = 18},
  [4010] = {.lex_state = 284, .external_lex_state = 21},
  [4011] = {.lex_state = 272, .external_lex_state = 21},
  [4012] = {.lex_state = 272, .external_lex_state = 21},
  [4013] = {.lex_state = 272, .external_lex_state = 6},
  [4014] = {.lex_state = 272, .external_lex_state = 6},
  [4015] = {.lex_state = 335, .external_lex_state = 6},
  [4016] = {.lex_state = 335, .external_lex_state = 6},
  [4017] = {.lex_state = 335, .external_lex_state = 6},
  [4018] = {.lex_state = 261, .external_lex_state = 18},
  [4019] = {.lex_state = 261, .external_lex_state = 18},
  [4020] = {.lex_state = 335, .external_lex_state = 6},
  [4021] = {.lex_state = 305, .external_lex_state = 21},
  [4022] = {.lex_state = 305, .external_lex_state = 21},
  [4023] = {.lex_state = 305, .external_lex_state = 21},
  [4024] = {.lex_state = 261, .external_lex_state = 18},
  [4025] = {.lex_state = 261, .external_lex_state = 18},
  [4026] = {.lex_state = 305, .external_lex_state = 21},
  [4027] = {.lex_state = 323, .external_lex_state = 21},
  [4028] = {.lex_state = 323, .external_lex_state = 21},
  [4029] = {.lex_state = 92, .external_lex_state = 29},
  [4030] = {.lex_state = 92, .external_lex_state = 29},
  [4031] = {.lex_state = 92, .external_lex_state = 18},
  [4032] = {.lex_state = 261, .external_lex_state = 18},
  [4033] = {.lex_state = 323, .external_lex_state = 21},
  [4034] = {.lex_state = 261, .external_lex_state = 18},
  [4035] = {.lex_state = 261, .external_lex_state = 18},
  [4036] = {.lex_state = 261, .external_lex_state = 18},
  [4037] = {.lex_state = 323, .external_lex_state = 21},
  [4038] = {.lex_state = 261, .external_lex_state = 18},
  [4039] = {.lex_state = 315, .external_lex_state = 21},
  [4040] = {.lex_state = 315, .external_lex_state = 21},
  [4041] = {.lex_state = 315, .external_lex_state = 21},
  [4042] = {.lex_state = 261, .external_lex_state = 18},
  [4043] = {.lex_state = 261, .external_lex_state = 18},
  [4044] = {.lex_state = 315, .external_lex_state = 21},
  [4045] = {.lex_state = 315, .external_lex_state = 6},
  [4046] = {.lex_state = 315, .external_lex_state = 6},
  [4047] = {.lex_state = 315, .external_lex_state = 6},
  [4048] = {.lex_state = 261, .external_lex_state = 18},
  [4049] = {.lex_state = 261, .external_lex_state = 18},
  [4050] = {.lex_state = 315, .external_lex_state = 6},
  [4051] = {.lex_state = 317, .external_lex_state = 6},
  [4052] = {.lex_state = 317, .external_lex_state = 6},
  [4053] = {.lex_state = 288, .external_lex_state = 21},
  [4054] = {.lex_state = 288, .external_lex_state = 21},
  [4055] = {.lex_state = 288, .external_lex_state = 6},
  [4056] = {.lex_state = 288, .external_lex_state = 6},
  [4057] = {.lex_state = 347, .external_lex_state = 4},
  [4058] = {.lex_state = 347, .external_lex_state = 21},
  [4059] = {.lex_state = 347, .external_lex_state = 21},
  [4060] = {.lex_state = 347, .external_lex_state = 21},
  [4061] = {.lex_state = 217},
  [4062] = {.lex_state = 259, .external_lex_state = 18},
  [4063] = {.lex_state = 85},
  [4064] = {.lex_state = 225, .external_lex_state = 18},
  [4065] = {.lex_state = 225, .external_lex_state = 18},
  [4066] = {.lex_state = 347, .external_lex_state = 21},
  [4067] = {.lex_state = 261, .external_lex_state = 30},
  [4068] = {.lex_state = 261, .external_lex_state = 18},
  [4069] = {.lex_state = 347, .external_lex_state = 21},
  [4070] = {.lex_state = 261, .external_lex_state = 30},
  [4071] = {.lex_state = 261, .external_lex_state = 18},
  [4072] = {.lex_state = 347, .external_lex_state = 21},
  [4073] = {.lex_state = 347, .external_lex_state = 21},
  [4074] = {.lex_state = 337, .external_lex_state = 4},
  [4075] = {.lex_state = 215},
  [4076] = {.lex_state = 337, .external_lex_state = 21},
  [4077] = {.lex_state = 337, .external_lex_state = 21},
  [4078] = {.lex_state = 92, .external_lex_state = 29},
  [4079] = {.lex_state = 92, .external_lex_state = 29},
  [4080] = {.lex_state = 92, .external_lex_state = 18},
  [4081] = {.lex_state = 259, .external_lex_state = 18},
  [4082] = {.lex_state = 337, .external_lex_state = 21},
  [4083] = {.lex_state = 261, .external_lex_state = 30},
  [4084] = {.lex_state = 261, .external_lex_state = 18},
  [4085] = {.lex_state = 261, .external_lex_state = 30},
  [4086] = {.lex_state = 261, .external_lex_state = 18},
  [4087] = {.lex_state = 261, .external_lex_state = 18},
  [4088] = {.lex_state = 337, .external_lex_state = 21},
  [4089] = {.lex_state = 261, .external_lex_state = 18},
  [4090] = {.lex_state = 261, .external_lex_state = 18},
  [4091] = {.lex_state = 337, .external_lex_state = 6},
  [4092] = {.lex_state = 337, .external_lex_state = 6},
  [4093] = {.lex_state = 92, .external_lex_state = 29},
  [4094] = {.lex_state = 92, .external_lex_state = 29},
  [4095] = {.lex_state = 92, .external_lex_state = 18},
  [4096] = {.lex_state = 259, .external_lex_state = 18},
  [4097] = {.lex_state = 337, .external_lex_state = 6},
  [4098] = {.lex_state = 261, .external_lex_state = 30},
  [4099] = {.lex_state = 261, .external_lex_state = 18},
  [4100] = {.lex_state = 261, .external_lex_state = 30},
  [4101] = {.lex_state = 261, .external_lex_state = 18},
  [4102] = {.lex_state = 261, .external_lex_state = 18},
  [4103] = {.lex_state = 337, .external_lex_state = 6},
  [4104] = {.lex_state = 261, .external_lex_state = 18},
  [4105] = {.lex_state = 261, .external_lex_state = 18},
  [4106] = {.lex_state = 343, .external_lex_state = 6},
  [4107] = {.lex_state = 343, .external_lex_state = 6},
  [4108] = {.lex_state = 92, .external_lex_state = 29},
  [4109] = {.lex_state = 92, .external_lex_state = 29},
  [4110] = {.lex_state = 92, .external_lex_state = 18},
  [4111] = {.lex_state = 261, .external_lex_state = 18},
  [4112] = {.lex_state = 343, .external_lex_state = 6},
  [4113] = {.lex_state = 261, .external_lex_state = 18},
  [4114] = {.lex_state = 261, .external_lex_state = 18},
  [4115] = {.lex_state = 261, .external_lex_state = 18},
  [4116] = {.lex_state = 343, .external_lex_state = 6},
  [4117] = {.lex_state = 261, .external_lex_state = 18},
  [4118] = {.lex_state = 330, .external_lex_state = 6},
  [4119] = {.lex_state = 146, .external_lex_state = 9},
  [4120] = {.lex_state = 102},
  [4121] = {.lex_state = 102},
  [4122] = {.lex_state = 205, .external_lex_state = 16},
  [4123] = {.lex_state = 284, .external_lex_state = 21},
  [4124] = {.lex_state = 284, .external_lex_state = 21},
  [4125] = {.lex_state = 335, .external_lex_state = 6},
  [4126] = {.lex_state = 335, .external_lex_state = 6},
  [4127] = {.lex_state = 305, .external_lex_state = 21},
  [4128] = {.lex_state = 305, .external_lex_state = 21},
  [4129] = {.lex_state = 323, .external_lex_state = 21},
  [4130] = {.lex_state = 323, .external_lex_state = 21},
  [4131] = {.lex_state = 323, .external_lex_state = 21},
  [4132] = {.lex_state = 261, .external_lex_state = 18},
  [4133] = {.lex_state = 261, .external_lex_state = 18},
  [4134] = {.lex_state = 323, .external_lex_state = 21},
  [4135] = {.lex_state = 315, .external_lex_state = 21},
  [4136] = {.lex_state = 315, .external_lex_state = 21},
  [4137] = {.lex_state = 315, .external_lex_state = 6},
  [4138] = {.lex_state = 315, .external_lex_state = 6},
  [4139] = {.lex_state = 347, .external_lex_state = 21},
  [4140] = {.lex_state = 347, .external_lex_state = 21},
  [4141] = {.lex_state = 92, .external_lex_state = 29},
  [4142] = {.lex_state = 92, .external_lex_state = 29},
  [4143] = {.lex_state = 92, .external_lex_state = 18},
  [4144] = {.lex_state = 259, .external_lex_state = 18},
  [4145] = {.lex_state = 347, .external_lex_state = 21},
  [4146] = {.lex_state = 261, .external_lex_state = 30},
  [4147] = {.lex_state = 261, .external_lex_state = 18},
  [4148] = {.lex_state = 261, .external_lex_state = 30},
  [4149] = {.lex_state = 261, .external_lex_state = 18},
  [4150] = {.lex_state = 261, .external_lex_state = 18},
  [4151] = {.lex_state = 347, .external_lex_state = 21},
  [4152] = {.lex_state = 261, .external_lex_state = 18},
  [4153] = {.lex_state = 261, .external_lex_state = 18},
  [4154] = {.lex_state = 337, .external_lex_state = 4},
  [4155] = {.lex_state = 337, .external_lex_state = 21},
  [4156] = {.lex_state = 337, .external_lex_state = 21},
  [4157] = {.lex_state = 92, .external_lex_state = 29},
  [4158] = {.lex_state = 92, .external_lex_state = 29},
  [4159] = {.lex_state = 92, .external_lex_state = 18},
  [4160] = {.lex_state = 261, .external_lex_state = 18},
  [4161] = {.lex_state = 337, .external_lex_state = 21},
  [4162] = {.lex_state = 261, .external_lex_state = 18},
  [4163] = {.lex_state = 261, .external_lex_state = 18},
  [4164] = {.lex_state = 261, .external_lex_state = 18},
  [4165] = {.lex_state = 337, .external_lex_state = 21},
  [4166] = {.lex_state = 261, .external_lex_state = 18},
  [4167] = {.lex_state = 337, .external_lex_state = 6},
  [4168] = {.lex_state = 337, .external_lex_state = 6},
  [4169] = {.lex_state = 92, .external_lex_state = 29},
  [4170] = {.lex_state = 92, .external_lex_state = 29},
  [4171] = {.lex_state = 92, .external_lex_state = 18},
  [4172] = {.lex_state = 261, .external_lex_state = 18},
  [4173] = {.lex_state = 337, .external_lex_state = 6},
  [4174] = {.lex_state = 261, .external_lex_state = 18},
  [4175] = {.lex_state = 261, .external_lex_state = 18},
  [4176] = {.lex_state = 261, .external_lex_state = 18},
  [4177] = {.lex_state = 337, .external_lex_state = 6},
  [4178] = {.lex_state = 261, .external_lex_state = 18},
  [4179] = {.lex_state = 343, .external_lex_state = 6},
  [4180] = {.lex_state = 343, .external_lex_state = 6},
  [4181] = {.lex_state = 343, .external_lex_state = 6},
  [4182] = {.lex_state = 261, .external_lex_state = 18},
  [4183] = {.lex_state = 261, .external_lex_state = 18},
  [4184] = {.lex_state = 343, .external_lex_state = 6},
  [4185] = {.lex_state = 323, .external_lex_state = 21},
  [4186] = {.lex_state = 323, .external_lex_state = 21},
  [4187] = {.lex_state = 347, .external_lex_state = 21},
  [4188] = {.lex_state = 347, .external_lex_state = 21},
  [4189] = {.lex_state = 92, .external_lex_state = 29},
  [4190] = {.lex_state = 92, .external_lex_state = 29},
  [4191] = {.lex_state = 92, .external_lex_state = 18},
  [4192] = {.lex_state = 261, .external_lex_state = 18},
  [4193] = {.lex_state = 347, .external_lex_state = 21},
  [4194] = {.lex_state = 261, .external_lex_state = 18},
  [4195] = {.lex_state = 261, .external_lex_state = 18},
  [4196] = {.lex_state = 261, .external_lex_state = 18},
  [4197] = {.lex_state = 347, .external_lex_state = 21},
  [4198] = {.lex_state = 261, .external_lex_state = 18},
  [4199] = {.lex_state = 337, .external_lex_state = 21},
  [4200] = {.lex_state = 337, .external_lex_state = 21},
  [4201] = {.lex_state = 337, .external_lex_state = 21},
  [4202] = {.lex_state = 261, .external_lex_state = 18},
  [4203] = {.lex_state = 261, .external_lex_state = 18},
  [4204] = {.lex_state = 337, .external_lex_state = 21},
  [4205] = {.lex_state = 337, .external_lex_state = 6},
  [4206] = {.lex_state = 337, .external_lex_state = 6},
  [4207] = {.lex_state = 337, .external_lex_state = 6},
  [4208] = {.lex_state = 261, .external_lex_state = 18},
  [4209] = {.lex_state = 261, .external_lex_state = 18},
  [4210] = {.lex_state = 337, .external_lex_state = 6},
  [4211] = {.lex_state = 343, .external_lex_state = 6},
  [4212] = {.lex_state = 343, .external_lex_state = 6},
  [4213] = {.lex_state = 347, .external_lex_state = 21},
  [4214] = {.lex_state = 347, .external_lex_state = 21},
  [4215] = {.lex_state = 347, .external_lex_state = 21},
  [4216] = {.lex_state = 261, .external_lex_state = 18},
  [4217] = {.lex_state = 261, .external_lex_state = 18},
  [4218] = {.lex_state = 347, .external_lex_state = 21},
  [4219] = {.lex_state = 337, .external_lex_state = 21},
  [4220] = {.lex_state = 337, .external_lex_state = 21},
  [4221] = {.lex_state = 337, .external_lex_state = 6},
  [4222] = {.lex_state = 337, .external_lex_state = 6},
  [4223] = {.lex_state = 347, .external_lex_state = 21},
  [4224] = {.lex_state = 347, .external_lex_state = 21},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_regex,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LT_LT,
  ts_external_token_LT_LT_DASH,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_regex] = sym_regex,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LT_LT] = anon_sym_LT_LT,
  [ts_external_token_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[31][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [4] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_variable_name] = true,
  },
  [8] = {
    [ts_external_token__empty_value] = true,
  },
  [9] = {
    [ts_external_token_LF] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
  },
  [11] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [12] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [13] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [16] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [17] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [18] = {
    [ts_external_token_RBRACE] = true,
  },
  [19] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [20] = {
    [ts_external_token_RBRACK] = true,
  },
  [21] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [22] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [23] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [24] = {
    [ts_external_token_heredoc_start] = true,
  },
  [25] = {
    [ts_external_token_regex] = true,
  },
  [26] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [27] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [28] = {
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LF] = true,
  },
  [29] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [30] = {
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [sym_regex] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [sym_test_operator] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(27),
    [sym__statements] = STATE(28),
    [sym_redirected_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_c_style_for_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_compound_statement] = STATE(29),
    [sym_subshell] = STATE(29),
    [sym_pipeline] = STATE(29),
    [sym_list] = STATE(29),
    [sym_negated_command] = STATE(29),
    [sym_test_command] = STATE(29),
    [sym_declaration_command] = STATE(29),
    [sym_unset_command] = STATE(29),
    [sym_command] = STATE(29),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(31),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym__statements_repeat1] = STATE(34),
    [aux_sym_command_repeat1] = STATE(35),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_GT] = ACTIONS(63),
    [anon_sym_AMP_GT] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(63),
    [anon_sym_LT_AMP] = ACTIONS(63),
    [anon_sym_GT_AMP] = ACTIONS(63),
    [sym_comment] = ACTIONS(57),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [sym_comment] = ACTIONS(57),
  },
  [4] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(71),
  },
  [5] = {
    [sym__expression] = STATE(51),
    [sym_binary_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_postfix_expression] = STATE(51),
    [sym_parenthesized_expression] = STATE(51),
    [sym_concatenation] = STATE(51),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [6] = {
    [sym__terminated_statement] = STATE(75),
    [sym_redirected_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_c_style_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_compound_statement] = STATE(76),
    [sym_subshell] = STATE(76),
    [sym_pipeline] = STATE(76),
    [sym_list] = STATE(76),
    [sym_negated_command] = STATE(76),
    [sym_test_command] = STATE(76),
    [sym_declaration_command] = STATE(76),
    [sym_unset_command] = STATE(76),
    [sym_command] = STATE(76),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(78),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [7] = {
    [sym__terminated_statement] = STATE(82),
    [sym_redirected_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_c_style_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_compound_statement] = STATE(76),
    [sym_subshell] = STATE(76),
    [sym_pipeline] = STATE(76),
    [sym_list] = STATE(76),
    [sym_negated_command] = STATE(76),
    [sym_test_command] = STATE(76),
    [sym_declaration_command] = STATE(76),
    [sym_unset_command] = STATE(76),
    [sym_command] = STATE(76),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(78),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [8] = {
    [sym_concatenation] = STATE(91),
    [sym_string] = STATE(86),
    [sym_simple_expansion] = STATE(86),
    [sym_string_expansion] = STATE(86),
    [sym_expansion] = STATE(86),
    [sym_command_substitution] = STATE(86),
    [sym_process_substitution] = STATE(86),
    [sym__special_characters] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(149),
  },
  [9] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(159),
  },
  [10] = {
    [sym__statements] = STATE(100),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [11] = {
    [sym__statements] = STATE(131),
    [sym_redirected_statement] = STATE(132),
    [sym_for_statement] = STATE(132),
    [sym_c_style_for_statement] = STATE(132),
    [sym_while_statement] = STATE(132),
    [sym_if_statement] = STATE(132),
    [sym_case_statement] = STATE(132),
    [sym_function_definition] = STATE(132),
    [sym_compound_statement] = STATE(132),
    [sym_subshell] = STATE(132),
    [sym_pipeline] = STATE(132),
    [sym_list] = STATE(132),
    [sym_negated_command] = STATE(132),
    [sym_test_command] = STATE(132),
    [sym_declaration_command] = STATE(132),
    [sym_unset_command] = STATE(132),
    [sym_command] = STATE(132),
    [sym_command_name] = STATE(133),
    [sym_variable_assignment] = STATE(134),
    [sym_subscript] = STATE(135),
    [sym_file_redirect] = STATE(138),
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_string_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym__statements_repeat1] = STATE(137),
    [aux_sym_command_repeat1] = STATE(138),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [12] = {
    [sym_subshell] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(35),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(47),
  },
  [13] = {
    [sym__expression] = STATE(152),
    [sym_binary_expression] = STATE(152),
    [sym_unary_expression] = STATE(152),
    [sym_postfix_expression] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_concatenation] = STATE(152),
    [sym_string] = STATE(147),
    [sym_simple_expansion] = STATE(147),
    [sym_string_expansion] = STATE(147),
    [sym_expansion] = STATE(147),
    [sym_command_substitution] = STATE(147),
    [sym_process_substitution] = STATE(147),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_characters] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [14] = {
    [sym__expression] = STATE(156),
    [sym_binary_expression] = STATE(156),
    [sym_unary_expression] = STATE(156),
    [sym_postfix_expression] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_concatenation] = STATE(156),
    [sym_string] = STATE(155),
    [sym_simple_expansion] = STATE(155),
    [sym_string_expansion] = STATE(155),
    [sym_expansion] = STATE(155),
    [sym_command_substitution] = STATE(155),
    [sym_process_substitution] = STATE(155),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [15] = {
    [sym_variable_assignment] = STATE(167),
    [sym_subscript] = STATE(166),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_string_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_declaration_command_repeat1] = STATE(167),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(261),
    [ts_builtin_sym_end] = ACTIONS(259),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(281),
    [sym_word] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [16] = {
    [sym_concatenation] = STATE(176),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_unset_command_repeat1] = STATE(176),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [ts_builtin_sym_end] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(289),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(305),
    [sym_word] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [17] = {
    [sym_concatenation] = STATE(185),
    [sym_string] = STATE(180),
    [sym_simple_expansion] = STATE(180),
    [sym_string_expansion] = STATE(180),
    [sym_expansion] = STATE(180),
    [sym_command_substitution] = STATE(180),
    [sym_process_substitution] = STATE(180),
    [sym__special_characters] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(315),
  },
  [18] = {
    [aux_sym_concatenation_repeat1] = STATE(187),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [19] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(194),
    [anon_sym_DQUOTE] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(333),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [20] = {
    [sym_string] = STATE(196),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(345),
    [sym_raw_string] = ACTIONS(347),
    [anon_sym_POUND] = ACTIONS(345),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(349),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_AT] = ACTIONS(351),
    [anon_sym_QMARK] = ACTIONS(351),
    [anon_sym_0] = ACTIONS(349),
    [anon_sym__] = ACTIONS(349),
  },
  [21] = {
    [aux_sym_concatenation_repeat1] = STATE(187),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [22] = {
    [sym_subscript] = STATE(201),
    [sym_variable_name] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOLLAR] = ACTIONS(361),
    [anon_sym_POUND] = ACTIONS(359),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_AT] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(365),
    [anon_sym_0] = ACTIONS(363),
    [anon_sym__] = ACTIONS(363),
  },
  [23] = {
    [sym__statements] = STATE(204),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(205),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [24] = {
    [sym__statements] = STATE(213),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [25] = {
    [sym__statements] = STATE(220),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [26] = {
    [aux_sym_concatenation_repeat1] = STATE(187),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(389),
    [sym_comment] = ACTIONS(57),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(391),
    [sym_comment] = ACTIONS(57),
  },
  [29] = {
    [sym_file_redirect] = STATE(232),
    [sym_heredoc_redirect] = STATE(232),
    [sym_heredoc_body] = STATE(231),
    [sym_herestring_redirect] = STATE(232),
    [aux_sym_redirected_statement_repeat1] = STATE(232),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [30] = {
    [sym_concatenation] = STATE(236),
    [sym_string] = STATE(235),
    [sym_simple_expansion] = STATE(235),
    [sym_string_expansion] = STATE(235),
    [sym_expansion] = STATE(235),
    [sym_command_substitution] = STATE(235),
    [sym_process_substitution] = STATE(235),
    [aux_sym_command_repeat2] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [ts_builtin_sym_end] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [31] = {
    [sym_file_redirect] = STATE(232),
    [sym_heredoc_redirect] = STATE(232),
    [sym_heredoc_body] = STATE(231),
    [sym_herestring_redirect] = STATE(232),
    [aux_sym_redirected_statement_repeat1] = STATE(232),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [32] = {
    [anon_sym_EQ] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [sym_comment] = ACTIONS(57),
  },
  [33] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [34] = {
    [sym_redirected_statement] = STATE(237),
    [sym_for_statement] = STATE(237),
    [sym_c_style_for_statement] = STATE(237),
    [sym_while_statement] = STATE(237),
    [sym_if_statement] = STATE(237),
    [sym_case_statement] = STATE(237),
    [sym_function_definition] = STATE(237),
    [sym_compound_statement] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_pipeline] = STATE(237),
    [sym_list] = STATE(237),
    [sym_negated_command] = STATE(237),
    [sym_test_command] = STATE(237),
    [sym_declaration_command] = STATE(237),
    [sym_unset_command] = STATE(237),
    [sym_command] = STATE(237),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(238),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(35),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [35] = {
    [sym_command_name] = STATE(240),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(47),
  },
  [36] = {
    [sym_concatenation] = STATE(244),
    [sym_string] = STATE(243),
    [sym_simple_expansion] = STATE(243),
    [sym_string_expansion] = STATE(243),
    [sym_expansion] = STATE(243),
    [sym_command_substitution] = STATE(243),
    [sym_process_substitution] = STATE(243),
    [sym__special_characters] = ACTIONS(439),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(441),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(441),
  },
  [37] = {
    [sym_concatenation] = STATE(247),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [sym__special_characters] = ACTIONS(443),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(445),
  },
  [38] = {
    [sym_concatenation] = STATE(248),
    [sym_string] = STATE(253),
    [sym_array] = STATE(248),
    [sym_simple_expansion] = STATE(253),
    [sym_string_expansion] = STATE(253),
    [sym_expansion] = STATE(253),
    [sym_command_substitution] = STATE(253),
    [sym_process_substitution] = STATE(253),
    [sym__empty_value] = ACTIONS(447),
    [anon_sym_LPAREN] = ACTIONS(449),
    [sym__special_characters] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(455),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(463),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(457),
  },
  [39] = {
    [sym__expression] = STATE(269),
    [sym_binary_expression] = STATE(269),
    [sym_unary_expression] = STATE(269),
    [sym_postfix_expression] = STATE(269),
    [sym_parenthesized_expression] = STATE(269),
    [sym_concatenation] = STATE(269),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(467),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [40] = {
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(499),
  },
  [41] = {
    [sym__expression] = STATE(282),
    [sym_binary_expression] = STATE(282),
    [sym_unary_expression] = STATE(282),
    [sym_postfix_expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(282),
    [sym_concatenation] = STATE(282),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(521),
    [sym_test_operator] = ACTIONS(523),
  },
  [42] = {
    [sym__expression] = STATE(283),
    [sym_binary_expression] = STATE(283),
    [sym_unary_expression] = STATE(283),
    [sym_postfix_expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(283),
    [sym_concatenation] = STATE(283),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [43] = {
    [aux_sym_concatenation_repeat1] = STATE(285),
    [sym__concat] = ACTIONS(525),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(527),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(527),
  },
  [44] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(288),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [45] = {
    [sym_string] = STATE(290),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(535),
    [sym_raw_string] = ACTIONS(537),
    [anon_sym_POUND] = ACTIONS(535),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(541),
    [anon_sym_QMARK] = ACTIONS(541),
    [anon_sym_0] = ACTIONS(539),
    [anon_sym__] = ACTIONS(539),
  },
  [46] = {
    [aux_sym_concatenation_repeat1] = STATE(285),
    [sym__concat] = ACTIONS(525),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(543),
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_EQ_TILDE] = ACTIONS(543),
    [anon_sym_EQ_EQ] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(545),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_DASH_EQ] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(543),
    [anon_sym_PLUS_PLUS] = ACTIONS(543),
    [anon_sym_DASH_DASH] = ACTIONS(543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(543),
  },
  [47] = {
    [sym_subscript] = STATE(295),
    [sym_variable_name] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_POUND] = ACTIONS(549),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(553),
    [anon_sym_STAR] = ACTIONS(555),
    [anon_sym_AT] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_0] = ACTIONS(553),
    [anon_sym__] = ACTIONS(553),
  },
  [48] = {
    [sym__statements] = STATE(296),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(297),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [49] = {
    [sym__statements] = STATE(298),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [50] = {
    [sym__statements] = STATE(299),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [51] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [52] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(567),
    [sym_comment] = ACTIONS(57),
  },
  [53] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(569),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(571),
  },
  [54] = {
    [sym__expression] = STATE(307),
    [sym_binary_expression] = STATE(307),
    [sym_unary_expression] = STATE(307),
    [sym_postfix_expression] = STATE(307),
    [sym_parenthesized_expression] = STATE(307),
    [sym_concatenation] = STATE(307),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [55] = {
    [sym__terminated_statement] = STATE(308),
    [sym_redirected_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_c_style_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_compound_statement] = STATE(76),
    [sym_subshell] = STATE(76),
    [sym_pipeline] = STATE(76),
    [sym_list] = STATE(76),
    [sym_negated_command] = STATE(76),
    [sym_test_command] = STATE(76),
    [sym_declaration_command] = STATE(76),
    [sym_unset_command] = STATE(76),
    [sym_command] = STATE(76),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(78),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [56] = {
    [sym__terminated_statement] = STATE(309),
    [sym_redirected_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_c_style_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_compound_statement] = STATE(76),
    [sym_subshell] = STATE(76),
    [sym_pipeline] = STATE(76),
    [sym_list] = STATE(76),
    [sym_negated_command] = STATE(76),
    [sym_test_command] = STATE(76),
    [sym_declaration_command] = STATE(76),
    [sym_unset_command] = STATE(76),
    [sym_command] = STATE(76),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(78),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [57] = {
    [sym_concatenation] = STATE(312),
    [sym_string] = STATE(311),
    [sym_simple_expansion] = STATE(311),
    [sym_string_expansion] = STATE(311),
    [sym_expansion] = STATE(311),
    [sym_command_substitution] = STATE(311),
    [sym_process_substitution] = STATE(311),
    [sym__special_characters] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(575),
  },
  [58] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(577),
  },
  [59] = {
    [sym__statements] = STATE(314),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [60] = {
    [sym__statements] = STATE(316),
    [sym_redirected_statement] = STATE(132),
    [sym_for_statement] = STATE(132),
    [sym_c_style_for_statement] = STATE(132),
    [sym_while_statement] = STATE(132),
    [sym_if_statement] = STATE(132),
    [sym_case_statement] = STATE(132),
    [sym_function_definition] = STATE(132),
    [sym_compound_statement] = STATE(132),
    [sym_subshell] = STATE(132),
    [sym_pipeline] = STATE(132),
    [sym_list] = STATE(132),
    [sym_negated_command] = STATE(132),
    [sym_test_command] = STATE(132),
    [sym_declaration_command] = STATE(132),
    [sym_unset_command] = STATE(132),
    [sym_command] = STATE(132),
    [sym_command_name] = STATE(133),
    [sym_variable_assignment] = STATE(134),
    [sym_subscript] = STATE(135),
    [sym_file_redirect] = STATE(138),
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_string_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym__statements_repeat1] = STATE(137),
    [aux_sym_command_repeat1] = STATE(138),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [61] = {
    [sym_subshell] = STATE(317),
    [sym_test_command] = STATE(317),
    [sym_command] = STATE(317),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(81),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(131),
  },
  [62] = {
    [sym__expression] = STATE(318),
    [sym_binary_expression] = STATE(318),
    [sym_unary_expression] = STATE(318),
    [sym_postfix_expression] = STATE(318),
    [sym_parenthesized_expression] = STATE(318),
    [sym_concatenation] = STATE(318),
    [sym_string] = STATE(147),
    [sym_simple_expansion] = STATE(147),
    [sym_string_expansion] = STATE(147),
    [sym_expansion] = STATE(147),
    [sym_command_substitution] = STATE(147),
    [sym_process_substitution] = STATE(147),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_characters] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [63] = {
    [sym__expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_postfix_expression] = STATE(319),
    [sym_parenthesized_expression] = STATE(319),
    [sym_concatenation] = STATE(319),
    [sym_string] = STATE(155),
    [sym_simple_expansion] = STATE(155),
    [sym_string_expansion] = STATE(155),
    [sym_expansion] = STATE(155),
    [sym_command_substitution] = STATE(155),
    [sym_process_substitution] = STATE(155),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [64] = {
    [sym_variable_assignment] = STATE(330),
    [sym_subscript] = STATE(329),
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(324),
    [sym_simple_expansion] = STATE(324),
    [sym_string_expansion] = STATE(324),
    [sym_expansion] = STATE(324),
    [sym_command_substitution] = STATE(324),
    [sym_process_substitution] = STATE(324),
    [aux_sym_declaration_command_repeat1] = STATE(330),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(587),
    [sym_raw_string] = ACTIONS(589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(593),
    [anon_sym_BQUOTE] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(597),
    [anon_sym_GT_LPAREN] = ACTIONS(597),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(599),
    [sym_word] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [65] = {
    [sym_concatenation] = STATE(339),
    [sym_string] = STATE(334),
    [sym_simple_expansion] = STATE(334),
    [sym_string_expansion] = STATE(334),
    [sym_expansion] = STATE(334),
    [sym_command_substitution] = STATE(334),
    [sym_process_substitution] = STATE(334),
    [aux_sym_unset_command_repeat1] = STATE(339),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [sym_raw_string] = ACTIONS(609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(611),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(615),
    [anon_sym_LT_LPAREN] = ACTIONS(617),
    [anon_sym_GT_LPAREN] = ACTIONS(617),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(619),
    [sym_word] = ACTIONS(621),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [66] = {
    [aux_sym_concatenation_repeat1] = STATE(341),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [67] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(344),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [68] = {
    [sym_string] = STATE(346),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(629),
    [sym_raw_string] = ACTIONS(631),
    [anon_sym_POUND] = ACTIONS(629),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_0] = ACTIONS(633),
    [anon_sym__] = ACTIONS(633),
  },
  [69] = {
    [aux_sym_concatenation_repeat1] = STATE(341),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [70] = {
    [sym_subscript] = STATE(351),
    [sym_variable_name] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_DASH] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_POUND] = ACTIONS(639),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_0] = ACTIONS(643),
    [anon_sym__] = ACTIONS(643),
  },
  [71] = {
    [sym__statements] = STATE(352),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(353),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [72] = {
    [sym__statements] = STATE(354),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [73] = {
    [sym__statements] = STATE(355),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [74] = {
    [aux_sym_concatenation_repeat1] = STATE(341),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [75] = {
    [sym_do_group] = STATE(358),
    [anon_sym_do] = ACTIONS(649),
    [sym_comment] = ACTIONS(57),
  },
  [76] = {
    [sym_file_redirect] = STATE(366),
    [sym_heredoc_redirect] = STATE(366),
    [sym_herestring_redirect] = STATE(366),
    [aux_sym_redirected_statement_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(651),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(663),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(671),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(653),
  },
  [77] = {
    [sym_concatenation] = STATE(370),
    [sym_string] = STATE(369),
    [sym_simple_expansion] = STATE(369),
    [sym_string_expansion] = STATE(369),
    [sym_expansion] = STATE(369),
    [sym_command_substitution] = STATE(369),
    [sym_process_substitution] = STATE(369),
    [aux_sym_command_repeat2] = STATE(370),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [78] = {
    [sym_file_redirect] = STATE(366),
    [sym_heredoc_redirect] = STATE(366),
    [sym_herestring_redirect] = STATE(366),
    [aux_sym_redirected_statement_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(671),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(653),
  },
  [79] = {
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(567),
    [sym_comment] = ACTIONS(57),
  },
  [80] = {
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [81] = {
    [sym_command_name] = STATE(371),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(681),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(131),
  },
  [82] = {
    [anon_sym_then] = ACTIONS(683),
    [sym_comment] = ACTIONS(57),
  },
  [83] = {
    [aux_sym_concatenation_repeat1] = STATE(376),
    [sym__concat] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(687),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(691),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(691),
    [anon_sym_AMP] = ACTIONS(691),
  },
  [84] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(379),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [85] = {
    [sym_string] = STATE(381),
    [anon_sym_DASH] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(697),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(703),
    [anon_sym_0] = ACTIONS(701),
    [anon_sym__] = ACTIONS(701),
  },
  [86] = {
    [aux_sym_concatenation_repeat1] = STATE(376),
    [sym__concat] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(705),
    [anon_sym_SEMI] = ACTIONS(707),
    [anon_sym_SEMI_SEMI] = ACTIONS(709),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
  },
  [87] = {
    [sym_subscript] = STATE(388),
    [sym_variable_name] = ACTIONS(711),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DOLLAR] = ACTIONS(715),
    [anon_sym_POUND] = ACTIONS(713),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(717),
    [anon_sym_STAR] = ACTIONS(719),
    [anon_sym_AT] = ACTIONS(719),
    [anon_sym_QMARK] = ACTIONS(719),
    [anon_sym_0] = ACTIONS(717),
    [anon_sym__] = ACTIONS(717),
  },
  [88] = {
    [sym__statements] = STATE(389),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(390),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [89] = {
    [sym__statements] = STATE(391),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [90] = {
    [sym__statements] = STATE(392),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [91] = {
    [anon_sym_in] = ACTIONS(705),
    [anon_sym_SEMI] = ACTIONS(707),
    [anon_sym_SEMI_SEMI] = ACTIONS(709),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
  },
  [92] = {
    [sym_compound_statement] = STATE(394),
    [anon_sym_LPAREN] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [93] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(723),
    [sym_comment] = ACTIONS(57),
  },
  [94] = {
    [sym_subshell] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(106),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(171),
  },
  [95] = {
    [sym_variable_assignment] = STATE(400),
    [sym_subscript] = STATE(399),
    [sym_concatenation] = STATE(400),
    [sym_string] = STATE(398),
    [sym_simple_expansion] = STATE(398),
    [sym_string_expansion] = STATE(398),
    [sym_expansion] = STATE(398),
    [sym_command_substitution] = STATE(398),
    [sym_process_substitution] = STATE(398),
    [aux_sym_declaration_command_repeat1] = STATE(400),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(731),
    [sym_word] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [96] = {
    [sym_concatenation] = STATE(403),
    [sym_string] = STATE(402),
    [sym_simple_expansion] = STATE(402),
    [sym_string_expansion] = STATE(402),
    [sym_expansion] = STATE(402),
    [sym_command_substitution] = STATE(402),
    [sym_process_substitution] = STATE(402),
    [aux_sym_unset_command_repeat1] = STATE(403),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_RPAREN] = ACTIONS(285),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(739),
    [sym_word] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [97] = {
    [aux_sym_concatenation_repeat1] = STATE(404),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [98] = {
    [aux_sym_concatenation_repeat1] = STATE(404),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [99] = {
    [aux_sym_concatenation_repeat1] = STATE(404),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [100] = {
    [anon_sym_RPAREN] = ACTIONS(743),
    [sym_comment] = ACTIONS(57),
  },
  [101] = {
    [sym_file_redirect] = STATE(411),
    [sym_heredoc_redirect] = STATE(411),
    [sym_heredoc_body] = STATE(231),
    [sym_herestring_redirect] = STATE(411),
    [aux_sym_redirected_statement_repeat1] = STATE(411),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_GT_GT] = ACTIONS(755),
    [anon_sym_AMP_GT] = ACTIONS(753),
    [anon_sym_AMP_GT_GT] = ACTIONS(755),
    [anon_sym_LT_AMP] = ACTIONS(755),
    [anon_sym_GT_AMP] = ACTIONS(755),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(757),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [102] = {
    [sym_concatenation] = STATE(415),
    [sym_string] = STATE(414),
    [sym_simple_expansion] = STATE(414),
    [sym_string_expansion] = STATE(414),
    [sym_expansion] = STATE(414),
    [sym_command_substitution] = STATE(414),
    [sym_process_substitution] = STATE(414),
    [aux_sym_command_repeat2] = STATE(415),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(761),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [103] = {
    [sym_file_redirect] = STATE(411),
    [sym_heredoc_redirect] = STATE(411),
    [sym_heredoc_body] = STATE(231),
    [sym_herestring_redirect] = STATE(411),
    [aux_sym_redirected_statement_repeat1] = STATE(411),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(757),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [104] = {
    [anon_sym_EQ] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(723),
    [sym_comment] = ACTIONS(57),
  },
  [105] = {
    [sym_redirected_statement] = STATE(416),
    [sym_for_statement] = STATE(416),
    [sym_c_style_for_statement] = STATE(416),
    [sym_while_statement] = STATE(416),
    [sym_if_statement] = STATE(416),
    [sym_case_statement] = STATE(416),
    [sym_function_definition] = STATE(416),
    [sym_compound_statement] = STATE(416),
    [sym_subshell] = STATE(416),
    [sym_pipeline] = STATE(416),
    [sym_list] = STATE(416),
    [sym_negated_command] = STATE(416),
    [sym_test_command] = STATE(416),
    [sym_declaration_command] = STATE(416),
    [sym_unset_command] = STATE(416),
    [sym_command] = STATE(416),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(417),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [106] = {
    [sym_command_name] = STATE(418),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(767),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(171),
  },
  [107] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_PLUS_EQ] = ACTIONS(769),
    [sym_comment] = ACTIONS(57),
  },
  [108] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(771),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(773),
  },
  [109] = {
    [sym__expression] = STATE(422),
    [sym_binary_expression] = STATE(422),
    [sym_unary_expression] = STATE(422),
    [sym_postfix_expression] = STATE(422),
    [sym_parenthesized_expression] = STATE(422),
    [sym_concatenation] = STATE(422),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [110] = {
    [sym__terminated_statement] = STATE(423),
    [sym_redirected_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_c_style_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_compound_statement] = STATE(76),
    [sym_subshell] = STATE(76),
    [sym_pipeline] = STATE(76),
    [sym_list] = STATE(76),
    [sym_negated_command] = STATE(76),
    [sym_test_command] = STATE(76),
    [sym_declaration_command] = STATE(76),
    [sym_unset_command] = STATE(76),
    [sym_command] = STATE(76),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(78),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [111] = {
    [sym__terminated_statement] = STATE(424),
    [sym_redirected_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_c_style_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_compound_statement] = STATE(76),
    [sym_subshell] = STATE(76),
    [sym_pipeline] = STATE(76),
    [sym_list] = STATE(76),
    [sym_negated_command] = STATE(76),
    [sym_test_command] = STATE(76),
    [sym_declaration_command] = STATE(76),
    [sym_unset_command] = STATE(76),
    [sym_command] = STATE(76),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(78),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [112] = {
    [sym_concatenation] = STATE(427),
    [sym_string] = STATE(426),
    [sym_simple_expansion] = STATE(426),
    [sym_string_expansion] = STATE(426),
    [sym_expansion] = STATE(426),
    [sym_command_substitution] = STATE(426),
    [sym_process_substitution] = STATE(426),
    [sym__special_characters] = ACTIONS(775),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(777),
  },
  [113] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(779),
  },
  [114] = {
    [sym__statements] = STATE(429),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [115] = {
    [sym__statements] = STATE(431),
    [sym_redirected_statement] = STATE(132),
    [sym_for_statement] = STATE(132),
    [sym_c_style_for_statement] = STATE(132),
    [sym_while_statement] = STATE(132),
    [sym_if_statement] = STATE(132),
    [sym_case_statement] = STATE(132),
    [sym_function_definition] = STATE(132),
    [sym_compound_statement] = STATE(132),
    [sym_subshell] = STATE(132),
    [sym_pipeline] = STATE(132),
    [sym_list] = STATE(132),
    [sym_negated_command] = STATE(132),
    [sym_test_command] = STATE(132),
    [sym_declaration_command] = STATE(132),
    [sym_unset_command] = STATE(132),
    [sym_command] = STATE(132),
    [sym_command_name] = STATE(133),
    [sym_variable_assignment] = STATE(134),
    [sym_subscript] = STATE(135),
    [sym_file_redirect] = STATE(138),
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_string_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym__statements_repeat1] = STATE(137),
    [aux_sym_command_repeat1] = STATE(138),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [116] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [ts_builtin_sym_end] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_done] = ACTIONS(783),
    [anon_sym_fi] = ACTIONS(783),
    [anon_sym_elif] = ACTIONS(783),
    [anon_sym_else] = ACTIONS(783),
    [anon_sym_esac] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [117] = {
    [sym_subshell] = STATE(432),
    [sym_test_command] = STATE(432),
    [sym_command] = STATE(432),
    [sym_command_name] = STATE(133),
    [sym_variable_assignment] = STATE(138),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(138),
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_string_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(138),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(211),
  },
  [118] = {
    [sym__expression] = STATE(433),
    [sym_binary_expression] = STATE(433),
    [sym_unary_expression] = STATE(433),
    [sym_postfix_expression] = STATE(433),
    [sym_parenthesized_expression] = STATE(433),
    [sym_concatenation] = STATE(433),
    [sym_string] = STATE(147),
    [sym_simple_expansion] = STATE(147),
    [sym_string_expansion] = STATE(147),
    [sym_expansion] = STATE(147),
    [sym_command_substitution] = STATE(147),
    [sym_process_substitution] = STATE(147),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_characters] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [119] = {
    [sym__expression] = STATE(434),
    [sym_binary_expression] = STATE(434),
    [sym_unary_expression] = STATE(434),
    [sym_postfix_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenation] = STATE(434),
    [sym_string] = STATE(155),
    [sym_simple_expansion] = STATE(155),
    [sym_string_expansion] = STATE(155),
    [sym_expansion] = STATE(155),
    [sym_command_substitution] = STATE(155),
    [sym_process_substitution] = STATE(155),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [120] = {
    [sym_variable_assignment] = STATE(445),
    [sym_subscript] = STATE(444),
    [sym_concatenation] = STATE(445),
    [sym_string] = STATE(439),
    [sym_simple_expansion] = STATE(439),
    [sym_string_expansion] = STATE(439),
    [sym_expansion] = STATE(439),
    [sym_command_substitution] = STATE(439),
    [sym_process_substitution] = STATE(439),
    [aux_sym_declaration_command_repeat1] = STATE(445),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(805),
    [sym_word] = ACTIONS(807),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [121] = {
    [sym_concatenation] = STATE(454),
    [sym_string] = STATE(449),
    [sym_simple_expansion] = STATE(449),
    [sym_string_expansion] = STATE(449),
    [sym_expansion] = STATE(449),
    [sym_command_substitution] = STATE(449),
    [sym_process_substitution] = STATE(449),
    [aux_sym_unset_command_repeat1] = STATE(454),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_RBRACE] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(825),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [122] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [123] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(459),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(833),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [124] = {
    [sym_string] = STATE(461),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(835),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_0] = ACTIONS(839),
    [anon_sym__] = ACTIONS(839),
  },
  [125] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [126] = {
    [sym_subscript] = STATE(466),
    [sym_variable_name] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_POUND] = ACTIONS(845),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_0] = ACTIONS(849),
    [anon_sym__] = ACTIONS(849),
  },
  [127] = {
    [sym__statements] = STATE(467),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(468),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [128] = {
    [sym__statements] = STATE(469),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [129] = {
    [sym__statements] = STATE(470),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [130] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [131] = {
    [anon_sym_RBRACE] = ACTIONS(855),
    [sym_comment] = ACTIONS(57),
  },
  [132] = {
    [sym_file_redirect] = STATE(483),
    [sym_heredoc_redirect] = STATE(483),
    [sym_heredoc_body] = STATE(482),
    [sym_herestring_redirect] = STATE(483),
    [aux_sym_redirected_statement_repeat1] = STATE(483),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(867),
    [anon_sym_AMP] = ACTIONS(863),
  },
  [133] = {
    [sym_concatenation] = STATE(487),
    [sym_string] = STATE(486),
    [sym_simple_expansion] = STATE(486),
    [sym_string_expansion] = STATE(486),
    [sym_expansion] = STATE(486),
    [sym_command_substitution] = STATE(486),
    [sym_process_substitution] = STATE(486),
    [aux_sym_command_repeat2] = STATE(487),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(885),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [134] = {
    [sym_file_redirect] = STATE(483),
    [sym_heredoc_redirect] = STATE(483),
    [sym_heredoc_body] = STATE(482),
    [sym_herestring_redirect] = STATE(483),
    [aux_sym_redirected_statement_repeat1] = STATE(483),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym__special_characters] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(867),
    [anon_sym_AMP] = ACTIONS(863),
  },
  [135] = {
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_PLUS_EQ] = ACTIONS(769),
    [sym_comment] = ACTIONS(57),
  },
  [136] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [137] = {
    [sym_redirected_statement] = STATE(488),
    [sym_for_statement] = STATE(488),
    [sym_c_style_for_statement] = STATE(488),
    [sym_while_statement] = STATE(488),
    [sym_if_statement] = STATE(488),
    [sym_case_statement] = STATE(488),
    [sym_function_definition] = STATE(488),
    [sym_compound_statement] = STATE(488),
    [sym_subshell] = STATE(488),
    [sym_pipeline] = STATE(488),
    [sym_list] = STATE(488),
    [sym_negated_command] = STATE(488),
    [sym_test_command] = STATE(488),
    [sym_declaration_command] = STATE(488),
    [sym_unset_command] = STATE(488),
    [sym_command] = STATE(488),
    [sym_command_name] = STATE(133),
    [sym_variable_assignment] = STATE(489),
    [sym_subscript] = STATE(135),
    [sym_file_redirect] = STATE(138),
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_string_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(138),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [138] = {
    [sym_command_name] = STATE(490),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_string_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(211),
  },
  [139] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [sym_comment] = ACTIONS(57),
  },
  [140] = {
    [sym__simple_heredoc_body] = ACTIONS(895),
    [sym__heredoc_body_beginning] = ACTIONS(895),
    [sym_file_descriptor] = ACTIONS(895),
    [ts_builtin_sym_end] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_done] = ACTIONS(895),
    [anon_sym_fi] = ACTIONS(895),
    [anon_sym_elif] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(895),
    [anon_sym_esac] = ACTIONS(895),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [141] = {
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [sym_comment] = ACTIONS(57),
  },
  [142] = {
    [sym__expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_unary_expression] = STATE(492),
    [sym_postfix_expression] = STATE(492),
    [sym_parenthesized_expression] = STATE(492),
    [sym_concatenation] = STATE(492),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(521),
    [sym_test_operator] = ACTIONS(523),
  },
  [143] = {
    [sym__expression] = STATE(493),
    [sym_binary_expression] = STATE(493),
    [sym_unary_expression] = STATE(493),
    [sym_postfix_expression] = STATE(493),
    [sym_parenthesized_expression] = STATE(493),
    [sym_concatenation] = STATE(493),
    [sym_string] = STATE(147),
    [sym_simple_expansion] = STATE(147),
    [sym_string_expansion] = STATE(147),
    [sym_expansion] = STATE(147),
    [sym_command_substitution] = STATE(147),
    [sym_process_substitution] = STATE(147),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_characters] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [144] = {
    [aux_sym_concatenation_repeat1] = STATE(495),
    [sym__concat] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_RBRACK] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(527),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(527),
  },
  [145] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(498),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(903),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [146] = {
    [sym_string] = STATE(500),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(907),
    [anon_sym_POUND] = ACTIONS(905),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_0] = ACTIONS(909),
    [anon_sym__] = ACTIONS(909),
  },
  [147] = {
    [aux_sym_concatenation_repeat1] = STATE(495),
    [sym__concat] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(543),
    [anon_sym_EQ_TILDE] = ACTIONS(543),
    [anon_sym_EQ_EQ] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(545),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_DASH_EQ] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(543),
    [anon_sym_PLUS_PLUS] = ACTIONS(543),
    [anon_sym_DASH_DASH] = ACTIONS(543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(543),
  },
  [148] = {
    [sym_subscript] = STATE(505),
    [sym_variable_name] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_DOLLAR] = ACTIONS(917),
    [anon_sym_POUND] = ACTIONS(915),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(921),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_0] = ACTIONS(919),
    [anon_sym__] = ACTIONS(919),
  },
  [149] = {
    [sym__statements] = STATE(506),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(507),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [150] = {
    [sym__statements] = STATE(508),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [151] = {
    [sym__statements] = STATE(509),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [152] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [153] = {
    [sym__expression] = STATE(513),
    [sym_binary_expression] = STATE(513),
    [sym_unary_expression] = STATE(513),
    [sym_postfix_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_concatenation] = STATE(513),
    [sym_string] = STATE(155),
    [sym_simple_expansion] = STATE(155),
    [sym_string_expansion] = STATE(155),
    [sym_expansion] = STATE(155),
    [sym_command_substitution] = STATE(155),
    [sym_process_substitution] = STATE(155),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [154] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__concat] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(527),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(527),
  },
  [155] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__concat] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(543),
    [anon_sym_EQ_TILDE] = ACTIONS(543),
    [anon_sym_EQ_EQ] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(545),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_DASH_EQ] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(543),
    [anon_sym_PLUS_PLUS] = ACTIONS(543),
    [anon_sym_DASH_DASH] = ACTIONS(543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(543),
  },
  [156] = {
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_EQ] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_BANG_EQ] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(931),
    [anon_sym_GT_EQ] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(931),
  },
  [157] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [sym_comment] = ACTIONS(57),
  },
  [158] = {
    [aux_sym_concatenation_repeat1] = STATE(519),
    [sym__simple_heredoc_body] = ACTIONS(939),
    [sym__heredoc_body_beginning] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [159] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(522),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_DOLLAR] = ACTIONS(947),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [160] = {
    [sym_string] = STATE(524),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(949),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_POUND] = ACTIONS(949),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(955),
    [anon_sym_QMARK] = ACTIONS(955),
    [anon_sym_0] = ACTIONS(953),
    [anon_sym__] = ACTIONS(953),
  },
  [161] = {
    [aux_sym_concatenation_repeat1] = STATE(519),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(957),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [162] = {
    [sym_subscript] = STATE(529),
    [sym_variable_name] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(965),
    [anon_sym_POUND] = ACTIONS(963),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(967),
    [anon_sym_STAR] = ACTIONS(969),
    [anon_sym_AT] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_0] = ACTIONS(967),
    [anon_sym__] = ACTIONS(967),
  },
  [163] = {
    [sym__statements] = STATE(530),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(531),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [164] = {
    [sym__statements] = STATE(532),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [165] = {
    [sym__statements] = STATE(533),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [166] = {
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [sym_comment] = ACTIONS(57),
  },
  [167] = {
    [sym_variable_assignment] = STATE(534),
    [sym_subscript] = STATE(166),
    [sym_concatenation] = STATE(534),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_string_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_declaration_command_repeat1] = STATE(534),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(261),
    [ts_builtin_sym_end] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(975),
    [sym_word] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [168] = {
    [aux_sym_concatenation_repeat1] = STATE(536),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(979),
    [ts_builtin_sym_end] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [169] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(539),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_DOLLAR] = ACTIONS(985),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [170] = {
    [sym_string] = STATE(541),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(987),
    [sym_raw_string] = ACTIONS(989),
    [anon_sym_POUND] = ACTIONS(987),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_0] = ACTIONS(991),
    [anon_sym__] = ACTIONS(991),
  },
  [171] = {
    [aux_sym_concatenation_repeat1] = STATE(536),
    [sym__simple_heredoc_body] = ACTIONS(995),
    [sym__heredoc_body_beginning] = ACTIONS(995),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(979),
    [ts_builtin_sym_end] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [172] = {
    [sym_subscript] = STATE(546),
    [sym_variable_name] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_POUND] = ACTIONS(1001),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_0] = ACTIONS(1005),
    [anon_sym__] = ACTIONS(1005),
  },
  [173] = {
    [sym__statements] = STATE(547),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(548),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [174] = {
    [sym__statements] = STATE(549),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [175] = {
    [sym__statements] = STATE(550),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [176] = {
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_unset_command_repeat1] = STATE(551),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [ts_builtin_sym_end] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(289),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1013),
    [sym_word] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [177] = {
    [aux_sym_concatenation_repeat1] = STATE(553),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [sym__special_characters] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1015),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1015),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [anon_sym_LT_LPAREN] = ACTIONS(1015),
    [anon_sym_GT_LPAREN] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1015),
  },
  [178] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(556),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [179] = {
    [sym_string] = STATE(558),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [sym_raw_string] = ACTIONS(1027),
    [anon_sym_POUND] = ACTIONS(1025),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1031),
    [anon_sym_0] = ACTIONS(1029),
    [anon_sym__] = ACTIONS(1029),
  },
  [180] = {
    [aux_sym_concatenation_repeat1] = STATE(553),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [sym__special_characters] = ACTIONS(1033),
    [anon_sym_DQUOTE] = ACTIONS(1033),
    [anon_sym_DOLLAR] = ACTIONS(1035),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1033),
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [anon_sym_LT_LPAREN] = ACTIONS(1033),
    [anon_sym_GT_LPAREN] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1033),
  },
  [181] = {
    [sym_subscript] = STATE(563),
    [sym_variable_name] = ACTIONS(1037),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1041),
    [anon_sym_POUND] = ACTIONS(1039),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1043),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(1045),
    [anon_sym_0] = ACTIONS(1043),
    [anon_sym__] = ACTIONS(1043),
  },
  [182] = {
    [sym__statements] = STATE(564),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(565),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [183] = {
    [sym__statements] = STATE(566),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [184] = {
    [sym__statements] = STATE(567),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [185] = {
    [sym_file_descriptor] = ACTIONS(1033),
    [sym_variable_name] = ACTIONS(1033),
    [anon_sym_RPAREN] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [sym__special_characters] = ACTIONS(1033),
    [anon_sym_DQUOTE] = ACTIONS(1033),
    [anon_sym_DOLLAR] = ACTIONS(1035),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1033),
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [anon_sym_LT_LPAREN] = ACTIONS(1033),
    [anon_sym_GT_LPAREN] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1033),
  },
  [186] = {
    [sym_string] = STATE(568),
    [sym_simple_expansion] = STATE(568),
    [sym_string_expansion] = STATE(568),
    [sym_expansion] = STATE(568),
    [sym_command_substitution] = STATE(568),
    [sym_process_substitution] = STATE(568),
    [sym__special_characters] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1047),
  },
  [187] = {
    [aux_sym_concatenation_repeat1] = STATE(569),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [188] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1055),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [189] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [190] = {
    [sym__concat] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(343),
  },
  [191] = {
    [sym_subscript] = STATE(578),
    [sym_variable_name] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1083),
    [anon_sym_0] = ACTIONS(1081),
    [anon_sym__] = ACTIONS(1081),
  },
  [192] = {
    [sym__statements] = STATE(579),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(580),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [193] = {
    [sym__statements] = STATE(581),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [194] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1085),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [195] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [ts_builtin_sym_end] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [196] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [ts_builtin_sym_end] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [197] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [198] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
  },
  [199] = {
    [sym_subscript] = STATE(588),
    [sym_variable_name] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_0] = ACTIONS(1107),
    [anon_sym__] = ACTIONS(1107),
  },
  [200] = {
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(599),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_COLON_QMARK] = ACTIONS(1113),
    [anon_sym_COLON_DASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [201] = {
    [sym_concatenation] = STATE(602),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(602),
    [anon_sym_RBRACE] = ACTIONS(1137),
    [anon_sym_EQ] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_COLON] = ACTIONS(1139),
    [anon_sym_COLON_QMARK] = ACTIONS(1139),
    [anon_sym_COLON_DASH] = ACTIONS(1139),
    [anon_sym_PERCENT] = ACTIONS(1139),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [202] = {
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_AMP_GT] = ACTIONS(1145),
    [anon_sym_AMP_GT_GT] = ACTIONS(1147),
    [anon_sym_LT_AMP] = ACTIONS(1147),
    [anon_sym_GT_AMP] = ACTIONS(1147),
    [sym_comment] = ACTIONS(57),
  },
  [203] = {
    [sym_concatenation] = STATE(185),
    [sym_string] = STATE(605),
    [sym_simple_expansion] = STATE(605),
    [sym_string_expansion] = STATE(605),
    [sym_expansion] = STATE(605),
    [sym_command_substitution] = STATE(605),
    [sym_process_substitution] = STATE(605),
    [sym__special_characters] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(1151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1151),
  },
  [204] = {
    [anon_sym_RPAREN] = ACTIONS(1153),
    [sym_comment] = ACTIONS(57),
  },
  [205] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [206] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1155),
    [anon_sym_PLUS_EQ] = ACTIONS(1155),
    [sym_comment] = ACTIONS(57),
  },
  [207] = {
    [sym_subshell] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(219),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [208] = {
    [sym_variable_assignment] = STATE(612),
    [sym_subscript] = STATE(611),
    [sym_concatenation] = STATE(612),
    [sym_string] = STATE(610),
    [sym_simple_expansion] = STATE(610),
    [sym_string_expansion] = STATE(610),
    [sym_expansion] = STATE(610),
    [sym_command_substitution] = STATE(610),
    [sym_process_substitution] = STATE(610),
    [aux_sym_declaration_command_repeat1] = STATE(612),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1163),
    [sym_word] = ACTIONS(1165),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [209] = {
    [sym_concatenation] = STATE(615),
    [sym_string] = STATE(614),
    [sym_simple_expansion] = STATE(614),
    [sym_string_expansion] = STATE(614),
    [sym_expansion] = STATE(614),
    [sym_command_substitution] = STATE(614),
    [sym_process_substitution] = STATE(614),
    [aux_sym_unset_command_repeat1] = STATE(615),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1171),
    [sym_word] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [210] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [211] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [212] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [213] = {
    [anon_sym_BQUOTE] = ACTIONS(1153),
    [sym_comment] = ACTIONS(57),
  },
  [214] = {
    [sym_file_redirect] = STATE(624),
    [sym_heredoc_redirect] = STATE(624),
    [sym_heredoc_body] = STATE(623),
    [sym_herestring_redirect] = STATE(624),
    [aux_sym_redirected_statement_repeat1] = STATE(624),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_SEMI_SEMI] = ACTIONS(1181),
    [anon_sym_PIPE_AMP] = ACTIONS(1183),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1189),
    [anon_sym_LT_AMP] = ACTIONS(1189),
    [anon_sym_GT_AMP] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1191),
    [anon_sym_BQUOTE] = ACTIONS(399),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1177),
  },
  [215] = {
    [sym_concatenation] = STATE(628),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(628),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(421),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [216] = {
    [sym_file_redirect] = STATE(624),
    [sym_heredoc_redirect] = STATE(624),
    [sym_heredoc_body] = STATE(623),
    [sym_herestring_redirect] = STATE(624),
    [aux_sym_redirected_statement_repeat1] = STATE(624),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_SEMI_SEMI] = ACTIONS(1181),
    [anon_sym_PIPE_AMP] = ACTIONS(1183),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1191),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(399),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1177),
  },
  [217] = {
    [anon_sym_EQ] = ACTIONS(1155),
    [anon_sym_PLUS_EQ] = ACTIONS(1155),
    [sym_comment] = ACTIONS(57),
  },
  [218] = {
    [sym_redirected_statement] = STATE(629),
    [sym_for_statement] = STATE(629),
    [sym_c_style_for_statement] = STATE(629),
    [sym_while_statement] = STATE(629),
    [sym_if_statement] = STATE(629),
    [sym_case_statement] = STATE(629),
    [sym_function_definition] = STATE(629),
    [sym_compound_statement] = STATE(629),
    [sym_subshell] = STATE(629),
    [sym_pipeline] = STATE(629),
    [sym_list] = STATE(629),
    [sym_negated_command] = STATE(629),
    [sym_test_command] = STATE(629),
    [sym_declaration_command] = STATE(629),
    [sym_unset_command] = STATE(629),
    [sym_command] = STATE(629),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(630),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [219] = {
    [sym_command_name] = STATE(631),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [220] = {
    [anon_sym_RPAREN] = ACTIONS(1203),
    [sym_comment] = ACTIONS(57),
  },
  [221] = {
    [anon_sym_RPAREN] = ACTIONS(1205),
    [sym_comment] = ACTIONS(57),
  },
  [222] = {
    [ts_builtin_sym_end] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_done] = ACTIONS(1207),
    [anon_sym_fi] = ACTIONS(1207),
    [anon_sym_elif] = ACTIONS(1207),
    [anon_sym_else] = ACTIONS(1207),
    [anon_sym_esac] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_SEMI_SEMI] = ACTIONS(1207),
    [anon_sym_BQUOTE] = ACTIONS(1207),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
  },
  [223] = {
    [sym_simple_expansion] = STATE(639),
    [sym_expansion] = STATE(639),
    [sym_command_substitution] = STATE(639),
    [aux_sym_heredoc_body_repeat1] = STATE(639),
    [sym__heredoc_body_middle] = ACTIONS(1211),
    [sym__heredoc_body_end] = ACTIONS(1213),
    [anon_sym_DOLLAR] = ACTIONS(1215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1219),
    [anon_sym_BQUOTE] = ACTIONS(1221),
    [sym_comment] = ACTIONS(57),
  },
  [224] = {
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_AMP_GT] = ACTIONS(1223),
    [anon_sym_AMP_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_AMP] = ACTIONS(1225),
    [anon_sym_GT_AMP] = ACTIONS(1225),
    [sym_comment] = ACTIONS(57),
  },
  [225] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [ts_builtin_sym_end] = ACTIONS(1229),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_SEMI_SEMI] = ACTIONS(1229),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [226] = {
    [sym_redirected_statement] = STATE(641),
    [sym_for_statement] = STATE(641),
    [sym_c_style_for_statement] = STATE(641),
    [sym_while_statement] = STATE(641),
    [sym_if_statement] = STATE(641),
    [sym_case_statement] = STATE(641),
    [sym_function_definition] = STATE(641),
    [sym_compound_statement] = STATE(641),
    [sym_subshell] = STATE(641),
    [sym_pipeline] = STATE(641),
    [sym_list] = STATE(641),
    [sym_negated_command] = STATE(641),
    [sym_test_command] = STATE(641),
    [sym_declaration_command] = STATE(641),
    [sym_unset_command] = STATE(641),
    [sym_command] = STATE(641),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(642),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [227] = {
    [sym_redirected_statement] = STATE(643),
    [sym_for_statement] = STATE(643),
    [sym_c_style_for_statement] = STATE(643),
    [sym_while_statement] = STATE(643),
    [sym_if_statement] = STATE(643),
    [sym_case_statement] = STATE(643),
    [sym_function_definition] = STATE(643),
    [sym_compound_statement] = STATE(643),
    [sym_subshell] = STATE(643),
    [sym_pipeline] = STATE(643),
    [sym_list] = STATE(643),
    [sym_negated_command] = STATE(643),
    [sym_test_command] = STATE(643),
    [sym_declaration_command] = STATE(643),
    [sym_unset_command] = STATE(643),
    [sym_command] = STATE(643),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(644),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [228] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(646),
    [sym_simple_expansion] = STATE(646),
    [sym_string_expansion] = STATE(646),
    [sym_expansion] = STATE(646),
    [sym_command_substitution] = STATE(646),
    [sym_process_substitution] = STATE(646),
    [sym__special_characters] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1235),
  },
  [229] = {
    [sym_heredoc_start] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
  },
  [230] = {
    [sym_concatenation] = STATE(651),
    [sym_string] = STATE(650),
    [sym_simple_expansion] = STATE(650),
    [sym_string_expansion] = STATE(650),
    [sym_expansion] = STATE(650),
    [sym_command_substitution] = STATE(650),
    [sym_process_substitution] = STATE(650),
    [sym__special_characters] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1241),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(1229),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_SEMI_SEMI] = ACTIONS(1245),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1245),
    [anon_sym_AMP] = ACTIONS(1245),
  },
  [232] = {
    [sym_file_redirect] = STATE(653),
    [sym_heredoc_redirect] = STATE(653),
    [sym_herestring_redirect] = STATE(653),
    [aux_sym_redirected_statement_repeat1] = STATE(653),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(1247),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [233] = {
    [sym_concatenation] = STATE(654),
    [sym_string] = STATE(656),
    [sym_simple_expansion] = STATE(656),
    [sym_string_expansion] = STATE(656),
    [sym_expansion] = STATE(656),
    [sym_command_substitution] = STATE(656),
    [sym_process_substitution] = STATE(656),
    [sym_regex] = ACTIONS(1251),
    [sym__special_characters] = ACTIONS(1253),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1255),
  },
  [234] = {
    [aux_sym_concatenation_repeat1] = STATE(187),
    [sym__simple_heredoc_body] = ACTIONS(1257),
    [sym__heredoc_body_beginning] = ACTIONS(1257),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [235] = {
    [aux_sym_concatenation_repeat1] = STATE(187),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [236] = {
    [sym_concatenation] = STATE(657),
    [sym_string] = STATE(235),
    [sym_simple_expansion] = STATE(235),
    [sym_string_expansion] = STATE(235),
    [sym_expansion] = STATE(235),
    [sym_command_substitution] = STATE(235),
    [sym_process_substitution] = STATE(235),
    [aux_sym_command_repeat2] = STATE(657),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [ts_builtin_sym_end] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [237] = {
    [sym_file_redirect] = STATE(232),
    [sym_heredoc_redirect] = STATE(232),
    [sym_heredoc_body] = STATE(659),
    [sym_herestring_redirect] = STATE(232),
    [aux_sym_redirected_statement_repeat1] = STATE(232),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(1229),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [238] = {
    [sym_file_redirect] = STATE(232),
    [sym_heredoc_redirect] = STATE(232),
    [sym_heredoc_body] = STATE(659),
    [sym_herestring_redirect] = STATE(232),
    [aux_sym_redirected_statement_repeat1] = STATE(232),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(1229),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [239] = {
    [sym_redirected_statement] = STATE(663),
    [sym_for_statement] = STATE(663),
    [sym_c_style_for_statement] = STATE(663),
    [sym_while_statement] = STATE(663),
    [sym_if_statement] = STATE(663),
    [sym_case_statement] = STATE(663),
    [sym_function_definition] = STATE(663),
    [sym_compound_statement] = STATE(663),
    [sym_subshell] = STATE(663),
    [sym_pipeline] = STATE(663),
    [sym_list] = STATE(663),
    [sym_negated_command] = STATE(663),
    [sym_test_command] = STATE(663),
    [sym_declaration_command] = STATE(663),
    [sym_unset_command] = STATE(663),
    [sym_command] = STATE(663),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(665),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(1273),
    [sym_variable_name] = ACTIONS(1276),
    [anon_sym_for] = ACTIONS(1279),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1282),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1288),
    [anon_sym_case] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1294),
    [anon_sym_LPAREN] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1309),
    [anon_sym_declare] = ACTIONS(1312),
    [anon_sym_typeset] = ACTIONS(1312),
    [anon_sym_export] = ACTIONS(1312),
    [anon_sym_readonly] = ACTIONS(1312),
    [anon_sym_local] = ACTIONS(1312),
    [anon_sym_unset] = ACTIONS(1315),
    [anon_sym_unsetenv] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1321),
    [anon_sym_AMP_GT] = ACTIONS(1318),
    [anon_sym_AMP_GT_GT] = ACTIONS(1321),
    [anon_sym_LT_AMP] = ACTIONS(1321),
    [anon_sym_GT_AMP] = ACTIONS(1321),
    [sym__special_characters] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1330),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(1342),
    [anon_sym_LT_LPAREN] = ACTIONS(1345),
    [anon_sym_GT_LPAREN] = ACTIONS(1345),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1348),
  },
  [240] = {
    [sym_concatenation] = STATE(667),
    [sym_string] = STATE(235),
    [sym_simple_expansion] = STATE(235),
    [sym_string_expansion] = STATE(235),
    [sym_expansion] = STATE(235),
    [sym_command_substitution] = STATE(235),
    [sym_process_substitution] = STATE(235),
    [aux_sym_command_repeat2] = STATE(667),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [ts_builtin_sym_end] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [241] = {
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(1351),
    [sym_variable_name] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_GT] = ACTIONS(1360),
    [anon_sym_AMP_GT] = ACTIONS(1357),
    [anon_sym_AMP_GT_GT] = ACTIONS(1360),
    [anon_sym_LT_AMP] = ACTIONS(1360),
    [anon_sym_GT_AMP] = ACTIONS(1360),
    [sym__special_characters] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [anon_sym_DOLLAR] = ACTIONS(1365),
    [sym_raw_string] = ACTIONS(1363),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1363),
    [anon_sym_BQUOTE] = ACTIONS(1363),
    [anon_sym_LT_LPAREN] = ACTIONS(1363),
    [anon_sym_GT_LPAREN] = ACTIONS(1363),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1363),
  },
  [242] = {
    [aux_sym_concatenation_repeat1] = STATE(553),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [sym__special_characters] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_DOLLAR] = ACTIONS(1369),
    [sym_raw_string] = ACTIONS(1367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [anon_sym_LT_LPAREN] = ACTIONS(1367),
    [anon_sym_GT_LPAREN] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1367),
  },
  [243] = {
    [aux_sym_concatenation_repeat1] = STATE(553),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [sym__special_characters] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1371),
  },
  [244] = {
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [sym__special_characters] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1371),
  },
  [245] = {
    [aux_sym_concatenation_repeat1] = STATE(670),
    [sym__concat] = ACTIONS(1375),
    [anon_sym_RBRACK] = ACTIONS(1377),
    [sym_comment] = ACTIONS(57),
  },
  [246] = {
    [aux_sym_concatenation_repeat1] = STATE(670),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_RBRACK] = ACTIONS(1381),
    [sym_comment] = ACTIONS(57),
  },
  [247] = {
    [sym__concat] = ACTIONS(1383),
    [anon_sym_RBRACK] = ACTIONS(1381),
    [sym_comment] = ACTIONS(57),
  },
  [248] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [ts_builtin_sym_end] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [249] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(683),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [250] = {
    [aux_sym_concatenation_repeat1] = STATE(685),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1407),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [251] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(688),
    [anon_sym_DQUOTE] = ACTIONS(1413),
    [anon_sym_DOLLAR] = ACTIONS(1415),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [252] = {
    [sym_string] = STATE(690),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(1417),
    [sym_raw_string] = ACTIONS(1419),
    [anon_sym_POUND] = ACTIONS(1417),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_AT] = ACTIONS(1423),
    [anon_sym_QMARK] = ACTIONS(1423),
    [anon_sym_0] = ACTIONS(1421),
    [anon_sym__] = ACTIONS(1421),
  },
  [253] = {
    [aux_sym_concatenation_repeat1] = STATE(685),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1385),
    [ts_builtin_sym_end] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [254] = {
    [sym_subscript] = STATE(695),
    [sym_variable_name] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_DOLLAR] = ACTIONS(1429),
    [anon_sym_POUND] = ACTIONS(1427),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_AT] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_0] = ACTIONS(1431),
    [anon_sym__] = ACTIONS(1431),
  },
  [255] = {
    [sym__statements] = STATE(696),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(697),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [256] = {
    [sym__statements] = STATE(698),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [257] = {
    [sym__statements] = STATE(699),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [258] = {
    [sym__expression] = STATE(701),
    [sym_binary_expression] = STATE(701),
    [sym_unary_expression] = STATE(701),
    [sym_postfix_expression] = STATE(701),
    [sym_parenthesized_expression] = STATE(701),
    [sym_concatenation] = STATE(701),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
  },
  [259] = {
    [sym__expression] = STATE(702),
    [sym_binary_expression] = STATE(702),
    [sym_unary_expression] = STATE(702),
    [sym_postfix_expression] = STATE(702),
    [sym_parenthesized_expression] = STATE(702),
    [sym_concatenation] = STATE(702),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(521),
    [sym_test_operator] = ACTIONS(523),
  },
  [260] = {
    [sym__expression] = STATE(703),
    [sym_binary_expression] = STATE(703),
    [sym_unary_expression] = STATE(703),
    [sym_postfix_expression] = STATE(703),
    [sym_parenthesized_expression] = STATE(703),
    [sym_concatenation] = STATE(703),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
  },
  [261] = {
    [aux_sym_concatenation_repeat1] = STATE(705),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_SEMI_SEMI] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(527),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(527),
    [anon_sym_LF] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(529),
  },
  [262] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(708),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_DOLLAR] = ACTIONS(1443),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [263] = {
    [sym_string] = STATE(710),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(1445),
    [sym_raw_string] = ACTIONS(1447),
    [anon_sym_POUND] = ACTIONS(1445),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1449),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_AT] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(1451),
    [anon_sym_0] = ACTIONS(1449),
    [anon_sym__] = ACTIONS(1449),
  },
  [264] = {
    [aux_sym_concatenation_repeat1] = STATE(705),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(543),
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_EQ_TILDE] = ACTIONS(543),
    [anon_sym_EQ_EQ] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(545),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_DASH_EQ] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(543),
    [anon_sym_PLUS_PLUS] = ACTIONS(543),
    [anon_sym_DASH_DASH] = ACTIONS(543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(543),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(545),
  },
  [265] = {
    [sym_subscript] = STATE(715),
    [sym_variable_name] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_DOLLAR] = ACTIONS(1457),
    [anon_sym_POUND] = ACTIONS(1455),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1459),
    [anon_sym_STAR] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_0] = ACTIONS(1459),
    [anon_sym__] = ACTIONS(1459),
  },
  [266] = {
    [sym__statements] = STATE(716),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(717),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [267] = {
    [sym__statements] = STATE(718),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [268] = {
    [sym__statements] = STATE(719),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [269] = {
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1465),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_AMP] = ACTIONS(1463),
  },
  [270] = {
    [sym_concatenation] = STATE(732),
    [sym_string] = STATE(727),
    [sym_simple_expansion] = STATE(727),
    [sym_string_expansion] = STATE(727),
    [sym_expansion] = STATE(727),
    [sym_command_substitution] = STATE(727),
    [sym_process_substitution] = STATE(727),
    [aux_sym_for_statement_repeat1] = STATE(732),
    [sym__special_characters] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [sym_raw_string] = ACTIONS(1481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1485),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(1489),
    [anon_sym_GT_LPAREN] = ACTIONS(1489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1481),
  },
  [271] = {
    [sym_do_group] = STATE(733),
    [anon_sym_do] = ACTIONS(649),
    [sym_comment] = ACTIONS(57),
  },
  [272] = {
    [sym__expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_unary_expression] = STATE(734),
    [sym_postfix_expression] = STATE(734),
    [sym_parenthesized_expression] = STATE(734),
    [sym_concatenation] = STATE(734),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(521),
    [sym_test_operator] = ACTIONS(523),
  },
  [273] = {
    [sym__expression] = STATE(735),
    [sym_binary_expression] = STATE(735),
    [sym_unary_expression] = STATE(735),
    [sym_postfix_expression] = STATE(735),
    [sym_parenthesized_expression] = STATE(735),
    [sym_concatenation] = STATE(735),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(521),
    [sym_test_operator] = ACTIONS(523),
  },
  [274] = {
    [aux_sym_concatenation_repeat1] = STATE(737),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(527),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(527),
  },
  [275] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(740),
    [anon_sym_DQUOTE] = ACTIONS(1493),
    [anon_sym_DOLLAR] = ACTIONS(1495),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [276] = {
    [sym_string] = STATE(742),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(1497),
    [sym_raw_string] = ACTIONS(1499),
    [anon_sym_POUND] = ACTIONS(1497),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_0] = ACTIONS(1501),
    [anon_sym__] = ACTIONS(1501),
  },
  [277] = {
    [aux_sym_concatenation_repeat1] = STATE(737),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_RPAREN] = ACTIONS(543),
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_EQ_TILDE] = ACTIONS(543),
    [anon_sym_EQ_EQ] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_PLUS_EQ] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [anon_sym_PLUS] = ACTIONS(545),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_DASH_EQ] = ACTIONS(543),
    [anon_sym_LT_EQ] = ACTIONS(543),
    [anon_sym_GT_EQ] = ACTIONS(543),
    [anon_sym_PLUS_PLUS] = ACTIONS(543),
    [anon_sym_DASH_DASH] = ACTIONS(543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(543),
  },
  [278] = {
    [sym_subscript] = STATE(747),
    [sym_variable_name] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_DOLLAR] = ACTIONS(1509),
    [anon_sym_POUND] = ACTIONS(1507),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1511),
    [anon_sym_STAR] = ACTIONS(1513),
    [anon_sym_AT] = ACTIONS(1513),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_0] = ACTIONS(1511),
    [anon_sym__] = ACTIONS(1511),
  },
  [279] = {
    [sym__statements] = STATE(748),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(749),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [280] = {
    [sym__statements] = STATE(750),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [281] = {
    [sym__statements] = STATE(751),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [282] = {
    [anon_sym_RPAREN] = ACTIONS(1515),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_EQ_EQ] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_PLUS_EQ] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_DASH_EQ] = ACTIONS(1517),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1517),
  },
  [283] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [284] = {
    [sym_string] = STATE(756),
    [sym_simple_expansion] = STATE(756),
    [sym_string_expansion] = STATE(756),
    [sym_expansion] = STATE(756),
    [sym_command_substitution] = STATE(756),
    [sym_process_substitution] = STATE(756),
    [sym__special_characters] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(1527),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1527),
  },
  [285] = {
    [aux_sym_concatenation_repeat1] = STATE(757),
    [sym__concat] = ACTIONS(525),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1051),
    [anon_sym_PLUS_EQ] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_BANG_EQ] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_DASH_EQ] = ACTIONS(1049),
    [anon_sym_LT_EQ] = ACTIONS(1049),
    [anon_sym_GT_EQ] = ACTIONS(1049),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1049),
  },
  [286] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1053),
    [anon_sym_EQ_EQ] = ACTIONS(1053),
    [anon_sym_EQ] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_BANG_EQ] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1053),
    [anon_sym_GT_EQ] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1053),
  },
  [287] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [288] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [289] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1087),
  },
  [290] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1091),
  },
  [291] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1097),
    [anon_sym_PLUS_EQ] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_DASH_EQ] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1095),
  },
  [292] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(1533),
    [sym_comment] = ACTIONS(57),
  },
  [293] = {
    [sym_subscript] = STATE(763),
    [sym_variable_name] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1539),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_0] = ACTIONS(1539),
    [anon_sym__] = ACTIONS(1539),
  },
  [294] = {
    [sym_concatenation] = STATE(766),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(766),
    [anon_sym_RBRACE] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1545),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1545),
    [anon_sym_COLON_QMARK] = ACTIONS(1545),
    [anon_sym_COLON_DASH] = ACTIONS(1545),
    [anon_sym_PERCENT] = ACTIONS(1545),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [295] = {
    [sym_concatenation] = STATE(769),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(769),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1557),
    [anon_sym_COLON] = ACTIONS(1553),
    [anon_sym_COLON_QMARK] = ACTIONS(1553),
    [anon_sym_COLON_DASH] = ACTIONS(1553),
    [anon_sym_PERCENT] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [296] = {
    [anon_sym_RPAREN] = ACTIONS(1559),
    [sym_comment] = ACTIONS(57),
  },
  [297] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [298] = {
    [anon_sym_BQUOTE] = ACTIONS(1559),
    [sym_comment] = ACTIONS(57),
  },
  [299] = {
    [anon_sym_RPAREN] = ACTIONS(1561),
    [sym_comment] = ACTIONS(57),
  },
  [300] = {
    [sym__simple_heredoc_body] = ACTIONS(1563),
    [sym__heredoc_body_beginning] = ACTIONS(1563),
    [sym_file_descriptor] = ACTIONS(1563),
    [ts_builtin_sym_end] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1565),
    [anon_sym_done] = ACTIONS(1563),
    [anon_sym_fi] = ACTIONS(1563),
    [anon_sym_elif] = ACTIONS(1563),
    [anon_sym_else] = ACTIONS(1563),
    [anon_sym_esac] = ACTIONS(1563),
    [anon_sym_PIPE] = ACTIONS(1565),
    [anon_sym_RPAREN] = ACTIONS(1563),
    [anon_sym_SEMI_SEMI] = ACTIONS(1563),
    [anon_sym_PIPE_AMP] = ACTIONS(1563),
    [anon_sym_AMP_AMP] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE] = ACTIONS(1563),
    [anon_sym_LT] = ACTIONS(1565),
    [anon_sym_GT] = ACTIONS(1565),
    [anon_sym_GT_GT] = ACTIONS(1563),
    [anon_sym_AMP_GT] = ACTIONS(1565),
    [anon_sym_AMP_GT_GT] = ACTIONS(1563),
    [anon_sym_LT_AMP] = ACTIONS(1563),
    [anon_sym_GT_AMP] = ACTIONS(1563),
    [anon_sym_LT_LT] = ACTIONS(1565),
    [anon_sym_LT_LT_DASH] = ACTIONS(1563),
    [anon_sym_LT_LT_LT] = ACTIONS(1563),
    [anon_sym_BQUOTE] = ACTIONS(1563),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1565),
  },
  [301] = {
    [sym__expression] = STATE(772),
    [sym_binary_expression] = STATE(772),
    [sym_unary_expression] = STATE(772),
    [sym_postfix_expression] = STATE(772),
    [sym_parenthesized_expression] = STATE(772),
    [sym_concatenation] = STATE(772),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [302] = {
    [sym__expression] = STATE(772),
    [sym_binary_expression] = STATE(772),
    [sym_unary_expression] = STATE(772),
    [sym_postfix_expression] = STATE(772),
    [sym_parenthesized_expression] = STATE(772),
    [sym_concatenation] = STATE(772),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [sym_regex] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [303] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1569),
    [anon_sym_AMP_AMP] = ACTIONS(1569),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1569),
    [anon_sym_EQ_TILDE] = ACTIONS(1569),
    [anon_sym_EQ_EQ] = ACTIONS(1569),
    [anon_sym_EQ] = ACTIONS(1571),
    [anon_sym_PLUS_EQ] = ACTIONS(1569),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_BANG_EQ] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1571),
    [anon_sym_DASH_EQ] = ACTIONS(1569),
    [anon_sym_LT_EQ] = ACTIONS(1569),
    [anon_sym_GT_EQ] = ACTIONS(1569),
    [anon_sym_PLUS_PLUS] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1569),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1569),
  },
  [304] = {
    [sym_concatenation] = STATE(774),
    [sym_string] = STATE(779),
    [sym_array] = STATE(774),
    [sym_simple_expansion] = STATE(779),
    [sym_string_expansion] = STATE(779),
    [sym_expansion] = STATE(779),
    [sym_command_substitution] = STATE(779),
    [sym_process_substitution] = STATE(779),
    [sym__empty_value] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [sym__special_characters] = ACTIONS(1577),
    [anon_sym_DQUOTE] = ACTIONS(1579),
    [anon_sym_DOLLAR] = ACTIONS(1581),
    [sym_raw_string] = ACTIONS(1583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1587),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1591),
    [anon_sym_GT_LPAREN] = ACTIONS(1591),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1583),
  },
  [305] = {
    [sym__expression] = STATE(785),
    [sym_binary_expression] = STATE(785),
    [sym_unary_expression] = STATE(785),
    [sym_postfix_expression] = STATE(785),
    [sym_parenthesized_expression] = STATE(785),
    [sym_concatenation] = STATE(785),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(1593),
    [anon_sym_SEMI_SEMI] = ACTIONS(1595),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(1595),
    [anon_sym_AMP] = ACTIONS(1595),
  },
  [306] = {
    [anon_sym_in] = ACTIONS(1597),
    [anon_sym_SEMI] = ACTIONS(1599),
    [anon_sym_SEMI_SEMI] = ACTIONS(1601),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
  },
  [307] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1603),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [308] = {
    [sym_do_group] = STATE(790),
    [anon_sym_do] = ACTIONS(1605),
    [sym_comment] = ACTIONS(57),
  },
  [309] = {
    [anon_sym_then] = ACTIONS(1607),
    [sym_comment] = ACTIONS(57),
  },
  [310] = {
    [aux_sym_concatenation_repeat1] = STATE(376),
    [sym__concat] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1611),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
  },
  [311] = {
    [aux_sym_concatenation_repeat1] = STATE(376),
    [sym__concat] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [312] = {
    [anon_sym_in] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [313] = {
    [sym_compound_statement] = STATE(797),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [314] = {
    [anon_sym_RPAREN] = ACTIONS(1623),
    [sym_comment] = ACTIONS(57),
  },
  [315] = {
    [sym_file_descriptor] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [316] = {
    [anon_sym_RBRACE] = ACTIONS(1625),
    [sym_comment] = ACTIONS(57),
  },
  [317] = {
    [sym_file_descriptor] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [318] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1603),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [319] = {
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1603),
    [anon_sym_EQ_TILDE] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_EQ] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_BANG_EQ] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(931),
    [anon_sym_GT_EQ] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(931),
  },
  [320] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [sym_comment] = ACTIONS(57),
  },
  [321] = {
    [aux_sym_concatenation_repeat1] = STATE(802),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(1629),
    [sym_variable_name] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [322] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(805),
    [anon_sym_DQUOTE] = ACTIONS(1631),
    [anon_sym_DOLLAR] = ACTIONS(1633),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [323] = {
    [sym_string] = STATE(807),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(1635),
    [sym_raw_string] = ACTIONS(1637),
    [anon_sym_POUND] = ACTIONS(1635),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1639),
    [anon_sym_STAR] = ACTIONS(1641),
    [anon_sym_AT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_0] = ACTIONS(1639),
    [anon_sym__] = ACTIONS(1639),
  },
  [324] = {
    [aux_sym_concatenation_repeat1] = STATE(802),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(1629),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [325] = {
    [sym_subscript] = STATE(812),
    [sym_variable_name] = ACTIONS(1643),
    [anon_sym_BANG] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_DOLLAR] = ACTIONS(1647),
    [anon_sym_POUND] = ACTIONS(1645),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1649),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_AT] = ACTIONS(1651),
    [anon_sym_QMARK] = ACTIONS(1651),
    [anon_sym_0] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1649),
  },
  [326] = {
    [sym__statements] = STATE(813),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(814),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [327] = {
    [sym__statements] = STATE(815),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [328] = {
    [sym__statements] = STATE(816),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [329] = {
    [anon_sym_EQ] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [sym_comment] = ACTIONS(57),
  },
  [330] = {
    [sym_variable_assignment] = STATE(817),
    [sym_subscript] = STATE(329),
    [sym_concatenation] = STATE(817),
    [sym_string] = STATE(324),
    [sym_simple_expansion] = STATE(324),
    [sym_string_expansion] = STATE(324),
    [sym_expansion] = STATE(324),
    [sym_command_substitution] = STATE(324),
    [sym_process_substitution] = STATE(324),
    [aux_sym_declaration_command_repeat1] = STATE(817),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(587),
    [sym_raw_string] = ACTIONS(589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(593),
    [anon_sym_BQUOTE] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(597),
    [anon_sym_GT_LPAREN] = ACTIONS(597),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1653),
    [sym_word] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [331] = {
    [aux_sym_concatenation_repeat1] = STATE(819),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(1655),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [332] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(822),
    [anon_sym_DQUOTE] = ACTIONS(1657),
    [anon_sym_DOLLAR] = ACTIONS(1659),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [333] = {
    [sym_string] = STATE(824),
    [anon_sym_DASH] = ACTIONS(1661),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [anon_sym_DOLLAR] = ACTIONS(1661),
    [sym_raw_string] = ACTIONS(1663),
    [anon_sym_POUND] = ACTIONS(1661),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1665),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_AT] = ACTIONS(1667),
    [anon_sym_QMARK] = ACTIONS(1667),
    [anon_sym_0] = ACTIONS(1665),
    [anon_sym__] = ACTIONS(1665),
  },
  [334] = {
    [aux_sym_concatenation_repeat1] = STATE(819),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(1655),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [335] = {
    [sym_subscript] = STATE(829),
    [sym_variable_name] = ACTIONS(1669),
    [anon_sym_BANG] = ACTIONS(1671),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [anon_sym_POUND] = ACTIONS(1671),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1675),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_AT] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_0] = ACTIONS(1675),
    [anon_sym__] = ACTIONS(1675),
  },
  [336] = {
    [sym__statements] = STATE(830),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(831),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [337] = {
    [sym__statements] = STATE(832),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [338] = {
    [sym__statements] = STATE(833),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [339] = {
    [sym_concatenation] = STATE(834),
    [sym_string] = STATE(334),
    [sym_simple_expansion] = STATE(334),
    [sym_string_expansion] = STATE(334),
    [sym_expansion] = STATE(334),
    [sym_command_substitution] = STATE(334),
    [sym_process_substitution] = STATE(334),
    [aux_sym_unset_command_repeat1] = STATE(834),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [sym_raw_string] = ACTIONS(609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(611),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(615),
    [anon_sym_LT_LPAREN] = ACTIONS(617),
    [anon_sym_GT_LPAREN] = ACTIONS(617),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1679),
    [sym_word] = ACTIONS(621),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [340] = {
    [sym_string] = STATE(835),
    [sym_simple_expansion] = STATE(835),
    [sym_string_expansion] = STATE(835),
    [sym_expansion] = STATE(835),
    [sym_command_substitution] = STATE(835),
    [sym_process_substitution] = STATE(835),
    [sym__special_characters] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1681),
  },
  [341] = {
    [aux_sym_concatenation_repeat1] = STATE(836),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [342] = {
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1055),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [343] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1683),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [344] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(1683),
    [anon_sym_DOLLAR] = ACTIONS(1685),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [345] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [346] = {
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [347] = {
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [348] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(1687),
    [sym_comment] = ACTIONS(57),
  },
  [349] = {
    [sym_subscript] = STATE(842),
    [sym_variable_name] = ACTIONS(1689),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_DOLLAR] = ACTIONS(1691),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1693),
    [anon_sym_STAR] = ACTIONS(1695),
    [anon_sym_AT] = ACTIONS(1695),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_0] = ACTIONS(1693),
    [anon_sym__] = ACTIONS(1693),
  },
  [350] = {
    [sym_concatenation] = STATE(845),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(845),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1701),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_COLON] = ACTIONS(1699),
    [anon_sym_COLON_QMARK] = ACTIONS(1699),
    [anon_sym_COLON_DASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [351] = {
    [sym_concatenation] = STATE(848),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(848),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_DASH] = ACTIONS(1707),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1711),
    [anon_sym_COLON] = ACTIONS(1707),
    [anon_sym_COLON_QMARK] = ACTIONS(1707),
    [anon_sym_COLON_DASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [352] = {
    [anon_sym_RPAREN] = ACTIONS(1713),
    [sym_comment] = ACTIONS(57),
  },
  [353] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [354] = {
    [anon_sym_BQUOTE] = ACTIONS(1713),
    [sym_comment] = ACTIONS(57),
  },
  [355] = {
    [anon_sym_RPAREN] = ACTIONS(1715),
    [sym_comment] = ACTIONS(57),
  },
  [356] = {
    [anon_sym_RPAREN] = ACTIONS(1717),
    [sym_comment] = ACTIONS(57),
  },
  [357] = {
    [sym__statements] = STATE(866),
    [sym_redirected_statement] = STATE(867),
    [sym_for_statement] = STATE(867),
    [sym_c_style_for_statement] = STATE(867),
    [sym_while_statement] = STATE(867),
    [sym_if_statement] = STATE(867),
    [sym_case_statement] = STATE(867),
    [sym_function_definition] = STATE(867),
    [sym_compound_statement] = STATE(867),
    [sym_subshell] = STATE(867),
    [sym_pipeline] = STATE(867),
    [sym_list] = STATE(867),
    [sym_negated_command] = STATE(867),
    [sym_test_command] = STATE(867),
    [sym_declaration_command] = STATE(867),
    [sym_unset_command] = STATE(867),
    [sym_command] = STATE(867),
    [sym_command_name] = STATE(868),
    [sym_variable_assignment] = STATE(869),
    [sym_subscript] = STATE(870),
    [sym_file_redirect] = STATE(873),
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(860),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [sym_process_substitution] = STATE(860),
    [aux_sym__statements_repeat1] = STATE(872),
    [aux_sym_command_repeat1] = STATE(873),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1719),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(1721),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_typeset] = ACTIONS(1725),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_readonly] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym_unset] = ACTIONS(1727),
    [anon_sym_unsetenv] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1745),
  },
  [358] = {
    [sym__simple_heredoc_body] = ACTIONS(1747),
    [sym__heredoc_body_beginning] = ACTIONS(1747),
    [sym_file_descriptor] = ACTIONS(1747),
    [ts_builtin_sym_end] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym_done] = ACTIONS(1747),
    [anon_sym_fi] = ACTIONS(1747),
    [anon_sym_elif] = ACTIONS(1747),
    [anon_sym_else] = ACTIONS(1747),
    [anon_sym_esac] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1749),
    [anon_sym_RPAREN] = ACTIONS(1747),
    [anon_sym_SEMI_SEMI] = ACTIONS(1747),
    [anon_sym_PIPE_AMP] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1749),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_AMP_GT] = ACTIONS(1749),
    [anon_sym_AMP_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_AMP] = ACTIONS(1747),
    [anon_sym_GT_AMP] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1749),
    [anon_sym_LT_LT_DASH] = ACTIONS(1747),
    [anon_sym_LT_LT_LT] = ACTIONS(1747),
    [anon_sym_BQUOTE] = ACTIONS(1747),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1749),
  },
  [359] = {
    [anon_sym_LT] = ACTIONS(1751),
    [anon_sym_GT] = ACTIONS(1751),
    [anon_sym_GT_GT] = ACTIONS(1753),
    [anon_sym_AMP_GT] = ACTIONS(1751),
    [anon_sym_AMP_GT_GT] = ACTIONS(1753),
    [anon_sym_LT_AMP] = ACTIONS(1753),
    [anon_sym_GT_AMP] = ACTIONS(1753),
    [sym_comment] = ACTIONS(57),
  },
  [360] = {
    [anon_sym_do] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(1755),
    [sym_comment] = ACTIONS(57),
  },
  [361] = {
    [sym_redirected_statement] = STATE(875),
    [sym_for_statement] = STATE(875),
    [sym_c_style_for_statement] = STATE(875),
    [sym_while_statement] = STATE(875),
    [sym_if_statement] = STATE(875),
    [sym_case_statement] = STATE(875),
    [sym_function_definition] = STATE(875),
    [sym_compound_statement] = STATE(875),
    [sym_subshell] = STATE(875),
    [sym_pipeline] = STATE(875),
    [sym_list] = STATE(875),
    [sym_negated_command] = STATE(875),
    [sym_test_command] = STATE(875),
    [sym_declaration_command] = STATE(875),
    [sym_unset_command] = STATE(875),
    [sym_command] = STATE(875),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(876),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [362] = {
    [sym_redirected_statement] = STATE(877),
    [sym_for_statement] = STATE(877),
    [sym_c_style_for_statement] = STATE(877),
    [sym_while_statement] = STATE(877),
    [sym_if_statement] = STATE(877),
    [sym_case_statement] = STATE(877),
    [sym_function_definition] = STATE(877),
    [sym_compound_statement] = STATE(877),
    [sym_subshell] = STATE(877),
    [sym_pipeline] = STATE(877),
    [sym_list] = STATE(877),
    [sym_negated_command] = STATE(877),
    [sym_test_command] = STATE(877),
    [sym_declaration_command] = STATE(877),
    [sym_unset_command] = STATE(877),
    [sym_command] = STATE(877),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(878),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [363] = {
    [sym_concatenation] = STATE(881),
    [sym_string] = STATE(880),
    [sym_simple_expansion] = STATE(880),
    [sym_string_expansion] = STATE(880),
    [sym_expansion] = STATE(880),
    [sym_command_substitution] = STATE(880),
    [sym_process_substitution] = STATE(880),
    [sym__special_characters] = ACTIONS(1757),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1759),
  },
  [364] = {
    [sym_heredoc_start] = ACTIONS(1761),
    [sym_comment] = ACTIONS(57),
  },
  [365] = {
    [sym_concatenation] = STATE(885),
    [sym_string] = STATE(884),
    [sym_simple_expansion] = STATE(884),
    [sym_string_expansion] = STATE(884),
    [sym_expansion] = STATE(884),
    [sym_command_substitution] = STATE(884),
    [sym_process_substitution] = STATE(884),
    [sym__special_characters] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1765),
  },
  [366] = {
    [sym_file_redirect] = STATE(886),
    [sym_heredoc_redirect] = STATE(886),
    [sym_herestring_redirect] = STATE(886),
    [aux_sym_redirected_statement_repeat1] = STATE(886),
    [sym_file_descriptor] = ACTIONS(651),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(663),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(671),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [367] = {
    [sym_concatenation] = STATE(887),
    [sym_string] = STATE(889),
    [sym_simple_expansion] = STATE(889),
    [sym_string_expansion] = STATE(889),
    [sym_expansion] = STATE(889),
    [sym_command_substitution] = STATE(889),
    [sym_process_substitution] = STATE(889),
    [sym_regex] = ACTIONS(1767),
    [sym__special_characters] = ACTIONS(1769),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1771),
  },
  [368] = {
    [aux_sym_concatenation_repeat1] = STATE(341),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [369] = {
    [aux_sym_concatenation_repeat1] = STATE(341),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [370] = {
    [sym_concatenation] = STATE(890),
    [sym_string] = STATE(369),
    [sym_simple_expansion] = STATE(369),
    [sym_string_expansion] = STATE(369),
    [sym_expansion] = STATE(369),
    [sym_command_substitution] = STATE(369),
    [sym_process_substitution] = STATE(369),
    [aux_sym_command_repeat2] = STATE(890),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [371] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(369),
    [sym_simple_expansion] = STATE(369),
    [sym_string_expansion] = STATE(369),
    [sym_expansion] = STATE(369),
    [sym_command_substitution] = STATE(369),
    [sym_process_substitution] = STATE(369),
    [aux_sym_command_repeat2] = STATE(891),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [372] = {
    [sym__statements] = STATE(908),
    [sym_redirected_statement] = STATE(909),
    [sym_for_statement] = STATE(909),
    [sym_c_style_for_statement] = STATE(909),
    [sym_while_statement] = STATE(909),
    [sym_if_statement] = STATE(909),
    [sym_elif_clause] = STATE(916),
    [sym_else_clause] = STATE(910),
    [sym_case_statement] = STATE(909),
    [sym_function_definition] = STATE(909),
    [sym_compound_statement] = STATE(909),
    [sym_subshell] = STATE(909),
    [sym_pipeline] = STATE(909),
    [sym_list] = STATE(909),
    [sym_negated_command] = STATE(909),
    [sym_test_command] = STATE(909),
    [sym_declaration_command] = STATE(909),
    [sym_unset_command] = STATE(909),
    [sym_command] = STATE(909),
    [sym_command_name] = STATE(911),
    [sym_variable_assignment] = STATE(912),
    [sym_subscript] = STATE(913),
    [sym_file_redirect] = STATE(917),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym__statements_repeat1] = STATE(915),
    [aux_sym_if_statement_repeat1] = STATE(916),
    [aux_sym_command_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(1775),
    [anon_sym_elif] = ACTIONS(1777),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1783),
    [anon_sym_typeset] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_readonly] = ACTIONS(1783),
    [anon_sym_local] = ACTIONS(1783),
    [anon_sym_unset] = ACTIONS(1785),
    [anon_sym_unsetenv] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1803),
  },
  [373] = {
    [sym_string] = STATE(918),
    [sym_simple_expansion] = STATE(918),
    [sym_string_expansion] = STATE(918),
    [sym_expansion] = STATE(918),
    [sym_command_substitution] = STATE(918),
    [sym_process_substitution] = STATE(918),
    [sym__special_characters] = ACTIONS(1805),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(1805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1805),
  },
  [374] = {
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1809),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1809),
    [anon_sym_AMP] = ACTIONS(1809),
  },
  [375] = {
    [anon_sym_in] = ACTIONS(1811),
    [sym_comment] = ACTIONS(57),
  },
  [376] = {
    [aux_sym_concatenation_repeat1] = STATE(921),
    [sym__concat] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1049),
  },
  [377] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [378] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1813),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [379] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(1813),
    [anon_sym_DOLLAR] = ACTIONS(1815),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [380] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [381] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [382] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [383] = {
    [anon_sym_SEMI] = ACTIONS(1817),
    [anon_sym_SEMI_SEMI] = ACTIONS(1819),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1819),
    [anon_sym_AMP] = ACTIONS(1819),
  },
  [384] = {
    [anon_sym_in] = ACTIONS(1821),
    [sym_comment] = ACTIONS(57),
  },
  [385] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(1823),
    [sym_comment] = ACTIONS(57),
  },
  [386] = {
    [sym_subscript] = STATE(929),
    [sym_variable_name] = ACTIONS(1825),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_DOLLAR] = ACTIONS(1827),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_AT] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1831),
    [anon_sym_0] = ACTIONS(1829),
    [anon_sym__] = ACTIONS(1829),
  },
  [387] = {
    [sym_concatenation] = STATE(932),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(932),
    [anon_sym_RBRACE] = ACTIONS(1833),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1835),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1839),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_COLON_QMARK] = ACTIONS(1835),
    [anon_sym_COLON_DASH] = ACTIONS(1835),
    [anon_sym_PERCENT] = ACTIONS(1835),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [388] = {
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(935),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_EQ] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1843),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1847),
    [anon_sym_COLON] = ACTIONS(1843),
    [anon_sym_COLON_QMARK] = ACTIONS(1843),
    [anon_sym_COLON_DASH] = ACTIONS(1843),
    [anon_sym_PERCENT] = ACTIONS(1843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [389] = {
    [anon_sym_RPAREN] = ACTIONS(1849),
    [sym_comment] = ACTIONS(57),
  },
  [390] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1849),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [391] = {
    [anon_sym_BQUOTE] = ACTIONS(1849),
    [sym_comment] = ACTIONS(57),
  },
  [392] = {
    [anon_sym_RPAREN] = ACTIONS(1851),
    [sym_comment] = ACTIONS(57),
  },
  [393] = {
    [anon_sym_RPAREN] = ACTIONS(1853),
    [sym_comment] = ACTIONS(57),
  },
  [394] = {
    [sym__simple_heredoc_body] = ACTIONS(1855),
    [sym__heredoc_body_beginning] = ACTIONS(1855),
    [sym_file_descriptor] = ACTIONS(1855),
    [ts_builtin_sym_end] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_done] = ACTIONS(1855),
    [anon_sym_fi] = ACTIONS(1855),
    [anon_sym_elif] = ACTIONS(1855),
    [anon_sym_else] = ACTIONS(1855),
    [anon_sym_esac] = ACTIONS(1855),
    [anon_sym_PIPE] = ACTIONS(1857),
    [anon_sym_RPAREN] = ACTIONS(1855),
    [anon_sym_SEMI_SEMI] = ACTIONS(1855),
    [anon_sym_PIPE_AMP] = ACTIONS(1855),
    [anon_sym_AMP_AMP] = ACTIONS(1855),
    [anon_sym_PIPE_PIPE] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_GT_GT] = ACTIONS(1855),
    [anon_sym_AMP_GT] = ACTIONS(1857),
    [anon_sym_AMP_GT_GT] = ACTIONS(1855),
    [anon_sym_LT_AMP] = ACTIONS(1855),
    [anon_sym_GT_AMP] = ACTIONS(1855),
    [anon_sym_LT_LT] = ACTIONS(1857),
    [anon_sym_LT_LT_DASH] = ACTIONS(1855),
    [anon_sym_LT_LT_LT] = ACTIONS(1855),
    [anon_sym_BQUOTE] = ACTIONS(1855),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1855),
    [anon_sym_AMP] = ACTIONS(1857),
  },
  [395] = {
    [sym_concatenation] = STATE(248),
    [sym_string] = STATE(940),
    [sym_array] = STATE(248),
    [sym_simple_expansion] = STATE(940),
    [sym_string_expansion] = STATE(940),
    [sym_expansion] = STATE(940),
    [sym_command_substitution] = STATE(940),
    [sym_process_substitution] = STATE(940),
    [sym__empty_value] = ACTIONS(447),
    [anon_sym_LPAREN] = ACTIONS(449),
    [sym__special_characters] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(455),
    [sym_raw_string] = ACTIONS(1861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(463),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1861),
  },
  [396] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_PLUS_EQ] = ACTIONS(1863),
    [sym_comment] = ACTIONS(57),
  },
  [397] = {
    [aux_sym_concatenation_repeat1] = STATE(942),
    [sym__simple_heredoc_body] = ACTIONS(939),
    [sym__heredoc_body_beginning] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [398] = {
    [aux_sym_concatenation_repeat1] = STATE(942),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [399] = {
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_PLUS_EQ] = ACTIONS(1863),
    [sym_comment] = ACTIONS(57),
  },
  [400] = {
    [sym_variable_assignment] = STATE(943),
    [sym_subscript] = STATE(399),
    [sym_concatenation] = STATE(943),
    [sym_string] = STATE(398),
    [sym_simple_expansion] = STATE(398),
    [sym_string_expansion] = STATE(398),
    [sym_expansion] = STATE(398),
    [sym_command_substitution] = STATE(398),
    [sym_process_substitution] = STATE(398),
    [aux_sym_declaration_command_repeat1] = STATE(943),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1865),
    [sym_word] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [401] = {
    [aux_sym_concatenation_repeat1] = STATE(944),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [402] = {
    [aux_sym_concatenation_repeat1] = STATE(944),
    [sym__simple_heredoc_body] = ACTIONS(995),
    [sym__heredoc_body_beginning] = ACTIONS(995),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [403] = {
    [sym_concatenation] = STATE(945),
    [sym_string] = STATE(402),
    [sym_simple_expansion] = STATE(402),
    [sym_string_expansion] = STATE(402),
    [sym_expansion] = STATE(402),
    [sym_command_substitution] = STATE(402),
    [sym_process_substitution] = STATE(402),
    [aux_sym_unset_command_repeat1] = STATE(945),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1867),
    [sym_word] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [404] = {
    [aux_sym_concatenation_repeat1] = STATE(946),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [405] = {
    [sym__simple_heredoc_body] = ACTIONS(1869),
    [sym__heredoc_body_beginning] = ACTIONS(1869),
    [sym_file_descriptor] = ACTIONS(1869),
    [ts_builtin_sym_end] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_done] = ACTIONS(1869),
    [anon_sym_fi] = ACTIONS(1869),
    [anon_sym_elif] = ACTIONS(1869),
    [anon_sym_else] = ACTIONS(1869),
    [anon_sym_esac] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1871),
    [anon_sym_RPAREN] = ACTIONS(1869),
    [anon_sym_SEMI_SEMI] = ACTIONS(1869),
    [anon_sym_PIPE_AMP] = ACTIONS(1869),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_PIPE_PIPE] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_GT] = ACTIONS(1871),
    [anon_sym_GT_GT] = ACTIONS(1869),
    [anon_sym_AMP_GT] = ACTIONS(1871),
    [anon_sym_AMP_GT_GT] = ACTIONS(1869),
    [anon_sym_LT_AMP] = ACTIONS(1869),
    [anon_sym_GT_AMP] = ACTIONS(1869),
    [anon_sym_LT_LT] = ACTIONS(1871),
    [anon_sym_LT_LT_DASH] = ACTIONS(1869),
    [anon_sym_LT_LT_LT] = ACTIONS(1869),
    [anon_sym_BQUOTE] = ACTIONS(1869),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1869),
    [anon_sym_AMP] = ACTIONS(1871),
  },
  [406] = {
    [anon_sym_LT] = ACTIONS(1873),
    [anon_sym_GT] = ACTIONS(1873),
    [anon_sym_GT_GT] = ACTIONS(1875),
    [anon_sym_AMP_GT] = ACTIONS(1873),
    [anon_sym_AMP_GT_GT] = ACTIONS(1875),
    [anon_sym_LT_AMP] = ACTIONS(1875),
    [anon_sym_GT_AMP] = ACTIONS(1875),
    [sym_comment] = ACTIONS(57),
  },
  [407] = {
    [sym_redirected_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_c_style_for_statement] = STATE(948),
    [sym_while_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_case_statement] = STATE(948),
    [sym_function_definition] = STATE(948),
    [sym_compound_statement] = STATE(948),
    [sym_subshell] = STATE(948),
    [sym_pipeline] = STATE(948),
    [sym_list] = STATE(948),
    [sym_negated_command] = STATE(948),
    [sym_test_command] = STATE(948),
    [sym_declaration_command] = STATE(948),
    [sym_unset_command] = STATE(948),
    [sym_command] = STATE(948),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(949),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [408] = {
    [sym_redirected_statement] = STATE(950),
    [sym_for_statement] = STATE(950),
    [sym_c_style_for_statement] = STATE(950),
    [sym_while_statement] = STATE(950),
    [sym_if_statement] = STATE(950),
    [sym_case_statement] = STATE(950),
    [sym_function_definition] = STATE(950),
    [sym_compound_statement] = STATE(950),
    [sym_subshell] = STATE(950),
    [sym_pipeline] = STATE(950),
    [sym_list] = STATE(950),
    [sym_negated_command] = STATE(950),
    [sym_test_command] = STATE(950),
    [sym_declaration_command] = STATE(950),
    [sym_unset_command] = STATE(950),
    [sym_command] = STATE(950),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(951),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [409] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(953),
    [sym_simple_expansion] = STATE(953),
    [sym_string_expansion] = STATE(953),
    [sym_expansion] = STATE(953),
    [sym_command_substitution] = STATE(953),
    [sym_process_substitution] = STATE(953),
    [sym__special_characters] = ACTIONS(1877),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1879),
  },
  [410] = {
    [sym_concatenation] = STATE(651),
    [sym_string] = STATE(955),
    [sym_simple_expansion] = STATE(955),
    [sym_string_expansion] = STATE(955),
    [sym_expansion] = STATE(955),
    [sym_command_substitution] = STATE(955),
    [sym_process_substitution] = STATE(955),
    [sym__special_characters] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1883),
  },
  [411] = {
    [sym_file_redirect] = STATE(956),
    [sym_heredoc_redirect] = STATE(956),
    [sym_herestring_redirect] = STATE(956),
    [aux_sym_redirected_statement_repeat1] = STATE(956),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_RPAREN] = ACTIONS(1247),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_GT_GT] = ACTIONS(755),
    [anon_sym_AMP_GT] = ACTIONS(753),
    [anon_sym_AMP_GT_GT] = ACTIONS(755),
    [anon_sym_LT_AMP] = ACTIONS(755),
    [anon_sym_GT_AMP] = ACTIONS(755),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(757),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [412] = {
    [sym_concatenation] = STATE(654),
    [sym_string] = STATE(958),
    [sym_simple_expansion] = STATE(958),
    [sym_string_expansion] = STATE(958),
    [sym_expansion] = STATE(958),
    [sym_command_substitution] = STATE(958),
    [sym_process_substitution] = STATE(958),
    [sym_regex] = ACTIONS(1251),
    [sym__special_characters] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1887),
  },
  [413] = {
    [aux_sym_concatenation_repeat1] = STATE(404),
    [sym__simple_heredoc_body] = ACTIONS(1257),
    [sym__heredoc_body_beginning] = ACTIONS(1257),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [414] = {
    [aux_sym_concatenation_repeat1] = STATE(404),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [415] = {
    [sym_concatenation] = STATE(959),
    [sym_string] = STATE(414),
    [sym_simple_expansion] = STATE(414),
    [sym_string_expansion] = STATE(414),
    [sym_expansion] = STATE(414),
    [sym_command_substitution] = STATE(414),
    [sym_process_substitution] = STATE(414),
    [aux_sym_command_repeat2] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(761),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [416] = {
    [sym_file_redirect] = STATE(411),
    [sym_heredoc_redirect] = STATE(411),
    [sym_heredoc_body] = STATE(659),
    [sym_herestring_redirect] = STATE(411),
    [aux_sym_redirected_statement_repeat1] = STATE(411),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_GT_GT] = ACTIONS(755),
    [anon_sym_AMP_GT] = ACTIONS(753),
    [anon_sym_AMP_GT_GT] = ACTIONS(755),
    [anon_sym_LT_AMP] = ACTIONS(755),
    [anon_sym_GT_AMP] = ACTIONS(755),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(757),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [417] = {
    [sym_file_redirect] = STATE(411),
    [sym_heredoc_redirect] = STATE(411),
    [sym_heredoc_body] = STATE(659),
    [sym_herestring_redirect] = STATE(411),
    [aux_sym_redirected_statement_repeat1] = STATE(411),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(757),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [418] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(414),
    [sym_simple_expansion] = STATE(414),
    [sym_string_expansion] = STATE(414),
    [sym_expansion] = STATE(414),
    [sym_command_substitution] = STATE(414),
    [sym_process_substitution] = STATE(414),
    [aux_sym_command_repeat2] = STATE(960),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(761),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [419] = {
    [sym_concatenation] = STATE(961),
    [sym_string] = STATE(966),
    [sym_array] = STATE(961),
    [sym_simple_expansion] = STATE(966),
    [sym_string_expansion] = STATE(966),
    [sym_expansion] = STATE(966),
    [sym_command_substitution] = STATE(966),
    [sym_process_substitution] = STATE(966),
    [sym__empty_value] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [sym__special_characters] = ACTIONS(1893),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [anon_sym_DOLLAR] = ACTIONS(1897),
    [sym_raw_string] = ACTIONS(1899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1903),
    [anon_sym_BQUOTE] = ACTIONS(1905),
    [anon_sym_LT_LPAREN] = ACTIONS(1907),
    [anon_sym_GT_LPAREN] = ACTIONS(1907),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1899),
  },
  [420] = {
    [sym__expression] = STATE(972),
    [sym_binary_expression] = STATE(972),
    [sym_unary_expression] = STATE(972),
    [sym_postfix_expression] = STATE(972),
    [sym_parenthesized_expression] = STATE(972),
    [sym_concatenation] = STATE(972),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(1909),
    [anon_sym_SEMI_SEMI] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
  },
  [421] = {
    [anon_sym_in] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1915),
    [anon_sym_SEMI_SEMI] = ACTIONS(1917),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
  },
  [422] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1919),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [423] = {
    [sym_do_group] = STATE(977),
    [anon_sym_do] = ACTIONS(1921),
    [sym_comment] = ACTIONS(57),
  },
  [424] = {
    [anon_sym_then] = ACTIONS(1923),
    [sym_comment] = ACTIONS(57),
  },
  [425] = {
    [aux_sym_concatenation_repeat1] = STATE(376),
    [sym__concat] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(1925),
    [anon_sym_SEMI] = ACTIONS(1927),
    [anon_sym_SEMI_SEMI] = ACTIONS(1929),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1929),
    [anon_sym_AMP] = ACTIONS(1929),
  },
  [426] = {
    [aux_sym_concatenation_repeat1] = STATE(376),
    [sym__concat] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(1931),
    [anon_sym_SEMI] = ACTIONS(1933),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [427] = {
    [anon_sym_in] = ACTIONS(1931),
    [anon_sym_SEMI] = ACTIONS(1933),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [428] = {
    [sym_compound_statement] = STATE(984),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [429] = {
    [anon_sym_RPAREN] = ACTIONS(1939),
    [sym_comment] = ACTIONS(57),
  },
  [430] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [431] = {
    [anon_sym_RBRACE] = ACTIONS(1941),
    [sym_comment] = ACTIONS(57),
  },
  [432] = {
    [sym__simple_heredoc_body] = ACTIONS(895),
    [sym__heredoc_body_beginning] = ACTIONS(895),
    [sym_file_descriptor] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [433] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1919),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [434] = {
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1919),
    [anon_sym_EQ_TILDE] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_EQ] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_BANG_EQ] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(931),
    [anon_sym_GT_EQ] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(931),
  },
  [435] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1943),
    [anon_sym_PLUS_EQ] = ACTIONS(1943),
    [sym_comment] = ACTIONS(57),
  },
  [436] = {
    [aux_sym_concatenation_repeat1] = STATE(989),
    [sym__simple_heredoc_body] = ACTIONS(939),
    [sym__heredoc_body_beginning] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(1945),
    [sym_variable_name] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [437] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(992),
    [anon_sym_DQUOTE] = ACTIONS(1947),
    [anon_sym_DOLLAR] = ACTIONS(1949),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [438] = {
    [sym_string] = STATE(994),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(1951),
    [sym_raw_string] = ACTIONS(1953),
    [anon_sym_POUND] = ACTIONS(1951),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1957),
    [anon_sym_QMARK] = ACTIONS(1957),
    [anon_sym_0] = ACTIONS(1955),
    [anon_sym__] = ACTIONS(1955),
  },
  [439] = {
    [aux_sym_concatenation_repeat1] = STATE(989),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(1945),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [440] = {
    [sym_subscript] = STATE(999),
    [sym_variable_name] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_DOLLAR] = ACTIONS(1963),
    [anon_sym_POUND] = ACTIONS(1961),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1967),
    [anon_sym_AT] = ACTIONS(1967),
    [anon_sym_QMARK] = ACTIONS(1967),
    [anon_sym_0] = ACTIONS(1965),
    [anon_sym__] = ACTIONS(1965),
  },
  [441] = {
    [sym__statements] = STATE(1000),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1001),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [442] = {
    [sym__statements] = STATE(1002),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [443] = {
    [sym__statements] = STATE(1003),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [444] = {
    [anon_sym_EQ] = ACTIONS(1943),
    [anon_sym_PLUS_EQ] = ACTIONS(1943),
    [sym_comment] = ACTIONS(57),
  },
  [445] = {
    [sym_variable_assignment] = STATE(1004),
    [sym_subscript] = STATE(444),
    [sym_concatenation] = STATE(1004),
    [sym_string] = STATE(439),
    [sym_simple_expansion] = STATE(439),
    [sym_string_expansion] = STATE(439),
    [sym_expansion] = STATE(439),
    [sym_command_substitution] = STATE(439),
    [sym_process_substitution] = STATE(439),
    [aux_sym_declaration_command_repeat1] = STATE(1004),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1969),
    [sym_word] = ACTIONS(807),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [446] = {
    [aux_sym_concatenation_repeat1] = STATE(1006),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [447] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1009),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [anon_sym_DOLLAR] = ACTIONS(1975),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [448] = {
    [sym_string] = STATE(1011),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(1977),
    [sym_raw_string] = ACTIONS(1979),
    [anon_sym_POUND] = ACTIONS(1977),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_AT] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1983),
    [anon_sym_0] = ACTIONS(1981),
    [anon_sym__] = ACTIONS(1981),
  },
  [449] = {
    [aux_sym_concatenation_repeat1] = STATE(1006),
    [sym__simple_heredoc_body] = ACTIONS(995),
    [sym__heredoc_body_beginning] = ACTIONS(995),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [450] = {
    [sym_subscript] = STATE(1016),
    [sym_variable_name] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_DOLLAR] = ACTIONS(1989),
    [anon_sym_POUND] = ACTIONS(1987),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_AT] = ACTIONS(1993),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_0] = ACTIONS(1991),
    [anon_sym__] = ACTIONS(1991),
  },
  [451] = {
    [sym__statements] = STATE(1017),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1018),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [452] = {
    [sym__statements] = STATE(1019),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [453] = {
    [sym__statements] = STATE(1020),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [454] = {
    [sym_concatenation] = STATE(1021),
    [sym_string] = STATE(449),
    [sym_simple_expansion] = STATE(449),
    [sym_string_expansion] = STATE(449),
    [sym_expansion] = STATE(449),
    [sym_command_substitution] = STATE(449),
    [sym_process_substitution] = STATE(449),
    [aux_sym_unset_command_repeat1] = STATE(1021),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1995),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [455] = {
    [sym_string] = STATE(1022),
    [sym_simple_expansion] = STATE(1022),
    [sym_string_expansion] = STATE(1022),
    [sym_expansion] = STATE(1022),
    [sym_command_substitution] = STATE(1022),
    [sym_process_substitution] = STATE(1022),
    [sym__special_characters] = ACTIONS(1997),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1997),
  },
  [456] = {
    [aux_sym_concatenation_repeat1] = STATE(1023),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [457] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1055),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [458] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [459] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [anon_sym_DOLLAR] = ACTIONS(2001),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [460] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [461] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [462] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [463] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2003),
    [sym_comment] = ACTIONS(57),
  },
  [464] = {
    [sym_subscript] = STATE(1029),
    [sym_variable_name] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_DOLLAR] = ACTIONS(2007),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(2011),
    [anon_sym_AT] = ACTIONS(2011),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_0] = ACTIONS(2009),
    [anon_sym__] = ACTIONS(2009),
  },
  [465] = {
    [sym_concatenation] = STATE(1032),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1032),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2015),
    [anon_sym_DASH] = ACTIONS(2015),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2019),
    [anon_sym_COLON] = ACTIONS(2015),
    [anon_sym_COLON_QMARK] = ACTIONS(2015),
    [anon_sym_COLON_DASH] = ACTIONS(2015),
    [anon_sym_PERCENT] = ACTIONS(2015),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [466] = {
    [sym_concatenation] = STATE(1035),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1035),
    [anon_sym_RBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2023),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(2023),
    [anon_sym_COLON_QMARK] = ACTIONS(2023),
    [anon_sym_COLON_DASH] = ACTIONS(2023),
    [anon_sym_PERCENT] = ACTIONS(2023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [467] = {
    [anon_sym_RPAREN] = ACTIONS(2029),
    [sym_comment] = ACTIONS(57),
  },
  [468] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [469] = {
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(57),
  },
  [470] = {
    [anon_sym_RPAREN] = ACTIONS(2031),
    [sym_comment] = ACTIONS(57),
  },
  [471] = {
    [anon_sym_RPAREN] = ACTIONS(2033),
    [sym_comment] = ACTIONS(57),
  },
  [472] = {
    [sym__simple_heredoc_body] = ACTIONS(2035),
    [sym__heredoc_body_beginning] = ACTIONS(2035),
    [sym_file_descriptor] = ACTIONS(2035),
    [ts_builtin_sym_end] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_done] = ACTIONS(2035),
    [anon_sym_fi] = ACTIONS(2035),
    [anon_sym_elif] = ACTIONS(2035),
    [anon_sym_else] = ACTIONS(2035),
    [anon_sym_esac] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_RPAREN] = ACTIONS(2035),
    [anon_sym_SEMI_SEMI] = ACTIONS(2035),
    [anon_sym_PIPE_AMP] = ACTIONS(2035),
    [anon_sym_AMP_AMP] = ACTIONS(2035),
    [anon_sym_PIPE_PIPE] = ACTIONS(2035),
    [anon_sym_LT] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2037),
    [anon_sym_GT_GT] = ACTIONS(2035),
    [anon_sym_AMP_GT] = ACTIONS(2037),
    [anon_sym_AMP_GT_GT] = ACTIONS(2035),
    [anon_sym_LT_AMP] = ACTIONS(2035),
    [anon_sym_GT_AMP] = ACTIONS(2035),
    [anon_sym_LT_LT] = ACTIONS(2037),
    [anon_sym_LT_LT_DASH] = ACTIONS(2035),
    [anon_sym_LT_LT_LT] = ACTIONS(2035),
    [anon_sym_BQUOTE] = ACTIONS(2035),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(2037),
  },
  [473] = {
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_SEMI_SEMI] = ACTIONS(1207),
    [anon_sym_RBRACE] = ACTIONS(1207),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
  },
  [474] = {
    [sym_simple_expansion] = STATE(1040),
    [sym_expansion] = STATE(1040),
    [sym_command_substitution] = STATE(1040),
    [aux_sym_heredoc_body_repeat1] = STATE(1040),
    [sym__heredoc_body_middle] = ACTIONS(2039),
    [sym__heredoc_body_end] = ACTIONS(2041),
    [anon_sym_DOLLAR] = ACTIONS(1215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1219),
    [anon_sym_BQUOTE] = ACTIONS(1221),
    [sym_comment] = ACTIONS(57),
  },
  [475] = {
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_GT] = ACTIONS(2045),
    [anon_sym_AMP_GT] = ACTIONS(2043),
    [anon_sym_AMP_GT_GT] = ACTIONS(2045),
    [anon_sym_LT_AMP] = ACTIONS(2045),
    [anon_sym_GT_AMP] = ACTIONS(2045),
    [sym_comment] = ACTIONS(57),
  },
  [476] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [477] = {
    [sym_redirected_statement] = STATE(1042),
    [sym_for_statement] = STATE(1042),
    [sym_c_style_for_statement] = STATE(1042),
    [sym_while_statement] = STATE(1042),
    [sym_if_statement] = STATE(1042),
    [sym_case_statement] = STATE(1042),
    [sym_function_definition] = STATE(1042),
    [sym_compound_statement] = STATE(1042),
    [sym_subshell] = STATE(1042),
    [sym_pipeline] = STATE(1042),
    [sym_list] = STATE(1042),
    [sym_negated_command] = STATE(1042),
    [sym_test_command] = STATE(1042),
    [sym_declaration_command] = STATE(1042),
    [sym_unset_command] = STATE(1042),
    [sym_command] = STATE(1042),
    [sym_command_name] = STATE(133),
    [sym_variable_assignment] = STATE(1043),
    [sym_subscript] = STATE(135),
    [sym_file_redirect] = STATE(138),
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_string_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(138),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [478] = {
    [sym_redirected_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_c_style_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_case_statement] = STATE(1044),
    [sym_function_definition] = STATE(1044),
    [sym_compound_statement] = STATE(1044),
    [sym_subshell] = STATE(1044),
    [sym_pipeline] = STATE(1044),
    [sym_list] = STATE(1044),
    [sym_negated_command] = STATE(1044),
    [sym_test_command] = STATE(1044),
    [sym_declaration_command] = STATE(1044),
    [sym_unset_command] = STATE(1044),
    [sym_command] = STATE(1044),
    [sym_command_name] = STATE(133),
    [sym_variable_assignment] = STATE(1045),
    [sym_subscript] = STATE(135),
    [sym_file_redirect] = STATE(138),
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_string_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(138),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [479] = {
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1047),
    [sym_simple_expansion] = STATE(1047),
    [sym_string_expansion] = STATE(1047),
    [sym_expansion] = STATE(1047),
    [sym_command_substitution] = STATE(1047),
    [sym_process_substitution] = STATE(1047),
    [sym__special_characters] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2049),
  },
  [480] = {
    [sym_heredoc_start] = ACTIONS(2051),
    [sym_comment] = ACTIONS(57),
  },
  [481] = {
    [sym_concatenation] = STATE(1052),
    [sym_string] = STATE(1051),
    [sym_simple_expansion] = STATE(1051),
    [sym_string_expansion] = STATE(1051),
    [sym_expansion] = STATE(1051),
    [sym_command_substitution] = STATE(1051),
    [sym_process_substitution] = STATE(1051),
    [sym__special_characters] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2055),
  },
  [482] = {
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_SEMI_SEMI] = ACTIONS(2059),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
  },
  [483] = {
    [sym_file_redirect] = STATE(1054),
    [sym_heredoc_redirect] = STATE(1054),
    [sym_herestring_redirect] = STATE(1054),
    [aux_sym_redirected_statement_repeat1] = STATE(1054),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [484] = {
    [sym_concatenation] = STATE(1055),
    [sym_string] = STATE(1057),
    [sym_simple_expansion] = STATE(1057),
    [sym_string_expansion] = STATE(1057),
    [sym_expansion] = STATE(1057),
    [sym_command_substitution] = STATE(1057),
    [sym_process_substitution] = STATE(1057),
    [sym_regex] = ACTIONS(2061),
    [sym__special_characters] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2065),
  },
  [485] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__simple_heredoc_body] = ACTIONS(1257),
    [sym__heredoc_body_beginning] = ACTIONS(1257),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [486] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [487] = {
    [sym_concatenation] = STATE(1058),
    [sym_string] = STATE(486),
    [sym_simple_expansion] = STATE(486),
    [sym_string_expansion] = STATE(486),
    [sym_expansion] = STATE(486),
    [sym_command_substitution] = STATE(486),
    [sym_process_substitution] = STATE(486),
    [aux_sym_command_repeat2] = STATE(1058),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(885),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [488] = {
    [sym_file_redirect] = STATE(483),
    [sym_heredoc_redirect] = STATE(483),
    [sym_heredoc_body] = STATE(1060),
    [sym_herestring_redirect] = STATE(483),
    [aux_sym_redirected_statement_repeat1] = STATE(483),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(2067),
  },
  [489] = {
    [sym_file_redirect] = STATE(483),
    [sym_heredoc_redirect] = STATE(483),
    [sym_heredoc_body] = STATE(1060),
    [sym_herestring_redirect] = STATE(483),
    [aux_sym_redirected_statement_repeat1] = STATE(483),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym__special_characters] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(2067),
  },
  [490] = {
    [sym_concatenation] = STATE(1061),
    [sym_string] = STATE(486),
    [sym_simple_expansion] = STATE(486),
    [sym_string_expansion] = STATE(486),
    [sym_expansion] = STATE(486),
    [sym_command_substitution] = STATE(486),
    [sym_process_substitution] = STATE(486),
    [aux_sym_command_repeat2] = STATE(1061),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(885),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [491] = {
    [sym_concatenation] = STATE(1062),
    [sym_string] = STATE(1065),
    [sym_array] = STATE(1062),
    [sym_simple_expansion] = STATE(1065),
    [sym_string_expansion] = STATE(1065),
    [sym_expansion] = STATE(1065),
    [sym_command_substitution] = STATE(1065),
    [sym_process_substitution] = STATE(1065),
    [sym__empty_value] = ACTIONS(2071),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [sym__special_characters] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2077),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2077),
  },
  [492] = {
    [anon_sym_RPAREN] = ACTIONS(2079),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_EQ_EQ] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_PLUS_EQ] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_DASH_EQ] = ACTIONS(1517),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1517),
  },
  [493] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1525),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [494] = {
    [sym_string] = STATE(1067),
    [sym_simple_expansion] = STATE(1067),
    [sym_string_expansion] = STATE(1067),
    [sym_expansion] = STATE(1067),
    [sym_command_substitution] = STATE(1067),
    [sym_process_substitution] = STATE(1067),
    [sym__special_characters] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2081),
  },
  [495] = {
    [aux_sym_concatenation_repeat1] = STATE(1068),
    [sym__concat] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_RBRACK] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1051),
    [anon_sym_PLUS_EQ] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_BANG_EQ] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_DASH_EQ] = ACTIONS(1049),
    [anon_sym_LT_EQ] = ACTIONS(1049),
    [anon_sym_GT_EQ] = ACTIONS(1049),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1049),
  },
  [496] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_RBRACK] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1053),
    [anon_sym_EQ_EQ] = ACTIONS(1053),
    [anon_sym_EQ] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_BANG_EQ] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1053),
    [anon_sym_GT_EQ] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1053),
  },
  [497] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [498] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DOLLAR] = ACTIONS(2085),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [499] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_RBRACK] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1087),
  },
  [500] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_RBRACK] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1091),
  },
  [501] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_RBRACK] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1097),
    [anon_sym_PLUS_EQ] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_DASH_EQ] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1095),
  },
  [502] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2087),
    [sym_comment] = ACTIONS(57),
  },
  [503] = {
    [sym_subscript] = STATE(1074),
    [sym_variable_name] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_DOLLAR] = ACTIONS(2091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2095),
    [anon_sym_0] = ACTIONS(2093),
    [anon_sym__] = ACTIONS(2093),
  },
  [504] = {
    [sym_concatenation] = STATE(1077),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1077),
    [anon_sym_RBRACE] = ACTIONS(2097),
    [anon_sym_EQ] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(2099),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_COLON] = ACTIONS(2099),
    [anon_sym_COLON_QMARK] = ACTIONS(2099),
    [anon_sym_COLON_DASH] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [505] = {
    [sym_concatenation] = STATE(1080),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1080),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_EQ] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2107),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_COLON] = ACTIONS(2107),
    [anon_sym_COLON_QMARK] = ACTIONS(2107),
    [anon_sym_COLON_DASH] = ACTIONS(2107),
    [anon_sym_PERCENT] = ACTIONS(2107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [506] = {
    [anon_sym_RPAREN] = ACTIONS(2113),
    [sym_comment] = ACTIONS(57),
  },
  [507] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2113),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [508] = {
    [anon_sym_BQUOTE] = ACTIONS(2113),
    [sym_comment] = ACTIONS(57),
  },
  [509] = {
    [anon_sym_RPAREN] = ACTIONS(2115),
    [sym_comment] = ACTIONS(57),
  },
  [510] = {
    [sym__expression] = STATE(1083),
    [sym_binary_expression] = STATE(1083),
    [sym_unary_expression] = STATE(1083),
    [sym_postfix_expression] = STATE(1083),
    [sym_parenthesized_expression] = STATE(1083),
    [sym_concatenation] = STATE(1083),
    [sym_string] = STATE(147),
    [sym_simple_expansion] = STATE(147),
    [sym_string_expansion] = STATE(147),
    [sym_expansion] = STATE(147),
    [sym_command_substitution] = STATE(147),
    [sym_process_substitution] = STATE(147),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_characters] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [511] = {
    [sym__expression] = STATE(1083),
    [sym_binary_expression] = STATE(1083),
    [sym_unary_expression] = STATE(1083),
    [sym_postfix_expression] = STATE(1083),
    [sym_parenthesized_expression] = STATE(1083),
    [sym_concatenation] = STATE(1083),
    [sym_string] = STATE(147),
    [sym_simple_expansion] = STATE(147),
    [sym_string_expansion] = STATE(147),
    [sym_expansion] = STATE(147),
    [sym_command_substitution] = STATE(147),
    [sym_process_substitution] = STATE(147),
    [sym_regex] = ACTIONS(2117),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_characters] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [512] = {
    [anon_sym_AMP_AMP] = ACTIONS(1569),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [anon_sym_RBRACK] = ACTIONS(1569),
    [anon_sym_EQ_TILDE] = ACTIONS(1569),
    [anon_sym_EQ_EQ] = ACTIONS(1569),
    [anon_sym_EQ] = ACTIONS(1571),
    [anon_sym_PLUS_EQ] = ACTIONS(1569),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_BANG_EQ] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1571),
    [anon_sym_DASH_EQ] = ACTIONS(1569),
    [anon_sym_LT_EQ] = ACTIONS(1569),
    [anon_sym_GT_EQ] = ACTIONS(1569),
    [anon_sym_PLUS_PLUS] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1569),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1569),
  },
  [513] = {
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1525),
    [anon_sym_EQ_TILDE] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_EQ] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_BANG_EQ] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(931),
    [anon_sym_GT_EQ] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(931),
  },
  [514] = {
    [aux_sym_concatenation_repeat1] = STATE(1085),
    [sym__concat] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1051),
    [anon_sym_PLUS_EQ] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_BANG_EQ] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_DASH_EQ] = ACTIONS(1049),
    [anon_sym_LT_EQ] = ACTIONS(1049),
    [anon_sym_GT_EQ] = ACTIONS(1049),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1049),
  },
  [515] = {
    [sym__expression] = STATE(772),
    [sym_binary_expression] = STATE(772),
    [sym_unary_expression] = STATE(772),
    [sym_postfix_expression] = STATE(772),
    [sym_parenthesized_expression] = STATE(772),
    [sym_concatenation] = STATE(772),
    [sym_string] = STATE(155),
    [sym_simple_expansion] = STATE(155),
    [sym_string_expansion] = STATE(155),
    [sym_expansion] = STATE(155),
    [sym_command_substitution] = STATE(155),
    [sym_process_substitution] = STATE(155),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [516] = {
    [sym__expression] = STATE(772),
    [sym_binary_expression] = STATE(772),
    [sym_unary_expression] = STATE(772),
    [sym_postfix_expression] = STATE(772),
    [sym_parenthesized_expression] = STATE(772),
    [sym_concatenation] = STATE(772),
    [sym_string] = STATE(155),
    [sym_simple_expansion] = STATE(155),
    [sym_string_expansion] = STATE(155),
    [sym_expansion] = STATE(155),
    [sym_command_substitution] = STATE(155),
    [sym_process_substitution] = STATE(155),
    [sym_regex] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [517] = {
    [sym_concatenation] = STATE(1086),
    [sym_string] = STATE(1089),
    [sym_array] = STATE(1086),
    [sym_simple_expansion] = STATE(1089),
    [sym_string_expansion] = STATE(1089),
    [sym_expansion] = STATE(1089),
    [sym_command_substitution] = STATE(1089),
    [sym_process_substitution] = STATE(1089),
    [sym__empty_value] = ACTIONS(2119),
    [anon_sym_LPAREN] = ACTIONS(2121),
    [sym__special_characters] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(2125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2125),
  },
  [518] = {
    [sym_string] = STATE(1090),
    [sym_simple_expansion] = STATE(1090),
    [sym_string_expansion] = STATE(1090),
    [sym_expansion] = STATE(1090),
    [sym_command_substitution] = STATE(1090),
    [sym_process_substitution] = STATE(1090),
    [sym__special_characters] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(2127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2127),
  },
  [519] = {
    [aux_sym_concatenation_repeat1] = STATE(1091),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1049),
    [ts_builtin_sym_end] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [520] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [521] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [522] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2131),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [523] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [ts_builtin_sym_end] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [524] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [ts_builtin_sym_end] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [525] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [526] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2133),
    [sym_comment] = ACTIONS(57),
  },
  [527] = {
    [sym_subscript] = STATE(1097),
    [sym_variable_name] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(2137),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2139),
    [anon_sym_STAR] = ACTIONS(2141),
    [anon_sym_AT] = ACTIONS(2141),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_0] = ACTIONS(2139),
    [anon_sym__] = ACTIONS(2139),
  },
  [528] = {
    [sym_concatenation] = STATE(1100),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1100),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_EQ] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_COLON_QMARK] = ACTIONS(2145),
    [anon_sym_COLON_DASH] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [529] = {
    [sym_concatenation] = STATE(1103),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1103),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_EQ] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2153),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2155),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2157),
    [anon_sym_COLON] = ACTIONS(2153),
    [anon_sym_COLON_QMARK] = ACTIONS(2153),
    [anon_sym_COLON_DASH] = ACTIONS(2153),
    [anon_sym_PERCENT] = ACTIONS(2153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [530] = {
    [anon_sym_RPAREN] = ACTIONS(2159),
    [sym_comment] = ACTIONS(57),
  },
  [531] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2159),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [532] = {
    [anon_sym_BQUOTE] = ACTIONS(2159),
    [sym_comment] = ACTIONS(57),
  },
  [533] = {
    [anon_sym_RPAREN] = ACTIONS(2161),
    [sym_comment] = ACTIONS(57),
  },
  [534] = {
    [sym_variable_assignment] = STATE(534),
    [sym_subscript] = STATE(166),
    [sym_concatenation] = STATE(534),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_string_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_declaration_command_repeat1] = STATE(534),
    [sym__simple_heredoc_body] = ACTIONS(2163),
    [sym__heredoc_body_beginning] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(2165),
    [ts_builtin_sym_end] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(2170),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [anon_sym_DOLLAR] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2185),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [anon_sym_LT_LPAREN] = ACTIONS(2191),
    [anon_sym_GT_LPAREN] = ACTIONS(2191),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2194),
    [sym_word] = ACTIONS(2197),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [535] = {
    [sym_string] = STATE(1106),
    [sym_simple_expansion] = STATE(1106),
    [sym_string_expansion] = STATE(1106),
    [sym_expansion] = STATE(1106),
    [sym_command_substitution] = STATE(1106),
    [sym_process_substitution] = STATE(1106),
    [sym__special_characters] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(2200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2200),
  },
  [536] = {
    [aux_sym_concatenation_repeat1] = STATE(1107),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(979),
    [ts_builtin_sym_end] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [537] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [538] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [539] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [540] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [ts_builtin_sym_end] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [541] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [ts_builtin_sym_end] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [542] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [543] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2206),
    [sym_comment] = ACTIONS(57),
  },
  [544] = {
    [sym_subscript] = STATE(1113),
    [sym_variable_name] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_DOLLAR] = ACTIONS(2210),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_AT] = ACTIONS(2214),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_0] = ACTIONS(2212),
    [anon_sym__] = ACTIONS(2212),
  },
  [545] = {
    [sym_concatenation] = STATE(1116),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1116),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [anon_sym_EQ] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2218),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2218),
    [anon_sym_COLON_QMARK] = ACTIONS(2218),
    [anon_sym_COLON_DASH] = ACTIONS(2218),
    [anon_sym_PERCENT] = ACTIONS(2218),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [546] = {
    [sym_concatenation] = STATE(1119),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1119),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2230),
    [anon_sym_COLON] = ACTIONS(2226),
    [anon_sym_COLON_QMARK] = ACTIONS(2226),
    [anon_sym_COLON_DASH] = ACTIONS(2226),
    [anon_sym_PERCENT] = ACTIONS(2226),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [547] = {
    [anon_sym_RPAREN] = ACTIONS(2232),
    [sym_comment] = ACTIONS(57),
  },
  [548] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [549] = {
    [anon_sym_BQUOTE] = ACTIONS(2232),
    [sym_comment] = ACTIONS(57),
  },
  [550] = {
    [anon_sym_RPAREN] = ACTIONS(2234),
    [sym_comment] = ACTIONS(57),
  },
  [551] = {
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_unset_command_repeat1] = STATE(551),
    [sym__simple_heredoc_body] = ACTIONS(2236),
    [sym__heredoc_body_beginning] = ACTIONS(2236),
    [sym_file_descriptor] = ACTIONS(2236),
    [ts_builtin_sym_end] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(2240),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [sym_raw_string] = ACTIONS(2249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(2258),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2264),
    [sym_word] = ACTIONS(2267),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [552] = {
    [sym_string] = STATE(1122),
    [sym_simple_expansion] = STATE(1122),
    [sym_string_expansion] = STATE(1122),
    [sym_expansion] = STATE(1122),
    [sym_command_substitution] = STATE(1122),
    [sym_process_substitution] = STATE(1122),
    [sym__special_characters] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2270),
  },
  [553] = {
    [aux_sym_concatenation_repeat1] = STATE(1123),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1049),
  },
  [554] = {
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1053),
  },
  [555] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [556] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_DOLLAR] = ACTIONS(2274),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [557] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1087),
  },
  [558] = {
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
  },
  [559] = {
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1095),
  },
  [560] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2276),
    [sym_comment] = ACTIONS(57),
  },
  [561] = {
    [sym_subscript] = STATE(1129),
    [sym_variable_name] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_DOLLAR] = ACTIONS(2280),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_AT] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2284),
    [anon_sym_0] = ACTIONS(2282),
    [anon_sym__] = ACTIONS(2282),
  },
  [562] = {
    [sym_concatenation] = STATE(1132),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1132),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_COLON_QMARK] = ACTIONS(2288),
    [anon_sym_COLON_DASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [563] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1135),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2296),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_COLON_QMARK] = ACTIONS(2296),
    [anon_sym_COLON_DASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [564] = {
    [anon_sym_RPAREN] = ACTIONS(2302),
    [sym_comment] = ACTIONS(57),
  },
  [565] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [566] = {
    [anon_sym_BQUOTE] = ACTIONS(2302),
    [sym_comment] = ACTIONS(57),
  },
  [567] = {
    [anon_sym_RPAREN] = ACTIONS(2304),
    [sym_comment] = ACTIONS(57),
  },
  [568] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [569] = {
    [aux_sym_concatenation_repeat1] = STATE(569),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2310),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [570] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym__string_content] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(343),
  },
  [571] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [572] = {
    [sym__concat] = ACTIONS(2317),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_DOLLAR] = ACTIONS(2319),
    [sym__string_content] = ACTIONS(2321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2319),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(343),
  },
  [573] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym__string_content] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(343),
  },
  [574] = {
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_DOLLAR] = ACTIONS(2319),
    [sym__string_content] = ACTIONS(2321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2319),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(343),
  },
  [575] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2323),
    [sym_comment] = ACTIONS(57),
  },
  [576] = {
    [sym_subscript] = STATE(1142),
    [sym_variable_name] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2327),
    [anon_sym_DOLLAR] = ACTIONS(2327),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2331),
    [anon_sym_QMARK] = ACTIONS(2331),
    [anon_sym_0] = ACTIONS(2329),
    [anon_sym__] = ACTIONS(2329),
  },
  [577] = {
    [sym_concatenation] = STATE(1145),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1145),
    [anon_sym_RBRACE] = ACTIONS(2333),
    [anon_sym_EQ] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2335),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2339),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_QMARK] = ACTIONS(2335),
    [anon_sym_COLON_DASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [578] = {
    [sym_concatenation] = STATE(1148),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1148),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_DASH] = ACTIONS(2343),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2343),
    [anon_sym_COLON_QMARK] = ACTIONS(2343),
    [anon_sym_COLON_DASH] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [579] = {
    [anon_sym_RPAREN] = ACTIONS(2349),
    [sym_comment] = ACTIONS(57),
  },
  [580] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [581] = {
    [anon_sym_BQUOTE] = ACTIONS(2349),
    [sym_comment] = ACTIONS(57),
  },
  [582] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [583] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym__string_content] = ACTIONS(2356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2365),
    [sym_comment] = ACTIONS(343),
  },
  [584] = {
    [sym_concatenation] = STATE(1154),
    [sym_string] = STATE(1153),
    [sym_simple_expansion] = STATE(1153),
    [sym_string_expansion] = STATE(1153),
    [sym_expansion] = STATE(1153),
    [sym_command_substitution] = STATE(1153),
    [sym_process_substitution] = STATE(1153),
    [sym__special_characters] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2370),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2370),
  },
  [585] = {
    [sym_concatenation] = STATE(1164),
    [sym_string] = STATE(1159),
    [sym_simple_expansion] = STATE(1159),
    [sym_string_expansion] = STATE(1159),
    [sym_expansion] = STATE(1159),
    [sym_command_substitution] = STATE(1159),
    [sym_process_substitution] = STATE(1159),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [sym__special_characters] = ACTIONS(2374),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(2380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2380),
  },
  [586] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2390),
    [sym_comment] = ACTIONS(57),
  },
  [587] = {
    [sym_concatenation] = STATE(1168),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1168),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_EQ] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2396),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2398),
    [anon_sym_COLON] = ACTIONS(2394),
    [anon_sym_COLON_QMARK] = ACTIONS(2394),
    [anon_sym_COLON_DASH] = ACTIONS(2394),
    [anon_sym_PERCENT] = ACTIONS(2394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [588] = {
    [sym_concatenation] = STATE(1170),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1170),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_EQ] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2402),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_COLON] = ACTIONS(2400),
    [anon_sym_COLON_QMARK] = ACTIONS(2400),
    [anon_sym_COLON_DASH] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [589] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [ts_builtin_sym_end] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [590] = {
    [aux_sym_concatenation_repeat1] = STATE(1172),
    [sym__concat] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_EQ] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [sym__special_characters] = ACTIONS(2414),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(2412),
    [anon_sym_POUND] = ACTIONS(2412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2412),
    [anon_sym_COLON] = ACTIONS(2414),
    [anon_sym_COLON_QMARK] = ACTIONS(2414),
    [anon_sym_COLON_DASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2412),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [anon_sym_LT_LPAREN] = ACTIONS(2412),
    [anon_sym_GT_LPAREN] = ACTIONS(2412),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2414),
  },
  [591] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1175),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [592] = {
    [sym_string] = STATE(1177),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(2420),
    [sym_raw_string] = ACTIONS(2422),
    [anon_sym_POUND] = ACTIONS(2420),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2424),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2426),
    [anon_sym_QMARK] = ACTIONS(2426),
    [anon_sym_0] = ACTIONS(2424),
    [anon_sym__] = ACTIONS(2424),
  },
  [593] = {
    [aux_sym_concatenation_repeat1] = STATE(1172),
    [sym__concat] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym_raw_string] = ACTIONS(2428),
    [anon_sym_POUND] = ACTIONS(2428),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2430),
    [anon_sym_COLON_QMARK] = ACTIONS(2430),
    [anon_sym_COLON_DASH] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_LT_LPAREN] = ACTIONS(2428),
    [anon_sym_GT_LPAREN] = ACTIONS(2428),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2430),
  },
  [594] = {
    [sym_subscript] = STATE(1182),
    [sym_variable_name] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_DOLLAR] = ACTIONS(2436),
    [anon_sym_POUND] = ACTIONS(2434),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_AT] = ACTIONS(2440),
    [anon_sym_QMARK] = ACTIONS(2440),
    [anon_sym_0] = ACTIONS(2438),
    [anon_sym__] = ACTIONS(2438),
  },
  [595] = {
    [sym_concatenation] = STATE(1185),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1185),
    [sym_regex] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_EQ] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2448),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2446),
    [anon_sym_COLON_QMARK] = ACTIONS(2446),
    [anon_sym_COLON_DASH] = ACTIONS(2446),
    [anon_sym_PERCENT] = ACTIONS(2446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [596] = {
    [sym__statements] = STATE(1186),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1187),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [597] = {
    [sym__statements] = STATE(1188),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [598] = {
    [sym__statements] = STATE(1189),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [599] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [600] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [ts_builtin_sym_end] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [601] = {
    [sym_concatenation] = STATE(1170),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1170),
    [sym_regex] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_EQ] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2402),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2400),
    [anon_sym_COLON_QMARK] = ACTIONS(2400),
    [anon_sym_COLON_DASH] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [602] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [603] = {
    [sym_concatenation] = STATE(244),
    [sym_string] = STATE(1193),
    [sym_simple_expansion] = STATE(1193),
    [sym_string_expansion] = STATE(1193),
    [sym_expansion] = STATE(1193),
    [sym_command_substitution] = STATE(1193),
    [sym_process_substitution] = STATE(1193),
    [sym__special_characters] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2462),
  },
  [604] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1015),
    [anon_sym_RPAREN] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [sym__special_characters] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1015),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1015),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [anon_sym_LT_LPAREN] = ACTIONS(1015),
    [anon_sym_GT_LPAREN] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1015),
  },
  [605] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1033),
    [anon_sym_RPAREN] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [sym__special_characters] = ACTIONS(1033),
    [anon_sym_DQUOTE] = ACTIONS(1033),
    [anon_sym_DOLLAR] = ACTIONS(1035),
    [sym_raw_string] = ACTIONS(1033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1033),
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [anon_sym_LT_LPAREN] = ACTIONS(1033),
    [anon_sym_GT_LPAREN] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1033),
  },
  [606] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [ts_builtin_sym_end] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [607] = {
    [sym_concatenation] = STATE(248),
    [sym_string] = STATE(1196),
    [sym_array] = STATE(248),
    [sym_simple_expansion] = STATE(1196),
    [sym_string_expansion] = STATE(1196),
    [sym_expansion] = STATE(1196),
    [sym_command_substitution] = STATE(1196),
    [sym_process_substitution] = STATE(1196),
    [sym__empty_value] = ACTIONS(447),
    [anon_sym_LPAREN] = ACTIONS(449),
    [sym__special_characters] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(455),
    [sym_raw_string] = ACTIONS(2470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(463),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2470),
  },
  [608] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_PLUS_EQ] = ACTIONS(2472),
    [sym_comment] = ACTIONS(57),
  },
  [609] = {
    [aux_sym_concatenation_repeat1] = STATE(1198),
    [sym__simple_heredoc_body] = ACTIONS(939),
    [sym__heredoc_body_beginning] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [610] = {
    [aux_sym_concatenation_repeat1] = STATE(1198),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [611] = {
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_PLUS_EQ] = ACTIONS(2472),
    [sym_comment] = ACTIONS(57),
  },
  [612] = {
    [sym_variable_assignment] = STATE(1199),
    [sym_subscript] = STATE(611),
    [sym_concatenation] = STATE(1199),
    [sym_string] = STATE(610),
    [sym_simple_expansion] = STATE(610),
    [sym_string_expansion] = STATE(610),
    [sym_expansion] = STATE(610),
    [sym_command_substitution] = STATE(610),
    [sym_process_substitution] = STATE(610),
    [aux_sym_declaration_command_repeat1] = STATE(1199),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2474),
    [sym_word] = ACTIONS(1165),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [613] = {
    [aux_sym_concatenation_repeat1] = STATE(1200),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [614] = {
    [aux_sym_concatenation_repeat1] = STATE(1200),
    [sym__simple_heredoc_body] = ACTIONS(995),
    [sym__heredoc_body_beginning] = ACTIONS(995),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [615] = {
    [sym_concatenation] = STATE(1201),
    [sym_string] = STATE(614),
    [sym_simple_expansion] = STATE(614),
    [sym_string_expansion] = STATE(614),
    [sym_expansion] = STATE(614),
    [sym_command_substitution] = STATE(614),
    [sym_process_substitution] = STATE(614),
    [aux_sym_unset_command_repeat1] = STATE(1201),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1009),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2476),
    [sym_word] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [616] = {
    [aux_sym_concatenation_repeat1] = STATE(1202),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [617] = {
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2480),
    [anon_sym_AMP_GT] = ACTIONS(2478),
    [anon_sym_AMP_GT_GT] = ACTIONS(2480),
    [anon_sym_LT_AMP] = ACTIONS(2480),
    [anon_sym_GT_AMP] = ACTIONS(2480),
    [sym_comment] = ACTIONS(57),
  },
  [618] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [619] = {
    [sym_redirected_statement] = STATE(1204),
    [sym_for_statement] = STATE(1204),
    [sym_c_style_for_statement] = STATE(1204),
    [sym_while_statement] = STATE(1204),
    [sym_if_statement] = STATE(1204),
    [sym_case_statement] = STATE(1204),
    [sym_function_definition] = STATE(1204),
    [sym_compound_statement] = STATE(1204),
    [sym_subshell] = STATE(1204),
    [sym_pipeline] = STATE(1204),
    [sym_list] = STATE(1204),
    [sym_negated_command] = STATE(1204),
    [sym_test_command] = STATE(1204),
    [sym_declaration_command] = STATE(1204),
    [sym_unset_command] = STATE(1204),
    [sym_command] = STATE(1204),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(1205),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [620] = {
    [sym_redirected_statement] = STATE(1206),
    [sym_for_statement] = STATE(1206),
    [sym_c_style_for_statement] = STATE(1206),
    [sym_while_statement] = STATE(1206),
    [sym_if_statement] = STATE(1206),
    [sym_case_statement] = STATE(1206),
    [sym_function_definition] = STATE(1206),
    [sym_compound_statement] = STATE(1206),
    [sym_subshell] = STATE(1206),
    [sym_pipeline] = STATE(1206),
    [sym_list] = STATE(1206),
    [sym_negated_command] = STATE(1206),
    [sym_test_command] = STATE(1206),
    [sym_declaration_command] = STATE(1206),
    [sym_unset_command] = STATE(1206),
    [sym_command] = STATE(1206),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(1207),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [621] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(1209),
    [sym_simple_expansion] = STATE(1209),
    [sym_string_expansion] = STATE(1209),
    [sym_expansion] = STATE(1209),
    [sym_command_substitution] = STATE(1209),
    [sym_process_substitution] = STATE(1209),
    [sym__special_characters] = ACTIONS(2482),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2484),
  },
  [622] = {
    [sym_concatenation] = STATE(651),
    [sym_string] = STATE(1211),
    [sym_simple_expansion] = STATE(1211),
    [sym_string_expansion] = STATE(1211),
    [sym_expansion] = STATE(1211),
    [sym_command_substitution] = STATE(1211),
    [sym_process_substitution] = STATE(1211),
    [sym__special_characters] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2488),
  },
  [623] = {
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
  },
  [624] = {
    [sym_file_redirect] = STATE(1213),
    [sym_heredoc_redirect] = STATE(1213),
    [sym_herestring_redirect] = STATE(1213),
    [aux_sym_redirected_statement_repeat1] = STATE(1213),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1189),
    [anon_sym_LT_AMP] = ACTIONS(1189),
    [anon_sym_GT_AMP] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1191),
    [anon_sym_BQUOTE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [625] = {
    [sym_concatenation] = STATE(654),
    [sym_string] = STATE(1215),
    [sym_simple_expansion] = STATE(1215),
    [sym_string_expansion] = STATE(1215),
    [sym_expansion] = STATE(1215),
    [sym_command_substitution] = STATE(1215),
    [sym_process_substitution] = STATE(1215),
    [sym_regex] = ACTIONS(1251),
    [sym__special_characters] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2496),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2496),
  },
  [626] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__simple_heredoc_body] = ACTIONS(1257),
    [sym__heredoc_body_beginning] = ACTIONS(1257),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [627] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [628] = {
    [sym_concatenation] = STATE(1216),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(1216),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1265),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [629] = {
    [sym_file_redirect] = STATE(624),
    [sym_heredoc_redirect] = STATE(624),
    [sym_heredoc_body] = STATE(1218),
    [sym_herestring_redirect] = STATE(624),
    [aux_sym_redirected_statement_repeat1] = STATE(624),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(1183),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1189),
    [anon_sym_LT_AMP] = ACTIONS(1189),
    [anon_sym_GT_AMP] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1191),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2498),
  },
  [630] = {
    [sym_file_redirect] = STATE(624),
    [sym_heredoc_redirect] = STATE(624),
    [sym_heredoc_body] = STATE(1218),
    [sym_herestring_redirect] = STATE(624),
    [aux_sym_redirected_statement_repeat1] = STATE(624),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(1183),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1191),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2498),
  },
  [631] = {
    [sym_concatenation] = STATE(1219),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(1219),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1265),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [632] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [ts_builtin_sym_end] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2504),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [633] = {
    [sym_compound_statement] = STATE(1220),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_done] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_elif] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_esac] = ACTIONS(2506),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
  },
  [635] = {
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_POUND] = ACTIONS(2510),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_0] = ACTIONS(2512),
    [anon_sym__] = ACTIONS(2512),
  },
  [636] = {
    [sym_subscript] = STATE(1226),
    [sym_variable_name] = ACTIONS(2516),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2520),
    [anon_sym_POUND] = ACTIONS(2518),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [anon_sym_STAR] = ACTIONS(2524),
    [anon_sym_AT] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(2524),
    [anon_sym_0] = ACTIONS(2522),
    [anon_sym__] = ACTIONS(2522),
  },
  [637] = {
    [sym__statements] = STATE(1227),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1228),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [638] = {
    [sym__statements] = STATE(1229),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [639] = {
    [sym_simple_expansion] = STATE(1231),
    [sym_expansion] = STATE(1231),
    [sym_command_substitution] = STATE(1231),
    [aux_sym_heredoc_body_repeat1] = STATE(1231),
    [sym__heredoc_body_middle] = ACTIONS(2526),
    [sym__heredoc_body_end] = ACTIONS(2528),
    [anon_sym_DOLLAR] = ACTIONS(1215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1219),
    [anon_sym_BQUOTE] = ACTIONS(1221),
    [sym_comment] = ACTIONS(57),
  },
  [640] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(1233),
    [sym_simple_expansion] = STATE(1233),
    [sym_string_expansion] = STATE(1233),
    [sym_expansion] = STATE(1233),
    [sym_command_substitution] = STATE(1233),
    [sym_process_substitution] = STATE(1233),
    [sym__special_characters] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2532),
  },
  [641] = {
    [sym_file_redirect] = STATE(232),
    [sym_heredoc_redirect] = STATE(232),
    [sym_herestring_redirect] = STATE(232),
    [aux_sym_redirected_statement_repeat1] = STATE(232),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [ts_builtin_sym_end] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [642] = {
    [sym_file_redirect] = STATE(232),
    [sym_heredoc_redirect] = STATE(232),
    [sym_herestring_redirect] = STATE(232),
    [aux_sym_redirected_statement_repeat1] = STATE(232),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [643] = {
    [sym_file_redirect] = STATE(232),
    [sym_heredoc_redirect] = STATE(232),
    [sym_herestring_redirect] = STATE(232),
    [aux_sym_redirected_statement_repeat1] = STATE(232),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [ts_builtin_sym_end] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [644] = {
    [sym_file_redirect] = STATE(232),
    [sym_heredoc_redirect] = STATE(232),
    [sym_herestring_redirect] = STATE(232),
    [aux_sym_redirected_statement_repeat1] = STATE(232),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [645] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1015),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [646] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [647] = {
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_done] = ACTIONS(1033),
    [anon_sym_fi] = ACTIONS(1033),
    [anon_sym_elif] = ACTIONS(1033),
    [anon_sym_else] = ACTIONS(1033),
    [anon_sym_esac] = ACTIONS(1033),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_RPAREN] = ACTIONS(1033),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [648] = {
    [sym__simple_heredoc_body] = ACTIONS(2542),
    [sym__heredoc_body_beginning] = ACTIONS(2542),
    [sym_file_descriptor] = ACTIONS(2542),
    [ts_builtin_sym_end] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_done] = ACTIONS(2542),
    [anon_sym_fi] = ACTIONS(2542),
    [anon_sym_elif] = ACTIONS(2542),
    [anon_sym_else] = ACTIONS(2542),
    [anon_sym_esac] = ACTIONS(2542),
    [anon_sym_PIPE] = ACTIONS(2544),
    [anon_sym_RPAREN] = ACTIONS(2542),
    [anon_sym_SEMI_SEMI] = ACTIONS(2542),
    [anon_sym_PIPE_AMP] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2542),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_GT] = ACTIONS(2544),
    [anon_sym_GT_GT] = ACTIONS(2542),
    [anon_sym_AMP_GT] = ACTIONS(2544),
    [anon_sym_AMP_GT_GT] = ACTIONS(2542),
    [anon_sym_LT_AMP] = ACTIONS(2542),
    [anon_sym_GT_AMP] = ACTIONS(2542),
    [anon_sym_LT_LT] = ACTIONS(2544),
    [anon_sym_LT_LT_DASH] = ACTIONS(2542),
    [anon_sym_LT_LT_LT] = ACTIONS(2542),
    [anon_sym_BQUOTE] = ACTIONS(2542),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2544),
  },
  [649] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(2546),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [650] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [651] = {
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [ts_builtin_sym_end] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_done] = ACTIONS(2550),
    [anon_sym_fi] = ACTIONS(2550),
    [anon_sym_elif] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_esac] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2550),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [anon_sym_BQUOTE] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [652] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [ts_builtin_sym_end] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_RPAREN] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2556),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [653] = {
    [sym_file_redirect] = STATE(653),
    [sym_heredoc_redirect] = STATE(653),
    [sym_herestring_redirect] = STATE(653),
    [aux_sym_redirected_statement_repeat1] = STATE(653),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(2562),
    [ts_builtin_sym_end] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(2567),
    [anon_sym_GT] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT] = ACTIONS(2567),
    [anon_sym_AMP_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_AMP] = ACTIONS(2570),
    [anon_sym_GT_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2579),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [654] = {
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [ts_builtin_sym_end] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [655] = {
    [aux_sym_concatenation_repeat1] = STATE(187),
    [sym__simple_heredoc_body] = ACTIONS(2586),
    [sym__heredoc_body_beginning] = ACTIONS(2586),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [656] = {
    [aux_sym_concatenation_repeat1] = STATE(187),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [657] = {
    [sym_concatenation] = STATE(657),
    [sym_string] = STATE(235),
    [sym_simple_expansion] = STATE(235),
    [sym_string_expansion] = STATE(235),
    [sym_expansion] = STATE(235),
    [sym_command_substitution] = STATE(235),
    [sym_process_substitution] = STATE(235),
    [aux_sym_command_repeat2] = STATE(657),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [ts_builtin_sym_end] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2593),
    [anon_sym_DQUOTE] = ACTIONS(2596),
    [anon_sym_DOLLAR] = ACTIONS(2599),
    [sym_raw_string] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2608),
    [anon_sym_BQUOTE] = ACTIONS(2611),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2617),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [658] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [ts_builtin_sym_end] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_RPAREN] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2556),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_RPAREN] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2622),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2622),
  },
  [660] = {
    [sym_subshell] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(666),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [661] = {
    [sym_variable_assignment] = STATE(1237),
    [sym_subscript] = STATE(611),
    [sym_concatenation] = STATE(1237),
    [sym_string] = STATE(610),
    [sym_simple_expansion] = STATE(610),
    [sym_string_expansion] = STATE(610),
    [sym_expansion] = STATE(610),
    [sym_command_substitution] = STATE(610),
    [sym_process_substitution] = STATE(610),
    [aux_sym_declaration_command_repeat1] = STATE(1237),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2624),
    [sym_word] = ACTIONS(1165),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [662] = {
    [sym_concatenation] = STATE(1238),
    [sym_string] = STATE(614),
    [sym_simple_expansion] = STATE(614),
    [sym_string_expansion] = STATE(614),
    [sym_expansion] = STATE(614),
    [sym_command_substitution] = STATE(614),
    [sym_process_substitution] = STATE(614),
    [aux_sym_unset_command_repeat1] = STATE(1238),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2626),
    [sym_word] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [663] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_heredoc_body] = STATE(1245),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2642),
    [anon_sym_AMP_GT] = ACTIONS(2640),
    [anon_sym_AMP_GT_GT] = ACTIONS(2642),
    [anon_sym_LT_AMP] = ACTIONS(2642),
    [anon_sym_GT_AMP] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2630),
  },
  [664] = {
    [sym_concatenation] = STATE(1247),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(1247),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [665] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_heredoc_body] = STATE(1245),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2630),
  },
  [666] = {
    [sym_command_name] = STATE(1248),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [667] = {
    [sym_concatenation] = STATE(657),
    [sym_string] = STATE(235),
    [sym_simple_expansion] = STATE(235),
    [sym_string_expansion] = STATE(235),
    [sym_expansion] = STATE(235),
    [sym_command_substitution] = STATE(235),
    [sym_process_substitution] = STATE(235),
    [aux_sym_command_repeat2] = STATE(657),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [668] = {
    [sym_string] = STATE(1067),
    [sym_simple_expansion] = STATE(1067),
    [sym_string_expansion] = STATE(1067),
    [sym_expansion] = STATE(1067),
    [sym_command_substitution] = STATE(1067),
    [sym_process_substitution] = STATE(1067),
    [anon_sym_RBRACK] = ACTIONS(2650),
    [sym__special_characters] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2081),
  },
  [669] = {
    [sym__concat] = ACTIONS(2654),
    [anon_sym_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [sym_comment] = ACTIONS(57),
  },
  [670] = {
    [aux_sym_concatenation_repeat1] = STATE(1251),
    [sym__concat] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
  },
  [671] = {
    [sym_string] = STATE(1067),
    [sym_simple_expansion] = STATE(1067),
    [sym_string_expansion] = STATE(1067),
    [sym_expansion] = STATE(1067),
    [sym_command_substitution] = STATE(1067),
    [sym_process_substitution] = STATE(1067),
    [anon_sym_RBRACK] = ACTIONS(2658),
    [sym__special_characters] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2081),
  },
  [672] = {
    [sym__concat] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_PLUS_EQ] = ACTIONS(2662),
    [sym_comment] = ACTIONS(57),
  },
  [673] = {
    [anon_sym_RBRACK] = ACTIONS(2658),
    [sym_comment] = ACTIONS(57),
  },
  [674] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [ts_builtin_sym_end] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_RPAREN] = ACTIONS(2664),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [675] = {
    [aux_sym_concatenation_repeat1] = STATE(1255),
    [sym__concat] = ACTIONS(2668),
    [anon_sym_RPAREN] = ACTIONS(2670),
    [sym__special_characters] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(2672),
    [sym_raw_string] = ACTIONS(2670),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2670),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2670),
    [anon_sym_BQUOTE] = ACTIONS(2670),
    [anon_sym_LT_LPAREN] = ACTIONS(2670),
    [anon_sym_GT_LPAREN] = ACTIONS(2670),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2670),
  },
  [676] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1258),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [anon_sym_DOLLAR] = ACTIONS(2676),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [677] = {
    [sym_string] = STATE(1260),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(2678),
    [sym_raw_string] = ACTIONS(2680),
    [anon_sym_POUND] = ACTIONS(2678),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2682),
    [anon_sym_STAR] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2684),
    [anon_sym_QMARK] = ACTIONS(2684),
    [anon_sym_0] = ACTIONS(2682),
    [anon_sym__] = ACTIONS(2682),
  },
  [678] = {
    [aux_sym_concatenation_repeat1] = STATE(1255),
    [sym__concat] = ACTIONS(2668),
    [anon_sym_RPAREN] = ACTIONS(2686),
    [sym__special_characters] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [anon_sym_DOLLAR] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2686),
    [anon_sym_BQUOTE] = ACTIONS(2686),
    [anon_sym_LT_LPAREN] = ACTIONS(2686),
    [anon_sym_GT_LPAREN] = ACTIONS(2686),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2686),
  },
  [679] = {
    [sym_subscript] = STATE(1265),
    [sym_variable_name] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_DOLLAR] = ACTIONS(2694),
    [anon_sym_POUND] = ACTIONS(2692),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2698),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_0] = ACTIONS(2696),
    [anon_sym__] = ACTIONS(2696),
  },
  [680] = {
    [sym__statements] = STATE(1266),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1267),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [681] = {
    [sym__statements] = STATE(1268),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [682] = {
    [sym__statements] = STATE(1269),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [683] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(2700),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [684] = {
    [sym_string] = STATE(1272),
    [sym_simple_expansion] = STATE(1272),
    [sym_string_expansion] = STATE(1272),
    [sym_expansion] = STATE(1272),
    [sym_command_substitution] = STATE(1272),
    [sym_process_substitution] = STATE(1272),
    [sym__special_characters] = ACTIONS(2702),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(455),
    [sym_raw_string] = ACTIONS(2702),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(463),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2702),
  },
  [685] = {
    [aux_sym_concatenation_repeat1] = STATE(1273),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1049),
    [ts_builtin_sym_end] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [686] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [687] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2704),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [688] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2704),
    [anon_sym_DOLLAR] = ACTIONS(2706),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [689] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [ts_builtin_sym_end] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [690] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [ts_builtin_sym_end] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [691] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [692] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2708),
    [sym_comment] = ACTIONS(57),
  },
  [693] = {
    [sym_subscript] = STATE(1279),
    [sym_variable_name] = ACTIONS(2710),
    [anon_sym_DASH] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2714),
    [anon_sym_STAR] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_QMARK] = ACTIONS(2716),
    [anon_sym_0] = ACTIONS(2714),
    [anon_sym__] = ACTIONS(2714),
  },
  [694] = {
    [sym_concatenation] = STATE(1282),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1282),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_EQ] = ACTIONS(2720),
    [anon_sym_DASH] = ACTIONS(2720),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2724),
    [anon_sym_COLON] = ACTIONS(2720),
    [anon_sym_COLON_QMARK] = ACTIONS(2720),
    [anon_sym_COLON_DASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [695] = {
    [sym_concatenation] = STATE(1285),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1285),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_EQ] = ACTIONS(2728),
    [anon_sym_DASH] = ACTIONS(2728),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2732),
    [anon_sym_COLON] = ACTIONS(2728),
    [anon_sym_COLON_QMARK] = ACTIONS(2728),
    [anon_sym_COLON_DASH] = ACTIONS(2728),
    [anon_sym_PERCENT] = ACTIONS(2728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [696] = {
    [anon_sym_RPAREN] = ACTIONS(2734),
    [sym_comment] = ACTIONS(57),
  },
  [697] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [698] = {
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(57),
  },
  [699] = {
    [anon_sym_RPAREN] = ACTIONS(2736),
    [sym_comment] = ACTIONS(57),
  },
  [700] = {
    [sym__expression] = STATE(1289),
    [sym_binary_expression] = STATE(1289),
    [sym_unary_expression] = STATE(1289),
    [sym_postfix_expression] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1289),
    [sym_concatenation] = STATE(1289),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [701] = {
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_SEMI_SEMI] = ACTIONS(2742),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [702] = {
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_EQ_EQ] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_PLUS_EQ] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_DASH_EQ] = ACTIONS(1517),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1517),
  },
  [703] = {
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(1525),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [704] = {
    [sym_string] = STATE(1292),
    [sym_simple_expansion] = STATE(1292),
    [sym_string_expansion] = STATE(1292),
    [sym_expansion] = STATE(1292),
    [sym_command_substitution] = STATE(1292),
    [sym_process_substitution] = STATE(1292),
    [sym__special_characters] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(2748),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2748),
  },
  [705] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1051),
    [anon_sym_PLUS_EQ] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_BANG_EQ] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_DASH_EQ] = ACTIONS(1049),
    [anon_sym_LT_EQ] = ACTIONS(1049),
    [anon_sym_GT_EQ] = ACTIONS(1049),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1049),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [706] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1053),
    [anon_sym_EQ_EQ] = ACTIONS(1053),
    [anon_sym_EQ] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_BANG_EQ] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1053),
    [anon_sym_GT_EQ] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [707] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [708] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2752),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [709] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [710] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [711] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1097),
    [anon_sym_PLUS_EQ] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_DASH_EQ] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [712] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2754),
    [sym_comment] = ACTIONS(57),
  },
  [713] = {
    [sym_subscript] = STATE(1299),
    [sym_variable_name] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2758),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_AT] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_0] = ACTIONS(2760),
    [anon_sym__] = ACTIONS(2760),
  },
  [714] = {
    [sym_concatenation] = STATE(1302),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1302),
    [anon_sym_RBRACE] = ACTIONS(2764),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2768),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_DASH] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [715] = {
    [sym_concatenation] = STATE(1305),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1305),
    [anon_sym_RBRACE] = ACTIONS(2772),
    [anon_sym_EQ] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2778),
    [anon_sym_COLON] = ACTIONS(2774),
    [anon_sym_COLON_QMARK] = ACTIONS(2774),
    [anon_sym_COLON_DASH] = ACTIONS(2774),
    [anon_sym_PERCENT] = ACTIONS(2774),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [716] = {
    [anon_sym_RPAREN] = ACTIONS(2780),
    [sym_comment] = ACTIONS(57),
  },
  [717] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [718] = {
    [anon_sym_BQUOTE] = ACTIONS(2780),
    [sym_comment] = ACTIONS(57),
  },
  [719] = {
    [anon_sym_RPAREN] = ACTIONS(2782),
    [sym_comment] = ACTIONS(57),
  },
  [720] = {
    [sym__expression] = STATE(1308),
    [sym_binary_expression] = STATE(1308),
    [sym_unary_expression] = STATE(1308),
    [sym_postfix_expression] = STATE(1308),
    [sym_parenthesized_expression] = STATE(1308),
    [sym_concatenation] = STATE(1308),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_SEMI_SEMI] = ACTIONS(2742),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2742),
  },
  [721] = {
    [sym__expression] = STATE(1309),
    [sym_binary_expression] = STATE(1309),
    [sym_unary_expression] = STATE(1309),
    [sym_postfix_expression] = STATE(1309),
    [sym_parenthesized_expression] = STATE(1309),
    [sym_concatenation] = STATE(1309),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
  },
  [722] = {
    [sym__expression] = STATE(1309),
    [sym_binary_expression] = STATE(1309),
    [sym_unary_expression] = STATE(1309),
    [sym_postfix_expression] = STATE(1309),
    [sym_parenthesized_expression] = STATE(1309),
    [sym_concatenation] = STATE(1309),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [sym_regex] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
  },
  [723] = {
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_SEMI_SEMI] = ACTIONS(1569),
    [anon_sym_AMP_AMP] = ACTIONS(1569),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [anon_sym_EQ_TILDE] = ACTIONS(1569),
    [anon_sym_EQ_EQ] = ACTIONS(1569),
    [anon_sym_EQ] = ACTIONS(1571),
    [anon_sym_PLUS_EQ] = ACTIONS(1569),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_BANG_EQ] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1571),
    [anon_sym_DASH_EQ] = ACTIONS(1569),
    [anon_sym_LT_EQ] = ACTIONS(1569),
    [anon_sym_GT_EQ] = ACTIONS(1569),
    [anon_sym_PLUS_PLUS] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1569),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1569),
    [anon_sym_LF] = ACTIONS(1569),
    [anon_sym_AMP] = ACTIONS(1571),
  },
  [724] = {
    [aux_sym_concatenation_repeat1] = STATE(1312),
    [sym__concat] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_SEMI_SEMI] = ACTIONS(2670),
    [sym__special_characters] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(2672),
    [sym_raw_string] = ACTIONS(2670),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2670),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2670),
    [anon_sym_BQUOTE] = ACTIONS(2670),
    [anon_sym_LT_LPAREN] = ACTIONS(2670),
    [anon_sym_GT_LPAREN] = ACTIONS(2670),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2672),
    [anon_sym_LF] = ACTIONS(2670),
    [anon_sym_AMP] = ACTIONS(2670),
  },
  [725] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1315),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [726] = {
    [sym_string] = STATE(1317),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(2792),
    [sym_raw_string] = ACTIONS(2794),
    [anon_sym_POUND] = ACTIONS(2792),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2796),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_QMARK] = ACTIONS(2798),
    [anon_sym_0] = ACTIONS(2796),
    [anon_sym__] = ACTIONS(2796),
  },
  [727] = {
    [aux_sym_concatenation_repeat1] = STATE(1312),
    [sym__concat] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(2688),
    [anon_sym_SEMI_SEMI] = ACTIONS(2686),
    [sym__special_characters] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [anon_sym_DOLLAR] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2686),
    [anon_sym_BQUOTE] = ACTIONS(2686),
    [anon_sym_LT_LPAREN] = ACTIONS(2686),
    [anon_sym_GT_LPAREN] = ACTIONS(2686),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2688),
    [anon_sym_LF] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2686),
  },
  [728] = {
    [sym_subscript] = STATE(1322),
    [sym_variable_name] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_POUND] = ACTIONS(2802),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2806),
    [anon_sym_STAR] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(2808),
    [anon_sym_QMARK] = ACTIONS(2808),
    [anon_sym_0] = ACTIONS(2806),
    [anon_sym__] = ACTIONS(2806),
  },
  [729] = {
    [sym__statements] = STATE(1323),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1324),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [730] = {
    [sym__statements] = STATE(1325),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [731] = {
    [sym__statements] = STATE(1326),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [732] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(727),
    [sym_simple_expansion] = STATE(727),
    [sym_string_expansion] = STATE(727),
    [sym_expansion] = STATE(727),
    [sym_command_substitution] = STATE(727),
    [sym_process_substitution] = STATE(727),
    [aux_sym_for_statement_repeat1] = STATE(1328),
    [anon_sym_SEMI] = ACTIONS(2810),
    [anon_sym_SEMI_SEMI] = ACTIONS(2812),
    [sym__special_characters] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [sym_raw_string] = ACTIONS(1481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1485),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(1489),
    [anon_sym_GT_LPAREN] = ACTIONS(1489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2814),
    [anon_sym_LF] = ACTIONS(2812),
    [anon_sym_AMP] = ACTIONS(2812),
  },
  [733] = {
    [sym__simple_heredoc_body] = ACTIONS(2816),
    [sym__heredoc_body_beginning] = ACTIONS(2816),
    [sym_file_descriptor] = ACTIONS(2816),
    [ts_builtin_sym_end] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_done] = ACTIONS(2816),
    [anon_sym_fi] = ACTIONS(2816),
    [anon_sym_elif] = ACTIONS(2816),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_esac] = ACTIONS(2816),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_RPAREN] = ACTIONS(2816),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [anon_sym_PIPE_AMP] = ACTIONS(2816),
    [anon_sym_AMP_AMP] = ACTIONS(2816),
    [anon_sym_PIPE_PIPE] = ACTIONS(2816),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_GT] = ACTIONS(2818),
    [anon_sym_GT_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT] = ACTIONS(2818),
    [anon_sym_AMP_GT_GT] = ACTIONS(2816),
    [anon_sym_LT_AMP] = ACTIONS(2816),
    [anon_sym_GT_AMP] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2818),
    [anon_sym_LT_LT_DASH] = ACTIONS(2816),
    [anon_sym_LT_LT_LT] = ACTIONS(2816),
    [anon_sym_BQUOTE] = ACTIONS(2816),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2818),
  },
  [734] = {
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_EQ_EQ] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_PLUS_EQ] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_DASH_EQ] = ACTIONS(1517),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1517),
  },
  [735] = {
    [anon_sym_RPAREN] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_EQ_EQ] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_PLUS_EQ] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_DASH_EQ] = ACTIONS(1517),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1517),
  },
  [736] = {
    [sym_string] = STATE(1330),
    [sym_simple_expansion] = STATE(1330),
    [sym_string_expansion] = STATE(1330),
    [sym_expansion] = STATE(1330),
    [sym_command_substitution] = STATE(1330),
    [sym_process_substitution] = STATE(1330),
    [sym__special_characters] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2822),
  },
  [737] = {
    [aux_sym_concatenation_repeat1] = STATE(1331),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1051),
    [anon_sym_PLUS_EQ] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_BANG_EQ] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_DASH_EQ] = ACTIONS(1049),
    [anon_sym_LT_EQ] = ACTIONS(1049),
    [anon_sym_GT_EQ] = ACTIONS(1049),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1049),
  },
  [738] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1053),
    [anon_sym_EQ_EQ] = ACTIONS(1053),
    [anon_sym_EQ] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_BANG_EQ] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1053),
    [anon_sym_GT_EQ] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1053),
  },
  [739] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [740] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2826),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [741] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1087),
  },
  [742] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1091),
  },
  [743] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1097),
    [anon_sym_PLUS_EQ] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_DASH_EQ] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1095),
  },
  [744] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2828),
    [sym_comment] = ACTIONS(57),
  },
  [745] = {
    [sym_subscript] = STATE(1337),
    [sym_variable_name] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2836),
    [anon_sym_QMARK] = ACTIONS(2836),
    [anon_sym_0] = ACTIONS(2834),
    [anon_sym__] = ACTIONS(2834),
  },
  [746] = {
    [sym_concatenation] = STATE(1340),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1340),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_EQ] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2840),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_COLON] = ACTIONS(2840),
    [anon_sym_COLON_QMARK] = ACTIONS(2840),
    [anon_sym_COLON_DASH] = ACTIONS(2840),
    [anon_sym_PERCENT] = ACTIONS(2840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [747] = {
    [sym_concatenation] = STATE(1343),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1343),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_EQ] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2848),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2848),
    [anon_sym_COLON_QMARK] = ACTIONS(2848),
    [anon_sym_COLON_DASH] = ACTIONS(2848),
    [anon_sym_PERCENT] = ACTIONS(2848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [748] = {
    [anon_sym_RPAREN] = ACTIONS(2854),
    [sym_comment] = ACTIONS(57),
  },
  [749] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [750] = {
    [anon_sym_BQUOTE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(57),
  },
  [751] = {
    [anon_sym_RPAREN] = ACTIONS(2856),
    [sym_comment] = ACTIONS(57),
  },
  [752] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_PIPE_PIPE] = ACTIONS(2858),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2858),
    [anon_sym_EQ_TILDE] = ACTIONS(2858),
    [anon_sym_EQ_EQ] = ACTIONS(2858),
    [anon_sym_EQ] = ACTIONS(2860),
    [anon_sym_PLUS_EQ] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_BANG_EQ] = ACTIONS(2858),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_DASH_EQ] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2858),
    [anon_sym_GT_EQ] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2858),
  },
  [753] = {
    [sym__expression] = STATE(1346),
    [sym_binary_expression] = STATE(1346),
    [sym_unary_expression] = STATE(1346),
    [sym_postfix_expression] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1346),
    [sym_concatenation] = STATE(1346),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(521),
    [sym_test_operator] = ACTIONS(523),
  },
  [754] = {
    [sym__expression] = STATE(1346),
    [sym_binary_expression] = STATE(1346),
    [sym_unary_expression] = STATE(1346),
    [sym_postfix_expression] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1346),
    [sym_concatenation] = STATE(1346),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [sym_regex] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(521),
    [sym_test_operator] = ACTIONS(523),
  },
  [755] = {
    [anon_sym_RPAREN] = ACTIONS(1569),
    [anon_sym_AMP_AMP] = ACTIONS(1569),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [anon_sym_EQ_TILDE] = ACTIONS(1569),
    [anon_sym_EQ_EQ] = ACTIONS(1569),
    [anon_sym_EQ] = ACTIONS(1571),
    [anon_sym_PLUS_EQ] = ACTIONS(1569),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_BANG_EQ] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1571),
    [anon_sym_DASH_EQ] = ACTIONS(1569),
    [anon_sym_LT_EQ] = ACTIONS(1569),
    [anon_sym_GT_EQ] = ACTIONS(1569),
    [anon_sym_PLUS_PLUS] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1569),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1569),
  },
  [756] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [757] = {
    [aux_sym_concatenation_repeat1] = STATE(757),
    [sym__concat] = ACTIONS(2864),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [758] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2313),
    [anon_sym_EQ_EQ] = ACTIONS(2313),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_BANG_EQ] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2315),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_LT_EQ] = ACTIONS(2313),
    [anon_sym_GT_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2313),
  },
  [759] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [760] = {
    [sym_concatenation] = STATE(1352),
    [sym_string] = STATE(1351),
    [sym_simple_expansion] = STATE(1351),
    [sym_string_expansion] = STATE(1351),
    [sym_expansion] = STATE(1351),
    [sym_command_substitution] = STATE(1351),
    [sym_process_substitution] = STATE(1351),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [sym__special_characters] = ACTIONS(2871),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2873),
  },
  [761] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2875),
    [sym_comment] = ACTIONS(57),
  },
  [762] = {
    [sym_concatenation] = STATE(1356),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1356),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2879),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_COLON_QMARK] = ACTIONS(2879),
    [anon_sym_COLON_DASH] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [763] = {
    [sym_concatenation] = STATE(1358),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1358),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2885),
    [anon_sym_COLON_QMARK] = ACTIONS(2885),
    [anon_sym_COLON_DASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [764] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2406),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_PLUS_EQ] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_DASH_EQ] = ACTIONS(2406),
    [anon_sym_LT_EQ] = ACTIONS(2406),
    [anon_sym_GT_EQ] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2406),
  },
  [765] = {
    [sym_concatenation] = STATE(1361),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1361),
    [sym_regex] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_DASH] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [766] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [767] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2454),
  },
  [768] = {
    [sym_concatenation] = STATE(1358),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1358),
    [sym_regex] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2885),
    [anon_sym_COLON_QMARK] = ACTIONS(2885),
    [anon_sym_COLON_DASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [769] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [770] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2464),
  },
  [771] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_EQ] = ACTIONS(2504),
    [anon_sym_PLUS_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_BANG_EQ] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_DASH_EQ] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2502),
  },
  [772] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [773] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [774] = {
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [775] = {
    [sym_concatenation] = STATE(1364),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1364),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [776] = {
    [aux_sym_concatenation_repeat1] = STATE(1366),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(2907),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [777] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1369),
    [anon_sym_DQUOTE] = ACTIONS(2909),
    [anon_sym_DOLLAR] = ACTIONS(2911),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [778] = {
    [sym_string] = STATE(1371),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(1579),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [sym_raw_string] = ACTIONS(2915),
    [anon_sym_POUND] = ACTIONS(2913),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2919),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_QMARK] = ACTIONS(2919),
    [anon_sym_0] = ACTIONS(2917),
    [anon_sym__] = ACTIONS(2917),
  },
  [779] = {
    [aux_sym_concatenation_repeat1] = STATE(1366),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(2907),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [780] = {
    [sym_subscript] = STATE(1376),
    [sym_variable_name] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_DOLLAR] = ACTIONS(2925),
    [anon_sym_POUND] = ACTIONS(2923),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_0] = ACTIONS(2927),
    [anon_sym__] = ACTIONS(2927),
  },
  [781] = {
    [sym__statements] = STATE(1377),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1378),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [782] = {
    [sym__statements] = STATE(1379),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [783] = {
    [sym__statements] = STATE(1380),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [784] = {
    [sym__expression] = STATE(1382),
    [sym_binary_expression] = STATE(1382),
    [sym_unary_expression] = STATE(1382),
    [sym_postfix_expression] = STATE(1382),
    [sym_parenthesized_expression] = STATE(1382),
    [sym_concatenation] = STATE(1382),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_SEMI_SEMI] = ACTIONS(2933),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
  },
  [785] = {
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_SEMI_SEMI] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2935),
  },
  [786] = {
    [sym_concatenation] = STATE(1384),
    [sym_string] = STATE(727),
    [sym_simple_expansion] = STATE(727),
    [sym_string_expansion] = STATE(727),
    [sym_expansion] = STATE(727),
    [sym_command_substitution] = STATE(727),
    [sym_process_substitution] = STATE(727),
    [aux_sym_for_statement_repeat1] = STATE(1384),
    [sym__special_characters] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [sym_raw_string] = ACTIONS(1481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1485),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(1489),
    [anon_sym_GT_LPAREN] = ACTIONS(1489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1481),
  },
  [787] = {
    [sym_do_group] = STATE(1385),
    [anon_sym_do] = ACTIONS(1605),
    [sym_comment] = ACTIONS(57),
  },
  [788] = {
    [sym_file_descriptor] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1565),
    [anon_sym_PIPE] = ACTIONS(1565),
    [anon_sym_SEMI_SEMI] = ACTIONS(1563),
    [anon_sym_PIPE_AMP] = ACTIONS(1563),
    [anon_sym_AMP_AMP] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE] = ACTIONS(1563),
    [anon_sym_LT] = ACTIONS(1565),
    [anon_sym_GT] = ACTIONS(1565),
    [anon_sym_GT_GT] = ACTIONS(1563),
    [anon_sym_AMP_GT] = ACTIONS(1565),
    [anon_sym_AMP_GT_GT] = ACTIONS(1563),
    [anon_sym_LT_AMP] = ACTIONS(1563),
    [anon_sym_GT_AMP] = ACTIONS(1563),
    [anon_sym_LT_LT] = ACTIONS(1565),
    [anon_sym_LT_LT_DASH] = ACTIONS(1563),
    [anon_sym_LT_LT_LT] = ACTIONS(1563),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1565),
  },
  [789] = {
    [sym__statements] = STATE(1387),
    [sym_redirected_statement] = STATE(867),
    [sym_for_statement] = STATE(867),
    [sym_c_style_for_statement] = STATE(867),
    [sym_while_statement] = STATE(867),
    [sym_if_statement] = STATE(867),
    [sym_case_statement] = STATE(867),
    [sym_function_definition] = STATE(867),
    [sym_compound_statement] = STATE(867),
    [sym_subshell] = STATE(867),
    [sym_pipeline] = STATE(867),
    [sym_list] = STATE(867),
    [sym_negated_command] = STATE(867),
    [sym_test_command] = STATE(867),
    [sym_declaration_command] = STATE(867),
    [sym_unset_command] = STATE(867),
    [sym_command] = STATE(867),
    [sym_command_name] = STATE(868),
    [sym_variable_assignment] = STATE(869),
    [sym_subscript] = STATE(870),
    [sym_file_redirect] = STATE(873),
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(860),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [sym_process_substitution] = STATE(860),
    [aux_sym__statements_repeat1] = STATE(872),
    [aux_sym_command_repeat1] = STATE(873),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1719),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_typeset] = ACTIONS(1725),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_readonly] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym_unset] = ACTIONS(1727),
    [anon_sym_unsetenv] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1745),
  },
  [790] = {
    [sym_file_descriptor] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1749),
    [anon_sym_SEMI_SEMI] = ACTIONS(1747),
    [anon_sym_PIPE_AMP] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1749),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_AMP_GT] = ACTIONS(1749),
    [anon_sym_AMP_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_AMP] = ACTIONS(1747),
    [anon_sym_GT_AMP] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1749),
    [anon_sym_LT_LT_DASH] = ACTIONS(1747),
    [anon_sym_LT_LT_LT] = ACTIONS(1747),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1749),
  },
  [791] = {
    [sym__statements] = STATE(1389),
    [sym_redirected_statement] = STATE(909),
    [sym_for_statement] = STATE(909),
    [sym_c_style_for_statement] = STATE(909),
    [sym_while_statement] = STATE(909),
    [sym_if_statement] = STATE(909),
    [sym_elif_clause] = STATE(1391),
    [sym_else_clause] = STATE(1390),
    [sym_case_statement] = STATE(909),
    [sym_function_definition] = STATE(909),
    [sym_compound_statement] = STATE(909),
    [sym_subshell] = STATE(909),
    [sym_pipeline] = STATE(909),
    [sym_list] = STATE(909),
    [sym_negated_command] = STATE(909),
    [sym_test_command] = STATE(909),
    [sym_declaration_command] = STATE(909),
    [sym_unset_command] = STATE(909),
    [sym_command] = STATE(909),
    [sym_command_name] = STATE(911),
    [sym_variable_assignment] = STATE(912),
    [sym_subscript] = STATE(913),
    [sym_file_redirect] = STATE(917),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym__statements_repeat1] = STATE(915),
    [aux_sym_if_statement_repeat1] = STATE(1391),
    [aux_sym_command_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(2941),
    [anon_sym_elif] = ACTIONS(1777),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1783),
    [anon_sym_typeset] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_readonly] = ACTIONS(1783),
    [anon_sym_local] = ACTIONS(1783),
    [anon_sym_unset] = ACTIONS(1785),
    [anon_sym_unsetenv] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1803),
  },
  [792] = {
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
  },
  [793] = {
    [anon_sym_in] = ACTIONS(2947),
    [sym_comment] = ACTIONS(57),
  },
  [794] = {
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym_SEMI_SEMI] = ACTIONS(2951),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
  },
  [795] = {
    [anon_sym_in] = ACTIONS(2953),
    [sym_comment] = ACTIONS(57),
  },
  [796] = {
    [anon_sym_RPAREN] = ACTIONS(2955),
    [sym_comment] = ACTIONS(57),
  },
  [797] = {
    [sym_file_descriptor] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1857),
    [anon_sym_SEMI_SEMI] = ACTIONS(1855),
    [anon_sym_PIPE_AMP] = ACTIONS(1855),
    [anon_sym_AMP_AMP] = ACTIONS(1855),
    [anon_sym_PIPE_PIPE] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_GT_GT] = ACTIONS(1855),
    [anon_sym_AMP_GT] = ACTIONS(1857),
    [anon_sym_AMP_GT_GT] = ACTIONS(1855),
    [anon_sym_LT_AMP] = ACTIONS(1855),
    [anon_sym_GT_AMP] = ACTIONS(1855),
    [anon_sym_LT_LT] = ACTIONS(1857),
    [anon_sym_LT_LT_DASH] = ACTIONS(1855),
    [anon_sym_LT_LT_LT] = ACTIONS(1855),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1855),
    [anon_sym_AMP] = ACTIONS(1857),
  },
  [798] = {
    [sym_file_descriptor] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_PIPE] = ACTIONS(1871),
    [anon_sym_SEMI_SEMI] = ACTIONS(1869),
    [anon_sym_PIPE_AMP] = ACTIONS(1869),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_PIPE_PIPE] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_GT] = ACTIONS(1871),
    [anon_sym_GT_GT] = ACTIONS(1869),
    [anon_sym_AMP_GT] = ACTIONS(1871),
    [anon_sym_AMP_GT_GT] = ACTIONS(1869),
    [anon_sym_LT_AMP] = ACTIONS(1869),
    [anon_sym_GT_AMP] = ACTIONS(1869),
    [anon_sym_LT_LT] = ACTIONS(1871),
    [anon_sym_LT_LT_DASH] = ACTIONS(1869),
    [anon_sym_LT_LT_LT] = ACTIONS(1869),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1869),
    [anon_sym_AMP] = ACTIONS(1871),
  },
  [799] = {
    [sym_file_descriptor] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI_SEMI] = ACTIONS(2035),
    [anon_sym_PIPE_AMP] = ACTIONS(2035),
    [anon_sym_AMP_AMP] = ACTIONS(2035),
    [anon_sym_PIPE_PIPE] = ACTIONS(2035),
    [anon_sym_LT] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2037),
    [anon_sym_GT_GT] = ACTIONS(2035),
    [anon_sym_AMP_GT] = ACTIONS(2037),
    [anon_sym_AMP_GT_GT] = ACTIONS(2035),
    [anon_sym_LT_AMP] = ACTIONS(2035),
    [anon_sym_GT_AMP] = ACTIONS(2035),
    [anon_sym_LT_LT] = ACTIONS(2037),
    [anon_sym_LT_LT_DASH] = ACTIONS(2035),
    [anon_sym_LT_LT_LT] = ACTIONS(2035),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(2037),
  },
  [800] = {
    [sym_concatenation] = STATE(1397),
    [sym_string] = STATE(1400),
    [sym_array] = STATE(1397),
    [sym_simple_expansion] = STATE(1400),
    [sym_string_expansion] = STATE(1400),
    [sym_expansion] = STATE(1400),
    [sym_command_substitution] = STATE(1400),
    [sym_process_substitution] = STATE(1400),
    [sym__empty_value] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [sym__special_characters] = ACTIONS(2961),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(587),
    [sym_raw_string] = ACTIONS(2963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(593),
    [anon_sym_BQUOTE] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(597),
    [anon_sym_GT_LPAREN] = ACTIONS(597),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2963),
  },
  [801] = {
    [sym_string] = STATE(1401),
    [sym_simple_expansion] = STATE(1401),
    [sym_string_expansion] = STATE(1401),
    [sym_expansion] = STATE(1401),
    [sym_command_substitution] = STATE(1401),
    [sym_process_substitution] = STATE(1401),
    [sym__special_characters] = ACTIONS(2965),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(587),
    [sym_raw_string] = ACTIONS(2965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(593),
    [anon_sym_BQUOTE] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(597),
    [anon_sym_GT_LPAREN] = ACTIONS(597),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2965),
  },
  [802] = {
    [aux_sym_concatenation_repeat1] = STATE(1402),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1629),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [803] = {
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [804] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [805] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_DOLLAR] = ACTIONS(2969),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [806] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [807] = {
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [808] = {
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [809] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(2971),
    [sym_comment] = ACTIONS(57),
  },
  [810] = {
    [sym_subscript] = STATE(1408),
    [sym_variable_name] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_DOLLAR] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_AT] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2979),
    [anon_sym_0] = ACTIONS(2977),
    [anon_sym__] = ACTIONS(2977),
  },
  [811] = {
    [sym_concatenation] = STATE(1411),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1411),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(2983),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_COLON_QMARK] = ACTIONS(2983),
    [anon_sym_COLON_DASH] = ACTIONS(2983),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [812] = {
    [sym_concatenation] = STATE(1414),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1414),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2991),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COLON_QMARK] = ACTIONS(2991),
    [anon_sym_COLON_DASH] = ACTIONS(2991),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [813] = {
    [anon_sym_RPAREN] = ACTIONS(2997),
    [sym_comment] = ACTIONS(57),
  },
  [814] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [815] = {
    [anon_sym_BQUOTE] = ACTIONS(2997),
    [sym_comment] = ACTIONS(57),
  },
  [816] = {
    [anon_sym_RPAREN] = ACTIONS(2999),
    [sym_comment] = ACTIONS(57),
  },
  [817] = {
    [sym_variable_assignment] = STATE(817),
    [sym_subscript] = STATE(329),
    [sym_concatenation] = STATE(817),
    [sym_string] = STATE(324),
    [sym_simple_expansion] = STATE(324),
    [sym_string_expansion] = STATE(324),
    [sym_expansion] = STATE(324),
    [sym_command_substitution] = STATE(324),
    [sym_process_substitution] = STATE(324),
    [aux_sym_declaration_command_repeat1] = STATE(817),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_DOLLAR] = ACTIONS(3010),
    [sym_raw_string] = ACTIONS(3013),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3019),
    [anon_sym_BQUOTE] = ACTIONS(3022),
    [anon_sym_LT_LPAREN] = ACTIONS(3025),
    [anon_sym_GT_LPAREN] = ACTIONS(3025),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3028),
    [sym_word] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [818] = {
    [sym_string] = STATE(1417),
    [sym_simple_expansion] = STATE(1417),
    [sym_string_expansion] = STATE(1417),
    [sym_expansion] = STATE(1417),
    [sym_command_substitution] = STATE(1417),
    [sym_process_substitution] = STATE(1417),
    [sym__special_characters] = ACTIONS(3034),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [sym_raw_string] = ACTIONS(3034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(611),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(615),
    [anon_sym_LT_LPAREN] = ACTIONS(617),
    [anon_sym_GT_LPAREN] = ACTIONS(617),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3034),
  },
  [819] = {
    [aux_sym_concatenation_repeat1] = STATE(1418),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1655),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [820] = {
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [821] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [822] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [823] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [824] = {
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [825] = {
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [826] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3040),
    [sym_comment] = ACTIONS(57),
  },
  [827] = {
    [sym_subscript] = STATE(1424),
    [sym_variable_name] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_DOLLAR] = ACTIONS(3044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AT] = ACTIONS(3048),
    [anon_sym_QMARK] = ACTIONS(3048),
    [anon_sym_0] = ACTIONS(3046),
    [anon_sym__] = ACTIONS(3046),
  },
  [828] = {
    [sym_concatenation] = STATE(1427),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1427),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3056),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_COLON_QMARK] = ACTIONS(3052),
    [anon_sym_COLON_DASH] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [829] = {
    [sym_concatenation] = STATE(1430),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1430),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3060),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3064),
    [anon_sym_COLON] = ACTIONS(3060),
    [anon_sym_COLON_QMARK] = ACTIONS(3060),
    [anon_sym_COLON_DASH] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3060),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [830] = {
    [anon_sym_RPAREN] = ACTIONS(3066),
    [sym_comment] = ACTIONS(57),
  },
  [831] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [832] = {
    [anon_sym_BQUOTE] = ACTIONS(3066),
    [sym_comment] = ACTIONS(57),
  },
  [833] = {
    [anon_sym_RPAREN] = ACTIONS(3068),
    [sym_comment] = ACTIONS(57),
  },
  [834] = {
    [sym_concatenation] = STATE(834),
    [sym_string] = STATE(334),
    [sym_simple_expansion] = STATE(334),
    [sym_string_expansion] = STATE(334),
    [sym_expansion] = STATE(334),
    [sym_command_substitution] = STATE(334),
    [sym_process_substitution] = STATE(334),
    [aux_sym_unset_command_repeat1] = STATE(834),
    [sym_file_descriptor] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3076),
    [sym_raw_string] = ACTIONS(3079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3085),
    [anon_sym_BQUOTE] = ACTIONS(3088),
    [anon_sym_LT_LPAREN] = ACTIONS(3091),
    [anon_sym_GT_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3094),
    [sym_word] = ACTIONS(3097),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [835] = {
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [836] = {
    [aux_sym_concatenation_repeat1] = STATE(836),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [837] = {
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [838] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [839] = {
    [sym_concatenation] = STATE(1437),
    [sym_string] = STATE(1436),
    [sym_simple_expansion] = STATE(1436),
    [sym_string_expansion] = STATE(1436),
    [sym_expansion] = STATE(1436),
    [sym_command_substitution] = STATE(1436),
    [sym_process_substitution] = STATE(1436),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [sym__special_characters] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(3109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3109),
  },
  [840] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3111),
    [sym_comment] = ACTIONS(57),
  },
  [841] = {
    [sym_concatenation] = STATE(1441),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1441),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3119),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [842] = {
    [sym_concatenation] = STATE(1443),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1443),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3121),
    [anon_sym_COLON_QMARK] = ACTIONS(3121),
    [anon_sym_COLON_DASH] = ACTIONS(3121),
    [anon_sym_PERCENT] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [843] = {
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [844] = {
    [sym_concatenation] = STATE(1446),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1446),
    [sym_regex] = ACTIONS(3127),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_EQ] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_DASH] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [845] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [846] = {
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [847] = {
    [sym_concatenation] = STATE(1443),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1443),
    [sym_regex] = ACTIONS(3135),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3121),
    [anon_sym_COLON_QMARK] = ACTIONS(3121),
    [anon_sym_COLON_DASH] = ACTIONS(3121),
    [anon_sym_PERCENT] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [848] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [849] = {
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [850] = {
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2504),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [851] = {
    [sym_compound_statement] = STATE(1448),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [852] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_PLUS_EQ] = ACTIONS(3137),
    [sym_comment] = ACTIONS(57),
  },
  [853] = {
    [sym__simple_heredoc_body] = ACTIONS(3139),
    [sym__heredoc_body_beginning] = ACTIONS(3139),
    [sym_file_descriptor] = ACTIONS(3139),
    [ts_builtin_sym_end] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_done] = ACTIONS(3139),
    [anon_sym_fi] = ACTIONS(3139),
    [anon_sym_elif] = ACTIONS(3139),
    [anon_sym_else] = ACTIONS(3139),
    [anon_sym_esac] = ACTIONS(3139),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_RPAREN] = ACTIONS(3139),
    [anon_sym_SEMI_SEMI] = ACTIONS(3139),
    [anon_sym_PIPE_AMP] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_GT] = ACTIONS(3141),
    [anon_sym_GT_GT] = ACTIONS(3139),
    [anon_sym_AMP_GT] = ACTIONS(3141),
    [anon_sym_AMP_GT_GT] = ACTIONS(3139),
    [anon_sym_LT_AMP] = ACTIONS(3139),
    [anon_sym_GT_AMP] = ACTIONS(3139),
    [anon_sym_LT_LT] = ACTIONS(3141),
    [anon_sym_LT_LT_DASH] = ACTIONS(3139),
    [anon_sym_LT_LT_LT] = ACTIONS(3139),
    [anon_sym_BQUOTE] = ACTIONS(3139),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3141),
  },
  [854] = {
    [sym_subshell] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_command_name] = STATE(868),
    [sym_variable_assignment] = STATE(873),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(873),
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(860),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [sym_process_substitution] = STATE(860),
    [aux_sym_command_repeat1] = STATE(873),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1735),
  },
  [855] = {
    [sym_variable_assignment] = STATE(1460),
    [sym_subscript] = STATE(1459),
    [sym_concatenation] = STATE(1460),
    [sym_string] = STATE(1454),
    [sym_simple_expansion] = STATE(1454),
    [sym_string_expansion] = STATE(1454),
    [sym_expansion] = STATE(1454),
    [sym_command_substitution] = STATE(1454),
    [sym_process_substitution] = STATE(1454),
    [aux_sym_declaration_command_repeat1] = STATE(1460),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(3143),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_done] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(3145),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(3149),
    [sym_raw_string] = ACTIONS(3151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3155),
    [anon_sym_BQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LPAREN] = ACTIONS(3159),
    [anon_sym_GT_LPAREN] = ACTIONS(3159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3161),
    [sym_word] = ACTIONS(3163),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [856] = {
    [sym_concatenation] = STATE(1469),
    [sym_string] = STATE(1464),
    [sym_simple_expansion] = STATE(1464),
    [sym_string_expansion] = STATE(1464),
    [sym_expansion] = STATE(1464),
    [sym_command_substitution] = STATE(1464),
    [sym_process_substitution] = STATE(1464),
    [aux_sym_unset_command_repeat1] = STATE(1469),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_done] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_DOLLAR] = ACTIONS(3169),
    [sym_raw_string] = ACTIONS(3171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3175),
    [anon_sym_BQUOTE] = ACTIONS(3177),
    [anon_sym_LT_LPAREN] = ACTIONS(3179),
    [anon_sym_GT_LPAREN] = ACTIONS(3179),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3181),
    [sym_word] = ACTIONS(3183),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [857] = {
    [aux_sym_concatenation_repeat1] = STATE(1471),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [858] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1474),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_DOLLAR] = ACTIONS(3189),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [859] = {
    [sym_string] = STATE(1476),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(3191),
    [sym_raw_string] = ACTIONS(3193),
    [anon_sym_POUND] = ACTIONS(3191),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3195),
    [anon_sym_STAR] = ACTIONS(3197),
    [anon_sym_AT] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3197),
    [anon_sym_0] = ACTIONS(3195),
    [anon_sym__] = ACTIONS(3195),
  },
  [860] = {
    [aux_sym_concatenation_repeat1] = STATE(1471),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [861] = {
    [sym_subscript] = STATE(1481),
    [sym_variable_name] = ACTIONS(3199),
    [anon_sym_BANG] = ACTIONS(3201),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_DOLLAR] = ACTIONS(3203),
    [anon_sym_POUND] = ACTIONS(3201),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3207),
    [anon_sym_QMARK] = ACTIONS(3207),
    [anon_sym_0] = ACTIONS(3205),
    [anon_sym__] = ACTIONS(3205),
  },
  [862] = {
    [sym__statements] = STATE(1482),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1483),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [863] = {
    [sym__statements] = STATE(1484),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [864] = {
    [sym__statements] = STATE(1485),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [865] = {
    [aux_sym_concatenation_repeat1] = STATE(1471),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [866] = {
    [anon_sym_done] = ACTIONS(3209),
    [sym_comment] = ACTIONS(57),
  },
  [867] = {
    [sym_file_redirect] = STATE(1494),
    [sym_heredoc_redirect] = STATE(1494),
    [sym_heredoc_body] = STATE(1493),
    [sym_herestring_redirect] = STATE(1494),
    [aux_sym_redirected_statement_repeat1] = STATE(1494),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_done] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(3215),
    [anon_sym_SEMI_SEMI] = ACTIONS(3217),
    [anon_sym_PIPE_AMP] = ACTIONS(3219),
    [anon_sym_AMP_AMP] = ACTIONS(3221),
    [anon_sym_PIPE_PIPE] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3225),
    [anon_sym_AMP_GT] = ACTIONS(3223),
    [anon_sym_AMP_GT_GT] = ACTIONS(3225),
    [anon_sym_LT_AMP] = ACTIONS(3225),
    [anon_sym_GT_AMP] = ACTIONS(3225),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3227),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3217),
    [anon_sym_AMP] = ACTIONS(3213),
  },
  [868] = {
    [sym_concatenation] = STATE(1498),
    [sym_string] = STATE(1497),
    [sym_simple_expansion] = STATE(1497),
    [sym_string_expansion] = STATE(1497),
    [sym_expansion] = STATE(1497),
    [sym_command_substitution] = STATE(1497),
    [sym_process_substitution] = STATE(1497),
    [aux_sym_command_repeat2] = STATE(1498),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_done] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(3229),
    [anon_sym_EQ_EQ] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(3233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3235),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [869] = {
    [sym_file_redirect] = STATE(1494),
    [sym_heredoc_redirect] = STATE(1494),
    [sym_heredoc_body] = STATE(1493),
    [sym_herestring_redirect] = STATE(1494),
    [aux_sym_redirected_statement_repeat1] = STATE(1494),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_done] = ACTIONS(3237),
    [anon_sym_PIPE] = ACTIONS(3215),
    [anon_sym_SEMI_SEMI] = ACTIONS(3217),
    [anon_sym_PIPE_AMP] = ACTIONS(3219),
    [anon_sym_AMP_AMP] = ACTIONS(3221),
    [anon_sym_PIPE_PIPE] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3227),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(3217),
    [anon_sym_AMP] = ACTIONS(3213),
  },
  [870] = {
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_PLUS_EQ] = ACTIONS(3137),
    [sym_comment] = ACTIONS(57),
  },
  [871] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [872] = {
    [sym_redirected_statement] = STATE(1499),
    [sym_for_statement] = STATE(1499),
    [sym_c_style_for_statement] = STATE(1499),
    [sym_while_statement] = STATE(1499),
    [sym_if_statement] = STATE(1499),
    [sym_case_statement] = STATE(1499),
    [sym_function_definition] = STATE(1499),
    [sym_compound_statement] = STATE(1499),
    [sym_subshell] = STATE(1499),
    [sym_pipeline] = STATE(1499),
    [sym_list] = STATE(1499),
    [sym_negated_command] = STATE(1499),
    [sym_test_command] = STATE(1499),
    [sym_declaration_command] = STATE(1499),
    [sym_unset_command] = STATE(1499),
    [sym_command] = STATE(1499),
    [sym_command_name] = STATE(868),
    [sym_variable_assignment] = STATE(1500),
    [sym_subscript] = STATE(870),
    [sym_file_redirect] = STATE(873),
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(860),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [sym_process_substitution] = STATE(860),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(873),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1719),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_typeset] = ACTIONS(1725),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_readonly] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym_unset] = ACTIONS(1727),
    [anon_sym_unsetenv] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1745),
  },
  [873] = {
    [sym_command_name] = STATE(1501),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(860),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [sym_process_substitution] = STATE(860),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1735),
  },
  [874] = {
    [sym_concatenation] = STATE(1504),
    [sym_string] = STATE(1503),
    [sym_simple_expansion] = STATE(1503),
    [sym_string_expansion] = STATE(1503),
    [sym_expansion] = STATE(1503),
    [sym_command_substitution] = STATE(1503),
    [sym_process_substitution] = STATE(1503),
    [sym__special_characters] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(3243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3243),
  },
  [875] = {
    [sym_file_redirect] = STATE(366),
    [sym_heredoc_redirect] = STATE(366),
    [sym_herestring_redirect] = STATE(366),
    [aux_sym_redirected_statement_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [876] = {
    [sym_file_redirect] = STATE(366),
    [sym_heredoc_redirect] = STATE(366),
    [sym_herestring_redirect] = STATE(366),
    [aux_sym_redirected_statement_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [877] = {
    [sym_file_redirect] = STATE(366),
    [sym_heredoc_redirect] = STATE(366),
    [sym_herestring_redirect] = STATE(366),
    [aux_sym_redirected_statement_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [878] = {
    [sym_file_redirect] = STATE(366),
    [sym_heredoc_redirect] = STATE(366),
    [sym_herestring_redirect] = STATE(366),
    [aux_sym_redirected_statement_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [879] = {
    [aux_sym_concatenation_repeat1] = STATE(1505),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [880] = {
    [aux_sym_concatenation_repeat1] = STATE(1505),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [881] = {
    [sym_file_descriptor] = ACTIONS(1033),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [882] = {
    [sym_file_descriptor] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_PIPE] = ACTIONS(2544),
    [anon_sym_SEMI_SEMI] = ACTIONS(2542),
    [anon_sym_PIPE_AMP] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2542),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_GT] = ACTIONS(2544),
    [anon_sym_GT_GT] = ACTIONS(2542),
    [anon_sym_AMP_GT] = ACTIONS(2544),
    [anon_sym_AMP_GT_GT] = ACTIONS(2542),
    [anon_sym_LT_AMP] = ACTIONS(2542),
    [anon_sym_GT_AMP] = ACTIONS(2542),
    [anon_sym_LT_LT] = ACTIONS(2544),
    [anon_sym_LT_LT_DASH] = ACTIONS(2542),
    [anon_sym_LT_LT_LT] = ACTIONS(2542),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2544),
  },
  [883] = {
    [aux_sym_concatenation_repeat1] = STATE(1505),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [884] = {
    [aux_sym_concatenation_repeat1] = STATE(1505),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [885] = {
    [sym_file_descriptor] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [886] = {
    [sym_file_redirect] = STATE(886),
    [sym_heredoc_redirect] = STATE(886),
    [sym_herestring_redirect] = STATE(886),
    [aux_sym_redirected_statement_repeat1] = STATE(886),
    [sym_file_descriptor] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3248),
    [anon_sym_GT] = ACTIONS(3248),
    [anon_sym_GT_GT] = ACTIONS(3251),
    [anon_sym_AMP_GT] = ACTIONS(3248),
    [anon_sym_AMP_GT_GT] = ACTIONS(3251),
    [anon_sym_LT_AMP] = ACTIONS(3251),
    [anon_sym_GT_AMP] = ACTIONS(3251),
    [anon_sym_LT_LT] = ACTIONS(3254),
    [anon_sym_LT_LT_DASH] = ACTIONS(3257),
    [anon_sym_LT_LT_LT] = ACTIONS(3260),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [887] = {
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [888] = {
    [aux_sym_concatenation_repeat1] = STATE(341),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [889] = {
    [aux_sym_concatenation_repeat1] = STATE(341),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [890] = {
    [sym_concatenation] = STATE(890),
    [sym_string] = STATE(369),
    [sym_simple_expansion] = STATE(369),
    [sym_string_expansion] = STATE(369),
    [sym_expansion] = STATE(369),
    [sym_command_substitution] = STATE(369),
    [sym_process_substitution] = STATE(369),
    [aux_sym_command_repeat2] = STATE(890),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(3263),
    [anon_sym_EQ_EQ] = ACTIONS(3263),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [anon_sym_DOLLAR] = ACTIONS(3272),
    [sym_raw_string] = ACTIONS(3275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3278),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3281),
    [anon_sym_BQUOTE] = ACTIONS(3284),
    [anon_sym_LT_LPAREN] = ACTIONS(3287),
    [anon_sym_GT_LPAREN] = ACTIONS(3287),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3290),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [891] = {
    [sym_concatenation] = STATE(890),
    [sym_string] = STATE(369),
    [sym_simple_expansion] = STATE(369),
    [sym_string_expansion] = STATE(369),
    [sym_expansion] = STATE(369),
    [sym_command_substitution] = STATE(369),
    [sym_process_substitution] = STATE(369),
    [aux_sym_command_repeat2] = STATE(890),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [892] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(3293),
    [anon_sym_PLUS_EQ] = ACTIONS(3293),
    [sym_comment] = ACTIONS(57),
  },
  [893] = {
    [sym__simple_heredoc_body] = ACTIONS(3295),
    [sym__heredoc_body_beginning] = ACTIONS(3295),
    [sym_file_descriptor] = ACTIONS(3295),
    [ts_builtin_sym_end] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_done] = ACTIONS(3295),
    [anon_sym_fi] = ACTIONS(3295),
    [anon_sym_elif] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_esac] = ACTIONS(3295),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_RPAREN] = ACTIONS(3295),
    [anon_sym_SEMI_SEMI] = ACTIONS(3295),
    [anon_sym_PIPE_AMP] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_PIPE_PIPE] = ACTIONS(3295),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_GT_GT] = ACTIONS(3295),
    [anon_sym_AMP_GT] = ACTIONS(3297),
    [anon_sym_AMP_GT_GT] = ACTIONS(3295),
    [anon_sym_LT_AMP] = ACTIONS(3295),
    [anon_sym_GT_AMP] = ACTIONS(3295),
    [anon_sym_LT_LT] = ACTIONS(3297),
    [anon_sym_LT_LT_DASH] = ACTIONS(3295),
    [anon_sym_LT_LT_LT] = ACTIONS(3295),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3297),
  },
  [894] = {
    [sym__terminated_statement] = STATE(1507),
    [sym_redirected_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_c_style_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_compound_statement] = STATE(76),
    [sym_subshell] = STATE(76),
    [sym_pipeline] = STATE(76),
    [sym_list] = STATE(76),
    [sym_negated_command] = STATE(76),
    [sym_test_command] = STATE(76),
    [sym_declaration_command] = STATE(76),
    [sym_unset_command] = STATE(76),
    [sym_command] = STATE(76),
    [sym_command_name] = STATE(77),
    [sym_variable_assignment] = STATE(78),
    [sym_subscript] = STATE(79),
    [sym_file_redirect] = STATE(81),
    [sym_concatenation] = STATE(80),
    [sym_string] = STATE(69),
    [sym_simple_expansion] = STATE(69),
    [sym_string_expansion] = STATE(69),
    [sym_expansion] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [sym_process_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(81),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [895] = {
    [sym__statements] = STATE(1521),
    [sym_redirected_statement] = STATE(1522),
    [sym_for_statement] = STATE(1522),
    [sym_c_style_for_statement] = STATE(1522),
    [sym_while_statement] = STATE(1522),
    [sym_if_statement] = STATE(1522),
    [sym_case_statement] = STATE(1522),
    [sym_function_definition] = STATE(1522),
    [sym_compound_statement] = STATE(1522),
    [sym_subshell] = STATE(1522),
    [sym_pipeline] = STATE(1522),
    [sym_list] = STATE(1522),
    [sym_negated_command] = STATE(1522),
    [sym_test_command] = STATE(1522),
    [sym_declaration_command] = STATE(1522),
    [sym_unset_command] = STATE(1522),
    [sym_command] = STATE(1522),
    [sym_command_name] = STATE(1523),
    [sym_variable_assignment] = STATE(1524),
    [sym_subscript] = STATE(1525),
    [sym_file_redirect] = STATE(1528),
    [sym_concatenation] = STATE(1526),
    [sym_string] = STATE(1515),
    [sym_simple_expansion] = STATE(1515),
    [sym_string_expansion] = STATE(1515),
    [sym_expansion] = STATE(1515),
    [sym_command_substitution] = STATE(1515),
    [sym_process_substitution] = STATE(1515),
    [aux_sym__statements_repeat1] = STATE(1527),
    [aux_sym_command_repeat1] = STATE(1528),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_typeset] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_local] = ACTIONS(3305),
    [anon_sym_unset] = ACTIONS(3307),
    [anon_sym_unsetenv] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(3315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3325),
  },
  [896] = {
    [sym_subshell] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_command_name] = STATE(911),
    [sym_variable_assignment] = STATE(917),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(917),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym_command_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1793),
  },
  [897] = {
    [sym_variable_assignment] = STATE(1539),
    [sym_subscript] = STATE(1538),
    [sym_concatenation] = STATE(1539),
    [sym_string] = STATE(1533),
    [sym_simple_expansion] = STATE(1533),
    [sym_string_expansion] = STATE(1533),
    [sym_expansion] = STATE(1533),
    [sym_command_substitution] = STATE(1533),
    [sym_process_substitution] = STATE(1533),
    [aux_sym_declaration_command_repeat1] = STATE(1539),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_fi] = ACTIONS(263),
    [anon_sym_elif] = ACTIONS(263),
    [anon_sym_else] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [sym_raw_string] = ACTIONS(3335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3341),
    [anon_sym_LT_LPAREN] = ACTIONS(3343),
    [anon_sym_GT_LPAREN] = ACTIONS(3343),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3345),
    [sym_word] = ACTIONS(3347),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [898] = {
    [sym_concatenation] = STATE(1548),
    [sym_string] = STATE(1543),
    [sym_simple_expansion] = STATE(1543),
    [sym_string_expansion] = STATE(1543),
    [sym_expansion] = STATE(1543),
    [sym_command_substitution] = STATE(1543),
    [sym_process_substitution] = STATE(1543),
    [aux_sym_unset_command_repeat1] = STATE(1548),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_fi] = ACTIONS(287),
    [anon_sym_elif] = ACTIONS(287),
    [anon_sym_else] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_DOLLAR] = ACTIONS(3353),
    [sym_raw_string] = ACTIONS(3355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3357),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3359),
    [anon_sym_BQUOTE] = ACTIONS(3361),
    [anon_sym_LT_LPAREN] = ACTIONS(3363),
    [anon_sym_GT_LPAREN] = ACTIONS(3363),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3365),
    [sym_word] = ACTIONS(3367),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [899] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [900] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1553),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_DOLLAR] = ACTIONS(3373),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [901] = {
    [sym_string] = STATE(1555),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [sym_raw_string] = ACTIONS(3377),
    [anon_sym_POUND] = ACTIONS(3375),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AT] = ACTIONS(3381),
    [anon_sym_QMARK] = ACTIONS(3381),
    [anon_sym_0] = ACTIONS(3379),
    [anon_sym__] = ACTIONS(3379),
  },
  [902] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [903] = {
    [sym_subscript] = STATE(1560),
    [sym_variable_name] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_POUND] = ACTIONS(3385),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(3391),
    [anon_sym_QMARK] = ACTIONS(3391),
    [anon_sym_0] = ACTIONS(3389),
    [anon_sym__] = ACTIONS(3389),
  },
  [904] = {
    [sym__statements] = STATE(1561),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1562),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [905] = {
    [sym__statements] = STATE(1563),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [906] = {
    [sym__statements] = STATE(1564),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [907] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [908] = {
    [sym_elif_clause] = STATE(1567),
    [sym_else_clause] = STATE(1566),
    [aux_sym_if_statement_repeat1] = STATE(1567),
    [anon_sym_fi] = ACTIONS(3393),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [909] = {
    [sym_file_redirect] = STATE(1575),
    [sym_heredoc_redirect] = STATE(1575),
    [sym_heredoc_body] = STATE(1574),
    [sym_herestring_redirect] = STATE(1575),
    [aux_sym_redirected_statement_repeat1] = STATE(1575),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_fi] = ACTIONS(399),
    [anon_sym_elif] = ACTIONS(399),
    [anon_sym_else] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(3403),
    [anon_sym_SEMI_SEMI] = ACTIONS(3405),
    [anon_sym_PIPE_AMP] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_PIPE_PIPE] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(3411),
    [anon_sym_GT] = ACTIONS(3411),
    [anon_sym_GT_GT] = ACTIONS(3413),
    [anon_sym_AMP_GT] = ACTIONS(3411),
    [anon_sym_AMP_GT_GT] = ACTIONS(3413),
    [anon_sym_LT_AMP] = ACTIONS(3413),
    [anon_sym_GT_AMP] = ACTIONS(3413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3415),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3401),
  },
  [910] = {
    [anon_sym_fi] = ACTIONS(3393),
    [sym_comment] = ACTIONS(57),
  },
  [911] = {
    [sym_concatenation] = STATE(1579),
    [sym_string] = STATE(1578),
    [sym_simple_expansion] = STATE(1578),
    [sym_string_expansion] = STATE(1578),
    [sym_expansion] = STATE(1578),
    [sym_command_substitution] = STATE(1578),
    [sym_process_substitution] = STATE(1578),
    [aux_sym_command_repeat2] = STATE(1579),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_fi] = ACTIONS(423),
    [anon_sym_elif] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(3417),
    [anon_sym_EQ_EQ] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [912] = {
    [sym_file_redirect] = STATE(1575),
    [sym_heredoc_redirect] = STATE(1575),
    [sym_heredoc_body] = STATE(1574),
    [sym_herestring_redirect] = STATE(1575),
    [aux_sym_redirected_statement_repeat1] = STATE(1575),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_fi] = ACTIONS(3237),
    [anon_sym_elif] = ACTIONS(3237),
    [anon_sym_else] = ACTIONS(3237),
    [anon_sym_PIPE] = ACTIONS(3403),
    [anon_sym_SEMI_SEMI] = ACTIONS(3405),
    [anon_sym_PIPE_AMP] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_PIPE_PIPE] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3415),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3401),
  },
  [913] = {
    [anon_sym_EQ] = ACTIONS(3293),
    [anon_sym_PLUS_EQ] = ACTIONS(3293),
    [sym_comment] = ACTIONS(57),
  },
  [914] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [915] = {
    [sym_redirected_statement] = STATE(1580),
    [sym_for_statement] = STATE(1580),
    [sym_c_style_for_statement] = STATE(1580),
    [sym_while_statement] = STATE(1580),
    [sym_if_statement] = STATE(1580),
    [sym_case_statement] = STATE(1580),
    [sym_function_definition] = STATE(1580),
    [sym_compound_statement] = STATE(1580),
    [sym_subshell] = STATE(1580),
    [sym_pipeline] = STATE(1580),
    [sym_list] = STATE(1580),
    [sym_negated_command] = STATE(1580),
    [sym_test_command] = STATE(1580),
    [sym_declaration_command] = STATE(1580),
    [sym_unset_command] = STATE(1580),
    [sym_command] = STATE(1580),
    [sym_command_name] = STATE(911),
    [sym_variable_assignment] = STATE(1581),
    [sym_subscript] = STATE(913),
    [sym_file_redirect] = STATE(917),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1783),
    [anon_sym_typeset] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_readonly] = ACTIONS(1783),
    [anon_sym_local] = ACTIONS(1783),
    [anon_sym_unset] = ACTIONS(1785),
    [anon_sym_unsetenv] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1803),
  },
  [916] = {
    [sym_elif_clause] = STATE(1582),
    [sym_else_clause] = STATE(1566),
    [aux_sym_if_statement_repeat1] = STATE(1582),
    [anon_sym_fi] = ACTIONS(3393),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [917] = {
    [sym_command_name] = STATE(1583),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1793),
  },
  [918] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_in] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
  },
  [919] = {
    [sym_case_item] = STATE(1589),
    [sym_last_case_item] = STATE(1587),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(1589),
    [anon_sym_esac] = ACTIONS(3427),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [920] = {
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_SEMI_SEMI] = ACTIONS(3437),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3437),
  },
  [921] = {
    [aux_sym_concatenation_repeat1] = STATE(921),
    [sym__concat] = ACTIONS(3439),
    [anon_sym_in] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
  },
  [922] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_in] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2313),
  },
  [923] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [924] = {
    [sym_case_item] = STATE(1594),
    [sym_last_case_item] = STATE(1593),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(1594),
    [anon_sym_esac] = ACTIONS(3444),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [925] = {
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym_SEMI_SEMI] = ACTIONS(3448),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3448),
    [anon_sym_AMP] = ACTIONS(3448),
  },
  [926] = {
    [sym_concatenation] = STATE(1599),
    [sym_string] = STATE(1598),
    [sym_simple_expansion] = STATE(1598),
    [sym_string_expansion] = STATE(1598),
    [sym_expansion] = STATE(1598),
    [sym_command_substitution] = STATE(1598),
    [sym_process_substitution] = STATE(1598),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [sym__special_characters] = ACTIONS(3452),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(3454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3454),
  },
  [927] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3456),
    [sym_comment] = ACTIONS(57),
  },
  [928] = {
    [sym_concatenation] = STATE(1603),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1603),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3460),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3464),
    [anon_sym_COLON] = ACTIONS(3460),
    [anon_sym_COLON_QMARK] = ACTIONS(3460),
    [anon_sym_COLON_DASH] = ACTIONS(3460),
    [anon_sym_PERCENT] = ACTIONS(3460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [929] = {
    [sym_concatenation] = STATE(1605),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1605),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_DASH] = ACTIONS(3466),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3468),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_COLON_QMARK] = ACTIONS(3466),
    [anon_sym_COLON_DASH] = ACTIONS(3466),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [930] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_in] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2406),
  },
  [931] = {
    [sym_concatenation] = STATE(1608),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1608),
    [sym_regex] = ACTIONS(3472),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_EQ] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_DASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [932] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [933] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2454),
  },
  [934] = {
    [sym_concatenation] = STATE(1605),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1605),
    [sym_regex] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_DASH] = ACTIONS(3466),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3468),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_COLON_QMARK] = ACTIONS(3466),
    [anon_sym_COLON_DASH] = ACTIONS(3466),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [935] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [936] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [937] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [938] = {
    [sym_compound_statement] = STATE(1610),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [939] = {
    [aux_sym_concatenation_repeat1] = STATE(1611),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [940] = {
    [aux_sym_concatenation_repeat1] = STATE(1611),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [941] = {
    [sym_concatenation] = STATE(1086),
    [sym_string] = STATE(1613),
    [sym_array] = STATE(1086),
    [sym_simple_expansion] = STATE(1613),
    [sym_string_expansion] = STATE(1613),
    [sym_expansion] = STATE(1613),
    [sym_command_substitution] = STATE(1613),
    [sym_process_substitution] = STATE(1613),
    [sym__empty_value] = ACTIONS(2119),
    [anon_sym_LPAREN] = ACTIONS(2121),
    [sym__special_characters] = ACTIONS(3482),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(3484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [942] = {
    [aux_sym_concatenation_repeat1] = STATE(1614),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [943] = {
    [sym_variable_assignment] = STATE(943),
    [sym_subscript] = STATE(399),
    [sym_concatenation] = STATE(943),
    [sym_string] = STATE(398),
    [sym_simple_expansion] = STATE(398),
    [sym_string_expansion] = STATE(398),
    [sym_expansion] = STATE(398),
    [sym_command_substitution] = STATE(398),
    [sym_process_substitution] = STATE(398),
    [aux_sym_declaration_command_repeat1] = STATE(943),
    [sym__simple_heredoc_body] = ACTIONS(2163),
    [sym__heredoc_body_beginning] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(3486),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_RPAREN] = ACTIONS(2163),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(3489),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [anon_sym_DOLLAR] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(3492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2185),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [anon_sym_LT_LPAREN] = ACTIONS(2191),
    [anon_sym_GT_LPAREN] = ACTIONS(2191),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3495),
    [sym_word] = ACTIONS(3498),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [944] = {
    [aux_sym_concatenation_repeat1] = STATE(1615),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [945] = {
    [sym_concatenation] = STATE(945),
    [sym_string] = STATE(402),
    [sym_simple_expansion] = STATE(402),
    [sym_string_expansion] = STATE(402),
    [sym_expansion] = STATE(402),
    [sym_command_substitution] = STATE(402),
    [sym_process_substitution] = STATE(402),
    [aux_sym_unset_command_repeat1] = STATE(945),
    [sym__simple_heredoc_body] = ACTIONS(2236),
    [sym__heredoc_body_beginning] = ACTIONS(2236),
    [sym_file_descriptor] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2236),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [sym_raw_string] = ACTIONS(3504),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(2258),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3507),
    [sym_word] = ACTIONS(3510),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [946] = {
    [aux_sym_concatenation_repeat1] = STATE(946),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [947] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(1617),
    [sym_simple_expansion] = STATE(1617),
    [sym_string_expansion] = STATE(1617),
    [sym_expansion] = STATE(1617),
    [sym_command_substitution] = STATE(1617),
    [sym_process_substitution] = STATE(1617),
    [sym__special_characters] = ACTIONS(3513),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(3515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3515),
  },
  [948] = {
    [sym_file_redirect] = STATE(411),
    [sym_heredoc_redirect] = STATE(411),
    [sym_herestring_redirect] = STATE(411),
    [aux_sym_redirected_statement_repeat1] = STATE(411),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [949] = {
    [sym_file_redirect] = STATE(411),
    [sym_heredoc_redirect] = STATE(411),
    [sym_herestring_redirect] = STATE(411),
    [aux_sym_redirected_statement_repeat1] = STATE(411),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [950] = {
    [sym_file_redirect] = STATE(411),
    [sym_heredoc_redirect] = STATE(411),
    [sym_herestring_redirect] = STATE(411),
    [aux_sym_redirected_statement_repeat1] = STATE(411),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(2538),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [951] = {
    [sym_file_redirect] = STATE(411),
    [sym_heredoc_redirect] = STATE(411),
    [sym_herestring_redirect] = STATE(411),
    [aux_sym_redirected_statement_repeat1] = STATE(411),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(2538),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [952] = {
    [aux_sym_concatenation_repeat1] = STATE(1618),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_RPAREN] = ACTIONS(1015),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [953] = {
    [aux_sym_concatenation_repeat1] = STATE(1618),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_RPAREN] = ACTIONS(1033),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [954] = {
    [aux_sym_concatenation_repeat1] = STATE(1618),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2546),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [955] = {
    [aux_sym_concatenation_repeat1] = STATE(1618),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2550),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [956] = {
    [sym_file_redirect] = STATE(956),
    [sym_heredoc_redirect] = STATE(956),
    [sym_herestring_redirect] = STATE(956),
    [aux_sym_redirected_statement_repeat1] = STATE(956),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3520),
    [anon_sym_GT] = ACTIONS(3520),
    [anon_sym_GT_GT] = ACTIONS(3523),
    [anon_sym_AMP_GT] = ACTIONS(3520),
    [anon_sym_AMP_GT_GT] = ACTIONS(3523),
    [anon_sym_LT_AMP] = ACTIONS(3523),
    [anon_sym_GT_AMP] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(3526),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [957] = {
    [aux_sym_concatenation_repeat1] = STATE(404),
    [sym__simple_heredoc_body] = ACTIONS(2586),
    [sym__heredoc_body_beginning] = ACTIONS(2586),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [958] = {
    [aux_sym_concatenation_repeat1] = STATE(404),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [959] = {
    [sym_concatenation] = STATE(959),
    [sym_string] = STATE(414),
    [sym_simple_expansion] = STATE(414),
    [sym_string_expansion] = STATE(414),
    [sym_expansion] = STATE(414),
    [sym_command_substitution] = STATE(414),
    [sym_process_substitution] = STATE(414),
    [aux_sym_command_repeat2] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(3532),
    [anon_sym_DQUOTE] = ACTIONS(2596),
    [anon_sym_DOLLAR] = ACTIONS(2599),
    [sym_raw_string] = ACTIONS(3535),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2608),
    [anon_sym_BQUOTE] = ACTIONS(2611),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3538),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [960] = {
    [sym_concatenation] = STATE(959),
    [sym_string] = STATE(414),
    [sym_simple_expansion] = STATE(414),
    [sym_string_expansion] = STATE(414),
    [sym_expansion] = STATE(414),
    [sym_command_substitution] = STATE(414),
    [sym_process_substitution] = STATE(414),
    [aux_sym_command_repeat2] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(761),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [961] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [962] = {
    [sym_concatenation] = STATE(1620),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1620),
    [anon_sym_RPAREN] = ACTIONS(3541),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [963] = {
    [aux_sym_concatenation_repeat1] = STATE(1622),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(3543),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_RBRACE] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1411),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [964] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1625),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [965] = {
    [sym_string] = STATE(1627),
    [anon_sym_DASH] = ACTIONS(3549),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [anon_sym_DOLLAR] = ACTIONS(3549),
    [sym_raw_string] = ACTIONS(3551),
    [anon_sym_POUND] = ACTIONS(3549),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3553),
    [anon_sym_STAR] = ACTIONS(3555),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_0] = ACTIONS(3553),
    [anon_sym__] = ACTIONS(3553),
  },
  [966] = {
    [aux_sym_concatenation_repeat1] = STATE(1622),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(3543),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [967] = {
    [sym_subscript] = STATE(1632),
    [sym_variable_name] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3561),
    [anon_sym_DOLLAR] = ACTIONS(3561),
    [anon_sym_POUND] = ACTIONS(3559),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3563),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_AT] = ACTIONS(3565),
    [anon_sym_QMARK] = ACTIONS(3565),
    [anon_sym_0] = ACTIONS(3563),
    [anon_sym__] = ACTIONS(3563),
  },
  [968] = {
    [sym__statements] = STATE(1633),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1634),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [969] = {
    [sym__statements] = STATE(1635),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [970] = {
    [sym__statements] = STATE(1636),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [971] = {
    [sym__expression] = STATE(1638),
    [sym_binary_expression] = STATE(1638),
    [sym_unary_expression] = STATE(1638),
    [sym_postfix_expression] = STATE(1638),
    [sym_parenthesized_expression] = STATE(1638),
    [sym_concatenation] = STATE(1638),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(3567),
    [anon_sym_SEMI_SEMI] = ACTIONS(3569),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3569),
  },
  [972] = {
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_SEMI_SEMI] = ACTIONS(3573),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(3573),
    [anon_sym_AMP] = ACTIONS(3571),
  },
  [973] = {
    [sym_concatenation] = STATE(1640),
    [sym_string] = STATE(727),
    [sym_simple_expansion] = STATE(727),
    [sym_string_expansion] = STATE(727),
    [sym_expansion] = STATE(727),
    [sym_command_substitution] = STATE(727),
    [sym_process_substitution] = STATE(727),
    [aux_sym_for_statement_repeat1] = STATE(1640),
    [sym__special_characters] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [sym_raw_string] = ACTIONS(1481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1485),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(1489),
    [anon_sym_GT_LPAREN] = ACTIONS(1489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1481),
  },
  [974] = {
    [sym_do_group] = STATE(1641),
    [anon_sym_do] = ACTIONS(1921),
    [sym_comment] = ACTIONS(57),
  },
  [975] = {
    [sym__simple_heredoc_body] = ACTIONS(1563),
    [sym__heredoc_body_beginning] = ACTIONS(1563),
    [sym_file_descriptor] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1565),
    [anon_sym_PIPE] = ACTIONS(1565),
    [anon_sym_SEMI_SEMI] = ACTIONS(1563),
    [anon_sym_RBRACE] = ACTIONS(1563),
    [anon_sym_PIPE_AMP] = ACTIONS(1563),
    [anon_sym_AMP_AMP] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE] = ACTIONS(1563),
    [anon_sym_LT] = ACTIONS(1565),
    [anon_sym_GT] = ACTIONS(1565),
    [anon_sym_GT_GT] = ACTIONS(1563),
    [anon_sym_AMP_GT] = ACTIONS(1565),
    [anon_sym_AMP_GT_GT] = ACTIONS(1563),
    [anon_sym_LT_AMP] = ACTIONS(1563),
    [anon_sym_GT_AMP] = ACTIONS(1563),
    [anon_sym_LT_LT] = ACTIONS(1565),
    [anon_sym_LT_LT_DASH] = ACTIONS(1563),
    [anon_sym_LT_LT_LT] = ACTIONS(1563),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1565),
  },
  [976] = {
    [sym__statements] = STATE(1643),
    [sym_redirected_statement] = STATE(867),
    [sym_for_statement] = STATE(867),
    [sym_c_style_for_statement] = STATE(867),
    [sym_while_statement] = STATE(867),
    [sym_if_statement] = STATE(867),
    [sym_case_statement] = STATE(867),
    [sym_function_definition] = STATE(867),
    [sym_compound_statement] = STATE(867),
    [sym_subshell] = STATE(867),
    [sym_pipeline] = STATE(867),
    [sym_list] = STATE(867),
    [sym_negated_command] = STATE(867),
    [sym_test_command] = STATE(867),
    [sym_declaration_command] = STATE(867),
    [sym_unset_command] = STATE(867),
    [sym_command] = STATE(867),
    [sym_command_name] = STATE(868),
    [sym_variable_assignment] = STATE(869),
    [sym_subscript] = STATE(870),
    [sym_file_redirect] = STATE(873),
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(860),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [sym_process_substitution] = STATE(860),
    [aux_sym__statements_repeat1] = STATE(872),
    [aux_sym_command_repeat1] = STATE(873),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1719),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_typeset] = ACTIONS(1725),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_readonly] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym_unset] = ACTIONS(1727),
    [anon_sym_unsetenv] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1745),
  },
  [977] = {
    [sym__simple_heredoc_body] = ACTIONS(1747),
    [sym__heredoc_body_beginning] = ACTIONS(1747),
    [sym_file_descriptor] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1749),
    [anon_sym_SEMI_SEMI] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(1747),
    [anon_sym_PIPE_AMP] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1749),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_AMP_GT] = ACTIONS(1749),
    [anon_sym_AMP_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_AMP] = ACTIONS(1747),
    [anon_sym_GT_AMP] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1749),
    [anon_sym_LT_LT_DASH] = ACTIONS(1747),
    [anon_sym_LT_LT_LT] = ACTIONS(1747),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1749),
  },
  [978] = {
    [sym__statements] = STATE(1645),
    [sym_redirected_statement] = STATE(909),
    [sym_for_statement] = STATE(909),
    [sym_c_style_for_statement] = STATE(909),
    [sym_while_statement] = STATE(909),
    [sym_if_statement] = STATE(909),
    [sym_elif_clause] = STATE(1647),
    [sym_else_clause] = STATE(1646),
    [sym_case_statement] = STATE(909),
    [sym_function_definition] = STATE(909),
    [sym_compound_statement] = STATE(909),
    [sym_subshell] = STATE(909),
    [sym_pipeline] = STATE(909),
    [sym_list] = STATE(909),
    [sym_negated_command] = STATE(909),
    [sym_test_command] = STATE(909),
    [sym_declaration_command] = STATE(909),
    [sym_unset_command] = STATE(909),
    [sym_command] = STATE(909),
    [sym_command_name] = STATE(911),
    [sym_variable_assignment] = STATE(912),
    [sym_subscript] = STATE(913),
    [sym_file_redirect] = STATE(917),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym__statements_repeat1] = STATE(915),
    [aux_sym_if_statement_repeat1] = STATE(1647),
    [aux_sym_command_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(3577),
    [anon_sym_elif] = ACTIONS(1777),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1783),
    [anon_sym_typeset] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_readonly] = ACTIONS(1783),
    [anon_sym_local] = ACTIONS(1783),
    [anon_sym_unset] = ACTIONS(1785),
    [anon_sym_unsetenv] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1803),
  },
  [979] = {
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym_SEMI_SEMI] = ACTIONS(3581),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3581),
    [anon_sym_AMP] = ACTIONS(3581),
  },
  [980] = {
    [anon_sym_in] = ACTIONS(3583),
    [sym_comment] = ACTIONS(57),
  },
  [981] = {
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3587),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3587),
  },
  [982] = {
    [anon_sym_in] = ACTIONS(3589),
    [sym_comment] = ACTIONS(57),
  },
  [983] = {
    [anon_sym_RPAREN] = ACTIONS(3591),
    [sym_comment] = ACTIONS(57),
  },
  [984] = {
    [sym__simple_heredoc_body] = ACTIONS(1855),
    [sym__heredoc_body_beginning] = ACTIONS(1855),
    [sym_file_descriptor] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1857),
    [anon_sym_SEMI_SEMI] = ACTIONS(1855),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_PIPE_AMP] = ACTIONS(1855),
    [anon_sym_AMP_AMP] = ACTIONS(1855),
    [anon_sym_PIPE_PIPE] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_GT_GT] = ACTIONS(1855),
    [anon_sym_AMP_GT] = ACTIONS(1857),
    [anon_sym_AMP_GT_GT] = ACTIONS(1855),
    [anon_sym_LT_AMP] = ACTIONS(1855),
    [anon_sym_GT_AMP] = ACTIONS(1855),
    [anon_sym_LT_LT] = ACTIONS(1857),
    [anon_sym_LT_LT_DASH] = ACTIONS(1855),
    [anon_sym_LT_LT_LT] = ACTIONS(1855),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1855),
    [anon_sym_AMP] = ACTIONS(1857),
  },
  [985] = {
    [sym__simple_heredoc_body] = ACTIONS(1869),
    [sym__heredoc_body_beginning] = ACTIONS(1869),
    [sym_file_descriptor] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_PIPE] = ACTIONS(1871),
    [anon_sym_SEMI_SEMI] = ACTIONS(1869),
    [anon_sym_RBRACE] = ACTIONS(1869),
    [anon_sym_PIPE_AMP] = ACTIONS(1869),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_PIPE_PIPE] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_GT] = ACTIONS(1871),
    [anon_sym_GT_GT] = ACTIONS(1869),
    [anon_sym_AMP_GT] = ACTIONS(1871),
    [anon_sym_AMP_GT_GT] = ACTIONS(1869),
    [anon_sym_LT_AMP] = ACTIONS(1869),
    [anon_sym_GT_AMP] = ACTIONS(1869),
    [anon_sym_LT_LT] = ACTIONS(1871),
    [anon_sym_LT_LT_DASH] = ACTIONS(1869),
    [anon_sym_LT_LT_LT] = ACTIONS(1869),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1869),
    [anon_sym_AMP] = ACTIONS(1871),
  },
  [986] = {
    [sym__simple_heredoc_body] = ACTIONS(2035),
    [sym__heredoc_body_beginning] = ACTIONS(2035),
    [sym_file_descriptor] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI_SEMI] = ACTIONS(2035),
    [anon_sym_RBRACE] = ACTIONS(2035),
    [anon_sym_PIPE_AMP] = ACTIONS(2035),
    [anon_sym_AMP_AMP] = ACTIONS(2035),
    [anon_sym_PIPE_PIPE] = ACTIONS(2035),
    [anon_sym_LT] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2037),
    [anon_sym_GT_GT] = ACTIONS(2035),
    [anon_sym_AMP_GT] = ACTIONS(2037),
    [anon_sym_AMP_GT_GT] = ACTIONS(2035),
    [anon_sym_LT_AMP] = ACTIONS(2035),
    [anon_sym_GT_AMP] = ACTIONS(2035),
    [anon_sym_LT_LT] = ACTIONS(2037),
    [anon_sym_LT_LT_DASH] = ACTIONS(2035),
    [anon_sym_LT_LT_LT] = ACTIONS(2035),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(2037),
  },
  [987] = {
    [sym_concatenation] = STATE(1653),
    [sym_string] = STATE(1656),
    [sym_array] = STATE(1653),
    [sym_simple_expansion] = STATE(1656),
    [sym_string_expansion] = STATE(1656),
    [sym_expansion] = STATE(1656),
    [sym_command_substitution] = STATE(1656),
    [sym_process_substitution] = STATE(1656),
    [sym__empty_value] = ACTIONS(3593),
    [anon_sym_LPAREN] = ACTIONS(3595),
    [sym__special_characters] = ACTIONS(3597),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(3599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3599),
  },
  [988] = {
    [sym_string] = STATE(1657),
    [sym_simple_expansion] = STATE(1657),
    [sym_string_expansion] = STATE(1657),
    [sym_expansion] = STATE(1657),
    [sym_command_substitution] = STATE(1657),
    [sym_process_substitution] = STATE(1657),
    [sym__special_characters] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(3601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3601),
  },
  [989] = {
    [aux_sym_concatenation_repeat1] = STATE(1658),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1945),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [990] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [991] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3603),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [992] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(3603),
    [anon_sym_DOLLAR] = ACTIONS(3605),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [993] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [994] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [995] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [996] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3607),
    [sym_comment] = ACTIONS(57),
  },
  [997] = {
    [sym_subscript] = STATE(1664),
    [sym_variable_name] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_DOLLAR] = ACTIONS(3611),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AT] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3615),
    [anon_sym_0] = ACTIONS(3613),
    [anon_sym__] = ACTIONS(3613),
  },
  [998] = {
    [sym_concatenation] = STATE(1667),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1667),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3621),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3623),
    [anon_sym_COLON] = ACTIONS(3619),
    [anon_sym_COLON_QMARK] = ACTIONS(3619),
    [anon_sym_COLON_DASH] = ACTIONS(3619),
    [anon_sym_PERCENT] = ACTIONS(3619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [999] = {
    [sym_concatenation] = STATE(1670),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1670),
    [anon_sym_RBRACE] = ACTIONS(3625),
    [anon_sym_EQ] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3631),
    [anon_sym_COLON] = ACTIONS(3627),
    [anon_sym_COLON_QMARK] = ACTIONS(3627),
    [anon_sym_COLON_DASH] = ACTIONS(3627),
    [anon_sym_PERCENT] = ACTIONS(3627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1000] = {
    [anon_sym_RPAREN] = ACTIONS(3633),
    [sym_comment] = ACTIONS(57),
  },
  [1001] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1002] = {
    [anon_sym_BQUOTE] = ACTIONS(3633),
    [sym_comment] = ACTIONS(57),
  },
  [1003] = {
    [anon_sym_RPAREN] = ACTIONS(3635),
    [sym_comment] = ACTIONS(57),
  },
  [1004] = {
    [sym_variable_assignment] = STATE(1004),
    [sym_subscript] = STATE(444),
    [sym_concatenation] = STATE(1004),
    [sym_string] = STATE(439),
    [sym_simple_expansion] = STATE(439),
    [sym_string_expansion] = STATE(439),
    [sym_expansion] = STATE(439),
    [sym_command_substitution] = STATE(439),
    [sym_process_substitution] = STATE(439),
    [aux_sym_declaration_command_repeat1] = STATE(1004),
    [sym__simple_heredoc_body] = ACTIONS(2163),
    [sym__heredoc_body_beginning] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [sym_raw_string] = ACTIONS(3649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3655),
    [anon_sym_BQUOTE] = ACTIONS(3658),
    [anon_sym_LT_LPAREN] = ACTIONS(3661),
    [anon_sym_GT_LPAREN] = ACTIONS(3661),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3664),
    [sym_word] = ACTIONS(3667),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [1005] = {
    [sym_string] = STATE(1673),
    [sym_simple_expansion] = STATE(1673),
    [sym_string_expansion] = STATE(1673),
    [sym_expansion] = STATE(1673),
    [sym_command_substitution] = STATE(1673),
    [sym_process_substitution] = STATE(1673),
    [sym__special_characters] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(3670),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3670),
  },
  [1006] = {
    [aux_sym_concatenation_repeat1] = STATE(1674),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1007] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1008] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3672),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1009] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(3672),
    [anon_sym_DOLLAR] = ACTIONS(3674),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1010] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [1011] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [1012] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [1013] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3676),
    [sym_comment] = ACTIONS(57),
  },
  [1014] = {
    [sym_subscript] = STATE(1680),
    [sym_variable_name] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_DOLLAR] = ACTIONS(3680),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3682),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_AT] = ACTIONS(3684),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_0] = ACTIONS(3682),
    [anon_sym__] = ACTIONS(3682),
  },
  [1015] = {
    [sym_concatenation] = STATE(1683),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1683),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_EQ] = ACTIONS(3688),
    [anon_sym_DASH] = ACTIONS(3688),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3692),
    [anon_sym_COLON] = ACTIONS(3688),
    [anon_sym_COLON_QMARK] = ACTIONS(3688),
    [anon_sym_COLON_DASH] = ACTIONS(3688),
    [anon_sym_PERCENT] = ACTIONS(3688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1016] = {
    [sym_concatenation] = STATE(1686),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1686),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [anon_sym_EQ] = ACTIONS(3696),
    [anon_sym_DASH] = ACTIONS(3696),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_COLON] = ACTIONS(3696),
    [anon_sym_COLON_QMARK] = ACTIONS(3696),
    [anon_sym_COLON_DASH] = ACTIONS(3696),
    [anon_sym_PERCENT] = ACTIONS(3696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1017] = {
    [anon_sym_RPAREN] = ACTIONS(3702),
    [sym_comment] = ACTIONS(57),
  },
  [1018] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1019] = {
    [anon_sym_BQUOTE] = ACTIONS(3702),
    [sym_comment] = ACTIONS(57),
  },
  [1020] = {
    [anon_sym_RPAREN] = ACTIONS(3704),
    [sym_comment] = ACTIONS(57),
  },
  [1021] = {
    [sym_concatenation] = STATE(1021),
    [sym_string] = STATE(449),
    [sym_simple_expansion] = STATE(449),
    [sym_string_expansion] = STATE(449),
    [sym_expansion] = STATE(449),
    [sym_command_substitution] = STATE(449),
    [sym_process_substitution] = STATE(449),
    [aux_sym_unset_command_repeat1] = STATE(1021),
    [sym__simple_heredoc_body] = ACTIONS(2236),
    [sym__heredoc_body_beginning] = ACTIONS(2236),
    [sym_file_descriptor] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_RBRACE] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3721),
    [anon_sym_BQUOTE] = ACTIONS(3724),
    [anon_sym_LT_LPAREN] = ACTIONS(3727),
    [anon_sym_GT_LPAREN] = ACTIONS(3727),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3730),
    [sym_word] = ACTIONS(3733),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [1022] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1023] = {
    [aux_sym_concatenation_repeat1] = STATE(1023),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3736),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1024] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2315),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1025] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3739),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1026] = {
    [sym_concatenation] = STATE(1693),
    [sym_string] = STATE(1692),
    [sym_simple_expansion] = STATE(1692),
    [sym_string_expansion] = STATE(1692),
    [sym_expansion] = STATE(1692),
    [sym_command_substitution] = STATE(1692),
    [sym_process_substitution] = STATE(1692),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [sym__special_characters] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(3745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3745),
  },
  [1027] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3747),
    [sym_comment] = ACTIONS(57),
  },
  [1028] = {
    [sym_concatenation] = STATE(1697),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1697),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_DASH] = ACTIONS(3751),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3755),
    [anon_sym_COLON] = ACTIONS(3751),
    [anon_sym_COLON_QMARK] = ACTIONS(3751),
    [anon_sym_COLON_DASH] = ACTIONS(3751),
    [anon_sym_PERCENT] = ACTIONS(3751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1029] = {
    [sym_concatenation] = STATE(1699),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1699),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3757),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3761),
    [anon_sym_COLON] = ACTIONS(3757),
    [anon_sym_COLON_QMARK] = ACTIONS(3757),
    [anon_sym_COLON_DASH] = ACTIONS(3757),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1030] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1031] = {
    [sym_concatenation] = STATE(1702),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1702),
    [sym_regex] = ACTIONS(3763),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_EQ] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_DASH] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1032] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1033] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1034] = {
    [sym_concatenation] = STATE(1699),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1699),
    [sym_regex] = ACTIONS(3771),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3757),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3757),
    [anon_sym_COLON_QMARK] = ACTIONS(3757),
    [anon_sym_COLON_DASH] = ACTIONS(3757),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1035] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1036] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1037] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2504),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1038] = {
    [sym_compound_statement] = STATE(1704),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [1039] = {
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
  },
  [1040] = {
    [sym_simple_expansion] = STATE(1231),
    [sym_expansion] = STATE(1231),
    [sym_command_substitution] = STATE(1231),
    [aux_sym_heredoc_body_repeat1] = STATE(1231),
    [sym__heredoc_body_middle] = ACTIONS(2526),
    [sym__heredoc_body_end] = ACTIONS(3773),
    [anon_sym_DOLLAR] = ACTIONS(1215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1219),
    [anon_sym_BQUOTE] = ACTIONS(1221),
    [sym_comment] = ACTIONS(57),
  },
  [1041] = {
    [sym_concatenation] = STATE(1708),
    [sym_string] = STATE(1707),
    [sym_simple_expansion] = STATE(1707),
    [sym_string_expansion] = STATE(1707),
    [sym_expansion] = STATE(1707),
    [sym_command_substitution] = STATE(1707),
    [sym_process_substitution] = STATE(1707),
    [sym__special_characters] = ACTIONS(3775),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(3777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3777),
  },
  [1042] = {
    [sym_file_redirect] = STATE(483),
    [sym_heredoc_redirect] = STATE(483),
    [sym_herestring_redirect] = STATE(483),
    [aux_sym_redirected_statement_repeat1] = STATE(483),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1043] = {
    [sym_file_redirect] = STATE(483),
    [sym_heredoc_redirect] = STATE(483),
    [sym_herestring_redirect] = STATE(483),
    [aux_sym_redirected_statement_repeat1] = STATE(483),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1044] = {
    [sym_file_redirect] = STATE(483),
    [sym_heredoc_redirect] = STATE(483),
    [sym_herestring_redirect] = STATE(483),
    [aux_sym_redirected_statement_repeat1] = STATE(483),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [1045] = {
    [sym_file_redirect] = STATE(483),
    [sym_heredoc_redirect] = STATE(483),
    [sym_herestring_redirect] = STATE(483),
    [aux_sym_redirected_statement_repeat1] = STATE(483),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [1046] = {
    [aux_sym_concatenation_repeat1] = STATE(1709),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [1047] = {
    [aux_sym_concatenation_repeat1] = STATE(1709),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [1048] = {
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [1049] = {
    [sym__simple_heredoc_body] = ACTIONS(2542),
    [sym__heredoc_body_beginning] = ACTIONS(2542),
    [sym_file_descriptor] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_PIPE] = ACTIONS(2544),
    [anon_sym_SEMI_SEMI] = ACTIONS(2542),
    [anon_sym_RBRACE] = ACTIONS(2542),
    [anon_sym_PIPE_AMP] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2542),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_GT] = ACTIONS(2544),
    [anon_sym_GT_GT] = ACTIONS(2542),
    [anon_sym_AMP_GT] = ACTIONS(2544),
    [anon_sym_AMP_GT_GT] = ACTIONS(2542),
    [anon_sym_LT_AMP] = ACTIONS(2542),
    [anon_sym_GT_AMP] = ACTIONS(2542),
    [anon_sym_LT_LT] = ACTIONS(2544),
    [anon_sym_LT_LT_DASH] = ACTIONS(2542),
    [anon_sym_LT_LT_LT] = ACTIONS(2542),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2544),
  },
  [1050] = {
    [aux_sym_concatenation_repeat1] = STATE(1709),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [1051] = {
    [aux_sym_concatenation_repeat1] = STATE(1709),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [1052] = {
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [1053] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [1054] = {
    [sym_file_redirect] = STATE(1054),
    [sym_heredoc_redirect] = STATE(1054),
    [sym_herestring_redirect] = STATE(1054),
    [aux_sym_redirected_statement_repeat1] = STATE(1054),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(3779),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3782),
    [anon_sym_GT] = ACTIONS(3782),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_AMP_GT] = ACTIONS(3782),
    [anon_sym_AMP_GT_GT] = ACTIONS(3785),
    [anon_sym_LT_AMP] = ACTIONS(3785),
    [anon_sym_GT_AMP] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3788),
    [anon_sym_LT_LT_DASH] = ACTIONS(3791),
    [anon_sym_LT_LT_LT] = ACTIONS(3794),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [1055] = {
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2584),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [1056] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__simple_heredoc_body] = ACTIONS(2586),
    [sym__heredoc_body_beginning] = ACTIONS(2586),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [1057] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2584),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [1058] = {
    [sym_concatenation] = STATE(1058),
    [sym_string] = STATE(486),
    [sym_simple_expansion] = STATE(486),
    [sym_string_expansion] = STATE(486),
    [sym_expansion] = STATE(486),
    [sym_command_substitution] = STATE(486),
    [sym_process_substitution] = STATE(486),
    [aux_sym_command_repeat2] = STATE(1058),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(3797),
    [anon_sym_EQ_EQ] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3803),
    [anon_sym_DOLLAR] = ACTIONS(3806),
    [sym_raw_string] = ACTIONS(3809),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3815),
    [anon_sym_BQUOTE] = ACTIONS(3818),
    [anon_sym_LT_LPAREN] = ACTIONS(3821),
    [anon_sym_GT_LPAREN] = ACTIONS(3821),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3824),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [1059] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [1060] = {
    [anon_sym_SEMI] = ACTIONS(3827),
    [anon_sym_SEMI_SEMI] = ACTIONS(3829),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3829),
  },
  [1061] = {
    [sym_concatenation] = STATE(1058),
    [sym_string] = STATE(486),
    [sym_simple_expansion] = STATE(486),
    [sym_string_expansion] = STATE(486),
    [sym_expansion] = STATE(486),
    [sym_command_substitution] = STATE(486),
    [sym_process_substitution] = STATE(486),
    [aux_sym_command_repeat2] = STATE(1058),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(885),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(889),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [1062] = {
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1385),
  },
  [1063] = {
    [sym_concatenation] = STATE(1712),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1712),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [1064] = {
    [aux_sym_concatenation_repeat1] = STATE(553),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1407),
  },
  [1065] = {
    [aux_sym_concatenation_repeat1] = STATE(553),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1385),
  },
  [1066] = {
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_PIPE_PIPE] = ACTIONS(2858),
    [anon_sym_RBRACK] = ACTIONS(2858),
    [anon_sym_EQ_TILDE] = ACTIONS(2858),
    [anon_sym_EQ_EQ] = ACTIONS(2858),
    [anon_sym_EQ] = ACTIONS(2860),
    [anon_sym_PLUS_EQ] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_BANG_EQ] = ACTIONS(2858),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_DASH_EQ] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2858),
    [anon_sym_GT_EQ] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2858),
  },
  [1067] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_RBRACK] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [1068] = {
    [aux_sym_concatenation_repeat1] = STATE(1068),
    [sym__concat] = ACTIONS(3833),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_RBRACK] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [1069] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_RBRACK] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2313),
    [anon_sym_EQ_EQ] = ACTIONS(2313),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_BANG_EQ] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2315),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_LT_EQ] = ACTIONS(2313),
    [anon_sym_GT_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2313),
  },
  [1070] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1071] = {
    [sym_concatenation] = STATE(1717),
    [sym_string] = STATE(1716),
    [sym_simple_expansion] = STATE(1716),
    [sym_string_expansion] = STATE(1716),
    [sym_expansion] = STATE(1716),
    [sym_command_substitution] = STATE(1716),
    [sym_process_substitution] = STATE(1716),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [sym__special_characters] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(3842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3842),
  },
  [1072] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3844),
    [sym_comment] = ACTIONS(57),
  },
  [1073] = {
    [sym_concatenation] = STATE(1721),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1721),
    [anon_sym_RBRACE] = ACTIONS(3846),
    [anon_sym_EQ] = ACTIONS(3848),
    [anon_sym_DASH] = ACTIONS(3848),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3852),
    [anon_sym_COLON] = ACTIONS(3848),
    [anon_sym_COLON_QMARK] = ACTIONS(3848),
    [anon_sym_COLON_DASH] = ACTIONS(3848),
    [anon_sym_PERCENT] = ACTIONS(3848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1074] = {
    [sym_concatenation] = STATE(1723),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1723),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_DASH] = ACTIONS(3854),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3858),
    [anon_sym_COLON] = ACTIONS(3854),
    [anon_sym_COLON_QMARK] = ACTIONS(3854),
    [anon_sym_COLON_DASH] = ACTIONS(3854),
    [anon_sym_PERCENT] = ACTIONS(3854),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1075] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_RBRACK] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2406),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_PLUS_EQ] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_DASH_EQ] = ACTIONS(2406),
    [anon_sym_LT_EQ] = ACTIONS(2406),
    [anon_sym_GT_EQ] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2406),
  },
  [1076] = {
    [sym_concatenation] = STATE(1726),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1726),
    [sym_regex] = ACTIONS(3860),
    [anon_sym_RBRACE] = ACTIONS(3862),
    [anon_sym_EQ] = ACTIONS(3864),
    [anon_sym_DASH] = ACTIONS(3864),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3864),
    [anon_sym_COLON_QMARK] = ACTIONS(3864),
    [anon_sym_COLON_DASH] = ACTIONS(3864),
    [anon_sym_PERCENT] = ACTIONS(3864),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1077] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3862),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1078] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_RBRACK] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2454),
  },
  [1079] = {
    [sym_concatenation] = STATE(1723),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1723),
    [sym_regex] = ACTIONS(3868),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_DASH] = ACTIONS(3854),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3854),
    [anon_sym_COLON_QMARK] = ACTIONS(3854),
    [anon_sym_COLON_DASH] = ACTIONS(3854),
    [anon_sym_PERCENT] = ACTIONS(3854),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1080] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1081] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_RBRACK] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2464),
  },
  [1082] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_EQ] = ACTIONS(2504),
    [anon_sym_PLUS_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_BANG_EQ] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_DASH_EQ] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2502),
  },
  [1083] = {
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [1084] = {
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [1085] = {
    [aux_sym_concatenation_repeat1] = STATE(1085),
    [sym__concat] = ACTIONS(2864),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [1086] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [ts_builtin_sym_end] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1087] = {
    [sym_concatenation] = STATE(1729),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1729),
    [anon_sym_RPAREN] = ACTIONS(3870),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [1088] = {
    [aux_sym_concatenation_repeat1] = STATE(519),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1407),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [1089] = {
    [aux_sym_concatenation_repeat1] = STATE(519),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1385),
    [ts_builtin_sym_end] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1090] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1091] = {
    [aux_sym_concatenation_repeat1] = STATE(1091),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3872),
    [sym_variable_name] = ACTIONS(2306),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1092] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1093] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1094] = {
    [sym_concatenation] = STATE(1734),
    [sym_string] = STATE(1733),
    [sym_simple_expansion] = STATE(1733),
    [sym_string_expansion] = STATE(1733),
    [sym_expansion] = STATE(1733),
    [sym_command_substitution] = STATE(1733),
    [sym_process_substitution] = STATE(1733),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [sym__special_characters] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(3881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3881),
  },
  [1095] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3883),
    [sym_comment] = ACTIONS(57),
  },
  [1096] = {
    [sym_concatenation] = STATE(1738),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1738),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3887),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3887),
    [anon_sym_COLON_QMARK] = ACTIONS(3887),
    [anon_sym_COLON_DASH] = ACTIONS(3887),
    [anon_sym_PERCENT] = ACTIONS(3887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1097] = {
    [sym_concatenation] = STATE(1740),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1740),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_EQ] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_DASH] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1098] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [ts_builtin_sym_end] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1099] = {
    [sym_concatenation] = STATE(1743),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1743),
    [sym_regex] = ACTIONS(3899),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_EQ] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3903),
    [anon_sym_COLON_QMARK] = ACTIONS(3903),
    [anon_sym_COLON_DASH] = ACTIONS(3903),
    [anon_sym_PERCENT] = ACTIONS(3903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1100] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1101] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [ts_builtin_sym_end] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1102] = {
    [sym_concatenation] = STATE(1740),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1740),
    [sym_regex] = ACTIONS(3907),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_EQ] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_DASH] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1103] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1104] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [ts_builtin_sym_end] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1105] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [ts_builtin_sym_end] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1106] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1107] = {
    [aux_sym_concatenation_repeat1] = STATE(1107),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3909),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1108] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1109] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1110] = {
    [sym_concatenation] = STATE(1749),
    [sym_string] = STATE(1748),
    [sym_simple_expansion] = STATE(1748),
    [sym_string_expansion] = STATE(1748),
    [sym_expansion] = STATE(1748),
    [sym_command_substitution] = STATE(1748),
    [sym_process_substitution] = STATE(1748),
    [anon_sym_RBRACE] = ACTIONS(3914),
    [sym__special_characters] = ACTIONS(3916),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(3918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3918),
  },
  [1111] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3920),
    [sym_comment] = ACTIONS(57),
  },
  [1112] = {
    [sym_concatenation] = STATE(1753),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1753),
    [anon_sym_RBRACE] = ACTIONS(3922),
    [anon_sym_EQ] = ACTIONS(3924),
    [anon_sym_DASH] = ACTIONS(3924),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3928),
    [anon_sym_COLON] = ACTIONS(3924),
    [anon_sym_COLON_QMARK] = ACTIONS(3924),
    [anon_sym_COLON_DASH] = ACTIONS(3924),
    [anon_sym_PERCENT] = ACTIONS(3924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1113] = {
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1755),
    [anon_sym_RBRACE] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3930),
    [anon_sym_DASH] = ACTIONS(3930),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3934),
    [anon_sym_COLON] = ACTIONS(3930),
    [anon_sym_COLON_QMARK] = ACTIONS(3930),
    [anon_sym_COLON_DASH] = ACTIONS(3930),
    [anon_sym_PERCENT] = ACTIONS(3930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1114] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [ts_builtin_sym_end] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1115] = {
    [sym_concatenation] = STATE(1758),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1758),
    [sym_regex] = ACTIONS(3936),
    [anon_sym_RBRACE] = ACTIONS(3938),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_DASH] = ACTIONS(3940),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3940),
    [anon_sym_COLON_QMARK] = ACTIONS(3940),
    [anon_sym_COLON_DASH] = ACTIONS(3940),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1116] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3938),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1117] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [ts_builtin_sym_end] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1118] = {
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1755),
    [sym_regex] = ACTIONS(3944),
    [anon_sym_RBRACE] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3930),
    [anon_sym_DASH] = ACTIONS(3930),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3930),
    [anon_sym_COLON_QMARK] = ACTIONS(3930),
    [anon_sym_COLON_DASH] = ACTIONS(3930),
    [anon_sym_PERCENT] = ACTIONS(3930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1119] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1120] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [ts_builtin_sym_end] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1121] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [ts_builtin_sym_end] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1122] = {
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2306),
  },
  [1123] = {
    [aux_sym_concatenation_repeat1] = STATE(1123),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2306),
  },
  [1124] = {
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2313),
  },
  [1125] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1126] = {
    [sym_concatenation] = STATE(1764),
    [sym_string] = STATE(1763),
    [sym_simple_expansion] = STATE(1763),
    [sym_string_expansion] = STATE(1763),
    [sym_expansion] = STATE(1763),
    [sym_command_substitution] = STATE(1763),
    [sym_process_substitution] = STATE(1763),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [sym__special_characters] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(3955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3955),
  },
  [1127] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3957),
    [sym_comment] = ACTIONS(57),
  },
  [1128] = {
    [sym_concatenation] = STATE(1768),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1768),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_EQ] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3965),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_DASH] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1129] = {
    [sym_concatenation] = STATE(1770),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1770),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3969),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3967),
    [anon_sym_COLON_QMARK] = ACTIONS(3967),
    [anon_sym_COLON_DASH] = ACTIONS(3967),
    [anon_sym_PERCENT] = ACTIONS(3967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1130] = {
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2406),
  },
  [1131] = {
    [sym_concatenation] = STATE(1773),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1773),
    [sym_regex] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_DASH] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1132] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1133] = {
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2454),
  },
  [1134] = {
    [sym_concatenation] = STATE(1770),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1770),
    [sym_regex] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3969),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(3967),
    [anon_sym_COLON_QMARK] = ACTIONS(3967),
    [anon_sym_COLON_DASH] = ACTIONS(3967),
    [anon_sym_PERCENT] = ACTIONS(3967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1135] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1136] = {
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
  },
  [1137] = {
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
  },
  [1138] = {
    [anon_sym_DQUOTE] = ACTIONS(3983),
    [anon_sym_DOLLAR] = ACTIONS(3983),
    [sym__string_content] = ACTIONS(3985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3983),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3983),
    [anon_sym_BQUOTE] = ACTIONS(3983),
    [sym_comment] = ACTIONS(343),
  },
  [1139] = {
    [sym_concatenation] = STATE(1778),
    [sym_string] = STATE(1777),
    [sym_simple_expansion] = STATE(1777),
    [sym_string_expansion] = STATE(1777),
    [sym_expansion] = STATE(1777),
    [sym_command_substitution] = STATE(1777),
    [sym_process_substitution] = STATE(1777),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [sym__special_characters] = ACTIONS(3989),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(3991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3991),
  },
  [1140] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(3993),
    [sym_comment] = ACTIONS(57),
  },
  [1141] = {
    [sym_concatenation] = STATE(1782),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1782),
    [anon_sym_RBRACE] = ACTIONS(3995),
    [anon_sym_EQ] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3997),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(3999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_COLON_QMARK] = ACTIONS(3997),
    [anon_sym_COLON_DASH] = ACTIONS(3997),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1142] = {
    [sym_concatenation] = STATE(1784),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1784),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_EQ] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4007),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_DASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1143] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym__string_content] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2408),
    [anon_sym_BQUOTE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(343),
  },
  [1144] = {
    [sym_concatenation] = STATE(1787),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1787),
    [sym_regex] = ACTIONS(4009),
    [anon_sym_RBRACE] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4013),
    [anon_sym_DASH] = ACTIONS(4013),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4015),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4013),
    [anon_sym_COLON_QMARK] = ACTIONS(4013),
    [anon_sym_COLON_DASH] = ACTIONS(4013),
    [anon_sym_PERCENT] = ACTIONS(4013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1145] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1146] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym__string_content] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2456),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2456),
    [anon_sym_BQUOTE] = ACTIONS(2456),
    [sym_comment] = ACTIONS(343),
  },
  [1147] = {
    [sym_concatenation] = STATE(1784),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1784),
    [sym_regex] = ACTIONS(4017),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_EQ] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_DASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1148] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1149] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym__string_content] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [sym_comment] = ACTIONS(343),
  },
  [1150] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [ts_builtin_sym_end] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [1151] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1152] = {
    [aux_sym_concatenation_repeat1] = STATE(670),
    [sym__concat] = ACTIONS(4023),
    [anon_sym_RBRACK] = ACTIONS(4025),
    [sym_comment] = ACTIONS(57),
  },
  [1153] = {
    [aux_sym_concatenation_repeat1] = STATE(670),
    [sym__concat] = ACTIONS(4027),
    [anon_sym_RBRACK] = ACTIONS(4029),
    [sym_comment] = ACTIONS(57),
  },
  [1154] = {
    [sym__concat] = ACTIONS(4031),
    [anon_sym_RBRACK] = ACTIONS(4029),
    [sym_comment] = ACTIONS(57),
  },
  [1155] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [ts_builtin_sym_end] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [1156] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(4039),
    [sym_comment] = ACTIONS(57),
  },
  [1157] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(1799),
    [anon_sym_DQUOTE] = ACTIONS(4041),
    [anon_sym_DOLLAR] = ACTIONS(4043),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1158] = {
    [sym_string] = STATE(1801),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(4045),
    [sym_raw_string] = ACTIONS(4047),
    [anon_sym_POUND] = ACTIONS(4045),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4049),
    [anon_sym_STAR] = ACTIONS(4051),
    [anon_sym_AT] = ACTIONS(4051),
    [anon_sym_QMARK] = ACTIONS(4051),
    [anon_sym_0] = ACTIONS(4049),
    [anon_sym__] = ACTIONS(4049),
  },
  [1159] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
  },
  [1160] = {
    [sym_subscript] = STATE(1807),
    [sym_variable_name] = ACTIONS(4055),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_DOLLAR] = ACTIONS(4059),
    [anon_sym_POUND] = ACTIONS(4057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4061),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AT] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4063),
    [anon_sym_0] = ACTIONS(4061),
    [anon_sym__] = ACTIONS(4061),
  },
  [1161] = {
    [sym__statements] = STATE(1808),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(1809),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1162] = {
    [sym__statements] = STATE(1810),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1163] = {
    [sym__statements] = STATE(1811),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1164] = {
    [anon_sym_RBRACE] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
  },
  [1165] = {
    [sym_concatenation] = STATE(1814),
    [sym_string] = STATE(1813),
    [sym_simple_expansion] = STATE(1813),
    [sym_string_expansion] = STATE(1813),
    [sym_expansion] = STATE(1813),
    [sym_command_substitution] = STATE(1813),
    [sym_process_substitution] = STATE(1813),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [sym__special_characters] = ACTIONS(4065),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4067),
  },
  [1166] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [ts_builtin_sym_end] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [1167] = {
    [sym_concatenation] = STATE(1817),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1817),
    [sym_regex] = ACTIONS(4073),
    [anon_sym_RBRACE] = ACTIONS(4075),
    [anon_sym_EQ] = ACTIONS(4077),
    [anon_sym_DASH] = ACTIONS(4077),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4077),
    [anon_sym_COLON_QMARK] = ACTIONS(4077),
    [anon_sym_COLON_DASH] = ACTIONS(4077),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1168] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4075),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1169] = {
    [sym_concatenation] = STATE(1819),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1819),
    [sym_regex] = ACTIONS(4081),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4083),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4083),
    [anon_sym_COLON_QMARK] = ACTIONS(4083),
    [anon_sym_COLON_DASH] = ACTIONS(4083),
    [anon_sym_PERCENT] = ACTIONS(4083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1170] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1171] = {
    [sym_string] = STATE(1820),
    [sym_simple_expansion] = STATE(1820),
    [sym_string_expansion] = STATE(1820),
    [sym_expansion] = STATE(1820),
    [sym_command_substitution] = STATE(1820),
    [sym_process_substitution] = STATE(1820),
    [sym__special_characters] = ACTIONS(4087),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(4087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4087),
  },
  [1172] = {
    [aux_sym_concatenation_repeat1] = STATE(1821),
    [sym__concat] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [sym__special_characters] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_POUND] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_COLON] = ACTIONS(1051),
    [anon_sym_COLON_QMARK] = ACTIONS(1051),
    [anon_sym_COLON_DASH] = ACTIONS(1051),
    [anon_sym_PERCENT] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1051),
  },
  [1173] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_EQ] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [sym__special_characters] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_POUND] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_COLON] = ACTIONS(1055),
    [anon_sym_COLON_QMARK] = ACTIONS(1055),
    [anon_sym_COLON_DASH] = ACTIONS(1055),
    [anon_sym_PERCENT] = ACTIONS(1055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1055),
  },
  [1174] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4089),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1175] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(4089),
    [anon_sym_DOLLAR] = ACTIONS(4091),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1176] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [sym__special_characters] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_POUND] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_COLON_QMARK] = ACTIONS(1089),
    [anon_sym_COLON_DASH] = ACTIONS(1089),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1089),
  },
  [1177] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_POUND] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1093),
    [anon_sym_COLON_QMARK] = ACTIONS(1093),
    [anon_sym_COLON_DASH] = ACTIONS(1093),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1093),
  },
  [1178] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_POUND] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(1097),
    [anon_sym_COLON_QMARK] = ACTIONS(1097),
    [anon_sym_COLON_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1097),
  },
  [1179] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4093),
    [sym_comment] = ACTIONS(57),
  },
  [1180] = {
    [sym_subscript] = STATE(1827),
    [sym_variable_name] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4097),
    [anon_sym_DOLLAR] = ACTIONS(4097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4099),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_AT] = ACTIONS(4101),
    [anon_sym_QMARK] = ACTIONS(4101),
    [anon_sym_0] = ACTIONS(4099),
    [anon_sym__] = ACTIONS(4099),
  },
  [1181] = {
    [sym_concatenation] = STATE(1830),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1830),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4105),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4109),
    [anon_sym_COLON] = ACTIONS(4105),
    [anon_sym_COLON_QMARK] = ACTIONS(4105),
    [anon_sym_COLON_DASH] = ACTIONS(4105),
    [anon_sym_PERCENT] = ACTIONS(4105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1182] = {
    [sym_concatenation] = STATE(1833),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1833),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4117),
    [anon_sym_COLON] = ACTIONS(4113),
    [anon_sym_COLON_QMARK] = ACTIONS(4113),
    [anon_sym_COLON_DASH] = ACTIONS(4113),
    [anon_sym_PERCENT] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1183] = {
    [sym_concatenation] = STATE(1835),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1835),
    [anon_sym_RBRACE] = ACTIONS(4119),
    [anon_sym_EQ] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4121),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_COLON_QMARK] = ACTIONS(4121),
    [anon_sym_COLON_DASH] = ACTIONS(4121),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1184] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [ts_builtin_sym_end] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1185] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4119),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1186] = {
    [anon_sym_RPAREN] = ACTIONS(4129),
    [sym_comment] = ACTIONS(57),
  },
  [1187] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4129),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1188] = {
    [anon_sym_BQUOTE] = ACTIONS(4129),
    [sym_comment] = ACTIONS(57),
  },
  [1189] = {
    [anon_sym_RPAREN] = ACTIONS(4131),
    [sym_comment] = ACTIONS(57),
  },
  [1190] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4133),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_DASH] = ACTIONS(4135),
    [sym__special_characters] = ACTIONS(4138),
    [anon_sym_DQUOTE] = ACTIONS(4141),
    [anon_sym_DOLLAR] = ACTIONS(4144),
    [sym_raw_string] = ACTIONS(4147),
    [anon_sym_POUND] = ACTIONS(4150),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4153),
    [anon_sym_COLON] = ACTIONS(4135),
    [anon_sym_COLON_QMARK] = ACTIONS(4135),
    [anon_sym_COLON_DASH] = ACTIONS(4135),
    [anon_sym_PERCENT] = ACTIONS(4135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4156),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4162),
    [anon_sym_GT_LPAREN] = ACTIONS(4162),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4165),
  },
  [1191] = {
    [sym_concatenation] = STATE(1819),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1819),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4083),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4083),
    [anon_sym_COLON_QMARK] = ACTIONS(4083),
    [anon_sym_COLON_DASH] = ACTIONS(4083),
    [anon_sym_PERCENT] = ACTIONS(4083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1192] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1367),
    [anon_sym_RPAREN] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [sym__special_characters] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_DOLLAR] = ACTIONS(1369),
    [sym_raw_string] = ACTIONS(1367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [anon_sym_LT_LPAREN] = ACTIONS(1367),
    [anon_sym_GT_LPAREN] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1367),
  },
  [1193] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [sym__special_characters] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1371),
  },
  [1194] = {
    [aux_sym_concatenation_repeat1] = STATE(1838),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1017),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1049),
  },
  [1195] = {
    [aux_sym_concatenation_repeat1] = STATE(1839),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [1196] = {
    [aux_sym_concatenation_repeat1] = STATE(1839),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1197] = {
    [sym_concatenation] = STATE(1086),
    [sym_string] = STATE(1841),
    [sym_array] = STATE(1086),
    [sym_simple_expansion] = STATE(1841),
    [sym_string_expansion] = STATE(1841),
    [sym_expansion] = STATE(1841),
    [sym_command_substitution] = STATE(1841),
    [sym_process_substitution] = STATE(1841),
    [sym__empty_value] = ACTIONS(2119),
    [anon_sym_LPAREN] = ACTIONS(2121),
    [sym__special_characters] = ACTIONS(4168),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(4170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4170),
  },
  [1198] = {
    [aux_sym_concatenation_repeat1] = STATE(1842),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1199] = {
    [sym_variable_assignment] = STATE(1199),
    [sym_subscript] = STATE(611),
    [sym_concatenation] = STATE(1199),
    [sym_string] = STATE(610),
    [sym_simple_expansion] = STATE(610),
    [sym_string_expansion] = STATE(610),
    [sym_expansion] = STATE(610),
    [sym_command_substitution] = STATE(610),
    [sym_process_substitution] = STATE(610),
    [aux_sym_declaration_command_repeat1] = STATE(1199),
    [sym__simple_heredoc_body] = ACTIONS(2163),
    [sym__heredoc_body_beginning] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(4175),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [anon_sym_DOLLAR] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(4178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2185),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [anon_sym_LT_LPAREN] = ACTIONS(2191),
    [anon_sym_GT_LPAREN] = ACTIONS(2191),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4181),
    [sym_word] = ACTIONS(4184),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [1200] = {
    [aux_sym_concatenation_repeat1] = STATE(1843),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1201] = {
    [sym_concatenation] = STATE(1201),
    [sym_string] = STATE(614),
    [sym_simple_expansion] = STATE(614),
    [sym_string_expansion] = STATE(614),
    [sym_expansion] = STATE(614),
    [sym_command_substitution] = STATE(614),
    [sym_process_substitution] = STATE(614),
    [aux_sym_unset_command_repeat1] = STATE(1201),
    [sym__simple_heredoc_body] = ACTIONS(2236),
    [sym__heredoc_body_beginning] = ACTIONS(2236),
    [sym_file_descriptor] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(4187),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [sym_raw_string] = ACTIONS(4190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(2258),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4193),
    [sym_word] = ACTIONS(4196),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [1202] = {
    [aux_sym_concatenation_repeat1] = STATE(1202),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1203] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(1845),
    [sym_simple_expansion] = STATE(1845),
    [sym_string_expansion] = STATE(1845),
    [sym_expansion] = STATE(1845),
    [sym_command_substitution] = STATE(1845),
    [sym_process_substitution] = STATE(1845),
    [sym__special_characters] = ACTIONS(4199),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4201),
  },
  [1204] = {
    [sym_file_redirect] = STATE(624),
    [sym_heredoc_redirect] = STATE(624),
    [sym_herestring_redirect] = STATE(624),
    [aux_sym_redirected_statement_repeat1] = STATE(624),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1205] = {
    [sym_file_redirect] = STATE(624),
    [sym_heredoc_redirect] = STATE(624),
    [sym_herestring_redirect] = STATE(624),
    [aux_sym_redirected_statement_repeat1] = STATE(624),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1206] = {
    [sym_file_redirect] = STATE(624),
    [sym_heredoc_redirect] = STATE(624),
    [sym_herestring_redirect] = STATE(624),
    [aux_sym_redirected_statement_repeat1] = STATE(624),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(1183),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [anon_sym_BQUOTE] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [1207] = {
    [sym_file_redirect] = STATE(624),
    [sym_heredoc_redirect] = STATE(624),
    [sym_herestring_redirect] = STATE(624),
    [aux_sym_redirected_statement_repeat1] = STATE(624),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(1183),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [1208] = {
    [aux_sym_concatenation_repeat1] = STATE(1846),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [1209] = {
    [aux_sym_concatenation_repeat1] = STATE(1846),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [1210] = {
    [aux_sym_concatenation_repeat1] = STATE(1846),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [1211] = {
    [aux_sym_concatenation_repeat1] = STATE(1846),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [anon_sym_BQUOTE] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [1212] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2556),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [1213] = {
    [sym_file_redirect] = STATE(1213),
    [sym_heredoc_redirect] = STATE(1213),
    [sym_herestring_redirect] = STATE(1213),
    [aux_sym_redirected_statement_repeat1] = STATE(1213),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(4203),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_GT] = ACTIONS(4206),
    [anon_sym_GT_GT] = ACTIONS(4209),
    [anon_sym_AMP_GT] = ACTIONS(4206),
    [anon_sym_AMP_GT_GT] = ACTIONS(4209),
    [anon_sym_LT_AMP] = ACTIONS(4209),
    [anon_sym_GT_AMP] = ACTIONS(4209),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(4212),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [1214] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__simple_heredoc_body] = ACTIONS(2586),
    [sym__heredoc_body_beginning] = ACTIONS(2586),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [1215] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [1216] = {
    [sym_concatenation] = STATE(1216),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(1216),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(4218),
    [anon_sym_DQUOTE] = ACTIONS(2596),
    [anon_sym_DOLLAR] = ACTIONS(2599),
    [sym_raw_string] = ACTIONS(4221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2608),
    [anon_sym_BQUOTE] = ACTIONS(2611),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4224),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [1217] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(2556),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [1218] = {
    [anon_sym_SEMI] = ACTIONS(4227),
    [anon_sym_SEMI_SEMI] = ACTIONS(4229),
    [anon_sym_BQUOTE] = ACTIONS(2556),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4229),
    [anon_sym_AMP] = ACTIONS(4229),
  },
  [1219] = {
    [sym_concatenation] = STATE(1216),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(1216),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [1220] = {
    [sym__simple_heredoc_body] = ACTIONS(4231),
    [sym__heredoc_body_beginning] = ACTIONS(4231),
    [sym_file_descriptor] = ACTIONS(4231),
    [ts_builtin_sym_end] = ACTIONS(4231),
    [anon_sym_SEMI] = ACTIONS(4233),
    [anon_sym_done] = ACTIONS(4231),
    [anon_sym_fi] = ACTIONS(4231),
    [anon_sym_elif] = ACTIONS(4231),
    [anon_sym_else] = ACTIONS(4231),
    [anon_sym_esac] = ACTIONS(4231),
    [anon_sym_PIPE] = ACTIONS(4233),
    [anon_sym_RPAREN] = ACTIONS(4231),
    [anon_sym_SEMI_SEMI] = ACTIONS(4231),
    [anon_sym_PIPE_AMP] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_GT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4231),
    [anon_sym_AMP_GT] = ACTIONS(4233),
    [anon_sym_AMP_GT_GT] = ACTIONS(4231),
    [anon_sym_LT_AMP] = ACTIONS(4231),
    [anon_sym_GT_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_LT_LT_DASH] = ACTIONS(4231),
    [anon_sym_LT_LT_LT] = ACTIONS(4231),
    [anon_sym_BQUOTE] = ACTIONS(4231),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4231),
    [anon_sym_AMP] = ACTIONS(4233),
  },
  [1221] = {
    [sym__heredoc_body_middle] = ACTIONS(1087),
    [sym__heredoc_body_end] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
  },
  [1222] = {
    [sym__heredoc_body_middle] = ACTIONS(1095),
    [sym__heredoc_body_end] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
  },
  [1223] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4235),
    [sym_comment] = ACTIONS(57),
  },
  [1224] = {
    [sym_subscript] = STATE(1851),
    [sym_variable_name] = ACTIONS(4237),
    [anon_sym_DASH] = ACTIONS(4239),
    [anon_sym_DOLLAR] = ACTIONS(4239),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4241),
    [anon_sym_STAR] = ACTIONS(4243),
    [anon_sym_AT] = ACTIONS(4243),
    [anon_sym_QMARK] = ACTIONS(4243),
    [anon_sym_0] = ACTIONS(4241),
    [anon_sym__] = ACTIONS(4241),
  },
  [1225] = {
    [sym_concatenation] = STATE(1854),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1854),
    [anon_sym_RBRACE] = ACTIONS(4245),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_DASH] = ACTIONS(4247),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4251),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_COLON_QMARK] = ACTIONS(4247),
    [anon_sym_COLON_DASH] = ACTIONS(4247),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1226] = {
    [sym_concatenation] = STATE(1857),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1857),
    [anon_sym_RBRACE] = ACTIONS(4253),
    [anon_sym_EQ] = ACTIONS(4255),
    [anon_sym_DASH] = ACTIONS(4255),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4259),
    [anon_sym_COLON] = ACTIONS(4255),
    [anon_sym_COLON_QMARK] = ACTIONS(4255),
    [anon_sym_COLON_DASH] = ACTIONS(4255),
    [anon_sym_PERCENT] = ACTIONS(4255),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1227] = {
    [anon_sym_RPAREN] = ACTIONS(4261),
    [sym_comment] = ACTIONS(57),
  },
  [1228] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4261),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1229] = {
    [anon_sym_BQUOTE] = ACTIONS(4261),
    [sym_comment] = ACTIONS(57),
  },
  [1230] = {
    [ts_builtin_sym_end] = ACTIONS(4263),
    [anon_sym_SEMI] = ACTIONS(4265),
    [anon_sym_done] = ACTIONS(4263),
    [anon_sym_fi] = ACTIONS(4263),
    [anon_sym_elif] = ACTIONS(4263),
    [anon_sym_else] = ACTIONS(4263),
    [anon_sym_esac] = ACTIONS(4263),
    [anon_sym_RPAREN] = ACTIONS(4263),
    [anon_sym_SEMI_SEMI] = ACTIONS(4263),
    [anon_sym_BQUOTE] = ACTIONS(4263),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4263),
    [anon_sym_AMP] = ACTIONS(4263),
  },
  [1231] = {
    [sym_simple_expansion] = STATE(1231),
    [sym_expansion] = STATE(1231),
    [sym_command_substitution] = STATE(1231),
    [aux_sym_heredoc_body_repeat1] = STATE(1231),
    [sym__heredoc_body_middle] = ACTIONS(4267),
    [sym__heredoc_body_end] = ACTIONS(4270),
    [anon_sym_DOLLAR] = ACTIONS(4272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4278),
    [anon_sym_BQUOTE] = ACTIONS(4281),
    [sym_comment] = ACTIONS(57),
  },
  [1232] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1367),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [1233] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1234] = {
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [ts_builtin_sym_end] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_done] = ACTIONS(1371),
    [anon_sym_fi] = ACTIONS(1371),
    [anon_sym_elif] = ACTIONS(1371),
    [anon_sym_else] = ACTIONS(1371),
    [anon_sym_esac] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1235] = {
    [aux_sym_concatenation_repeat1] = STATE(1859),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1236] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [ts_builtin_sym_end] = ACTIONS(4284),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_SEMI_SEMI] = ACTIONS(4284),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [1237] = {
    [sym_variable_assignment] = STATE(1199),
    [sym_subscript] = STATE(611),
    [sym_concatenation] = STATE(1199),
    [sym_string] = STATE(610),
    [sym_simple_expansion] = STATE(610),
    [sym_string_expansion] = STATE(610),
    [sym_expansion] = STATE(610),
    [sym_command_substitution] = STATE(610),
    [sym_process_substitution] = STATE(610),
    [aux_sym_declaration_command_repeat1] = STATE(1199),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2474),
    [sym_word] = ACTIONS(1165),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1238] = {
    [sym_concatenation] = STATE(1201),
    [sym_string] = STATE(614),
    [sym_simple_expansion] = STATE(614),
    [sym_string_expansion] = STATE(614),
    [sym_expansion] = STATE(614),
    [sym_command_substitution] = STATE(614),
    [sym_process_substitution] = STATE(614),
    [aux_sym_unset_command_repeat1] = STATE(1201),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2476),
    [sym_word] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [1239] = {
    [anon_sym_LT] = ACTIONS(4286),
    [anon_sym_GT] = ACTIONS(4286),
    [anon_sym_GT_GT] = ACTIONS(4288),
    [anon_sym_AMP_GT] = ACTIONS(4286),
    [anon_sym_AMP_GT_GT] = ACTIONS(4288),
    [anon_sym_LT_AMP] = ACTIONS(4288),
    [anon_sym_GT_AMP] = ACTIONS(4288),
    [sym_comment] = ACTIONS(57),
  },
  [1240] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [1241] = {
    [sym_redirected_statement] = STATE(1861),
    [sym_for_statement] = STATE(1861),
    [sym_c_style_for_statement] = STATE(1861),
    [sym_while_statement] = STATE(1861),
    [sym_if_statement] = STATE(1861),
    [sym_case_statement] = STATE(1861),
    [sym_function_definition] = STATE(1861),
    [sym_compound_statement] = STATE(1861),
    [sym_subshell] = STATE(1861),
    [sym_pipeline] = STATE(1861),
    [sym_list] = STATE(1861),
    [sym_negated_command] = STATE(1861),
    [sym_test_command] = STATE(1861),
    [sym_declaration_command] = STATE(1861),
    [sym_unset_command] = STATE(1861),
    [sym_command] = STATE(1861),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(1862),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4292),
    [anon_sym_typeset] = ACTIONS(4292),
    [anon_sym_export] = ACTIONS(4292),
    [anon_sym_readonly] = ACTIONS(4292),
    [anon_sym_local] = ACTIONS(4292),
    [anon_sym_unset] = ACTIONS(4294),
    [anon_sym_unsetenv] = ACTIONS(4294),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1242] = {
    [sym_redirected_statement] = STATE(1863),
    [sym_for_statement] = STATE(1863),
    [sym_c_style_for_statement] = STATE(1863),
    [sym_while_statement] = STATE(1863),
    [sym_if_statement] = STATE(1863),
    [sym_case_statement] = STATE(1863),
    [sym_function_definition] = STATE(1863),
    [sym_compound_statement] = STATE(1863),
    [sym_subshell] = STATE(1863),
    [sym_pipeline] = STATE(1863),
    [sym_list] = STATE(1863),
    [sym_negated_command] = STATE(1863),
    [sym_test_command] = STATE(1863),
    [sym_declaration_command] = STATE(1863),
    [sym_unset_command] = STATE(1863),
    [sym_command] = STATE(1863),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(1864),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4292),
    [anon_sym_typeset] = ACTIONS(4292),
    [anon_sym_export] = ACTIONS(4292),
    [anon_sym_readonly] = ACTIONS(4292),
    [anon_sym_local] = ACTIONS(4292),
    [anon_sym_unset] = ACTIONS(4294),
    [anon_sym_unsetenv] = ACTIONS(4294),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1243] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(1866),
    [sym_simple_expansion] = STATE(1866),
    [sym_string_expansion] = STATE(1866),
    [sym_expansion] = STATE(1866),
    [sym_command_substitution] = STATE(1866),
    [sym_process_substitution] = STATE(1866),
    [sym__special_characters] = ACTIONS(4296),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4298),
  },
  [1244] = {
    [sym_concatenation] = STATE(651),
    [sym_string] = STATE(1868),
    [sym_simple_expansion] = STATE(1868),
    [sym_string_expansion] = STATE(1868),
    [sym_expansion] = STATE(1868),
    [sym_command_substitution] = STATE(1868),
    [sym_process_substitution] = STATE(1868),
    [sym__special_characters] = ACTIONS(4300),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4302),
  },
  [1245] = {
    [anon_sym_SEMI] = ACTIONS(4304),
    [anon_sym_SEMI_SEMI] = ACTIONS(4306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4306),
    [anon_sym_AMP] = ACTIONS(4306),
  },
  [1246] = {
    [sym_file_redirect] = STATE(1870),
    [sym_heredoc_redirect] = STATE(1870),
    [sym_herestring_redirect] = STATE(1870),
    [aux_sym_redirected_statement_repeat1] = STATE(1870),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2642),
    [anon_sym_AMP_GT] = ACTIONS(2640),
    [anon_sym_AMP_GT_GT] = ACTIONS(2642),
    [anon_sym_LT_AMP] = ACTIONS(2642),
    [anon_sym_GT_AMP] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [1247] = {
    [sym_concatenation] = STATE(1216),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(1216),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1248] = {
    [sym_concatenation] = STATE(1871),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(1871),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1249] = {
    [sym__concat] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(4310),
    [anon_sym_PLUS_EQ] = ACTIONS(4310),
    [sym_comment] = ACTIONS(57),
  },
  [1250] = {
    [anon_sym_EQ] = ACTIONS(4310),
    [anon_sym_PLUS_EQ] = ACTIONS(4310),
    [sym_comment] = ACTIONS(57),
  },
  [1251] = {
    [aux_sym_concatenation_repeat1] = STATE(1251),
    [sym__concat] = ACTIONS(3833),
    [anon_sym_RBRACK] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
  },
  [1252] = {
    [sym__concat] = ACTIONS(4312),
    [anon_sym_EQ] = ACTIONS(4314),
    [anon_sym_PLUS_EQ] = ACTIONS(4314),
    [sym_comment] = ACTIONS(57),
  },
  [1253] = {
    [anon_sym_EQ] = ACTIONS(4314),
    [anon_sym_PLUS_EQ] = ACTIONS(4314),
    [sym_comment] = ACTIONS(57),
  },
  [1254] = {
    [sym_string] = STATE(1874),
    [sym_simple_expansion] = STATE(1874),
    [sym_string_expansion] = STATE(1874),
    [sym_expansion] = STATE(1874),
    [sym_command_substitution] = STATE(1874),
    [sym_process_substitution] = STATE(1874),
    [sym__special_characters] = ACTIONS(4316),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(4316),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4316),
  },
  [1255] = {
    [aux_sym_concatenation_repeat1] = STATE(1875),
    [sym__concat] = ACTIONS(2668),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1049),
  },
  [1256] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1053),
  },
  [1257] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4318),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1258] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(4318),
    [anon_sym_DOLLAR] = ACTIONS(4320),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1259] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1087),
  },
  [1260] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
  },
  [1261] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1095),
  },
  [1262] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4322),
    [sym_comment] = ACTIONS(57),
  },
  [1263] = {
    [sym_subscript] = STATE(1881),
    [sym_variable_name] = ACTIONS(4324),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_DOLLAR] = ACTIONS(4326),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4328),
    [anon_sym_STAR] = ACTIONS(4330),
    [anon_sym_AT] = ACTIONS(4330),
    [anon_sym_QMARK] = ACTIONS(4330),
    [anon_sym_0] = ACTIONS(4328),
    [anon_sym__] = ACTIONS(4328),
  },
  [1264] = {
    [sym_concatenation] = STATE(1884),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1884),
    [anon_sym_RBRACE] = ACTIONS(4332),
    [anon_sym_EQ] = ACTIONS(4334),
    [anon_sym_DASH] = ACTIONS(4334),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4338),
    [anon_sym_COLON] = ACTIONS(4334),
    [anon_sym_COLON_QMARK] = ACTIONS(4334),
    [anon_sym_COLON_DASH] = ACTIONS(4334),
    [anon_sym_PERCENT] = ACTIONS(4334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1265] = {
    [sym_concatenation] = STATE(1887),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1887),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_COLON] = ACTIONS(4342),
    [anon_sym_COLON_QMARK] = ACTIONS(4342),
    [anon_sym_COLON_DASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1266] = {
    [anon_sym_RPAREN] = ACTIONS(4348),
    [sym_comment] = ACTIONS(57),
  },
  [1267] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1268] = {
    [anon_sym_BQUOTE] = ACTIONS(4348),
    [sym_comment] = ACTIONS(57),
  },
  [1269] = {
    [anon_sym_RPAREN] = ACTIONS(4350),
    [sym_comment] = ACTIONS(57),
  },
  [1270] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [ts_builtin_sym_end] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_RPAREN] = ACTIONS(4352),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [1271] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(4356),
    [sym__special_characters] = ACTIONS(4358),
    [anon_sym_DQUOTE] = ACTIONS(4361),
    [anon_sym_DOLLAR] = ACTIONS(4364),
    [sym_raw_string] = ACTIONS(4367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4370),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4373),
    [anon_sym_BQUOTE] = ACTIONS(4376),
    [anon_sym_LT_LPAREN] = ACTIONS(4379),
    [anon_sym_GT_LPAREN] = ACTIONS(4379),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4367),
  },
  [1272] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1273] = {
    [aux_sym_concatenation_repeat1] = STATE(1273),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(4382),
    [sym_variable_name] = ACTIONS(2306),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1274] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1275] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4385),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1276] = {
    [sym_concatenation] = STATE(1894),
    [sym_string] = STATE(1893),
    [sym_simple_expansion] = STATE(1893),
    [sym_string_expansion] = STATE(1893),
    [sym_expansion] = STATE(1893),
    [sym_command_substitution] = STATE(1893),
    [sym_process_substitution] = STATE(1893),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [sym__special_characters] = ACTIONS(4389),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(4391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4391),
  },
  [1277] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4393),
    [sym_comment] = ACTIONS(57),
  },
  [1278] = {
    [sym_concatenation] = STATE(1898),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1898),
    [anon_sym_RBRACE] = ACTIONS(4395),
    [anon_sym_EQ] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4401),
    [anon_sym_COLON] = ACTIONS(4397),
    [anon_sym_COLON_QMARK] = ACTIONS(4397),
    [anon_sym_COLON_DASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1279] = {
    [sym_concatenation] = STATE(1900),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1900),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [anon_sym_EQ] = ACTIONS(4403),
    [anon_sym_DASH] = ACTIONS(4403),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4407),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COLON_QMARK] = ACTIONS(4403),
    [anon_sym_COLON_DASH] = ACTIONS(4403),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1280] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [ts_builtin_sym_end] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1281] = {
    [sym_concatenation] = STATE(1903),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1903),
    [sym_regex] = ACTIONS(4409),
    [anon_sym_RBRACE] = ACTIONS(4411),
    [anon_sym_EQ] = ACTIONS(4413),
    [anon_sym_DASH] = ACTIONS(4413),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4413),
    [anon_sym_COLON_QMARK] = ACTIONS(4413),
    [anon_sym_COLON_DASH] = ACTIONS(4413),
    [anon_sym_PERCENT] = ACTIONS(4413),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1282] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4411),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1283] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [ts_builtin_sym_end] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1284] = {
    [sym_concatenation] = STATE(1900),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1900),
    [sym_regex] = ACTIONS(4417),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [anon_sym_EQ] = ACTIONS(4403),
    [anon_sym_DASH] = ACTIONS(4403),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COLON_QMARK] = ACTIONS(4403),
    [anon_sym_COLON_DASH] = ACTIONS(4403),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1285] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1286] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [ts_builtin_sym_end] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1287] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [ts_builtin_sym_end] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1288] = {
    [sym_do_group] = STATE(1906),
    [sym_compound_statement] = STATE(1906),
    [anon_sym_SEMI] = ACTIONS(4419),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1289] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4421),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [1290] = {
    [sym__expression] = STATE(1908),
    [sym_binary_expression] = STATE(1908),
    [sym_unary_expression] = STATE(1908),
    [sym_postfix_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_concatenation] = STATE(1908),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1291] = {
    [anon_sym_SEMI] = ACTIONS(2860),
    [anon_sym_SEMI_SEMI] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_PIPE_PIPE] = ACTIONS(2858),
    [anon_sym_EQ_TILDE] = ACTIONS(2858),
    [anon_sym_EQ_EQ] = ACTIONS(2858),
    [anon_sym_EQ] = ACTIONS(2860),
    [anon_sym_PLUS_EQ] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_BANG_EQ] = ACTIONS(2858),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_DASH_EQ] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2858),
    [anon_sym_GT_EQ] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2858),
    [anon_sym_LF] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2860),
  },
  [1292] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1293] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(4423),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1294] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2313),
    [anon_sym_EQ_EQ] = ACTIONS(2313),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_BANG_EQ] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2315),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_LT_EQ] = ACTIONS(2313),
    [anon_sym_GT_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2313),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1295] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4426),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1296] = {
    [sym_concatenation] = STATE(1913),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [sym__special_characters] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(4432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4432),
  },
  [1297] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4434),
    [sym_comment] = ACTIONS(57),
  },
  [1298] = {
    [sym_concatenation] = STATE(1917),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1917),
    [anon_sym_RBRACE] = ACTIONS(4436),
    [anon_sym_EQ] = ACTIONS(4438),
    [anon_sym_DASH] = ACTIONS(4438),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4442),
    [anon_sym_COLON] = ACTIONS(4438),
    [anon_sym_COLON_QMARK] = ACTIONS(4438),
    [anon_sym_COLON_DASH] = ACTIONS(4438),
    [anon_sym_PERCENT] = ACTIONS(4438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1299] = {
    [sym_concatenation] = STATE(1919),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1919),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_EQ] = ACTIONS(4444),
    [anon_sym_DASH] = ACTIONS(4444),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4448),
    [anon_sym_COLON] = ACTIONS(4444),
    [anon_sym_COLON_QMARK] = ACTIONS(4444),
    [anon_sym_COLON_DASH] = ACTIONS(4444),
    [anon_sym_PERCENT] = ACTIONS(4444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1300] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2406),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_PLUS_EQ] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_DASH_EQ] = ACTIONS(2406),
    [anon_sym_LT_EQ] = ACTIONS(2406),
    [anon_sym_GT_EQ] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2406),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1301] = {
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1922),
    [sym_regex] = ACTIONS(4450),
    [anon_sym_RBRACE] = ACTIONS(4452),
    [anon_sym_EQ] = ACTIONS(4454),
    [anon_sym_DASH] = ACTIONS(4454),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4454),
    [anon_sym_COLON_QMARK] = ACTIONS(4454),
    [anon_sym_COLON_DASH] = ACTIONS(4454),
    [anon_sym_PERCENT] = ACTIONS(4454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1302] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4452),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1303] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2454),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1304] = {
    [sym_concatenation] = STATE(1919),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1919),
    [sym_regex] = ACTIONS(4458),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_EQ] = ACTIONS(4444),
    [anon_sym_DASH] = ACTIONS(4444),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4444),
    [anon_sym_COLON_QMARK] = ACTIONS(4444),
    [anon_sym_COLON_DASH] = ACTIONS(4444),
    [anon_sym_PERCENT] = ACTIONS(4444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1305] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1306] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1307] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_EQ] = ACTIONS(2504),
    [anon_sym_PLUS_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_BANG_EQ] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_DASH_EQ] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1308] = {
    [anon_sym_SEMI] = ACTIONS(4460),
    [anon_sym_SEMI_SEMI] = ACTIONS(4462),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(4462),
    [anon_sym_AMP] = ACTIONS(4460),
  },
  [1309] = {
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_SEMI_SEMI] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
    [anon_sym_LF] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2903),
  },
  [1310] = {
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_SEMI_SEMI] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
    [anon_sym_LF] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2903),
  },
  [1311] = {
    [sym_string] = STATE(1925),
    [sym_simple_expansion] = STATE(1925),
    [sym_string_expansion] = STATE(1925),
    [sym_expansion] = STATE(1925),
    [sym_command_substitution] = STATE(1925),
    [sym_process_substitution] = STATE(1925),
    [sym__special_characters] = ACTIONS(4464),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [sym_raw_string] = ACTIONS(4464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1485),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(1489),
    [anon_sym_GT_LPAREN] = ACTIONS(1489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4464),
  },
  [1312] = {
    [aux_sym_concatenation_repeat1] = STATE(1926),
    [sym__concat] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1049),
  },
  [1313] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1314] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4466),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1315] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(4466),
    [anon_sym_DOLLAR] = ACTIONS(4468),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1316] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1087),
  },
  [1317] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1318] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1319] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4470),
    [sym_comment] = ACTIONS(57),
  },
  [1320] = {
    [sym_subscript] = STATE(1932),
    [sym_variable_name] = ACTIONS(4472),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_DOLLAR] = ACTIONS(4474),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4476),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AT] = ACTIONS(4478),
    [anon_sym_QMARK] = ACTIONS(4478),
    [anon_sym_0] = ACTIONS(4476),
    [anon_sym__] = ACTIONS(4476),
  },
  [1321] = {
    [sym_concatenation] = STATE(1935),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1935),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_EQ] = ACTIONS(4482),
    [anon_sym_DASH] = ACTIONS(4482),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COLON_QMARK] = ACTIONS(4482),
    [anon_sym_COLON_DASH] = ACTIONS(4482),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1322] = {
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1938),
    [anon_sym_RBRACE] = ACTIONS(4488),
    [anon_sym_EQ] = ACTIONS(4490),
    [anon_sym_DASH] = ACTIONS(4490),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4494),
    [anon_sym_COLON] = ACTIONS(4490),
    [anon_sym_COLON_QMARK] = ACTIONS(4490),
    [anon_sym_COLON_DASH] = ACTIONS(4490),
    [anon_sym_PERCENT] = ACTIONS(4490),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1323] = {
    [anon_sym_RPAREN] = ACTIONS(4496),
    [sym_comment] = ACTIONS(57),
  },
  [1324] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1325] = {
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_comment] = ACTIONS(57),
  },
  [1326] = {
    [anon_sym_RPAREN] = ACTIONS(4498),
    [sym_comment] = ACTIONS(57),
  },
  [1327] = {
    [sym_do_group] = STATE(1941),
    [anon_sym_do] = ACTIONS(649),
    [sym_comment] = ACTIONS(57),
  },
  [1328] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(727),
    [sym_simple_expansion] = STATE(727),
    [sym_string_expansion] = STATE(727),
    [sym_expansion] = STATE(727),
    [sym_command_substitution] = STATE(727),
    [sym_process_substitution] = STATE(727),
    [aux_sym_for_statement_repeat1] = STATE(1328),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_SEMI_SEMI] = ACTIONS(4356),
    [sym__special_characters] = ACTIONS(4502),
    [anon_sym_DQUOTE] = ACTIONS(4505),
    [anon_sym_DOLLAR] = ACTIONS(4508),
    [sym_raw_string] = ACTIONS(4511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4517),
    [anon_sym_BQUOTE] = ACTIONS(4520),
    [anon_sym_LT_LPAREN] = ACTIONS(4523),
    [anon_sym_GT_LPAREN] = ACTIONS(4523),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4526),
    [anon_sym_LF] = ACTIONS(4356),
    [anon_sym_AMP] = ACTIONS(4356),
  },
  [1329] = {
    [anon_sym_RPAREN] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_PIPE_PIPE] = ACTIONS(2858),
    [anon_sym_EQ_TILDE] = ACTIONS(2858),
    [anon_sym_EQ_EQ] = ACTIONS(2858),
    [anon_sym_EQ] = ACTIONS(2860),
    [anon_sym_PLUS_EQ] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_BANG_EQ] = ACTIONS(2858),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_DASH_EQ] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2858),
    [anon_sym_GT_EQ] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2858),
  },
  [1330] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [1331] = {
    [aux_sym_concatenation_repeat1] = STATE(1331),
    [sym__concat] = ACTIONS(4529),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2306),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2306),
  },
  [1332] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2313),
    [anon_sym_EQ_EQ] = ACTIONS(2313),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_BANG_EQ] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2315),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_LT_EQ] = ACTIONS(2313),
    [anon_sym_GT_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2313),
  },
  [1333] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4532),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1334] = {
    [sym_concatenation] = STATE(1946),
    [sym_string] = STATE(1945),
    [sym_simple_expansion] = STATE(1945),
    [sym_string_expansion] = STATE(1945),
    [sym_expansion] = STATE(1945),
    [sym_command_substitution] = STATE(1945),
    [sym_process_substitution] = STATE(1945),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [sym__special_characters] = ACTIONS(4536),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(4538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4538),
  },
  [1335] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4540),
    [sym_comment] = ACTIONS(57),
  },
  [1336] = {
    [sym_concatenation] = STATE(1950),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1950),
    [anon_sym_RBRACE] = ACTIONS(4542),
    [anon_sym_EQ] = ACTIONS(4544),
    [anon_sym_DASH] = ACTIONS(4544),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4544),
    [anon_sym_COLON_QMARK] = ACTIONS(4544),
    [anon_sym_COLON_DASH] = ACTIONS(4544),
    [anon_sym_PERCENT] = ACTIONS(4544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1337] = {
    [sym_concatenation] = STATE(1952),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1952),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(4550),
    [anon_sym_DASH] = ACTIONS(4550),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4554),
    [anon_sym_COLON] = ACTIONS(4550),
    [anon_sym_COLON_QMARK] = ACTIONS(4550),
    [anon_sym_COLON_DASH] = ACTIONS(4550),
    [anon_sym_PERCENT] = ACTIONS(4550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1338] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2406),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_PLUS_EQ] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_DASH_EQ] = ACTIONS(2406),
    [anon_sym_LT_EQ] = ACTIONS(2406),
    [anon_sym_GT_EQ] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2406),
  },
  [1339] = {
    [sym_concatenation] = STATE(1955),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1955),
    [sym_regex] = ACTIONS(4556),
    [anon_sym_RBRACE] = ACTIONS(4558),
    [anon_sym_EQ] = ACTIONS(4560),
    [anon_sym_DASH] = ACTIONS(4560),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4560),
    [anon_sym_COLON_QMARK] = ACTIONS(4560),
    [anon_sym_COLON_DASH] = ACTIONS(4560),
    [anon_sym_PERCENT] = ACTIONS(4560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1340] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4558),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1341] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2454),
  },
  [1342] = {
    [sym_concatenation] = STATE(1952),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1952),
    [sym_regex] = ACTIONS(4564),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(4550),
    [anon_sym_DASH] = ACTIONS(4550),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4550),
    [anon_sym_COLON_QMARK] = ACTIONS(4550),
    [anon_sym_COLON_DASH] = ACTIONS(4550),
    [anon_sym_PERCENT] = ACTIONS(4550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1343] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1344] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2464),
  },
  [1345] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_EQ] = ACTIONS(2504),
    [anon_sym_PLUS_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_BANG_EQ] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_DASH_EQ] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2502),
  },
  [1346] = {
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [1347] = {
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [1348] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4019),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4019),
  },
  [1349] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4033),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4033),
    [anon_sym_LT_EQ] = ACTIONS(4033),
    [anon_sym_GT_EQ] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4033),
    [anon_sym_DASH_DASH] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4033),
  },
  [1350] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [sym_comment] = ACTIONS(57),
  },
  [1351] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [sym_comment] = ACTIONS(57),
  },
  [1352] = {
    [anon_sym_RBRACE] = ACTIONS(4568),
    [sym_comment] = ACTIONS(57),
  },
  [1353] = {
    [sym_concatenation] = STATE(1961),
    [sym_string] = STATE(1960),
    [sym_simple_expansion] = STATE(1960),
    [sym_string_expansion] = STATE(1960),
    [sym_expansion] = STATE(1960),
    [sym_command_substitution] = STATE(1960),
    [sym_process_substitution] = STATE(1960),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4570),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4572),
  },
  [1354] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4069),
    [anon_sym_LT_EQ] = ACTIONS(4069),
    [anon_sym_GT_EQ] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4069),
    [anon_sym_DASH_DASH] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4069),
  },
  [1355] = {
    [sym_concatenation] = STATE(1964),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1964),
    [sym_regex] = ACTIONS(4574),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [anon_sym_EQ] = ACTIONS(4578),
    [anon_sym_DASH] = ACTIONS(4578),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_COLON_QMARK] = ACTIONS(4578),
    [anon_sym_COLON_DASH] = ACTIONS(4578),
    [anon_sym_PERCENT] = ACTIONS(4578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1356] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1357] = {
    [sym_concatenation] = STATE(1966),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1966),
    [sym_regex] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_DASH] = ACTIONS(4584),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4584),
    [anon_sym_COLON_QMARK] = ACTIONS(4584),
    [anon_sym_COLON_DASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1358] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1359] = {
    [sym_concatenation] = STATE(1968),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1968),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4590),
    [anon_sym_COLON_QMARK] = ACTIONS(4590),
    [anon_sym_COLON_DASH] = ACTIONS(4590),
    [anon_sym_PERCENT] = ACTIONS(4590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1360] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_PLUS_EQ] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DASH_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4125),
  },
  [1361] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1362] = {
    [sym_concatenation] = STATE(1966),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1966),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_DASH] = ACTIONS(4584),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4584),
    [anon_sym_COLON_QMARK] = ACTIONS(4584),
    [anon_sym_COLON_DASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1363] = {
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [1364] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(4594),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [1365] = {
    [sym_string] = STATE(1970),
    [sym_simple_expansion] = STATE(1970),
    [sym_string_expansion] = STATE(1970),
    [sym_expansion] = STATE(1970),
    [sym_command_substitution] = STATE(1970),
    [sym_process_substitution] = STATE(1970),
    [sym__special_characters] = ACTIONS(4596),
    [anon_sym_DQUOTE] = ACTIONS(1579),
    [anon_sym_DOLLAR] = ACTIONS(1581),
    [sym_raw_string] = ACTIONS(4596),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1587),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1591),
    [anon_sym_GT_LPAREN] = ACTIONS(1591),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4596),
  },
  [1366] = {
    [aux_sym_concatenation_repeat1] = STATE(1971),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(2907),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1367] = {
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1368] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4598),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1369] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(4598),
    [anon_sym_DOLLAR] = ACTIONS(4600),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1370] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [1371] = {
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [1372] = {
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [1373] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(57),
  },
  [1374] = {
    [sym_subscript] = STATE(1977),
    [sym_variable_name] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_DOLLAR] = ACTIONS(4606),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4610),
    [anon_sym_AT] = ACTIONS(4610),
    [anon_sym_QMARK] = ACTIONS(4610),
    [anon_sym_0] = ACTIONS(4608),
    [anon_sym__] = ACTIONS(4608),
  },
  [1375] = {
    [sym_concatenation] = STATE(1980),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1980),
    [anon_sym_RBRACE] = ACTIONS(4612),
    [anon_sym_EQ] = ACTIONS(4614),
    [anon_sym_DASH] = ACTIONS(4614),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4618),
    [anon_sym_COLON] = ACTIONS(4614),
    [anon_sym_COLON_QMARK] = ACTIONS(4614),
    [anon_sym_COLON_DASH] = ACTIONS(4614),
    [anon_sym_PERCENT] = ACTIONS(4614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1376] = {
    [sym_concatenation] = STATE(1983),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1983),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_EQ] = ACTIONS(4622),
    [anon_sym_DASH] = ACTIONS(4622),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4626),
    [anon_sym_COLON] = ACTIONS(4622),
    [anon_sym_COLON_QMARK] = ACTIONS(4622),
    [anon_sym_COLON_DASH] = ACTIONS(4622),
    [anon_sym_PERCENT] = ACTIONS(4622),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1377] = {
    [anon_sym_RPAREN] = ACTIONS(4628),
    [sym_comment] = ACTIONS(57),
  },
  [1378] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1379] = {
    [anon_sym_BQUOTE] = ACTIONS(4628),
    [sym_comment] = ACTIONS(57),
  },
  [1380] = {
    [anon_sym_RPAREN] = ACTIONS(4630),
    [sym_comment] = ACTIONS(57),
  },
  [1381] = {
    [sym__expression] = STATE(1987),
    [sym_binary_expression] = STATE(1987),
    [sym_unary_expression] = STATE(1987),
    [sym_postfix_expression] = STATE(1987),
    [sym_parenthesized_expression] = STATE(1987),
    [sym_concatenation] = STATE(1987),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4632),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1382] = {
    [anon_sym_SEMI] = ACTIONS(4634),
    [anon_sym_SEMI_SEMI] = ACTIONS(4636),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(4636),
    [anon_sym_AMP] = ACTIONS(4634),
  },
  [1383] = {
    [sym__expression] = STATE(1989),
    [sym_binary_expression] = STATE(1989),
    [sym_unary_expression] = STATE(1989),
    [sym_postfix_expression] = STATE(1989),
    [sym_parenthesized_expression] = STATE(1989),
    [sym_concatenation] = STATE(1989),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(4634),
    [anon_sym_SEMI_SEMI] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(4636),
    [anon_sym_AMP] = ACTIONS(4636),
  },
  [1384] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(727),
    [sym_simple_expansion] = STATE(727),
    [sym_string_expansion] = STATE(727),
    [sym_expansion] = STATE(727),
    [sym_command_substitution] = STATE(727),
    [sym_process_substitution] = STATE(727),
    [aux_sym_for_statement_repeat1] = STATE(1328),
    [anon_sym_SEMI] = ACTIONS(4638),
    [anon_sym_SEMI_SEMI] = ACTIONS(4640),
    [sym__special_characters] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [sym_raw_string] = ACTIONS(1481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1485),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(1489),
    [anon_sym_GT_LPAREN] = ACTIONS(1489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2814),
    [anon_sym_LF] = ACTIONS(4640),
    [anon_sym_AMP] = ACTIONS(4640),
  },
  [1385] = {
    [sym_file_descriptor] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [anon_sym_PIPE_AMP] = ACTIONS(2816),
    [anon_sym_AMP_AMP] = ACTIONS(2816),
    [anon_sym_PIPE_PIPE] = ACTIONS(2816),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_GT] = ACTIONS(2818),
    [anon_sym_GT_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT] = ACTIONS(2818),
    [anon_sym_AMP_GT_GT] = ACTIONS(2816),
    [anon_sym_LT_AMP] = ACTIONS(2816),
    [anon_sym_GT_AMP] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2818),
    [anon_sym_LT_LT_DASH] = ACTIONS(2816),
    [anon_sym_LT_LT_LT] = ACTIONS(2816),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2818),
  },
  [1386] = {
    [sym_file_descriptor] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_SEMI_SEMI] = ACTIONS(3139),
    [anon_sym_PIPE_AMP] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_GT] = ACTIONS(3141),
    [anon_sym_GT_GT] = ACTIONS(3139),
    [anon_sym_AMP_GT] = ACTIONS(3141),
    [anon_sym_AMP_GT_GT] = ACTIONS(3139),
    [anon_sym_LT_AMP] = ACTIONS(3139),
    [anon_sym_GT_AMP] = ACTIONS(3139),
    [anon_sym_LT_LT] = ACTIONS(3141),
    [anon_sym_LT_LT_DASH] = ACTIONS(3139),
    [anon_sym_LT_LT_LT] = ACTIONS(3139),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3141),
  },
  [1387] = {
    [anon_sym_done] = ACTIONS(4642),
    [sym_comment] = ACTIONS(57),
  },
  [1388] = {
    [sym_file_descriptor] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_SEMI_SEMI] = ACTIONS(3295),
    [anon_sym_PIPE_AMP] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_PIPE_PIPE] = ACTIONS(3295),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_GT_GT] = ACTIONS(3295),
    [anon_sym_AMP_GT] = ACTIONS(3297),
    [anon_sym_AMP_GT_GT] = ACTIONS(3295),
    [anon_sym_LT_AMP] = ACTIONS(3295),
    [anon_sym_GT_AMP] = ACTIONS(3295),
    [anon_sym_LT_LT] = ACTIONS(3297),
    [anon_sym_LT_LT_DASH] = ACTIONS(3295),
    [anon_sym_LT_LT_LT] = ACTIONS(3295),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3297),
  },
  [1389] = {
    [sym_elif_clause] = STATE(1994),
    [sym_else_clause] = STATE(1993),
    [aux_sym_if_statement_repeat1] = STATE(1994),
    [anon_sym_fi] = ACTIONS(4644),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [1390] = {
    [anon_sym_fi] = ACTIONS(4644),
    [sym_comment] = ACTIONS(57),
  },
  [1391] = {
    [sym_elif_clause] = STATE(1582),
    [sym_else_clause] = STATE(1993),
    [aux_sym_if_statement_repeat1] = STATE(1582),
    [anon_sym_fi] = ACTIONS(4644),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [1392] = {
    [sym_case_item] = STATE(1997),
    [sym_last_case_item] = STATE(1996),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(1997),
    [anon_sym_esac] = ACTIONS(4646),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [1393] = {
    [anon_sym_SEMI] = ACTIONS(4648),
    [anon_sym_SEMI_SEMI] = ACTIONS(4650),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4650),
    [anon_sym_AMP] = ACTIONS(4650),
  },
  [1394] = {
    [sym_case_item] = STATE(2001),
    [sym_last_case_item] = STATE(2000),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2001),
    [anon_sym_esac] = ACTIONS(4652),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [1395] = {
    [anon_sym_SEMI] = ACTIONS(4654),
    [anon_sym_SEMI_SEMI] = ACTIONS(4656),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4656),
    [anon_sym_AMP] = ACTIONS(4656),
  },
  [1396] = {
    [sym_compound_statement] = STATE(2003),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [1397] = {
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1398] = {
    [sym_concatenation] = STATE(2005),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(2005),
    [anon_sym_RPAREN] = ACTIONS(4658),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [1399] = {
    [aux_sym_concatenation_repeat1] = STATE(802),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(1629),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [1400] = {
    [aux_sym_concatenation_repeat1] = STATE(802),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(1629),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1401] = {
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1402] = {
    [aux_sym_concatenation_repeat1] = STATE(1402),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(4660),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1403] = {
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1404] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4663),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1405] = {
    [sym_concatenation] = STATE(2010),
    [sym_string] = STATE(2009),
    [sym_simple_expansion] = STATE(2009),
    [sym_string_expansion] = STATE(2009),
    [sym_expansion] = STATE(2009),
    [sym_command_substitution] = STATE(2009),
    [sym_process_substitution] = STATE(2009),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [sym__special_characters] = ACTIONS(4667),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(4669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4669),
  },
  [1406] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4671),
    [sym_comment] = ACTIONS(57),
  },
  [1407] = {
    [sym_concatenation] = STATE(2014),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2014),
    [anon_sym_RBRACE] = ACTIONS(4673),
    [anon_sym_EQ] = ACTIONS(4675),
    [anon_sym_DASH] = ACTIONS(4675),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4679),
    [anon_sym_COLON] = ACTIONS(4675),
    [anon_sym_COLON_QMARK] = ACTIONS(4675),
    [anon_sym_COLON_DASH] = ACTIONS(4675),
    [anon_sym_PERCENT] = ACTIONS(4675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1408] = {
    [sym_concatenation] = STATE(2016),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2016),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [anon_sym_EQ] = ACTIONS(4681),
    [anon_sym_DASH] = ACTIONS(4681),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4685),
    [anon_sym_COLON] = ACTIONS(4681),
    [anon_sym_COLON_QMARK] = ACTIONS(4681),
    [anon_sym_COLON_DASH] = ACTIONS(4681),
    [anon_sym_PERCENT] = ACTIONS(4681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1409] = {
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1410] = {
    [sym_concatenation] = STATE(2019),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2019),
    [sym_regex] = ACTIONS(4687),
    [anon_sym_RBRACE] = ACTIONS(4689),
    [anon_sym_EQ] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4691),
    [anon_sym_COLON_QMARK] = ACTIONS(4691),
    [anon_sym_COLON_DASH] = ACTIONS(4691),
    [anon_sym_PERCENT] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1411] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4689),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1412] = {
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1413] = {
    [sym_concatenation] = STATE(2016),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2016),
    [sym_regex] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [anon_sym_EQ] = ACTIONS(4681),
    [anon_sym_DASH] = ACTIONS(4681),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4681),
    [anon_sym_COLON_QMARK] = ACTIONS(4681),
    [anon_sym_COLON_DASH] = ACTIONS(4681),
    [anon_sym_PERCENT] = ACTIONS(4681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1414] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1415] = {
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1416] = {
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1417] = {
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1418] = {
    [aux_sym_concatenation_repeat1] = STATE(1418),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(4697),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1419] = {
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1420] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4700),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1421] = {
    [sym_concatenation] = STATE(2025),
    [sym_string] = STATE(2024),
    [sym_simple_expansion] = STATE(2024),
    [sym_string_expansion] = STATE(2024),
    [sym_expansion] = STATE(2024),
    [sym_command_substitution] = STATE(2024),
    [sym_process_substitution] = STATE(2024),
    [anon_sym_RBRACE] = ACTIONS(4702),
    [sym__special_characters] = ACTIONS(4704),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(4706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4706),
  },
  [1422] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4708),
    [sym_comment] = ACTIONS(57),
  },
  [1423] = {
    [sym_concatenation] = STATE(2029),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2029),
    [anon_sym_RBRACE] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(4712),
    [anon_sym_DASH] = ACTIONS(4712),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4716),
    [anon_sym_COLON] = ACTIONS(4712),
    [anon_sym_COLON_QMARK] = ACTIONS(4712),
    [anon_sym_COLON_DASH] = ACTIONS(4712),
    [anon_sym_PERCENT] = ACTIONS(4712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1424] = {
    [sym_concatenation] = STATE(2031),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2031),
    [anon_sym_RBRACE] = ACTIONS(4702),
    [anon_sym_EQ] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4718),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4722),
    [anon_sym_COLON] = ACTIONS(4718),
    [anon_sym_COLON_QMARK] = ACTIONS(4718),
    [anon_sym_COLON_DASH] = ACTIONS(4718),
    [anon_sym_PERCENT] = ACTIONS(4718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1425] = {
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1426] = {
    [sym_concatenation] = STATE(2034),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2034),
    [sym_regex] = ACTIONS(4724),
    [anon_sym_RBRACE] = ACTIONS(4726),
    [anon_sym_EQ] = ACTIONS(4728),
    [anon_sym_DASH] = ACTIONS(4728),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4728),
    [anon_sym_COLON_QMARK] = ACTIONS(4728),
    [anon_sym_COLON_DASH] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1427] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4726),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1428] = {
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1429] = {
    [sym_concatenation] = STATE(2031),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2031),
    [sym_regex] = ACTIONS(4732),
    [anon_sym_RBRACE] = ACTIONS(4702),
    [anon_sym_EQ] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4718),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4718),
    [anon_sym_COLON_QMARK] = ACTIONS(4718),
    [anon_sym_COLON_DASH] = ACTIONS(4718),
    [anon_sym_PERCENT] = ACTIONS(4718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1430] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4702),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1431] = {
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1432] = {
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1433] = {
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [1434] = {
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [1435] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(4734),
    [sym_comment] = ACTIONS(57),
  },
  [1436] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [sym_comment] = ACTIONS(57),
  },
  [1437] = {
    [anon_sym_RBRACE] = ACTIONS(4736),
    [sym_comment] = ACTIONS(57),
  },
  [1438] = {
    [sym_concatenation] = STATE(2040),
    [sym_string] = STATE(2039),
    [sym_simple_expansion] = STATE(2039),
    [sym_string_expansion] = STATE(2039),
    [sym_expansion] = STATE(2039),
    [sym_command_substitution] = STATE(2039),
    [sym_process_substitution] = STATE(2039),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [sym__special_characters] = ACTIONS(4738),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(4740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4740),
  },
  [1439] = {
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [1440] = {
    [sym_concatenation] = STATE(2043),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2043),
    [sym_regex] = ACTIONS(4742),
    [anon_sym_RBRACE] = ACTIONS(4744),
    [anon_sym_EQ] = ACTIONS(4746),
    [anon_sym_DASH] = ACTIONS(4746),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4748),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4746),
    [anon_sym_COLON_QMARK] = ACTIONS(4746),
    [anon_sym_COLON_DASH] = ACTIONS(4746),
    [anon_sym_PERCENT] = ACTIONS(4746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1441] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4744),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1442] = {
    [sym_concatenation] = STATE(2045),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2045),
    [sym_regex] = ACTIONS(4750),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [anon_sym_EQ] = ACTIONS(4752),
    [anon_sym_DASH] = ACTIONS(4752),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4752),
    [anon_sym_COLON_QMARK] = ACTIONS(4752),
    [anon_sym_COLON_DASH] = ACTIONS(4752),
    [anon_sym_PERCENT] = ACTIONS(4752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1443] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1444] = {
    [sym_concatenation] = STATE(2047),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2047),
    [anon_sym_RBRACE] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(4758),
    [anon_sym_DASH] = ACTIONS(4758),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4758),
    [anon_sym_COLON_QMARK] = ACTIONS(4758),
    [anon_sym_COLON_DASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1445] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1446] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(4756),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1447] = {
    [sym_concatenation] = STATE(2045),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2045),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [anon_sym_EQ] = ACTIONS(4752),
    [anon_sym_DASH] = ACTIONS(4752),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(4752),
    [anon_sym_COLON_QMARK] = ACTIONS(4752),
    [anon_sym_COLON_DASH] = ACTIONS(4752),
    [anon_sym_PERCENT] = ACTIONS(4752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1448] = {
    [sym_file_descriptor] = ACTIONS(4231),
    [anon_sym_SEMI] = ACTIONS(4233),
    [anon_sym_PIPE] = ACTIONS(4233),
    [anon_sym_SEMI_SEMI] = ACTIONS(4231),
    [anon_sym_PIPE_AMP] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_GT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4231),
    [anon_sym_AMP_GT] = ACTIONS(4233),
    [anon_sym_AMP_GT_GT] = ACTIONS(4231),
    [anon_sym_LT_AMP] = ACTIONS(4231),
    [anon_sym_GT_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_LT_LT_DASH] = ACTIONS(4231),
    [anon_sym_LT_LT_LT] = ACTIONS(4231),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4231),
    [anon_sym_AMP] = ACTIONS(4233),
  },
  [1449] = {
    [sym_concatenation] = STATE(2048),
    [sym_string] = STATE(2053),
    [sym_array] = STATE(2048),
    [sym_simple_expansion] = STATE(2053),
    [sym_string_expansion] = STATE(2053),
    [sym_expansion] = STATE(2053),
    [sym_command_substitution] = STATE(2053),
    [sym_process_substitution] = STATE(2053),
    [sym__empty_value] = ACTIONS(4762),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [sym__special_characters] = ACTIONS(4766),
    [anon_sym_DQUOTE] = ACTIONS(4768),
    [anon_sym_DOLLAR] = ACTIONS(4770),
    [sym_raw_string] = ACTIONS(4772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4774),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4776),
    [anon_sym_BQUOTE] = ACTIONS(4778),
    [anon_sym_LT_LPAREN] = ACTIONS(4780),
    [anon_sym_GT_LPAREN] = ACTIONS(4780),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4772),
  },
  [1450] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(4782),
    [anon_sym_PLUS_EQ] = ACTIONS(4782),
    [sym_comment] = ACTIONS(57),
  },
  [1451] = {
    [aux_sym_concatenation_repeat1] = STATE(2060),
    [sym__simple_heredoc_body] = ACTIONS(939),
    [sym__heredoc_body_beginning] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(4784),
    [sym_variable_name] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_done] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [1452] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2063),
    [anon_sym_DQUOTE] = ACTIONS(4786),
    [anon_sym_DOLLAR] = ACTIONS(4788),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1453] = {
    [sym_string] = STATE(2065),
    [anon_sym_DASH] = ACTIONS(4790),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(4790),
    [sym_raw_string] = ACTIONS(4792),
    [anon_sym_POUND] = ACTIONS(4790),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4794),
    [anon_sym_STAR] = ACTIONS(4796),
    [anon_sym_AT] = ACTIONS(4796),
    [anon_sym_QMARK] = ACTIONS(4796),
    [anon_sym_0] = ACTIONS(4794),
    [anon_sym__] = ACTIONS(4794),
  },
  [1454] = {
    [aux_sym_concatenation_repeat1] = STATE(2060),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(4784),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_done] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [1455] = {
    [sym_subscript] = STATE(2070),
    [sym_variable_name] = ACTIONS(4798),
    [anon_sym_BANG] = ACTIONS(4800),
    [anon_sym_DASH] = ACTIONS(4802),
    [anon_sym_DOLLAR] = ACTIONS(4802),
    [anon_sym_POUND] = ACTIONS(4800),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4806),
    [anon_sym_AT] = ACTIONS(4806),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_0] = ACTIONS(4804),
    [anon_sym__] = ACTIONS(4804),
  },
  [1456] = {
    [sym__statements] = STATE(2071),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2072),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1457] = {
    [sym__statements] = STATE(2073),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1458] = {
    [sym__statements] = STATE(2074),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1459] = {
    [anon_sym_EQ] = ACTIONS(4782),
    [anon_sym_PLUS_EQ] = ACTIONS(4782),
    [sym_comment] = ACTIONS(57),
  },
  [1460] = {
    [sym_variable_assignment] = STATE(2075),
    [sym_subscript] = STATE(1459),
    [sym_concatenation] = STATE(2075),
    [sym_string] = STATE(1454),
    [sym_simple_expansion] = STATE(1454),
    [sym_string_expansion] = STATE(1454),
    [sym_expansion] = STATE(1454),
    [sym_command_substitution] = STATE(1454),
    [sym_process_substitution] = STATE(1454),
    [aux_sym_declaration_command_repeat1] = STATE(2075),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(3143),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_done] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(3145),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(3149),
    [sym_raw_string] = ACTIONS(3151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3155),
    [anon_sym_BQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LPAREN] = ACTIONS(3159),
    [anon_sym_GT_LPAREN] = ACTIONS(3159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4808),
    [sym_word] = ACTIONS(3163),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1461] = {
    [aux_sym_concatenation_repeat1] = STATE(2077),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(4810),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_done] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [1462] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2080),
    [anon_sym_DQUOTE] = ACTIONS(4812),
    [anon_sym_DOLLAR] = ACTIONS(4814),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1463] = {
    [sym_string] = STATE(2082),
    [anon_sym_DASH] = ACTIONS(4816),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_DOLLAR] = ACTIONS(4816),
    [sym_raw_string] = ACTIONS(4818),
    [anon_sym_POUND] = ACTIONS(4816),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4820),
    [anon_sym_STAR] = ACTIONS(4822),
    [anon_sym_AT] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4822),
    [anon_sym_0] = ACTIONS(4820),
    [anon_sym__] = ACTIONS(4820),
  },
  [1464] = {
    [aux_sym_concatenation_repeat1] = STATE(2077),
    [sym__simple_heredoc_body] = ACTIONS(995),
    [sym__heredoc_body_beginning] = ACTIONS(995),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(4810),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_done] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [1465] = {
    [sym_subscript] = STATE(2087),
    [sym_variable_name] = ACTIONS(4824),
    [anon_sym_BANG] = ACTIONS(4826),
    [anon_sym_DASH] = ACTIONS(4828),
    [anon_sym_DOLLAR] = ACTIONS(4828),
    [anon_sym_POUND] = ACTIONS(4826),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4832),
    [anon_sym_AT] = ACTIONS(4832),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_0] = ACTIONS(4830),
    [anon_sym__] = ACTIONS(4830),
  },
  [1466] = {
    [sym__statements] = STATE(2088),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2089),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1467] = {
    [sym__statements] = STATE(2090),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1468] = {
    [sym__statements] = STATE(2091),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1469] = {
    [sym_concatenation] = STATE(2092),
    [sym_string] = STATE(1464),
    [sym_simple_expansion] = STATE(1464),
    [sym_string_expansion] = STATE(1464),
    [sym_expansion] = STATE(1464),
    [sym_command_substitution] = STATE(1464),
    [sym_process_substitution] = STATE(1464),
    [aux_sym_unset_command_repeat1] = STATE(2092),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_done] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_DOLLAR] = ACTIONS(3169),
    [sym_raw_string] = ACTIONS(3171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3175),
    [anon_sym_BQUOTE] = ACTIONS(3177),
    [anon_sym_LT_LPAREN] = ACTIONS(3179),
    [anon_sym_GT_LPAREN] = ACTIONS(3179),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4834),
    [sym_word] = ACTIONS(3183),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [1470] = {
    [sym_string] = STATE(2093),
    [sym_simple_expansion] = STATE(2093),
    [sym_string_expansion] = STATE(2093),
    [sym_expansion] = STATE(2093),
    [sym_command_substitution] = STATE(2093),
    [sym_process_substitution] = STATE(2093),
    [sym__special_characters] = ACTIONS(4836),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(4836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4836),
  },
  [1471] = {
    [aux_sym_concatenation_repeat1] = STATE(2094),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_done] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1472] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_done] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1055),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1473] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(4838),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1474] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(4838),
    [anon_sym_DOLLAR] = ACTIONS(4840),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1475] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_done] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [1476] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_done] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [1477] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_done] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [1478] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(4842),
    [sym_comment] = ACTIONS(57),
  },
  [1479] = {
    [sym_subscript] = STATE(2100),
    [sym_variable_name] = ACTIONS(4844),
    [anon_sym_DASH] = ACTIONS(4846),
    [anon_sym_DOLLAR] = ACTIONS(4846),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4848),
    [anon_sym_STAR] = ACTIONS(4850),
    [anon_sym_AT] = ACTIONS(4850),
    [anon_sym_QMARK] = ACTIONS(4850),
    [anon_sym_0] = ACTIONS(4848),
    [anon_sym__] = ACTIONS(4848),
  },
  [1480] = {
    [sym_concatenation] = STATE(2103),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2103),
    [anon_sym_RBRACE] = ACTIONS(4852),
    [anon_sym_EQ] = ACTIONS(4854),
    [anon_sym_DASH] = ACTIONS(4854),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4858),
    [anon_sym_COLON] = ACTIONS(4854),
    [anon_sym_COLON_QMARK] = ACTIONS(4854),
    [anon_sym_COLON_DASH] = ACTIONS(4854),
    [anon_sym_PERCENT] = ACTIONS(4854),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1481] = {
    [sym_concatenation] = STATE(2106),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2106),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_EQ] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4862),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(4864),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(4866),
    [anon_sym_COLON] = ACTIONS(4862),
    [anon_sym_COLON_QMARK] = ACTIONS(4862),
    [anon_sym_COLON_DASH] = ACTIONS(4862),
    [anon_sym_PERCENT] = ACTIONS(4862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1482] = {
    [anon_sym_RPAREN] = ACTIONS(4868),
    [sym_comment] = ACTIONS(57),
  },
  [1483] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4868),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1484] = {
    [anon_sym_BQUOTE] = ACTIONS(4868),
    [sym_comment] = ACTIONS(57),
  },
  [1485] = {
    [anon_sym_RPAREN] = ACTIONS(4870),
    [sym_comment] = ACTIONS(57),
  },
  [1486] = {
    [sym__simple_heredoc_body] = ACTIONS(4872),
    [sym__heredoc_body_beginning] = ACTIONS(4872),
    [sym_file_descriptor] = ACTIONS(4872),
    [ts_builtin_sym_end] = ACTIONS(4872),
    [anon_sym_SEMI] = ACTIONS(4874),
    [anon_sym_done] = ACTIONS(4872),
    [anon_sym_fi] = ACTIONS(4872),
    [anon_sym_elif] = ACTIONS(4872),
    [anon_sym_else] = ACTIONS(4872),
    [anon_sym_esac] = ACTIONS(4872),
    [anon_sym_PIPE] = ACTIONS(4874),
    [anon_sym_RPAREN] = ACTIONS(4872),
    [anon_sym_SEMI_SEMI] = ACTIONS(4872),
    [anon_sym_PIPE_AMP] = ACTIONS(4872),
    [anon_sym_AMP_AMP] = ACTIONS(4872),
    [anon_sym_PIPE_PIPE] = ACTIONS(4872),
    [anon_sym_LT] = ACTIONS(4874),
    [anon_sym_GT] = ACTIONS(4874),
    [anon_sym_GT_GT] = ACTIONS(4872),
    [anon_sym_AMP_GT] = ACTIONS(4874),
    [anon_sym_AMP_GT_GT] = ACTIONS(4872),
    [anon_sym_LT_AMP] = ACTIONS(4872),
    [anon_sym_GT_AMP] = ACTIONS(4872),
    [anon_sym_LT_LT] = ACTIONS(4874),
    [anon_sym_LT_LT_DASH] = ACTIONS(4872),
    [anon_sym_LT_LT_LT] = ACTIONS(4872),
    [anon_sym_BQUOTE] = ACTIONS(4872),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4872),
    [anon_sym_AMP] = ACTIONS(4874),
  },
  [1487] = {
    [anon_sym_LT] = ACTIONS(4876),
    [anon_sym_GT] = ACTIONS(4876),
    [anon_sym_GT_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT] = ACTIONS(4876),
    [anon_sym_AMP_GT_GT] = ACTIONS(4878),
    [anon_sym_LT_AMP] = ACTIONS(4878),
    [anon_sym_GT_AMP] = ACTIONS(4878),
    [sym_comment] = ACTIONS(57),
  },
  [1488] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_done] = ACTIONS(4880),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [1489] = {
    [sym_redirected_statement] = STATE(2110),
    [sym_for_statement] = STATE(2110),
    [sym_c_style_for_statement] = STATE(2110),
    [sym_while_statement] = STATE(2110),
    [sym_if_statement] = STATE(2110),
    [sym_case_statement] = STATE(2110),
    [sym_function_definition] = STATE(2110),
    [sym_compound_statement] = STATE(2110),
    [sym_subshell] = STATE(2110),
    [sym_pipeline] = STATE(2110),
    [sym_list] = STATE(2110),
    [sym_negated_command] = STATE(2110),
    [sym_test_command] = STATE(2110),
    [sym_declaration_command] = STATE(2110),
    [sym_unset_command] = STATE(2110),
    [sym_command] = STATE(2110),
    [sym_command_name] = STATE(868),
    [sym_variable_assignment] = STATE(2111),
    [sym_subscript] = STATE(870),
    [sym_file_redirect] = STATE(873),
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(860),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [sym_process_substitution] = STATE(860),
    [aux_sym_command_repeat1] = STATE(873),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1719),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_typeset] = ACTIONS(1725),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_readonly] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym_unset] = ACTIONS(1727),
    [anon_sym_unsetenv] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1745),
  },
  [1490] = {
    [sym_redirected_statement] = STATE(2112),
    [sym_for_statement] = STATE(2112),
    [sym_c_style_for_statement] = STATE(2112),
    [sym_while_statement] = STATE(2112),
    [sym_if_statement] = STATE(2112),
    [sym_case_statement] = STATE(2112),
    [sym_function_definition] = STATE(2112),
    [sym_compound_statement] = STATE(2112),
    [sym_subshell] = STATE(2112),
    [sym_pipeline] = STATE(2112),
    [sym_list] = STATE(2112),
    [sym_negated_command] = STATE(2112),
    [sym_test_command] = STATE(2112),
    [sym_declaration_command] = STATE(2112),
    [sym_unset_command] = STATE(2112),
    [sym_command] = STATE(2112),
    [sym_command_name] = STATE(868),
    [sym_variable_assignment] = STATE(2113),
    [sym_subscript] = STATE(870),
    [sym_file_redirect] = STATE(873),
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(860),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [sym_process_substitution] = STATE(860),
    [aux_sym_command_repeat1] = STATE(873),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1719),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_typeset] = ACTIONS(1725),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_readonly] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym_unset] = ACTIONS(1727),
    [anon_sym_unsetenv] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1745),
  },
  [1491] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(2117),
    [sym_simple_expansion] = STATE(2117),
    [sym_string_expansion] = STATE(2117),
    [sym_expansion] = STATE(2117),
    [sym_command_substitution] = STATE(2117),
    [sym_process_substitution] = STATE(2117),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4888),
  },
  [1492] = {
    [sym_concatenation] = STATE(651),
    [sym_string] = STATE(2123),
    [sym_simple_expansion] = STATE(2123),
    [sym_string_expansion] = STATE(2123),
    [sym_expansion] = STATE(2123),
    [sym_command_substitution] = STATE(2123),
    [sym_process_substitution] = STATE(2123),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4900),
  },
  [1493] = {
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_done] = ACTIONS(1229),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [1494] = {
    [sym_file_redirect] = STATE(2125),
    [sym_heredoc_redirect] = STATE(2125),
    [sym_herestring_redirect] = STATE(2125),
    [aux_sym_redirected_statement_repeat1] = STATE(2125),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_done] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3225),
    [anon_sym_AMP_GT] = ACTIONS(3223),
    [anon_sym_AMP_GT_GT] = ACTIONS(3225),
    [anon_sym_LT_AMP] = ACTIONS(3225),
    [anon_sym_GT_AMP] = ACTIONS(3225),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3227),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [1495] = {
    [sym_concatenation] = STATE(2126),
    [sym_string] = STATE(2128),
    [sym_simple_expansion] = STATE(2128),
    [sym_string_expansion] = STATE(2128),
    [sym_expansion] = STATE(2128),
    [sym_command_substitution] = STATE(2128),
    [sym_process_substitution] = STATE(2128),
    [sym_regex] = ACTIONS(4906),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4910),
  },
  [1496] = {
    [aux_sym_concatenation_repeat1] = STATE(1471),
    [sym__simple_heredoc_body] = ACTIONS(1257),
    [sym__heredoc_body_beginning] = ACTIONS(1257),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_done] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [1497] = {
    [aux_sym_concatenation_repeat1] = STATE(1471),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_done] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1498] = {
    [sym_concatenation] = STATE(2129),
    [sym_string] = STATE(1497),
    [sym_simple_expansion] = STATE(1497),
    [sym_string_expansion] = STATE(1497),
    [sym_expansion] = STATE(1497),
    [sym_command_substitution] = STATE(1497),
    [sym_process_substitution] = STATE(1497),
    [aux_sym_command_repeat2] = STATE(2129),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_done] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(3229),
    [anon_sym_EQ_EQ] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(3233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3235),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1499] = {
    [sym_file_redirect] = STATE(1494),
    [sym_heredoc_redirect] = STATE(1494),
    [sym_heredoc_body] = STATE(2131),
    [sym_herestring_redirect] = STATE(1494),
    [aux_sym_redirected_statement_repeat1] = STATE(1494),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_done] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(3215),
    [anon_sym_SEMI_SEMI] = ACTIONS(4914),
    [anon_sym_PIPE_AMP] = ACTIONS(3219),
    [anon_sym_AMP_AMP] = ACTIONS(3221),
    [anon_sym_PIPE_PIPE] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3225),
    [anon_sym_AMP_GT] = ACTIONS(3223),
    [anon_sym_AMP_GT_GT] = ACTIONS(3225),
    [anon_sym_LT_AMP] = ACTIONS(3225),
    [anon_sym_GT_AMP] = ACTIONS(3225),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3227),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [1500] = {
    [sym_file_redirect] = STATE(1494),
    [sym_heredoc_redirect] = STATE(1494),
    [sym_heredoc_body] = STATE(2131),
    [sym_herestring_redirect] = STATE(1494),
    [aux_sym_redirected_statement_repeat1] = STATE(1494),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_done] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(3215),
    [anon_sym_SEMI_SEMI] = ACTIONS(4914),
    [anon_sym_PIPE_AMP] = ACTIONS(3219),
    [anon_sym_AMP_AMP] = ACTIONS(3221),
    [anon_sym_PIPE_PIPE] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3227),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [1501] = {
    [sym_concatenation] = STATE(2132),
    [sym_string] = STATE(1497),
    [sym_simple_expansion] = STATE(1497),
    [sym_string_expansion] = STATE(1497),
    [sym_expansion] = STATE(1497),
    [sym_command_substitution] = STATE(1497),
    [sym_process_substitution] = STATE(1497),
    [aux_sym_command_repeat2] = STATE(2132),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_done] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(3229),
    [anon_sym_EQ_EQ] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(3233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3235),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1502] = {
    [aux_sym_concatenation_repeat1] = STATE(1505),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [1503] = {
    [aux_sym_concatenation_repeat1] = STATE(1505),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1504] = {
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1505] = {
    [aux_sym_concatenation_repeat1] = STATE(2133),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1506] = {
    [sym_concatenation] = STATE(2134),
    [sym_string] = STATE(2139),
    [sym_array] = STATE(2134),
    [sym_simple_expansion] = STATE(2139),
    [sym_string_expansion] = STATE(2139),
    [sym_expansion] = STATE(2139),
    [sym_command_substitution] = STATE(2139),
    [sym_process_substitution] = STATE(2139),
    [sym__empty_value] = ACTIONS(4916),
    [anon_sym_LPAREN] = ACTIONS(4918),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4922),
    [anon_sym_DOLLAR] = ACTIONS(4924),
    [sym_raw_string] = ACTIONS(4926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4930),
    [anon_sym_BQUOTE] = ACTIONS(4932),
    [anon_sym_LT_LPAREN] = ACTIONS(4934),
    [anon_sym_GT_LPAREN] = ACTIONS(4934),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4926),
  },
  [1507] = {
    [anon_sym_then] = ACTIONS(4936),
    [sym_comment] = ACTIONS(57),
  },
  [1508] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(4938),
    [anon_sym_PLUS_EQ] = ACTIONS(4938),
    [sym_comment] = ACTIONS(57),
  },
  [1509] = {
    [sym_subshell] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_command_name] = STATE(1523),
    [sym_variable_assignment] = STATE(1528),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(1528),
    [sym_concatenation] = STATE(1526),
    [sym_string] = STATE(1515),
    [sym_simple_expansion] = STATE(1515),
    [sym_string_expansion] = STATE(1515),
    [sym_expansion] = STATE(1515),
    [sym_command_substitution] = STATE(1515),
    [sym_process_substitution] = STATE(1515),
    [aux_sym_command_repeat1] = STATE(1528),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(3315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3315),
  },
  [1510] = {
    [sym_variable_assignment] = STATE(2156),
    [sym_subscript] = STATE(2155),
    [sym_concatenation] = STATE(2156),
    [sym_string] = STATE(2150),
    [sym_simple_expansion] = STATE(2150),
    [sym_string_expansion] = STATE(2150),
    [sym_expansion] = STATE(2150),
    [sym_command_substitution] = STATE(2150),
    [sym_process_substitution] = STATE(2150),
    [aux_sym_declaration_command_repeat1] = STATE(2156),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(4940),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_fi] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(4942),
    [anon_sym_DQUOTE] = ACTIONS(4944),
    [anon_sym_DOLLAR] = ACTIONS(4946),
    [sym_raw_string] = ACTIONS(4948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4952),
    [anon_sym_BQUOTE] = ACTIONS(4954),
    [anon_sym_LT_LPAREN] = ACTIONS(4956),
    [anon_sym_GT_LPAREN] = ACTIONS(4956),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4958),
    [sym_word] = ACTIONS(4960),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [1511] = {
    [sym_concatenation] = STATE(2165),
    [sym_string] = STATE(2160),
    [sym_simple_expansion] = STATE(2160),
    [sym_string_expansion] = STATE(2160),
    [sym_expansion] = STATE(2160),
    [sym_command_substitution] = STATE(2160),
    [sym_process_substitution] = STATE(2160),
    [aux_sym_unset_command_repeat1] = STATE(2165),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_fi] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4964),
    [anon_sym_DOLLAR] = ACTIONS(4966),
    [sym_raw_string] = ACTIONS(4968),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4970),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4972),
    [anon_sym_BQUOTE] = ACTIONS(4974),
    [anon_sym_LT_LPAREN] = ACTIONS(4976),
    [anon_sym_GT_LPAREN] = ACTIONS(4976),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4978),
    [sym_word] = ACTIONS(4980),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [1512] = {
    [aux_sym_concatenation_repeat1] = STATE(2167),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1513] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2170),
    [anon_sym_DQUOTE] = ACTIONS(4984),
    [anon_sym_DOLLAR] = ACTIONS(4986),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1514] = {
    [sym_string] = STATE(2172),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(4988),
    [sym_raw_string] = ACTIONS(4990),
    [anon_sym_POUND] = ACTIONS(4988),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4994),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_0] = ACTIONS(4992),
    [anon_sym__] = ACTIONS(4992),
  },
  [1515] = {
    [aux_sym_concatenation_repeat1] = STATE(2167),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1516] = {
    [sym_subscript] = STATE(2177),
    [sym_variable_name] = ACTIONS(4996),
    [anon_sym_BANG] = ACTIONS(4998),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_DOLLAR] = ACTIONS(5000),
    [anon_sym_POUND] = ACTIONS(4998),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5002),
    [anon_sym_STAR] = ACTIONS(5004),
    [anon_sym_AT] = ACTIONS(5004),
    [anon_sym_QMARK] = ACTIONS(5004),
    [anon_sym_0] = ACTIONS(5002),
    [anon_sym__] = ACTIONS(5002),
  },
  [1517] = {
    [sym__statements] = STATE(2178),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2179),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1518] = {
    [sym__statements] = STATE(2180),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1519] = {
    [sym__statements] = STATE(2181),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1520] = {
    [aux_sym_concatenation_repeat1] = STATE(2167),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1521] = {
    [anon_sym_fi] = ACTIONS(5006),
    [sym_comment] = ACTIONS(57),
  },
  [1522] = {
    [sym_file_redirect] = STATE(2189),
    [sym_heredoc_redirect] = STATE(2189),
    [sym_heredoc_body] = STATE(2188),
    [sym_herestring_redirect] = STATE(2189),
    [aux_sym_redirected_statement_repeat1] = STATE(2189),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(5008),
    [anon_sym_SEMI] = ACTIONS(5010),
    [anon_sym_fi] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(5012),
    [anon_sym_SEMI_SEMI] = ACTIONS(5014),
    [anon_sym_PIPE_AMP] = ACTIONS(5016),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(5020),
    [anon_sym_GT] = ACTIONS(5020),
    [anon_sym_GT_GT] = ACTIONS(5022),
    [anon_sym_AMP_GT] = ACTIONS(5020),
    [anon_sym_AMP_GT_GT] = ACTIONS(5022),
    [anon_sym_LT_AMP] = ACTIONS(5022),
    [anon_sym_GT_AMP] = ACTIONS(5022),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5014),
    [anon_sym_AMP] = ACTIONS(5010),
  },
  [1523] = {
    [sym_concatenation] = STATE(2193),
    [sym_string] = STATE(2192),
    [sym_simple_expansion] = STATE(2192),
    [sym_string_expansion] = STATE(2192),
    [sym_expansion] = STATE(2192),
    [sym_command_substitution] = STATE(2192),
    [sym_process_substitution] = STATE(2192),
    [aux_sym_command_repeat2] = STATE(2193),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_fi] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(5026),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(5028),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(5030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5032),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [1524] = {
    [sym_file_redirect] = STATE(2189),
    [sym_heredoc_redirect] = STATE(2189),
    [sym_heredoc_body] = STATE(2188),
    [sym_herestring_redirect] = STATE(2189),
    [aux_sym_redirected_statement_repeat1] = STATE(2189),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(5010),
    [anon_sym_fi] = ACTIONS(3237),
    [anon_sym_PIPE] = ACTIONS(5012),
    [anon_sym_SEMI_SEMI] = ACTIONS(5014),
    [anon_sym_PIPE_AMP] = ACTIONS(5016),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5024),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(5014),
    [anon_sym_AMP] = ACTIONS(5010),
  },
  [1525] = {
    [anon_sym_EQ] = ACTIONS(4938),
    [anon_sym_PLUS_EQ] = ACTIONS(4938),
    [sym_comment] = ACTIONS(57),
  },
  [1526] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1527] = {
    [sym_redirected_statement] = STATE(2194),
    [sym_for_statement] = STATE(2194),
    [sym_c_style_for_statement] = STATE(2194),
    [sym_while_statement] = STATE(2194),
    [sym_if_statement] = STATE(2194),
    [sym_case_statement] = STATE(2194),
    [sym_function_definition] = STATE(2194),
    [sym_compound_statement] = STATE(2194),
    [sym_subshell] = STATE(2194),
    [sym_pipeline] = STATE(2194),
    [sym_list] = STATE(2194),
    [sym_negated_command] = STATE(2194),
    [sym_test_command] = STATE(2194),
    [sym_declaration_command] = STATE(2194),
    [sym_unset_command] = STATE(2194),
    [sym_command] = STATE(2194),
    [sym_command_name] = STATE(1523),
    [sym_variable_assignment] = STATE(2195),
    [sym_subscript] = STATE(1525),
    [sym_file_redirect] = STATE(1528),
    [sym_concatenation] = STATE(1526),
    [sym_string] = STATE(1515),
    [sym_simple_expansion] = STATE(1515),
    [sym_string_expansion] = STATE(1515),
    [sym_expansion] = STATE(1515),
    [sym_command_substitution] = STATE(1515),
    [sym_process_substitution] = STATE(1515),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(1528),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_typeset] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_local] = ACTIONS(3305),
    [anon_sym_unset] = ACTIONS(3307),
    [anon_sym_unsetenv] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(3315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3325),
  },
  [1528] = {
    [sym_command_name] = STATE(2196),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(1526),
    [sym_string] = STATE(1515),
    [sym_simple_expansion] = STATE(1515),
    [sym_string_expansion] = STATE(1515),
    [sym_expansion] = STATE(1515),
    [sym_command_substitution] = STATE(1515),
    [sym_process_substitution] = STATE(1515),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(5034),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(3315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3315),
  },
  [1529] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(5036),
    [anon_sym_PLUS_EQ] = ACTIONS(5036),
    [sym_comment] = ACTIONS(57),
  },
  [1530] = {
    [aux_sym_concatenation_repeat1] = STATE(2199),
    [sym__simple_heredoc_body] = ACTIONS(939),
    [sym__heredoc_body_beginning] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(5038),
    [sym_variable_name] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_fi] = ACTIONS(943),
    [anon_sym_elif] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [1531] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2202),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [anon_sym_DOLLAR] = ACTIONS(5042),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1532] = {
    [sym_string] = STATE(2204),
    [anon_sym_DASH] = ACTIONS(5044),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [sym_raw_string] = ACTIONS(5046),
    [anon_sym_POUND] = ACTIONS(5044),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5048),
    [anon_sym_STAR] = ACTIONS(5050),
    [anon_sym_AT] = ACTIONS(5050),
    [anon_sym_QMARK] = ACTIONS(5050),
    [anon_sym_0] = ACTIONS(5048),
    [anon_sym__] = ACTIONS(5048),
  },
  [1533] = {
    [aux_sym_concatenation_repeat1] = STATE(2199),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(5038),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_fi] = ACTIONS(959),
    [anon_sym_elif] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [1534] = {
    [sym_subscript] = STATE(2209),
    [sym_variable_name] = ACTIONS(5052),
    [anon_sym_BANG] = ACTIONS(5054),
    [anon_sym_DASH] = ACTIONS(5056),
    [anon_sym_DOLLAR] = ACTIONS(5056),
    [anon_sym_POUND] = ACTIONS(5054),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5058),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_AT] = ACTIONS(5060),
    [anon_sym_QMARK] = ACTIONS(5060),
    [anon_sym_0] = ACTIONS(5058),
    [anon_sym__] = ACTIONS(5058),
  },
  [1535] = {
    [sym__statements] = STATE(2210),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2211),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1536] = {
    [sym__statements] = STATE(2212),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1537] = {
    [sym__statements] = STATE(2213),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1538] = {
    [anon_sym_EQ] = ACTIONS(5036),
    [anon_sym_PLUS_EQ] = ACTIONS(5036),
    [sym_comment] = ACTIONS(57),
  },
  [1539] = {
    [sym_variable_assignment] = STATE(2214),
    [sym_subscript] = STATE(1538),
    [sym_concatenation] = STATE(2214),
    [sym_string] = STATE(1533),
    [sym_simple_expansion] = STATE(1533),
    [sym_string_expansion] = STATE(1533),
    [sym_expansion] = STATE(1533),
    [sym_command_substitution] = STATE(1533),
    [sym_process_substitution] = STATE(1533),
    [aux_sym_declaration_command_repeat1] = STATE(2214),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_fi] = ACTIONS(973),
    [anon_sym_elif] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [sym_raw_string] = ACTIONS(3335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3341),
    [anon_sym_LT_LPAREN] = ACTIONS(3343),
    [anon_sym_GT_LPAREN] = ACTIONS(3343),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5062),
    [sym_word] = ACTIONS(3347),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1540] = {
    [aux_sym_concatenation_repeat1] = STATE(2216),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_fi] = ACTIONS(981),
    [anon_sym_elif] = ACTIONS(981),
    [anon_sym_else] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [1541] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2219),
    [anon_sym_DQUOTE] = ACTIONS(5066),
    [anon_sym_DOLLAR] = ACTIONS(5068),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1542] = {
    [sym_string] = STATE(2221),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_DOLLAR] = ACTIONS(5070),
    [sym_raw_string] = ACTIONS(5072),
    [anon_sym_POUND] = ACTIONS(5070),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5074),
    [anon_sym_STAR] = ACTIONS(5076),
    [anon_sym_AT] = ACTIONS(5076),
    [anon_sym_QMARK] = ACTIONS(5076),
    [anon_sym_0] = ACTIONS(5074),
    [anon_sym__] = ACTIONS(5074),
  },
  [1543] = {
    [aux_sym_concatenation_repeat1] = STATE(2216),
    [sym__simple_heredoc_body] = ACTIONS(995),
    [sym__heredoc_body_beginning] = ACTIONS(995),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_fi] = ACTIONS(997),
    [anon_sym_elif] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [1544] = {
    [sym_subscript] = STATE(2226),
    [sym_variable_name] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_DASH] = ACTIONS(5082),
    [anon_sym_DOLLAR] = ACTIONS(5082),
    [anon_sym_POUND] = ACTIONS(5080),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5084),
    [anon_sym_STAR] = ACTIONS(5086),
    [anon_sym_AT] = ACTIONS(5086),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_0] = ACTIONS(5084),
    [anon_sym__] = ACTIONS(5084),
  },
  [1545] = {
    [sym__statements] = STATE(2227),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2228),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1546] = {
    [sym__statements] = STATE(2229),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1547] = {
    [sym__statements] = STATE(2230),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1548] = {
    [sym_concatenation] = STATE(2231),
    [sym_string] = STATE(1543),
    [sym_simple_expansion] = STATE(1543),
    [sym_string_expansion] = STATE(1543),
    [sym_expansion] = STATE(1543),
    [sym_command_substitution] = STATE(1543),
    [sym_process_substitution] = STATE(1543),
    [aux_sym_unset_command_repeat1] = STATE(2231),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_fi] = ACTIONS(1011),
    [anon_sym_elif] = ACTIONS(1011),
    [anon_sym_else] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_DOLLAR] = ACTIONS(3353),
    [sym_raw_string] = ACTIONS(3355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3357),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3359),
    [anon_sym_BQUOTE] = ACTIONS(3361),
    [anon_sym_LT_LPAREN] = ACTIONS(3363),
    [anon_sym_GT_LPAREN] = ACTIONS(3363),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5088),
    [sym_word] = ACTIONS(3367),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [1549] = {
    [sym_string] = STATE(2232),
    [sym_simple_expansion] = STATE(2232),
    [sym_string_expansion] = STATE(2232),
    [sym_expansion] = STATE(2232),
    [sym_command_substitution] = STATE(2232),
    [sym_process_substitution] = STATE(2232),
    [sym__special_characters] = ACTIONS(5090),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(5090),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5090),
  },
  [1550] = {
    [aux_sym_concatenation_repeat1] = STATE(2233),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_elif] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1551] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_fi] = ACTIONS(1055),
    [anon_sym_elif] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1055),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1552] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5092),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1553] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(5092),
    [anon_sym_DOLLAR] = ACTIONS(5094),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1554] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_elif] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [1555] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_elif] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [1556] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_elif] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [1557] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5096),
    [sym_comment] = ACTIONS(57),
  },
  [1558] = {
    [sym_subscript] = STATE(2239),
    [sym_variable_name] = ACTIONS(5098),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_DOLLAR] = ACTIONS(5100),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5104),
    [anon_sym_AT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(5104),
    [anon_sym_0] = ACTIONS(5102),
    [anon_sym__] = ACTIONS(5102),
  },
  [1559] = {
    [sym_concatenation] = STATE(2242),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2242),
    [anon_sym_RBRACE] = ACTIONS(5106),
    [anon_sym_EQ] = ACTIONS(5108),
    [anon_sym_DASH] = ACTIONS(5108),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_COLON] = ACTIONS(5108),
    [anon_sym_COLON_QMARK] = ACTIONS(5108),
    [anon_sym_COLON_DASH] = ACTIONS(5108),
    [anon_sym_PERCENT] = ACTIONS(5108),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1560] = {
    [sym_concatenation] = STATE(2245),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2245),
    [anon_sym_RBRACE] = ACTIONS(5114),
    [anon_sym_EQ] = ACTIONS(5116),
    [anon_sym_DASH] = ACTIONS(5116),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5120),
    [anon_sym_COLON] = ACTIONS(5116),
    [anon_sym_COLON_QMARK] = ACTIONS(5116),
    [anon_sym_COLON_DASH] = ACTIONS(5116),
    [anon_sym_PERCENT] = ACTIONS(5116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1561] = {
    [anon_sym_RPAREN] = ACTIONS(5122),
    [sym_comment] = ACTIONS(57),
  },
  [1562] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5122),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1563] = {
    [anon_sym_BQUOTE] = ACTIONS(5122),
    [sym_comment] = ACTIONS(57),
  },
  [1564] = {
    [anon_sym_RPAREN] = ACTIONS(5124),
    [sym_comment] = ACTIONS(57),
  },
  [1565] = {
    [sym__simple_heredoc_body] = ACTIONS(5126),
    [sym__heredoc_body_beginning] = ACTIONS(5126),
    [sym_file_descriptor] = ACTIONS(5126),
    [ts_builtin_sym_end] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5128),
    [anon_sym_done] = ACTIONS(5126),
    [anon_sym_fi] = ACTIONS(5126),
    [anon_sym_elif] = ACTIONS(5126),
    [anon_sym_else] = ACTIONS(5126),
    [anon_sym_esac] = ACTIONS(5126),
    [anon_sym_PIPE] = ACTIONS(5128),
    [anon_sym_RPAREN] = ACTIONS(5126),
    [anon_sym_SEMI_SEMI] = ACTIONS(5126),
    [anon_sym_PIPE_AMP] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_LT] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5126),
    [anon_sym_AMP_GT] = ACTIONS(5128),
    [anon_sym_AMP_GT_GT] = ACTIONS(5126),
    [anon_sym_LT_AMP] = ACTIONS(5126),
    [anon_sym_GT_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_LT_LT_DASH] = ACTIONS(5126),
    [anon_sym_LT_LT_LT] = ACTIONS(5126),
    [anon_sym_BQUOTE] = ACTIONS(5126),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5126),
    [anon_sym_AMP] = ACTIONS(5128),
  },
  [1566] = {
    [anon_sym_fi] = ACTIONS(5130),
    [sym_comment] = ACTIONS(57),
  },
  [1567] = {
    [sym_elif_clause] = STATE(1582),
    [sym_else_clause] = STATE(2249),
    [aux_sym_if_statement_repeat1] = STATE(1582),
    [anon_sym_fi] = ACTIONS(5130),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [1568] = {
    [anon_sym_LT] = ACTIONS(5132),
    [anon_sym_GT] = ACTIONS(5132),
    [anon_sym_GT_GT] = ACTIONS(5134),
    [anon_sym_AMP_GT] = ACTIONS(5132),
    [anon_sym_AMP_GT_GT] = ACTIONS(5134),
    [anon_sym_LT_AMP] = ACTIONS(5134),
    [anon_sym_GT_AMP] = ACTIONS(5134),
    [sym_comment] = ACTIONS(57),
  },
  [1569] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_fi] = ACTIONS(4880),
    [anon_sym_elif] = ACTIONS(4880),
    [anon_sym_else] = ACTIONS(4880),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [1570] = {
    [sym_redirected_statement] = STATE(2251),
    [sym_for_statement] = STATE(2251),
    [sym_c_style_for_statement] = STATE(2251),
    [sym_while_statement] = STATE(2251),
    [sym_if_statement] = STATE(2251),
    [sym_case_statement] = STATE(2251),
    [sym_function_definition] = STATE(2251),
    [sym_compound_statement] = STATE(2251),
    [sym_subshell] = STATE(2251),
    [sym_pipeline] = STATE(2251),
    [sym_list] = STATE(2251),
    [sym_negated_command] = STATE(2251),
    [sym_test_command] = STATE(2251),
    [sym_declaration_command] = STATE(2251),
    [sym_unset_command] = STATE(2251),
    [sym_command] = STATE(2251),
    [sym_command_name] = STATE(911),
    [sym_variable_assignment] = STATE(2252),
    [sym_subscript] = STATE(913),
    [sym_file_redirect] = STATE(917),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym_command_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1783),
    [anon_sym_typeset] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_readonly] = ACTIONS(1783),
    [anon_sym_local] = ACTIONS(1783),
    [anon_sym_unset] = ACTIONS(1785),
    [anon_sym_unsetenv] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1803),
  },
  [1571] = {
    [sym_redirected_statement] = STATE(2253),
    [sym_for_statement] = STATE(2253),
    [sym_c_style_for_statement] = STATE(2253),
    [sym_while_statement] = STATE(2253),
    [sym_if_statement] = STATE(2253),
    [sym_case_statement] = STATE(2253),
    [sym_function_definition] = STATE(2253),
    [sym_compound_statement] = STATE(2253),
    [sym_subshell] = STATE(2253),
    [sym_pipeline] = STATE(2253),
    [sym_list] = STATE(2253),
    [sym_negated_command] = STATE(2253),
    [sym_test_command] = STATE(2253),
    [sym_declaration_command] = STATE(2253),
    [sym_unset_command] = STATE(2253),
    [sym_command] = STATE(2253),
    [sym_command_name] = STATE(911),
    [sym_variable_assignment] = STATE(2254),
    [sym_subscript] = STATE(913),
    [sym_file_redirect] = STATE(917),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym_command_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1783),
    [anon_sym_typeset] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_readonly] = ACTIONS(1783),
    [anon_sym_local] = ACTIONS(1783),
    [anon_sym_unset] = ACTIONS(1785),
    [anon_sym_unsetenv] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1803),
  },
  [1572] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(2256),
    [sym_simple_expansion] = STATE(2256),
    [sym_string_expansion] = STATE(2256),
    [sym_expansion] = STATE(2256),
    [sym_command_substitution] = STATE(2256),
    [sym_process_substitution] = STATE(2256),
    [sym__special_characters] = ACTIONS(5136),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(5138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5138),
  },
  [1573] = {
    [sym_concatenation] = STATE(651),
    [sym_string] = STATE(2258),
    [sym_simple_expansion] = STATE(2258),
    [sym_string_expansion] = STATE(2258),
    [sym_expansion] = STATE(2258),
    [sym_command_substitution] = STATE(2258),
    [sym_process_substitution] = STATE(2258),
    [sym__special_characters] = ACTIONS(5140),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(5142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5142),
  },
  [1574] = {
    [anon_sym_SEMI] = ACTIONS(5144),
    [anon_sym_fi] = ACTIONS(1229),
    [anon_sym_elif] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1229),
    [anon_sym_SEMI_SEMI] = ACTIONS(5146),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5146),
  },
  [1575] = {
    [sym_file_redirect] = STATE(2260),
    [sym_heredoc_redirect] = STATE(2260),
    [sym_herestring_redirect] = STATE(2260),
    [aux_sym_redirected_statement_repeat1] = STATE(2260),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_fi] = ACTIONS(1247),
    [anon_sym_elif] = ACTIONS(1247),
    [anon_sym_else] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(3411),
    [anon_sym_GT] = ACTIONS(3411),
    [anon_sym_GT_GT] = ACTIONS(3413),
    [anon_sym_AMP_GT] = ACTIONS(3411),
    [anon_sym_AMP_GT_GT] = ACTIONS(3413),
    [anon_sym_LT_AMP] = ACTIONS(3413),
    [anon_sym_GT_AMP] = ACTIONS(3413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3415),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [1576] = {
    [sym_concatenation] = STATE(2261),
    [sym_string] = STATE(2263),
    [sym_simple_expansion] = STATE(2263),
    [sym_string_expansion] = STATE(2263),
    [sym_expansion] = STATE(2263),
    [sym_command_substitution] = STATE(2263),
    [sym_process_substitution] = STATE(2263),
    [sym_regex] = ACTIONS(5148),
    [sym__special_characters] = ACTIONS(5150),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(5152),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5152),
  },
  [1577] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym__simple_heredoc_body] = ACTIONS(1257),
    [sym__heredoc_body_beginning] = ACTIONS(1257),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_fi] = ACTIONS(1259),
    [anon_sym_elif] = ACTIONS(1259),
    [anon_sym_else] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [1578] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_fi] = ACTIONS(1263),
    [anon_sym_elif] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1579] = {
    [sym_concatenation] = STATE(2264),
    [sym_string] = STATE(1578),
    [sym_simple_expansion] = STATE(1578),
    [sym_string_expansion] = STATE(1578),
    [sym_expansion] = STATE(1578),
    [sym_command_substitution] = STATE(1578),
    [sym_process_substitution] = STATE(1578),
    [aux_sym_command_repeat2] = STATE(2264),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_fi] = ACTIONS(1267),
    [anon_sym_elif] = ACTIONS(1267),
    [anon_sym_else] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(3417),
    [anon_sym_EQ_EQ] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1580] = {
    [sym_file_redirect] = STATE(1575),
    [sym_heredoc_redirect] = STATE(1575),
    [sym_heredoc_body] = STATE(2266),
    [sym_herestring_redirect] = STATE(1575),
    [aux_sym_redirected_statement_repeat1] = STATE(1575),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(5154),
    [anon_sym_fi] = ACTIONS(1229),
    [anon_sym_elif] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(3403),
    [anon_sym_SEMI_SEMI] = ACTIONS(5156),
    [anon_sym_PIPE_AMP] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_PIPE_PIPE] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(3411),
    [anon_sym_GT] = ACTIONS(3411),
    [anon_sym_GT_GT] = ACTIONS(3413),
    [anon_sym_AMP_GT] = ACTIONS(3411),
    [anon_sym_AMP_GT_GT] = ACTIONS(3413),
    [anon_sym_LT_AMP] = ACTIONS(3413),
    [anon_sym_GT_AMP] = ACTIONS(3413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3415),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5156),
    [anon_sym_AMP] = ACTIONS(5154),
  },
  [1581] = {
    [sym_file_redirect] = STATE(1575),
    [sym_heredoc_redirect] = STATE(1575),
    [sym_heredoc_body] = STATE(2266),
    [sym_herestring_redirect] = STATE(1575),
    [aux_sym_redirected_statement_repeat1] = STATE(1575),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(5154),
    [anon_sym_fi] = ACTIONS(4880),
    [anon_sym_elif] = ACTIONS(4880),
    [anon_sym_else] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(3403),
    [anon_sym_SEMI_SEMI] = ACTIONS(5156),
    [anon_sym_PIPE_AMP] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_PIPE_PIPE] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3415),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(5156),
    [anon_sym_AMP] = ACTIONS(5154),
  },
  [1582] = {
    [sym_elif_clause] = STATE(1582),
    [aux_sym_if_statement_repeat1] = STATE(1582),
    [anon_sym_fi] = ACTIONS(5158),
    [anon_sym_elif] = ACTIONS(5160),
    [anon_sym_else] = ACTIONS(5158),
    [sym_comment] = ACTIONS(57),
  },
  [1583] = {
    [sym_concatenation] = STATE(2267),
    [sym_string] = STATE(1578),
    [sym_simple_expansion] = STATE(1578),
    [sym_string_expansion] = STATE(1578),
    [sym_expansion] = STATE(1578),
    [sym_command_substitution] = STATE(1578),
    [sym_process_substitution] = STATE(1578),
    [aux_sym_command_repeat2] = STATE(2267),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_fi] = ACTIONS(1267),
    [anon_sym_elif] = ACTIONS(1267),
    [anon_sym_else] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(3417),
    [anon_sym_EQ_EQ] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1584] = {
    [sym__simple_heredoc_body] = ACTIONS(5163),
    [sym__heredoc_body_beginning] = ACTIONS(5163),
    [sym_file_descriptor] = ACTIONS(5163),
    [ts_builtin_sym_end] = ACTIONS(5163),
    [anon_sym_SEMI] = ACTIONS(5165),
    [anon_sym_done] = ACTIONS(5163),
    [anon_sym_fi] = ACTIONS(5163),
    [anon_sym_elif] = ACTIONS(5163),
    [anon_sym_else] = ACTIONS(5163),
    [anon_sym_esac] = ACTIONS(5163),
    [anon_sym_PIPE] = ACTIONS(5165),
    [anon_sym_RPAREN] = ACTIONS(5163),
    [anon_sym_SEMI_SEMI] = ACTIONS(5163),
    [anon_sym_PIPE_AMP] = ACTIONS(5163),
    [anon_sym_AMP_AMP] = ACTIONS(5163),
    [anon_sym_PIPE_PIPE] = ACTIONS(5163),
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_GT_GT] = ACTIONS(5163),
    [anon_sym_AMP_GT] = ACTIONS(5165),
    [anon_sym_AMP_GT_GT] = ACTIONS(5163),
    [anon_sym_LT_AMP] = ACTIONS(5163),
    [anon_sym_GT_AMP] = ACTIONS(5163),
    [anon_sym_LT_LT] = ACTIONS(5165),
    [anon_sym_LT_LT_DASH] = ACTIONS(5163),
    [anon_sym_LT_LT_LT] = ACTIONS(5163),
    [anon_sym_BQUOTE] = ACTIONS(5163),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5163),
    [anon_sym_AMP] = ACTIONS(5165),
  },
  [1585] = {
    [aux_sym_case_item_repeat1] = STATE(2270),
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5169),
    [sym_comment] = ACTIONS(57),
  },
  [1586] = {
    [aux_sym_case_item_repeat1] = STATE(2273),
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5171),
    [sym_comment] = ACTIONS(57),
  },
  [1587] = {
    [anon_sym_esac] = ACTIONS(5173),
    [sym_comment] = ACTIONS(57),
  },
  [1588] = {
    [aux_sym_case_item_repeat1] = STATE(2273),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5171),
    [sym_comment] = ACTIONS(57),
  },
  [1589] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(2275),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [1590] = {
    [sym_case_item] = STATE(2277),
    [sym_last_case_item] = STATE(2275),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2277),
    [anon_sym_esac] = ACTIONS(5175),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [1591] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_in] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4019),
  },
  [1592] = {
    [sym__simple_heredoc_body] = ACTIONS(5177),
    [sym__heredoc_body_beginning] = ACTIONS(5177),
    [sym_file_descriptor] = ACTIONS(5177),
    [ts_builtin_sym_end] = ACTIONS(5177),
    [anon_sym_SEMI] = ACTIONS(5179),
    [anon_sym_done] = ACTIONS(5177),
    [anon_sym_fi] = ACTIONS(5177),
    [anon_sym_elif] = ACTIONS(5177),
    [anon_sym_else] = ACTIONS(5177),
    [anon_sym_esac] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_RPAREN] = ACTIONS(5177),
    [anon_sym_SEMI_SEMI] = ACTIONS(5177),
    [anon_sym_PIPE_AMP] = ACTIONS(5177),
    [anon_sym_AMP_AMP] = ACTIONS(5177),
    [anon_sym_PIPE_PIPE] = ACTIONS(5177),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5177),
    [anon_sym_AMP_GT] = ACTIONS(5179),
    [anon_sym_AMP_GT_GT] = ACTIONS(5177),
    [anon_sym_LT_AMP] = ACTIONS(5177),
    [anon_sym_GT_AMP] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5177),
    [anon_sym_LT_LT_LT] = ACTIONS(5177),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5177),
    [anon_sym_AMP] = ACTIONS(5179),
  },
  [1593] = {
    [anon_sym_esac] = ACTIONS(5181),
    [sym_comment] = ACTIONS(57),
  },
  [1594] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(2279),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [1595] = {
    [sym_case_item] = STATE(2280),
    [sym_last_case_item] = STATE(2279),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2280),
    [anon_sym_esac] = ACTIONS(5183),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [1596] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_in] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4033),
  },
  [1597] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [sym_comment] = ACTIONS(57),
  },
  [1598] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [sym_comment] = ACTIONS(57),
  },
  [1599] = {
    [anon_sym_RBRACE] = ACTIONS(5187),
    [sym_comment] = ACTIONS(57),
  },
  [1600] = {
    [sym_concatenation] = STATE(2285),
    [sym_string] = STATE(2284),
    [sym_simple_expansion] = STATE(2284),
    [sym_string_expansion] = STATE(2284),
    [sym_expansion] = STATE(2284),
    [sym_command_substitution] = STATE(2284),
    [sym_process_substitution] = STATE(2284),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [sym__special_characters] = ACTIONS(5189),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5191),
  },
  [1601] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_in] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [1602] = {
    [sym_concatenation] = STATE(2288),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2288),
    [sym_regex] = ACTIONS(5193),
    [anon_sym_RBRACE] = ACTIONS(5195),
    [anon_sym_EQ] = ACTIONS(5197),
    [anon_sym_DASH] = ACTIONS(5197),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5197),
    [anon_sym_COLON_QMARK] = ACTIONS(5197),
    [anon_sym_COLON_DASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1603] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5195),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1604] = {
    [sym_concatenation] = STATE(2290),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2290),
    [sym_regex] = ACTIONS(5201),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_EQ] = ACTIONS(5203),
    [anon_sym_DASH] = ACTIONS(5203),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_COLON_QMARK] = ACTIONS(5203),
    [anon_sym_COLON_DASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5203),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1605] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1606] = {
    [sym_concatenation] = STATE(2292),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2292),
    [anon_sym_RBRACE] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5209),
    [anon_sym_DASH] = ACTIONS(5209),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5209),
    [anon_sym_COLON_QMARK] = ACTIONS(5209),
    [anon_sym_COLON_DASH] = ACTIONS(5209),
    [anon_sym_PERCENT] = ACTIONS(5209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1607] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_in] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4125),
  },
  [1608] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1609] = {
    [sym_concatenation] = STATE(2290),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2290),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_EQ] = ACTIONS(5203),
    [anon_sym_DASH] = ACTIONS(5203),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_COLON_QMARK] = ACTIONS(5203),
    [anon_sym_COLON_DASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5203),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1610] = {
    [sym__simple_heredoc_body] = ACTIONS(5213),
    [sym__heredoc_body_beginning] = ACTIONS(5213),
    [sym_file_descriptor] = ACTIONS(5213),
    [ts_builtin_sym_end] = ACTIONS(5213),
    [anon_sym_SEMI] = ACTIONS(5215),
    [anon_sym_done] = ACTIONS(5213),
    [anon_sym_fi] = ACTIONS(5213),
    [anon_sym_elif] = ACTIONS(5213),
    [anon_sym_else] = ACTIONS(5213),
    [anon_sym_esac] = ACTIONS(5213),
    [anon_sym_PIPE] = ACTIONS(5215),
    [anon_sym_RPAREN] = ACTIONS(5213),
    [anon_sym_SEMI_SEMI] = ACTIONS(5213),
    [anon_sym_PIPE_AMP] = ACTIONS(5213),
    [anon_sym_AMP_AMP] = ACTIONS(5213),
    [anon_sym_PIPE_PIPE] = ACTIONS(5213),
    [anon_sym_LT] = ACTIONS(5215),
    [anon_sym_GT] = ACTIONS(5215),
    [anon_sym_GT_GT] = ACTIONS(5213),
    [anon_sym_AMP_GT] = ACTIONS(5215),
    [anon_sym_AMP_GT_GT] = ACTIONS(5213),
    [anon_sym_LT_AMP] = ACTIONS(5213),
    [anon_sym_GT_AMP] = ACTIONS(5213),
    [anon_sym_LT_LT] = ACTIONS(5215),
    [anon_sym_LT_LT_DASH] = ACTIONS(5213),
    [anon_sym_LT_LT_LT] = ACTIONS(5213),
    [anon_sym_BQUOTE] = ACTIONS(5213),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5213),
    [anon_sym_AMP] = ACTIONS(5215),
  },
  [1611] = {
    [aux_sym_concatenation_repeat1] = STATE(2293),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1612] = {
    [aux_sym_concatenation_repeat1] = STATE(942),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [1613] = {
    [aux_sym_concatenation_repeat1] = STATE(942),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1614] = {
    [aux_sym_concatenation_repeat1] = STATE(1614),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3872),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1615] = {
    [aux_sym_concatenation_repeat1] = STATE(1615),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1616] = {
    [aux_sym_concatenation_repeat1] = STATE(1618),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_RPAREN] = ACTIONS(1367),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [1617] = {
    [aux_sym_concatenation_repeat1] = STATE(1618),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1618] = {
    [aux_sym_concatenation_repeat1] = STATE(2294),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1619] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [1620] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(5217),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [1621] = {
    [sym_string] = STATE(2296),
    [sym_simple_expansion] = STATE(2296),
    [sym_string_expansion] = STATE(2296),
    [sym_expansion] = STATE(2296),
    [sym_command_substitution] = STATE(2296),
    [sym_process_substitution] = STATE(2296),
    [sym__special_characters] = ACTIONS(5219),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [anon_sym_DOLLAR] = ACTIONS(1897),
    [sym_raw_string] = ACTIONS(5219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1903),
    [anon_sym_BQUOTE] = ACTIONS(1905),
    [anon_sym_LT_LPAREN] = ACTIONS(1907),
    [anon_sym_GT_LPAREN] = ACTIONS(1907),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5219),
  },
  [1622] = {
    [aux_sym_concatenation_repeat1] = STATE(2297),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(3543),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1623] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1624] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5221),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1625] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(5221),
    [anon_sym_DOLLAR] = ACTIONS(5223),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1626] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [1627] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [1628] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [1629] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5225),
    [sym_comment] = ACTIONS(57),
  },
  [1630] = {
    [sym_subscript] = STATE(2303),
    [sym_variable_name] = ACTIONS(5227),
    [anon_sym_DASH] = ACTIONS(5229),
    [anon_sym_DOLLAR] = ACTIONS(5229),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5231),
    [anon_sym_STAR] = ACTIONS(5233),
    [anon_sym_AT] = ACTIONS(5233),
    [anon_sym_QMARK] = ACTIONS(5233),
    [anon_sym_0] = ACTIONS(5231),
    [anon_sym__] = ACTIONS(5231),
  },
  [1631] = {
    [sym_concatenation] = STATE(2306),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2306),
    [anon_sym_RBRACE] = ACTIONS(5235),
    [anon_sym_EQ] = ACTIONS(5237),
    [anon_sym_DASH] = ACTIONS(5237),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5241),
    [anon_sym_COLON] = ACTIONS(5237),
    [anon_sym_COLON_QMARK] = ACTIONS(5237),
    [anon_sym_COLON_DASH] = ACTIONS(5237),
    [anon_sym_PERCENT] = ACTIONS(5237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1632] = {
    [sym_concatenation] = STATE(2309),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2309),
    [anon_sym_RBRACE] = ACTIONS(5243),
    [anon_sym_EQ] = ACTIONS(5245),
    [anon_sym_DASH] = ACTIONS(5245),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5245),
    [anon_sym_COLON_QMARK] = ACTIONS(5245),
    [anon_sym_COLON_DASH] = ACTIONS(5245),
    [anon_sym_PERCENT] = ACTIONS(5245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1633] = {
    [anon_sym_RPAREN] = ACTIONS(5251),
    [sym_comment] = ACTIONS(57),
  },
  [1634] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5251),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1635] = {
    [anon_sym_BQUOTE] = ACTIONS(5251),
    [sym_comment] = ACTIONS(57),
  },
  [1636] = {
    [anon_sym_RPAREN] = ACTIONS(5253),
    [sym_comment] = ACTIONS(57),
  },
  [1637] = {
    [sym__expression] = STATE(2313),
    [sym_binary_expression] = STATE(2313),
    [sym_unary_expression] = STATE(2313),
    [sym_postfix_expression] = STATE(2313),
    [sym_parenthesized_expression] = STATE(2313),
    [sym_concatenation] = STATE(2313),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5255),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1638] = {
    [anon_sym_SEMI] = ACTIONS(5257),
    [anon_sym_SEMI_SEMI] = ACTIONS(5259),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(5259),
    [anon_sym_AMP] = ACTIONS(5257),
  },
  [1639] = {
    [sym__expression] = STATE(2315),
    [sym_binary_expression] = STATE(2315),
    [sym_unary_expression] = STATE(2315),
    [sym_postfix_expression] = STATE(2315),
    [sym_parenthesized_expression] = STATE(2315),
    [sym_concatenation] = STATE(2315),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [anon_sym_SEMI] = ACTIONS(5257),
    [anon_sym_SEMI_SEMI] = ACTIONS(5259),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [sym__special_characters] = ACTIONS(475),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_LT_LPAREN] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(491),
    [sym_test_operator] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(5259),
    [anon_sym_AMP] = ACTIONS(5259),
  },
  [1640] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(727),
    [sym_simple_expansion] = STATE(727),
    [sym_string_expansion] = STATE(727),
    [sym_expansion] = STATE(727),
    [sym_command_substitution] = STATE(727),
    [sym_process_substitution] = STATE(727),
    [aux_sym_for_statement_repeat1] = STATE(1328),
    [anon_sym_SEMI] = ACTIONS(5261),
    [anon_sym_SEMI_SEMI] = ACTIONS(5263),
    [sym__special_characters] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [sym_raw_string] = ACTIONS(1481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1485),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(1489),
    [anon_sym_GT_LPAREN] = ACTIONS(1489),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2814),
    [anon_sym_LF] = ACTIONS(5263),
    [anon_sym_AMP] = ACTIONS(5263),
  },
  [1641] = {
    [sym__simple_heredoc_body] = ACTIONS(2816),
    [sym__heredoc_body_beginning] = ACTIONS(2816),
    [sym_file_descriptor] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [anon_sym_RBRACE] = ACTIONS(2816),
    [anon_sym_PIPE_AMP] = ACTIONS(2816),
    [anon_sym_AMP_AMP] = ACTIONS(2816),
    [anon_sym_PIPE_PIPE] = ACTIONS(2816),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_GT] = ACTIONS(2818),
    [anon_sym_GT_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT] = ACTIONS(2818),
    [anon_sym_AMP_GT_GT] = ACTIONS(2816),
    [anon_sym_LT_AMP] = ACTIONS(2816),
    [anon_sym_GT_AMP] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2818),
    [anon_sym_LT_LT_DASH] = ACTIONS(2816),
    [anon_sym_LT_LT_LT] = ACTIONS(2816),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2818),
  },
  [1642] = {
    [sym__simple_heredoc_body] = ACTIONS(3139),
    [sym__heredoc_body_beginning] = ACTIONS(3139),
    [sym_file_descriptor] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_SEMI_SEMI] = ACTIONS(3139),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_PIPE_AMP] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_GT] = ACTIONS(3141),
    [anon_sym_GT_GT] = ACTIONS(3139),
    [anon_sym_AMP_GT] = ACTIONS(3141),
    [anon_sym_AMP_GT_GT] = ACTIONS(3139),
    [anon_sym_LT_AMP] = ACTIONS(3139),
    [anon_sym_GT_AMP] = ACTIONS(3139),
    [anon_sym_LT_LT] = ACTIONS(3141),
    [anon_sym_LT_LT_DASH] = ACTIONS(3139),
    [anon_sym_LT_LT_LT] = ACTIONS(3139),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3141),
  },
  [1643] = {
    [anon_sym_done] = ACTIONS(5265),
    [sym_comment] = ACTIONS(57),
  },
  [1644] = {
    [sym__simple_heredoc_body] = ACTIONS(3295),
    [sym__heredoc_body_beginning] = ACTIONS(3295),
    [sym_file_descriptor] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_SEMI_SEMI] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_PIPE_AMP] = ACTIONS(3295),
    [anon_sym_AMP_AMP] = ACTIONS(3295),
    [anon_sym_PIPE_PIPE] = ACTIONS(3295),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_GT_GT] = ACTIONS(3295),
    [anon_sym_AMP_GT] = ACTIONS(3297),
    [anon_sym_AMP_GT_GT] = ACTIONS(3295),
    [anon_sym_LT_AMP] = ACTIONS(3295),
    [anon_sym_GT_AMP] = ACTIONS(3295),
    [anon_sym_LT_LT] = ACTIONS(3297),
    [anon_sym_LT_LT_DASH] = ACTIONS(3295),
    [anon_sym_LT_LT_LT] = ACTIONS(3295),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3297),
  },
  [1645] = {
    [sym_elif_clause] = STATE(2320),
    [sym_else_clause] = STATE(2319),
    [aux_sym_if_statement_repeat1] = STATE(2320),
    [anon_sym_fi] = ACTIONS(5267),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [1646] = {
    [anon_sym_fi] = ACTIONS(5267),
    [sym_comment] = ACTIONS(57),
  },
  [1647] = {
    [sym_elif_clause] = STATE(1582),
    [sym_else_clause] = STATE(2319),
    [aux_sym_if_statement_repeat1] = STATE(1582),
    [anon_sym_fi] = ACTIONS(5267),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [1648] = {
    [sym_case_item] = STATE(2323),
    [sym_last_case_item] = STATE(2322),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2323),
    [anon_sym_esac] = ACTIONS(5269),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [1649] = {
    [anon_sym_SEMI] = ACTIONS(5271),
    [anon_sym_SEMI_SEMI] = ACTIONS(5273),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5273),
    [anon_sym_AMP] = ACTIONS(5273),
  },
  [1650] = {
    [sym_case_item] = STATE(2327),
    [sym_last_case_item] = STATE(2326),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2327),
    [anon_sym_esac] = ACTIONS(5275),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [1651] = {
    [anon_sym_SEMI] = ACTIONS(5277),
    [anon_sym_SEMI_SEMI] = ACTIONS(5279),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5279),
  },
  [1652] = {
    [sym_compound_statement] = STATE(2329),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [1653] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1654] = {
    [sym_concatenation] = STATE(2331),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(2331),
    [anon_sym_RPAREN] = ACTIONS(5281),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [1655] = {
    [aux_sym_concatenation_repeat1] = STATE(989),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(1945),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_RBRACE] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1411),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [1656] = {
    [aux_sym_concatenation_repeat1] = STATE(989),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(1945),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1657] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1658] = {
    [aux_sym_concatenation_repeat1] = STATE(1658),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(5283),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1659] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2315),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1660] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5286),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1661] = {
    [sym_concatenation] = STATE(2336),
    [sym_string] = STATE(2335),
    [sym_simple_expansion] = STATE(2335),
    [sym_string_expansion] = STATE(2335),
    [sym_expansion] = STATE(2335),
    [sym_command_substitution] = STATE(2335),
    [sym_process_substitution] = STATE(2335),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [sym__special_characters] = ACTIONS(5290),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5292),
  },
  [1662] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5294),
    [sym_comment] = ACTIONS(57),
  },
  [1663] = {
    [sym_concatenation] = STATE(2340),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2340),
    [anon_sym_RBRACE] = ACTIONS(5296),
    [anon_sym_EQ] = ACTIONS(5298),
    [anon_sym_DASH] = ACTIONS(5298),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5302),
    [anon_sym_COLON] = ACTIONS(5298),
    [anon_sym_COLON_QMARK] = ACTIONS(5298),
    [anon_sym_COLON_DASH] = ACTIONS(5298),
    [anon_sym_PERCENT] = ACTIONS(5298),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1664] = {
    [sym_concatenation] = STATE(2342),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2342),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_EQ] = ACTIONS(5304),
    [anon_sym_DASH] = ACTIONS(5304),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5308),
    [anon_sym_COLON] = ACTIONS(5304),
    [anon_sym_COLON_QMARK] = ACTIONS(5304),
    [anon_sym_COLON_DASH] = ACTIONS(5304),
    [anon_sym_PERCENT] = ACTIONS(5304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1665] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1666] = {
    [sym_concatenation] = STATE(2345),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2345),
    [sym_regex] = ACTIONS(5310),
    [anon_sym_RBRACE] = ACTIONS(5312),
    [anon_sym_EQ] = ACTIONS(5314),
    [anon_sym_DASH] = ACTIONS(5314),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5316),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5314),
    [anon_sym_COLON_QMARK] = ACTIONS(5314),
    [anon_sym_COLON_DASH] = ACTIONS(5314),
    [anon_sym_PERCENT] = ACTIONS(5314),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1667] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5312),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1668] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1669] = {
    [sym_concatenation] = STATE(2342),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2342),
    [sym_regex] = ACTIONS(5318),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_EQ] = ACTIONS(5304),
    [anon_sym_DASH] = ACTIONS(5304),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5304),
    [anon_sym_COLON_QMARK] = ACTIONS(5304),
    [anon_sym_COLON_DASH] = ACTIONS(5304),
    [anon_sym_PERCENT] = ACTIONS(5304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1670] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1671] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1672] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1673] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1674] = {
    [aux_sym_concatenation_repeat1] = STATE(1674),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(5320),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1675] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2315),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1676] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5323),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1677] = {
    [sym_concatenation] = STATE(2351),
    [sym_string] = STATE(2350),
    [sym_simple_expansion] = STATE(2350),
    [sym_string_expansion] = STATE(2350),
    [sym_expansion] = STATE(2350),
    [sym_command_substitution] = STATE(2350),
    [sym_process_substitution] = STATE(2350),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5329),
  },
  [1678] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5331),
    [sym_comment] = ACTIONS(57),
  },
  [1679] = {
    [sym_concatenation] = STATE(2355),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2355),
    [anon_sym_RBRACE] = ACTIONS(5333),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_DASH] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5339),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_COLON_QMARK] = ACTIONS(5335),
    [anon_sym_COLON_DASH] = ACTIONS(5335),
    [anon_sym_PERCENT] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1680] = {
    [sym_concatenation] = STATE(2357),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2357),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5341),
    [anon_sym_DASH] = ACTIONS(5341),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5341),
    [anon_sym_COLON_QMARK] = ACTIONS(5341),
    [anon_sym_COLON_DASH] = ACTIONS(5341),
    [anon_sym_PERCENT] = ACTIONS(5341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1681] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1682] = {
    [sym_concatenation] = STATE(2360),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2360),
    [sym_regex] = ACTIONS(5347),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5351),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_COLON_QMARK] = ACTIONS(5351),
    [anon_sym_COLON_DASH] = ACTIONS(5351),
    [anon_sym_PERCENT] = ACTIONS(5351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1683] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1684] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1685] = {
    [sym_concatenation] = STATE(2357),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2357),
    [sym_regex] = ACTIONS(5355),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5341),
    [anon_sym_DASH] = ACTIONS(5341),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5341),
    [anon_sym_COLON_QMARK] = ACTIONS(5341),
    [anon_sym_COLON_DASH] = ACTIONS(5341),
    [anon_sym_PERCENT] = ACTIONS(5341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1686] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1687] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1688] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1689] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4021),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [1690] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_RBRACE] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4035),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [1691] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5357),
    [sym_comment] = ACTIONS(57),
  },
  [1692] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [sym_comment] = ACTIONS(57),
  },
  [1693] = {
    [anon_sym_RBRACE] = ACTIONS(5359),
    [sym_comment] = ACTIONS(57),
  },
  [1694] = {
    [sym_concatenation] = STATE(2366),
    [sym_string] = STATE(2365),
    [sym_simple_expansion] = STATE(2365),
    [sym_string_expansion] = STATE(2365),
    [sym_expansion] = STATE(2365),
    [sym_command_substitution] = STATE(2365),
    [sym_process_substitution] = STATE(2365),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [sym__special_characters] = ACTIONS(5361),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5363),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5363),
  },
  [1695] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [1696] = {
    [sym_concatenation] = STATE(2369),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2369),
    [sym_regex] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5367),
    [anon_sym_EQ] = ACTIONS(5369),
    [anon_sym_DASH] = ACTIONS(5369),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5369),
    [anon_sym_COLON_QMARK] = ACTIONS(5369),
    [anon_sym_COLON_DASH] = ACTIONS(5369),
    [anon_sym_PERCENT] = ACTIONS(5369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1697] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5367),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1698] = {
    [sym_concatenation] = STATE(2371),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2371),
    [sym_regex] = ACTIONS(5373),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [anon_sym_EQ] = ACTIONS(5375),
    [anon_sym_DASH] = ACTIONS(5375),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5375),
    [anon_sym_COLON_QMARK] = ACTIONS(5375),
    [anon_sym_COLON_DASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1699] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1700] = {
    [sym_concatenation] = STATE(2373),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2373),
    [anon_sym_RBRACE] = ACTIONS(5379),
    [anon_sym_EQ] = ACTIONS(5381),
    [anon_sym_DASH] = ACTIONS(5381),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5381),
    [anon_sym_COLON_QMARK] = ACTIONS(5381),
    [anon_sym_COLON_DASH] = ACTIONS(5381),
    [anon_sym_PERCENT] = ACTIONS(5381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1701] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1702] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5379),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1703] = {
    [sym_concatenation] = STATE(2371),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2371),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [anon_sym_EQ] = ACTIONS(5375),
    [anon_sym_DASH] = ACTIONS(5375),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5375),
    [anon_sym_COLON_QMARK] = ACTIONS(5375),
    [anon_sym_COLON_DASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1704] = {
    [sym__simple_heredoc_body] = ACTIONS(4231),
    [sym__heredoc_body_beginning] = ACTIONS(4231),
    [sym_file_descriptor] = ACTIONS(4231),
    [anon_sym_SEMI] = ACTIONS(4233),
    [anon_sym_PIPE] = ACTIONS(4233),
    [anon_sym_SEMI_SEMI] = ACTIONS(4231),
    [anon_sym_RBRACE] = ACTIONS(4231),
    [anon_sym_PIPE_AMP] = ACTIONS(4231),
    [anon_sym_AMP_AMP] = ACTIONS(4231),
    [anon_sym_PIPE_PIPE] = ACTIONS(4231),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_GT] = ACTIONS(4233),
    [anon_sym_GT_GT] = ACTIONS(4231),
    [anon_sym_AMP_GT] = ACTIONS(4233),
    [anon_sym_AMP_GT_GT] = ACTIONS(4231),
    [anon_sym_LT_AMP] = ACTIONS(4231),
    [anon_sym_GT_AMP] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(4233),
    [anon_sym_LT_LT_DASH] = ACTIONS(4231),
    [anon_sym_LT_LT_LT] = ACTIONS(4231),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4231),
    [anon_sym_AMP] = ACTIONS(4233),
  },
  [1705] = {
    [anon_sym_SEMI] = ACTIONS(4265),
    [anon_sym_SEMI_SEMI] = ACTIONS(4263),
    [anon_sym_RBRACE] = ACTIONS(4263),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4263),
    [anon_sym_AMP] = ACTIONS(4263),
  },
  [1706] = {
    [aux_sym_concatenation_repeat1] = STATE(1709),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_RBRACE] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [1707] = {
    [aux_sym_concatenation_repeat1] = STATE(1709),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1708] = {
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1709] = {
    [aux_sym_concatenation_repeat1] = STATE(2374),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1710] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(4284),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [1711] = {
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2664),
  },
  [1712] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(5385),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [1713] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_RBRACK] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4019),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4019),
  },
  [1714] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_RBRACK] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4033),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4033),
    [anon_sym_LT_EQ] = ACTIONS(4033),
    [anon_sym_GT_EQ] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4033),
    [anon_sym_DASH_DASH] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4033),
  },
  [1715] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [sym_comment] = ACTIONS(57),
  },
  [1716] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [sym_comment] = ACTIONS(57),
  },
  [1717] = {
    [anon_sym_RBRACE] = ACTIONS(5389),
    [sym_comment] = ACTIONS(57),
  },
  [1718] = {
    [sym_concatenation] = STATE(2380),
    [sym_string] = STATE(2379),
    [sym_simple_expansion] = STATE(2379),
    [sym_string_expansion] = STATE(2379),
    [sym_expansion] = STATE(2379),
    [sym_command_substitution] = STATE(2379),
    [sym_process_substitution] = STATE(2379),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [sym__special_characters] = ACTIONS(5391),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5393),
  },
  [1719] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_RBRACK] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4069),
    [anon_sym_LT_EQ] = ACTIONS(4069),
    [anon_sym_GT_EQ] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4069),
    [anon_sym_DASH_DASH] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4069),
  },
  [1720] = {
    [sym_concatenation] = STATE(2383),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2383),
    [sym_regex] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_EQ] = ACTIONS(5399),
    [anon_sym_DASH] = ACTIONS(5399),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5399),
    [anon_sym_COLON_QMARK] = ACTIONS(5399),
    [anon_sym_COLON_DASH] = ACTIONS(5399),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1721] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1722] = {
    [sym_concatenation] = STATE(2385),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2385),
    [sym_regex] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_EQ] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5405),
    [anon_sym_COLON_QMARK] = ACTIONS(5405),
    [anon_sym_COLON_DASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1723] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1724] = {
    [sym_concatenation] = STATE(2387),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2387),
    [anon_sym_RBRACE] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(5411),
    [anon_sym_DASH] = ACTIONS(5411),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_COLON_QMARK] = ACTIONS(5411),
    [anon_sym_COLON_DASH] = ACTIONS(5411),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1725] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_RBRACK] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_PLUS_EQ] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DASH_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4125),
  },
  [1726] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1727] = {
    [sym_concatenation] = STATE(2385),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2385),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_EQ] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5405),
    [anon_sym_COLON_QMARK] = ACTIONS(5405),
    [anon_sym_COLON_DASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1728] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [ts_builtin_sym_end] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_RPAREN] = ACTIONS(2664),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2666),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [1729] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(5415),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [1730] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [ts_builtin_sym_end] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [1731] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [ts_builtin_sym_end] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [1732] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [sym_comment] = ACTIONS(57),
  },
  [1733] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [sym_comment] = ACTIONS(57),
  },
  [1734] = {
    [anon_sym_RBRACE] = ACTIONS(5419),
    [sym_comment] = ACTIONS(57),
  },
  [1735] = {
    [sym_concatenation] = STATE(2393),
    [sym_string] = STATE(2392),
    [sym_simple_expansion] = STATE(2392),
    [sym_string_expansion] = STATE(2392),
    [sym_expansion] = STATE(2392),
    [sym_command_substitution] = STATE(2392),
    [sym_process_substitution] = STATE(2392),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [sym__special_characters] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5423),
  },
  [1736] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [ts_builtin_sym_end] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [1737] = {
    [sym_concatenation] = STATE(2396),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2396),
    [sym_regex] = ACTIONS(5425),
    [anon_sym_RBRACE] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5429),
    [anon_sym_DASH] = ACTIONS(5429),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5429),
    [anon_sym_COLON_QMARK] = ACTIONS(5429),
    [anon_sym_COLON_DASH] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1738] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1739] = {
    [sym_concatenation] = STATE(2398),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2398),
    [sym_regex] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5435),
    [anon_sym_DASH] = ACTIONS(5435),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5435),
    [anon_sym_COLON_QMARK] = ACTIONS(5435),
    [anon_sym_COLON_DASH] = ACTIONS(5435),
    [anon_sym_PERCENT] = ACTIONS(5435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1740] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1741] = {
    [sym_concatenation] = STATE(2400),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2400),
    [anon_sym_RBRACE] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5441),
    [anon_sym_DASH] = ACTIONS(5441),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5441),
    [anon_sym_COLON_QMARK] = ACTIONS(5441),
    [anon_sym_COLON_DASH] = ACTIONS(5441),
    [anon_sym_PERCENT] = ACTIONS(5441),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1742] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [ts_builtin_sym_end] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1743] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1744] = {
    [sym_concatenation] = STATE(2398),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2398),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5435),
    [anon_sym_DASH] = ACTIONS(5435),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5435),
    [anon_sym_COLON_QMARK] = ACTIONS(5435),
    [anon_sym_COLON_DASH] = ACTIONS(5435),
    [anon_sym_PERCENT] = ACTIONS(5435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1745] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [ts_builtin_sym_end] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [1746] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [ts_builtin_sym_end] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [1747] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [sym_comment] = ACTIONS(57),
  },
  [1748] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5447),
    [sym_comment] = ACTIONS(57),
  },
  [1749] = {
    [anon_sym_RBRACE] = ACTIONS(5447),
    [sym_comment] = ACTIONS(57),
  },
  [1750] = {
    [sym_concatenation] = STATE(2405),
    [sym_string] = STATE(2404),
    [sym_simple_expansion] = STATE(2404),
    [sym_string_expansion] = STATE(2404),
    [sym_expansion] = STATE(2404),
    [sym_command_substitution] = STATE(2404),
    [sym_process_substitution] = STATE(2404),
    [anon_sym_RBRACE] = ACTIONS(5447),
    [sym__special_characters] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5451),
  },
  [1751] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [ts_builtin_sym_end] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [1752] = {
    [sym_concatenation] = STATE(2408),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2408),
    [sym_regex] = ACTIONS(5453),
    [anon_sym_RBRACE] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5457),
    [anon_sym_DASH] = ACTIONS(5457),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5457),
    [anon_sym_COLON_QMARK] = ACTIONS(5457),
    [anon_sym_COLON_DASH] = ACTIONS(5457),
    [anon_sym_PERCENT] = ACTIONS(5457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1753] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1754] = {
    [sym_concatenation] = STATE(2410),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2410),
    [sym_regex] = ACTIONS(5461),
    [anon_sym_RBRACE] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5463),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5463),
    [anon_sym_COLON_QMARK] = ACTIONS(5463),
    [anon_sym_COLON_DASH] = ACTIONS(5463),
    [anon_sym_PERCENT] = ACTIONS(5463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1755] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1756] = {
    [sym_concatenation] = STATE(2412),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2412),
    [anon_sym_RBRACE] = ACTIONS(5467),
    [anon_sym_EQ] = ACTIONS(5469),
    [anon_sym_DASH] = ACTIONS(5469),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5469),
    [anon_sym_COLON_QMARK] = ACTIONS(5469),
    [anon_sym_COLON_DASH] = ACTIONS(5469),
    [anon_sym_PERCENT] = ACTIONS(5469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1757] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [ts_builtin_sym_end] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1758] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5467),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1759] = {
    [sym_concatenation] = STATE(2410),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2410),
    [anon_sym_RBRACE] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5463),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5463),
    [anon_sym_COLON_QMARK] = ACTIONS(5463),
    [anon_sym_COLON_DASH] = ACTIONS(5463),
    [anon_sym_PERCENT] = ACTIONS(5463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1760] = {
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4019),
  },
  [1761] = {
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4033),
  },
  [1762] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5473),
    [sym_comment] = ACTIONS(57),
  },
  [1763] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [sym_comment] = ACTIONS(57),
  },
  [1764] = {
    [anon_sym_RBRACE] = ACTIONS(5475),
    [sym_comment] = ACTIONS(57),
  },
  [1765] = {
    [sym_concatenation] = STATE(2417),
    [sym_string] = STATE(2416),
    [sym_simple_expansion] = STATE(2416),
    [sym_string_expansion] = STATE(2416),
    [sym_expansion] = STATE(2416),
    [sym_command_substitution] = STATE(2416),
    [sym_process_substitution] = STATE(2416),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [sym__special_characters] = ACTIONS(5477),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5479),
  },
  [1766] = {
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
  },
  [1767] = {
    [sym_concatenation] = STATE(2420),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2420),
    [sym_regex] = ACTIONS(5481),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5485),
    [anon_sym_DASH] = ACTIONS(5485),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5485),
    [anon_sym_COLON_QMARK] = ACTIONS(5485),
    [anon_sym_COLON_DASH] = ACTIONS(5485),
    [anon_sym_PERCENT] = ACTIONS(5485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1768] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1769] = {
    [sym_concatenation] = STATE(2422),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2422),
    [sym_regex] = ACTIONS(5489),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_DASH] = ACTIONS(5491),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5491),
    [anon_sym_COLON_QMARK] = ACTIONS(5491),
    [anon_sym_COLON_DASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1770] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1771] = {
    [sym_concatenation] = STATE(2424),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2424),
    [anon_sym_RBRACE] = ACTIONS(5495),
    [anon_sym_EQ] = ACTIONS(5497),
    [anon_sym_DASH] = ACTIONS(5497),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5497),
    [anon_sym_COLON_QMARK] = ACTIONS(5497),
    [anon_sym_COLON_DASH] = ACTIONS(5497),
    [anon_sym_PERCENT] = ACTIONS(5497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1772] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4125),
  },
  [1773] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5495),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1774] = {
    [sym_concatenation] = STATE(2422),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2422),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_DASH] = ACTIONS(5491),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5491),
    [anon_sym_COLON_QMARK] = ACTIONS(5491),
    [anon_sym_COLON_DASH] = ACTIONS(5491),
    [anon_sym_PERCENT] = ACTIONS(5491),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1775] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4035),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym__string_content] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4035),
    [anon_sym_BQUOTE] = ACTIONS(4035),
    [sym_comment] = ACTIONS(343),
  },
  [1776] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5501),
    [sym_comment] = ACTIONS(57),
  },
  [1777] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5503),
    [sym_comment] = ACTIONS(57),
  },
  [1778] = {
    [anon_sym_RBRACE] = ACTIONS(5503),
    [sym_comment] = ACTIONS(57),
  },
  [1779] = {
    [sym_concatenation] = STATE(2429),
    [sym_string] = STATE(2428),
    [sym_simple_expansion] = STATE(2428),
    [sym_string_expansion] = STATE(2428),
    [sym_expansion] = STATE(2428),
    [sym_command_substitution] = STATE(2428),
    [sym_process_substitution] = STATE(2428),
    [anon_sym_RBRACE] = ACTIONS(5503),
    [sym__special_characters] = ACTIONS(5505),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5507),
  },
  [1780] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4071),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym__string_content] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [sym_comment] = ACTIONS(343),
  },
  [1781] = {
    [sym_concatenation] = STATE(2432),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2432),
    [sym_regex] = ACTIONS(5509),
    [anon_sym_RBRACE] = ACTIONS(5511),
    [anon_sym_EQ] = ACTIONS(5513),
    [anon_sym_DASH] = ACTIONS(5513),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5513),
    [anon_sym_COLON_QMARK] = ACTIONS(5513),
    [anon_sym_COLON_DASH] = ACTIONS(5513),
    [anon_sym_PERCENT] = ACTIONS(5513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1782] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5511),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1783] = {
    [sym_concatenation] = STATE(2434),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2434),
    [sym_regex] = ACTIONS(5517),
    [anon_sym_RBRACE] = ACTIONS(5503),
    [anon_sym_EQ] = ACTIONS(5519),
    [anon_sym_DASH] = ACTIONS(5519),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5519),
    [anon_sym_COLON_QMARK] = ACTIONS(5519),
    [anon_sym_COLON_DASH] = ACTIONS(5519),
    [anon_sym_PERCENT] = ACTIONS(5519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1784] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5503),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1785] = {
    [sym_concatenation] = STATE(2436),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2436),
    [anon_sym_RBRACE] = ACTIONS(5523),
    [anon_sym_EQ] = ACTIONS(5525),
    [anon_sym_DASH] = ACTIONS(5525),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5527),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5525),
    [anon_sym_COLON_QMARK] = ACTIONS(5525),
    [anon_sym_COLON_DASH] = ACTIONS(5525),
    [anon_sym_PERCENT] = ACTIONS(5525),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1786] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4127),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__string_content] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4127),
    [anon_sym_BQUOTE] = ACTIONS(4127),
    [sym_comment] = ACTIONS(343),
  },
  [1787] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5523),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1788] = {
    [sym_concatenation] = STATE(2434),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2434),
    [anon_sym_RBRACE] = ACTIONS(5503),
    [anon_sym_EQ] = ACTIONS(5519),
    [anon_sym_DASH] = ACTIONS(5519),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5519),
    [anon_sym_COLON_QMARK] = ACTIONS(5519),
    [anon_sym_COLON_DASH] = ACTIONS(5519),
    [anon_sym_PERCENT] = ACTIONS(5519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1789] = {
    [sym_string] = STATE(1067),
    [sym_simple_expansion] = STATE(1067),
    [sym_string_expansion] = STATE(1067),
    [sym_expansion] = STATE(1067),
    [sym_command_substitution] = STATE(1067),
    [sym_process_substitution] = STATE(1067),
    [anon_sym_RBRACK] = ACTIONS(5529),
    [sym__special_characters] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2081),
  },
  [1790] = {
    [sym__concat] = ACTIONS(5531),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(5533),
    [anon_sym_DASH] = ACTIONS(5533),
    [sym__special_characters] = ACTIONS(5533),
    [anon_sym_DQUOTE] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(5533),
    [sym_raw_string] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2656),
    [anon_sym_SLASH] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(5533),
    [anon_sym_COLON_QMARK] = ACTIONS(5533),
    [anon_sym_COLON_DASH] = ACTIONS(5533),
    [anon_sym_PERCENT] = ACTIONS(5533),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2656),
    [anon_sym_BQUOTE] = ACTIONS(2656),
    [anon_sym_LT_LPAREN] = ACTIONS(2656),
    [anon_sym_GT_LPAREN] = ACTIONS(2656),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5533),
  },
  [1791] = {
    [sym_string] = STATE(1067),
    [sym_simple_expansion] = STATE(1067),
    [sym_string_expansion] = STATE(1067),
    [sym_expansion] = STATE(1067),
    [sym_command_substitution] = STATE(1067),
    [sym_process_substitution] = STATE(1067),
    [anon_sym_RBRACK] = ACTIONS(5535),
    [sym__special_characters] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2081),
  },
  [1792] = {
    [sym__concat] = ACTIONS(5537),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_EQ] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5539),
    [sym__special_characters] = ACTIONS(5539),
    [anon_sym_DQUOTE] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(5539),
    [sym_raw_string] = ACTIONS(2662),
    [anon_sym_POUND] = ACTIONS(2662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2662),
    [anon_sym_SLASH] = ACTIONS(2662),
    [anon_sym_COLON] = ACTIONS(5539),
    [anon_sym_COLON_QMARK] = ACTIONS(5539),
    [anon_sym_COLON_DASH] = ACTIONS(5539),
    [anon_sym_PERCENT] = ACTIONS(5539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2662),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_LT_LPAREN] = ACTIONS(2662),
    [anon_sym_GT_LPAREN] = ACTIONS(2662),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5539),
  },
  [1793] = {
    [anon_sym_RBRACK] = ACTIONS(5535),
    [sym_comment] = ACTIONS(57),
  },
  [1794] = {
    [sym_string] = STATE(2441),
    [sym_simple_expansion] = STATE(2441),
    [sym_string_expansion] = STATE(2441),
    [sym_expansion] = STATE(2441),
    [sym_command_substitution] = STATE(2441),
    [sym_process_substitution] = STATE(2441),
    [sym__special_characters] = ACTIONS(5541),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5541),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5541),
  },
  [1795] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [ts_builtin_sym_end] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [1796] = {
    [aux_sym_concatenation_repeat1] = STATE(2442),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
  },
  [1797] = {
    [sym__concat] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
  },
  [1798] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5547),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1799] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(5547),
    [anon_sym_DOLLAR] = ACTIONS(5549),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1800] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
  },
  [1801] = {
    [sym__concat] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
  },
  [1802] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
  },
  [1803] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [ts_builtin_sym_end] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [1804] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5555),
    [sym_comment] = ACTIONS(57),
  },
  [1805] = {
    [sym_subscript] = STATE(2448),
    [sym_variable_name] = ACTIONS(5557),
    [anon_sym_DASH] = ACTIONS(5559),
    [anon_sym_DOLLAR] = ACTIONS(5559),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5561),
    [anon_sym_STAR] = ACTIONS(5563),
    [anon_sym_AT] = ACTIONS(5563),
    [anon_sym_QMARK] = ACTIONS(5563),
    [anon_sym_0] = ACTIONS(5561),
    [anon_sym__] = ACTIONS(5561),
  },
  [1806] = {
    [sym_concatenation] = STATE(2451),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2451),
    [anon_sym_RBRACE] = ACTIONS(5565),
    [anon_sym_EQ] = ACTIONS(5567),
    [anon_sym_DASH] = ACTIONS(5567),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5571),
    [anon_sym_COLON] = ACTIONS(5567),
    [anon_sym_COLON_QMARK] = ACTIONS(5567),
    [anon_sym_COLON_DASH] = ACTIONS(5567),
    [anon_sym_PERCENT] = ACTIONS(5567),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1807] = {
    [sym_concatenation] = STATE(2454),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2454),
    [anon_sym_RBRACE] = ACTIONS(5573),
    [anon_sym_EQ] = ACTIONS(5575),
    [anon_sym_DASH] = ACTIONS(5575),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5579),
    [anon_sym_COLON] = ACTIONS(5575),
    [anon_sym_COLON_QMARK] = ACTIONS(5575),
    [anon_sym_COLON_DASH] = ACTIONS(5575),
    [anon_sym_PERCENT] = ACTIONS(5575),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1808] = {
    [anon_sym_RPAREN] = ACTIONS(5581),
    [sym_comment] = ACTIONS(57),
  },
  [1809] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5581),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1810] = {
    [anon_sym_BQUOTE] = ACTIONS(5581),
    [sym_comment] = ACTIONS(57),
  },
  [1811] = {
    [anon_sym_RPAREN] = ACTIONS(5583),
    [sym_comment] = ACTIONS(57),
  },
  [1812] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5585),
    [sym_comment] = ACTIONS(57),
  },
  [1813] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5587),
    [sym_comment] = ACTIONS(57),
  },
  [1814] = {
    [anon_sym_RBRACE] = ACTIONS(5587),
    [sym_comment] = ACTIONS(57),
  },
  [1815] = {
    [sym_concatenation] = STATE(2460),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2460),
    [anon_sym_RBRACE] = ACTIONS(5589),
    [anon_sym_EQ] = ACTIONS(5591),
    [anon_sym_DASH] = ACTIONS(5591),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5593),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5591),
    [anon_sym_COLON_QMARK] = ACTIONS(5591),
    [anon_sym_COLON_DASH] = ACTIONS(5591),
    [anon_sym_PERCENT] = ACTIONS(5591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1816] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [ts_builtin_sym_end] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_RPAREN] = ACTIONS(5595),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5597),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [1817] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5589),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1818] = {
    [sym_concatenation] = STATE(2461),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2461),
    [anon_sym_RBRACE] = ACTIONS(5587),
    [anon_sym_EQ] = ACTIONS(5599),
    [anon_sym_DASH] = ACTIONS(5599),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5599),
    [anon_sym_COLON_QMARK] = ACTIONS(5599),
    [anon_sym_COLON_DASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1819] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5587),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1820] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_POUND] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_COLON_QMARK] = ACTIONS(2308),
    [anon_sym_COLON_DASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2308),
  },
  [1821] = {
    [aux_sym_concatenation_repeat1] = STATE(1821),
    [sym__concat] = ACTIONS(5603),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_POUND] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_COLON_QMARK] = ACTIONS(2308),
    [anon_sym_COLON_DASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2308),
  },
  [1822] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2313),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2315),
    [sym__special_characters] = ACTIONS(2315),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_POUND] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_COLON] = ACTIONS(2315),
    [anon_sym_COLON_QMARK] = ACTIONS(2315),
    [anon_sym_COLON_DASH] = ACTIONS(2315),
    [anon_sym_PERCENT] = ACTIONS(2315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2315),
  },
  [1823] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5606),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1824] = {
    [sym_concatenation] = STATE(2466),
    [sym_string] = STATE(2465),
    [sym_simple_expansion] = STATE(2465),
    [sym_string_expansion] = STATE(2465),
    [sym_expansion] = STATE(2465),
    [sym_command_substitution] = STATE(2465),
    [sym_process_substitution] = STATE(2465),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [sym__special_characters] = ACTIONS(5610),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5612),
  },
  [1825] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5614),
    [sym_comment] = ACTIONS(57),
  },
  [1826] = {
    [sym_concatenation] = STATE(2470),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2470),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_EQ] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5622),
    [anon_sym_COLON] = ACTIONS(5618),
    [anon_sym_COLON_QMARK] = ACTIONS(5618),
    [anon_sym_COLON_DASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1827] = {
    [sym_concatenation] = STATE(2472),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2472),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_EQ] = ACTIONS(5624),
    [anon_sym_DASH] = ACTIONS(5624),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5626),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5628),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_COLON_QMARK] = ACTIONS(5624),
    [anon_sym_COLON_DASH] = ACTIONS(5624),
    [anon_sym_PERCENT] = ACTIONS(5624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1828] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [sym__special_characters] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_POUND] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_COLON] = ACTIONS(2408),
    [anon_sym_COLON_QMARK] = ACTIONS(2408),
    [anon_sym_COLON_DASH] = ACTIONS(2408),
    [anon_sym_PERCENT] = ACTIONS(2408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2408),
  },
  [1829] = {
    [sym_concatenation] = STATE(2475),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2475),
    [sym_regex] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5634),
    [anon_sym_COLON_QMARK] = ACTIONS(5634),
    [anon_sym_COLON_DASH] = ACTIONS(5634),
    [anon_sym_PERCENT] = ACTIONS(5634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1830] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1831] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [sym__special_characters] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_POUND] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_COLON] = ACTIONS(2456),
    [anon_sym_COLON_QMARK] = ACTIONS(2456),
    [anon_sym_COLON_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2456),
  },
  [1832] = {
    [sym_concatenation] = STATE(2472),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2472),
    [sym_regex] = ACTIONS(5638),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_EQ] = ACTIONS(5624),
    [anon_sym_DASH] = ACTIONS(5624),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5626),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_COLON_QMARK] = ACTIONS(5624),
    [anon_sym_COLON_DASH] = ACTIONS(5624),
    [anon_sym_PERCENT] = ACTIONS(5624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1833] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1834] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [ts_builtin_sym_end] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [1835] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1836] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [sym__special_characters] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_POUND] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2466),
  },
  [1837] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_EQ] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [sym__special_characters] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_POUND] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_COLON] = ACTIONS(2504),
    [anon_sym_COLON_QMARK] = ACTIONS(2504),
    [anon_sym_COLON_DASH] = ACTIONS(2504),
    [anon_sym_PERCENT] = ACTIONS(2504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2504),
  },
  [1838] = {
    [aux_sym_concatenation_repeat1] = STATE(1838),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2306),
  },
  [1839] = {
    [aux_sym_concatenation_repeat1] = STATE(2478),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(1409),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1840] = {
    [aux_sym_concatenation_repeat1] = STATE(1198),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [1841] = {
    [aux_sym_concatenation_repeat1] = STATE(1198),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [1842] = {
    [aux_sym_concatenation_repeat1] = STATE(1842),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3872),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1843] = {
    [aux_sym_concatenation_repeat1] = STATE(1843),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1844] = {
    [aux_sym_concatenation_repeat1] = STATE(1846),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [1845] = {
    [aux_sym_concatenation_repeat1] = STATE(1846),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1846] = {
    [aux_sym_concatenation_repeat1] = STATE(2479),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [1847] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(4284),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [1848] = {
    [sym_concatenation] = STATE(2483),
    [sym_string] = STATE(2482),
    [sym_simple_expansion] = STATE(2482),
    [sym_string_expansion] = STATE(2482),
    [sym_expansion] = STATE(2482),
    [sym_command_substitution] = STATE(2482),
    [sym_process_substitution] = STATE(2482),
    [anon_sym_RBRACE] = ACTIONS(5646),
    [sym__special_characters] = ACTIONS(5648),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5650),
  },
  [1849] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5652),
    [sym_comment] = ACTIONS(57),
  },
  [1850] = {
    [sym_concatenation] = STATE(2487),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2487),
    [anon_sym_RBRACE] = ACTIONS(5654),
    [anon_sym_EQ] = ACTIONS(5656),
    [anon_sym_DASH] = ACTIONS(5656),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5660),
    [anon_sym_COLON] = ACTIONS(5656),
    [anon_sym_COLON_QMARK] = ACTIONS(5656),
    [anon_sym_COLON_DASH] = ACTIONS(5656),
    [anon_sym_PERCENT] = ACTIONS(5656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1851] = {
    [sym_concatenation] = STATE(2489),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2489),
    [anon_sym_RBRACE] = ACTIONS(5646),
    [anon_sym_EQ] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5662),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_COLON] = ACTIONS(5662),
    [anon_sym_COLON_QMARK] = ACTIONS(5662),
    [anon_sym_COLON_DASH] = ACTIONS(5662),
    [anon_sym_PERCENT] = ACTIONS(5662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1852] = {
    [sym__heredoc_body_middle] = ACTIONS(2406),
    [sym__heredoc_body_end] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
  },
  [1853] = {
    [sym_concatenation] = STATE(2492),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2492),
    [sym_regex] = ACTIONS(5668),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5672),
    [anon_sym_DASH] = ACTIONS(5672),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5672),
    [anon_sym_COLON_QMARK] = ACTIONS(5672),
    [anon_sym_COLON_DASH] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1854] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1855] = {
    [sym__heredoc_body_middle] = ACTIONS(2454),
    [sym__heredoc_body_end] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
  },
  [1856] = {
    [sym_concatenation] = STATE(2489),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2489),
    [sym_regex] = ACTIONS(5676),
    [anon_sym_RBRACE] = ACTIONS(5646),
    [anon_sym_EQ] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5662),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5662),
    [anon_sym_COLON_QMARK] = ACTIONS(5662),
    [anon_sym_COLON_DASH] = ACTIONS(5662),
    [anon_sym_PERCENT] = ACTIONS(5662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1857] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5646),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1858] = {
    [sym__heredoc_body_middle] = ACTIONS(2464),
    [sym__heredoc_body_end] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
  },
  [1859] = {
    [aux_sym_concatenation_repeat1] = STATE(1859),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2310),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1860] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(2495),
    [sym_simple_expansion] = STATE(2495),
    [sym_string_expansion] = STATE(2495),
    [sym_expansion] = STATE(2495),
    [sym_command_substitution] = STATE(2495),
    [sym_process_substitution] = STATE(2495),
    [sym__special_characters] = ACTIONS(5678),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(5680),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5680),
  },
  [1861] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1862] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1863] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [1864] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [1865] = {
    [aux_sym_concatenation_repeat1] = STATE(2496),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [1866] = {
    [aux_sym_concatenation_repeat1] = STATE(2496),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [1867] = {
    [aux_sym_concatenation_repeat1] = STATE(2496),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [1868] = {
    [aux_sym_concatenation_repeat1] = STATE(2496),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [1869] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [1870] = {
    [sym_file_redirect] = STATE(1870),
    [sym_heredoc_redirect] = STATE(1870),
    [sym_herestring_redirect] = STATE(1870),
    [aux_sym_redirected_statement_repeat1] = STATE(1870),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(5682),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(5685),
    [anon_sym_GT] = ACTIONS(5685),
    [anon_sym_GT_GT] = ACTIONS(5688),
    [anon_sym_AMP_GT] = ACTIONS(5685),
    [anon_sym_AMP_GT_GT] = ACTIONS(5688),
    [anon_sym_LT_AMP] = ACTIONS(5688),
    [anon_sym_GT_AMP] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(5691),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [1871] = {
    [sym_concatenation] = STATE(1216),
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_string_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [aux_sym_command_repeat2] = STATE(1216),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [1872] = {
    [anon_sym_EQ] = ACTIONS(5694),
    [anon_sym_PLUS_EQ] = ACTIONS(5694),
    [sym_comment] = ACTIONS(57),
  },
  [1873] = {
    [anon_sym_EQ] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [sym_comment] = ACTIONS(57),
  },
  [1874] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2306),
  },
  [1875] = {
    [aux_sym_concatenation_repeat1] = STATE(1875),
    [sym__concat] = ACTIONS(5698),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2306),
  },
  [1876] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2313),
  },
  [1877] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5701),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1878] = {
    [sym_concatenation] = STATE(2501),
    [sym_string] = STATE(2500),
    [sym_simple_expansion] = STATE(2500),
    [sym_string_expansion] = STATE(2500),
    [sym_expansion] = STATE(2500),
    [sym_command_substitution] = STATE(2500),
    [sym_process_substitution] = STATE(2500),
    [anon_sym_RBRACE] = ACTIONS(5703),
    [sym__special_characters] = ACTIONS(5705),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5707),
  },
  [1879] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5709),
    [sym_comment] = ACTIONS(57),
  },
  [1880] = {
    [sym_concatenation] = STATE(2505),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2505),
    [anon_sym_RBRACE] = ACTIONS(5711),
    [anon_sym_EQ] = ACTIONS(5713),
    [anon_sym_DASH] = ACTIONS(5713),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5717),
    [anon_sym_COLON] = ACTIONS(5713),
    [anon_sym_COLON_QMARK] = ACTIONS(5713),
    [anon_sym_COLON_DASH] = ACTIONS(5713),
    [anon_sym_PERCENT] = ACTIONS(5713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1881] = {
    [sym_concatenation] = STATE(2507),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2507),
    [anon_sym_RBRACE] = ACTIONS(5703),
    [anon_sym_EQ] = ACTIONS(5719),
    [anon_sym_DASH] = ACTIONS(5719),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5723),
    [anon_sym_COLON] = ACTIONS(5719),
    [anon_sym_COLON_QMARK] = ACTIONS(5719),
    [anon_sym_COLON_DASH] = ACTIONS(5719),
    [anon_sym_PERCENT] = ACTIONS(5719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1882] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2406),
  },
  [1883] = {
    [sym_concatenation] = STATE(2510),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2510),
    [sym_regex] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5729),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5729),
    [anon_sym_COLON_QMARK] = ACTIONS(5729),
    [anon_sym_COLON_DASH] = ACTIONS(5729),
    [anon_sym_PERCENT] = ACTIONS(5729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1884] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1885] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2454),
  },
  [1886] = {
    [sym_concatenation] = STATE(2507),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2507),
    [sym_regex] = ACTIONS(5733),
    [anon_sym_RBRACE] = ACTIONS(5703),
    [anon_sym_EQ] = ACTIONS(5719),
    [anon_sym_DASH] = ACTIONS(5719),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5719),
    [anon_sym_COLON_QMARK] = ACTIONS(5719),
    [anon_sym_COLON_DASH] = ACTIONS(5719),
    [anon_sym_PERCENT] = ACTIONS(5719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1887] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5703),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1888] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
  },
  [1889] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
  },
  [1890] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [ts_builtin_sym_end] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [1891] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [ts_builtin_sym_end] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [1892] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [sym_comment] = ACTIONS(57),
  },
  [1893] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5737),
    [sym_comment] = ACTIONS(57),
  },
  [1894] = {
    [anon_sym_RBRACE] = ACTIONS(5737),
    [sym_comment] = ACTIONS(57),
  },
  [1895] = {
    [sym_concatenation] = STATE(2516),
    [sym_string] = STATE(2515),
    [sym_simple_expansion] = STATE(2515),
    [sym_string_expansion] = STATE(2515),
    [sym_expansion] = STATE(2515),
    [sym_command_substitution] = STATE(2515),
    [sym_process_substitution] = STATE(2515),
    [anon_sym_RBRACE] = ACTIONS(5737),
    [sym__special_characters] = ACTIONS(5739),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5741),
  },
  [1896] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [ts_builtin_sym_end] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [1897] = {
    [sym_concatenation] = STATE(2519),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2519),
    [sym_regex] = ACTIONS(5743),
    [anon_sym_RBRACE] = ACTIONS(5745),
    [anon_sym_EQ] = ACTIONS(5747),
    [anon_sym_DASH] = ACTIONS(5747),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5747),
    [anon_sym_COLON_QMARK] = ACTIONS(5747),
    [anon_sym_COLON_DASH] = ACTIONS(5747),
    [anon_sym_PERCENT] = ACTIONS(5747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1898] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5745),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1899] = {
    [sym_concatenation] = STATE(2521),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2521),
    [sym_regex] = ACTIONS(5751),
    [anon_sym_RBRACE] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5753),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5753),
    [anon_sym_COLON_QMARK] = ACTIONS(5753),
    [anon_sym_COLON_DASH] = ACTIONS(5753),
    [anon_sym_PERCENT] = ACTIONS(5753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1900] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1901] = {
    [sym_concatenation] = STATE(2523),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2523),
    [anon_sym_RBRACE] = ACTIONS(5757),
    [anon_sym_EQ] = ACTIONS(5759),
    [anon_sym_DASH] = ACTIONS(5759),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5759),
    [anon_sym_COLON_QMARK] = ACTIONS(5759),
    [anon_sym_COLON_DASH] = ACTIONS(5759),
    [anon_sym_PERCENT] = ACTIONS(5759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1902] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [ts_builtin_sym_end] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1903] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5757),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1904] = {
    [sym_concatenation] = STATE(2521),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2521),
    [anon_sym_RBRACE] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5753),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5753),
    [anon_sym_COLON_QMARK] = ACTIONS(5753),
    [anon_sym_COLON_DASH] = ACTIONS(5753),
    [anon_sym_PERCENT] = ACTIONS(5753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1905] = {
    [sym_do_group] = STATE(2524),
    [sym_compound_statement] = STATE(2524),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1906] = {
    [sym__simple_heredoc_body] = ACTIONS(5763),
    [sym__heredoc_body_beginning] = ACTIONS(5763),
    [sym_file_descriptor] = ACTIONS(5763),
    [ts_builtin_sym_end] = ACTIONS(5763),
    [anon_sym_SEMI] = ACTIONS(5765),
    [anon_sym_done] = ACTIONS(5763),
    [anon_sym_fi] = ACTIONS(5763),
    [anon_sym_elif] = ACTIONS(5763),
    [anon_sym_else] = ACTIONS(5763),
    [anon_sym_esac] = ACTIONS(5763),
    [anon_sym_PIPE] = ACTIONS(5765),
    [anon_sym_RPAREN] = ACTIONS(5763),
    [anon_sym_SEMI_SEMI] = ACTIONS(5763),
    [anon_sym_PIPE_AMP] = ACTIONS(5763),
    [anon_sym_AMP_AMP] = ACTIONS(5763),
    [anon_sym_PIPE_PIPE] = ACTIONS(5763),
    [anon_sym_LT] = ACTIONS(5765),
    [anon_sym_GT] = ACTIONS(5765),
    [anon_sym_GT_GT] = ACTIONS(5763),
    [anon_sym_AMP_GT] = ACTIONS(5765),
    [anon_sym_AMP_GT_GT] = ACTIONS(5763),
    [anon_sym_LT_AMP] = ACTIONS(5763),
    [anon_sym_GT_AMP] = ACTIONS(5763),
    [anon_sym_LT_LT] = ACTIONS(5765),
    [anon_sym_LT_LT_DASH] = ACTIONS(5763),
    [anon_sym_LT_LT_LT] = ACTIONS(5763),
    [anon_sym_BQUOTE] = ACTIONS(5763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5763),
    [anon_sym_AMP] = ACTIONS(5765),
  },
  [1907] = {
    [sym_do_group] = STATE(2524),
    [sym_compound_statement] = STATE(2524),
    [anon_sym_SEMI] = ACTIONS(5767),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1908] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5769),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [1909] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4019),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4019),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [1910] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4033),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4033),
    [anon_sym_LT_EQ] = ACTIONS(4033),
    [anon_sym_GT_EQ] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4033),
    [anon_sym_DASH_DASH] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4033),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [1911] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5771),
    [sym_comment] = ACTIONS(57),
  },
  [1912] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [sym_comment] = ACTIONS(57),
  },
  [1913] = {
    [anon_sym_RBRACE] = ACTIONS(5773),
    [sym_comment] = ACTIONS(57),
  },
  [1914] = {
    [sym_concatenation] = STATE(2531),
    [sym_string] = STATE(2530),
    [sym_simple_expansion] = STATE(2530),
    [sym_string_expansion] = STATE(2530),
    [sym_expansion] = STATE(2530),
    [sym_command_substitution] = STATE(2530),
    [sym_process_substitution] = STATE(2530),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [sym__special_characters] = ACTIONS(5775),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5777),
  },
  [1915] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4069),
    [anon_sym_LT_EQ] = ACTIONS(4069),
    [anon_sym_GT_EQ] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4069),
    [anon_sym_DASH_DASH] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [1916] = {
    [sym_concatenation] = STATE(2534),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2534),
    [sym_regex] = ACTIONS(5779),
    [anon_sym_RBRACE] = ACTIONS(5781),
    [anon_sym_EQ] = ACTIONS(5783),
    [anon_sym_DASH] = ACTIONS(5783),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5783),
    [anon_sym_COLON_QMARK] = ACTIONS(5783),
    [anon_sym_COLON_DASH] = ACTIONS(5783),
    [anon_sym_PERCENT] = ACTIONS(5783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1917] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5781),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1918] = {
    [sym_concatenation] = STATE(2536),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2536),
    [sym_regex] = ACTIONS(5787),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5789),
    [anon_sym_DASH] = ACTIONS(5789),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5789),
    [anon_sym_COLON_QMARK] = ACTIONS(5789),
    [anon_sym_COLON_DASH] = ACTIONS(5789),
    [anon_sym_PERCENT] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1919] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1920] = {
    [sym_concatenation] = STATE(2538),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2538),
    [anon_sym_RBRACE] = ACTIONS(5793),
    [anon_sym_EQ] = ACTIONS(5795),
    [anon_sym_DASH] = ACTIONS(5795),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5797),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5795),
    [anon_sym_COLON_QMARK] = ACTIONS(5795),
    [anon_sym_COLON_DASH] = ACTIONS(5795),
    [anon_sym_PERCENT] = ACTIONS(5795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1921] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_PLUS_EQ] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DASH_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4125),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1922] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5793),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1923] = {
    [sym_concatenation] = STATE(2536),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2536),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_EQ] = ACTIONS(5789),
    [anon_sym_DASH] = ACTIONS(5789),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5789),
    [anon_sym_COLON_QMARK] = ACTIONS(5789),
    [anon_sym_COLON_DASH] = ACTIONS(5789),
    [anon_sym_PERCENT] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1924] = {
    [sym__expression] = STATE(2539),
    [sym_binary_expression] = STATE(2539),
    [sym_unary_expression] = STATE(2539),
    [sym_postfix_expression] = STATE(2539),
    [sym_parenthesized_expression] = STATE(2539),
    [sym_concatenation] = STATE(2539),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5769),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1925] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
  },
  [1926] = {
    [aux_sym_concatenation_repeat1] = STATE(1926),
    [sym__concat] = ACTIONS(5799),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
  },
  [1927] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2313),
  },
  [1928] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5802),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1929] = {
    [sym_concatenation] = STATE(2544),
    [sym_string] = STATE(2543),
    [sym_simple_expansion] = STATE(2543),
    [sym_string_expansion] = STATE(2543),
    [sym_expansion] = STATE(2543),
    [sym_command_substitution] = STATE(2543),
    [sym_process_substitution] = STATE(2543),
    [anon_sym_RBRACE] = ACTIONS(5804),
    [sym__special_characters] = ACTIONS(5806),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5808),
  },
  [1930] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5810),
    [sym_comment] = ACTIONS(57),
  },
  [1931] = {
    [sym_concatenation] = STATE(2548),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2548),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5814),
    [anon_sym_DASH] = ACTIONS(5814),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_COLON] = ACTIONS(5814),
    [anon_sym_COLON_QMARK] = ACTIONS(5814),
    [anon_sym_COLON_DASH] = ACTIONS(5814),
    [anon_sym_PERCENT] = ACTIONS(5814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1932] = {
    [sym_concatenation] = STATE(2550),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2550),
    [anon_sym_RBRACE] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_COLON] = ACTIONS(5820),
    [anon_sym_COLON_QMARK] = ACTIONS(5820),
    [anon_sym_COLON_DASH] = ACTIONS(5820),
    [anon_sym_PERCENT] = ACTIONS(5820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1933] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2406),
  },
  [1934] = {
    [sym_concatenation] = STATE(2553),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2553),
    [sym_regex] = ACTIONS(5826),
    [anon_sym_RBRACE] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5830),
    [anon_sym_DASH] = ACTIONS(5830),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5830),
    [anon_sym_COLON_QMARK] = ACTIONS(5830),
    [anon_sym_COLON_DASH] = ACTIONS(5830),
    [anon_sym_PERCENT] = ACTIONS(5830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1935] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1936] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2454),
  },
  [1937] = {
    [sym_concatenation] = STATE(2550),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2550),
    [sym_regex] = ACTIONS(5834),
    [anon_sym_RBRACE] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5820),
    [anon_sym_COLON_QMARK] = ACTIONS(5820),
    [anon_sym_COLON_DASH] = ACTIONS(5820),
    [anon_sym_PERCENT] = ACTIONS(5820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1938] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1939] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1940] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1941] = {
    [sym__simple_heredoc_body] = ACTIONS(5836),
    [sym__heredoc_body_beginning] = ACTIONS(5836),
    [sym_file_descriptor] = ACTIONS(5836),
    [ts_builtin_sym_end] = ACTIONS(5836),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_done] = ACTIONS(5836),
    [anon_sym_fi] = ACTIONS(5836),
    [anon_sym_elif] = ACTIONS(5836),
    [anon_sym_else] = ACTIONS(5836),
    [anon_sym_esac] = ACTIONS(5836),
    [anon_sym_PIPE] = ACTIONS(5838),
    [anon_sym_RPAREN] = ACTIONS(5836),
    [anon_sym_SEMI_SEMI] = ACTIONS(5836),
    [anon_sym_PIPE_AMP] = ACTIONS(5836),
    [anon_sym_AMP_AMP] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5836),
    [anon_sym_LT] = ACTIONS(5838),
    [anon_sym_GT] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5836),
    [anon_sym_AMP_GT] = ACTIONS(5838),
    [anon_sym_AMP_GT_GT] = ACTIONS(5836),
    [anon_sym_LT_AMP] = ACTIONS(5836),
    [anon_sym_GT_AMP] = ACTIONS(5836),
    [anon_sym_LT_LT] = ACTIONS(5838),
    [anon_sym_LT_LT_DASH] = ACTIONS(5836),
    [anon_sym_LT_LT_LT] = ACTIONS(5836),
    [anon_sym_BQUOTE] = ACTIONS(5836),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5836),
    [anon_sym_AMP] = ACTIONS(5838),
  },
  [1942] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4019),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4019),
  },
  [1943] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4033),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4033),
    [anon_sym_LT_EQ] = ACTIONS(4033),
    [anon_sym_GT_EQ] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4033),
    [anon_sym_DASH_DASH] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4033),
  },
  [1944] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(57),
  },
  [1945] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [sym_comment] = ACTIONS(57),
  },
  [1946] = {
    [anon_sym_RBRACE] = ACTIONS(5842),
    [sym_comment] = ACTIONS(57),
  },
  [1947] = {
    [sym_concatenation] = STATE(2559),
    [sym_string] = STATE(2558),
    [sym_simple_expansion] = STATE(2558),
    [sym_string_expansion] = STATE(2558),
    [sym_expansion] = STATE(2558),
    [sym_command_substitution] = STATE(2558),
    [sym_process_substitution] = STATE(2558),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [sym__special_characters] = ACTIONS(5844),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5846),
  },
  [1948] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4069),
    [anon_sym_LT_EQ] = ACTIONS(4069),
    [anon_sym_GT_EQ] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4069),
    [anon_sym_DASH_DASH] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4069),
  },
  [1949] = {
    [sym_concatenation] = STATE(2562),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2562),
    [sym_regex] = ACTIONS(5848),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5852),
    [anon_sym_DASH] = ACTIONS(5852),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5852),
    [anon_sym_COLON_QMARK] = ACTIONS(5852),
    [anon_sym_COLON_DASH] = ACTIONS(5852),
    [anon_sym_PERCENT] = ACTIONS(5852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1950] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1951] = {
    [sym_concatenation] = STATE(2564),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2564),
    [sym_regex] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5860),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5858),
    [anon_sym_COLON_QMARK] = ACTIONS(5858),
    [anon_sym_COLON_DASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1952] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1953] = {
    [sym_concatenation] = STATE(2566),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2566),
    [anon_sym_RBRACE] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5864),
    [anon_sym_COLON_QMARK] = ACTIONS(5864),
    [anon_sym_COLON_DASH] = ACTIONS(5864),
    [anon_sym_PERCENT] = ACTIONS(5864),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1954] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_PLUS_EQ] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DASH_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4125),
  },
  [1955] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1956] = {
    [sym_concatenation] = STATE(2564),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2564),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5860),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5858),
    [anon_sym_COLON_QMARK] = ACTIONS(5858),
    [anon_sym_COLON_DASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1957] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5543),
    [anon_sym_EQ_EQ] = ACTIONS(5543),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_PLUS_EQ] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_BANG_EQ] = ACTIONS(5543),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_DASH_EQ] = ACTIONS(5543),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_PLUS_PLUS] = ACTIONS(5543),
    [anon_sym_DASH_DASH] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5543),
  },
  [1958] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5551),
    [anon_sym_EQ_EQ] = ACTIONS(5551),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_PLUS_EQ] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_BANG_EQ] = ACTIONS(5551),
    [anon_sym_PLUS] = ACTIONS(5553),
    [anon_sym_DASH] = ACTIONS(5553),
    [anon_sym_DASH_EQ] = ACTIONS(5551),
    [anon_sym_LT_EQ] = ACTIONS(5551),
    [anon_sym_GT_EQ] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5551),
  },
  [1959] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5868),
    [sym_comment] = ACTIONS(57),
  },
  [1960] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [sym_comment] = ACTIONS(57),
  },
  [1961] = {
    [anon_sym_RBRACE] = ACTIONS(5870),
    [sym_comment] = ACTIONS(57),
  },
  [1962] = {
    [sym_concatenation] = STATE(2570),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2570),
    [anon_sym_RBRACE] = ACTIONS(5872),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5874),
    [anon_sym_COLON_QMARK] = ACTIONS(5874),
    [anon_sym_COLON_DASH] = ACTIONS(5874),
    [anon_sym_PERCENT] = ACTIONS(5874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1963] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5595),
    [anon_sym_EQ_EQ] = ACTIONS(5595),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_PLUS_EQ] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_BANG_EQ] = ACTIONS(5595),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_DASH_EQ] = ACTIONS(5595),
    [anon_sym_LT_EQ] = ACTIONS(5595),
    [anon_sym_GT_EQ] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(5595),
    [anon_sym_DASH_DASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5595),
  },
  [1964] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5872),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1965] = {
    [sym_concatenation] = STATE(2571),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2571),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5878),
    [anon_sym_COLON_QMARK] = ACTIONS(5878),
    [anon_sym_COLON_DASH] = ACTIONS(5878),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1966] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1967] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_PLUS_EQ] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_DASH_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5640),
  },
  [1968] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1969] = {
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [1970] = {
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1971] = {
    [aux_sym_concatenation_repeat1] = STATE(1971),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(5884),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [1972] = {
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [1973] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [1974] = {
    [sym_concatenation] = STATE(2577),
    [sym_string] = STATE(2576),
    [sym_simple_expansion] = STATE(2576),
    [sym_string_expansion] = STATE(2576),
    [sym_expansion] = STATE(2576),
    [sym_command_substitution] = STATE(2576),
    [sym_process_substitution] = STATE(2576),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [sym__special_characters] = ACTIONS(5891),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5893),
  },
  [1975] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(5895),
    [sym_comment] = ACTIONS(57),
  },
  [1976] = {
    [sym_concatenation] = STATE(2581),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2581),
    [anon_sym_RBRACE] = ACTIONS(5897),
    [anon_sym_EQ] = ACTIONS(5899),
    [anon_sym_DASH] = ACTIONS(5899),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5903),
    [anon_sym_COLON] = ACTIONS(5899),
    [anon_sym_COLON_QMARK] = ACTIONS(5899),
    [anon_sym_COLON_DASH] = ACTIONS(5899),
    [anon_sym_PERCENT] = ACTIONS(5899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1977] = {
    [sym_concatenation] = STATE(2583),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2583),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_EQ] = ACTIONS(5905),
    [anon_sym_DASH] = ACTIONS(5905),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(5909),
    [anon_sym_COLON] = ACTIONS(5905),
    [anon_sym_COLON_QMARK] = ACTIONS(5905),
    [anon_sym_COLON_DASH] = ACTIONS(5905),
    [anon_sym_PERCENT] = ACTIONS(5905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1978] = {
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [1979] = {
    [sym_concatenation] = STATE(2586),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2586),
    [sym_regex] = ACTIONS(5911),
    [anon_sym_RBRACE] = ACTIONS(5913),
    [anon_sym_EQ] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5915),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5915),
    [anon_sym_COLON_QMARK] = ACTIONS(5915),
    [anon_sym_COLON_DASH] = ACTIONS(5915),
    [anon_sym_PERCENT] = ACTIONS(5915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1980] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5913),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1981] = {
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [1982] = {
    [sym_concatenation] = STATE(2583),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2583),
    [sym_regex] = ACTIONS(5919),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_EQ] = ACTIONS(5905),
    [anon_sym_DASH] = ACTIONS(5905),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5905),
    [anon_sym_COLON_QMARK] = ACTIONS(5905),
    [anon_sym_COLON_DASH] = ACTIONS(5905),
    [anon_sym_PERCENT] = ACTIONS(5905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1983] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [1984] = {
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [1985] = {
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [1986] = {
    [sym_do_group] = STATE(2589),
    [sym_compound_statement] = STATE(2589),
    [anon_sym_SEMI] = ACTIONS(5921),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [1987] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [1988] = {
    [sym__expression] = STATE(2591),
    [sym_binary_expression] = STATE(2591),
    [sym_unary_expression] = STATE(2591),
    [sym_postfix_expression] = STATE(2591),
    [sym_parenthesized_expression] = STATE(2591),
    [sym_concatenation] = STATE(2591),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5923),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1989] = {
    [anon_sym_SEMI] = ACTIONS(5925),
    [anon_sym_SEMI_SEMI] = ACTIONS(5927),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(5927),
    [anon_sym_AMP] = ACTIONS(5925),
  },
  [1990] = {
    [sym_do_group] = STATE(2593),
    [anon_sym_do] = ACTIONS(1605),
    [sym_comment] = ACTIONS(57),
  },
  [1991] = {
    [sym_file_descriptor] = ACTIONS(4872),
    [anon_sym_SEMI] = ACTIONS(4874),
    [anon_sym_PIPE] = ACTIONS(4874),
    [anon_sym_SEMI_SEMI] = ACTIONS(4872),
    [anon_sym_PIPE_AMP] = ACTIONS(4872),
    [anon_sym_AMP_AMP] = ACTIONS(4872),
    [anon_sym_PIPE_PIPE] = ACTIONS(4872),
    [anon_sym_LT] = ACTIONS(4874),
    [anon_sym_GT] = ACTIONS(4874),
    [anon_sym_GT_GT] = ACTIONS(4872),
    [anon_sym_AMP_GT] = ACTIONS(4874),
    [anon_sym_AMP_GT_GT] = ACTIONS(4872),
    [anon_sym_LT_AMP] = ACTIONS(4872),
    [anon_sym_GT_AMP] = ACTIONS(4872),
    [anon_sym_LT_LT] = ACTIONS(4874),
    [anon_sym_LT_LT_DASH] = ACTIONS(4872),
    [anon_sym_LT_LT_LT] = ACTIONS(4872),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4872),
    [anon_sym_AMP] = ACTIONS(4874),
  },
  [1992] = {
    [sym_file_descriptor] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5128),
    [anon_sym_PIPE] = ACTIONS(5128),
    [anon_sym_SEMI_SEMI] = ACTIONS(5126),
    [anon_sym_PIPE_AMP] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_LT] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5126),
    [anon_sym_AMP_GT] = ACTIONS(5128),
    [anon_sym_AMP_GT_GT] = ACTIONS(5126),
    [anon_sym_LT_AMP] = ACTIONS(5126),
    [anon_sym_GT_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_LT_LT_DASH] = ACTIONS(5126),
    [anon_sym_LT_LT_LT] = ACTIONS(5126),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5126),
    [anon_sym_AMP] = ACTIONS(5128),
  },
  [1993] = {
    [anon_sym_fi] = ACTIONS(5929),
    [sym_comment] = ACTIONS(57),
  },
  [1994] = {
    [sym_elif_clause] = STATE(1582),
    [sym_else_clause] = STATE(2595),
    [aux_sym_if_statement_repeat1] = STATE(1582),
    [anon_sym_fi] = ACTIONS(5929),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [1995] = {
    [sym_file_descriptor] = ACTIONS(5163),
    [anon_sym_SEMI] = ACTIONS(5165),
    [anon_sym_PIPE] = ACTIONS(5165),
    [anon_sym_SEMI_SEMI] = ACTIONS(5163),
    [anon_sym_PIPE_AMP] = ACTIONS(5163),
    [anon_sym_AMP_AMP] = ACTIONS(5163),
    [anon_sym_PIPE_PIPE] = ACTIONS(5163),
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_GT_GT] = ACTIONS(5163),
    [anon_sym_AMP_GT] = ACTIONS(5165),
    [anon_sym_AMP_GT_GT] = ACTIONS(5163),
    [anon_sym_LT_AMP] = ACTIONS(5163),
    [anon_sym_GT_AMP] = ACTIONS(5163),
    [anon_sym_LT_LT] = ACTIONS(5165),
    [anon_sym_LT_LT_DASH] = ACTIONS(5163),
    [anon_sym_LT_LT_LT] = ACTIONS(5163),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5163),
    [anon_sym_AMP] = ACTIONS(5165),
  },
  [1996] = {
    [anon_sym_esac] = ACTIONS(5931),
    [sym_comment] = ACTIONS(57),
  },
  [1997] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(2597),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [1998] = {
    [sym_case_item] = STATE(2598),
    [sym_last_case_item] = STATE(2597),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2598),
    [anon_sym_esac] = ACTIONS(5933),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [1999] = {
    [sym_file_descriptor] = ACTIONS(5177),
    [anon_sym_SEMI] = ACTIONS(5179),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_SEMI_SEMI] = ACTIONS(5177),
    [anon_sym_PIPE_AMP] = ACTIONS(5177),
    [anon_sym_AMP_AMP] = ACTIONS(5177),
    [anon_sym_PIPE_PIPE] = ACTIONS(5177),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5177),
    [anon_sym_AMP_GT] = ACTIONS(5179),
    [anon_sym_AMP_GT_GT] = ACTIONS(5177),
    [anon_sym_LT_AMP] = ACTIONS(5177),
    [anon_sym_GT_AMP] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5177),
    [anon_sym_LT_LT_LT] = ACTIONS(5177),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5177),
    [anon_sym_AMP] = ACTIONS(5179),
  },
  [2000] = {
    [anon_sym_esac] = ACTIONS(5935),
    [sym_comment] = ACTIONS(57),
  },
  [2001] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(2600),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2002] = {
    [sym_case_item] = STATE(2601),
    [sym_last_case_item] = STATE(2600),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2601),
    [anon_sym_esac] = ACTIONS(5937),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [2003] = {
    [sym_file_descriptor] = ACTIONS(5213),
    [anon_sym_SEMI] = ACTIONS(5215),
    [anon_sym_PIPE] = ACTIONS(5215),
    [anon_sym_SEMI_SEMI] = ACTIONS(5213),
    [anon_sym_PIPE_AMP] = ACTIONS(5213),
    [anon_sym_AMP_AMP] = ACTIONS(5213),
    [anon_sym_PIPE_PIPE] = ACTIONS(5213),
    [anon_sym_LT] = ACTIONS(5215),
    [anon_sym_GT] = ACTIONS(5215),
    [anon_sym_GT_GT] = ACTIONS(5213),
    [anon_sym_AMP_GT] = ACTIONS(5215),
    [anon_sym_AMP_GT_GT] = ACTIONS(5213),
    [anon_sym_LT_AMP] = ACTIONS(5213),
    [anon_sym_GT_AMP] = ACTIONS(5213),
    [anon_sym_LT_LT] = ACTIONS(5215),
    [anon_sym_LT_LT_DASH] = ACTIONS(5213),
    [anon_sym_LT_LT_LT] = ACTIONS(5213),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5213),
    [anon_sym_AMP] = ACTIONS(5215),
  },
  [2004] = {
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2666),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [2005] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2006] = {
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [2007] = {
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [2008] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5941),
    [sym_comment] = ACTIONS(57),
  },
  [2009] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [sym_comment] = ACTIONS(57),
  },
  [2010] = {
    [anon_sym_RBRACE] = ACTIONS(5943),
    [sym_comment] = ACTIONS(57),
  },
  [2011] = {
    [sym_concatenation] = STATE(2607),
    [sym_string] = STATE(2606),
    [sym_simple_expansion] = STATE(2606),
    [sym_string_expansion] = STATE(2606),
    [sym_expansion] = STATE(2606),
    [sym_command_substitution] = STATE(2606),
    [sym_process_substitution] = STATE(2606),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [sym__special_characters] = ACTIONS(5945),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5947),
  },
  [2012] = {
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2013] = {
    [sym_concatenation] = STATE(2610),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2610),
    [sym_regex] = ACTIONS(5949),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_DASH] = ACTIONS(5953),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_COLON_QMARK] = ACTIONS(5953),
    [anon_sym_COLON_DASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2014] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2015] = {
    [sym_concatenation] = STATE(2612),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2612),
    [sym_regex] = ACTIONS(5957),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5959),
    [anon_sym_COLON_QMARK] = ACTIONS(5959),
    [anon_sym_COLON_DASH] = ACTIONS(5959),
    [anon_sym_PERCENT] = ACTIONS(5959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2016] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2017] = {
    [sym_concatenation] = STATE(2614),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2614),
    [anon_sym_RBRACE] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(5965),
    [anon_sym_DASH] = ACTIONS(5965),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5965),
    [anon_sym_COLON_QMARK] = ACTIONS(5965),
    [anon_sym_COLON_DASH] = ACTIONS(5965),
    [anon_sym_PERCENT] = ACTIONS(5965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2018] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2019] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2020] = {
    [sym_concatenation] = STATE(2612),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2612),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5959),
    [anon_sym_COLON_QMARK] = ACTIONS(5959),
    [anon_sym_COLON_DASH] = ACTIONS(5959),
    [anon_sym_PERCENT] = ACTIONS(5959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2021] = {
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [2022] = {
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [2023] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5969),
    [sym_comment] = ACTIONS(57),
  },
  [2024] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5971),
    [sym_comment] = ACTIONS(57),
  },
  [2025] = {
    [anon_sym_RBRACE] = ACTIONS(5971),
    [sym_comment] = ACTIONS(57),
  },
  [2026] = {
    [sym_concatenation] = STATE(2619),
    [sym_string] = STATE(2618),
    [sym_simple_expansion] = STATE(2618),
    [sym_string_expansion] = STATE(2618),
    [sym_expansion] = STATE(2618),
    [sym_command_substitution] = STATE(2618),
    [sym_process_substitution] = STATE(2618),
    [anon_sym_RBRACE] = ACTIONS(5971),
    [sym__special_characters] = ACTIONS(5973),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(5975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5975),
  },
  [2027] = {
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2028] = {
    [sym_concatenation] = STATE(2622),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2622),
    [sym_regex] = ACTIONS(5977),
    [anon_sym_RBRACE] = ACTIONS(5979),
    [anon_sym_EQ] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(5981),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5981),
    [anon_sym_COLON_QMARK] = ACTIONS(5981),
    [anon_sym_COLON_DASH] = ACTIONS(5981),
    [anon_sym_PERCENT] = ACTIONS(5981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2029] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5979),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2030] = {
    [sym_concatenation] = STATE(2624),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2624),
    [sym_regex] = ACTIONS(5985),
    [anon_sym_RBRACE] = ACTIONS(5971),
    [anon_sym_EQ] = ACTIONS(5987),
    [anon_sym_DASH] = ACTIONS(5987),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_COLON_QMARK] = ACTIONS(5987),
    [anon_sym_COLON_DASH] = ACTIONS(5987),
    [anon_sym_PERCENT] = ACTIONS(5987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2031] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5971),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2032] = {
    [sym_concatenation] = STATE(2626),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2626),
    [anon_sym_RBRACE] = ACTIONS(5991),
    [anon_sym_EQ] = ACTIONS(5993),
    [anon_sym_DASH] = ACTIONS(5993),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5993),
    [anon_sym_COLON_QMARK] = ACTIONS(5993),
    [anon_sym_COLON_DASH] = ACTIONS(5993),
    [anon_sym_PERCENT] = ACTIONS(5993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2033] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2034] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5991),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2035] = {
    [sym_concatenation] = STATE(2624),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2624),
    [anon_sym_RBRACE] = ACTIONS(5971),
    [anon_sym_EQ] = ACTIONS(5987),
    [anon_sym_DASH] = ACTIONS(5987),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(5989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_COLON_QMARK] = ACTIONS(5987),
    [anon_sym_COLON_DASH] = ACTIONS(5987),
    [anon_sym_PERCENT] = ACTIONS(5987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2036] = {
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2037] = {
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2038] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5997),
    [sym_comment] = ACTIONS(57),
  },
  [2039] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(5999),
    [sym_comment] = ACTIONS(57),
  },
  [2040] = {
    [anon_sym_RBRACE] = ACTIONS(5999),
    [sym_comment] = ACTIONS(57),
  },
  [2041] = {
    [sym_concatenation] = STATE(2630),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2630),
    [anon_sym_RBRACE] = ACTIONS(6001),
    [anon_sym_EQ] = ACTIONS(6003),
    [anon_sym_DASH] = ACTIONS(6003),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6003),
    [anon_sym_COLON_QMARK] = ACTIONS(6003),
    [anon_sym_COLON_DASH] = ACTIONS(6003),
    [anon_sym_PERCENT] = ACTIONS(6003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2042] = {
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5597),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2043] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6001),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2044] = {
    [sym_concatenation] = STATE(2631),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2631),
    [anon_sym_RBRACE] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(6007),
    [anon_sym_DASH] = ACTIONS(6007),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6009),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6007),
    [anon_sym_COLON_QMARK] = ACTIONS(6007),
    [anon_sym_COLON_DASH] = ACTIONS(6007),
    [anon_sym_PERCENT] = ACTIONS(6007),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2045] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2046] = {
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2047] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6011),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2048] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_done] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2049] = {
    [sym_concatenation] = STATE(2634),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(2634),
    [anon_sym_RPAREN] = ACTIONS(6013),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2050] = {
    [aux_sym_concatenation_repeat1] = STATE(2636),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(6015),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_done] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [2051] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2639),
    [anon_sym_DQUOTE] = ACTIONS(6017),
    [anon_sym_DOLLAR] = ACTIONS(6019),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2052] = {
    [sym_string] = STATE(2641),
    [anon_sym_DASH] = ACTIONS(6021),
    [anon_sym_DQUOTE] = ACTIONS(4768),
    [anon_sym_DOLLAR] = ACTIONS(6021),
    [sym_raw_string] = ACTIONS(6023),
    [anon_sym_POUND] = ACTIONS(6021),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6025),
    [anon_sym_STAR] = ACTIONS(6027),
    [anon_sym_AT] = ACTIONS(6027),
    [anon_sym_QMARK] = ACTIONS(6027),
    [anon_sym_0] = ACTIONS(6025),
    [anon_sym__] = ACTIONS(6025),
  },
  [2053] = {
    [aux_sym_concatenation_repeat1] = STATE(2636),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(6015),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_done] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2054] = {
    [sym_subscript] = STATE(2646),
    [sym_variable_name] = ACTIONS(6029),
    [anon_sym_BANG] = ACTIONS(6031),
    [anon_sym_DASH] = ACTIONS(6033),
    [anon_sym_DOLLAR] = ACTIONS(6033),
    [anon_sym_POUND] = ACTIONS(6031),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6035),
    [anon_sym_STAR] = ACTIONS(6037),
    [anon_sym_AT] = ACTIONS(6037),
    [anon_sym_QMARK] = ACTIONS(6037),
    [anon_sym_0] = ACTIONS(6035),
    [anon_sym__] = ACTIONS(6035),
  },
  [2055] = {
    [sym__statements] = STATE(2647),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2648),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2056] = {
    [sym__statements] = STATE(2649),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2057] = {
    [sym__statements] = STATE(2650),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2058] = {
    [sym_concatenation] = STATE(2651),
    [sym_string] = STATE(2654),
    [sym_array] = STATE(2651),
    [sym_simple_expansion] = STATE(2654),
    [sym_string_expansion] = STATE(2654),
    [sym_expansion] = STATE(2654),
    [sym_command_substitution] = STATE(2654),
    [sym_process_substitution] = STATE(2654),
    [sym__empty_value] = ACTIONS(6039),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [sym__special_characters] = ACTIONS(6043),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(3149),
    [sym_raw_string] = ACTIONS(6045),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3155),
    [anon_sym_BQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LPAREN] = ACTIONS(3159),
    [anon_sym_GT_LPAREN] = ACTIONS(3159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6045),
  },
  [2059] = {
    [sym_string] = STATE(2655),
    [sym_simple_expansion] = STATE(2655),
    [sym_string_expansion] = STATE(2655),
    [sym_expansion] = STATE(2655),
    [sym_command_substitution] = STATE(2655),
    [sym_process_substitution] = STATE(2655),
    [sym__special_characters] = ACTIONS(6047),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(3149),
    [sym_raw_string] = ACTIONS(6047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3155),
    [anon_sym_BQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LPAREN] = ACTIONS(3159),
    [anon_sym_GT_LPAREN] = ACTIONS(3159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6047),
  },
  [2060] = {
    [aux_sym_concatenation_repeat1] = STATE(2656),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(4784),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_done] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2061] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_done] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2062] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(6049),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2063] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(6049),
    [anon_sym_DOLLAR] = ACTIONS(6051),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2064] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_done] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2065] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_done] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2066] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_done] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2067] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(6053),
    [sym_comment] = ACTIONS(57),
  },
  [2068] = {
    [sym_subscript] = STATE(2662),
    [sym_variable_name] = ACTIONS(6055),
    [anon_sym_DASH] = ACTIONS(6057),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6061),
    [anon_sym_AT] = ACTIONS(6061),
    [anon_sym_QMARK] = ACTIONS(6061),
    [anon_sym_0] = ACTIONS(6059),
    [anon_sym__] = ACTIONS(6059),
  },
  [2069] = {
    [sym_concatenation] = STATE(2665),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2665),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(6065),
    [anon_sym_DASH] = ACTIONS(6065),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_COLON_QMARK] = ACTIONS(6065),
    [anon_sym_COLON_DASH] = ACTIONS(6065),
    [anon_sym_PERCENT] = ACTIONS(6065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2070] = {
    [sym_concatenation] = STATE(2668),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2668),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6073),
    [anon_sym_DASH] = ACTIONS(6073),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6075),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6073),
    [anon_sym_COLON_QMARK] = ACTIONS(6073),
    [anon_sym_COLON_DASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2071] = {
    [anon_sym_RPAREN] = ACTIONS(6079),
    [sym_comment] = ACTIONS(57),
  },
  [2072] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2073] = {
    [anon_sym_BQUOTE] = ACTIONS(6079),
    [sym_comment] = ACTIONS(57),
  },
  [2074] = {
    [anon_sym_RPAREN] = ACTIONS(6081),
    [sym_comment] = ACTIONS(57),
  },
  [2075] = {
    [sym_variable_assignment] = STATE(2075),
    [sym_subscript] = STATE(1459),
    [sym_concatenation] = STATE(2075),
    [sym_string] = STATE(1454),
    [sym_simple_expansion] = STATE(1454),
    [sym_string_expansion] = STATE(1454),
    [sym_expansion] = STATE(1454),
    [sym_command_substitution] = STATE(1454),
    [sym_process_substitution] = STATE(1454),
    [aux_sym_declaration_command_repeat1] = STATE(2075),
    [sym__simple_heredoc_body] = ACTIONS(2163),
    [sym__heredoc_body_beginning] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(6083),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_done] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(6086),
    [anon_sym_DQUOTE] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6092),
    [sym_raw_string] = ACTIONS(6095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6101),
    [anon_sym_BQUOTE] = ACTIONS(6104),
    [anon_sym_LT_LPAREN] = ACTIONS(6107),
    [anon_sym_GT_LPAREN] = ACTIONS(6107),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6110),
    [sym_word] = ACTIONS(6113),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [2076] = {
    [sym_string] = STATE(2671),
    [sym_simple_expansion] = STATE(2671),
    [sym_string_expansion] = STATE(2671),
    [sym_expansion] = STATE(2671),
    [sym_command_substitution] = STATE(2671),
    [sym_process_substitution] = STATE(2671),
    [sym__special_characters] = ACTIONS(6116),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_DOLLAR] = ACTIONS(3169),
    [sym_raw_string] = ACTIONS(6116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3175),
    [anon_sym_BQUOTE] = ACTIONS(3177),
    [anon_sym_LT_LPAREN] = ACTIONS(3179),
    [anon_sym_GT_LPAREN] = ACTIONS(3179),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6116),
  },
  [2077] = {
    [aux_sym_concatenation_repeat1] = STATE(2672),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(4810),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_done] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2078] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_done] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2079] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(6118),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2080] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(6118),
    [anon_sym_DOLLAR] = ACTIONS(6120),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2081] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_done] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2082] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_done] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2083] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_done] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2084] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(6122),
    [sym_comment] = ACTIONS(57),
  },
  [2085] = {
    [sym_subscript] = STATE(2678),
    [sym_variable_name] = ACTIONS(6124),
    [anon_sym_DASH] = ACTIONS(6126),
    [anon_sym_DOLLAR] = ACTIONS(6126),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6128),
    [anon_sym_STAR] = ACTIONS(6130),
    [anon_sym_AT] = ACTIONS(6130),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_0] = ACTIONS(6128),
    [anon_sym__] = ACTIONS(6128),
  },
  [2086] = {
    [sym_concatenation] = STATE(2681),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2681),
    [anon_sym_RBRACE] = ACTIONS(6132),
    [anon_sym_EQ] = ACTIONS(6134),
    [anon_sym_DASH] = ACTIONS(6134),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6138),
    [anon_sym_COLON] = ACTIONS(6134),
    [anon_sym_COLON_QMARK] = ACTIONS(6134),
    [anon_sym_COLON_DASH] = ACTIONS(6134),
    [anon_sym_PERCENT] = ACTIONS(6134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2087] = {
    [sym_concatenation] = STATE(2684),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2684),
    [anon_sym_RBRACE] = ACTIONS(6140),
    [anon_sym_EQ] = ACTIONS(6142),
    [anon_sym_DASH] = ACTIONS(6142),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_COLON] = ACTIONS(6142),
    [anon_sym_COLON_QMARK] = ACTIONS(6142),
    [anon_sym_COLON_DASH] = ACTIONS(6142),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2088] = {
    [anon_sym_RPAREN] = ACTIONS(6148),
    [sym_comment] = ACTIONS(57),
  },
  [2089] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6148),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2090] = {
    [anon_sym_BQUOTE] = ACTIONS(6148),
    [sym_comment] = ACTIONS(57),
  },
  [2091] = {
    [anon_sym_RPAREN] = ACTIONS(6150),
    [sym_comment] = ACTIONS(57),
  },
  [2092] = {
    [sym_concatenation] = STATE(2092),
    [sym_string] = STATE(1464),
    [sym_simple_expansion] = STATE(1464),
    [sym_string_expansion] = STATE(1464),
    [sym_expansion] = STATE(1464),
    [sym_command_substitution] = STATE(1464),
    [sym_process_substitution] = STATE(1464),
    [aux_sym_unset_command_repeat1] = STATE(2092),
    [sym__simple_heredoc_body] = ACTIONS(2236),
    [sym__heredoc_body_beginning] = ACTIONS(2236),
    [sym_file_descriptor] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_done] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(6152),
    [anon_sym_DQUOTE] = ACTIONS(6155),
    [anon_sym_DOLLAR] = ACTIONS(6158),
    [sym_raw_string] = ACTIONS(6161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6167),
    [anon_sym_BQUOTE] = ACTIONS(6170),
    [anon_sym_LT_LPAREN] = ACTIONS(6173),
    [anon_sym_GT_LPAREN] = ACTIONS(6173),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6176),
    [sym_word] = ACTIONS(6179),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [2093] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2094] = {
    [aux_sym_concatenation_repeat1] = STATE(2094),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(6182),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2095] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_done] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [2096] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(6185),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2097] = {
    [sym_concatenation] = STATE(2691),
    [sym_string] = STATE(2690),
    [sym_simple_expansion] = STATE(2690),
    [sym_string_expansion] = STATE(2690),
    [sym_expansion] = STATE(2690),
    [sym_command_substitution] = STATE(2690),
    [sym_process_substitution] = STATE(2690),
    [anon_sym_RBRACE] = ACTIONS(6187),
    [sym__special_characters] = ACTIONS(6189),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(6191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6191),
  },
  [2098] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(6193),
    [sym_comment] = ACTIONS(57),
  },
  [2099] = {
    [sym_concatenation] = STATE(2695),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2695),
    [anon_sym_RBRACE] = ACTIONS(6195),
    [anon_sym_EQ] = ACTIONS(6197),
    [anon_sym_DASH] = ACTIONS(6197),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6201),
    [anon_sym_COLON] = ACTIONS(6197),
    [anon_sym_COLON_QMARK] = ACTIONS(6197),
    [anon_sym_COLON_DASH] = ACTIONS(6197),
    [anon_sym_PERCENT] = ACTIONS(6197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2100] = {
    [sym_concatenation] = STATE(2697),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2697),
    [anon_sym_RBRACE] = ACTIONS(6187),
    [anon_sym_EQ] = ACTIONS(6203),
    [anon_sym_DASH] = ACTIONS(6203),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6207),
    [anon_sym_COLON] = ACTIONS(6203),
    [anon_sym_COLON_QMARK] = ACTIONS(6203),
    [anon_sym_COLON_DASH] = ACTIONS(6203),
    [anon_sym_PERCENT] = ACTIONS(6203),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2101] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_done] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [2102] = {
    [sym_concatenation] = STATE(2700),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2700),
    [sym_regex] = ACTIONS(6209),
    [anon_sym_RBRACE] = ACTIONS(6211),
    [anon_sym_EQ] = ACTIONS(6213),
    [anon_sym_DASH] = ACTIONS(6213),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6213),
    [anon_sym_COLON_QMARK] = ACTIONS(6213),
    [anon_sym_COLON_DASH] = ACTIONS(6213),
    [anon_sym_PERCENT] = ACTIONS(6213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2103] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6211),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2104] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_done] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [2105] = {
    [sym_concatenation] = STATE(2697),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2697),
    [sym_regex] = ACTIONS(6217),
    [anon_sym_RBRACE] = ACTIONS(6187),
    [anon_sym_EQ] = ACTIONS(6203),
    [anon_sym_DASH] = ACTIONS(6203),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6203),
    [anon_sym_COLON_QMARK] = ACTIONS(6203),
    [anon_sym_COLON_DASH] = ACTIONS(6203),
    [anon_sym_PERCENT] = ACTIONS(6203),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2106] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6187),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2107] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_done] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [2108] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_done] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2504),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [2109] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(2703),
    [sym_simple_expansion] = STATE(2703),
    [sym_string_expansion] = STATE(2703),
    [sym_expansion] = STATE(2703),
    [sym_command_substitution] = STATE(2703),
    [sym_process_substitution] = STATE(2703),
    [sym__special_characters] = ACTIONS(6219),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(6221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6221),
  },
  [2110] = {
    [sym_file_redirect] = STATE(1494),
    [sym_heredoc_redirect] = STATE(1494),
    [sym_herestring_redirect] = STATE(1494),
    [aux_sym_redirected_statement_repeat1] = STATE(1494),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_done] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2111] = {
    [sym_file_redirect] = STATE(1494),
    [sym_heredoc_redirect] = STATE(1494),
    [sym_herestring_redirect] = STATE(1494),
    [aux_sym_redirected_statement_repeat1] = STATE(1494),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_done] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2112] = {
    [sym_file_redirect] = STATE(1494),
    [sym_heredoc_redirect] = STATE(1494),
    [sym_herestring_redirect] = STATE(1494),
    [aux_sym_redirected_statement_repeat1] = STATE(1494),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_done] = ACTIONS(2538),
    [anon_sym_PIPE] = ACTIONS(3215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(3219),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [2113] = {
    [sym_file_redirect] = STATE(1494),
    [sym_heredoc_redirect] = STATE(1494),
    [sym_herestring_redirect] = STATE(1494),
    [aux_sym_redirected_statement_repeat1] = STATE(1494),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_done] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(3215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(3219),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [2114] = {
    [aux_sym_concatenation_repeat1] = STATE(2705),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_done] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [2115] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2708),
    [anon_sym_DQUOTE] = ACTIONS(6225),
    [anon_sym_DOLLAR] = ACTIONS(6227),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2116] = {
    [sym_string] = STATE(2710),
    [anon_sym_DASH] = ACTIONS(6229),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(6229),
    [sym_raw_string] = ACTIONS(6231),
    [anon_sym_POUND] = ACTIONS(6229),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6233),
    [anon_sym_STAR] = ACTIONS(6235),
    [anon_sym_AT] = ACTIONS(6235),
    [anon_sym_QMARK] = ACTIONS(6235),
    [anon_sym_0] = ACTIONS(6233),
    [anon_sym__] = ACTIONS(6233),
  },
  [2117] = {
    [aux_sym_concatenation_repeat1] = STATE(2705),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_done] = ACTIONS(1033),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [2118] = {
    [sym_subscript] = STATE(2715),
    [sym_variable_name] = ACTIONS(6237),
    [anon_sym_BANG] = ACTIONS(6239),
    [anon_sym_DASH] = ACTIONS(6241),
    [anon_sym_DOLLAR] = ACTIONS(6241),
    [anon_sym_POUND] = ACTIONS(6239),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6243),
    [anon_sym_STAR] = ACTIONS(6245),
    [anon_sym_AT] = ACTIONS(6245),
    [anon_sym_QMARK] = ACTIONS(6245),
    [anon_sym_0] = ACTIONS(6243),
    [anon_sym__] = ACTIONS(6243),
  },
  [2119] = {
    [sym__statements] = STATE(2716),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2717),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2120] = {
    [sym__statements] = STATE(2718),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2121] = {
    [sym__statements] = STATE(2719),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2122] = {
    [aux_sym_concatenation_repeat1] = STATE(2705),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_done] = ACTIONS(2546),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [2123] = {
    [aux_sym_concatenation_repeat1] = STATE(2705),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_done] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [2124] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_done] = ACTIONS(6247),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [2125] = {
    [sym_file_redirect] = STATE(2125),
    [sym_heredoc_redirect] = STATE(2125),
    [sym_herestring_redirect] = STATE(2125),
    [aux_sym_redirected_statement_repeat1] = STATE(2125),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(6249),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_done] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_GT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6255),
    [anon_sym_AMP_GT] = ACTIONS(6252),
    [anon_sym_AMP_GT_GT] = ACTIONS(6255),
    [anon_sym_LT_AMP] = ACTIONS(6255),
    [anon_sym_GT_AMP] = ACTIONS(6255),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(6258),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [2126] = {
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_done] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2127] = {
    [aux_sym_concatenation_repeat1] = STATE(1471),
    [sym__simple_heredoc_body] = ACTIONS(2586),
    [sym__heredoc_body_beginning] = ACTIONS(2586),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_done] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [2128] = {
    [aux_sym_concatenation_repeat1] = STATE(1471),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_done] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2129] = {
    [sym_concatenation] = STATE(2129),
    [sym_string] = STATE(1497),
    [sym_simple_expansion] = STATE(1497),
    [sym_string_expansion] = STATE(1497),
    [sym_expansion] = STATE(1497),
    [sym_command_substitution] = STATE(1497),
    [sym_process_substitution] = STATE(1497),
    [aux_sym_command_repeat2] = STATE(2129),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_done] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(6261),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(6264),
    [anon_sym_DQUOTE] = ACTIONS(6267),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [sym_raw_string] = ACTIONS(6273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6279),
    [anon_sym_BQUOTE] = ACTIONS(6282),
    [anon_sym_LT_LPAREN] = ACTIONS(6285),
    [anon_sym_GT_LPAREN] = ACTIONS(6285),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6288),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2130] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_done] = ACTIONS(6247),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [2131] = {
    [anon_sym_SEMI] = ACTIONS(6291),
    [anon_sym_done] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(6293),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6293),
    [anon_sym_AMP] = ACTIONS(6293),
  },
  [2132] = {
    [sym_concatenation] = STATE(2129),
    [sym_string] = STATE(1497),
    [sym_simple_expansion] = STATE(1497),
    [sym_string_expansion] = STATE(1497),
    [sym_expansion] = STATE(1497),
    [sym_command_substitution] = STATE(1497),
    [sym_process_substitution] = STATE(1497),
    [aux_sym_command_repeat2] = STATE(2129),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_done] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(3229),
    [anon_sym_EQ_EQ] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(3233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_LT_LPAREN] = ACTIONS(1743),
    [anon_sym_GT_LPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3235),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [2133] = {
    [aux_sym_concatenation_repeat1] = STATE(2133),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2134] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_fi] = ACTIONS(1387),
    [anon_sym_elif] = ACTIONS(1387),
    [anon_sym_else] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2135] = {
    [sym_concatenation] = STATE(2722),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(2722),
    [anon_sym_RPAREN] = ACTIONS(6295),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2136] = {
    [aux_sym_concatenation_repeat1] = STATE(2724),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(6297),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_fi] = ACTIONS(1411),
    [anon_sym_elif] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [2137] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2727),
    [anon_sym_DQUOTE] = ACTIONS(6299),
    [anon_sym_DOLLAR] = ACTIONS(6301),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2138] = {
    [sym_string] = STATE(2729),
    [anon_sym_DASH] = ACTIONS(6303),
    [anon_sym_DQUOTE] = ACTIONS(4922),
    [anon_sym_DOLLAR] = ACTIONS(6303),
    [sym_raw_string] = ACTIONS(6305),
    [anon_sym_POUND] = ACTIONS(6303),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6307),
    [anon_sym_STAR] = ACTIONS(6309),
    [anon_sym_AT] = ACTIONS(6309),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_0] = ACTIONS(6307),
    [anon_sym__] = ACTIONS(6307),
  },
  [2139] = {
    [aux_sym_concatenation_repeat1] = STATE(2724),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(6297),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_fi] = ACTIONS(1387),
    [anon_sym_elif] = ACTIONS(1387),
    [anon_sym_else] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2140] = {
    [sym_subscript] = STATE(2734),
    [sym_variable_name] = ACTIONS(6311),
    [anon_sym_BANG] = ACTIONS(6313),
    [anon_sym_DASH] = ACTIONS(6315),
    [anon_sym_DOLLAR] = ACTIONS(6315),
    [anon_sym_POUND] = ACTIONS(6313),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6317),
    [anon_sym_STAR] = ACTIONS(6319),
    [anon_sym_AT] = ACTIONS(6319),
    [anon_sym_QMARK] = ACTIONS(6319),
    [anon_sym_0] = ACTIONS(6317),
    [anon_sym__] = ACTIONS(6317),
  },
  [2141] = {
    [sym__statements] = STATE(2735),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2736),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2142] = {
    [sym__statements] = STATE(2737),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2143] = {
    [sym__statements] = STATE(2738),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2144] = {
    [sym__statements] = STATE(2739),
    [sym_redirected_statement] = STATE(909),
    [sym_for_statement] = STATE(909),
    [sym_c_style_for_statement] = STATE(909),
    [sym_while_statement] = STATE(909),
    [sym_if_statement] = STATE(909),
    [sym_case_statement] = STATE(909),
    [sym_function_definition] = STATE(909),
    [sym_compound_statement] = STATE(909),
    [sym_subshell] = STATE(909),
    [sym_pipeline] = STATE(909),
    [sym_list] = STATE(909),
    [sym_negated_command] = STATE(909),
    [sym_test_command] = STATE(909),
    [sym_declaration_command] = STATE(909),
    [sym_unset_command] = STATE(909),
    [sym_command] = STATE(909),
    [sym_command_name] = STATE(911),
    [sym_variable_assignment] = STATE(912),
    [sym_subscript] = STATE(913),
    [sym_file_redirect] = STATE(917),
    [sym_concatenation] = STATE(914),
    [sym_string] = STATE(902),
    [sym_simple_expansion] = STATE(902),
    [sym_string_expansion] = STATE(902),
    [sym_expansion] = STATE(902),
    [sym_command_substitution] = STATE(902),
    [sym_process_substitution] = STATE(902),
    [aux_sym__statements_repeat1] = STATE(915),
    [aux_sym_command_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(6321),
    [anon_sym_elif] = ACTIONS(6321),
    [anon_sym_else] = ACTIONS(6321),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1783),
    [anon_sym_typeset] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_readonly] = ACTIONS(1783),
    [anon_sym_local] = ACTIONS(1783),
    [anon_sym_unset] = ACTIONS(1785),
    [anon_sym_unsetenv] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1803),
  },
  [2145] = {
    [sym_concatenation] = STATE(2740),
    [sym_string] = STATE(2745),
    [sym_array] = STATE(2740),
    [sym_simple_expansion] = STATE(2745),
    [sym_string_expansion] = STATE(2745),
    [sym_expansion] = STATE(2745),
    [sym_command_substitution] = STATE(2745),
    [sym_process_substitution] = STATE(2745),
    [sym__empty_value] = ACTIONS(6323),
    [anon_sym_LPAREN] = ACTIONS(6325),
    [sym__special_characters] = ACTIONS(6327),
    [anon_sym_DQUOTE] = ACTIONS(6329),
    [anon_sym_DOLLAR] = ACTIONS(6331),
    [sym_raw_string] = ACTIONS(6333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6337),
    [anon_sym_BQUOTE] = ACTIONS(6339),
    [anon_sym_LT_LPAREN] = ACTIONS(6341),
    [anon_sym_GT_LPAREN] = ACTIONS(6341),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6333),
  },
  [2146] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(6343),
    [anon_sym_PLUS_EQ] = ACTIONS(6343),
    [sym_comment] = ACTIONS(57),
  },
  [2147] = {
    [aux_sym_concatenation_repeat1] = STATE(2752),
    [sym__simple_heredoc_body] = ACTIONS(939),
    [sym__heredoc_body_beginning] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(6345),
    [sym_variable_name] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_fi] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [2148] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2755),
    [anon_sym_DQUOTE] = ACTIONS(6347),
    [anon_sym_DOLLAR] = ACTIONS(6349),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2149] = {
    [sym_string] = STATE(2757),
    [anon_sym_DASH] = ACTIONS(6351),
    [anon_sym_DQUOTE] = ACTIONS(4944),
    [anon_sym_DOLLAR] = ACTIONS(6351),
    [sym_raw_string] = ACTIONS(6353),
    [anon_sym_POUND] = ACTIONS(6351),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6355),
    [anon_sym_STAR] = ACTIONS(6357),
    [anon_sym_AT] = ACTIONS(6357),
    [anon_sym_QMARK] = ACTIONS(6357),
    [anon_sym_0] = ACTIONS(6355),
    [anon_sym__] = ACTIONS(6355),
  },
  [2150] = {
    [aux_sym_concatenation_repeat1] = STATE(2752),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(6345),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_fi] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [2151] = {
    [sym_subscript] = STATE(2762),
    [sym_variable_name] = ACTIONS(6359),
    [anon_sym_BANG] = ACTIONS(6361),
    [anon_sym_DASH] = ACTIONS(6363),
    [anon_sym_DOLLAR] = ACTIONS(6363),
    [anon_sym_POUND] = ACTIONS(6361),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6365),
    [anon_sym_STAR] = ACTIONS(6367),
    [anon_sym_AT] = ACTIONS(6367),
    [anon_sym_QMARK] = ACTIONS(6367),
    [anon_sym_0] = ACTIONS(6365),
    [anon_sym__] = ACTIONS(6365),
  },
  [2152] = {
    [sym__statements] = STATE(2763),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2764),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2153] = {
    [sym__statements] = STATE(2765),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2154] = {
    [sym__statements] = STATE(2766),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2155] = {
    [anon_sym_EQ] = ACTIONS(6343),
    [anon_sym_PLUS_EQ] = ACTIONS(6343),
    [sym_comment] = ACTIONS(57),
  },
  [2156] = {
    [sym_variable_assignment] = STATE(2767),
    [sym_subscript] = STATE(2155),
    [sym_concatenation] = STATE(2767),
    [sym_string] = STATE(2150),
    [sym_simple_expansion] = STATE(2150),
    [sym_string_expansion] = STATE(2150),
    [sym_expansion] = STATE(2150),
    [sym_command_substitution] = STATE(2150),
    [sym_process_substitution] = STATE(2150),
    [aux_sym_declaration_command_repeat1] = STATE(2767),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(4940),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_fi] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(4942),
    [anon_sym_DQUOTE] = ACTIONS(4944),
    [anon_sym_DOLLAR] = ACTIONS(4946),
    [sym_raw_string] = ACTIONS(4948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4952),
    [anon_sym_BQUOTE] = ACTIONS(4954),
    [anon_sym_LT_LPAREN] = ACTIONS(4956),
    [anon_sym_GT_LPAREN] = ACTIONS(4956),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6369),
    [sym_word] = ACTIONS(4960),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [2157] = {
    [aux_sym_concatenation_repeat1] = STATE(2769),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(6371),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_fi] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [2158] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(2772),
    [anon_sym_DQUOTE] = ACTIONS(6373),
    [anon_sym_DOLLAR] = ACTIONS(6375),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2159] = {
    [sym_string] = STATE(2774),
    [anon_sym_DASH] = ACTIONS(6377),
    [anon_sym_DQUOTE] = ACTIONS(4964),
    [anon_sym_DOLLAR] = ACTIONS(6377),
    [sym_raw_string] = ACTIONS(6379),
    [anon_sym_POUND] = ACTIONS(6377),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6381),
    [anon_sym_STAR] = ACTIONS(6383),
    [anon_sym_AT] = ACTIONS(6383),
    [anon_sym_QMARK] = ACTIONS(6383),
    [anon_sym_0] = ACTIONS(6381),
    [anon_sym__] = ACTIONS(6381),
  },
  [2160] = {
    [aux_sym_concatenation_repeat1] = STATE(2769),
    [sym__simple_heredoc_body] = ACTIONS(995),
    [sym__heredoc_body_beginning] = ACTIONS(995),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(6371),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_fi] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [2161] = {
    [sym_subscript] = STATE(2779),
    [sym_variable_name] = ACTIONS(6385),
    [anon_sym_BANG] = ACTIONS(6387),
    [anon_sym_DASH] = ACTIONS(6389),
    [anon_sym_DOLLAR] = ACTIONS(6389),
    [anon_sym_POUND] = ACTIONS(6387),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6391),
    [anon_sym_STAR] = ACTIONS(6393),
    [anon_sym_AT] = ACTIONS(6393),
    [anon_sym_QMARK] = ACTIONS(6393),
    [anon_sym_0] = ACTIONS(6391),
    [anon_sym__] = ACTIONS(6391),
  },
  [2162] = {
    [sym__statements] = STATE(2780),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(2781),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2163] = {
    [sym__statements] = STATE(2782),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2164] = {
    [sym__statements] = STATE(2783),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2165] = {
    [sym_concatenation] = STATE(2784),
    [sym_string] = STATE(2160),
    [sym_simple_expansion] = STATE(2160),
    [sym_string_expansion] = STATE(2160),
    [sym_expansion] = STATE(2160),
    [sym_command_substitution] = STATE(2160),
    [sym_process_substitution] = STATE(2160),
    [aux_sym_unset_command_repeat1] = STATE(2784),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_fi] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4964),
    [anon_sym_DOLLAR] = ACTIONS(4966),
    [sym_raw_string] = ACTIONS(4968),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4970),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4972),
    [anon_sym_BQUOTE] = ACTIONS(4974),
    [anon_sym_LT_LPAREN] = ACTIONS(4976),
    [anon_sym_GT_LPAREN] = ACTIONS(4976),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6395),
    [sym_word] = ACTIONS(4980),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [2166] = {
    [sym_string] = STATE(2785),
    [sym_simple_expansion] = STATE(2785),
    [sym_string_expansion] = STATE(2785),
    [sym_expansion] = STATE(2785),
    [sym_command_substitution] = STATE(2785),
    [sym_process_substitution] = STATE(2785),
    [sym__special_characters] = ACTIONS(6397),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(6397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6397),
  },
  [2167] = {
    [aux_sym_concatenation_repeat1] = STATE(2786),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2168] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_fi] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1055),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2169] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(6399),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2170] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(6399),
    [anon_sym_DOLLAR] = ACTIONS(6401),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2171] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2172] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2173] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2174] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(6403),
    [sym_comment] = ACTIONS(57),
  },
  [2175] = {
    [sym_subscript] = STATE(2792),
    [sym_variable_name] = ACTIONS(6405),
    [anon_sym_DASH] = ACTIONS(6407),
    [anon_sym_DOLLAR] = ACTIONS(6407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6409),
    [anon_sym_STAR] = ACTIONS(6411),
    [anon_sym_AT] = ACTIONS(6411),
    [anon_sym_QMARK] = ACTIONS(6411),
    [anon_sym_0] = ACTIONS(6409),
    [anon_sym__] = ACTIONS(6409),
  },
  [2176] = {
    [sym_concatenation] = STATE(2795),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2795),
    [anon_sym_RBRACE] = ACTIONS(6413),
    [anon_sym_EQ] = ACTIONS(6415),
    [anon_sym_DASH] = ACTIONS(6415),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6419),
    [anon_sym_COLON] = ACTIONS(6415),
    [anon_sym_COLON_QMARK] = ACTIONS(6415),
    [anon_sym_COLON_DASH] = ACTIONS(6415),
    [anon_sym_PERCENT] = ACTIONS(6415),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2177] = {
    [sym_concatenation] = STATE(2798),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2798),
    [anon_sym_RBRACE] = ACTIONS(6421),
    [anon_sym_EQ] = ACTIONS(6423),
    [anon_sym_DASH] = ACTIONS(6423),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6427),
    [anon_sym_COLON] = ACTIONS(6423),
    [anon_sym_COLON_QMARK] = ACTIONS(6423),
    [anon_sym_COLON_DASH] = ACTIONS(6423),
    [anon_sym_PERCENT] = ACTIONS(6423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2178] = {
    [anon_sym_RPAREN] = ACTIONS(6429),
    [sym_comment] = ACTIONS(57),
  },
  [2179] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6429),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2180] = {
    [anon_sym_BQUOTE] = ACTIONS(6429),
    [sym_comment] = ACTIONS(57),
  },
  [2181] = {
    [anon_sym_RPAREN] = ACTIONS(6431),
    [sym_comment] = ACTIONS(57),
  },
  [2182] = {
    [anon_sym_LT] = ACTIONS(6433),
    [anon_sym_GT] = ACTIONS(6433),
    [anon_sym_GT_GT] = ACTIONS(6435),
    [anon_sym_AMP_GT] = ACTIONS(6433),
    [anon_sym_AMP_GT_GT] = ACTIONS(6435),
    [anon_sym_LT_AMP] = ACTIONS(6435),
    [anon_sym_GT_AMP] = ACTIONS(6435),
    [sym_comment] = ACTIONS(57),
  },
  [2183] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_fi] = ACTIONS(4880),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [2184] = {
    [sym_redirected_statement] = STATE(2802),
    [sym_for_statement] = STATE(2802),
    [sym_c_style_for_statement] = STATE(2802),
    [sym_while_statement] = STATE(2802),
    [sym_if_statement] = STATE(2802),
    [sym_case_statement] = STATE(2802),
    [sym_function_definition] = STATE(2802),
    [sym_compound_statement] = STATE(2802),
    [sym_subshell] = STATE(2802),
    [sym_pipeline] = STATE(2802),
    [sym_list] = STATE(2802),
    [sym_negated_command] = STATE(2802),
    [sym_test_command] = STATE(2802),
    [sym_declaration_command] = STATE(2802),
    [sym_unset_command] = STATE(2802),
    [sym_command] = STATE(2802),
    [sym_command_name] = STATE(1523),
    [sym_variable_assignment] = STATE(2803),
    [sym_subscript] = STATE(1525),
    [sym_file_redirect] = STATE(1528),
    [sym_concatenation] = STATE(1526),
    [sym_string] = STATE(1515),
    [sym_simple_expansion] = STATE(1515),
    [sym_string_expansion] = STATE(1515),
    [sym_expansion] = STATE(1515),
    [sym_command_substitution] = STATE(1515),
    [sym_process_substitution] = STATE(1515),
    [aux_sym_command_repeat1] = STATE(1528),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_typeset] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_local] = ACTIONS(3305),
    [anon_sym_unset] = ACTIONS(3307),
    [anon_sym_unsetenv] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(3315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3325),
  },
  [2185] = {
    [sym_redirected_statement] = STATE(2804),
    [sym_for_statement] = STATE(2804),
    [sym_c_style_for_statement] = STATE(2804),
    [sym_while_statement] = STATE(2804),
    [sym_if_statement] = STATE(2804),
    [sym_case_statement] = STATE(2804),
    [sym_function_definition] = STATE(2804),
    [sym_compound_statement] = STATE(2804),
    [sym_subshell] = STATE(2804),
    [sym_pipeline] = STATE(2804),
    [sym_list] = STATE(2804),
    [sym_negated_command] = STATE(2804),
    [sym_test_command] = STATE(2804),
    [sym_declaration_command] = STATE(2804),
    [sym_unset_command] = STATE(2804),
    [sym_command] = STATE(2804),
    [sym_command_name] = STATE(1523),
    [sym_variable_assignment] = STATE(2805),
    [sym_subscript] = STATE(1525),
    [sym_file_redirect] = STATE(1528),
    [sym_concatenation] = STATE(1526),
    [sym_string] = STATE(1515),
    [sym_simple_expansion] = STATE(1515),
    [sym_string_expansion] = STATE(1515),
    [sym_expansion] = STATE(1515),
    [sym_command_substitution] = STATE(1515),
    [sym_process_substitution] = STATE(1515),
    [aux_sym_command_repeat1] = STATE(1528),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_typeset] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_local] = ACTIONS(3305),
    [anon_sym_unset] = ACTIONS(3307),
    [anon_sym_unsetenv] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(3315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3325),
  },
  [2186] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(2807),
    [sym_simple_expansion] = STATE(2807),
    [sym_string_expansion] = STATE(2807),
    [sym_expansion] = STATE(2807),
    [sym_command_substitution] = STATE(2807),
    [sym_process_substitution] = STATE(2807),
    [sym__special_characters] = ACTIONS(6437),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(6439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6439),
  },
  [2187] = {
    [sym_concatenation] = STATE(651),
    [sym_string] = STATE(2809),
    [sym_simple_expansion] = STATE(2809),
    [sym_string_expansion] = STATE(2809),
    [sym_expansion] = STATE(2809),
    [sym_command_substitution] = STATE(2809),
    [sym_process_substitution] = STATE(2809),
    [sym__special_characters] = ACTIONS(6441),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(6443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6443),
  },
  [2188] = {
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_fi] = ACTIONS(1229),
    [anon_sym_SEMI_SEMI] = ACTIONS(6447),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6447),
    [anon_sym_AMP] = ACTIONS(6447),
  },
  [2189] = {
    [sym_file_redirect] = STATE(2811),
    [sym_heredoc_redirect] = STATE(2811),
    [sym_herestring_redirect] = STATE(2811),
    [aux_sym_redirected_statement_repeat1] = STATE(2811),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(5008),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_fi] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(5020),
    [anon_sym_GT] = ACTIONS(5020),
    [anon_sym_GT_GT] = ACTIONS(5022),
    [anon_sym_AMP_GT] = ACTIONS(5020),
    [anon_sym_AMP_GT_GT] = ACTIONS(5022),
    [anon_sym_LT_AMP] = ACTIONS(5022),
    [anon_sym_GT_AMP] = ACTIONS(5022),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [2190] = {
    [sym_concatenation] = STATE(2812),
    [sym_string] = STATE(2814),
    [sym_simple_expansion] = STATE(2814),
    [sym_string_expansion] = STATE(2814),
    [sym_expansion] = STATE(2814),
    [sym_command_substitution] = STATE(2814),
    [sym_process_substitution] = STATE(2814),
    [sym_regex] = ACTIONS(6449),
    [sym__special_characters] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(6453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6453),
  },
  [2191] = {
    [aux_sym_concatenation_repeat1] = STATE(2167),
    [sym__simple_heredoc_body] = ACTIONS(1257),
    [sym__heredoc_body_beginning] = ACTIONS(1257),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_fi] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [2192] = {
    [aux_sym_concatenation_repeat1] = STATE(2167),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_fi] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [2193] = {
    [sym_concatenation] = STATE(2815),
    [sym_string] = STATE(2192),
    [sym_simple_expansion] = STATE(2192),
    [sym_string_expansion] = STATE(2192),
    [sym_expansion] = STATE(2192),
    [sym_command_substitution] = STATE(2192),
    [sym_process_substitution] = STATE(2192),
    [aux_sym_command_repeat2] = STATE(2815),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_fi] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(5026),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(5028),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(5030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5032),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [2194] = {
    [sym_file_redirect] = STATE(2189),
    [sym_heredoc_redirect] = STATE(2189),
    [sym_heredoc_body] = STATE(2817),
    [sym_herestring_redirect] = STATE(2189),
    [aux_sym_redirected_statement_repeat1] = STATE(2189),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(5008),
    [anon_sym_SEMI] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(5012),
    [anon_sym_SEMI_SEMI] = ACTIONS(6457),
    [anon_sym_PIPE_AMP] = ACTIONS(5016),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(5020),
    [anon_sym_GT] = ACTIONS(5020),
    [anon_sym_GT_GT] = ACTIONS(5022),
    [anon_sym_AMP_GT] = ACTIONS(5020),
    [anon_sym_AMP_GT_GT] = ACTIONS(5022),
    [anon_sym_LT_AMP] = ACTIONS(5022),
    [anon_sym_GT_AMP] = ACTIONS(5022),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6455),
  },
  [2195] = {
    [sym_file_redirect] = STATE(2189),
    [sym_heredoc_redirect] = STATE(2189),
    [sym_heredoc_body] = STATE(2817),
    [sym_herestring_redirect] = STATE(2189),
    [aux_sym_redirected_statement_repeat1] = STATE(2189),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(5012),
    [anon_sym_SEMI_SEMI] = ACTIONS(6457),
    [anon_sym_PIPE_AMP] = ACTIONS(5016),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5024),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6455),
  },
  [2196] = {
    [sym_concatenation] = STATE(2818),
    [sym_string] = STATE(2192),
    [sym_simple_expansion] = STATE(2192),
    [sym_string_expansion] = STATE(2192),
    [sym_expansion] = STATE(2192),
    [sym_command_substitution] = STATE(2192),
    [sym_process_substitution] = STATE(2192),
    [aux_sym_command_repeat2] = STATE(2818),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_fi] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(5026),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(5028),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(5030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5032),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [2197] = {
    [sym_concatenation] = STATE(2819),
    [sym_string] = STATE(2822),
    [sym_array] = STATE(2819),
    [sym_simple_expansion] = STATE(2822),
    [sym_string_expansion] = STATE(2822),
    [sym_expansion] = STATE(2822),
    [sym_command_substitution] = STATE(2822),
    [sym_process_substitution] = STATE(2822),
    [sym__empty_value] = ACTIONS(6459),
    [anon_sym_LPAREN] = ACTIONS(6461),
    [sym__special_characters] = ACTIONS(6463),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [sym_raw_string] = ACTIONS(6465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3341),
    [anon_sym_LT_LPAREN] = ACTIONS(3343),
    [anon_sym_GT_LPAREN] = ACTIONS(3343),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6465),
  },
  [2198] = {
    [sym_string] = STATE(2823),
    [sym_simple_expansion] = STATE(2823),
    [sym_string_expansion] = STATE(2823),
    [sym_expansion] = STATE(2823),
    [sym_command_substitution] = STATE(2823),
    [sym_process_substitution] = STATE(2823),
    [sym__special_characters] = ACTIONS(6467),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [sym_raw_string] = ACTIONS(6467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3341),
    [anon_sym_LT_LPAREN] = ACTIONS(3343),
    [anon_sym_GT_LPAREN] = ACTIONS(3343),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6467),
  },
  [2199] = {
    [aux_sym_concatenation_repeat1] = STATE(2824),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(5038),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_elif] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2200] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_fi] = ACTIONS(1055),
    [anon_sym_elif] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2201] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(6469),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2202] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(6469),
    [anon_sym_DOLLAR] = ACTIONS(6471),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2203] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_elif] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2204] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_elif] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2205] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_elif] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2206] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(6473),
    [sym_comment] = ACTIONS(57),
  },
  [2207] = {
    [sym_subscript] = STATE(2830),
    [sym_variable_name] = ACTIONS(6475),
    [anon_sym_DASH] = ACTIONS(6477),
    [anon_sym_DOLLAR] = ACTIONS(6477),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6479),
    [anon_sym_STAR] = ACTIONS(6481),
    [anon_sym_AT] = ACTIONS(6481),
    [anon_sym_QMARK] = ACTIONS(6481),
    [anon_sym_0] = ACTIONS(6479),
    [anon_sym__] = ACTIONS(6479),
  },
  [2208] = {
    [sym_concatenation] = STATE(2833),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2833),
    [anon_sym_RBRACE] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(6485),
    [anon_sym_DASH] = ACTIONS(6485),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6489),
    [anon_sym_COLON] = ACTIONS(6485),
    [anon_sym_COLON_QMARK] = ACTIONS(6485),
    [anon_sym_COLON_DASH] = ACTIONS(6485),
    [anon_sym_PERCENT] = ACTIONS(6485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2209] = {
    [sym_concatenation] = STATE(2836),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2836),
    [anon_sym_RBRACE] = ACTIONS(6491),
    [anon_sym_EQ] = ACTIONS(6493),
    [anon_sym_DASH] = ACTIONS(6493),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6495),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6497),
    [anon_sym_COLON] = ACTIONS(6493),
    [anon_sym_COLON_QMARK] = ACTIONS(6493),
    [anon_sym_COLON_DASH] = ACTIONS(6493),
    [anon_sym_PERCENT] = ACTIONS(6493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2210] = {
    [anon_sym_RPAREN] = ACTIONS(6499),
    [sym_comment] = ACTIONS(57),
  },
  [2211] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6499),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2212] = {
    [anon_sym_BQUOTE] = ACTIONS(6499),
    [sym_comment] = ACTIONS(57),
  },
  [2213] = {
    [anon_sym_RPAREN] = ACTIONS(6501),
    [sym_comment] = ACTIONS(57),
  },
  [2214] = {
    [sym_variable_assignment] = STATE(2214),
    [sym_subscript] = STATE(1538),
    [sym_concatenation] = STATE(2214),
    [sym_string] = STATE(1533),
    [sym_simple_expansion] = STATE(1533),
    [sym_string_expansion] = STATE(1533),
    [sym_expansion] = STATE(1533),
    [sym_command_substitution] = STATE(1533),
    [sym_process_substitution] = STATE(1533),
    [aux_sym_declaration_command_repeat1] = STATE(2214),
    [sym__simple_heredoc_body] = ACTIONS(2163),
    [sym__heredoc_body_beginning] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(6503),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_fi] = ACTIONS(2168),
    [anon_sym_elif] = ACTIONS(2168),
    [anon_sym_else] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(6506),
    [anon_sym_DQUOTE] = ACTIONS(6509),
    [anon_sym_DOLLAR] = ACTIONS(6512),
    [sym_raw_string] = ACTIONS(6515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6518),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6521),
    [anon_sym_BQUOTE] = ACTIONS(6524),
    [anon_sym_LT_LPAREN] = ACTIONS(6527),
    [anon_sym_GT_LPAREN] = ACTIONS(6527),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6530),
    [sym_word] = ACTIONS(6533),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [2215] = {
    [sym_string] = STATE(2839),
    [sym_simple_expansion] = STATE(2839),
    [sym_string_expansion] = STATE(2839),
    [sym_expansion] = STATE(2839),
    [sym_command_substitution] = STATE(2839),
    [sym_process_substitution] = STATE(2839),
    [sym__special_characters] = ACTIONS(6536),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_DOLLAR] = ACTIONS(3353),
    [sym_raw_string] = ACTIONS(6536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3357),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3359),
    [anon_sym_BQUOTE] = ACTIONS(3361),
    [anon_sym_LT_LPAREN] = ACTIONS(3363),
    [anon_sym_GT_LPAREN] = ACTIONS(3363),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6536),
  },
  [2216] = {
    [aux_sym_concatenation_repeat1] = STATE(2840),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_elif] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2217] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_fi] = ACTIONS(1055),
    [anon_sym_elif] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2218] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(6538),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2219] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(6538),
    [anon_sym_DOLLAR] = ACTIONS(6540),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2220] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_elif] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2221] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_elif] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2222] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_elif] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2223] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(6542),
    [sym_comment] = ACTIONS(57),
  },
  [2224] = {
    [sym_subscript] = STATE(2846),
    [sym_variable_name] = ACTIONS(6544),
    [anon_sym_DASH] = ACTIONS(6546),
    [anon_sym_DOLLAR] = ACTIONS(6546),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6550),
    [anon_sym_AT] = ACTIONS(6550),
    [anon_sym_QMARK] = ACTIONS(6550),
    [anon_sym_0] = ACTIONS(6548),
    [anon_sym__] = ACTIONS(6548),
  },
  [2225] = {
    [sym_concatenation] = STATE(2849),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2849),
    [anon_sym_RBRACE] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6554),
    [anon_sym_DASH] = ACTIONS(6554),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6556),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_COLON_QMARK] = ACTIONS(6554),
    [anon_sym_COLON_DASH] = ACTIONS(6554),
    [anon_sym_PERCENT] = ACTIONS(6554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2226] = {
    [sym_concatenation] = STATE(2852),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2852),
    [anon_sym_RBRACE] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6562),
    [anon_sym_DASH] = ACTIONS(6562),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6566),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_COLON_QMARK] = ACTIONS(6562),
    [anon_sym_COLON_DASH] = ACTIONS(6562),
    [anon_sym_PERCENT] = ACTIONS(6562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2227] = {
    [anon_sym_RPAREN] = ACTIONS(6568),
    [sym_comment] = ACTIONS(57),
  },
  [2228] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2229] = {
    [anon_sym_BQUOTE] = ACTIONS(6568),
    [sym_comment] = ACTIONS(57),
  },
  [2230] = {
    [anon_sym_RPAREN] = ACTIONS(6570),
    [sym_comment] = ACTIONS(57),
  },
  [2231] = {
    [sym_concatenation] = STATE(2231),
    [sym_string] = STATE(1543),
    [sym_simple_expansion] = STATE(1543),
    [sym_string_expansion] = STATE(1543),
    [sym_expansion] = STATE(1543),
    [sym_command_substitution] = STATE(1543),
    [sym_process_substitution] = STATE(1543),
    [aux_sym_unset_command_repeat1] = STATE(2231),
    [sym__simple_heredoc_body] = ACTIONS(2236),
    [sym__heredoc_body_beginning] = ACTIONS(2236),
    [sym_file_descriptor] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_fi] = ACTIONS(2238),
    [anon_sym_elif] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(6572),
    [anon_sym_DQUOTE] = ACTIONS(6575),
    [anon_sym_DOLLAR] = ACTIONS(6578),
    [sym_raw_string] = ACTIONS(6581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6587),
    [anon_sym_BQUOTE] = ACTIONS(6590),
    [anon_sym_LT_LPAREN] = ACTIONS(6593),
    [anon_sym_GT_LPAREN] = ACTIONS(6593),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6596),
    [sym_word] = ACTIONS(6599),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [2232] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_elif] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2233] = {
    [aux_sym_concatenation_repeat1] = STATE(2233),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(6602),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_elif] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2234] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_fi] = ACTIONS(2315),
    [anon_sym_elif] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [2235] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(6605),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2236] = {
    [sym_concatenation] = STATE(2859),
    [sym_string] = STATE(2858),
    [sym_simple_expansion] = STATE(2858),
    [sym_string_expansion] = STATE(2858),
    [sym_expansion] = STATE(2858),
    [sym_command_substitution] = STATE(2858),
    [sym_process_substitution] = STATE(2858),
    [anon_sym_RBRACE] = ACTIONS(6607),
    [sym__special_characters] = ACTIONS(6609),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(6611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6611),
  },
  [2237] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(6613),
    [sym_comment] = ACTIONS(57),
  },
  [2238] = {
    [sym_concatenation] = STATE(2863),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2863),
    [anon_sym_RBRACE] = ACTIONS(6615),
    [anon_sym_EQ] = ACTIONS(6617),
    [anon_sym_DASH] = ACTIONS(6617),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6621),
    [anon_sym_COLON] = ACTIONS(6617),
    [anon_sym_COLON_QMARK] = ACTIONS(6617),
    [anon_sym_COLON_DASH] = ACTIONS(6617),
    [anon_sym_PERCENT] = ACTIONS(6617),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2239] = {
    [sym_concatenation] = STATE(2865),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2865),
    [anon_sym_RBRACE] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6623),
    [anon_sym_DASH] = ACTIONS(6623),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6627),
    [anon_sym_COLON] = ACTIONS(6623),
    [anon_sym_COLON_QMARK] = ACTIONS(6623),
    [anon_sym_COLON_DASH] = ACTIONS(6623),
    [anon_sym_PERCENT] = ACTIONS(6623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2240] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_fi] = ACTIONS(2408),
    [anon_sym_elif] = ACTIONS(2408),
    [anon_sym_else] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [2241] = {
    [sym_concatenation] = STATE(2868),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2868),
    [sym_regex] = ACTIONS(6629),
    [anon_sym_RBRACE] = ACTIONS(6631),
    [anon_sym_EQ] = ACTIONS(6633),
    [anon_sym_DASH] = ACTIONS(6633),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6633),
    [anon_sym_COLON_QMARK] = ACTIONS(6633),
    [anon_sym_COLON_DASH] = ACTIONS(6633),
    [anon_sym_PERCENT] = ACTIONS(6633),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2242] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6631),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2243] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_fi] = ACTIONS(2456),
    [anon_sym_elif] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [2244] = {
    [sym_concatenation] = STATE(2865),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2865),
    [sym_regex] = ACTIONS(6637),
    [anon_sym_RBRACE] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6623),
    [anon_sym_DASH] = ACTIONS(6623),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6623),
    [anon_sym_COLON_QMARK] = ACTIONS(6623),
    [anon_sym_COLON_DASH] = ACTIONS(6623),
    [anon_sym_PERCENT] = ACTIONS(6623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2245] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2246] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_fi] = ACTIONS(2466),
    [anon_sym_elif] = ACTIONS(2466),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [2247] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_fi] = ACTIONS(2504),
    [anon_sym_elif] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2504),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [2248] = {
    [sym__simple_heredoc_body] = ACTIONS(6639),
    [sym__heredoc_body_beginning] = ACTIONS(6639),
    [sym_file_descriptor] = ACTIONS(6639),
    [ts_builtin_sym_end] = ACTIONS(6639),
    [anon_sym_SEMI] = ACTIONS(6641),
    [anon_sym_done] = ACTIONS(6639),
    [anon_sym_fi] = ACTIONS(6639),
    [anon_sym_elif] = ACTIONS(6639),
    [anon_sym_else] = ACTIONS(6639),
    [anon_sym_esac] = ACTIONS(6639),
    [anon_sym_PIPE] = ACTIONS(6641),
    [anon_sym_RPAREN] = ACTIONS(6639),
    [anon_sym_SEMI_SEMI] = ACTIONS(6639),
    [anon_sym_PIPE_AMP] = ACTIONS(6639),
    [anon_sym_AMP_AMP] = ACTIONS(6639),
    [anon_sym_PIPE_PIPE] = ACTIONS(6639),
    [anon_sym_LT] = ACTIONS(6641),
    [anon_sym_GT] = ACTIONS(6641),
    [anon_sym_GT_GT] = ACTIONS(6639),
    [anon_sym_AMP_GT] = ACTIONS(6641),
    [anon_sym_AMP_GT_GT] = ACTIONS(6639),
    [anon_sym_LT_AMP] = ACTIONS(6639),
    [anon_sym_GT_AMP] = ACTIONS(6639),
    [anon_sym_LT_LT] = ACTIONS(6641),
    [anon_sym_LT_LT_DASH] = ACTIONS(6639),
    [anon_sym_LT_LT_LT] = ACTIONS(6639),
    [anon_sym_BQUOTE] = ACTIONS(6639),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6639),
    [anon_sym_AMP] = ACTIONS(6641),
  },
  [2249] = {
    [anon_sym_fi] = ACTIONS(6643),
    [sym_comment] = ACTIONS(57),
  },
  [2250] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(2872),
    [sym_simple_expansion] = STATE(2872),
    [sym_string_expansion] = STATE(2872),
    [sym_expansion] = STATE(2872),
    [sym_command_substitution] = STATE(2872),
    [sym_process_substitution] = STATE(2872),
    [sym__special_characters] = ACTIONS(6645),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(6647),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6647),
  },
  [2251] = {
    [sym_file_redirect] = STATE(1575),
    [sym_heredoc_redirect] = STATE(1575),
    [sym_herestring_redirect] = STATE(1575),
    [aux_sym_redirected_statement_repeat1] = STATE(1575),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2534),
    [anon_sym_elif] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2252] = {
    [sym_file_redirect] = STATE(1575),
    [sym_heredoc_redirect] = STATE(1575),
    [sym_herestring_redirect] = STATE(1575),
    [aux_sym_redirected_statement_repeat1] = STATE(1575),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_elif] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2253] = {
    [sym_file_redirect] = STATE(1575),
    [sym_heredoc_redirect] = STATE(1575),
    [sym_herestring_redirect] = STATE(1575),
    [aux_sym_redirected_statement_repeat1] = STATE(1575),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_fi] = ACTIONS(2538),
    [anon_sym_elif] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_PIPE] = ACTIONS(3403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [2254] = {
    [sym_file_redirect] = STATE(1575),
    [sym_heredoc_redirect] = STATE(1575),
    [sym_herestring_redirect] = STATE(1575),
    [aux_sym_redirected_statement_repeat1] = STATE(1575),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_fi] = ACTIONS(2540),
    [anon_sym_elif] = ACTIONS(2540),
    [anon_sym_else] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(3403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [2255] = {
    [aux_sym_concatenation_repeat1] = STATE(2873),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_fi] = ACTIONS(1015),
    [anon_sym_elif] = ACTIONS(1015),
    [anon_sym_else] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [2256] = {
    [aux_sym_concatenation_repeat1] = STATE(2873),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_fi] = ACTIONS(1033),
    [anon_sym_elif] = ACTIONS(1033),
    [anon_sym_else] = ACTIONS(1033),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [2257] = {
    [aux_sym_concatenation_repeat1] = STATE(2873),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_fi] = ACTIONS(2546),
    [anon_sym_elif] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2546),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [2258] = {
    [aux_sym_concatenation_repeat1] = STATE(2873),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_fi] = ACTIONS(2550),
    [anon_sym_elif] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [2259] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_fi] = ACTIONS(6247),
    [anon_sym_elif] = ACTIONS(6247),
    [anon_sym_else] = ACTIONS(6247),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [2260] = {
    [sym_file_redirect] = STATE(2260),
    [sym_heredoc_redirect] = STATE(2260),
    [sym_herestring_redirect] = STATE(2260),
    [aux_sym_redirected_statement_repeat1] = STATE(2260),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(6649),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_fi] = ACTIONS(2560),
    [anon_sym_elif] = ACTIONS(2560),
    [anon_sym_else] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(6652),
    [anon_sym_GT] = ACTIONS(6652),
    [anon_sym_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_GT] = ACTIONS(6652),
    [anon_sym_AMP_GT_GT] = ACTIONS(6655),
    [anon_sym_LT_AMP] = ACTIONS(6655),
    [anon_sym_GT_AMP] = ACTIONS(6655),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(6658),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [2261] = {
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_fi] = ACTIONS(2584),
    [anon_sym_elif] = ACTIONS(2584),
    [anon_sym_else] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2262] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym__simple_heredoc_body] = ACTIONS(2586),
    [sym__heredoc_body_beginning] = ACTIONS(2586),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_fi] = ACTIONS(2588),
    [anon_sym_elif] = ACTIONS(2588),
    [anon_sym_else] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [2263] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_fi] = ACTIONS(2584),
    [anon_sym_elif] = ACTIONS(2584),
    [anon_sym_else] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2264] = {
    [sym_concatenation] = STATE(2264),
    [sym_string] = STATE(1578),
    [sym_simple_expansion] = STATE(1578),
    [sym_string_expansion] = STATE(1578),
    [sym_expansion] = STATE(1578),
    [sym_command_substitution] = STATE(1578),
    [sym_process_substitution] = STATE(1578),
    [aux_sym_command_repeat2] = STATE(2264),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_fi] = ACTIONS(2584),
    [anon_sym_elif] = ACTIONS(2584),
    [anon_sym_else] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(6661),
    [anon_sym_EQ_EQ] = ACTIONS(6661),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(6664),
    [anon_sym_DQUOTE] = ACTIONS(6667),
    [anon_sym_DOLLAR] = ACTIONS(6670),
    [sym_raw_string] = ACTIONS(6673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6679),
    [anon_sym_BQUOTE] = ACTIONS(6682),
    [anon_sym_LT_LPAREN] = ACTIONS(6685),
    [anon_sym_GT_LPAREN] = ACTIONS(6685),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6688),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2265] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_fi] = ACTIONS(6247),
    [anon_sym_elif] = ACTIONS(6247),
    [anon_sym_else] = ACTIONS(6247),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [2266] = {
    [anon_sym_SEMI] = ACTIONS(6691),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_elif] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(6693),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6693),
    [anon_sym_AMP] = ACTIONS(6693),
  },
  [2267] = {
    [sym_concatenation] = STATE(2264),
    [sym_string] = STATE(1578),
    [sym_simple_expansion] = STATE(1578),
    [sym_string_expansion] = STATE(1578),
    [sym_expansion] = STATE(1578),
    [sym_command_substitution] = STATE(1578),
    [sym_process_substitution] = STATE(1578),
    [aux_sym_command_repeat2] = STATE(2264),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_fi] = ACTIONS(2648),
    [anon_sym_elif] = ACTIONS(2648),
    [anon_sym_else] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(3417),
    [anon_sym_EQ_EQ] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_LT_LPAREN] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [2268] = {
    [sym_concatenation] = STATE(2877),
    [sym_string] = STATE(2876),
    [sym_simple_expansion] = STATE(2876),
    [sym_string_expansion] = STATE(2876),
    [sym_expansion] = STATE(2876),
    [sym_command_substitution] = STATE(2876),
    [sym_process_substitution] = STATE(2876),
    [sym__special_characters] = ACTIONS(6695),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(6697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6697),
  },
  [2269] = {
    [sym__statements] = STATE(2892),
    [sym_redirected_statement] = STATE(2893),
    [sym_for_statement] = STATE(2893),
    [sym_c_style_for_statement] = STATE(2893),
    [sym_while_statement] = STATE(2893),
    [sym_if_statement] = STATE(2893),
    [sym_case_statement] = STATE(2893),
    [sym_function_definition] = STATE(2893),
    [sym_compound_statement] = STATE(2893),
    [sym_subshell] = STATE(2893),
    [sym_pipeline] = STATE(2893),
    [sym_list] = STATE(2893),
    [sym_negated_command] = STATE(2893),
    [sym_test_command] = STATE(2893),
    [sym_declaration_command] = STATE(2893),
    [sym_unset_command] = STATE(2893),
    [sym_command] = STATE(2893),
    [sym_command_name] = STATE(2894),
    [sym_variable_assignment] = STATE(2895),
    [sym_subscript] = STATE(2896),
    [sym_file_redirect] = STATE(2899),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym__statements_repeat1] = STATE(2898),
    [aux_sym_command_repeat1] = STATE(2899),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6699),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(6701),
    [anon_sym_SEMI_SEMI] = ACTIONS(6703),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6705),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6707),
    [anon_sym_typeset] = ACTIONS(6707),
    [anon_sym_export] = ACTIONS(6707),
    [anon_sym_readonly] = ACTIONS(6707),
    [anon_sym_local] = ACTIONS(6707),
    [anon_sym_unset] = ACTIONS(6709),
    [anon_sym_unsetenv] = ACTIONS(6709),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(6711),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6727),
  },
  [2270] = {
    [aux_sym_case_item_repeat1] = STATE(2901),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [sym_comment] = ACTIONS(57),
  },
  [2271] = {
    [aux_sym_concatenation_repeat1] = STATE(2902),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1049),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
  },
  [2272] = {
    [sym__statements] = STATE(2904),
    [sym_redirected_statement] = STATE(2893),
    [sym_for_statement] = STATE(2893),
    [sym_c_style_for_statement] = STATE(2893),
    [sym_while_statement] = STATE(2893),
    [sym_if_statement] = STATE(2893),
    [sym_case_statement] = STATE(2893),
    [sym_function_definition] = STATE(2893),
    [sym_compound_statement] = STATE(2893),
    [sym_subshell] = STATE(2893),
    [sym_pipeline] = STATE(2893),
    [sym_list] = STATE(2893),
    [sym_negated_command] = STATE(2893),
    [sym_test_command] = STATE(2893),
    [sym_declaration_command] = STATE(2893),
    [sym_unset_command] = STATE(2893),
    [sym_command] = STATE(2893),
    [sym_command_name] = STATE(2894),
    [sym_variable_assignment] = STATE(2895),
    [sym_subscript] = STATE(2896),
    [sym_file_redirect] = STATE(2899),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym__statements_repeat1] = STATE(2898),
    [aux_sym_command_repeat1] = STATE(2899),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6699),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(6731),
    [anon_sym_SEMI_SEMI] = ACTIONS(6733),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6705),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6707),
    [anon_sym_typeset] = ACTIONS(6707),
    [anon_sym_export] = ACTIONS(6707),
    [anon_sym_readonly] = ACTIONS(6707),
    [anon_sym_local] = ACTIONS(6707),
    [anon_sym_unset] = ACTIONS(6709),
    [anon_sym_unsetenv] = ACTIONS(6709),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(6711),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6727),
  },
  [2273] = {
    [aux_sym_case_item_repeat1] = STATE(2901),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(6735),
    [sym_comment] = ACTIONS(57),
  },
  [2274] = {
    [sym__simple_heredoc_body] = ACTIONS(6737),
    [sym__heredoc_body_beginning] = ACTIONS(6737),
    [sym_file_descriptor] = ACTIONS(6737),
    [ts_builtin_sym_end] = ACTIONS(6737),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_done] = ACTIONS(6737),
    [anon_sym_fi] = ACTIONS(6737),
    [anon_sym_elif] = ACTIONS(6737),
    [anon_sym_else] = ACTIONS(6737),
    [anon_sym_esac] = ACTIONS(6737),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6737),
    [anon_sym_SEMI_SEMI] = ACTIONS(6737),
    [anon_sym_PIPE_AMP] = ACTIONS(6737),
    [anon_sym_AMP_AMP] = ACTIONS(6737),
    [anon_sym_PIPE_PIPE] = ACTIONS(6737),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_GT_GT] = ACTIONS(6737),
    [anon_sym_AMP_GT] = ACTIONS(6739),
    [anon_sym_AMP_GT_GT] = ACTIONS(6737),
    [anon_sym_LT_AMP] = ACTIONS(6737),
    [anon_sym_GT_AMP] = ACTIONS(6737),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_LT_LT_DASH] = ACTIONS(6737),
    [anon_sym_LT_LT_LT] = ACTIONS(6737),
    [anon_sym_BQUOTE] = ACTIONS(6737),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6737),
    [anon_sym_AMP] = ACTIONS(6739),
  },
  [2275] = {
    [anon_sym_esac] = ACTIONS(6741),
    [sym_comment] = ACTIONS(57),
  },
  [2276] = {
    [sym_case_item] = STATE(2276),
    [sym_concatenation] = STATE(2909),
    [sym_string] = STATE(2908),
    [sym_simple_expansion] = STATE(2908),
    [sym_string_expansion] = STATE(2908),
    [sym_expansion] = STATE(2908),
    [sym_command_substitution] = STATE(2908),
    [sym_process_substitution] = STATE(2908),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(6743),
    [anon_sym_DQUOTE] = ACTIONS(6746),
    [anon_sym_DOLLAR] = ACTIONS(6749),
    [sym_raw_string] = ACTIONS(6752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6758),
    [anon_sym_BQUOTE] = ACTIONS(6761),
    [anon_sym_LT_LPAREN] = ACTIONS(6764),
    [anon_sym_GT_LPAREN] = ACTIONS(6764),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6752),
  },
  [2277] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(2910),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2278] = {
    [sym__simple_heredoc_body] = ACTIONS(6767),
    [sym__heredoc_body_beginning] = ACTIONS(6767),
    [sym_file_descriptor] = ACTIONS(6767),
    [ts_builtin_sym_end] = ACTIONS(6767),
    [anon_sym_SEMI] = ACTIONS(6769),
    [anon_sym_done] = ACTIONS(6767),
    [anon_sym_fi] = ACTIONS(6767),
    [anon_sym_elif] = ACTIONS(6767),
    [anon_sym_else] = ACTIONS(6767),
    [anon_sym_esac] = ACTIONS(6767),
    [anon_sym_PIPE] = ACTIONS(6769),
    [anon_sym_RPAREN] = ACTIONS(6767),
    [anon_sym_SEMI_SEMI] = ACTIONS(6767),
    [anon_sym_PIPE_AMP] = ACTIONS(6767),
    [anon_sym_AMP_AMP] = ACTIONS(6767),
    [anon_sym_PIPE_PIPE] = ACTIONS(6767),
    [anon_sym_LT] = ACTIONS(6769),
    [anon_sym_GT] = ACTIONS(6769),
    [anon_sym_GT_GT] = ACTIONS(6767),
    [anon_sym_AMP_GT] = ACTIONS(6769),
    [anon_sym_AMP_GT_GT] = ACTIONS(6767),
    [anon_sym_LT_AMP] = ACTIONS(6767),
    [anon_sym_GT_AMP] = ACTIONS(6767),
    [anon_sym_LT_LT] = ACTIONS(6769),
    [anon_sym_LT_LT_DASH] = ACTIONS(6767),
    [anon_sym_LT_LT_LT] = ACTIONS(6767),
    [anon_sym_BQUOTE] = ACTIONS(6767),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6767),
    [anon_sym_AMP] = ACTIONS(6769),
  },
  [2279] = {
    [anon_sym_esac] = ACTIONS(6771),
    [sym_comment] = ACTIONS(57),
  },
  [2280] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(2912),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2281] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_in] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5543),
  },
  [2282] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_in] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5551),
  },
  [2283] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6773),
    [sym_comment] = ACTIONS(57),
  },
  [2284] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6775),
    [sym_comment] = ACTIONS(57),
  },
  [2285] = {
    [anon_sym_RBRACE] = ACTIONS(6775),
    [sym_comment] = ACTIONS(57),
  },
  [2286] = {
    [sym_concatenation] = STATE(2916),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2916),
    [anon_sym_RBRACE] = ACTIONS(6777),
    [anon_sym_EQ] = ACTIONS(6779),
    [anon_sym_DASH] = ACTIONS(6779),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6781),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6779),
    [anon_sym_COLON_QMARK] = ACTIONS(6779),
    [anon_sym_COLON_DASH] = ACTIONS(6779),
    [anon_sym_PERCENT] = ACTIONS(6779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2287] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_in] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5595),
  },
  [2288] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6777),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2289] = {
    [sym_concatenation] = STATE(2917),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2917),
    [anon_sym_RBRACE] = ACTIONS(6775),
    [anon_sym_EQ] = ACTIONS(6783),
    [anon_sym_DASH] = ACTIONS(6783),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6783),
    [anon_sym_COLON_QMARK] = ACTIONS(6783),
    [anon_sym_COLON_DASH] = ACTIONS(6783),
    [anon_sym_PERCENT] = ACTIONS(6783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2290] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6775),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2291] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_in] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5640),
  },
  [2292] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6787),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2293] = {
    [aux_sym_concatenation_repeat1] = STATE(2293),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(4382),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2294] = {
    [aux_sym_concatenation_repeat1] = STATE(2294),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2295] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4354),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [2296] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2297] = {
    [aux_sym_concatenation_repeat1] = STATE(2297),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(6789),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2298] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2315),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [2299] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(6792),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2300] = {
    [sym_concatenation] = STATE(2923),
    [sym_string] = STATE(2922),
    [sym_simple_expansion] = STATE(2922),
    [sym_string_expansion] = STATE(2922),
    [sym_expansion] = STATE(2922),
    [sym_command_substitution] = STATE(2922),
    [sym_process_substitution] = STATE(2922),
    [anon_sym_RBRACE] = ACTIONS(6794),
    [sym__special_characters] = ACTIONS(6796),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(6798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6798),
  },
  [2301] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(6800),
    [sym_comment] = ACTIONS(57),
  },
  [2302] = {
    [sym_concatenation] = STATE(2927),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2927),
    [anon_sym_RBRACE] = ACTIONS(6802),
    [anon_sym_EQ] = ACTIONS(6804),
    [anon_sym_DASH] = ACTIONS(6804),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_COLON_QMARK] = ACTIONS(6804),
    [anon_sym_COLON_DASH] = ACTIONS(6804),
    [anon_sym_PERCENT] = ACTIONS(6804),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2303] = {
    [sym_concatenation] = STATE(2929),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2929),
    [anon_sym_RBRACE] = ACTIONS(6794),
    [anon_sym_EQ] = ACTIONS(6810),
    [anon_sym_DASH] = ACTIONS(6810),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_COLON_QMARK] = ACTIONS(6810),
    [anon_sym_COLON_DASH] = ACTIONS(6810),
    [anon_sym_PERCENT] = ACTIONS(6810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2304] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [2305] = {
    [sym_concatenation] = STATE(2932),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2932),
    [sym_regex] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6818),
    [anon_sym_EQ] = ACTIONS(6820),
    [anon_sym_DASH] = ACTIONS(6820),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6820),
    [anon_sym_COLON_QMARK] = ACTIONS(6820),
    [anon_sym_COLON_DASH] = ACTIONS(6820),
    [anon_sym_PERCENT] = ACTIONS(6820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2306] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6818),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2307] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [2308] = {
    [sym_concatenation] = STATE(2929),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2929),
    [sym_regex] = ACTIONS(6824),
    [anon_sym_RBRACE] = ACTIONS(6794),
    [anon_sym_EQ] = ACTIONS(6810),
    [anon_sym_DASH] = ACTIONS(6810),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_COLON_QMARK] = ACTIONS(6810),
    [anon_sym_COLON_DASH] = ACTIONS(6810),
    [anon_sym_PERCENT] = ACTIONS(6810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2309] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6794),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2310] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [2311] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [2312] = {
    [sym_do_group] = STATE(2935),
    [sym_compound_statement] = STATE(2935),
    [anon_sym_SEMI] = ACTIONS(6826),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [2313] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6828),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [2314] = {
    [sym__expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_unary_expression] = STATE(2937),
    [sym_postfix_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2937),
    [sym_concatenation] = STATE(2937),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6828),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2315] = {
    [anon_sym_SEMI] = ACTIONS(6830),
    [anon_sym_SEMI_SEMI] = ACTIONS(6832),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(6832),
    [anon_sym_AMP] = ACTIONS(6830),
  },
  [2316] = {
    [sym_do_group] = STATE(2939),
    [anon_sym_do] = ACTIONS(1921),
    [sym_comment] = ACTIONS(57),
  },
  [2317] = {
    [sym__simple_heredoc_body] = ACTIONS(4872),
    [sym__heredoc_body_beginning] = ACTIONS(4872),
    [sym_file_descriptor] = ACTIONS(4872),
    [anon_sym_SEMI] = ACTIONS(4874),
    [anon_sym_PIPE] = ACTIONS(4874),
    [anon_sym_SEMI_SEMI] = ACTIONS(4872),
    [anon_sym_RBRACE] = ACTIONS(4872),
    [anon_sym_PIPE_AMP] = ACTIONS(4872),
    [anon_sym_AMP_AMP] = ACTIONS(4872),
    [anon_sym_PIPE_PIPE] = ACTIONS(4872),
    [anon_sym_LT] = ACTIONS(4874),
    [anon_sym_GT] = ACTIONS(4874),
    [anon_sym_GT_GT] = ACTIONS(4872),
    [anon_sym_AMP_GT] = ACTIONS(4874),
    [anon_sym_AMP_GT_GT] = ACTIONS(4872),
    [anon_sym_LT_AMP] = ACTIONS(4872),
    [anon_sym_GT_AMP] = ACTIONS(4872),
    [anon_sym_LT_LT] = ACTIONS(4874),
    [anon_sym_LT_LT_DASH] = ACTIONS(4872),
    [anon_sym_LT_LT_LT] = ACTIONS(4872),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4872),
    [anon_sym_AMP] = ACTIONS(4874),
  },
  [2318] = {
    [sym__simple_heredoc_body] = ACTIONS(5126),
    [sym__heredoc_body_beginning] = ACTIONS(5126),
    [sym_file_descriptor] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5128),
    [anon_sym_PIPE] = ACTIONS(5128),
    [anon_sym_SEMI_SEMI] = ACTIONS(5126),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [anon_sym_PIPE_AMP] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_LT] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5126),
    [anon_sym_AMP_GT] = ACTIONS(5128),
    [anon_sym_AMP_GT_GT] = ACTIONS(5126),
    [anon_sym_LT_AMP] = ACTIONS(5126),
    [anon_sym_GT_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_LT_LT_DASH] = ACTIONS(5126),
    [anon_sym_LT_LT_LT] = ACTIONS(5126),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5126),
    [anon_sym_AMP] = ACTIONS(5128),
  },
  [2319] = {
    [anon_sym_fi] = ACTIONS(6834),
    [sym_comment] = ACTIONS(57),
  },
  [2320] = {
    [sym_elif_clause] = STATE(1582),
    [sym_else_clause] = STATE(2941),
    [aux_sym_if_statement_repeat1] = STATE(1582),
    [anon_sym_fi] = ACTIONS(6834),
    [anon_sym_elif] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3397),
    [sym_comment] = ACTIONS(57),
  },
  [2321] = {
    [sym__simple_heredoc_body] = ACTIONS(5163),
    [sym__heredoc_body_beginning] = ACTIONS(5163),
    [sym_file_descriptor] = ACTIONS(5163),
    [anon_sym_SEMI] = ACTIONS(5165),
    [anon_sym_PIPE] = ACTIONS(5165),
    [anon_sym_SEMI_SEMI] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_PIPE_AMP] = ACTIONS(5163),
    [anon_sym_AMP_AMP] = ACTIONS(5163),
    [anon_sym_PIPE_PIPE] = ACTIONS(5163),
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_GT_GT] = ACTIONS(5163),
    [anon_sym_AMP_GT] = ACTIONS(5165),
    [anon_sym_AMP_GT_GT] = ACTIONS(5163),
    [anon_sym_LT_AMP] = ACTIONS(5163),
    [anon_sym_GT_AMP] = ACTIONS(5163),
    [anon_sym_LT_LT] = ACTIONS(5165),
    [anon_sym_LT_LT_DASH] = ACTIONS(5163),
    [anon_sym_LT_LT_LT] = ACTIONS(5163),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5163),
    [anon_sym_AMP] = ACTIONS(5165),
  },
  [2322] = {
    [anon_sym_esac] = ACTIONS(6836),
    [sym_comment] = ACTIONS(57),
  },
  [2323] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(2943),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2324] = {
    [sym_case_item] = STATE(2944),
    [sym_last_case_item] = STATE(2943),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2944),
    [anon_sym_esac] = ACTIONS(6838),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [2325] = {
    [sym__simple_heredoc_body] = ACTIONS(5177),
    [sym__heredoc_body_beginning] = ACTIONS(5177),
    [sym_file_descriptor] = ACTIONS(5177),
    [anon_sym_SEMI] = ACTIONS(5179),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_SEMI_SEMI] = ACTIONS(5177),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_PIPE_AMP] = ACTIONS(5177),
    [anon_sym_AMP_AMP] = ACTIONS(5177),
    [anon_sym_PIPE_PIPE] = ACTIONS(5177),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5177),
    [anon_sym_AMP_GT] = ACTIONS(5179),
    [anon_sym_AMP_GT_GT] = ACTIONS(5177),
    [anon_sym_LT_AMP] = ACTIONS(5177),
    [anon_sym_GT_AMP] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_LT_LT_DASH] = ACTIONS(5177),
    [anon_sym_LT_LT_LT] = ACTIONS(5177),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5177),
    [anon_sym_AMP] = ACTIONS(5179),
  },
  [2326] = {
    [anon_sym_esac] = ACTIONS(6840),
    [sym_comment] = ACTIONS(57),
  },
  [2327] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(2946),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2328] = {
    [sym_case_item] = STATE(2947),
    [sym_last_case_item] = STATE(2946),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2947),
    [anon_sym_esac] = ACTIONS(6842),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3433),
  },
  [2329] = {
    [sym__simple_heredoc_body] = ACTIONS(5213),
    [sym__heredoc_body_beginning] = ACTIONS(5213),
    [sym_file_descriptor] = ACTIONS(5213),
    [anon_sym_SEMI] = ACTIONS(5215),
    [anon_sym_PIPE] = ACTIONS(5215),
    [anon_sym_SEMI_SEMI] = ACTIONS(5213),
    [anon_sym_RBRACE] = ACTIONS(5213),
    [anon_sym_PIPE_AMP] = ACTIONS(5213),
    [anon_sym_AMP_AMP] = ACTIONS(5213),
    [anon_sym_PIPE_PIPE] = ACTIONS(5213),
    [anon_sym_LT] = ACTIONS(5215),
    [anon_sym_GT] = ACTIONS(5215),
    [anon_sym_GT_GT] = ACTIONS(5213),
    [anon_sym_AMP_GT] = ACTIONS(5215),
    [anon_sym_AMP_GT_GT] = ACTIONS(5213),
    [anon_sym_LT_AMP] = ACTIONS(5213),
    [anon_sym_GT_AMP] = ACTIONS(5213),
    [anon_sym_LT_LT] = ACTIONS(5215),
    [anon_sym_LT_LT_DASH] = ACTIONS(5213),
    [anon_sym_LT_LT_LT] = ACTIONS(5213),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5213),
    [anon_sym_AMP] = ACTIONS(5215),
  },
  [2330] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2666),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [2331] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(6844),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2332] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4021),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [2333] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_RBRACE] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4035),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [2334] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6846),
    [sym_comment] = ACTIONS(57),
  },
  [2335] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [sym_comment] = ACTIONS(57),
  },
  [2336] = {
    [anon_sym_RBRACE] = ACTIONS(6848),
    [sym_comment] = ACTIONS(57),
  },
  [2337] = {
    [sym_concatenation] = STATE(2953),
    [sym_string] = STATE(2952),
    [sym_simple_expansion] = STATE(2952),
    [sym_string_expansion] = STATE(2952),
    [sym_expansion] = STATE(2952),
    [sym_command_substitution] = STATE(2952),
    [sym_process_substitution] = STATE(2952),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [sym__special_characters] = ACTIONS(6850),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(6852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6852),
  },
  [2338] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2339] = {
    [sym_concatenation] = STATE(2956),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2956),
    [sym_regex] = ACTIONS(6854),
    [anon_sym_RBRACE] = ACTIONS(6856),
    [anon_sym_EQ] = ACTIONS(6858),
    [anon_sym_DASH] = ACTIONS(6858),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6860),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6858),
    [anon_sym_COLON_QMARK] = ACTIONS(6858),
    [anon_sym_COLON_DASH] = ACTIONS(6858),
    [anon_sym_PERCENT] = ACTIONS(6858),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2340] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6856),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2341] = {
    [sym_concatenation] = STATE(2958),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2958),
    [sym_regex] = ACTIONS(6862),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [anon_sym_EQ] = ACTIONS(6864),
    [anon_sym_DASH] = ACTIONS(6864),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6864),
    [anon_sym_COLON_QMARK] = ACTIONS(6864),
    [anon_sym_COLON_DASH] = ACTIONS(6864),
    [anon_sym_PERCENT] = ACTIONS(6864),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2342] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2343] = {
    [sym_concatenation] = STATE(2960),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2960),
    [anon_sym_RBRACE] = ACTIONS(6868),
    [anon_sym_EQ] = ACTIONS(6870),
    [anon_sym_DASH] = ACTIONS(6870),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6872),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6870),
    [anon_sym_COLON_QMARK] = ACTIONS(6870),
    [anon_sym_COLON_DASH] = ACTIONS(6870),
    [anon_sym_PERCENT] = ACTIONS(6870),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2344] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2345] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6868),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2346] = {
    [sym_concatenation] = STATE(2958),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2958),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [anon_sym_EQ] = ACTIONS(6864),
    [anon_sym_DASH] = ACTIONS(6864),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6864),
    [anon_sym_COLON_QMARK] = ACTIONS(6864),
    [anon_sym_COLON_DASH] = ACTIONS(6864),
    [anon_sym_PERCENT] = ACTIONS(6864),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2347] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4021),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [2348] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_RBRACE] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4035),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [2349] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6874),
    [sym_comment] = ACTIONS(57),
  },
  [2350] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6876),
    [sym_comment] = ACTIONS(57),
  },
  [2351] = {
    [anon_sym_RBRACE] = ACTIONS(6876),
    [sym_comment] = ACTIONS(57),
  },
  [2352] = {
    [sym_concatenation] = STATE(2965),
    [sym_string] = STATE(2964),
    [sym_simple_expansion] = STATE(2964),
    [sym_string_expansion] = STATE(2964),
    [sym_expansion] = STATE(2964),
    [sym_command_substitution] = STATE(2964),
    [sym_process_substitution] = STATE(2964),
    [anon_sym_RBRACE] = ACTIONS(6876),
    [sym__special_characters] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(6880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6880),
  },
  [2353] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2354] = {
    [sym_concatenation] = STATE(2968),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2968),
    [sym_regex] = ACTIONS(6882),
    [anon_sym_RBRACE] = ACTIONS(6884),
    [anon_sym_EQ] = ACTIONS(6886),
    [anon_sym_DASH] = ACTIONS(6886),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6886),
    [anon_sym_COLON_QMARK] = ACTIONS(6886),
    [anon_sym_COLON_DASH] = ACTIONS(6886),
    [anon_sym_PERCENT] = ACTIONS(6886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2355] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6884),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2356] = {
    [sym_concatenation] = STATE(2970),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2970),
    [sym_regex] = ACTIONS(6890),
    [anon_sym_RBRACE] = ACTIONS(6876),
    [anon_sym_EQ] = ACTIONS(6892),
    [anon_sym_DASH] = ACTIONS(6892),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6892),
    [anon_sym_COLON_QMARK] = ACTIONS(6892),
    [anon_sym_COLON_DASH] = ACTIONS(6892),
    [anon_sym_PERCENT] = ACTIONS(6892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2357] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6876),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2358] = {
    [sym_concatenation] = STATE(2972),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2972),
    [anon_sym_RBRACE] = ACTIONS(6896),
    [anon_sym_EQ] = ACTIONS(6898),
    [anon_sym_DASH] = ACTIONS(6898),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6898),
    [anon_sym_COLON_QMARK] = ACTIONS(6898),
    [anon_sym_COLON_DASH] = ACTIONS(6898),
    [anon_sym_PERCENT] = ACTIONS(6898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2359] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2360] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6896),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2361] = {
    [sym_concatenation] = STATE(2970),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2970),
    [anon_sym_RBRACE] = ACTIONS(6876),
    [anon_sym_EQ] = ACTIONS(6892),
    [anon_sym_DASH] = ACTIONS(6892),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6892),
    [anon_sym_COLON_QMARK] = ACTIONS(6892),
    [anon_sym_COLON_DASH] = ACTIONS(6892),
    [anon_sym_PERCENT] = ACTIONS(6892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2362] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5545),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2363] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5553),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2364] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6902),
    [sym_comment] = ACTIONS(57),
  },
  [2365] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [sym_comment] = ACTIONS(57),
  },
  [2366] = {
    [anon_sym_RBRACE] = ACTIONS(6904),
    [sym_comment] = ACTIONS(57),
  },
  [2367] = {
    [sym_concatenation] = STATE(2976),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2976),
    [anon_sym_RBRACE] = ACTIONS(6906),
    [anon_sym_EQ] = ACTIONS(6908),
    [anon_sym_DASH] = ACTIONS(6908),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6908),
    [anon_sym_COLON_QMARK] = ACTIONS(6908),
    [anon_sym_COLON_DASH] = ACTIONS(6908),
    [anon_sym_PERCENT] = ACTIONS(6908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2368] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5597),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5597),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2369] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6906),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2370] = {
    [sym_concatenation] = STATE(2977),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2977),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [anon_sym_EQ] = ACTIONS(6912),
    [anon_sym_DASH] = ACTIONS(6912),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6912),
    [anon_sym_COLON_QMARK] = ACTIONS(6912),
    [anon_sym_COLON_DASH] = ACTIONS(6912),
    [anon_sym_PERCENT] = ACTIONS(6912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2371] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2372] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5642),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2373] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6916),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2374] = {
    [aux_sym_concatenation_repeat1] = STATE(2374),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(3736),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2375] = {
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4352),
  },
  [2376] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5543),
    [anon_sym_EQ_EQ] = ACTIONS(5543),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_PLUS_EQ] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_BANG_EQ] = ACTIONS(5543),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_DASH_EQ] = ACTIONS(5543),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_PLUS_PLUS] = ACTIONS(5543),
    [anon_sym_DASH_DASH] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5543),
  },
  [2377] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_RBRACK] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5551),
    [anon_sym_EQ_EQ] = ACTIONS(5551),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_PLUS_EQ] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_BANG_EQ] = ACTIONS(5551),
    [anon_sym_PLUS] = ACTIONS(5553),
    [anon_sym_DASH] = ACTIONS(5553),
    [anon_sym_DASH_EQ] = ACTIONS(5551),
    [anon_sym_LT_EQ] = ACTIONS(5551),
    [anon_sym_GT_EQ] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5551),
  },
  [2378] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6918),
    [sym_comment] = ACTIONS(57),
  },
  [2379] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6920),
    [sym_comment] = ACTIONS(57),
  },
  [2380] = {
    [anon_sym_RBRACE] = ACTIONS(6920),
    [sym_comment] = ACTIONS(57),
  },
  [2381] = {
    [sym_concatenation] = STATE(2982),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2982),
    [anon_sym_RBRACE] = ACTIONS(6922),
    [anon_sym_EQ] = ACTIONS(6924),
    [anon_sym_DASH] = ACTIONS(6924),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6924),
    [anon_sym_COLON_QMARK] = ACTIONS(6924),
    [anon_sym_COLON_DASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2382] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_RBRACK] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5595),
    [anon_sym_EQ_EQ] = ACTIONS(5595),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_PLUS_EQ] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_BANG_EQ] = ACTIONS(5595),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_DASH_EQ] = ACTIONS(5595),
    [anon_sym_LT_EQ] = ACTIONS(5595),
    [anon_sym_GT_EQ] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(5595),
    [anon_sym_DASH_DASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5595),
  },
  [2383] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6922),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2384] = {
    [sym_concatenation] = STATE(2983),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2983),
    [anon_sym_RBRACE] = ACTIONS(6920),
    [anon_sym_EQ] = ACTIONS(6928),
    [anon_sym_DASH] = ACTIONS(6928),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6928),
    [anon_sym_COLON_QMARK] = ACTIONS(6928),
    [anon_sym_COLON_DASH] = ACTIONS(6928),
    [anon_sym_PERCENT] = ACTIONS(6928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2385] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6920),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2386] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_PLUS_EQ] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_DASH_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5640),
  },
  [2387] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6932),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2388] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [ts_builtin_sym_end] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_RPAREN] = ACTIONS(4352),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4354),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [2389] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [ts_builtin_sym_end] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2390] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [ts_builtin_sym_end] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2391] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6934),
    [sym_comment] = ACTIONS(57),
  },
  [2392] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6936),
    [sym_comment] = ACTIONS(57),
  },
  [2393] = {
    [anon_sym_RBRACE] = ACTIONS(6936),
    [sym_comment] = ACTIONS(57),
  },
  [2394] = {
    [sym_concatenation] = STATE(2988),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2988),
    [anon_sym_RBRACE] = ACTIONS(6938),
    [anon_sym_EQ] = ACTIONS(6940),
    [anon_sym_DASH] = ACTIONS(6940),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6940),
    [anon_sym_COLON_QMARK] = ACTIONS(6940),
    [anon_sym_COLON_DASH] = ACTIONS(6940),
    [anon_sym_PERCENT] = ACTIONS(6940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2395] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [ts_builtin_sym_end] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_RPAREN] = ACTIONS(5595),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2396] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6938),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2397] = {
    [sym_concatenation] = STATE(2989),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2989),
    [anon_sym_RBRACE] = ACTIONS(6936),
    [anon_sym_EQ] = ACTIONS(6944),
    [anon_sym_DASH] = ACTIONS(6944),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6944),
    [anon_sym_COLON_QMARK] = ACTIONS(6944),
    [anon_sym_COLON_DASH] = ACTIONS(6944),
    [anon_sym_PERCENT] = ACTIONS(6944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2398] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6936),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2399] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [ts_builtin_sym_end] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2400] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6948),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2401] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [ts_builtin_sym_end] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2402] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [ts_builtin_sym_end] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2403] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6950),
    [sym_comment] = ACTIONS(57),
  },
  [2404] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6952),
    [sym_comment] = ACTIONS(57),
  },
  [2405] = {
    [anon_sym_RBRACE] = ACTIONS(6952),
    [sym_comment] = ACTIONS(57),
  },
  [2406] = {
    [sym_concatenation] = STATE(2994),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2994),
    [anon_sym_RBRACE] = ACTIONS(6954),
    [anon_sym_EQ] = ACTIONS(6956),
    [anon_sym_DASH] = ACTIONS(6956),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6956),
    [anon_sym_COLON_QMARK] = ACTIONS(6956),
    [anon_sym_COLON_DASH] = ACTIONS(6956),
    [anon_sym_PERCENT] = ACTIONS(6956),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2407] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [ts_builtin_sym_end] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_RPAREN] = ACTIONS(5595),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2408] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6954),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2409] = {
    [sym_concatenation] = STATE(2995),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(2995),
    [anon_sym_RBRACE] = ACTIONS(6952),
    [anon_sym_EQ] = ACTIONS(6960),
    [anon_sym_DASH] = ACTIONS(6960),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6960),
    [anon_sym_COLON_QMARK] = ACTIONS(6960),
    [anon_sym_COLON_DASH] = ACTIONS(6960),
    [anon_sym_PERCENT] = ACTIONS(6960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2410] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6952),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2411] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [ts_builtin_sym_end] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2412] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6964),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2413] = {
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5543),
  },
  [2414] = {
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5551),
  },
  [2415] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6966),
    [sym_comment] = ACTIONS(57),
  },
  [2416] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6968),
    [sym_comment] = ACTIONS(57),
  },
  [2417] = {
    [anon_sym_RBRACE] = ACTIONS(6968),
    [sym_comment] = ACTIONS(57),
  },
  [2418] = {
    [sym_concatenation] = STATE(3000),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3000),
    [anon_sym_RBRACE] = ACTIONS(6970),
    [anon_sym_EQ] = ACTIONS(6972),
    [anon_sym_DASH] = ACTIONS(6972),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6974),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6972),
    [anon_sym_COLON_QMARK] = ACTIONS(6972),
    [anon_sym_COLON_DASH] = ACTIONS(6972),
    [anon_sym_PERCENT] = ACTIONS(6972),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2419] = {
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_RPAREN] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5595),
  },
  [2420] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6970),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2421] = {
    [sym_concatenation] = STATE(3001),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3001),
    [anon_sym_RBRACE] = ACTIONS(6968),
    [anon_sym_EQ] = ACTIONS(6976),
    [anon_sym_DASH] = ACTIONS(6976),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6978),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6976),
    [anon_sym_COLON_QMARK] = ACTIONS(6976),
    [anon_sym_COLON_DASH] = ACTIONS(6976),
    [anon_sym_PERCENT] = ACTIONS(6976),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2422] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6968),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2423] = {
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5640),
  },
  [2424] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6980),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2425] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5545),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym__string_content] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5545),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5545),
    [anon_sym_BQUOTE] = ACTIONS(5545),
    [sym_comment] = ACTIONS(343),
  },
  [2426] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5553),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym__string_content] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5553),
    [anon_sym_BQUOTE] = ACTIONS(5553),
    [sym_comment] = ACTIONS(343),
  },
  [2427] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6982),
    [sym_comment] = ACTIONS(57),
  },
  [2428] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [sym_comment] = ACTIONS(57),
  },
  [2429] = {
    [anon_sym_RBRACE] = ACTIONS(6984),
    [sym_comment] = ACTIONS(57),
  },
  [2430] = {
    [sym_concatenation] = STATE(3006),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3006),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_EQ] = ACTIONS(6988),
    [anon_sym_DASH] = ACTIONS(6988),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6988),
    [anon_sym_COLON_QMARK] = ACTIONS(6988),
    [anon_sym_COLON_DASH] = ACTIONS(6988),
    [anon_sym_PERCENT] = ACTIONS(6988),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2431] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym__string_content] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5597),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5597),
    [anon_sym_BQUOTE] = ACTIONS(5597),
    [sym_comment] = ACTIONS(343),
  },
  [2432] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2433] = {
    [sym_concatenation] = STATE(3007),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3007),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [anon_sym_EQ] = ACTIONS(6992),
    [anon_sym_DASH] = ACTIONS(6992),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(6994),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(6992),
    [anon_sym_COLON_QMARK] = ACTIONS(6992),
    [anon_sym_COLON_DASH] = ACTIONS(6992),
    [anon_sym_PERCENT] = ACTIONS(6992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2434] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2435] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5642),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym__string_content] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5642),
    [anon_sym_BQUOTE] = ACTIONS(5642),
    [sym_comment] = ACTIONS(343),
  },
  [2436] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2437] = {
    [sym__concat] = ACTIONS(6998),
    [anon_sym_RBRACE] = ACTIONS(4310),
    [anon_sym_EQ] = ACTIONS(7000),
    [anon_sym_DASH] = ACTIONS(7000),
    [sym__special_characters] = ACTIONS(7000),
    [anon_sym_DQUOTE] = ACTIONS(4310),
    [anon_sym_DOLLAR] = ACTIONS(7000),
    [sym_raw_string] = ACTIONS(4310),
    [anon_sym_POUND] = ACTIONS(4310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4310),
    [anon_sym_SLASH] = ACTIONS(4310),
    [anon_sym_COLON] = ACTIONS(7000),
    [anon_sym_COLON_QMARK] = ACTIONS(7000),
    [anon_sym_COLON_DASH] = ACTIONS(7000),
    [anon_sym_PERCENT] = ACTIONS(7000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4310),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [anon_sym_LT_LPAREN] = ACTIONS(4310),
    [anon_sym_GT_LPAREN] = ACTIONS(4310),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7000),
  },
  [2438] = {
    [anon_sym_RBRACE] = ACTIONS(4310),
    [anon_sym_EQ] = ACTIONS(7000),
    [anon_sym_DASH] = ACTIONS(7000),
    [sym__special_characters] = ACTIONS(7000),
    [anon_sym_DQUOTE] = ACTIONS(4310),
    [anon_sym_DOLLAR] = ACTIONS(7000),
    [sym_raw_string] = ACTIONS(4310),
    [anon_sym_POUND] = ACTIONS(4310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4310),
    [anon_sym_SLASH] = ACTIONS(4310),
    [anon_sym_COLON] = ACTIONS(7000),
    [anon_sym_COLON_QMARK] = ACTIONS(7000),
    [anon_sym_COLON_DASH] = ACTIONS(7000),
    [anon_sym_PERCENT] = ACTIONS(7000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4310),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [anon_sym_LT_LPAREN] = ACTIONS(4310),
    [anon_sym_GT_LPAREN] = ACTIONS(4310),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7000),
  },
  [2439] = {
    [sym__concat] = ACTIONS(7002),
    [anon_sym_RBRACE] = ACTIONS(4314),
    [anon_sym_EQ] = ACTIONS(7004),
    [anon_sym_DASH] = ACTIONS(7004),
    [sym__special_characters] = ACTIONS(7004),
    [anon_sym_DQUOTE] = ACTIONS(4314),
    [anon_sym_DOLLAR] = ACTIONS(7004),
    [sym_raw_string] = ACTIONS(4314),
    [anon_sym_POUND] = ACTIONS(4314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_COLON] = ACTIONS(7004),
    [anon_sym_COLON_QMARK] = ACTIONS(7004),
    [anon_sym_COLON_DASH] = ACTIONS(7004),
    [anon_sym_PERCENT] = ACTIONS(7004),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4314),
    [anon_sym_BQUOTE] = ACTIONS(4314),
    [anon_sym_LT_LPAREN] = ACTIONS(4314),
    [anon_sym_GT_LPAREN] = ACTIONS(4314),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7004),
  },
  [2440] = {
    [anon_sym_RBRACE] = ACTIONS(4314),
    [anon_sym_EQ] = ACTIONS(7004),
    [anon_sym_DASH] = ACTIONS(7004),
    [sym__special_characters] = ACTIONS(7004),
    [anon_sym_DQUOTE] = ACTIONS(4314),
    [anon_sym_DOLLAR] = ACTIONS(7004),
    [sym_raw_string] = ACTIONS(4314),
    [anon_sym_POUND] = ACTIONS(4314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4314),
    [anon_sym_COLON] = ACTIONS(7004),
    [anon_sym_COLON_QMARK] = ACTIONS(7004),
    [anon_sym_COLON_DASH] = ACTIONS(7004),
    [anon_sym_PERCENT] = ACTIONS(7004),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4314),
    [anon_sym_BQUOTE] = ACTIONS(4314),
    [anon_sym_LT_LPAREN] = ACTIONS(4314),
    [anon_sym_GT_LPAREN] = ACTIONS(4314),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7004),
  },
  [2441] = {
    [sym__concat] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
  },
  [2442] = {
    [aux_sym_concatenation_repeat1] = STATE(2442),
    [sym__concat] = ACTIONS(7006),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
  },
  [2443] = {
    [sym__concat] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
  },
  [2444] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7009),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2445] = {
    [sym_concatenation] = STATE(3015),
    [sym_string] = STATE(3014),
    [sym_simple_expansion] = STATE(3014),
    [sym_string_expansion] = STATE(3014),
    [sym_expansion] = STATE(3014),
    [sym_command_substitution] = STATE(3014),
    [sym_process_substitution] = STATE(3014),
    [anon_sym_RBRACE] = ACTIONS(7011),
    [sym__special_characters] = ACTIONS(7013),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7015),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7015),
  },
  [2446] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7017),
    [sym_comment] = ACTIONS(57),
  },
  [2447] = {
    [sym_concatenation] = STATE(3019),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3019),
    [anon_sym_RBRACE] = ACTIONS(7019),
    [anon_sym_EQ] = ACTIONS(7021),
    [anon_sym_DASH] = ACTIONS(7021),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7025),
    [anon_sym_COLON] = ACTIONS(7021),
    [anon_sym_COLON_QMARK] = ACTIONS(7021),
    [anon_sym_COLON_DASH] = ACTIONS(7021),
    [anon_sym_PERCENT] = ACTIONS(7021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2448] = {
    [sym_concatenation] = STATE(3021),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3021),
    [anon_sym_RBRACE] = ACTIONS(7011),
    [anon_sym_EQ] = ACTIONS(7027),
    [anon_sym_DASH] = ACTIONS(7027),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7029),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7031),
    [anon_sym_COLON] = ACTIONS(7027),
    [anon_sym_COLON_QMARK] = ACTIONS(7027),
    [anon_sym_COLON_DASH] = ACTIONS(7027),
    [anon_sym_PERCENT] = ACTIONS(7027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2449] = {
    [sym__concat] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
  },
  [2450] = {
    [sym_concatenation] = STATE(3024),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3024),
    [sym_regex] = ACTIONS(7033),
    [anon_sym_RBRACE] = ACTIONS(7035),
    [anon_sym_EQ] = ACTIONS(7037),
    [anon_sym_DASH] = ACTIONS(7037),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7039),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7037),
    [anon_sym_COLON_QMARK] = ACTIONS(7037),
    [anon_sym_COLON_DASH] = ACTIONS(7037),
    [anon_sym_PERCENT] = ACTIONS(7037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2451] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7035),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2452] = {
    [sym__concat] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
  },
  [2453] = {
    [sym_concatenation] = STATE(3021),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3021),
    [sym_regex] = ACTIONS(7041),
    [anon_sym_RBRACE] = ACTIONS(7011),
    [anon_sym_EQ] = ACTIONS(7027),
    [anon_sym_DASH] = ACTIONS(7027),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7029),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7027),
    [anon_sym_COLON_QMARK] = ACTIONS(7027),
    [anon_sym_COLON_DASH] = ACTIONS(7027),
    [anon_sym_PERCENT] = ACTIONS(7027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2454] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7011),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2455] = {
    [sym__concat] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
  },
  [2456] = {
    [sym__concat] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
  },
  [2457] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [ts_builtin_sym_end] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7045),
    [anon_sym_EQ_EQ] = ACTIONS(7045),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [2458] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [ts_builtin_sym_end] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_RPAREN] = ACTIONS(7047),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7049),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [2459] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [ts_builtin_sym_end] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_RPAREN] = ACTIONS(7051),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_EQ_EQ] = ACTIONS(7053),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [2460] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7055),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2461] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7057),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2462] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [sym__special_characters] = ACTIONS(4021),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_POUND] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_COLON] = ACTIONS(4021),
    [anon_sym_COLON_QMARK] = ACTIONS(4021),
    [anon_sym_COLON_DASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4021),
  },
  [2463] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_RBRACE] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4035),
    [sym__special_characters] = ACTIONS(4035),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_POUND] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4035),
    [anon_sym_COLON_QMARK] = ACTIONS(4035),
    [anon_sym_COLON_DASH] = ACTIONS(4035),
    [anon_sym_PERCENT] = ACTIONS(4035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4035),
  },
  [2464] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7059),
    [sym_comment] = ACTIONS(57),
  },
  [2465] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7061),
    [sym_comment] = ACTIONS(57),
  },
  [2466] = {
    [anon_sym_RBRACE] = ACTIONS(7061),
    [sym_comment] = ACTIONS(57),
  },
  [2467] = {
    [sym_concatenation] = STATE(3032),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [anon_sym_RBRACE] = ACTIONS(7061),
    [sym__special_characters] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7065),
  },
  [2468] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4069),
    [anon_sym_EQ] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4071),
    [sym__special_characters] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_POUND] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_COLON] = ACTIONS(4071),
    [anon_sym_COLON_QMARK] = ACTIONS(4071),
    [anon_sym_COLON_DASH] = ACTIONS(4071),
    [anon_sym_PERCENT] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4071),
  },
  [2469] = {
    [sym_concatenation] = STATE(3035),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3035),
    [sym_regex] = ACTIONS(7067),
    [anon_sym_RBRACE] = ACTIONS(7069),
    [anon_sym_EQ] = ACTIONS(7071),
    [anon_sym_DASH] = ACTIONS(7071),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7071),
    [anon_sym_COLON_QMARK] = ACTIONS(7071),
    [anon_sym_COLON_DASH] = ACTIONS(7071),
    [anon_sym_PERCENT] = ACTIONS(7071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2470] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7069),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2471] = {
    [sym_concatenation] = STATE(3037),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3037),
    [sym_regex] = ACTIONS(7075),
    [anon_sym_RBRACE] = ACTIONS(7061),
    [anon_sym_EQ] = ACTIONS(7077),
    [anon_sym_DASH] = ACTIONS(7077),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7077),
    [anon_sym_COLON_QMARK] = ACTIONS(7077),
    [anon_sym_COLON_DASH] = ACTIONS(7077),
    [anon_sym_PERCENT] = ACTIONS(7077),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2472] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7061),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2473] = {
    [sym_concatenation] = STATE(3039),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3039),
    [anon_sym_RBRACE] = ACTIONS(7081),
    [anon_sym_EQ] = ACTIONS(7083),
    [anon_sym_DASH] = ACTIONS(7083),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7083),
    [anon_sym_COLON_QMARK] = ACTIONS(7083),
    [anon_sym_COLON_DASH] = ACTIONS(7083),
    [anon_sym_PERCENT] = ACTIONS(7083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2474] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [sym__special_characters] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_POUND] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_COLON] = ACTIONS(4127),
    [anon_sym_COLON_QMARK] = ACTIONS(4127),
    [anon_sym_COLON_DASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4127),
  },
  [2475] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7081),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2476] = {
    [sym_concatenation] = STATE(3037),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3037),
    [anon_sym_RBRACE] = ACTIONS(7061),
    [anon_sym_EQ] = ACTIONS(7077),
    [anon_sym_DASH] = ACTIONS(7077),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7077),
    [anon_sym_COLON_QMARK] = ACTIONS(7077),
    [anon_sym_COLON_DASH] = ACTIONS(7077),
    [anon_sym_PERCENT] = ACTIONS(7077),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2477] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [ts_builtin_sym_end] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_RPAREN] = ACTIONS(7087),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7089),
    [anon_sym_EQ_EQ] = ACTIONS(7089),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [2478] = {
    [aux_sym_concatenation_repeat1] = STATE(2478),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(4382),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2479] = {
    [aux_sym_concatenation_repeat1] = STATE(2479),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2480] = {
    [sym__heredoc_body_middle] = ACTIONS(4033),
    [sym__heredoc_body_end] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
  },
  [2481] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7091),
    [sym_comment] = ACTIONS(57),
  },
  [2482] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7093),
    [sym_comment] = ACTIONS(57),
  },
  [2483] = {
    [anon_sym_RBRACE] = ACTIONS(7093),
    [sym_comment] = ACTIONS(57),
  },
  [2484] = {
    [sym_concatenation] = STATE(3044),
    [sym_string] = STATE(3043),
    [sym_simple_expansion] = STATE(3043),
    [sym_string_expansion] = STATE(3043),
    [sym_expansion] = STATE(3043),
    [sym_command_substitution] = STATE(3043),
    [sym_process_substitution] = STATE(3043),
    [anon_sym_RBRACE] = ACTIONS(7093),
    [sym__special_characters] = ACTIONS(7095),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7097),
  },
  [2485] = {
    [sym__heredoc_body_middle] = ACTIONS(4069),
    [sym__heredoc_body_end] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
  },
  [2486] = {
    [sym_concatenation] = STATE(3047),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3047),
    [sym_regex] = ACTIONS(7099),
    [anon_sym_RBRACE] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(7103),
    [anon_sym_DASH] = ACTIONS(7103),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7103),
    [anon_sym_COLON_QMARK] = ACTIONS(7103),
    [anon_sym_COLON_DASH] = ACTIONS(7103),
    [anon_sym_PERCENT] = ACTIONS(7103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2487] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2488] = {
    [sym_concatenation] = STATE(3049),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3049),
    [sym_regex] = ACTIONS(7107),
    [anon_sym_RBRACE] = ACTIONS(7093),
    [anon_sym_EQ] = ACTIONS(7109),
    [anon_sym_DASH] = ACTIONS(7109),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7109),
    [anon_sym_COLON_QMARK] = ACTIONS(7109),
    [anon_sym_COLON_DASH] = ACTIONS(7109),
    [anon_sym_PERCENT] = ACTIONS(7109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2489] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7093),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2490] = {
    [sym_concatenation] = STATE(3051),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3051),
    [anon_sym_RBRACE] = ACTIONS(7113),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_DASH] = ACTIONS(7115),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_COLON_QMARK] = ACTIONS(7115),
    [anon_sym_COLON_DASH] = ACTIONS(7115),
    [anon_sym_PERCENT] = ACTIONS(7115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2491] = {
    [sym__heredoc_body_middle] = ACTIONS(4125),
    [sym__heredoc_body_end] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
  },
  [2492] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7113),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2493] = {
    [sym_concatenation] = STATE(3049),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3049),
    [anon_sym_RBRACE] = ACTIONS(7093),
    [anon_sym_EQ] = ACTIONS(7109),
    [anon_sym_DASH] = ACTIONS(7109),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7109),
    [anon_sym_COLON_QMARK] = ACTIONS(7109),
    [anon_sym_COLON_DASH] = ACTIONS(7109),
    [anon_sym_PERCENT] = ACTIONS(7109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2494] = {
    [aux_sym_concatenation_repeat1] = STATE(2496),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [2495] = {
    [aux_sym_concatenation_repeat1] = STATE(2496),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2496] = {
    [aux_sym_concatenation_repeat1] = STATE(3052),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2497] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4019),
  },
  [2498] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4033),
  },
  [2499] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [sym_comment] = ACTIONS(57),
  },
  [2500] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7121),
    [sym_comment] = ACTIONS(57),
  },
  [2501] = {
    [anon_sym_RBRACE] = ACTIONS(7121),
    [sym_comment] = ACTIONS(57),
  },
  [2502] = {
    [sym_concatenation] = STATE(3057),
    [sym_string] = STATE(3056),
    [sym_simple_expansion] = STATE(3056),
    [sym_string_expansion] = STATE(3056),
    [sym_expansion] = STATE(3056),
    [sym_command_substitution] = STATE(3056),
    [sym_process_substitution] = STATE(3056),
    [anon_sym_RBRACE] = ACTIONS(7121),
    [sym__special_characters] = ACTIONS(7123),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7125),
  },
  [2503] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
  },
  [2504] = {
    [sym_concatenation] = STATE(3060),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3060),
    [sym_regex] = ACTIONS(7127),
    [anon_sym_RBRACE] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7131),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7131),
    [anon_sym_COLON_QMARK] = ACTIONS(7131),
    [anon_sym_COLON_DASH] = ACTIONS(7131),
    [anon_sym_PERCENT] = ACTIONS(7131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2505] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7129),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2506] = {
    [sym_concatenation] = STATE(3062),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3062),
    [sym_regex] = ACTIONS(7135),
    [anon_sym_RBRACE] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_DASH] = ACTIONS(7137),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_COLON_QMARK] = ACTIONS(7137),
    [anon_sym_COLON_DASH] = ACTIONS(7137),
    [anon_sym_PERCENT] = ACTIONS(7137),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2507] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2508] = {
    [sym_concatenation] = STATE(3064),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3064),
    [anon_sym_RBRACE] = ACTIONS(7141),
    [anon_sym_EQ] = ACTIONS(7143),
    [anon_sym_DASH] = ACTIONS(7143),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7143),
    [anon_sym_COLON_QMARK] = ACTIONS(7143),
    [anon_sym_COLON_DASH] = ACTIONS(7143),
    [anon_sym_PERCENT] = ACTIONS(7143),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2509] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4125),
  },
  [2510] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7141),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2511] = {
    [sym_concatenation] = STATE(3062),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3062),
    [anon_sym_RBRACE] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7137),
    [anon_sym_DASH] = ACTIONS(7137),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7137),
    [anon_sym_COLON_QMARK] = ACTIONS(7137),
    [anon_sym_COLON_DASH] = ACTIONS(7137),
    [anon_sym_PERCENT] = ACTIONS(7137),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2512] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [ts_builtin_sym_end] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2513] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [ts_builtin_sym_end] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2514] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7147),
    [sym_comment] = ACTIONS(57),
  },
  [2515] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7149),
    [sym_comment] = ACTIONS(57),
  },
  [2516] = {
    [anon_sym_RBRACE] = ACTIONS(7149),
    [sym_comment] = ACTIONS(57),
  },
  [2517] = {
    [sym_concatenation] = STATE(3068),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3068),
    [anon_sym_RBRACE] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(7153),
    [anon_sym_DASH] = ACTIONS(7153),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7155),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7153),
    [anon_sym_COLON_QMARK] = ACTIONS(7153),
    [anon_sym_COLON_DASH] = ACTIONS(7153),
    [anon_sym_PERCENT] = ACTIONS(7153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2518] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [ts_builtin_sym_end] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_RPAREN] = ACTIONS(5595),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2519] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2520] = {
    [sym_concatenation] = STATE(3069),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3069),
    [anon_sym_RBRACE] = ACTIONS(7149),
    [anon_sym_EQ] = ACTIONS(7157),
    [anon_sym_DASH] = ACTIONS(7157),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7157),
    [anon_sym_COLON_QMARK] = ACTIONS(7157),
    [anon_sym_COLON_DASH] = ACTIONS(7157),
    [anon_sym_PERCENT] = ACTIONS(7157),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2521] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7149),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2522] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [ts_builtin_sym_end] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2523] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7161),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2524] = {
    [sym__simple_heredoc_body] = ACTIONS(7163),
    [sym__heredoc_body_beginning] = ACTIONS(7163),
    [sym_file_descriptor] = ACTIONS(7163),
    [ts_builtin_sym_end] = ACTIONS(7163),
    [anon_sym_SEMI] = ACTIONS(7165),
    [anon_sym_done] = ACTIONS(7163),
    [anon_sym_fi] = ACTIONS(7163),
    [anon_sym_elif] = ACTIONS(7163),
    [anon_sym_else] = ACTIONS(7163),
    [anon_sym_esac] = ACTIONS(7163),
    [anon_sym_PIPE] = ACTIONS(7165),
    [anon_sym_RPAREN] = ACTIONS(7163),
    [anon_sym_SEMI_SEMI] = ACTIONS(7163),
    [anon_sym_PIPE_AMP] = ACTIONS(7163),
    [anon_sym_AMP_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7163),
    [anon_sym_LT] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7165),
    [anon_sym_GT_GT] = ACTIONS(7163),
    [anon_sym_AMP_GT] = ACTIONS(7165),
    [anon_sym_AMP_GT_GT] = ACTIONS(7163),
    [anon_sym_LT_AMP] = ACTIONS(7163),
    [anon_sym_GT_AMP] = ACTIONS(7163),
    [anon_sym_LT_LT] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7163),
    [anon_sym_LT_LT_LT] = ACTIONS(7163),
    [anon_sym_BQUOTE] = ACTIONS(7163),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7165),
  },
  [2525] = {
    [sym_do_group] = STATE(3071),
    [sym_compound_statement] = STATE(3071),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2526] = {
    [sym_do_group] = STATE(3071),
    [sym_compound_statement] = STATE(3071),
    [anon_sym_SEMI] = ACTIONS(7167),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2527] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5543),
    [anon_sym_EQ_EQ] = ACTIONS(5543),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_PLUS_EQ] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_BANG_EQ] = ACTIONS(5543),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_DASH_EQ] = ACTIONS(5543),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_PLUS_PLUS] = ACTIONS(5543),
    [anon_sym_DASH_DASH] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5543),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2528] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5551),
    [anon_sym_EQ_EQ] = ACTIONS(5551),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_PLUS_EQ] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_BANG_EQ] = ACTIONS(5551),
    [anon_sym_PLUS] = ACTIONS(5553),
    [anon_sym_DASH] = ACTIONS(5553),
    [anon_sym_DASH_EQ] = ACTIONS(5551),
    [anon_sym_LT_EQ] = ACTIONS(5551),
    [anon_sym_GT_EQ] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5551),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2529] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7169),
    [sym_comment] = ACTIONS(57),
  },
  [2530] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7171),
    [sym_comment] = ACTIONS(57),
  },
  [2531] = {
    [anon_sym_RBRACE] = ACTIONS(7171),
    [sym_comment] = ACTIONS(57),
  },
  [2532] = {
    [sym_concatenation] = STATE(3076),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3076),
    [anon_sym_RBRACE] = ACTIONS(7173),
    [anon_sym_EQ] = ACTIONS(7175),
    [anon_sym_DASH] = ACTIONS(7175),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7175),
    [anon_sym_COLON_QMARK] = ACTIONS(7175),
    [anon_sym_COLON_DASH] = ACTIONS(7175),
    [anon_sym_PERCENT] = ACTIONS(7175),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2533] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5595),
    [anon_sym_EQ_EQ] = ACTIONS(5595),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_PLUS_EQ] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_BANG_EQ] = ACTIONS(5595),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_DASH_EQ] = ACTIONS(5595),
    [anon_sym_LT_EQ] = ACTIONS(5595),
    [anon_sym_GT_EQ] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(5595),
    [anon_sym_DASH_DASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5595),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2534] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7173),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2535] = {
    [sym_concatenation] = STATE(3077),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3077),
    [anon_sym_RBRACE] = ACTIONS(7171),
    [anon_sym_EQ] = ACTIONS(7179),
    [anon_sym_DASH] = ACTIONS(7179),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7179),
    [anon_sym_COLON_QMARK] = ACTIONS(7179),
    [anon_sym_COLON_DASH] = ACTIONS(7179),
    [anon_sym_PERCENT] = ACTIONS(7179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2536] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7171),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2537] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_PLUS_EQ] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_DASH_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5640),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2538] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7183),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2539] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7185),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [2540] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4019),
  },
  [2541] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4033),
  },
  [2542] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7187),
    [sym_comment] = ACTIONS(57),
  },
  [2543] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7189),
    [sym_comment] = ACTIONS(57),
  },
  [2544] = {
    [anon_sym_RBRACE] = ACTIONS(7189),
    [sym_comment] = ACTIONS(57),
  },
  [2545] = {
    [sym_concatenation] = STATE(3084),
    [sym_string] = STATE(3083),
    [sym_simple_expansion] = STATE(3083),
    [sym_string_expansion] = STATE(3083),
    [sym_expansion] = STATE(3083),
    [sym_command_substitution] = STATE(3083),
    [sym_process_substitution] = STATE(3083),
    [anon_sym_RBRACE] = ACTIONS(7189),
    [sym__special_characters] = ACTIONS(7191),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7193),
  },
  [2546] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2547] = {
    [sym_concatenation] = STATE(3087),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3087),
    [sym_regex] = ACTIONS(7195),
    [anon_sym_RBRACE] = ACTIONS(7197),
    [anon_sym_EQ] = ACTIONS(7199),
    [anon_sym_DASH] = ACTIONS(7199),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7199),
    [anon_sym_COLON_QMARK] = ACTIONS(7199),
    [anon_sym_COLON_DASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2548] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7197),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2549] = {
    [sym_concatenation] = STATE(3089),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3089),
    [sym_regex] = ACTIONS(7203),
    [anon_sym_RBRACE] = ACTIONS(7189),
    [anon_sym_EQ] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(7205),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7205),
    [anon_sym_COLON_QMARK] = ACTIONS(7205),
    [anon_sym_COLON_DASH] = ACTIONS(7205),
    [anon_sym_PERCENT] = ACTIONS(7205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2550] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7189),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2551] = {
    [sym_concatenation] = STATE(3091),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3091),
    [anon_sym_RBRACE] = ACTIONS(7209),
    [anon_sym_EQ] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7211),
    [anon_sym_COLON_QMARK] = ACTIONS(7211),
    [anon_sym_COLON_DASH] = ACTIONS(7211),
    [anon_sym_PERCENT] = ACTIONS(7211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2552] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4125),
  },
  [2553] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7209),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2554] = {
    [sym_concatenation] = STATE(3089),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3089),
    [anon_sym_RBRACE] = ACTIONS(7189),
    [anon_sym_EQ] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(7205),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7205),
    [anon_sym_COLON_QMARK] = ACTIONS(7205),
    [anon_sym_COLON_DASH] = ACTIONS(7205),
    [anon_sym_PERCENT] = ACTIONS(7205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2555] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5543),
    [anon_sym_EQ_EQ] = ACTIONS(5543),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_PLUS_EQ] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_BANG_EQ] = ACTIONS(5543),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_DASH_EQ] = ACTIONS(5543),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_PLUS_PLUS] = ACTIONS(5543),
    [anon_sym_DASH_DASH] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5543),
  },
  [2556] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5551),
    [anon_sym_EQ_EQ] = ACTIONS(5551),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_PLUS_EQ] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_BANG_EQ] = ACTIONS(5551),
    [anon_sym_PLUS] = ACTIONS(5553),
    [anon_sym_DASH] = ACTIONS(5553),
    [anon_sym_DASH_EQ] = ACTIONS(5551),
    [anon_sym_LT_EQ] = ACTIONS(5551),
    [anon_sym_GT_EQ] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5551),
  },
  [2557] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7215),
    [sym_comment] = ACTIONS(57),
  },
  [2558] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7217),
    [sym_comment] = ACTIONS(57),
  },
  [2559] = {
    [anon_sym_RBRACE] = ACTIONS(7217),
    [sym_comment] = ACTIONS(57),
  },
  [2560] = {
    [sym_concatenation] = STATE(3095),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3095),
    [anon_sym_RBRACE] = ACTIONS(7219),
    [anon_sym_EQ] = ACTIONS(7221),
    [anon_sym_DASH] = ACTIONS(7221),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7223),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7221),
    [anon_sym_COLON_QMARK] = ACTIONS(7221),
    [anon_sym_COLON_DASH] = ACTIONS(7221),
    [anon_sym_PERCENT] = ACTIONS(7221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2561] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_RPAREN] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5595),
    [anon_sym_EQ_EQ] = ACTIONS(5595),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_PLUS_EQ] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_BANG_EQ] = ACTIONS(5595),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_DASH_EQ] = ACTIONS(5595),
    [anon_sym_LT_EQ] = ACTIONS(5595),
    [anon_sym_GT_EQ] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(5595),
    [anon_sym_DASH_DASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5595),
  },
  [2562] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7219),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2563] = {
    [sym_concatenation] = STATE(3096),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3096),
    [anon_sym_RBRACE] = ACTIONS(7217),
    [anon_sym_EQ] = ACTIONS(7225),
    [anon_sym_DASH] = ACTIONS(7225),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7225),
    [anon_sym_COLON_QMARK] = ACTIONS(7225),
    [anon_sym_COLON_DASH] = ACTIONS(7225),
    [anon_sym_PERCENT] = ACTIONS(7225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2564] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7217),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2565] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_PLUS_EQ] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_DASH_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5640),
  },
  [2566] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7229),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2567] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7043),
    [anon_sym_EQ_EQ] = ACTIONS(7043),
    [anon_sym_EQ] = ACTIONS(7045),
    [anon_sym_PLUS_EQ] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_BANG_EQ] = ACTIONS(7043),
    [anon_sym_PLUS] = ACTIONS(7045),
    [anon_sym_DASH] = ACTIONS(7045),
    [anon_sym_DASH_EQ] = ACTIONS(7043),
    [anon_sym_LT_EQ] = ACTIONS(7043),
    [anon_sym_GT_EQ] = ACTIONS(7043),
    [anon_sym_PLUS_PLUS] = ACTIONS(7043),
    [anon_sym_DASH_DASH] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7043),
  },
  [2568] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7047),
    [anon_sym_EQ_EQ] = ACTIONS(7047),
    [anon_sym_EQ] = ACTIONS(7049),
    [anon_sym_PLUS_EQ] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_BANG_EQ] = ACTIONS(7047),
    [anon_sym_PLUS] = ACTIONS(7049),
    [anon_sym_DASH] = ACTIONS(7049),
    [anon_sym_DASH_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_GT_EQ] = ACTIONS(7047),
    [anon_sym_PLUS_PLUS] = ACTIONS(7047),
    [anon_sym_DASH_DASH] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7047),
  },
  [2569] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7051),
    [anon_sym_EQ_EQ] = ACTIONS(7051),
    [anon_sym_EQ] = ACTIONS(7053),
    [anon_sym_PLUS_EQ] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_BANG_EQ] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_EQ] = ACTIONS(7051),
    [anon_sym_LT_EQ] = ACTIONS(7051),
    [anon_sym_GT_EQ] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7051),
  },
  [2570] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7231),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2571] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7233),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2572] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7087),
    [anon_sym_EQ_EQ] = ACTIONS(7087),
    [anon_sym_EQ] = ACTIONS(7089),
    [anon_sym_PLUS_EQ] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_BANG_EQ] = ACTIONS(7087),
    [anon_sym_PLUS] = ACTIONS(7089),
    [anon_sym_DASH] = ACTIONS(7089),
    [anon_sym_DASH_EQ] = ACTIONS(7087),
    [anon_sym_LT_EQ] = ACTIONS(7087),
    [anon_sym_GT_EQ] = ACTIONS(7087),
    [anon_sym_PLUS_PLUS] = ACTIONS(7087),
    [anon_sym_DASH_DASH] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7087),
  },
  [2573] = {
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [2574] = {
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [2575] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7235),
    [sym_comment] = ACTIONS(57),
  },
  [2576] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7237),
    [sym_comment] = ACTIONS(57),
  },
  [2577] = {
    [anon_sym_RBRACE] = ACTIONS(7237),
    [sym_comment] = ACTIONS(57),
  },
  [2578] = {
    [sym_concatenation] = STATE(3104),
    [sym_string] = STATE(3103),
    [sym_simple_expansion] = STATE(3103),
    [sym_string_expansion] = STATE(3103),
    [sym_expansion] = STATE(3103),
    [sym_command_substitution] = STATE(3103),
    [sym_process_substitution] = STATE(3103),
    [anon_sym_RBRACE] = ACTIONS(7237),
    [sym__special_characters] = ACTIONS(7239),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7241),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7241),
  },
  [2579] = {
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2580] = {
    [sym_concatenation] = STATE(3107),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3107),
    [sym_regex] = ACTIONS(7243),
    [anon_sym_RBRACE] = ACTIONS(7245),
    [anon_sym_EQ] = ACTIONS(7247),
    [anon_sym_DASH] = ACTIONS(7247),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7247),
    [anon_sym_COLON_QMARK] = ACTIONS(7247),
    [anon_sym_COLON_DASH] = ACTIONS(7247),
    [anon_sym_PERCENT] = ACTIONS(7247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2581] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7245),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2582] = {
    [sym_concatenation] = STATE(3109),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3109),
    [sym_regex] = ACTIONS(7251),
    [anon_sym_RBRACE] = ACTIONS(7237),
    [anon_sym_EQ] = ACTIONS(7253),
    [anon_sym_DASH] = ACTIONS(7253),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7253),
    [anon_sym_COLON_QMARK] = ACTIONS(7253),
    [anon_sym_COLON_DASH] = ACTIONS(7253),
    [anon_sym_PERCENT] = ACTIONS(7253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2583] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7237),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2584] = {
    [sym_concatenation] = STATE(3111),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3111),
    [anon_sym_RBRACE] = ACTIONS(7257),
    [anon_sym_EQ] = ACTIONS(7259),
    [anon_sym_DASH] = ACTIONS(7259),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7259),
    [anon_sym_COLON_QMARK] = ACTIONS(7259),
    [anon_sym_COLON_DASH] = ACTIONS(7259),
    [anon_sym_PERCENT] = ACTIONS(7259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2585] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2586] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7257),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2587] = {
    [sym_concatenation] = STATE(3109),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3109),
    [anon_sym_RBRACE] = ACTIONS(7237),
    [anon_sym_EQ] = ACTIONS(7253),
    [anon_sym_DASH] = ACTIONS(7253),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7253),
    [anon_sym_COLON_QMARK] = ACTIONS(7253),
    [anon_sym_COLON_DASH] = ACTIONS(7253),
    [anon_sym_PERCENT] = ACTIONS(7253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2588] = {
    [sym_do_group] = STATE(3112),
    [sym_compound_statement] = STATE(3112),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [2589] = {
    [sym_file_descriptor] = ACTIONS(5763),
    [anon_sym_SEMI] = ACTIONS(5765),
    [anon_sym_PIPE] = ACTIONS(5765),
    [anon_sym_SEMI_SEMI] = ACTIONS(5763),
    [anon_sym_PIPE_AMP] = ACTIONS(5763),
    [anon_sym_AMP_AMP] = ACTIONS(5763),
    [anon_sym_PIPE_PIPE] = ACTIONS(5763),
    [anon_sym_LT] = ACTIONS(5765),
    [anon_sym_GT] = ACTIONS(5765),
    [anon_sym_GT_GT] = ACTIONS(5763),
    [anon_sym_AMP_GT] = ACTIONS(5765),
    [anon_sym_AMP_GT_GT] = ACTIONS(5763),
    [anon_sym_LT_AMP] = ACTIONS(5763),
    [anon_sym_GT_AMP] = ACTIONS(5763),
    [anon_sym_LT_LT] = ACTIONS(5765),
    [anon_sym_LT_LT_DASH] = ACTIONS(5763),
    [anon_sym_LT_LT_LT] = ACTIONS(5763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5763),
    [anon_sym_AMP] = ACTIONS(5765),
  },
  [2590] = {
    [sym_do_group] = STATE(3112),
    [sym_compound_statement] = STATE(3112),
    [anon_sym_SEMI] = ACTIONS(7263),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [2591] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7265),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [2592] = {
    [sym__expression] = STATE(3115),
    [sym_binary_expression] = STATE(3115),
    [sym_unary_expression] = STATE(3115),
    [sym_postfix_expression] = STATE(3115),
    [sym_parenthesized_expression] = STATE(3115),
    [sym_concatenation] = STATE(3115),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7265),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2593] = {
    [sym_file_descriptor] = ACTIONS(5836),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_PIPE] = ACTIONS(5838),
    [anon_sym_SEMI_SEMI] = ACTIONS(5836),
    [anon_sym_PIPE_AMP] = ACTIONS(5836),
    [anon_sym_AMP_AMP] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5836),
    [anon_sym_LT] = ACTIONS(5838),
    [anon_sym_GT] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5836),
    [anon_sym_AMP_GT] = ACTIONS(5838),
    [anon_sym_AMP_GT_GT] = ACTIONS(5836),
    [anon_sym_LT_AMP] = ACTIONS(5836),
    [anon_sym_GT_AMP] = ACTIONS(5836),
    [anon_sym_LT_LT] = ACTIONS(5838),
    [anon_sym_LT_LT_DASH] = ACTIONS(5836),
    [anon_sym_LT_LT_LT] = ACTIONS(5836),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5836),
    [anon_sym_AMP] = ACTIONS(5838),
  },
  [2594] = {
    [sym_file_descriptor] = ACTIONS(6639),
    [anon_sym_SEMI] = ACTIONS(6641),
    [anon_sym_PIPE] = ACTIONS(6641),
    [anon_sym_SEMI_SEMI] = ACTIONS(6639),
    [anon_sym_PIPE_AMP] = ACTIONS(6639),
    [anon_sym_AMP_AMP] = ACTIONS(6639),
    [anon_sym_PIPE_PIPE] = ACTIONS(6639),
    [anon_sym_LT] = ACTIONS(6641),
    [anon_sym_GT] = ACTIONS(6641),
    [anon_sym_GT_GT] = ACTIONS(6639),
    [anon_sym_AMP_GT] = ACTIONS(6641),
    [anon_sym_AMP_GT_GT] = ACTIONS(6639),
    [anon_sym_LT_AMP] = ACTIONS(6639),
    [anon_sym_GT_AMP] = ACTIONS(6639),
    [anon_sym_LT_LT] = ACTIONS(6641),
    [anon_sym_LT_LT_DASH] = ACTIONS(6639),
    [anon_sym_LT_LT_LT] = ACTIONS(6639),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6639),
    [anon_sym_AMP] = ACTIONS(6641),
  },
  [2595] = {
    [anon_sym_fi] = ACTIONS(7267),
    [sym_comment] = ACTIONS(57),
  },
  [2596] = {
    [sym_file_descriptor] = ACTIONS(6737),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_SEMI_SEMI] = ACTIONS(6737),
    [anon_sym_PIPE_AMP] = ACTIONS(6737),
    [anon_sym_AMP_AMP] = ACTIONS(6737),
    [anon_sym_PIPE_PIPE] = ACTIONS(6737),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_GT_GT] = ACTIONS(6737),
    [anon_sym_AMP_GT] = ACTIONS(6739),
    [anon_sym_AMP_GT_GT] = ACTIONS(6737),
    [anon_sym_LT_AMP] = ACTIONS(6737),
    [anon_sym_GT_AMP] = ACTIONS(6737),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_LT_LT_DASH] = ACTIONS(6737),
    [anon_sym_LT_LT_LT] = ACTIONS(6737),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6737),
    [anon_sym_AMP] = ACTIONS(6739),
  },
  [2597] = {
    [anon_sym_esac] = ACTIONS(7269),
    [sym_comment] = ACTIONS(57),
  },
  [2598] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(3118),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2599] = {
    [sym_file_descriptor] = ACTIONS(6767),
    [anon_sym_SEMI] = ACTIONS(6769),
    [anon_sym_PIPE] = ACTIONS(6769),
    [anon_sym_SEMI_SEMI] = ACTIONS(6767),
    [anon_sym_PIPE_AMP] = ACTIONS(6767),
    [anon_sym_AMP_AMP] = ACTIONS(6767),
    [anon_sym_PIPE_PIPE] = ACTIONS(6767),
    [anon_sym_LT] = ACTIONS(6769),
    [anon_sym_GT] = ACTIONS(6769),
    [anon_sym_GT_GT] = ACTIONS(6767),
    [anon_sym_AMP_GT] = ACTIONS(6769),
    [anon_sym_AMP_GT_GT] = ACTIONS(6767),
    [anon_sym_LT_AMP] = ACTIONS(6767),
    [anon_sym_GT_AMP] = ACTIONS(6767),
    [anon_sym_LT_LT] = ACTIONS(6769),
    [anon_sym_LT_LT_DASH] = ACTIONS(6767),
    [anon_sym_LT_LT_LT] = ACTIONS(6767),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6767),
    [anon_sym_AMP] = ACTIONS(6769),
  },
  [2600] = {
    [anon_sym_esac] = ACTIONS(7271),
    [sym_comment] = ACTIONS(57),
  },
  [2601] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(3120),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2602] = {
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4354),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [2603] = {
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2604] = {
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2605] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7273),
    [sym_comment] = ACTIONS(57),
  },
  [2606] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7275),
    [sym_comment] = ACTIONS(57),
  },
  [2607] = {
    [anon_sym_RBRACE] = ACTIONS(7275),
    [sym_comment] = ACTIONS(57),
  },
  [2608] = {
    [sym_concatenation] = STATE(3124),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3124),
    [anon_sym_RBRACE] = ACTIONS(7277),
    [anon_sym_EQ] = ACTIONS(7279),
    [anon_sym_DASH] = ACTIONS(7279),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7279),
    [anon_sym_COLON_QMARK] = ACTIONS(7279),
    [anon_sym_COLON_DASH] = ACTIONS(7279),
    [anon_sym_PERCENT] = ACTIONS(7279),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2609] = {
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2610] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7277),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2611] = {
    [sym_concatenation] = STATE(3125),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3125),
    [anon_sym_RBRACE] = ACTIONS(7275),
    [anon_sym_EQ] = ACTIONS(7283),
    [anon_sym_DASH] = ACTIONS(7283),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7283),
    [anon_sym_COLON_QMARK] = ACTIONS(7283),
    [anon_sym_COLON_DASH] = ACTIONS(7283),
    [anon_sym_PERCENT] = ACTIONS(7283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2612] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7275),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2613] = {
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2614] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7287),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2615] = {
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2616] = {
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2617] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7289),
    [sym_comment] = ACTIONS(57),
  },
  [2618] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7291),
    [sym_comment] = ACTIONS(57),
  },
  [2619] = {
    [anon_sym_RBRACE] = ACTIONS(7291),
    [sym_comment] = ACTIONS(57),
  },
  [2620] = {
    [sym_concatenation] = STATE(3130),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3130),
    [anon_sym_RBRACE] = ACTIONS(7293),
    [anon_sym_EQ] = ACTIONS(7295),
    [anon_sym_DASH] = ACTIONS(7295),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7295),
    [anon_sym_COLON_QMARK] = ACTIONS(7295),
    [anon_sym_COLON_DASH] = ACTIONS(7295),
    [anon_sym_PERCENT] = ACTIONS(7295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2621] = {
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2622] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7293),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2623] = {
    [sym_concatenation] = STATE(3131),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3131),
    [anon_sym_RBRACE] = ACTIONS(7291),
    [anon_sym_EQ] = ACTIONS(7299),
    [anon_sym_DASH] = ACTIONS(7299),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7299),
    [anon_sym_COLON_QMARK] = ACTIONS(7299),
    [anon_sym_COLON_DASH] = ACTIONS(7299),
    [anon_sym_PERCENT] = ACTIONS(7299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2624] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7291),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2625] = {
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2626] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7303),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2627] = {
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7045),
    [anon_sym_EQ_EQ] = ACTIONS(7045),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [2628] = {
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7049),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [2629] = {
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_EQ_EQ] = ACTIONS(7053),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [2630] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7305),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2631] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7307),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2632] = {
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7089),
    [anon_sym_EQ_EQ] = ACTIONS(7089),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [2633] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_done] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [2634] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(7309),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2635] = {
    [sym_string] = STATE(3136),
    [sym_simple_expansion] = STATE(3136),
    [sym_string_expansion] = STATE(3136),
    [sym_expansion] = STATE(3136),
    [sym_command_substitution] = STATE(3136),
    [sym_process_substitution] = STATE(3136),
    [sym__special_characters] = ACTIONS(7311),
    [anon_sym_DQUOTE] = ACTIONS(4768),
    [anon_sym_DOLLAR] = ACTIONS(4770),
    [sym_raw_string] = ACTIONS(7311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4774),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4776),
    [anon_sym_BQUOTE] = ACTIONS(4778),
    [anon_sym_LT_LPAREN] = ACTIONS(4780),
    [anon_sym_GT_LPAREN] = ACTIONS(4780),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7311),
  },
  [2636] = {
    [aux_sym_concatenation_repeat1] = STATE(3137),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(6015),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_done] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2637] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_done] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2638] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2639] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [anon_sym_DOLLAR] = ACTIONS(7315),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2640] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_done] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2641] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_done] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2642] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_done] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2643] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7317),
    [sym_comment] = ACTIONS(57),
  },
  [2644] = {
    [sym_subscript] = STATE(3143),
    [sym_variable_name] = ACTIONS(7319),
    [anon_sym_DASH] = ACTIONS(7321),
    [anon_sym_DOLLAR] = ACTIONS(7321),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7323),
    [anon_sym_STAR] = ACTIONS(7325),
    [anon_sym_AT] = ACTIONS(7325),
    [anon_sym_QMARK] = ACTIONS(7325),
    [anon_sym_0] = ACTIONS(7323),
    [anon_sym__] = ACTIONS(7323),
  },
  [2645] = {
    [sym_concatenation] = STATE(3146),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3146),
    [anon_sym_RBRACE] = ACTIONS(7327),
    [anon_sym_EQ] = ACTIONS(7329),
    [anon_sym_DASH] = ACTIONS(7329),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7333),
    [anon_sym_COLON] = ACTIONS(7329),
    [anon_sym_COLON_QMARK] = ACTIONS(7329),
    [anon_sym_COLON_DASH] = ACTIONS(7329),
    [anon_sym_PERCENT] = ACTIONS(7329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2646] = {
    [sym_concatenation] = STATE(3149),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3149),
    [anon_sym_RBRACE] = ACTIONS(7335),
    [anon_sym_EQ] = ACTIONS(7337),
    [anon_sym_DASH] = ACTIONS(7337),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7341),
    [anon_sym_COLON] = ACTIONS(7337),
    [anon_sym_COLON_QMARK] = ACTIONS(7337),
    [anon_sym_COLON_DASH] = ACTIONS(7337),
    [anon_sym_PERCENT] = ACTIONS(7337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2647] = {
    [anon_sym_RPAREN] = ACTIONS(7343),
    [sym_comment] = ACTIONS(57),
  },
  [2648] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7343),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2649] = {
    [anon_sym_BQUOTE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(57),
  },
  [2650] = {
    [anon_sym_RPAREN] = ACTIONS(7345),
    [sym_comment] = ACTIONS(57),
  },
  [2651] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_done] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2652] = {
    [sym_concatenation] = STATE(3153),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(3153),
    [anon_sym_RPAREN] = ACTIONS(7347),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2653] = {
    [aux_sym_concatenation_repeat1] = STATE(2060),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(4784),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_done] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [2654] = {
    [aux_sym_concatenation_repeat1] = STATE(2060),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(4784),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_done] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2655] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2656] = {
    [aux_sym_concatenation_repeat1] = STATE(2656),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(7349),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2657] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_done] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [2658] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7352),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2659] = {
    [sym_concatenation] = STATE(3158),
    [sym_string] = STATE(3157),
    [sym_simple_expansion] = STATE(3157),
    [sym_string_expansion] = STATE(3157),
    [sym_expansion] = STATE(3157),
    [sym_command_substitution] = STATE(3157),
    [sym_process_substitution] = STATE(3157),
    [anon_sym_RBRACE] = ACTIONS(7354),
    [sym__special_characters] = ACTIONS(7356),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7358),
  },
  [2660] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7360),
    [sym_comment] = ACTIONS(57),
  },
  [2661] = {
    [sym_concatenation] = STATE(3162),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3162),
    [anon_sym_RBRACE] = ACTIONS(7362),
    [anon_sym_EQ] = ACTIONS(7364),
    [anon_sym_DASH] = ACTIONS(7364),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7368),
    [anon_sym_COLON] = ACTIONS(7364),
    [anon_sym_COLON_QMARK] = ACTIONS(7364),
    [anon_sym_COLON_DASH] = ACTIONS(7364),
    [anon_sym_PERCENT] = ACTIONS(7364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2662] = {
    [sym_concatenation] = STATE(3164),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3164),
    [anon_sym_RBRACE] = ACTIONS(7354),
    [anon_sym_EQ] = ACTIONS(7370),
    [anon_sym_DASH] = ACTIONS(7370),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7372),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7374),
    [anon_sym_COLON] = ACTIONS(7370),
    [anon_sym_COLON_QMARK] = ACTIONS(7370),
    [anon_sym_COLON_DASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2663] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_done] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [2664] = {
    [sym_concatenation] = STATE(3167),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3167),
    [sym_regex] = ACTIONS(7376),
    [anon_sym_RBRACE] = ACTIONS(7378),
    [anon_sym_EQ] = ACTIONS(7380),
    [anon_sym_DASH] = ACTIONS(7380),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7380),
    [anon_sym_COLON_QMARK] = ACTIONS(7380),
    [anon_sym_COLON_DASH] = ACTIONS(7380),
    [anon_sym_PERCENT] = ACTIONS(7380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2665] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7378),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2666] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_done] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [2667] = {
    [sym_concatenation] = STATE(3164),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3164),
    [sym_regex] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7354),
    [anon_sym_EQ] = ACTIONS(7370),
    [anon_sym_DASH] = ACTIONS(7370),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7372),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7370),
    [anon_sym_COLON_QMARK] = ACTIONS(7370),
    [anon_sym_COLON_DASH] = ACTIONS(7370),
    [anon_sym_PERCENT] = ACTIONS(7370),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2668] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7354),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2669] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_done] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [2670] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_done] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [2671] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2672] = {
    [aux_sym_concatenation_repeat1] = STATE(2672),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(7386),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2673] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_done] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [2674] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7389),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2675] = {
    [sym_concatenation] = STATE(3173),
    [sym_string] = STATE(3172),
    [sym_simple_expansion] = STATE(3172),
    [sym_string_expansion] = STATE(3172),
    [sym_expansion] = STATE(3172),
    [sym_command_substitution] = STATE(3172),
    [sym_process_substitution] = STATE(3172),
    [anon_sym_RBRACE] = ACTIONS(7391),
    [sym__special_characters] = ACTIONS(7393),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7395),
  },
  [2676] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7397),
    [sym_comment] = ACTIONS(57),
  },
  [2677] = {
    [sym_concatenation] = STATE(3177),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3177),
    [anon_sym_RBRACE] = ACTIONS(7399),
    [anon_sym_EQ] = ACTIONS(7401),
    [anon_sym_DASH] = ACTIONS(7401),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7405),
    [anon_sym_COLON] = ACTIONS(7401),
    [anon_sym_COLON_QMARK] = ACTIONS(7401),
    [anon_sym_COLON_DASH] = ACTIONS(7401),
    [anon_sym_PERCENT] = ACTIONS(7401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2678] = {
    [sym_concatenation] = STATE(3179),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3179),
    [anon_sym_RBRACE] = ACTIONS(7391),
    [anon_sym_EQ] = ACTIONS(7407),
    [anon_sym_DASH] = ACTIONS(7407),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7411),
    [anon_sym_COLON] = ACTIONS(7407),
    [anon_sym_COLON_QMARK] = ACTIONS(7407),
    [anon_sym_COLON_DASH] = ACTIONS(7407),
    [anon_sym_PERCENT] = ACTIONS(7407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2679] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_done] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [2680] = {
    [sym_concatenation] = STATE(3182),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3182),
    [sym_regex] = ACTIONS(7413),
    [anon_sym_RBRACE] = ACTIONS(7415),
    [anon_sym_EQ] = ACTIONS(7417),
    [anon_sym_DASH] = ACTIONS(7417),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7417),
    [anon_sym_COLON_QMARK] = ACTIONS(7417),
    [anon_sym_COLON_DASH] = ACTIONS(7417),
    [anon_sym_PERCENT] = ACTIONS(7417),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2681] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7415),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2682] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_done] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [2683] = {
    [sym_concatenation] = STATE(3179),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3179),
    [sym_regex] = ACTIONS(7421),
    [anon_sym_RBRACE] = ACTIONS(7391),
    [anon_sym_EQ] = ACTIONS(7407),
    [anon_sym_DASH] = ACTIONS(7407),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7407),
    [anon_sym_COLON_QMARK] = ACTIONS(7407),
    [anon_sym_COLON_DASH] = ACTIONS(7407),
    [anon_sym_PERCENT] = ACTIONS(7407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2684] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7391),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2685] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_done] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [2686] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_done] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [2687] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_done] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [2688] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_done] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [2689] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7423),
    [sym_comment] = ACTIONS(57),
  },
  [2690] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7425),
    [sym_comment] = ACTIONS(57),
  },
  [2691] = {
    [anon_sym_RBRACE] = ACTIONS(7425),
    [sym_comment] = ACTIONS(57),
  },
  [2692] = {
    [sym_concatenation] = STATE(3188),
    [sym_string] = STATE(3187),
    [sym_simple_expansion] = STATE(3187),
    [sym_string_expansion] = STATE(3187),
    [sym_expansion] = STATE(3187),
    [sym_command_substitution] = STATE(3187),
    [sym_process_substitution] = STATE(3187),
    [anon_sym_RBRACE] = ACTIONS(7425),
    [sym__special_characters] = ACTIONS(7427),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7429),
  },
  [2693] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_done] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2694] = {
    [sym_concatenation] = STATE(3191),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3191),
    [sym_regex] = ACTIONS(7431),
    [anon_sym_RBRACE] = ACTIONS(7433),
    [anon_sym_EQ] = ACTIONS(7435),
    [anon_sym_DASH] = ACTIONS(7435),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7435),
    [anon_sym_COLON_QMARK] = ACTIONS(7435),
    [anon_sym_COLON_DASH] = ACTIONS(7435),
    [anon_sym_PERCENT] = ACTIONS(7435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2695] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7433),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2696] = {
    [sym_concatenation] = STATE(3193),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3193),
    [sym_regex] = ACTIONS(7439),
    [anon_sym_RBRACE] = ACTIONS(7425),
    [anon_sym_EQ] = ACTIONS(7441),
    [anon_sym_DASH] = ACTIONS(7441),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7441),
    [anon_sym_COLON_QMARK] = ACTIONS(7441),
    [anon_sym_COLON_DASH] = ACTIONS(7441),
    [anon_sym_PERCENT] = ACTIONS(7441),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2697] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7425),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2698] = {
    [sym_concatenation] = STATE(3195),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3195),
    [anon_sym_RBRACE] = ACTIONS(7445),
    [anon_sym_EQ] = ACTIONS(7447),
    [anon_sym_DASH] = ACTIONS(7447),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7447),
    [anon_sym_COLON_QMARK] = ACTIONS(7447),
    [anon_sym_COLON_DASH] = ACTIONS(7447),
    [anon_sym_PERCENT] = ACTIONS(7447),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2699] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2700] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7445),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2701] = {
    [sym_concatenation] = STATE(3193),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3193),
    [anon_sym_RBRACE] = ACTIONS(7425),
    [anon_sym_EQ] = ACTIONS(7441),
    [anon_sym_DASH] = ACTIONS(7441),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7441),
    [anon_sym_COLON_QMARK] = ACTIONS(7441),
    [anon_sym_COLON_DASH] = ACTIONS(7441),
    [anon_sym_PERCENT] = ACTIONS(7441),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2702] = {
    [aux_sym_concatenation_repeat1] = STATE(2705),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_done] = ACTIONS(1367),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [2703] = {
    [aux_sym_concatenation_repeat1] = STATE(2705),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_done] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2704] = {
    [sym_string] = STATE(3196),
    [sym_simple_expansion] = STATE(3196),
    [sym_string_expansion] = STATE(3196),
    [sym_expansion] = STATE(3196),
    [sym_command_substitution] = STATE(3196),
    [sym_process_substitution] = STATE(3196),
    [sym__special_characters] = ACTIONS(7451),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(7451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7451),
  },
  [2705] = {
    [aux_sym_concatenation_repeat1] = STATE(3197),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_done] = ACTIONS(1049),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2706] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_done] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(1053),
    [anon_sym_elif] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2707] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7453),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2708] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(7453),
    [anon_sym_DOLLAR] = ACTIONS(7455),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2709] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_done] = ACTIONS(1087),
    [anon_sym_fi] = ACTIONS(1087),
    [anon_sym_elif] = ACTIONS(1087),
    [anon_sym_else] = ACTIONS(1087),
    [anon_sym_esac] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2710] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_done] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_elif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2711] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_done] = ACTIONS(1095),
    [anon_sym_fi] = ACTIONS(1095),
    [anon_sym_elif] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2712] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7457),
    [sym_comment] = ACTIONS(57),
  },
  [2713] = {
    [sym_subscript] = STATE(3203),
    [sym_variable_name] = ACTIONS(7459),
    [anon_sym_DASH] = ACTIONS(7461),
    [anon_sym_DOLLAR] = ACTIONS(7461),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7463),
    [anon_sym_STAR] = ACTIONS(7465),
    [anon_sym_AT] = ACTIONS(7465),
    [anon_sym_QMARK] = ACTIONS(7465),
    [anon_sym_0] = ACTIONS(7463),
    [anon_sym__] = ACTIONS(7463),
  },
  [2714] = {
    [sym_concatenation] = STATE(3206),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3206),
    [anon_sym_RBRACE] = ACTIONS(7467),
    [anon_sym_EQ] = ACTIONS(7469),
    [anon_sym_DASH] = ACTIONS(7469),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7473),
    [anon_sym_COLON] = ACTIONS(7469),
    [anon_sym_COLON_QMARK] = ACTIONS(7469),
    [anon_sym_COLON_DASH] = ACTIONS(7469),
    [anon_sym_PERCENT] = ACTIONS(7469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2715] = {
    [sym_concatenation] = STATE(3209),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3209),
    [anon_sym_RBRACE] = ACTIONS(7475),
    [anon_sym_EQ] = ACTIONS(7477),
    [anon_sym_DASH] = ACTIONS(7477),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7481),
    [anon_sym_COLON] = ACTIONS(7477),
    [anon_sym_COLON_QMARK] = ACTIONS(7477),
    [anon_sym_COLON_DASH] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7477),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2716] = {
    [anon_sym_RPAREN] = ACTIONS(7483),
    [sym_comment] = ACTIONS(57),
  },
  [2717] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7483),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2718] = {
    [anon_sym_BQUOTE] = ACTIONS(7483),
    [sym_comment] = ACTIONS(57),
  },
  [2719] = {
    [anon_sym_RPAREN] = ACTIONS(7485),
    [sym_comment] = ACTIONS(57),
  },
  [2720] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_done] = ACTIONS(7487),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [2721] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_fi] = ACTIONS(2666),
    [anon_sym_elif] = ACTIONS(2666),
    [anon_sym_else] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [2722] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(7489),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2723] = {
    [sym_string] = STATE(3213),
    [sym_simple_expansion] = STATE(3213),
    [sym_string_expansion] = STATE(3213),
    [sym_expansion] = STATE(3213),
    [sym_command_substitution] = STATE(3213),
    [sym_process_substitution] = STATE(3213),
    [sym__special_characters] = ACTIONS(7491),
    [anon_sym_DQUOTE] = ACTIONS(4922),
    [anon_sym_DOLLAR] = ACTIONS(4924),
    [sym_raw_string] = ACTIONS(7491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4930),
    [anon_sym_BQUOTE] = ACTIONS(4932),
    [anon_sym_LT_LPAREN] = ACTIONS(4934),
    [anon_sym_GT_LPAREN] = ACTIONS(4934),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7491),
  },
  [2724] = {
    [aux_sym_concatenation_repeat1] = STATE(3214),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(6297),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_elif] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2725] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_fi] = ACTIONS(1055),
    [anon_sym_elif] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2726] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7493),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2727] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(7493),
    [anon_sym_DOLLAR] = ACTIONS(7495),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2728] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_elif] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2729] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_elif] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2730] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_elif] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2731] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7497),
    [sym_comment] = ACTIONS(57),
  },
  [2732] = {
    [sym_subscript] = STATE(3220),
    [sym_variable_name] = ACTIONS(7499),
    [anon_sym_DASH] = ACTIONS(7501),
    [anon_sym_DOLLAR] = ACTIONS(7501),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7503),
    [anon_sym_STAR] = ACTIONS(7505),
    [anon_sym_AT] = ACTIONS(7505),
    [anon_sym_QMARK] = ACTIONS(7505),
    [anon_sym_0] = ACTIONS(7503),
    [anon_sym__] = ACTIONS(7503),
  },
  [2733] = {
    [sym_concatenation] = STATE(3223),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3223),
    [anon_sym_RBRACE] = ACTIONS(7507),
    [anon_sym_EQ] = ACTIONS(7509),
    [anon_sym_DASH] = ACTIONS(7509),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7513),
    [anon_sym_COLON] = ACTIONS(7509),
    [anon_sym_COLON_QMARK] = ACTIONS(7509),
    [anon_sym_COLON_DASH] = ACTIONS(7509),
    [anon_sym_PERCENT] = ACTIONS(7509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2734] = {
    [sym_concatenation] = STATE(3226),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3226),
    [anon_sym_RBRACE] = ACTIONS(7515),
    [anon_sym_EQ] = ACTIONS(7517),
    [anon_sym_DASH] = ACTIONS(7517),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7521),
    [anon_sym_COLON] = ACTIONS(7517),
    [anon_sym_COLON_QMARK] = ACTIONS(7517),
    [anon_sym_COLON_DASH] = ACTIONS(7517),
    [anon_sym_PERCENT] = ACTIONS(7517),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2735] = {
    [anon_sym_RPAREN] = ACTIONS(7523),
    [sym_comment] = ACTIONS(57),
  },
  [2736] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7523),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2737] = {
    [anon_sym_BQUOTE] = ACTIONS(7523),
    [sym_comment] = ACTIONS(57),
  },
  [2738] = {
    [anon_sym_RPAREN] = ACTIONS(7525),
    [sym_comment] = ACTIONS(57),
  },
  [2739] = {
    [anon_sym_fi] = ACTIONS(7527),
    [anon_sym_elif] = ACTIONS(7527),
    [anon_sym_else] = ACTIONS(7527),
    [sym_comment] = ACTIONS(57),
  },
  [2740] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_fi] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2741] = {
    [sym_concatenation] = STATE(3230),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(3230),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2742] = {
    [aux_sym_concatenation_repeat1] = STATE(3232),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(7531),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_fi] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [2743] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(3235),
    [anon_sym_DQUOTE] = ACTIONS(7533),
    [anon_sym_DOLLAR] = ACTIONS(7535),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2744] = {
    [sym_string] = STATE(3237),
    [anon_sym_DASH] = ACTIONS(7537),
    [anon_sym_DQUOTE] = ACTIONS(6329),
    [anon_sym_DOLLAR] = ACTIONS(7537),
    [sym_raw_string] = ACTIONS(7539),
    [anon_sym_POUND] = ACTIONS(7537),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7541),
    [anon_sym_STAR] = ACTIONS(7543),
    [anon_sym_AT] = ACTIONS(7543),
    [anon_sym_QMARK] = ACTIONS(7543),
    [anon_sym_0] = ACTIONS(7541),
    [anon_sym__] = ACTIONS(7541),
  },
  [2745] = {
    [aux_sym_concatenation_repeat1] = STATE(3232),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(7531),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_fi] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2746] = {
    [sym_subscript] = STATE(3242),
    [sym_variable_name] = ACTIONS(7545),
    [anon_sym_BANG] = ACTIONS(7547),
    [anon_sym_DASH] = ACTIONS(7549),
    [anon_sym_DOLLAR] = ACTIONS(7549),
    [anon_sym_POUND] = ACTIONS(7547),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7551),
    [anon_sym_STAR] = ACTIONS(7553),
    [anon_sym_AT] = ACTIONS(7553),
    [anon_sym_QMARK] = ACTIONS(7553),
    [anon_sym_0] = ACTIONS(7551),
    [anon_sym__] = ACTIONS(7551),
  },
  [2747] = {
    [sym__statements] = STATE(3243),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(3244),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2748] = {
    [sym__statements] = STATE(3245),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2749] = {
    [sym__statements] = STATE(3246),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2750] = {
    [sym_concatenation] = STATE(3247),
    [sym_string] = STATE(3250),
    [sym_array] = STATE(3247),
    [sym_simple_expansion] = STATE(3250),
    [sym_string_expansion] = STATE(3250),
    [sym_expansion] = STATE(3250),
    [sym_command_substitution] = STATE(3250),
    [sym_process_substitution] = STATE(3250),
    [sym__empty_value] = ACTIONS(7555),
    [anon_sym_LPAREN] = ACTIONS(7557),
    [sym__special_characters] = ACTIONS(7559),
    [anon_sym_DQUOTE] = ACTIONS(4944),
    [anon_sym_DOLLAR] = ACTIONS(4946),
    [sym_raw_string] = ACTIONS(7561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4952),
    [anon_sym_BQUOTE] = ACTIONS(4954),
    [anon_sym_LT_LPAREN] = ACTIONS(4956),
    [anon_sym_GT_LPAREN] = ACTIONS(4956),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7561),
  },
  [2751] = {
    [sym_string] = STATE(3251),
    [sym_simple_expansion] = STATE(3251),
    [sym_string_expansion] = STATE(3251),
    [sym_expansion] = STATE(3251),
    [sym_command_substitution] = STATE(3251),
    [sym_process_substitution] = STATE(3251),
    [sym__special_characters] = ACTIONS(7563),
    [anon_sym_DQUOTE] = ACTIONS(4944),
    [anon_sym_DOLLAR] = ACTIONS(4946),
    [sym_raw_string] = ACTIONS(7563),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4952),
    [anon_sym_BQUOTE] = ACTIONS(4954),
    [anon_sym_LT_LPAREN] = ACTIONS(4956),
    [anon_sym_GT_LPAREN] = ACTIONS(4956),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7563),
  },
  [2752] = {
    [aux_sym_concatenation_repeat1] = STATE(3252),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(6345),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2753] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_fi] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2754] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2755] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(7565),
    [anon_sym_DOLLAR] = ACTIONS(7567),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2756] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2757] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2758] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2759] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7569),
    [sym_comment] = ACTIONS(57),
  },
  [2760] = {
    [sym_subscript] = STATE(3258),
    [sym_variable_name] = ACTIONS(7571),
    [anon_sym_DASH] = ACTIONS(7573),
    [anon_sym_DOLLAR] = ACTIONS(7573),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7575),
    [anon_sym_STAR] = ACTIONS(7577),
    [anon_sym_AT] = ACTIONS(7577),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_0] = ACTIONS(7575),
    [anon_sym__] = ACTIONS(7575),
  },
  [2761] = {
    [sym_concatenation] = STATE(3261),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3261),
    [anon_sym_RBRACE] = ACTIONS(7579),
    [anon_sym_EQ] = ACTIONS(7581),
    [anon_sym_DASH] = ACTIONS(7581),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7585),
    [anon_sym_COLON] = ACTIONS(7581),
    [anon_sym_COLON_QMARK] = ACTIONS(7581),
    [anon_sym_COLON_DASH] = ACTIONS(7581),
    [anon_sym_PERCENT] = ACTIONS(7581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2762] = {
    [sym_concatenation] = STATE(3264),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3264),
    [anon_sym_RBRACE] = ACTIONS(7587),
    [anon_sym_EQ] = ACTIONS(7589),
    [anon_sym_DASH] = ACTIONS(7589),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7593),
    [anon_sym_COLON] = ACTIONS(7589),
    [anon_sym_COLON_QMARK] = ACTIONS(7589),
    [anon_sym_COLON_DASH] = ACTIONS(7589),
    [anon_sym_PERCENT] = ACTIONS(7589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2763] = {
    [anon_sym_RPAREN] = ACTIONS(7595),
    [sym_comment] = ACTIONS(57),
  },
  [2764] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7595),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2765] = {
    [anon_sym_BQUOTE] = ACTIONS(7595),
    [sym_comment] = ACTIONS(57),
  },
  [2766] = {
    [anon_sym_RPAREN] = ACTIONS(7597),
    [sym_comment] = ACTIONS(57),
  },
  [2767] = {
    [sym_variable_assignment] = STATE(2767),
    [sym_subscript] = STATE(2155),
    [sym_concatenation] = STATE(2767),
    [sym_string] = STATE(2150),
    [sym_simple_expansion] = STATE(2150),
    [sym_string_expansion] = STATE(2150),
    [sym_expansion] = STATE(2150),
    [sym_command_substitution] = STATE(2150),
    [sym_process_substitution] = STATE(2150),
    [aux_sym_declaration_command_repeat1] = STATE(2767),
    [sym__simple_heredoc_body] = ACTIONS(2163),
    [sym__heredoc_body_beginning] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(7599),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_fi] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(7602),
    [anon_sym_DQUOTE] = ACTIONS(7605),
    [anon_sym_DOLLAR] = ACTIONS(7608),
    [sym_raw_string] = ACTIONS(7611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7617),
    [anon_sym_BQUOTE] = ACTIONS(7620),
    [anon_sym_LT_LPAREN] = ACTIONS(7623),
    [anon_sym_GT_LPAREN] = ACTIONS(7623),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7626),
    [sym_word] = ACTIONS(7629),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [2768] = {
    [sym_string] = STATE(3267),
    [sym_simple_expansion] = STATE(3267),
    [sym_string_expansion] = STATE(3267),
    [sym_expansion] = STATE(3267),
    [sym_command_substitution] = STATE(3267),
    [sym_process_substitution] = STATE(3267),
    [sym__special_characters] = ACTIONS(7632),
    [anon_sym_DQUOTE] = ACTIONS(4964),
    [anon_sym_DOLLAR] = ACTIONS(4966),
    [sym_raw_string] = ACTIONS(7632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4970),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4972),
    [anon_sym_BQUOTE] = ACTIONS(4974),
    [anon_sym_LT_LPAREN] = ACTIONS(4976),
    [anon_sym_GT_LPAREN] = ACTIONS(4976),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7632),
  },
  [2769] = {
    [aux_sym_concatenation_repeat1] = STATE(3268),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(6371),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2770] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_fi] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2771] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7634),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2772] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(7634),
    [anon_sym_DOLLAR] = ACTIONS(7636),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2773] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [2774] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [2775] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2776] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7638),
    [sym_comment] = ACTIONS(57),
  },
  [2777] = {
    [sym_subscript] = STATE(3274),
    [sym_variable_name] = ACTIONS(7640),
    [anon_sym_DASH] = ACTIONS(7642),
    [anon_sym_DOLLAR] = ACTIONS(7642),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7644),
    [anon_sym_STAR] = ACTIONS(7646),
    [anon_sym_AT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_0] = ACTIONS(7644),
    [anon_sym__] = ACTIONS(7644),
  },
  [2778] = {
    [sym_concatenation] = STATE(3277),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3277),
    [anon_sym_RBRACE] = ACTIONS(7648),
    [anon_sym_EQ] = ACTIONS(7650),
    [anon_sym_DASH] = ACTIONS(7650),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7654),
    [anon_sym_COLON] = ACTIONS(7650),
    [anon_sym_COLON_QMARK] = ACTIONS(7650),
    [anon_sym_COLON_DASH] = ACTIONS(7650),
    [anon_sym_PERCENT] = ACTIONS(7650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2779] = {
    [sym_concatenation] = STATE(3280),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3280),
    [anon_sym_RBRACE] = ACTIONS(7656),
    [anon_sym_EQ] = ACTIONS(7658),
    [anon_sym_DASH] = ACTIONS(7658),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7662),
    [anon_sym_COLON] = ACTIONS(7658),
    [anon_sym_COLON_QMARK] = ACTIONS(7658),
    [anon_sym_COLON_DASH] = ACTIONS(7658),
    [anon_sym_PERCENT] = ACTIONS(7658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2780] = {
    [anon_sym_RPAREN] = ACTIONS(7664),
    [sym_comment] = ACTIONS(57),
  },
  [2781] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7664),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2782] = {
    [anon_sym_BQUOTE] = ACTIONS(7664),
    [sym_comment] = ACTIONS(57),
  },
  [2783] = {
    [anon_sym_RPAREN] = ACTIONS(7666),
    [sym_comment] = ACTIONS(57),
  },
  [2784] = {
    [sym_concatenation] = STATE(2784),
    [sym_string] = STATE(2160),
    [sym_simple_expansion] = STATE(2160),
    [sym_string_expansion] = STATE(2160),
    [sym_expansion] = STATE(2160),
    [sym_command_substitution] = STATE(2160),
    [sym_process_substitution] = STATE(2160),
    [aux_sym_unset_command_repeat1] = STATE(2784),
    [sym__simple_heredoc_body] = ACTIONS(2236),
    [sym__heredoc_body_beginning] = ACTIONS(2236),
    [sym_file_descriptor] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_fi] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(7668),
    [anon_sym_DQUOTE] = ACTIONS(7671),
    [anon_sym_DOLLAR] = ACTIONS(7674),
    [sym_raw_string] = ACTIONS(7677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7683),
    [anon_sym_BQUOTE] = ACTIONS(7686),
    [anon_sym_LT_LPAREN] = ACTIONS(7689),
    [anon_sym_GT_LPAREN] = ACTIONS(7689),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7692),
    [sym_word] = ACTIONS(7695),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [2785] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2786] = {
    [aux_sym_concatenation_repeat1] = STATE(2786),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(7698),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2787] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_fi] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [2788] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7701),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2789] = {
    [sym_concatenation] = STATE(3287),
    [sym_string] = STATE(3286),
    [sym_simple_expansion] = STATE(3286),
    [sym_string_expansion] = STATE(3286),
    [sym_expansion] = STATE(3286),
    [sym_command_substitution] = STATE(3286),
    [sym_process_substitution] = STATE(3286),
    [anon_sym_RBRACE] = ACTIONS(7703),
    [sym__special_characters] = ACTIONS(7705),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7707),
  },
  [2790] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7709),
    [sym_comment] = ACTIONS(57),
  },
  [2791] = {
    [sym_concatenation] = STATE(3291),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3291),
    [anon_sym_RBRACE] = ACTIONS(7711),
    [anon_sym_EQ] = ACTIONS(7713),
    [anon_sym_DASH] = ACTIONS(7713),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7717),
    [anon_sym_COLON] = ACTIONS(7713),
    [anon_sym_COLON_QMARK] = ACTIONS(7713),
    [anon_sym_COLON_DASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2792] = {
    [sym_concatenation] = STATE(3293),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3293),
    [anon_sym_RBRACE] = ACTIONS(7703),
    [anon_sym_EQ] = ACTIONS(7719),
    [anon_sym_DASH] = ACTIONS(7719),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7723),
    [anon_sym_COLON] = ACTIONS(7719),
    [anon_sym_COLON_QMARK] = ACTIONS(7719),
    [anon_sym_COLON_DASH] = ACTIONS(7719),
    [anon_sym_PERCENT] = ACTIONS(7719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2793] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_fi] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [2794] = {
    [sym_concatenation] = STATE(3296),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3296),
    [sym_regex] = ACTIONS(7725),
    [anon_sym_RBRACE] = ACTIONS(7727),
    [anon_sym_EQ] = ACTIONS(7729),
    [anon_sym_DASH] = ACTIONS(7729),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7729),
    [anon_sym_COLON_QMARK] = ACTIONS(7729),
    [anon_sym_COLON_DASH] = ACTIONS(7729),
    [anon_sym_PERCENT] = ACTIONS(7729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2795] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7727),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2796] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_fi] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [2797] = {
    [sym_concatenation] = STATE(3293),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3293),
    [sym_regex] = ACTIONS(7733),
    [anon_sym_RBRACE] = ACTIONS(7703),
    [anon_sym_EQ] = ACTIONS(7719),
    [anon_sym_DASH] = ACTIONS(7719),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7719),
    [anon_sym_COLON_QMARK] = ACTIONS(7719),
    [anon_sym_COLON_DASH] = ACTIONS(7719),
    [anon_sym_PERCENT] = ACTIONS(7719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2798] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7703),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2799] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_fi] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [2800] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_fi] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2504),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [2801] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(3299),
    [sym_simple_expansion] = STATE(3299),
    [sym_string_expansion] = STATE(3299),
    [sym_expansion] = STATE(3299),
    [sym_command_substitution] = STATE(3299),
    [sym_process_substitution] = STATE(3299),
    [sym__special_characters] = ACTIONS(7735),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(7737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7737),
  },
  [2802] = {
    [sym_file_redirect] = STATE(2189),
    [sym_heredoc_redirect] = STATE(2189),
    [sym_herestring_redirect] = STATE(2189),
    [aux_sym_redirected_statement_repeat1] = STATE(2189),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2803] = {
    [sym_file_redirect] = STATE(2189),
    [sym_heredoc_redirect] = STATE(2189),
    [sym_herestring_redirect] = STATE(2189),
    [aux_sym_redirected_statement_repeat1] = STATE(2189),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2804] = {
    [sym_file_redirect] = STATE(2189),
    [sym_heredoc_redirect] = STATE(2189),
    [sym_herestring_redirect] = STATE(2189),
    [aux_sym_redirected_statement_repeat1] = STATE(2189),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_fi] = ACTIONS(2538),
    [anon_sym_PIPE] = ACTIONS(5012),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(5016),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [2805] = {
    [sym_file_redirect] = STATE(2189),
    [sym_heredoc_redirect] = STATE(2189),
    [sym_herestring_redirect] = STATE(2189),
    [aux_sym_redirected_statement_repeat1] = STATE(2189),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_fi] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(5012),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(5016),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [2806] = {
    [aux_sym_concatenation_repeat1] = STATE(3300),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_fi] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [2807] = {
    [aux_sym_concatenation_repeat1] = STATE(3300),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_fi] = ACTIONS(1033),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [2808] = {
    [aux_sym_concatenation_repeat1] = STATE(3300),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_fi] = ACTIONS(2546),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [2809] = {
    [aux_sym_concatenation_repeat1] = STATE(3300),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_fi] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [2810] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_fi] = ACTIONS(6247),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [2811] = {
    [sym_file_redirect] = STATE(2811),
    [sym_heredoc_redirect] = STATE(2811),
    [sym_herestring_redirect] = STATE(2811),
    [aux_sym_redirected_statement_repeat1] = STATE(2811),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(7739),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_fi] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(7742),
    [anon_sym_GT] = ACTIONS(7742),
    [anon_sym_GT_GT] = ACTIONS(7745),
    [anon_sym_AMP_GT] = ACTIONS(7742),
    [anon_sym_AMP_GT_GT] = ACTIONS(7745),
    [anon_sym_LT_AMP] = ACTIONS(7745),
    [anon_sym_GT_AMP] = ACTIONS(7745),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [2812] = {
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_fi] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2813] = {
    [aux_sym_concatenation_repeat1] = STATE(2167),
    [sym__simple_heredoc_body] = ACTIONS(2586),
    [sym__heredoc_body_beginning] = ACTIONS(2586),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_fi] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [2814] = {
    [aux_sym_concatenation_repeat1] = STATE(2167),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_fi] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2815] = {
    [sym_concatenation] = STATE(2815),
    [sym_string] = STATE(2192),
    [sym_simple_expansion] = STATE(2192),
    [sym_string_expansion] = STATE(2192),
    [sym_expansion] = STATE(2192),
    [sym_command_substitution] = STATE(2192),
    [sym_process_substitution] = STATE(2192),
    [aux_sym_command_repeat2] = STATE(2815),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_fi] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(7751),
    [anon_sym_EQ_EQ] = ACTIONS(7751),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(7754),
    [anon_sym_DQUOTE] = ACTIONS(7757),
    [anon_sym_DOLLAR] = ACTIONS(7760),
    [sym_raw_string] = ACTIONS(7763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7769),
    [anon_sym_BQUOTE] = ACTIONS(7772),
    [anon_sym_LT_LPAREN] = ACTIONS(7775),
    [anon_sym_GT_LPAREN] = ACTIONS(7775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7778),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [2816] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_fi] = ACTIONS(6247),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [2817] = {
    [anon_sym_SEMI] = ACTIONS(7781),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(7783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7783),
    [anon_sym_AMP] = ACTIONS(7783),
  },
  [2818] = {
    [sym_concatenation] = STATE(2815),
    [sym_string] = STATE(2192),
    [sym_simple_expansion] = STATE(2192),
    [sym_string_expansion] = STATE(2192),
    [sym_expansion] = STATE(2192),
    [sym_command_substitution] = STATE(2192),
    [sym_process_substitution] = STATE(2192),
    [aux_sym_command_repeat2] = STATE(2815),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_fi] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(5026),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(5028),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [sym_raw_string] = ACTIONS(5030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5032),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [2819] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_fi] = ACTIONS(1387),
    [anon_sym_elif] = ACTIONS(1387),
    [anon_sym_else] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2820] = {
    [sym_concatenation] = STATE(3303),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(3303),
    [anon_sym_RPAREN] = ACTIONS(7785),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [2821] = {
    [aux_sym_concatenation_repeat1] = STATE(2199),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(5038),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_fi] = ACTIONS(1411),
    [anon_sym_elif] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [2822] = {
    [aux_sym_concatenation_repeat1] = STATE(2199),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(5038),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_fi] = ACTIONS(1387),
    [anon_sym_elif] = ACTIONS(1387),
    [anon_sym_else] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [2823] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_elif] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2824] = {
    [aux_sym_concatenation_repeat1] = STATE(2824),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(7787),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_elif] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2825] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_fi] = ACTIONS(2315),
    [anon_sym_elif] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [2826] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7790),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2827] = {
    [sym_concatenation] = STATE(3308),
    [sym_string] = STATE(3307),
    [sym_simple_expansion] = STATE(3307),
    [sym_string_expansion] = STATE(3307),
    [sym_expansion] = STATE(3307),
    [sym_command_substitution] = STATE(3307),
    [sym_process_substitution] = STATE(3307),
    [anon_sym_RBRACE] = ACTIONS(7792),
    [sym__special_characters] = ACTIONS(7794),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7796),
  },
  [2828] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7798),
    [sym_comment] = ACTIONS(57),
  },
  [2829] = {
    [sym_concatenation] = STATE(3312),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3312),
    [anon_sym_RBRACE] = ACTIONS(7800),
    [anon_sym_EQ] = ACTIONS(7802),
    [anon_sym_DASH] = ACTIONS(7802),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7804),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7806),
    [anon_sym_COLON] = ACTIONS(7802),
    [anon_sym_COLON_QMARK] = ACTIONS(7802),
    [anon_sym_COLON_DASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2830] = {
    [sym_concatenation] = STATE(3314),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3314),
    [anon_sym_RBRACE] = ACTIONS(7792),
    [anon_sym_EQ] = ACTIONS(7808),
    [anon_sym_DASH] = ACTIONS(7808),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7812),
    [anon_sym_COLON] = ACTIONS(7808),
    [anon_sym_COLON_QMARK] = ACTIONS(7808),
    [anon_sym_COLON_DASH] = ACTIONS(7808),
    [anon_sym_PERCENT] = ACTIONS(7808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2831] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_fi] = ACTIONS(2408),
    [anon_sym_elif] = ACTIONS(2408),
    [anon_sym_else] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [2832] = {
    [sym_concatenation] = STATE(3317),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3317),
    [sym_regex] = ACTIONS(7814),
    [anon_sym_RBRACE] = ACTIONS(7816),
    [anon_sym_EQ] = ACTIONS(7818),
    [anon_sym_DASH] = ACTIONS(7818),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7818),
    [anon_sym_COLON_QMARK] = ACTIONS(7818),
    [anon_sym_COLON_DASH] = ACTIONS(7818),
    [anon_sym_PERCENT] = ACTIONS(7818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2833] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7816),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2834] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_fi] = ACTIONS(2456),
    [anon_sym_elif] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [2835] = {
    [sym_concatenation] = STATE(3314),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3314),
    [sym_regex] = ACTIONS(7822),
    [anon_sym_RBRACE] = ACTIONS(7792),
    [anon_sym_EQ] = ACTIONS(7808),
    [anon_sym_DASH] = ACTIONS(7808),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7808),
    [anon_sym_COLON_QMARK] = ACTIONS(7808),
    [anon_sym_COLON_DASH] = ACTIONS(7808),
    [anon_sym_PERCENT] = ACTIONS(7808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2836] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7792),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2837] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_fi] = ACTIONS(2466),
    [anon_sym_elif] = ACTIONS(2466),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [2838] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_fi] = ACTIONS(2504),
    [anon_sym_elif] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [2839] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_elif] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2840] = {
    [aux_sym_concatenation_repeat1] = STATE(2840),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(7824),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_elif] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [2841] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_fi] = ACTIONS(2315),
    [anon_sym_elif] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [2842] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(7827),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [2843] = {
    [sym_concatenation] = STATE(3323),
    [sym_string] = STATE(3322),
    [sym_simple_expansion] = STATE(3322),
    [sym_string_expansion] = STATE(3322),
    [sym_expansion] = STATE(3322),
    [sym_command_substitution] = STATE(3322),
    [sym_process_substitution] = STATE(3322),
    [anon_sym_RBRACE] = ACTIONS(7829),
    [sym__special_characters] = ACTIONS(7831),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7833),
  },
  [2844] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(7835),
    [sym_comment] = ACTIONS(57),
  },
  [2845] = {
    [sym_concatenation] = STATE(3327),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3327),
    [anon_sym_RBRACE] = ACTIONS(7837),
    [anon_sym_EQ] = ACTIONS(7839),
    [anon_sym_DASH] = ACTIONS(7839),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7843),
    [anon_sym_COLON] = ACTIONS(7839),
    [anon_sym_COLON_QMARK] = ACTIONS(7839),
    [anon_sym_COLON_DASH] = ACTIONS(7839),
    [anon_sym_PERCENT] = ACTIONS(7839),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2846] = {
    [sym_concatenation] = STATE(3329),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3329),
    [anon_sym_RBRACE] = ACTIONS(7829),
    [anon_sym_EQ] = ACTIONS(7845),
    [anon_sym_DASH] = ACTIONS(7845),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(7849),
    [anon_sym_COLON] = ACTIONS(7845),
    [anon_sym_COLON_QMARK] = ACTIONS(7845),
    [anon_sym_COLON_DASH] = ACTIONS(7845),
    [anon_sym_PERCENT] = ACTIONS(7845),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2847] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_fi] = ACTIONS(2408),
    [anon_sym_elif] = ACTIONS(2408),
    [anon_sym_else] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [2848] = {
    [sym_concatenation] = STATE(3332),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3332),
    [sym_regex] = ACTIONS(7851),
    [anon_sym_RBRACE] = ACTIONS(7853),
    [anon_sym_EQ] = ACTIONS(7855),
    [anon_sym_DASH] = ACTIONS(7855),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7855),
    [anon_sym_COLON_QMARK] = ACTIONS(7855),
    [anon_sym_COLON_DASH] = ACTIONS(7855),
    [anon_sym_PERCENT] = ACTIONS(7855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2849] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7853),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2850] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_fi] = ACTIONS(2456),
    [anon_sym_elif] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [2851] = {
    [sym_concatenation] = STATE(3329),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3329),
    [sym_regex] = ACTIONS(7859),
    [anon_sym_RBRACE] = ACTIONS(7829),
    [anon_sym_EQ] = ACTIONS(7845),
    [anon_sym_DASH] = ACTIONS(7845),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7845),
    [anon_sym_COLON_QMARK] = ACTIONS(7845),
    [anon_sym_COLON_DASH] = ACTIONS(7845),
    [anon_sym_PERCENT] = ACTIONS(7845),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2852] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7829),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2853] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_fi] = ACTIONS(2466),
    [anon_sym_elif] = ACTIONS(2466),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [2854] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_fi] = ACTIONS(2504),
    [anon_sym_elif] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [2855] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_fi] = ACTIONS(4021),
    [anon_sym_elif] = ACTIONS(4021),
    [anon_sym_else] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [2856] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_fi] = ACTIONS(4035),
    [anon_sym_elif] = ACTIONS(4035),
    [anon_sym_else] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [2857] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7861),
    [sym_comment] = ACTIONS(57),
  },
  [2858] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(7863),
    [sym_comment] = ACTIONS(57),
  },
  [2859] = {
    [anon_sym_RBRACE] = ACTIONS(7863),
    [sym_comment] = ACTIONS(57),
  },
  [2860] = {
    [sym_concatenation] = STATE(3338),
    [sym_string] = STATE(3337),
    [sym_simple_expansion] = STATE(3337),
    [sym_string_expansion] = STATE(3337),
    [sym_expansion] = STATE(3337),
    [sym_command_substitution] = STATE(3337),
    [sym_process_substitution] = STATE(3337),
    [anon_sym_RBRACE] = ACTIONS(7863),
    [sym__special_characters] = ACTIONS(7865),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(7867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7867),
  },
  [2861] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_fi] = ACTIONS(4071),
    [anon_sym_elif] = ACTIONS(4071),
    [anon_sym_else] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2862] = {
    [sym_concatenation] = STATE(3341),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3341),
    [sym_regex] = ACTIONS(7869),
    [anon_sym_RBRACE] = ACTIONS(7871),
    [anon_sym_EQ] = ACTIONS(7873),
    [anon_sym_DASH] = ACTIONS(7873),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7873),
    [anon_sym_COLON_QMARK] = ACTIONS(7873),
    [anon_sym_COLON_DASH] = ACTIONS(7873),
    [anon_sym_PERCENT] = ACTIONS(7873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2863] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7871),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2864] = {
    [sym_concatenation] = STATE(3343),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3343),
    [sym_regex] = ACTIONS(7877),
    [anon_sym_RBRACE] = ACTIONS(7863),
    [anon_sym_EQ] = ACTIONS(7879),
    [anon_sym_DASH] = ACTIONS(7879),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7879),
    [anon_sym_COLON_QMARK] = ACTIONS(7879),
    [anon_sym_COLON_DASH] = ACTIONS(7879),
    [anon_sym_PERCENT] = ACTIONS(7879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2865] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7863),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2866] = {
    [sym_concatenation] = STATE(3345),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3345),
    [anon_sym_RBRACE] = ACTIONS(7883),
    [anon_sym_EQ] = ACTIONS(7885),
    [anon_sym_DASH] = ACTIONS(7885),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7885),
    [anon_sym_COLON_QMARK] = ACTIONS(7885),
    [anon_sym_COLON_DASH] = ACTIONS(7885),
    [anon_sym_PERCENT] = ACTIONS(7885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2867] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_elif] = ACTIONS(4127),
    [anon_sym_else] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2868] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(7883),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2869] = {
    [sym_concatenation] = STATE(3343),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3343),
    [anon_sym_RBRACE] = ACTIONS(7863),
    [anon_sym_EQ] = ACTIONS(7879),
    [anon_sym_DASH] = ACTIONS(7879),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(7881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(7879),
    [anon_sym_COLON_QMARK] = ACTIONS(7879),
    [anon_sym_COLON_DASH] = ACTIONS(7879),
    [anon_sym_PERCENT] = ACTIONS(7879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2870] = {
    [sym__simple_heredoc_body] = ACTIONS(7889),
    [sym__heredoc_body_beginning] = ACTIONS(7889),
    [sym_file_descriptor] = ACTIONS(7889),
    [ts_builtin_sym_end] = ACTIONS(7889),
    [anon_sym_SEMI] = ACTIONS(7891),
    [anon_sym_done] = ACTIONS(7889),
    [anon_sym_fi] = ACTIONS(7889),
    [anon_sym_elif] = ACTIONS(7889),
    [anon_sym_else] = ACTIONS(7889),
    [anon_sym_esac] = ACTIONS(7889),
    [anon_sym_PIPE] = ACTIONS(7891),
    [anon_sym_RPAREN] = ACTIONS(7889),
    [anon_sym_SEMI_SEMI] = ACTIONS(7889),
    [anon_sym_PIPE_AMP] = ACTIONS(7889),
    [anon_sym_AMP_AMP] = ACTIONS(7889),
    [anon_sym_PIPE_PIPE] = ACTIONS(7889),
    [anon_sym_LT] = ACTIONS(7891),
    [anon_sym_GT] = ACTIONS(7891),
    [anon_sym_GT_GT] = ACTIONS(7889),
    [anon_sym_AMP_GT] = ACTIONS(7891),
    [anon_sym_AMP_GT_GT] = ACTIONS(7889),
    [anon_sym_LT_AMP] = ACTIONS(7889),
    [anon_sym_GT_AMP] = ACTIONS(7889),
    [anon_sym_LT_LT] = ACTIONS(7891),
    [anon_sym_LT_LT_DASH] = ACTIONS(7889),
    [anon_sym_LT_LT_LT] = ACTIONS(7889),
    [anon_sym_BQUOTE] = ACTIONS(7889),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7889),
    [anon_sym_AMP] = ACTIONS(7891),
  },
  [2871] = {
    [aux_sym_concatenation_repeat1] = STATE(2873),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_fi] = ACTIONS(1367),
    [anon_sym_elif] = ACTIONS(1367),
    [anon_sym_else] = ACTIONS(1367),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [2872] = {
    [aux_sym_concatenation_repeat1] = STATE(2873),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1371),
    [anon_sym_elif] = ACTIONS(1371),
    [anon_sym_else] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2873] = {
    [aux_sym_concatenation_repeat1] = STATE(3346),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1049),
    [anon_sym_elif] = ACTIONS(1049),
    [anon_sym_else] = ACTIONS(1049),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [2874] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_fi] = ACTIONS(7487),
    [anon_sym_elif] = ACTIONS(7487),
    [anon_sym_else] = ACTIONS(7487),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [2875] = {
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_RPAREN] = ACTIONS(7893),
    [sym_comment] = ACTIONS(57),
  },
  [2876] = {
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(7895),
    [anon_sym_RPAREN] = ACTIONS(7895),
    [sym_comment] = ACTIONS(57),
  },
  [2877] = {
    [anon_sym_PIPE] = ACTIONS(7895),
    [anon_sym_RPAREN] = ACTIONS(7895),
    [sym_comment] = ACTIONS(57),
  },
  [2878] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(7897),
    [anon_sym_PLUS_EQ] = ACTIONS(7897),
    [sym_comment] = ACTIONS(57),
  },
  [2879] = {
    [anon_sym_esac] = ACTIONS(7899),
    [sym__special_characters] = ACTIONS(7901),
    [anon_sym_DQUOTE] = ACTIONS(7901),
    [anon_sym_DOLLAR] = ACTIONS(7903),
    [sym_raw_string] = ACTIONS(7901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7901),
    [anon_sym_BQUOTE] = ACTIONS(7901),
    [anon_sym_LT_LPAREN] = ACTIONS(7901),
    [anon_sym_GT_LPAREN] = ACTIONS(7901),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7903),
  },
  [2880] = {
    [sym_subshell] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_command_name] = STATE(2894),
    [sym_variable_assignment] = STATE(2899),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(2899),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym_command_repeat1] = STATE(2899),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(6711),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6717),
  },
  [2881] = {
    [sym_variable_assignment] = STATE(3358),
    [sym_subscript] = STATE(3357),
    [sym_concatenation] = STATE(3358),
    [sym_string] = STATE(3352),
    [sym_simple_expansion] = STATE(3352),
    [sym_string_expansion] = STATE(3352),
    [sym_expansion] = STATE(3352),
    [sym_command_substitution] = STATE(3352),
    [sym_process_substitution] = STATE(3352),
    [aux_sym_declaration_command_repeat1] = STATE(3358),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_esac] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_characters] = ACTIONS(7907),
    [anon_sym_DQUOTE] = ACTIONS(7909),
    [anon_sym_DOLLAR] = ACTIONS(7911),
    [sym_raw_string] = ACTIONS(7913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7917),
    [anon_sym_BQUOTE] = ACTIONS(7919),
    [anon_sym_LT_LPAREN] = ACTIONS(7921),
    [anon_sym_GT_LPAREN] = ACTIONS(7921),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7923),
    [sym_word] = ACTIONS(7925),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [2882] = {
    [sym_concatenation] = STATE(3367),
    [sym_string] = STATE(3362),
    [sym_simple_expansion] = STATE(3362),
    [sym_string_expansion] = STATE(3362),
    [sym_expansion] = STATE(3362),
    [sym_command_substitution] = STATE(3362),
    [sym_process_substitution] = STATE(3362),
    [aux_sym_unset_command_repeat1] = STATE(3367),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_esac] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_characters] = ACTIONS(7927),
    [anon_sym_DQUOTE] = ACTIONS(7929),
    [anon_sym_DOLLAR] = ACTIONS(7931),
    [sym_raw_string] = ACTIONS(7933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7935),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7937),
    [anon_sym_BQUOTE] = ACTIONS(7939),
    [anon_sym_LT_LPAREN] = ACTIONS(7941),
    [anon_sym_GT_LPAREN] = ACTIONS(7941),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7943),
    [sym_word] = ACTIONS(7945),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [2883] = {
    [aux_sym_concatenation_repeat1] = STATE(3369),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(7947),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_characters] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2884] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(3372),
    [anon_sym_DQUOTE] = ACTIONS(7949),
    [anon_sym_DOLLAR] = ACTIONS(7951),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2885] = {
    [sym_string] = STATE(3374),
    [anon_sym_DASH] = ACTIONS(7953),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(7953),
    [sym_raw_string] = ACTIONS(7955),
    [anon_sym_POUND] = ACTIONS(7953),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7957),
    [anon_sym_STAR] = ACTIONS(7959),
    [anon_sym_AT] = ACTIONS(7959),
    [anon_sym_QMARK] = ACTIONS(7959),
    [anon_sym_0] = ACTIONS(7957),
    [anon_sym__] = ACTIONS(7957),
  },
  [2886] = {
    [aux_sym_concatenation_repeat1] = STATE(3369),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(7947),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [2887] = {
    [sym_subscript] = STATE(3379),
    [sym_variable_name] = ACTIONS(7961),
    [anon_sym_BANG] = ACTIONS(7963),
    [anon_sym_DASH] = ACTIONS(7965),
    [anon_sym_DOLLAR] = ACTIONS(7965),
    [anon_sym_POUND] = ACTIONS(7963),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7967),
    [anon_sym_STAR] = ACTIONS(7969),
    [anon_sym_AT] = ACTIONS(7969),
    [anon_sym_QMARK] = ACTIONS(7969),
    [anon_sym_0] = ACTIONS(7967),
    [anon_sym__] = ACTIONS(7967),
  },
  [2888] = {
    [sym__statements] = STATE(3380),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(3381),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2889] = {
    [sym__statements] = STATE(3382),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2890] = {
    [sym__statements] = STATE(3383),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2891] = {
    [aux_sym_concatenation_repeat1] = STATE(3369),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(7947),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [2892] = {
    [anon_sym_esac] = ACTIONS(7971),
    [anon_sym_SEMI_SEMI] = ACTIONS(7973),
    [sym_comment] = ACTIONS(57),
  },
  [2893] = {
    [sym_file_redirect] = STATE(3392),
    [sym_heredoc_redirect] = STATE(3392),
    [sym_heredoc_body] = STATE(3391),
    [sym_herestring_redirect] = STATE(3392),
    [aux_sym_redirected_statement_repeat1] = STATE(3392),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(7975),
    [anon_sym_SEMI] = ACTIONS(7977),
    [anon_sym_esac] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(7979),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(7981),
    [anon_sym_AMP_AMP] = ACTIONS(7983),
    [anon_sym_PIPE_PIPE] = ACTIONS(7983),
    [anon_sym_LT] = ACTIONS(7985),
    [anon_sym_GT] = ACTIONS(7985),
    [anon_sym_GT_GT] = ACTIONS(7987),
    [anon_sym_AMP_GT] = ACTIONS(7985),
    [anon_sym_AMP_GT_GT] = ACTIONS(7987),
    [anon_sym_LT_AMP] = ACTIONS(7987),
    [anon_sym_GT_AMP] = ACTIONS(7987),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7989),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7991),
    [anon_sym_AMP] = ACTIONS(7977),
  },
  [2894] = {
    [sym_concatenation] = STATE(3396),
    [sym_string] = STATE(3395),
    [sym_simple_expansion] = STATE(3395),
    [sym_string_expansion] = STATE(3395),
    [sym_expansion] = STATE(3395),
    [sym_command_substitution] = STATE(3395),
    [sym_process_substitution] = STATE(3395),
    [aux_sym_command_repeat2] = STATE(3396),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_esac] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(7993),
    [anon_sym_EQ_EQ] = ACTIONS(7993),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_characters] = ACTIONS(7995),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(7997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7999),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [2895] = {
    [sym_file_redirect] = STATE(3392),
    [sym_heredoc_redirect] = STATE(3392),
    [sym_heredoc_body] = STATE(3391),
    [sym_herestring_redirect] = STATE(3392),
    [aux_sym_redirected_statement_repeat1] = STATE(3392),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(7977),
    [anon_sym_esac] = ACTIONS(3237),
    [anon_sym_PIPE] = ACTIONS(7979),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(7981),
    [anon_sym_AMP_AMP] = ACTIONS(7983),
    [anon_sym_PIPE_PIPE] = ACTIONS(7983),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7989),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(7991),
    [anon_sym_AMP] = ACTIONS(7977),
  },
  [2896] = {
    [anon_sym_EQ] = ACTIONS(7897),
    [anon_sym_PLUS_EQ] = ACTIONS(7897),
    [sym_comment] = ACTIONS(57),
  },
  [2897] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [2898] = {
    [sym_redirected_statement] = STATE(3397),
    [sym_for_statement] = STATE(3397),
    [sym_c_style_for_statement] = STATE(3397),
    [sym_while_statement] = STATE(3397),
    [sym_if_statement] = STATE(3397),
    [sym_case_statement] = STATE(3397),
    [sym_function_definition] = STATE(3397),
    [sym_compound_statement] = STATE(3397),
    [sym_subshell] = STATE(3397),
    [sym_pipeline] = STATE(3397),
    [sym_list] = STATE(3397),
    [sym_negated_command] = STATE(3397),
    [sym_test_command] = STATE(3397),
    [sym_declaration_command] = STATE(3397),
    [sym_unset_command] = STATE(3397),
    [sym_command] = STATE(3397),
    [sym_command_name] = STATE(2894),
    [sym_variable_assignment] = STATE(3398),
    [sym_subscript] = STATE(2896),
    [sym_file_redirect] = STATE(2899),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(2899),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6699),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6705),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6707),
    [anon_sym_typeset] = ACTIONS(6707),
    [anon_sym_export] = ACTIONS(6707),
    [anon_sym_readonly] = ACTIONS(6707),
    [anon_sym_local] = ACTIONS(6707),
    [anon_sym_unset] = ACTIONS(6709),
    [anon_sym_unsetenv] = ACTIONS(6709),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(6711),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6727),
  },
  [2899] = {
    [sym_command_name] = STATE(3399),
    [sym_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(241),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym_command_repeat1] = STATE(241),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(8001),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6717),
  },
  [2900] = {
    [sym__statements] = STATE(3400),
    [sym_redirected_statement] = STATE(2893),
    [sym_for_statement] = STATE(2893),
    [sym_c_style_for_statement] = STATE(2893),
    [sym_while_statement] = STATE(2893),
    [sym_if_statement] = STATE(2893),
    [sym_case_statement] = STATE(2893),
    [sym_function_definition] = STATE(2893),
    [sym_compound_statement] = STATE(2893),
    [sym_subshell] = STATE(2893),
    [sym_pipeline] = STATE(2893),
    [sym_list] = STATE(2893),
    [sym_negated_command] = STATE(2893),
    [sym_test_command] = STATE(2893),
    [sym_declaration_command] = STATE(2893),
    [sym_unset_command] = STATE(2893),
    [sym_command] = STATE(2893),
    [sym_command_name] = STATE(2894),
    [sym_variable_assignment] = STATE(2895),
    [sym_subscript] = STATE(2896),
    [sym_file_redirect] = STATE(2899),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym__statements_repeat1] = STATE(2898),
    [aux_sym_command_repeat1] = STATE(2899),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6699),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(7899),
    [anon_sym_SEMI_SEMI] = ACTIONS(7973),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6705),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6707),
    [anon_sym_typeset] = ACTIONS(6707),
    [anon_sym_export] = ACTIONS(6707),
    [anon_sym_readonly] = ACTIONS(6707),
    [anon_sym_local] = ACTIONS(6707),
    [anon_sym_unset] = ACTIONS(6709),
    [anon_sym_unsetenv] = ACTIONS(6709),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(6711),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6727),
  },
  [2901] = {
    [aux_sym_case_item_repeat1] = STATE(2901),
    [anon_sym_PIPE] = ACTIONS(8003),
    [anon_sym_RPAREN] = ACTIONS(7895),
    [sym_comment] = ACTIONS(57),
  },
  [2902] = {
    [aux_sym_concatenation_repeat1] = STATE(2902),
    [sym__concat] = ACTIONS(4529),
    [anon_sym_PIPE] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
  },
  [2903] = {
    [anon_sym_esac] = ACTIONS(8006),
    [sym__special_characters] = ACTIONS(8008),
    [anon_sym_DQUOTE] = ACTIONS(8008),
    [anon_sym_DOLLAR] = ACTIONS(8010),
    [sym_raw_string] = ACTIONS(8008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8008),
    [anon_sym_BQUOTE] = ACTIONS(8008),
    [anon_sym_LT_LPAREN] = ACTIONS(8008),
    [anon_sym_GT_LPAREN] = ACTIONS(8008),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8010),
  },
  [2904] = {
    [anon_sym_esac] = ACTIONS(8012),
    [anon_sym_SEMI_SEMI] = ACTIONS(8014),
    [sym_comment] = ACTIONS(57),
  },
  [2905] = {
    [sym__statements] = STATE(3402),
    [sym_redirected_statement] = STATE(2893),
    [sym_for_statement] = STATE(2893),
    [sym_c_style_for_statement] = STATE(2893),
    [sym_while_statement] = STATE(2893),
    [sym_if_statement] = STATE(2893),
    [sym_case_statement] = STATE(2893),
    [sym_function_definition] = STATE(2893),
    [sym_compound_statement] = STATE(2893),
    [sym_subshell] = STATE(2893),
    [sym_pipeline] = STATE(2893),
    [sym_list] = STATE(2893),
    [sym_negated_command] = STATE(2893),
    [sym_test_command] = STATE(2893),
    [sym_declaration_command] = STATE(2893),
    [sym_unset_command] = STATE(2893),
    [sym_command] = STATE(2893),
    [sym_command_name] = STATE(2894),
    [sym_variable_assignment] = STATE(2895),
    [sym_subscript] = STATE(2896),
    [sym_file_redirect] = STATE(2899),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym__statements_repeat1] = STATE(2898),
    [aux_sym_command_repeat1] = STATE(2899),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6699),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(8006),
    [anon_sym_SEMI_SEMI] = ACTIONS(8014),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6705),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6707),
    [anon_sym_typeset] = ACTIONS(6707),
    [anon_sym_export] = ACTIONS(6707),
    [anon_sym_readonly] = ACTIONS(6707),
    [anon_sym_local] = ACTIONS(6707),
    [anon_sym_unset] = ACTIONS(6709),
    [anon_sym_unsetenv] = ACTIONS(6709),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(6711),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6727),
  },
  [2906] = {
    [sym__simple_heredoc_body] = ACTIONS(8016),
    [sym__heredoc_body_beginning] = ACTIONS(8016),
    [sym_file_descriptor] = ACTIONS(8016),
    [ts_builtin_sym_end] = ACTIONS(8016),
    [anon_sym_SEMI] = ACTIONS(8018),
    [anon_sym_done] = ACTIONS(8016),
    [anon_sym_fi] = ACTIONS(8016),
    [anon_sym_elif] = ACTIONS(8016),
    [anon_sym_else] = ACTIONS(8016),
    [anon_sym_esac] = ACTIONS(8016),
    [anon_sym_PIPE] = ACTIONS(8018),
    [anon_sym_RPAREN] = ACTIONS(8016),
    [anon_sym_SEMI_SEMI] = ACTIONS(8016),
    [anon_sym_PIPE_AMP] = ACTIONS(8016),
    [anon_sym_AMP_AMP] = ACTIONS(8016),
    [anon_sym_PIPE_PIPE] = ACTIONS(8016),
    [anon_sym_LT] = ACTIONS(8018),
    [anon_sym_GT] = ACTIONS(8018),
    [anon_sym_GT_GT] = ACTIONS(8016),
    [anon_sym_AMP_GT] = ACTIONS(8018),
    [anon_sym_AMP_GT_GT] = ACTIONS(8016),
    [anon_sym_LT_AMP] = ACTIONS(8016),
    [anon_sym_GT_AMP] = ACTIONS(8016),
    [anon_sym_LT_LT] = ACTIONS(8018),
    [anon_sym_LT_LT_DASH] = ACTIONS(8016),
    [anon_sym_LT_LT_LT] = ACTIONS(8016),
    [anon_sym_BQUOTE] = ACTIONS(8016),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8016),
    [anon_sym_AMP] = ACTIONS(8018),
  },
  [2907] = {
    [aux_sym_case_item_repeat1] = STATE(3404),
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(8020),
    [sym_comment] = ACTIONS(57),
  },
  [2908] = {
    [aux_sym_case_item_repeat1] = STATE(3406),
    [aux_sym_concatenation_repeat1] = STATE(2271),
    [sym__concat] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(8022),
    [sym_comment] = ACTIONS(57),
  },
  [2909] = {
    [aux_sym_case_item_repeat1] = STATE(3406),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(8022),
    [sym_comment] = ACTIONS(57),
  },
  [2910] = {
    [anon_sym_esac] = ACTIONS(8024),
    [sym_comment] = ACTIONS(57),
  },
  [2911] = {
    [sym__simple_heredoc_body] = ACTIONS(8026),
    [sym__heredoc_body_beginning] = ACTIONS(8026),
    [sym_file_descriptor] = ACTIONS(8026),
    [ts_builtin_sym_end] = ACTIONS(8026),
    [anon_sym_SEMI] = ACTIONS(8028),
    [anon_sym_done] = ACTIONS(8026),
    [anon_sym_fi] = ACTIONS(8026),
    [anon_sym_elif] = ACTIONS(8026),
    [anon_sym_else] = ACTIONS(8026),
    [anon_sym_esac] = ACTIONS(8026),
    [anon_sym_PIPE] = ACTIONS(8028),
    [anon_sym_RPAREN] = ACTIONS(8026),
    [anon_sym_SEMI_SEMI] = ACTIONS(8026),
    [anon_sym_PIPE_AMP] = ACTIONS(8026),
    [anon_sym_AMP_AMP] = ACTIONS(8026),
    [anon_sym_PIPE_PIPE] = ACTIONS(8026),
    [anon_sym_LT] = ACTIONS(8028),
    [anon_sym_GT] = ACTIONS(8028),
    [anon_sym_GT_GT] = ACTIONS(8026),
    [anon_sym_AMP_GT] = ACTIONS(8028),
    [anon_sym_AMP_GT_GT] = ACTIONS(8026),
    [anon_sym_LT_AMP] = ACTIONS(8026),
    [anon_sym_GT_AMP] = ACTIONS(8026),
    [anon_sym_LT_LT] = ACTIONS(8028),
    [anon_sym_LT_LT_DASH] = ACTIONS(8026),
    [anon_sym_LT_LT_LT] = ACTIONS(8026),
    [anon_sym_BQUOTE] = ACTIONS(8026),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8026),
    [anon_sym_AMP] = ACTIONS(8028),
  },
  [2912] = {
    [anon_sym_esac] = ACTIONS(8030),
    [sym_comment] = ACTIONS(57),
  },
  [2913] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_in] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7043),
  },
  [2914] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_in] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7047),
  },
  [2915] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_in] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7051),
  },
  [2916] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2917] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8034),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2918] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_in] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7087),
  },
  [2919] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4021),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [2920] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_RBRACE] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4035),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [2921] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8036),
    [sym_comment] = ACTIONS(57),
  },
  [2922] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8038),
    [sym_comment] = ACTIONS(57),
  },
  [2923] = {
    [anon_sym_RBRACE] = ACTIONS(8038),
    [sym_comment] = ACTIONS(57),
  },
  [2924] = {
    [sym_concatenation] = STATE(3415),
    [sym_string] = STATE(3414),
    [sym_simple_expansion] = STATE(3414),
    [sym_string_expansion] = STATE(3414),
    [sym_expansion] = STATE(3414),
    [sym_command_substitution] = STATE(3414),
    [sym_process_substitution] = STATE(3414),
    [anon_sym_RBRACE] = ACTIONS(8038),
    [sym__special_characters] = ACTIONS(8040),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8042),
  },
  [2925] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2926] = {
    [sym_concatenation] = STATE(3418),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3418),
    [sym_regex] = ACTIONS(8044),
    [anon_sym_RBRACE] = ACTIONS(8046),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_DASH] = ACTIONS(8048),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_COLON_QMARK] = ACTIONS(8048),
    [anon_sym_COLON_DASH] = ACTIONS(8048),
    [anon_sym_PERCENT] = ACTIONS(8048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2927] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8046),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2928] = {
    [sym_concatenation] = STATE(3420),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3420),
    [sym_regex] = ACTIONS(8052),
    [anon_sym_RBRACE] = ACTIONS(8038),
    [anon_sym_EQ] = ACTIONS(8054),
    [anon_sym_DASH] = ACTIONS(8054),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8054),
    [anon_sym_COLON_QMARK] = ACTIONS(8054),
    [anon_sym_COLON_DASH] = ACTIONS(8054),
    [anon_sym_PERCENT] = ACTIONS(8054),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2929] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8038),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2930] = {
    [sym_concatenation] = STATE(3422),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3422),
    [anon_sym_RBRACE] = ACTIONS(8058),
    [anon_sym_EQ] = ACTIONS(8060),
    [anon_sym_DASH] = ACTIONS(8060),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8060),
    [anon_sym_COLON_QMARK] = ACTIONS(8060),
    [anon_sym_COLON_DASH] = ACTIONS(8060),
    [anon_sym_PERCENT] = ACTIONS(8060),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2931] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2932] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8058),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2933] = {
    [sym_concatenation] = STATE(3420),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3420),
    [anon_sym_RBRACE] = ACTIONS(8038),
    [anon_sym_EQ] = ACTIONS(8054),
    [anon_sym_DASH] = ACTIONS(8054),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8054),
    [anon_sym_COLON_QMARK] = ACTIONS(8054),
    [anon_sym_COLON_DASH] = ACTIONS(8054),
    [anon_sym_PERCENT] = ACTIONS(8054),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2934] = {
    [sym_do_group] = STATE(3423),
    [sym_compound_statement] = STATE(3423),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [2935] = {
    [sym__simple_heredoc_body] = ACTIONS(5763),
    [sym__heredoc_body_beginning] = ACTIONS(5763),
    [sym_file_descriptor] = ACTIONS(5763),
    [anon_sym_SEMI] = ACTIONS(5765),
    [anon_sym_PIPE] = ACTIONS(5765),
    [anon_sym_SEMI_SEMI] = ACTIONS(5763),
    [anon_sym_RBRACE] = ACTIONS(5763),
    [anon_sym_PIPE_AMP] = ACTIONS(5763),
    [anon_sym_AMP_AMP] = ACTIONS(5763),
    [anon_sym_PIPE_PIPE] = ACTIONS(5763),
    [anon_sym_LT] = ACTIONS(5765),
    [anon_sym_GT] = ACTIONS(5765),
    [anon_sym_GT_GT] = ACTIONS(5763),
    [anon_sym_AMP_GT] = ACTIONS(5765),
    [anon_sym_AMP_GT_GT] = ACTIONS(5763),
    [anon_sym_LT_AMP] = ACTIONS(5763),
    [anon_sym_GT_AMP] = ACTIONS(5763),
    [anon_sym_LT_LT] = ACTIONS(5765),
    [anon_sym_LT_LT_DASH] = ACTIONS(5763),
    [anon_sym_LT_LT_LT] = ACTIONS(5763),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5763),
    [anon_sym_AMP] = ACTIONS(5765),
  },
  [2936] = {
    [sym_do_group] = STATE(3423),
    [sym_compound_statement] = STATE(3423),
    [anon_sym_SEMI] = ACTIONS(8064),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [2937] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8066),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [2938] = {
    [sym__expression] = STATE(3426),
    [sym_binary_expression] = STATE(3426),
    [sym_unary_expression] = STATE(3426),
    [sym_postfix_expression] = STATE(3426),
    [sym_parenthesized_expression] = STATE(3426),
    [sym_concatenation] = STATE(3426),
    [sym_string] = STATE(46),
    [sym_simple_expansion] = STATE(46),
    [sym_string_expansion] = STATE(46),
    [sym_expansion] = STATE(46),
    [sym_command_substitution] = STATE(46),
    [sym_process_substitution] = STATE(46),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8066),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_characters] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2939] = {
    [sym__simple_heredoc_body] = ACTIONS(5836),
    [sym__heredoc_body_beginning] = ACTIONS(5836),
    [sym_file_descriptor] = ACTIONS(5836),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_PIPE] = ACTIONS(5838),
    [anon_sym_SEMI_SEMI] = ACTIONS(5836),
    [anon_sym_RBRACE] = ACTIONS(5836),
    [anon_sym_PIPE_AMP] = ACTIONS(5836),
    [anon_sym_AMP_AMP] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5836),
    [anon_sym_LT] = ACTIONS(5838),
    [anon_sym_GT] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5836),
    [anon_sym_AMP_GT] = ACTIONS(5838),
    [anon_sym_AMP_GT_GT] = ACTIONS(5836),
    [anon_sym_LT_AMP] = ACTIONS(5836),
    [anon_sym_GT_AMP] = ACTIONS(5836),
    [anon_sym_LT_LT] = ACTIONS(5838),
    [anon_sym_LT_LT_DASH] = ACTIONS(5836),
    [anon_sym_LT_LT_LT] = ACTIONS(5836),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5836),
    [anon_sym_AMP] = ACTIONS(5838),
  },
  [2940] = {
    [sym__simple_heredoc_body] = ACTIONS(6639),
    [sym__heredoc_body_beginning] = ACTIONS(6639),
    [sym_file_descriptor] = ACTIONS(6639),
    [anon_sym_SEMI] = ACTIONS(6641),
    [anon_sym_PIPE] = ACTIONS(6641),
    [anon_sym_SEMI_SEMI] = ACTIONS(6639),
    [anon_sym_RBRACE] = ACTIONS(6639),
    [anon_sym_PIPE_AMP] = ACTIONS(6639),
    [anon_sym_AMP_AMP] = ACTIONS(6639),
    [anon_sym_PIPE_PIPE] = ACTIONS(6639),
    [anon_sym_LT] = ACTIONS(6641),
    [anon_sym_GT] = ACTIONS(6641),
    [anon_sym_GT_GT] = ACTIONS(6639),
    [anon_sym_AMP_GT] = ACTIONS(6641),
    [anon_sym_AMP_GT_GT] = ACTIONS(6639),
    [anon_sym_LT_AMP] = ACTIONS(6639),
    [anon_sym_GT_AMP] = ACTIONS(6639),
    [anon_sym_LT_LT] = ACTIONS(6641),
    [anon_sym_LT_LT_DASH] = ACTIONS(6639),
    [anon_sym_LT_LT_LT] = ACTIONS(6639),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6639),
    [anon_sym_AMP] = ACTIONS(6641),
  },
  [2941] = {
    [anon_sym_fi] = ACTIONS(8068),
    [sym_comment] = ACTIONS(57),
  },
  [2942] = {
    [sym__simple_heredoc_body] = ACTIONS(6737),
    [sym__heredoc_body_beginning] = ACTIONS(6737),
    [sym_file_descriptor] = ACTIONS(6737),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_SEMI_SEMI] = ACTIONS(6737),
    [anon_sym_RBRACE] = ACTIONS(6737),
    [anon_sym_PIPE_AMP] = ACTIONS(6737),
    [anon_sym_AMP_AMP] = ACTIONS(6737),
    [anon_sym_PIPE_PIPE] = ACTIONS(6737),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_GT_GT] = ACTIONS(6737),
    [anon_sym_AMP_GT] = ACTIONS(6739),
    [anon_sym_AMP_GT_GT] = ACTIONS(6737),
    [anon_sym_LT_AMP] = ACTIONS(6737),
    [anon_sym_GT_AMP] = ACTIONS(6737),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_LT_LT_DASH] = ACTIONS(6737),
    [anon_sym_LT_LT_LT] = ACTIONS(6737),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6737),
    [anon_sym_AMP] = ACTIONS(6739),
  },
  [2943] = {
    [anon_sym_esac] = ACTIONS(8070),
    [sym_comment] = ACTIONS(57),
  },
  [2944] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(3429),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2945] = {
    [sym__simple_heredoc_body] = ACTIONS(6767),
    [sym__heredoc_body_beginning] = ACTIONS(6767),
    [sym_file_descriptor] = ACTIONS(6767),
    [anon_sym_SEMI] = ACTIONS(6769),
    [anon_sym_PIPE] = ACTIONS(6769),
    [anon_sym_SEMI_SEMI] = ACTIONS(6767),
    [anon_sym_RBRACE] = ACTIONS(6767),
    [anon_sym_PIPE_AMP] = ACTIONS(6767),
    [anon_sym_AMP_AMP] = ACTIONS(6767),
    [anon_sym_PIPE_PIPE] = ACTIONS(6767),
    [anon_sym_LT] = ACTIONS(6769),
    [anon_sym_GT] = ACTIONS(6769),
    [anon_sym_GT_GT] = ACTIONS(6767),
    [anon_sym_AMP_GT] = ACTIONS(6769),
    [anon_sym_AMP_GT_GT] = ACTIONS(6767),
    [anon_sym_LT_AMP] = ACTIONS(6767),
    [anon_sym_GT_AMP] = ACTIONS(6767),
    [anon_sym_LT_LT] = ACTIONS(6769),
    [anon_sym_LT_LT_DASH] = ACTIONS(6767),
    [anon_sym_LT_LT_LT] = ACTIONS(6767),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6767),
    [anon_sym_AMP] = ACTIONS(6769),
  },
  [2946] = {
    [anon_sym_esac] = ACTIONS(8072),
    [sym_comment] = ACTIONS(57),
  },
  [2947] = {
    [sym_case_item] = STATE(2276),
    [sym_last_case_item] = STATE(3431),
    [sym_concatenation] = STATE(1588),
    [sym_string] = STATE(1586),
    [sym_simple_expansion] = STATE(1586),
    [sym_string_expansion] = STATE(1586),
    [sym_expansion] = STATE(1586),
    [sym_command_substitution] = STATE(1586),
    [sym_process_substitution] = STATE(1586),
    [aux_sym_case_statement_repeat1] = STATE(2276),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(519),
    [anon_sym_GT_LPAREN] = ACTIONS(519),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3431),
  },
  [2948] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4354),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4354),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [2949] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5545),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2950] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5553),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2951] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8074),
    [sym_comment] = ACTIONS(57),
  },
  [2952] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8076),
    [sym_comment] = ACTIONS(57),
  },
  [2953] = {
    [anon_sym_RBRACE] = ACTIONS(8076),
    [sym_comment] = ACTIONS(57),
  },
  [2954] = {
    [sym_concatenation] = STATE(3435),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3435),
    [anon_sym_RBRACE] = ACTIONS(8078),
    [anon_sym_EQ] = ACTIONS(8080),
    [anon_sym_DASH] = ACTIONS(8080),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8080),
    [anon_sym_COLON_QMARK] = ACTIONS(8080),
    [anon_sym_COLON_DASH] = ACTIONS(8080),
    [anon_sym_PERCENT] = ACTIONS(8080),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2955] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5597),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2956] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8078),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2957] = {
    [sym_concatenation] = STATE(3436),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3436),
    [anon_sym_RBRACE] = ACTIONS(8076),
    [anon_sym_EQ] = ACTIONS(8084),
    [anon_sym_DASH] = ACTIONS(8084),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8086),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8084),
    [anon_sym_COLON_QMARK] = ACTIONS(8084),
    [anon_sym_COLON_DASH] = ACTIONS(8084),
    [anon_sym_PERCENT] = ACTIONS(8084),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2958] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8076),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2959] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5642),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2960] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8088),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2961] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5545),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [2962] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5553),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2963] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [sym_comment] = ACTIONS(57),
  },
  [2964] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8092),
    [sym_comment] = ACTIONS(57),
  },
  [2965] = {
    [anon_sym_RBRACE] = ACTIONS(8092),
    [sym_comment] = ACTIONS(57),
  },
  [2966] = {
    [sym_concatenation] = STATE(3441),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3441),
    [anon_sym_RBRACE] = ACTIONS(8094),
    [anon_sym_EQ] = ACTIONS(8096),
    [anon_sym_DASH] = ACTIONS(8096),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8096),
    [anon_sym_COLON_QMARK] = ACTIONS(8096),
    [anon_sym_COLON_DASH] = ACTIONS(8096),
    [anon_sym_PERCENT] = ACTIONS(8096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2967] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5597),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [2968] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8094),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2969] = {
    [sym_concatenation] = STATE(3442),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3442),
    [anon_sym_RBRACE] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(8100),
    [anon_sym_DASH] = ACTIONS(8100),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8100),
    [anon_sym_COLON_QMARK] = ACTIONS(8100),
    [anon_sym_COLON_DASH] = ACTIONS(8100),
    [anon_sym_PERCENT] = ACTIONS(8100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2970] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2971] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5642),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [2972] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2973] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_RBRACE] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7045),
    [anon_sym_EQ_EQ] = ACTIONS(7045),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7045),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [2974] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7049),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7049),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [2975] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_EQ_EQ] = ACTIONS(7053),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7053),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [2976] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8106),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2977] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2978] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_RBRACE] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7089),
    [anon_sym_EQ_EQ] = ACTIONS(7089),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7089),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [2979] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_RBRACK] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7043),
    [anon_sym_EQ_EQ] = ACTIONS(7043),
    [anon_sym_EQ] = ACTIONS(7045),
    [anon_sym_PLUS_EQ] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_BANG_EQ] = ACTIONS(7043),
    [anon_sym_PLUS] = ACTIONS(7045),
    [anon_sym_DASH] = ACTIONS(7045),
    [anon_sym_DASH_EQ] = ACTIONS(7043),
    [anon_sym_LT_EQ] = ACTIONS(7043),
    [anon_sym_GT_EQ] = ACTIONS(7043),
    [anon_sym_PLUS_PLUS] = ACTIONS(7043),
    [anon_sym_DASH_DASH] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7043),
  },
  [2980] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_RBRACK] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7047),
    [anon_sym_EQ_EQ] = ACTIONS(7047),
    [anon_sym_EQ] = ACTIONS(7049),
    [anon_sym_PLUS_EQ] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_BANG_EQ] = ACTIONS(7047),
    [anon_sym_PLUS] = ACTIONS(7049),
    [anon_sym_DASH] = ACTIONS(7049),
    [anon_sym_DASH_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_GT_EQ] = ACTIONS(7047),
    [anon_sym_PLUS_PLUS] = ACTIONS(7047),
    [anon_sym_DASH_DASH] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7047),
  },
  [2981] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_RBRACK] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7051),
    [anon_sym_EQ_EQ] = ACTIONS(7051),
    [anon_sym_EQ] = ACTIONS(7053),
    [anon_sym_PLUS_EQ] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_BANG_EQ] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_EQ] = ACTIONS(7051),
    [anon_sym_LT_EQ] = ACTIONS(7051),
    [anon_sym_GT_EQ] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7051),
  },
  [2982] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2983] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8112),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2984] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_RBRACK] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7087),
    [anon_sym_EQ_EQ] = ACTIONS(7087),
    [anon_sym_EQ] = ACTIONS(7089),
    [anon_sym_PLUS_EQ] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_BANG_EQ] = ACTIONS(7087),
    [anon_sym_PLUS] = ACTIONS(7089),
    [anon_sym_DASH] = ACTIONS(7089),
    [anon_sym_DASH_EQ] = ACTIONS(7087),
    [anon_sym_LT_EQ] = ACTIONS(7087),
    [anon_sym_GT_EQ] = ACTIONS(7087),
    [anon_sym_PLUS_PLUS] = ACTIONS(7087),
    [anon_sym_DASH_DASH] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7087),
  },
  [2985] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [ts_builtin_sym_end] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [2986] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [ts_builtin_sym_end] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_RPAREN] = ACTIONS(7047),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [2987] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [ts_builtin_sym_end] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_RPAREN] = ACTIONS(7051),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [2988] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8114),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2989] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2990] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [ts_builtin_sym_end] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_RPAREN] = ACTIONS(7087),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [2991] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [ts_builtin_sym_end] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [2992] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [ts_builtin_sym_end] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_RPAREN] = ACTIONS(7047),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [2993] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [ts_builtin_sym_end] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_RPAREN] = ACTIONS(7051),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [2994] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8118),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2995] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8120),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [2996] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [ts_builtin_sym_end] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_RPAREN] = ACTIONS(7087),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [2997] = {
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7043),
  },
  [2998] = {
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_RPAREN] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7047),
  },
  [2999] = {
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_RPAREN] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7051),
  },
  [3000] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8122),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3001] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8124),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3002] = {
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_RPAREN] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7087),
  },
  [3003] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7045),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym__string_content] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7045),
    [anon_sym_BQUOTE] = ACTIONS(7045),
    [sym_comment] = ACTIONS(343),
  },
  [3004] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7049),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym__string_content] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7049),
    [anon_sym_BQUOTE] = ACTIONS(7049),
    [sym_comment] = ACTIONS(343),
  },
  [3005] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7053),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym__string_content] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7053),
    [anon_sym_BQUOTE] = ACTIONS(7053),
    [sym_comment] = ACTIONS(343),
  },
  [3006] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3007] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8128),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3008] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7089),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym__string_content] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7089),
    [anon_sym_BQUOTE] = ACTIONS(7089),
    [sym_comment] = ACTIONS(343),
  },
  [3009] = {
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_DASH] = ACTIONS(8130),
    [sym__special_characters] = ACTIONS(8130),
    [anon_sym_DQUOTE] = ACTIONS(5694),
    [anon_sym_DOLLAR] = ACTIONS(8130),
    [sym_raw_string] = ACTIONS(5694),
    [anon_sym_POUND] = ACTIONS(5694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5694),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_COLON] = ACTIONS(8130),
    [anon_sym_COLON_QMARK] = ACTIONS(8130),
    [anon_sym_COLON_DASH] = ACTIONS(8130),
    [anon_sym_PERCENT] = ACTIONS(8130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5694),
    [anon_sym_BQUOTE] = ACTIONS(5694),
    [anon_sym_LT_LPAREN] = ACTIONS(5694),
    [anon_sym_GT_LPAREN] = ACTIONS(5694),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(8130),
  },
  [3010] = {
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_EQ] = ACTIONS(8132),
    [anon_sym_DASH] = ACTIONS(8132),
    [sym__special_characters] = ACTIONS(8132),
    [anon_sym_DQUOTE] = ACTIONS(5696),
    [anon_sym_DOLLAR] = ACTIONS(8132),
    [sym_raw_string] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_COLON] = ACTIONS(8132),
    [anon_sym_COLON_QMARK] = ACTIONS(8132),
    [anon_sym_COLON_DASH] = ACTIONS(8132),
    [anon_sym_PERCENT] = ACTIONS(8132),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5696),
    [anon_sym_BQUOTE] = ACTIONS(5696),
    [anon_sym_LT_LPAREN] = ACTIONS(5696),
    [anon_sym_GT_LPAREN] = ACTIONS(5696),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(8132),
  },
  [3011] = {
    [sym__concat] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
  },
  [3012] = {
    [sym__concat] = ACTIONS(4033),
    [anon_sym_RBRACE] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
  },
  [3013] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8134),
    [sym_comment] = ACTIONS(57),
  },
  [3014] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8136),
    [sym_comment] = ACTIONS(57),
  },
  [3015] = {
    [anon_sym_RBRACE] = ACTIONS(8136),
    [sym_comment] = ACTIONS(57),
  },
  [3016] = {
    [sym_concatenation] = STATE(3460),
    [sym_string] = STATE(3459),
    [sym_simple_expansion] = STATE(3459),
    [sym_string_expansion] = STATE(3459),
    [sym_expansion] = STATE(3459),
    [sym_command_substitution] = STATE(3459),
    [sym_process_substitution] = STATE(3459),
    [anon_sym_RBRACE] = ACTIONS(8136),
    [sym__special_characters] = ACTIONS(8138),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8140),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8140),
  },
  [3017] = {
    [sym__concat] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
  },
  [3018] = {
    [sym_concatenation] = STATE(3463),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3463),
    [sym_regex] = ACTIONS(8142),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_DASH] = ACTIONS(8146),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_COLON_QMARK] = ACTIONS(8146),
    [anon_sym_COLON_DASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3019] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3020] = {
    [sym_concatenation] = STATE(3465),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3465),
    [sym_regex] = ACTIONS(8150),
    [anon_sym_RBRACE] = ACTIONS(8136),
    [anon_sym_EQ] = ACTIONS(8152),
    [anon_sym_DASH] = ACTIONS(8152),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8152),
    [anon_sym_COLON_QMARK] = ACTIONS(8152),
    [anon_sym_COLON_DASH] = ACTIONS(8152),
    [anon_sym_PERCENT] = ACTIONS(8152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3021] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8136),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3022] = {
    [sym_concatenation] = STATE(3467),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3467),
    [anon_sym_RBRACE] = ACTIONS(8156),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_DASH] = ACTIONS(8158),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_COLON_QMARK] = ACTIONS(8158),
    [anon_sym_COLON_DASH] = ACTIONS(8158),
    [anon_sym_PERCENT] = ACTIONS(8158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3023] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
  },
  [3024] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8156),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3025] = {
    [sym_concatenation] = STATE(3465),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3465),
    [anon_sym_RBRACE] = ACTIONS(8136),
    [anon_sym_EQ] = ACTIONS(8152),
    [anon_sym_DASH] = ACTIONS(8152),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8152),
    [anon_sym_COLON_QMARK] = ACTIONS(8152),
    [anon_sym_COLON_DASH] = ACTIONS(8152),
    [anon_sym_PERCENT] = ACTIONS(8152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3026] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [ts_builtin_sym_end] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_RPAREN] = ACTIONS(8162),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8164),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3027] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [ts_builtin_sym_end] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3028] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_DASH] = ACTIONS(5545),
    [sym__special_characters] = ACTIONS(5545),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_POUND] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_COLON] = ACTIONS(5545),
    [anon_sym_COLON_QMARK] = ACTIONS(5545),
    [anon_sym_COLON_DASH] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5545),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5545),
  },
  [3029] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_DASH] = ACTIONS(5553),
    [sym__special_characters] = ACTIONS(5553),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_POUND] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_COLON] = ACTIONS(5553),
    [anon_sym_COLON_QMARK] = ACTIONS(5553),
    [anon_sym_COLON_DASH] = ACTIONS(5553),
    [anon_sym_PERCENT] = ACTIONS(5553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5553),
  },
  [3030] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8170),
    [sym_comment] = ACTIONS(57),
  },
  [3031] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(57),
  },
  [3032] = {
    [anon_sym_RBRACE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(57),
  },
  [3033] = {
    [sym_concatenation] = STATE(3471),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3471),
    [anon_sym_RBRACE] = ACTIONS(8174),
    [anon_sym_EQ] = ACTIONS(8176),
    [anon_sym_DASH] = ACTIONS(8176),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8176),
    [anon_sym_COLON_QMARK] = ACTIONS(8176),
    [anon_sym_COLON_DASH] = ACTIONS(8176),
    [anon_sym_PERCENT] = ACTIONS(8176),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3034] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5595),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [sym__special_characters] = ACTIONS(5597),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_POUND] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_COLON_QMARK] = ACTIONS(5597),
    [anon_sym_COLON_DASH] = ACTIONS(5597),
    [anon_sym_PERCENT] = ACTIONS(5597),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5597),
  },
  [3035] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8174),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3036] = {
    [sym_concatenation] = STATE(3472),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3472),
    [anon_sym_RBRACE] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8180),
    [anon_sym_DASH] = ACTIONS(8180),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8180),
    [anon_sym_COLON_QMARK] = ACTIONS(8180),
    [anon_sym_COLON_DASH] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(8180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3037] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3038] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [sym__special_characters] = ACTIONS(5642),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_POUND] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5642),
    [anon_sym_COLON_QMARK] = ACTIONS(5642),
    [anon_sym_COLON_DASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5642),
  },
  [3039] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3040] = {
    [sym__heredoc_body_middle] = ACTIONS(5543),
    [sym__heredoc_body_end] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
  },
  [3041] = {
    [sym__heredoc_body_middle] = ACTIONS(5551),
    [sym__heredoc_body_end] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
  },
  [3042] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8186),
    [sym_comment] = ACTIONS(57),
  },
  [3043] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [sym_comment] = ACTIONS(57),
  },
  [3044] = {
    [anon_sym_RBRACE] = ACTIONS(8188),
    [sym_comment] = ACTIONS(57),
  },
  [3045] = {
    [sym_concatenation] = STATE(3477),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3477),
    [anon_sym_RBRACE] = ACTIONS(8190),
    [anon_sym_EQ] = ACTIONS(8192),
    [anon_sym_DASH] = ACTIONS(8192),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8192),
    [anon_sym_COLON_QMARK] = ACTIONS(8192),
    [anon_sym_COLON_DASH] = ACTIONS(8192),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3046] = {
    [sym__heredoc_body_middle] = ACTIONS(5595),
    [sym__heredoc_body_end] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
  },
  [3047] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8190),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3048] = {
    [sym_concatenation] = STATE(3478),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3478),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8196),
    [anon_sym_DASH] = ACTIONS(8196),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8196),
    [anon_sym_COLON_QMARK] = ACTIONS(8196),
    [anon_sym_COLON_DASH] = ACTIONS(8196),
    [anon_sym_PERCENT] = ACTIONS(8196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3049] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3050] = {
    [sym__heredoc_body_middle] = ACTIONS(5640),
    [sym__heredoc_body_end] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
  },
  [3051] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3052] = {
    [aux_sym_concatenation_repeat1] = STATE(3052),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3053] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5543),
  },
  [3054] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5551),
  },
  [3055] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8202),
    [sym_comment] = ACTIONS(57),
  },
  [3056] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [sym_comment] = ACTIONS(57),
  },
  [3057] = {
    [anon_sym_RBRACE] = ACTIONS(8204),
    [sym_comment] = ACTIONS(57),
  },
  [3058] = {
    [sym_concatenation] = STATE(3483),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3483),
    [anon_sym_RBRACE] = ACTIONS(8206),
    [anon_sym_EQ] = ACTIONS(8208),
    [anon_sym_DASH] = ACTIONS(8208),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8208),
    [anon_sym_COLON_QMARK] = ACTIONS(8208),
    [anon_sym_COLON_DASH] = ACTIONS(8208),
    [anon_sym_PERCENT] = ACTIONS(8208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3059] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_RPAREN] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5595),
  },
  [3060] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8206),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3061] = {
    [sym_concatenation] = STATE(3484),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3484),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8212),
    [anon_sym_DASH] = ACTIONS(8212),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8212),
    [anon_sym_COLON_QMARK] = ACTIONS(8212),
    [anon_sym_COLON_DASH] = ACTIONS(8212),
    [anon_sym_PERCENT] = ACTIONS(8212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3062] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3063] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5640),
  },
  [3064] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3065] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [ts_builtin_sym_end] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3066] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [ts_builtin_sym_end] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_RPAREN] = ACTIONS(7047),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3067] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [ts_builtin_sym_end] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_RPAREN] = ACTIONS(7051),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3068] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8218),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3069] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3070] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [ts_builtin_sym_end] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_RPAREN] = ACTIONS(7087),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3071] = {
    [sym__simple_heredoc_body] = ACTIONS(8222),
    [sym__heredoc_body_beginning] = ACTIONS(8222),
    [sym_file_descriptor] = ACTIONS(8222),
    [ts_builtin_sym_end] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_done] = ACTIONS(8222),
    [anon_sym_fi] = ACTIONS(8222),
    [anon_sym_elif] = ACTIONS(8222),
    [anon_sym_else] = ACTIONS(8222),
    [anon_sym_esac] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8222),
    [anon_sym_SEMI_SEMI] = ACTIONS(8222),
    [anon_sym_PIPE_AMP] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8222),
    [anon_sym_PIPE_PIPE] = ACTIONS(8222),
    [anon_sym_LT] = ACTIONS(8224),
    [anon_sym_GT] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8222),
    [anon_sym_AMP_GT] = ACTIONS(8224),
    [anon_sym_AMP_GT_GT] = ACTIONS(8222),
    [anon_sym_LT_AMP] = ACTIONS(8222),
    [anon_sym_GT_AMP] = ACTIONS(8222),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_LT_LT_DASH] = ACTIONS(8222),
    [anon_sym_LT_LT_LT] = ACTIONS(8222),
    [anon_sym_BQUOTE] = ACTIONS(8222),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8224),
  },
  [3072] = {
    [sym_do_group] = STATE(3488),
    [sym_compound_statement] = STATE(3488),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3073] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7043),
    [anon_sym_EQ_EQ] = ACTIONS(7043),
    [anon_sym_EQ] = ACTIONS(7045),
    [anon_sym_PLUS_EQ] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_BANG_EQ] = ACTIONS(7043),
    [anon_sym_PLUS] = ACTIONS(7045),
    [anon_sym_DASH] = ACTIONS(7045),
    [anon_sym_DASH_EQ] = ACTIONS(7043),
    [anon_sym_LT_EQ] = ACTIONS(7043),
    [anon_sym_GT_EQ] = ACTIONS(7043),
    [anon_sym_PLUS_PLUS] = ACTIONS(7043),
    [anon_sym_DASH_DASH] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7043),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3074] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7047),
    [anon_sym_EQ_EQ] = ACTIONS(7047),
    [anon_sym_EQ] = ACTIONS(7049),
    [anon_sym_PLUS_EQ] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_BANG_EQ] = ACTIONS(7047),
    [anon_sym_PLUS] = ACTIONS(7049),
    [anon_sym_DASH] = ACTIONS(7049),
    [anon_sym_DASH_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_GT_EQ] = ACTIONS(7047),
    [anon_sym_PLUS_PLUS] = ACTIONS(7047),
    [anon_sym_DASH_DASH] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7047),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3075] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7051),
    [anon_sym_EQ_EQ] = ACTIONS(7051),
    [anon_sym_EQ] = ACTIONS(7053),
    [anon_sym_PLUS_EQ] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_BANG_EQ] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_EQ] = ACTIONS(7051),
    [anon_sym_LT_EQ] = ACTIONS(7051),
    [anon_sym_GT_EQ] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7051),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3076] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8226),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3077] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8228),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3078] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7087),
    [anon_sym_EQ_EQ] = ACTIONS(7087),
    [anon_sym_EQ] = ACTIONS(7089),
    [anon_sym_PLUS_EQ] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_BANG_EQ] = ACTIONS(7087),
    [anon_sym_PLUS] = ACTIONS(7089),
    [anon_sym_DASH] = ACTIONS(7089),
    [anon_sym_DASH_EQ] = ACTIONS(7087),
    [anon_sym_LT_EQ] = ACTIONS(7087),
    [anon_sym_GT_EQ] = ACTIONS(7087),
    [anon_sym_PLUS_PLUS] = ACTIONS(7087),
    [anon_sym_DASH_DASH] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7087),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3079] = {
    [sym_do_group] = STATE(3488),
    [sym_compound_statement] = STATE(3488),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3080] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5543),
  },
  [3081] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5551),
  },
  [3082] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8232),
    [sym_comment] = ACTIONS(57),
  },
  [3083] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8234),
    [sym_comment] = ACTIONS(57),
  },
  [3084] = {
    [anon_sym_RBRACE] = ACTIONS(8234),
    [sym_comment] = ACTIONS(57),
  },
  [3085] = {
    [sym_concatenation] = STATE(3495),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3495),
    [anon_sym_RBRACE] = ACTIONS(8236),
    [anon_sym_EQ] = ACTIONS(8238),
    [anon_sym_DASH] = ACTIONS(8238),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8240),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8238),
    [anon_sym_COLON_QMARK] = ACTIONS(8238),
    [anon_sym_COLON_DASH] = ACTIONS(8238),
    [anon_sym_PERCENT] = ACTIONS(8238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3086] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5595),
  },
  [3087] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8236),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3088] = {
    [sym_concatenation] = STATE(3496),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3496),
    [anon_sym_RBRACE] = ACTIONS(8234),
    [anon_sym_EQ] = ACTIONS(8242),
    [anon_sym_DASH] = ACTIONS(8242),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8242),
    [anon_sym_COLON_QMARK] = ACTIONS(8242),
    [anon_sym_COLON_DASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3089] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8234),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3090] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5640),
  },
  [3091] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3092] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7043),
    [anon_sym_EQ_EQ] = ACTIONS(7043),
    [anon_sym_EQ] = ACTIONS(7045),
    [anon_sym_PLUS_EQ] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_BANG_EQ] = ACTIONS(7043),
    [anon_sym_PLUS] = ACTIONS(7045),
    [anon_sym_DASH] = ACTIONS(7045),
    [anon_sym_DASH_EQ] = ACTIONS(7043),
    [anon_sym_LT_EQ] = ACTIONS(7043),
    [anon_sym_GT_EQ] = ACTIONS(7043),
    [anon_sym_PLUS_PLUS] = ACTIONS(7043),
    [anon_sym_DASH_DASH] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7043),
  },
  [3093] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_RPAREN] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7047),
    [anon_sym_EQ_EQ] = ACTIONS(7047),
    [anon_sym_EQ] = ACTIONS(7049),
    [anon_sym_PLUS_EQ] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_BANG_EQ] = ACTIONS(7047),
    [anon_sym_PLUS] = ACTIONS(7049),
    [anon_sym_DASH] = ACTIONS(7049),
    [anon_sym_DASH_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_GT_EQ] = ACTIONS(7047),
    [anon_sym_PLUS_PLUS] = ACTIONS(7047),
    [anon_sym_DASH_DASH] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7047),
  },
  [3094] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_RPAREN] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7051),
    [anon_sym_EQ_EQ] = ACTIONS(7051),
    [anon_sym_EQ] = ACTIONS(7053),
    [anon_sym_PLUS_EQ] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_BANG_EQ] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_EQ] = ACTIONS(7051),
    [anon_sym_LT_EQ] = ACTIONS(7051),
    [anon_sym_GT_EQ] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7051),
  },
  [3095] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8248),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3096] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3097] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_RPAREN] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7087),
    [anon_sym_EQ_EQ] = ACTIONS(7087),
    [anon_sym_EQ] = ACTIONS(7089),
    [anon_sym_PLUS_EQ] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_BANG_EQ] = ACTIONS(7087),
    [anon_sym_PLUS] = ACTIONS(7089),
    [anon_sym_DASH] = ACTIONS(7089),
    [anon_sym_DASH_EQ] = ACTIONS(7087),
    [anon_sym_LT_EQ] = ACTIONS(7087),
    [anon_sym_GT_EQ] = ACTIONS(7087),
    [anon_sym_PLUS_PLUS] = ACTIONS(7087),
    [anon_sym_DASH_DASH] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7087),
  },
  [3098] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8162),
    [anon_sym_EQ] = ACTIONS(8164),
    [anon_sym_PLUS_EQ] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8162),
    [anon_sym_PLUS] = ACTIONS(8164),
    [anon_sym_DASH] = ACTIONS(8164),
    [anon_sym_DASH_EQ] = ACTIONS(8162),
    [anon_sym_LT_EQ] = ACTIONS(8162),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_PLUS_PLUS] = ACTIONS(8162),
    [anon_sym_DASH_DASH] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8162),
  },
  [3099] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_EQ_EQ] = ACTIONS(8166),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_PLUS_EQ] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_PLUS] = ACTIONS(8168),
    [anon_sym_DASH] = ACTIONS(8168),
    [anon_sym_DASH_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8166),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_PLUS_PLUS] = ACTIONS(8166),
    [anon_sym_DASH_DASH] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8166),
  },
  [3100] = {
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3101] = {
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3102] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8252),
    [sym_comment] = ACTIONS(57),
  },
  [3103] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [sym_comment] = ACTIONS(57),
  },
  [3104] = {
    [anon_sym_RBRACE] = ACTIONS(8254),
    [sym_comment] = ACTIONS(57),
  },
  [3105] = {
    [sym_concatenation] = STATE(3503),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3503),
    [anon_sym_RBRACE] = ACTIONS(8256),
    [anon_sym_EQ] = ACTIONS(8258),
    [anon_sym_DASH] = ACTIONS(8258),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8258),
    [anon_sym_COLON_QMARK] = ACTIONS(8258),
    [anon_sym_COLON_DASH] = ACTIONS(8258),
    [anon_sym_PERCENT] = ACTIONS(8258),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3106] = {
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3107] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8256),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3108] = {
    [sym_concatenation] = STATE(3504),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3504),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8262),
    [anon_sym_DASH] = ACTIONS(8262),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8262),
    [anon_sym_COLON_QMARK] = ACTIONS(8262),
    [anon_sym_COLON_DASH] = ACTIONS(8262),
    [anon_sym_PERCENT] = ACTIONS(8262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3109] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3110] = {
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3111] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3112] = {
    [sym_file_descriptor] = ACTIONS(7163),
    [anon_sym_SEMI] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7165),
    [anon_sym_SEMI_SEMI] = ACTIONS(7163),
    [anon_sym_PIPE_AMP] = ACTIONS(7163),
    [anon_sym_AMP_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7163),
    [anon_sym_LT] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7165),
    [anon_sym_GT_GT] = ACTIONS(7163),
    [anon_sym_AMP_GT] = ACTIONS(7165),
    [anon_sym_AMP_GT_GT] = ACTIONS(7163),
    [anon_sym_LT_AMP] = ACTIONS(7163),
    [anon_sym_GT_AMP] = ACTIONS(7163),
    [anon_sym_LT_LT] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7163),
    [anon_sym_LT_LT_LT] = ACTIONS(7163),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7165),
  },
  [3113] = {
    [sym_do_group] = STATE(3506),
    [sym_compound_statement] = STATE(3506),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3114] = {
    [sym_do_group] = STATE(3506),
    [sym_compound_statement] = STATE(3506),
    [anon_sym_SEMI] = ACTIONS(8268),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3115] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8270),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [3116] = {
    [sym_file_descriptor] = ACTIONS(7889),
    [anon_sym_SEMI] = ACTIONS(7891),
    [anon_sym_PIPE] = ACTIONS(7891),
    [anon_sym_SEMI_SEMI] = ACTIONS(7889),
    [anon_sym_PIPE_AMP] = ACTIONS(7889),
    [anon_sym_AMP_AMP] = ACTIONS(7889),
    [anon_sym_PIPE_PIPE] = ACTIONS(7889),
    [anon_sym_LT] = ACTIONS(7891),
    [anon_sym_GT] = ACTIONS(7891),
    [anon_sym_GT_GT] = ACTIONS(7889),
    [anon_sym_AMP_GT] = ACTIONS(7891),
    [anon_sym_AMP_GT_GT] = ACTIONS(7889),
    [anon_sym_LT_AMP] = ACTIONS(7889),
    [anon_sym_GT_AMP] = ACTIONS(7889),
    [anon_sym_LT_LT] = ACTIONS(7891),
    [anon_sym_LT_LT_DASH] = ACTIONS(7889),
    [anon_sym_LT_LT_LT] = ACTIONS(7889),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7889),
    [anon_sym_AMP] = ACTIONS(7891),
  },
  [3117] = {
    [sym_file_descriptor] = ACTIONS(8016),
    [anon_sym_SEMI] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8018),
    [anon_sym_SEMI_SEMI] = ACTIONS(8016),
    [anon_sym_PIPE_AMP] = ACTIONS(8016),
    [anon_sym_AMP_AMP] = ACTIONS(8016),
    [anon_sym_PIPE_PIPE] = ACTIONS(8016),
    [anon_sym_LT] = ACTIONS(8018),
    [anon_sym_GT] = ACTIONS(8018),
    [anon_sym_GT_GT] = ACTIONS(8016),
    [anon_sym_AMP_GT] = ACTIONS(8018),
    [anon_sym_AMP_GT_GT] = ACTIONS(8016),
    [anon_sym_LT_AMP] = ACTIONS(8016),
    [anon_sym_GT_AMP] = ACTIONS(8016),
    [anon_sym_LT_LT] = ACTIONS(8018),
    [anon_sym_LT_LT_DASH] = ACTIONS(8016),
    [anon_sym_LT_LT_LT] = ACTIONS(8016),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8016),
    [anon_sym_AMP] = ACTIONS(8018),
  },
  [3118] = {
    [anon_sym_esac] = ACTIONS(8272),
    [sym_comment] = ACTIONS(57),
  },
  [3119] = {
    [sym_file_descriptor] = ACTIONS(8026),
    [anon_sym_SEMI] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8028),
    [anon_sym_SEMI_SEMI] = ACTIONS(8026),
    [anon_sym_PIPE_AMP] = ACTIONS(8026),
    [anon_sym_AMP_AMP] = ACTIONS(8026),
    [anon_sym_PIPE_PIPE] = ACTIONS(8026),
    [anon_sym_LT] = ACTIONS(8028),
    [anon_sym_GT] = ACTIONS(8028),
    [anon_sym_GT_GT] = ACTIONS(8026),
    [anon_sym_AMP_GT] = ACTIONS(8028),
    [anon_sym_AMP_GT_GT] = ACTIONS(8026),
    [anon_sym_LT_AMP] = ACTIONS(8026),
    [anon_sym_GT_AMP] = ACTIONS(8026),
    [anon_sym_LT_LT] = ACTIONS(8028),
    [anon_sym_LT_LT_DASH] = ACTIONS(8026),
    [anon_sym_LT_LT_LT] = ACTIONS(8026),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8026),
    [anon_sym_AMP] = ACTIONS(8028),
  },
  [3120] = {
    [anon_sym_esac] = ACTIONS(8274),
    [sym_comment] = ACTIONS(57),
  },
  [3121] = {
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3122] = {
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3123] = {
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3124] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8276),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3125] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3126] = {
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3127] = {
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3128] = {
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3129] = {
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3130] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8280),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3131] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3132] = {
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3133] = {
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8164),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3134] = {
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3135] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_done] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [3136] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3137] = {
    [aux_sym_concatenation_repeat1] = STATE(3137),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(8284),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3138] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_done] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3139] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(8287),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3140] = {
    [sym_concatenation] = STATE(3519),
    [sym_string] = STATE(3518),
    [sym_simple_expansion] = STATE(3518),
    [sym_string_expansion] = STATE(3518),
    [sym_expansion] = STATE(3518),
    [sym_command_substitution] = STATE(3518),
    [sym_process_substitution] = STATE(3518),
    [anon_sym_RBRACE] = ACTIONS(8289),
    [sym__special_characters] = ACTIONS(8291),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8293),
  },
  [3141] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(8295),
    [sym_comment] = ACTIONS(57),
  },
  [3142] = {
    [sym_concatenation] = STATE(3523),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3523),
    [anon_sym_RBRACE] = ACTIONS(8297),
    [anon_sym_EQ] = ACTIONS(8299),
    [anon_sym_DASH] = ACTIONS(8299),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8303),
    [anon_sym_COLON] = ACTIONS(8299),
    [anon_sym_COLON_QMARK] = ACTIONS(8299),
    [anon_sym_COLON_DASH] = ACTIONS(8299),
    [anon_sym_PERCENT] = ACTIONS(8299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3143] = {
    [sym_concatenation] = STATE(3525),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3525),
    [anon_sym_RBRACE] = ACTIONS(8289),
    [anon_sym_EQ] = ACTIONS(8305),
    [anon_sym_DASH] = ACTIONS(8305),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8309),
    [anon_sym_COLON] = ACTIONS(8305),
    [anon_sym_COLON_QMARK] = ACTIONS(8305),
    [anon_sym_COLON_DASH] = ACTIONS(8305),
    [anon_sym_PERCENT] = ACTIONS(8305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3144] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_done] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3145] = {
    [sym_concatenation] = STATE(3528),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3528),
    [sym_regex] = ACTIONS(8311),
    [anon_sym_RBRACE] = ACTIONS(8313),
    [anon_sym_EQ] = ACTIONS(8315),
    [anon_sym_DASH] = ACTIONS(8315),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8315),
    [anon_sym_COLON_QMARK] = ACTIONS(8315),
    [anon_sym_COLON_DASH] = ACTIONS(8315),
    [anon_sym_PERCENT] = ACTIONS(8315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3146] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8313),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3147] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_done] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3148] = {
    [sym_concatenation] = STATE(3525),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3525),
    [sym_regex] = ACTIONS(8319),
    [anon_sym_RBRACE] = ACTIONS(8289),
    [anon_sym_EQ] = ACTIONS(8305),
    [anon_sym_DASH] = ACTIONS(8305),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8305),
    [anon_sym_COLON_QMARK] = ACTIONS(8305),
    [anon_sym_COLON_DASH] = ACTIONS(8305),
    [anon_sym_PERCENT] = ACTIONS(8305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3149] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8289),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3150] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_done] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3151] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_done] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3152] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_done] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2666),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [3153] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(8321),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [3154] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_done] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3155] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_done] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3156] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8323),
    [sym_comment] = ACTIONS(57),
  },
  [3157] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8325),
    [sym_comment] = ACTIONS(57),
  },
  [3158] = {
    [anon_sym_RBRACE] = ACTIONS(8325),
    [sym_comment] = ACTIONS(57),
  },
  [3159] = {
    [sym_concatenation] = STATE(3535),
    [sym_string] = STATE(3534),
    [sym_simple_expansion] = STATE(3534),
    [sym_string_expansion] = STATE(3534),
    [sym_expansion] = STATE(3534),
    [sym_command_substitution] = STATE(3534),
    [sym_process_substitution] = STATE(3534),
    [anon_sym_RBRACE] = ACTIONS(8325),
    [sym__special_characters] = ACTIONS(8327),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8329),
  },
  [3160] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_done] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3161] = {
    [sym_concatenation] = STATE(3538),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3538),
    [sym_regex] = ACTIONS(8331),
    [anon_sym_RBRACE] = ACTIONS(8333),
    [anon_sym_EQ] = ACTIONS(8335),
    [anon_sym_DASH] = ACTIONS(8335),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8335),
    [anon_sym_COLON_QMARK] = ACTIONS(8335),
    [anon_sym_COLON_DASH] = ACTIONS(8335),
    [anon_sym_PERCENT] = ACTIONS(8335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3162] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8333),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3163] = {
    [sym_concatenation] = STATE(3540),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3540),
    [sym_regex] = ACTIONS(8339),
    [anon_sym_RBRACE] = ACTIONS(8325),
    [anon_sym_EQ] = ACTIONS(8341),
    [anon_sym_DASH] = ACTIONS(8341),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8341),
    [anon_sym_COLON_QMARK] = ACTIONS(8341),
    [anon_sym_COLON_DASH] = ACTIONS(8341),
    [anon_sym_PERCENT] = ACTIONS(8341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3164] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8325),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3165] = {
    [sym_concatenation] = STATE(3542),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3542),
    [anon_sym_RBRACE] = ACTIONS(8345),
    [anon_sym_EQ] = ACTIONS(8347),
    [anon_sym_DASH] = ACTIONS(8347),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8347),
    [anon_sym_COLON_QMARK] = ACTIONS(8347),
    [anon_sym_COLON_DASH] = ACTIONS(8347),
    [anon_sym_PERCENT] = ACTIONS(8347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3166] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3167] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8345),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3168] = {
    [sym_concatenation] = STATE(3540),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3540),
    [anon_sym_RBRACE] = ACTIONS(8325),
    [anon_sym_EQ] = ACTIONS(8341),
    [anon_sym_DASH] = ACTIONS(8341),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8341),
    [anon_sym_COLON_QMARK] = ACTIONS(8341),
    [anon_sym_COLON_DASH] = ACTIONS(8341),
    [anon_sym_PERCENT] = ACTIONS(8341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3169] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_done] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3170] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_done] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3171] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8351),
    [sym_comment] = ACTIONS(57),
  },
  [3172] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(57),
  },
  [3173] = {
    [anon_sym_RBRACE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(57),
  },
  [3174] = {
    [sym_concatenation] = STATE(3547),
    [sym_string] = STATE(3546),
    [sym_simple_expansion] = STATE(3546),
    [sym_string_expansion] = STATE(3546),
    [sym_expansion] = STATE(3546),
    [sym_command_substitution] = STATE(3546),
    [sym_process_substitution] = STATE(3546),
    [anon_sym_RBRACE] = ACTIONS(8353),
    [sym__special_characters] = ACTIONS(8355),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8357),
  },
  [3175] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_done] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3176] = {
    [sym_concatenation] = STATE(3550),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3550),
    [sym_regex] = ACTIONS(8359),
    [anon_sym_RBRACE] = ACTIONS(8361),
    [anon_sym_EQ] = ACTIONS(8363),
    [anon_sym_DASH] = ACTIONS(8363),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8363),
    [anon_sym_COLON_QMARK] = ACTIONS(8363),
    [anon_sym_COLON_DASH] = ACTIONS(8363),
    [anon_sym_PERCENT] = ACTIONS(8363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3177] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8361),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3178] = {
    [sym_concatenation] = STATE(3552),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3552),
    [sym_regex] = ACTIONS(8367),
    [anon_sym_RBRACE] = ACTIONS(8353),
    [anon_sym_EQ] = ACTIONS(8369),
    [anon_sym_DASH] = ACTIONS(8369),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8369),
    [anon_sym_COLON_QMARK] = ACTIONS(8369),
    [anon_sym_COLON_DASH] = ACTIONS(8369),
    [anon_sym_PERCENT] = ACTIONS(8369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3179] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8353),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3180] = {
    [sym_concatenation] = STATE(3554),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3554),
    [anon_sym_RBRACE] = ACTIONS(8373),
    [anon_sym_EQ] = ACTIONS(8375),
    [anon_sym_DASH] = ACTIONS(8375),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8375),
    [anon_sym_COLON_QMARK] = ACTIONS(8375),
    [anon_sym_COLON_DASH] = ACTIONS(8375),
    [anon_sym_PERCENT] = ACTIONS(8375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3181] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3182] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8373),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3183] = {
    [sym_concatenation] = STATE(3552),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3552),
    [anon_sym_RBRACE] = ACTIONS(8353),
    [anon_sym_EQ] = ACTIONS(8369),
    [anon_sym_DASH] = ACTIONS(8369),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8369),
    [anon_sym_COLON_QMARK] = ACTIONS(8369),
    [anon_sym_COLON_DASH] = ACTIONS(8369),
    [anon_sym_PERCENT] = ACTIONS(8369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3184] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_done] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3185] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_done] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3186] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8379),
    [sym_comment] = ACTIONS(57),
  },
  [3187] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8381),
    [sym_comment] = ACTIONS(57),
  },
  [3188] = {
    [anon_sym_RBRACE] = ACTIONS(8381),
    [sym_comment] = ACTIONS(57),
  },
  [3189] = {
    [sym_concatenation] = STATE(3558),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3558),
    [anon_sym_RBRACE] = ACTIONS(8383),
    [anon_sym_EQ] = ACTIONS(8385),
    [anon_sym_DASH] = ACTIONS(8385),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8385),
    [anon_sym_COLON_QMARK] = ACTIONS(8385),
    [anon_sym_COLON_DASH] = ACTIONS(8385),
    [anon_sym_PERCENT] = ACTIONS(8385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3190] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_done] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5597),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3191] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8383),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3192] = {
    [sym_concatenation] = STATE(3559),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3559),
    [anon_sym_RBRACE] = ACTIONS(8381),
    [anon_sym_EQ] = ACTIONS(8389),
    [anon_sym_DASH] = ACTIONS(8389),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8389),
    [anon_sym_COLON_QMARK] = ACTIONS(8389),
    [anon_sym_COLON_DASH] = ACTIONS(8389),
    [anon_sym_PERCENT] = ACTIONS(8389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3193] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8381),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3194] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_done] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3195] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8393),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3196] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2306),
    [anon_sym_fi] = ACTIONS(2306),
    [anon_sym_elif] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2306),
    [anon_sym_esac] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3197] = {
    [aux_sym_concatenation_repeat1] = STATE(3197),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(8395),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_done] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3198] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_done] = ACTIONS(2313),
    [anon_sym_fi] = ACTIONS(2313),
    [anon_sym_elif] = ACTIONS(2313),
    [anon_sym_else] = ACTIONS(2313),
    [anon_sym_esac] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3199] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(8398),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3200] = {
    [sym_concatenation] = STATE(3565),
    [sym_string] = STATE(3564),
    [sym_simple_expansion] = STATE(3564),
    [sym_string_expansion] = STATE(3564),
    [sym_expansion] = STATE(3564),
    [sym_command_substitution] = STATE(3564),
    [sym_process_substitution] = STATE(3564),
    [anon_sym_RBRACE] = ACTIONS(8400),
    [sym__special_characters] = ACTIONS(8402),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8404),
  },
  [3201] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(8406),
    [sym_comment] = ACTIONS(57),
  },
  [3202] = {
    [sym_concatenation] = STATE(3569),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3569),
    [anon_sym_RBRACE] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_DASH] = ACTIONS(8410),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8414),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_COLON_QMARK] = ACTIONS(8410),
    [anon_sym_COLON_DASH] = ACTIONS(8410),
    [anon_sym_PERCENT] = ACTIONS(8410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3203] = {
    [sym_concatenation] = STATE(3571),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3571),
    [anon_sym_RBRACE] = ACTIONS(8400),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_DASH] = ACTIONS(8416),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8420),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_COLON_QMARK] = ACTIONS(8416),
    [anon_sym_COLON_DASH] = ACTIONS(8416),
    [anon_sym_PERCENT] = ACTIONS(8416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3204] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_done] = ACTIONS(2406),
    [anon_sym_fi] = ACTIONS(2406),
    [anon_sym_elif] = ACTIONS(2406),
    [anon_sym_else] = ACTIONS(2406),
    [anon_sym_esac] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3205] = {
    [sym_concatenation] = STATE(3574),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3574),
    [sym_regex] = ACTIONS(8422),
    [anon_sym_RBRACE] = ACTIONS(8424),
    [anon_sym_EQ] = ACTIONS(8426),
    [anon_sym_DASH] = ACTIONS(8426),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8428),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8426),
    [anon_sym_COLON_QMARK] = ACTIONS(8426),
    [anon_sym_COLON_DASH] = ACTIONS(8426),
    [anon_sym_PERCENT] = ACTIONS(8426),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3206] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8424),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3207] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_done] = ACTIONS(2454),
    [anon_sym_fi] = ACTIONS(2454),
    [anon_sym_elif] = ACTIONS(2454),
    [anon_sym_else] = ACTIONS(2454),
    [anon_sym_esac] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3208] = {
    [sym_concatenation] = STATE(3571),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3571),
    [sym_regex] = ACTIONS(8430),
    [anon_sym_RBRACE] = ACTIONS(8400),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_DASH] = ACTIONS(8416),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_COLON_QMARK] = ACTIONS(8416),
    [anon_sym_COLON_DASH] = ACTIONS(8416),
    [anon_sym_PERCENT] = ACTIONS(8416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3209] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8400),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3210] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_done] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_elif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_esac] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3211] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_done] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_elif] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_esac] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3212] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_fi] = ACTIONS(4354),
    [anon_sym_elif] = ACTIONS(4354),
    [anon_sym_else] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [3213] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_elif] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3214] = {
    [aux_sym_concatenation_repeat1] = STATE(3214),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(8432),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_elif] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3215] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_fi] = ACTIONS(2315),
    [anon_sym_elif] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3216] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(8435),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3217] = {
    [sym_concatenation] = STATE(3580),
    [sym_string] = STATE(3579),
    [sym_simple_expansion] = STATE(3579),
    [sym_string_expansion] = STATE(3579),
    [sym_expansion] = STATE(3579),
    [sym_command_substitution] = STATE(3579),
    [sym_process_substitution] = STATE(3579),
    [anon_sym_RBRACE] = ACTIONS(8437),
    [sym__special_characters] = ACTIONS(8439),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8441),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8441),
  },
  [3218] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(8443),
    [sym_comment] = ACTIONS(57),
  },
  [3219] = {
    [sym_concatenation] = STATE(3584),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3584),
    [anon_sym_RBRACE] = ACTIONS(8445),
    [anon_sym_EQ] = ACTIONS(8447),
    [anon_sym_DASH] = ACTIONS(8447),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8451),
    [anon_sym_COLON] = ACTIONS(8447),
    [anon_sym_COLON_QMARK] = ACTIONS(8447),
    [anon_sym_COLON_DASH] = ACTIONS(8447),
    [anon_sym_PERCENT] = ACTIONS(8447),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3220] = {
    [sym_concatenation] = STATE(3586),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3586),
    [anon_sym_RBRACE] = ACTIONS(8437),
    [anon_sym_EQ] = ACTIONS(8453),
    [anon_sym_DASH] = ACTIONS(8453),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_COLON] = ACTIONS(8453),
    [anon_sym_COLON_QMARK] = ACTIONS(8453),
    [anon_sym_COLON_DASH] = ACTIONS(8453),
    [anon_sym_PERCENT] = ACTIONS(8453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3221] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_fi] = ACTIONS(2408),
    [anon_sym_elif] = ACTIONS(2408),
    [anon_sym_else] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3222] = {
    [sym_concatenation] = STATE(3589),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3589),
    [sym_regex] = ACTIONS(8459),
    [anon_sym_RBRACE] = ACTIONS(8461),
    [anon_sym_EQ] = ACTIONS(8463),
    [anon_sym_DASH] = ACTIONS(8463),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8463),
    [anon_sym_COLON_QMARK] = ACTIONS(8463),
    [anon_sym_COLON_DASH] = ACTIONS(8463),
    [anon_sym_PERCENT] = ACTIONS(8463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3223] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8461),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3224] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_fi] = ACTIONS(2456),
    [anon_sym_elif] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3225] = {
    [sym_concatenation] = STATE(3586),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3586),
    [sym_regex] = ACTIONS(8467),
    [anon_sym_RBRACE] = ACTIONS(8437),
    [anon_sym_EQ] = ACTIONS(8453),
    [anon_sym_DASH] = ACTIONS(8453),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8453),
    [anon_sym_COLON_QMARK] = ACTIONS(8453),
    [anon_sym_COLON_DASH] = ACTIONS(8453),
    [anon_sym_PERCENT] = ACTIONS(8453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3226] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8437),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3227] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_fi] = ACTIONS(2466),
    [anon_sym_elif] = ACTIONS(2466),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3228] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_fi] = ACTIONS(2504),
    [anon_sym_elif] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3229] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_fi] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [3230] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(8469),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [3231] = {
    [sym_string] = STATE(3592),
    [sym_simple_expansion] = STATE(3592),
    [sym_string_expansion] = STATE(3592),
    [sym_expansion] = STATE(3592),
    [sym_command_substitution] = STATE(3592),
    [sym_process_substitution] = STATE(3592),
    [sym__special_characters] = ACTIONS(8471),
    [anon_sym_DQUOTE] = ACTIONS(6329),
    [anon_sym_DOLLAR] = ACTIONS(6331),
    [sym_raw_string] = ACTIONS(8471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6337),
    [anon_sym_BQUOTE] = ACTIONS(6339),
    [anon_sym_LT_LPAREN] = ACTIONS(6341),
    [anon_sym_GT_LPAREN] = ACTIONS(6341),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8471),
  },
  [3232] = {
    [aux_sym_concatenation_repeat1] = STATE(3593),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(7531),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [3233] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_fi] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [3234] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(8473),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3235] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(8473),
    [anon_sym_DOLLAR] = ACTIONS(8475),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3236] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [3237] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [3238] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [3239] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(8477),
    [sym_comment] = ACTIONS(57),
  },
  [3240] = {
    [sym_subscript] = STATE(3599),
    [sym_variable_name] = ACTIONS(8479),
    [anon_sym_DASH] = ACTIONS(8481),
    [anon_sym_DOLLAR] = ACTIONS(8481),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8483),
    [anon_sym_STAR] = ACTIONS(8485),
    [anon_sym_AT] = ACTIONS(8485),
    [anon_sym_QMARK] = ACTIONS(8485),
    [anon_sym_0] = ACTIONS(8483),
    [anon_sym__] = ACTIONS(8483),
  },
  [3241] = {
    [sym_concatenation] = STATE(3602),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3602),
    [anon_sym_RBRACE] = ACTIONS(8487),
    [anon_sym_EQ] = ACTIONS(8489),
    [anon_sym_DASH] = ACTIONS(8489),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8493),
    [anon_sym_COLON] = ACTIONS(8489),
    [anon_sym_COLON_QMARK] = ACTIONS(8489),
    [anon_sym_COLON_DASH] = ACTIONS(8489),
    [anon_sym_PERCENT] = ACTIONS(8489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3242] = {
    [sym_concatenation] = STATE(3605),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3605),
    [anon_sym_RBRACE] = ACTIONS(8495),
    [anon_sym_EQ] = ACTIONS(8497),
    [anon_sym_DASH] = ACTIONS(8497),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8501),
    [anon_sym_COLON] = ACTIONS(8497),
    [anon_sym_COLON_QMARK] = ACTIONS(8497),
    [anon_sym_COLON_DASH] = ACTIONS(8497),
    [anon_sym_PERCENT] = ACTIONS(8497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3243] = {
    [anon_sym_RPAREN] = ACTIONS(8503),
    [sym_comment] = ACTIONS(57),
  },
  [3244] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(8503),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3245] = {
    [anon_sym_BQUOTE] = ACTIONS(8503),
    [sym_comment] = ACTIONS(57),
  },
  [3246] = {
    [anon_sym_RPAREN] = ACTIONS(8505),
    [sym_comment] = ACTIONS(57),
  },
  [3247] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_fi] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [3248] = {
    [sym_concatenation] = STATE(3609),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(3609),
    [anon_sym_RPAREN] = ACTIONS(8507),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [3249] = {
    [aux_sym_concatenation_repeat1] = STATE(2752),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(6345),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_fi] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [3250] = {
    [aux_sym_concatenation_repeat1] = STATE(2752),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(6345),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_fi] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [3251] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3252] = {
    [aux_sym_concatenation_repeat1] = STATE(3252),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(8509),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3253] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_fi] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3254] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(8512),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3255] = {
    [sym_concatenation] = STATE(3614),
    [sym_string] = STATE(3613),
    [sym_simple_expansion] = STATE(3613),
    [sym_string_expansion] = STATE(3613),
    [sym_expansion] = STATE(3613),
    [sym_command_substitution] = STATE(3613),
    [sym_process_substitution] = STATE(3613),
    [anon_sym_RBRACE] = ACTIONS(8514),
    [sym__special_characters] = ACTIONS(8516),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8518),
  },
  [3256] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(8520),
    [sym_comment] = ACTIONS(57),
  },
  [3257] = {
    [sym_concatenation] = STATE(3618),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3618),
    [anon_sym_RBRACE] = ACTIONS(8522),
    [anon_sym_EQ] = ACTIONS(8524),
    [anon_sym_DASH] = ACTIONS(8524),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8528),
    [anon_sym_COLON] = ACTIONS(8524),
    [anon_sym_COLON_QMARK] = ACTIONS(8524),
    [anon_sym_COLON_DASH] = ACTIONS(8524),
    [anon_sym_PERCENT] = ACTIONS(8524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3258] = {
    [sym_concatenation] = STATE(3620),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3620),
    [anon_sym_RBRACE] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(8530),
    [anon_sym_DASH] = ACTIONS(8530),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8534),
    [anon_sym_COLON] = ACTIONS(8530),
    [anon_sym_COLON_QMARK] = ACTIONS(8530),
    [anon_sym_COLON_DASH] = ACTIONS(8530),
    [anon_sym_PERCENT] = ACTIONS(8530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3259] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_fi] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3260] = {
    [sym_concatenation] = STATE(3623),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3623),
    [sym_regex] = ACTIONS(8536),
    [anon_sym_RBRACE] = ACTIONS(8538),
    [anon_sym_EQ] = ACTIONS(8540),
    [anon_sym_DASH] = ACTIONS(8540),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8540),
    [anon_sym_COLON_QMARK] = ACTIONS(8540),
    [anon_sym_COLON_DASH] = ACTIONS(8540),
    [anon_sym_PERCENT] = ACTIONS(8540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3261] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8538),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3262] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_fi] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3263] = {
    [sym_concatenation] = STATE(3620),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3620),
    [sym_regex] = ACTIONS(8544),
    [anon_sym_RBRACE] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(8530),
    [anon_sym_DASH] = ACTIONS(8530),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8530),
    [anon_sym_COLON_QMARK] = ACTIONS(8530),
    [anon_sym_COLON_DASH] = ACTIONS(8530),
    [anon_sym_PERCENT] = ACTIONS(8530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3264] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3265] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_fi] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3266] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_fi] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3267] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3268] = {
    [aux_sym_concatenation_repeat1] = STATE(3268),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(8546),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3269] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_fi] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3270] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(8549),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3271] = {
    [sym_concatenation] = STATE(3629),
    [sym_string] = STATE(3628),
    [sym_simple_expansion] = STATE(3628),
    [sym_string_expansion] = STATE(3628),
    [sym_expansion] = STATE(3628),
    [sym_command_substitution] = STATE(3628),
    [sym_process_substitution] = STATE(3628),
    [anon_sym_RBRACE] = ACTIONS(8551),
    [sym__special_characters] = ACTIONS(8553),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8555),
  },
  [3272] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(8557),
    [sym_comment] = ACTIONS(57),
  },
  [3273] = {
    [sym_concatenation] = STATE(3633),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3633),
    [anon_sym_RBRACE] = ACTIONS(8559),
    [anon_sym_EQ] = ACTIONS(8561),
    [anon_sym_DASH] = ACTIONS(8561),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8563),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8565),
    [anon_sym_COLON] = ACTIONS(8561),
    [anon_sym_COLON_QMARK] = ACTIONS(8561),
    [anon_sym_COLON_DASH] = ACTIONS(8561),
    [anon_sym_PERCENT] = ACTIONS(8561),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3274] = {
    [sym_concatenation] = STATE(3635),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3635),
    [anon_sym_RBRACE] = ACTIONS(8551),
    [anon_sym_EQ] = ACTIONS(8567),
    [anon_sym_DASH] = ACTIONS(8567),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8571),
    [anon_sym_COLON] = ACTIONS(8567),
    [anon_sym_COLON_QMARK] = ACTIONS(8567),
    [anon_sym_COLON_DASH] = ACTIONS(8567),
    [anon_sym_PERCENT] = ACTIONS(8567),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3275] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_fi] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3276] = {
    [sym_concatenation] = STATE(3638),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3638),
    [sym_regex] = ACTIONS(8573),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(8577),
    [anon_sym_DASH] = ACTIONS(8577),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8577),
    [anon_sym_COLON_QMARK] = ACTIONS(8577),
    [anon_sym_COLON_DASH] = ACTIONS(8577),
    [anon_sym_PERCENT] = ACTIONS(8577),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3277] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3278] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_fi] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3279] = {
    [sym_concatenation] = STATE(3635),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3635),
    [sym_regex] = ACTIONS(8581),
    [anon_sym_RBRACE] = ACTIONS(8551),
    [anon_sym_EQ] = ACTIONS(8567),
    [anon_sym_DASH] = ACTIONS(8567),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8567),
    [anon_sym_COLON_QMARK] = ACTIONS(8567),
    [anon_sym_COLON_DASH] = ACTIONS(8567),
    [anon_sym_PERCENT] = ACTIONS(8567),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3280] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8551),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3281] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_fi] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3282] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_fi] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3283] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_fi] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3284] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_fi] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3285] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8583),
    [sym_comment] = ACTIONS(57),
  },
  [3286] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8585),
    [sym_comment] = ACTIONS(57),
  },
  [3287] = {
    [anon_sym_RBRACE] = ACTIONS(8585),
    [sym_comment] = ACTIONS(57),
  },
  [3288] = {
    [sym_concatenation] = STATE(3644),
    [sym_string] = STATE(3643),
    [sym_simple_expansion] = STATE(3643),
    [sym_string_expansion] = STATE(3643),
    [sym_expansion] = STATE(3643),
    [sym_command_substitution] = STATE(3643),
    [sym_process_substitution] = STATE(3643),
    [anon_sym_RBRACE] = ACTIONS(8585),
    [sym__special_characters] = ACTIONS(8587),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8589),
  },
  [3289] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_fi] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3290] = {
    [sym_concatenation] = STATE(3647),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3647),
    [sym_regex] = ACTIONS(8591),
    [anon_sym_RBRACE] = ACTIONS(8593),
    [anon_sym_EQ] = ACTIONS(8595),
    [anon_sym_DASH] = ACTIONS(8595),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8597),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8595),
    [anon_sym_COLON_QMARK] = ACTIONS(8595),
    [anon_sym_COLON_DASH] = ACTIONS(8595),
    [anon_sym_PERCENT] = ACTIONS(8595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3291] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8593),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3292] = {
    [sym_concatenation] = STATE(3649),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3649),
    [sym_regex] = ACTIONS(8599),
    [anon_sym_RBRACE] = ACTIONS(8585),
    [anon_sym_EQ] = ACTIONS(8601),
    [anon_sym_DASH] = ACTIONS(8601),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8603),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8601),
    [anon_sym_COLON_QMARK] = ACTIONS(8601),
    [anon_sym_COLON_DASH] = ACTIONS(8601),
    [anon_sym_PERCENT] = ACTIONS(8601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3293] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8585),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3294] = {
    [sym_concatenation] = STATE(3651),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3651),
    [anon_sym_RBRACE] = ACTIONS(8605),
    [anon_sym_EQ] = ACTIONS(8607),
    [anon_sym_DASH] = ACTIONS(8607),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8607),
    [anon_sym_COLON_QMARK] = ACTIONS(8607),
    [anon_sym_COLON_DASH] = ACTIONS(8607),
    [anon_sym_PERCENT] = ACTIONS(8607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3295] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3296] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8605),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3297] = {
    [sym_concatenation] = STATE(3649),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3649),
    [anon_sym_RBRACE] = ACTIONS(8585),
    [anon_sym_EQ] = ACTIONS(8601),
    [anon_sym_DASH] = ACTIONS(8601),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8603),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8601),
    [anon_sym_COLON_QMARK] = ACTIONS(8601),
    [anon_sym_COLON_DASH] = ACTIONS(8601),
    [anon_sym_PERCENT] = ACTIONS(8601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3298] = {
    [aux_sym_concatenation_repeat1] = STATE(3300),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_fi] = ACTIONS(1367),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [3299] = {
    [aux_sym_concatenation_repeat1] = STATE(3300),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [3300] = {
    [aux_sym_concatenation_repeat1] = STATE(3652),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1049),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [3301] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_fi] = ACTIONS(7487),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [3302] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_fi] = ACTIONS(2666),
    [anon_sym_elif] = ACTIONS(2666),
    [anon_sym_else] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2666),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [3303] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(8611),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [3304] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_fi] = ACTIONS(4021),
    [anon_sym_elif] = ACTIONS(4021),
    [anon_sym_else] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3305] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_fi] = ACTIONS(4035),
    [anon_sym_elif] = ACTIONS(4035),
    [anon_sym_else] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3306] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8613),
    [sym_comment] = ACTIONS(57),
  },
  [3307] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8615),
    [sym_comment] = ACTIONS(57),
  },
  [3308] = {
    [anon_sym_RBRACE] = ACTIONS(8615),
    [sym_comment] = ACTIONS(57),
  },
  [3309] = {
    [sym_concatenation] = STATE(3658),
    [sym_string] = STATE(3657),
    [sym_simple_expansion] = STATE(3657),
    [sym_string_expansion] = STATE(3657),
    [sym_expansion] = STATE(3657),
    [sym_command_substitution] = STATE(3657),
    [sym_process_substitution] = STATE(3657),
    [anon_sym_RBRACE] = ACTIONS(8615),
    [sym__special_characters] = ACTIONS(8617),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8619),
  },
  [3310] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_fi] = ACTIONS(4071),
    [anon_sym_elif] = ACTIONS(4071),
    [anon_sym_else] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3311] = {
    [sym_concatenation] = STATE(3661),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3661),
    [sym_regex] = ACTIONS(8621),
    [anon_sym_RBRACE] = ACTIONS(8623),
    [anon_sym_EQ] = ACTIONS(8625),
    [anon_sym_DASH] = ACTIONS(8625),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8625),
    [anon_sym_COLON_QMARK] = ACTIONS(8625),
    [anon_sym_COLON_DASH] = ACTIONS(8625),
    [anon_sym_PERCENT] = ACTIONS(8625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3312] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8623),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3313] = {
    [sym_concatenation] = STATE(3663),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3663),
    [sym_regex] = ACTIONS(8629),
    [anon_sym_RBRACE] = ACTIONS(8615),
    [anon_sym_EQ] = ACTIONS(8631),
    [anon_sym_DASH] = ACTIONS(8631),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8631),
    [anon_sym_COLON_QMARK] = ACTIONS(8631),
    [anon_sym_COLON_DASH] = ACTIONS(8631),
    [anon_sym_PERCENT] = ACTIONS(8631),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3314] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8615),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3315] = {
    [sym_concatenation] = STATE(3665),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3665),
    [anon_sym_RBRACE] = ACTIONS(8635),
    [anon_sym_EQ] = ACTIONS(8637),
    [anon_sym_DASH] = ACTIONS(8637),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8637),
    [anon_sym_COLON_QMARK] = ACTIONS(8637),
    [anon_sym_COLON_DASH] = ACTIONS(8637),
    [anon_sym_PERCENT] = ACTIONS(8637),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3316] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_elif] = ACTIONS(4127),
    [anon_sym_else] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3317] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8635),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3318] = {
    [sym_concatenation] = STATE(3663),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3663),
    [anon_sym_RBRACE] = ACTIONS(8615),
    [anon_sym_EQ] = ACTIONS(8631),
    [anon_sym_DASH] = ACTIONS(8631),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8631),
    [anon_sym_COLON_QMARK] = ACTIONS(8631),
    [anon_sym_COLON_DASH] = ACTIONS(8631),
    [anon_sym_PERCENT] = ACTIONS(8631),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3319] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_fi] = ACTIONS(4021),
    [anon_sym_elif] = ACTIONS(4021),
    [anon_sym_else] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3320] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_fi] = ACTIONS(4035),
    [anon_sym_elif] = ACTIONS(4035),
    [anon_sym_else] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3321] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8641),
    [sym_comment] = ACTIONS(57),
  },
  [3322] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8643),
    [sym_comment] = ACTIONS(57),
  },
  [3323] = {
    [anon_sym_RBRACE] = ACTIONS(8643),
    [sym_comment] = ACTIONS(57),
  },
  [3324] = {
    [sym_concatenation] = STATE(3670),
    [sym_string] = STATE(3669),
    [sym_simple_expansion] = STATE(3669),
    [sym_string_expansion] = STATE(3669),
    [sym_expansion] = STATE(3669),
    [sym_command_substitution] = STATE(3669),
    [sym_process_substitution] = STATE(3669),
    [anon_sym_RBRACE] = ACTIONS(8643),
    [sym__special_characters] = ACTIONS(8645),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8647),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8647),
  },
  [3325] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_fi] = ACTIONS(4071),
    [anon_sym_elif] = ACTIONS(4071),
    [anon_sym_else] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3326] = {
    [sym_concatenation] = STATE(3673),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3673),
    [sym_regex] = ACTIONS(8649),
    [anon_sym_RBRACE] = ACTIONS(8651),
    [anon_sym_EQ] = ACTIONS(8653),
    [anon_sym_DASH] = ACTIONS(8653),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8653),
    [anon_sym_COLON_QMARK] = ACTIONS(8653),
    [anon_sym_COLON_DASH] = ACTIONS(8653),
    [anon_sym_PERCENT] = ACTIONS(8653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3327] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8651),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3328] = {
    [sym_concatenation] = STATE(3675),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3675),
    [sym_regex] = ACTIONS(8657),
    [anon_sym_RBRACE] = ACTIONS(8643),
    [anon_sym_EQ] = ACTIONS(8659),
    [anon_sym_DASH] = ACTIONS(8659),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8659),
    [anon_sym_COLON_QMARK] = ACTIONS(8659),
    [anon_sym_COLON_DASH] = ACTIONS(8659),
    [anon_sym_PERCENT] = ACTIONS(8659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3329] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8643),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3330] = {
    [sym_concatenation] = STATE(3677),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3677),
    [anon_sym_RBRACE] = ACTIONS(8663),
    [anon_sym_EQ] = ACTIONS(8665),
    [anon_sym_DASH] = ACTIONS(8665),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8665),
    [anon_sym_COLON_QMARK] = ACTIONS(8665),
    [anon_sym_COLON_DASH] = ACTIONS(8665),
    [anon_sym_PERCENT] = ACTIONS(8665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3331] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_elif] = ACTIONS(4127),
    [anon_sym_else] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3332] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8663),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3333] = {
    [sym_concatenation] = STATE(3675),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3675),
    [anon_sym_RBRACE] = ACTIONS(8643),
    [anon_sym_EQ] = ACTIONS(8659),
    [anon_sym_DASH] = ACTIONS(8659),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8659),
    [anon_sym_COLON_QMARK] = ACTIONS(8659),
    [anon_sym_COLON_DASH] = ACTIONS(8659),
    [anon_sym_PERCENT] = ACTIONS(8659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3334] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_fi] = ACTIONS(5545),
    [anon_sym_elif] = ACTIONS(5545),
    [anon_sym_else] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3335] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_fi] = ACTIONS(5553),
    [anon_sym_elif] = ACTIONS(5553),
    [anon_sym_else] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3336] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8669),
    [sym_comment] = ACTIONS(57),
  },
  [3337] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8671),
    [sym_comment] = ACTIONS(57),
  },
  [3338] = {
    [anon_sym_RBRACE] = ACTIONS(8671),
    [sym_comment] = ACTIONS(57),
  },
  [3339] = {
    [sym_concatenation] = STATE(3681),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3681),
    [anon_sym_RBRACE] = ACTIONS(8673),
    [anon_sym_EQ] = ACTIONS(8675),
    [anon_sym_DASH] = ACTIONS(8675),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8675),
    [anon_sym_COLON_QMARK] = ACTIONS(8675),
    [anon_sym_COLON_DASH] = ACTIONS(8675),
    [anon_sym_PERCENT] = ACTIONS(8675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3340] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_fi] = ACTIONS(5597),
    [anon_sym_elif] = ACTIONS(5597),
    [anon_sym_else] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5597),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3341] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8673),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3342] = {
    [sym_concatenation] = STATE(3682),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3682),
    [anon_sym_RBRACE] = ACTIONS(8671),
    [anon_sym_EQ] = ACTIONS(8679),
    [anon_sym_DASH] = ACTIONS(8679),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8679),
    [anon_sym_COLON_QMARK] = ACTIONS(8679),
    [anon_sym_COLON_DASH] = ACTIONS(8679),
    [anon_sym_PERCENT] = ACTIONS(8679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3343] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8671),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3344] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_fi] = ACTIONS(5642),
    [anon_sym_elif] = ACTIONS(5642),
    [anon_sym_else] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3345] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8683),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3346] = {
    [aux_sym_concatenation_repeat1] = STATE(3346),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(8395),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2306),
    [anon_sym_elif] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3347] = {
    [sym_concatenation] = STATE(3684),
    [sym_string] = STATE(3689),
    [sym_array] = STATE(3684),
    [sym_simple_expansion] = STATE(3689),
    [sym_string_expansion] = STATE(3689),
    [sym_expansion] = STATE(3689),
    [sym_command_substitution] = STATE(3689),
    [sym_process_substitution] = STATE(3689),
    [sym__empty_value] = ACTIONS(8685),
    [anon_sym_LPAREN] = ACTIONS(8687),
    [sym__special_characters] = ACTIONS(8689),
    [anon_sym_DQUOTE] = ACTIONS(8691),
    [anon_sym_DOLLAR] = ACTIONS(8693),
    [sym_raw_string] = ACTIONS(8695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8699),
    [anon_sym_BQUOTE] = ACTIONS(8701),
    [anon_sym_LT_LPAREN] = ACTIONS(8703),
    [anon_sym_GT_LPAREN] = ACTIONS(8703),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8695),
  },
  [3348] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(8705),
    [anon_sym_PLUS_EQ] = ACTIONS(8705),
    [sym_comment] = ACTIONS(57),
  },
  [3349] = {
    [aux_sym_concatenation_repeat1] = STATE(3696),
    [sym__simple_heredoc_body] = ACTIONS(939),
    [sym__heredoc_body_beginning] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(939),
    [sym__concat] = ACTIONS(8707),
    [sym_variable_name] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_esac] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(943),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(943),
    [sym_word] = ACTIONS(943),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(943),
  },
  [3350] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(3699),
    [anon_sym_DQUOTE] = ACTIONS(8709),
    [anon_sym_DOLLAR] = ACTIONS(8711),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3351] = {
    [sym_string] = STATE(3701),
    [anon_sym_DASH] = ACTIONS(8713),
    [anon_sym_DQUOTE] = ACTIONS(7909),
    [anon_sym_DOLLAR] = ACTIONS(8713),
    [sym_raw_string] = ACTIONS(8715),
    [anon_sym_POUND] = ACTIONS(8713),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8717),
    [anon_sym_STAR] = ACTIONS(8719),
    [anon_sym_AT] = ACTIONS(8719),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_0] = ACTIONS(8717),
    [anon_sym__] = ACTIONS(8717),
  },
  [3352] = {
    [aux_sym_concatenation_repeat1] = STATE(3696),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(8707),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_esac] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_characters] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [3353] = {
    [sym_subscript] = STATE(3706),
    [sym_variable_name] = ACTIONS(8721),
    [anon_sym_BANG] = ACTIONS(8723),
    [anon_sym_DASH] = ACTIONS(8725),
    [anon_sym_DOLLAR] = ACTIONS(8725),
    [anon_sym_POUND] = ACTIONS(8723),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8727),
    [anon_sym_STAR] = ACTIONS(8729),
    [anon_sym_AT] = ACTIONS(8729),
    [anon_sym_QMARK] = ACTIONS(8729),
    [anon_sym_0] = ACTIONS(8727),
    [anon_sym__] = ACTIONS(8727),
  },
  [3354] = {
    [sym__statements] = STATE(3707),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(3708),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3355] = {
    [sym__statements] = STATE(3709),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3356] = {
    [sym__statements] = STATE(3710),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3357] = {
    [anon_sym_EQ] = ACTIONS(8705),
    [anon_sym_PLUS_EQ] = ACTIONS(8705),
    [sym_comment] = ACTIONS(57),
  },
  [3358] = {
    [sym_variable_assignment] = STATE(3711),
    [sym_subscript] = STATE(3357),
    [sym_concatenation] = STATE(3711),
    [sym_string] = STATE(3352),
    [sym_simple_expansion] = STATE(3352),
    [sym_string_expansion] = STATE(3352),
    [sym_expansion] = STATE(3352),
    [sym_command_substitution] = STATE(3352),
    [sym_process_substitution] = STATE(3352),
    [aux_sym_declaration_command_repeat1] = STATE(3711),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_esac] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_characters] = ACTIONS(7907),
    [anon_sym_DQUOTE] = ACTIONS(7909),
    [anon_sym_DOLLAR] = ACTIONS(7911),
    [sym_raw_string] = ACTIONS(7913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7917),
    [anon_sym_BQUOTE] = ACTIONS(7919),
    [anon_sym_LT_LPAREN] = ACTIONS(7921),
    [anon_sym_GT_LPAREN] = ACTIONS(7921),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8731),
    [sym_word] = ACTIONS(7925),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [3359] = {
    [aux_sym_concatenation_repeat1] = STATE(3713),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym__concat] = ACTIONS(8733),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_esac] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(981),
    [sym_word] = ACTIONS(981),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(981),
  },
  [3360] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(3716),
    [anon_sym_DQUOTE] = ACTIONS(8735),
    [anon_sym_DOLLAR] = ACTIONS(8737),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3361] = {
    [sym_string] = STATE(3718),
    [anon_sym_DASH] = ACTIONS(8739),
    [anon_sym_DQUOTE] = ACTIONS(7929),
    [anon_sym_DOLLAR] = ACTIONS(8739),
    [sym_raw_string] = ACTIONS(8741),
    [anon_sym_POUND] = ACTIONS(8739),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8743),
    [anon_sym_STAR] = ACTIONS(8745),
    [anon_sym_AT] = ACTIONS(8745),
    [anon_sym_QMARK] = ACTIONS(8745),
    [anon_sym_0] = ACTIONS(8743),
    [anon_sym__] = ACTIONS(8743),
  },
  [3362] = {
    [aux_sym_concatenation_repeat1] = STATE(3713),
    [sym__simple_heredoc_body] = ACTIONS(995),
    [sym__heredoc_body_beginning] = ACTIONS(995),
    [sym_file_descriptor] = ACTIONS(995),
    [sym__concat] = ACTIONS(8733),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_esac] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [sym__special_characters] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(995),
    [anon_sym_GT_LPAREN] = ACTIONS(995),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(997),
    [sym_word] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [3363] = {
    [sym_subscript] = STATE(3723),
    [sym_variable_name] = ACTIONS(8747),
    [anon_sym_BANG] = ACTIONS(8749),
    [anon_sym_DASH] = ACTIONS(8751),
    [anon_sym_DOLLAR] = ACTIONS(8751),
    [anon_sym_POUND] = ACTIONS(8749),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8753),
    [anon_sym_STAR] = ACTIONS(8755),
    [anon_sym_AT] = ACTIONS(8755),
    [anon_sym_QMARK] = ACTIONS(8755),
    [anon_sym_0] = ACTIONS(8753),
    [anon_sym__] = ACTIONS(8753),
  },
  [3364] = {
    [sym__statements] = STATE(3724),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(3725),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3365] = {
    [sym__statements] = STATE(3726),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3366] = {
    [sym__statements] = STATE(3727),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3367] = {
    [sym_concatenation] = STATE(3728),
    [sym_string] = STATE(3362),
    [sym_simple_expansion] = STATE(3362),
    [sym_string_expansion] = STATE(3362),
    [sym_expansion] = STATE(3362),
    [sym_command_substitution] = STATE(3362),
    [sym_process_substitution] = STATE(3362),
    [aux_sym_unset_command_repeat1] = STATE(3728),
    [sym__simple_heredoc_body] = ACTIONS(1009),
    [sym__heredoc_body_beginning] = ACTIONS(1009),
    [sym_file_descriptor] = ACTIONS(1009),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_esac] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_LT_LT_LT] = ACTIONS(1009),
    [sym__special_characters] = ACTIONS(7927),
    [anon_sym_DQUOTE] = ACTIONS(7929),
    [anon_sym_DOLLAR] = ACTIONS(7931),
    [sym_raw_string] = ACTIONS(7933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7935),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7937),
    [anon_sym_BQUOTE] = ACTIONS(7939),
    [anon_sym_LT_LPAREN] = ACTIONS(7941),
    [anon_sym_GT_LPAREN] = ACTIONS(7941),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8757),
    [sym_word] = ACTIONS(7945),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [3368] = {
    [sym_string] = STATE(3729),
    [sym_simple_expansion] = STATE(3729),
    [sym_string_expansion] = STATE(3729),
    [sym_expansion] = STATE(3729),
    [sym_command_substitution] = STATE(3729),
    [sym_process_substitution] = STATE(3729),
    [sym__special_characters] = ACTIONS(8759),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(8759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8759),
  },
  [3369] = {
    [aux_sym_concatenation_repeat1] = STATE(3730),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(7947),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_esac] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [3370] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_esac] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_EQ_TILDE] = ACTIONS(1055),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [3371] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(8761),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3372] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(8761),
    [anon_sym_DOLLAR] = ACTIONS(8763),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3373] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_esac] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [3374] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [3375] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [3376] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(8765),
    [sym_comment] = ACTIONS(57),
  },
  [3377] = {
    [sym_subscript] = STATE(3736),
    [sym_variable_name] = ACTIONS(8767),
    [anon_sym_DASH] = ACTIONS(8769),
    [anon_sym_DOLLAR] = ACTIONS(8769),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8771),
    [anon_sym_STAR] = ACTIONS(8773),
    [anon_sym_AT] = ACTIONS(8773),
    [anon_sym_QMARK] = ACTIONS(8773),
    [anon_sym_0] = ACTIONS(8771),
    [anon_sym__] = ACTIONS(8771),
  },
  [3378] = {
    [sym_concatenation] = STATE(3739),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3739),
    [anon_sym_RBRACE] = ACTIONS(8775),
    [anon_sym_EQ] = ACTIONS(8777),
    [anon_sym_DASH] = ACTIONS(8777),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8781),
    [anon_sym_COLON] = ACTIONS(8777),
    [anon_sym_COLON_QMARK] = ACTIONS(8777),
    [anon_sym_COLON_DASH] = ACTIONS(8777),
    [anon_sym_PERCENT] = ACTIONS(8777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3379] = {
    [sym_concatenation] = STATE(3742),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3742),
    [anon_sym_RBRACE] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(8785),
    [anon_sym_DASH] = ACTIONS(8785),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(8789),
    [anon_sym_COLON] = ACTIONS(8785),
    [anon_sym_COLON_QMARK] = ACTIONS(8785),
    [anon_sym_COLON_DASH] = ACTIONS(8785),
    [anon_sym_PERCENT] = ACTIONS(8785),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3380] = {
    [anon_sym_RPAREN] = ACTIONS(8791),
    [sym_comment] = ACTIONS(57),
  },
  [3381] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(8791),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3382] = {
    [anon_sym_BQUOTE] = ACTIONS(8791),
    [sym_comment] = ACTIONS(57),
  },
  [3383] = {
    [anon_sym_RPAREN] = ACTIONS(8793),
    [sym_comment] = ACTIONS(57),
  },
  [3384] = {
    [anon_sym_esac] = ACTIONS(8795),
    [sym__special_characters] = ACTIONS(8797),
    [anon_sym_DQUOTE] = ACTIONS(8797),
    [anon_sym_DOLLAR] = ACTIONS(8799),
    [sym_raw_string] = ACTIONS(8797),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8797),
    [anon_sym_BQUOTE] = ACTIONS(8797),
    [anon_sym_LT_LPAREN] = ACTIONS(8797),
    [anon_sym_GT_LPAREN] = ACTIONS(8797),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8799),
  },
  [3385] = {
    [anon_sym_LT] = ACTIONS(8801),
    [anon_sym_GT] = ACTIONS(8801),
    [anon_sym_GT_GT] = ACTIONS(8803),
    [anon_sym_AMP_GT] = ACTIONS(8801),
    [anon_sym_AMP_GT_GT] = ACTIONS(8803),
    [anon_sym_LT_AMP] = ACTIONS(8803),
    [anon_sym_GT_AMP] = ACTIONS(8803),
    [sym_comment] = ACTIONS(57),
  },
  [3386] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_esac] = ACTIONS(4880),
    [anon_sym_SEMI_SEMI] = ACTIONS(1229),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [3387] = {
    [sym_redirected_statement] = STATE(3746),
    [sym_for_statement] = STATE(3746),
    [sym_c_style_for_statement] = STATE(3746),
    [sym_while_statement] = STATE(3746),
    [sym_if_statement] = STATE(3746),
    [sym_case_statement] = STATE(3746),
    [sym_function_definition] = STATE(3746),
    [sym_compound_statement] = STATE(3746),
    [sym_subshell] = STATE(3746),
    [sym_pipeline] = STATE(3746),
    [sym_list] = STATE(3746),
    [sym_negated_command] = STATE(3746),
    [sym_test_command] = STATE(3746),
    [sym_declaration_command] = STATE(3746),
    [sym_unset_command] = STATE(3746),
    [sym_command] = STATE(3746),
    [sym_command_name] = STATE(2894),
    [sym_variable_assignment] = STATE(3747),
    [sym_subscript] = STATE(2896),
    [sym_file_redirect] = STATE(2899),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym_command_repeat1] = STATE(2899),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6699),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6705),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6707),
    [anon_sym_typeset] = ACTIONS(6707),
    [anon_sym_export] = ACTIONS(6707),
    [anon_sym_readonly] = ACTIONS(6707),
    [anon_sym_local] = ACTIONS(6707),
    [anon_sym_unset] = ACTIONS(6709),
    [anon_sym_unsetenv] = ACTIONS(6709),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(6711),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6727),
  },
  [3388] = {
    [sym_redirected_statement] = STATE(3748),
    [sym_for_statement] = STATE(3748),
    [sym_c_style_for_statement] = STATE(3748),
    [sym_while_statement] = STATE(3748),
    [sym_if_statement] = STATE(3748),
    [sym_case_statement] = STATE(3748),
    [sym_function_definition] = STATE(3748),
    [sym_compound_statement] = STATE(3748),
    [sym_subshell] = STATE(3748),
    [sym_pipeline] = STATE(3748),
    [sym_list] = STATE(3748),
    [sym_negated_command] = STATE(3748),
    [sym_test_command] = STATE(3748),
    [sym_declaration_command] = STATE(3748),
    [sym_unset_command] = STATE(3748),
    [sym_command] = STATE(3748),
    [sym_command_name] = STATE(2894),
    [sym_variable_assignment] = STATE(3749),
    [sym_subscript] = STATE(2896),
    [sym_file_redirect] = STATE(2899),
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(2886),
    [sym_simple_expansion] = STATE(2886),
    [sym_string_expansion] = STATE(2886),
    [sym_expansion] = STATE(2886),
    [sym_command_substitution] = STATE(2886),
    [sym_process_substitution] = STATE(2886),
    [aux_sym_command_repeat1] = STATE(2899),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6699),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6705),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6707),
    [anon_sym_typeset] = ACTIONS(6707),
    [anon_sym_export] = ACTIONS(6707),
    [anon_sym_readonly] = ACTIONS(6707),
    [anon_sym_local] = ACTIONS(6707),
    [anon_sym_unset] = ACTIONS(6709),
    [anon_sym_unsetenv] = ACTIONS(6709),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(6711),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6727),
  },
  [3389] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(3751),
    [sym_simple_expansion] = STATE(3751),
    [sym_string_expansion] = STATE(3751),
    [sym_expansion] = STATE(3751),
    [sym_command_substitution] = STATE(3751),
    [sym_process_substitution] = STATE(3751),
    [sym__special_characters] = ACTIONS(8805),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(8807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8807),
  },
  [3390] = {
    [sym_concatenation] = STATE(651),
    [sym_string] = STATE(3753),
    [sym_simple_expansion] = STATE(3753),
    [sym_string_expansion] = STATE(3753),
    [sym_expansion] = STATE(3753),
    [sym_command_substitution] = STATE(3753),
    [sym_process_substitution] = STATE(3753),
    [sym__special_characters] = ACTIONS(8809),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(8811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8811),
  },
  [3391] = {
    [anon_sym_SEMI] = ACTIONS(8813),
    [anon_sym_esac] = ACTIONS(1229),
    [anon_sym_SEMI_SEMI] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8815),
    [anon_sym_AMP] = ACTIONS(8815),
  },
  [3392] = {
    [sym_file_redirect] = STATE(3755),
    [sym_heredoc_redirect] = STATE(3755),
    [sym_herestring_redirect] = STATE(3755),
    [aux_sym_redirected_statement_repeat1] = STATE(3755),
    [sym__simple_heredoc_body] = ACTIONS(1247),
    [sym__heredoc_body_beginning] = ACTIONS(1247),
    [sym_file_descriptor] = ACTIONS(7975),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_esac] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1247),
    [anon_sym_PIPE_AMP] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(7985),
    [anon_sym_GT] = ACTIONS(7985),
    [anon_sym_GT_GT] = ACTIONS(7987),
    [anon_sym_AMP_GT] = ACTIONS(7985),
    [anon_sym_AMP_GT_GT] = ACTIONS(7987),
    [anon_sym_LT_AMP] = ACTIONS(7987),
    [anon_sym_GT_AMP] = ACTIONS(7987),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7989),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
  },
  [3393] = {
    [sym_concatenation] = STATE(3756),
    [sym_string] = STATE(3758),
    [sym_simple_expansion] = STATE(3758),
    [sym_string_expansion] = STATE(3758),
    [sym_expansion] = STATE(3758),
    [sym_command_substitution] = STATE(3758),
    [sym_process_substitution] = STATE(3758),
    [sym_regex] = ACTIONS(8817),
    [sym__special_characters] = ACTIONS(8819),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(8821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8821),
  },
  [3394] = {
    [aux_sym_concatenation_repeat1] = STATE(3369),
    [sym__simple_heredoc_body] = ACTIONS(1257),
    [sym__heredoc_body_beginning] = ACTIONS(1257),
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(7947),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_esac] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_LT_LT_LT] = ACTIONS(1257),
    [sym__special_characters] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [3395] = {
    [aux_sym_concatenation_repeat1] = STATE(3369),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(7947),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_esac] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [3396] = {
    [sym_concatenation] = STATE(3759),
    [sym_string] = STATE(3395),
    [sym_simple_expansion] = STATE(3395),
    [sym_string_expansion] = STATE(3395),
    [sym_expansion] = STATE(3395),
    [sym_command_substitution] = STATE(3395),
    [sym_process_substitution] = STATE(3395),
    [aux_sym_command_repeat2] = STATE(3759),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_esac] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(7993),
    [anon_sym_EQ_EQ] = ACTIONS(7993),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(7995),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(7997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7999),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [3397] = {
    [sym_file_redirect] = STATE(3392),
    [sym_heredoc_redirect] = STATE(3392),
    [sym_heredoc_body] = STATE(3761),
    [sym_herestring_redirect] = STATE(3392),
    [aux_sym_redirected_statement_repeat1] = STATE(3392),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(7975),
    [anon_sym_SEMI] = ACTIONS(8823),
    [anon_sym_esac] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(7979),
    [anon_sym_SEMI_SEMI] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(7981),
    [anon_sym_AMP_AMP] = ACTIONS(7983),
    [anon_sym_PIPE_PIPE] = ACTIONS(7983),
    [anon_sym_LT] = ACTIONS(7985),
    [anon_sym_GT] = ACTIONS(7985),
    [anon_sym_GT_GT] = ACTIONS(7987),
    [anon_sym_AMP_GT] = ACTIONS(7985),
    [anon_sym_AMP_GT_GT] = ACTIONS(7987),
    [anon_sym_LT_AMP] = ACTIONS(7987),
    [anon_sym_GT_AMP] = ACTIONS(7987),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7989),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8825),
    [anon_sym_AMP] = ACTIONS(8823),
  },
  [3398] = {
    [sym_file_redirect] = STATE(3392),
    [sym_heredoc_redirect] = STATE(3392),
    [sym_heredoc_body] = STATE(3761),
    [sym_herestring_redirect] = STATE(3392),
    [aux_sym_redirected_statement_repeat1] = STATE(3392),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(8823),
    [anon_sym_esac] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(7979),
    [anon_sym_SEMI_SEMI] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(7981),
    [anon_sym_AMP_AMP] = ACTIONS(7983),
    [anon_sym_PIPE_PIPE] = ACTIONS(7983),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7989),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(8825),
    [anon_sym_AMP] = ACTIONS(8823),
  },
  [3399] = {
    [sym_concatenation] = STATE(3762),
    [sym_string] = STATE(3395),
    [sym_simple_expansion] = STATE(3395),
    [sym_string_expansion] = STATE(3395),
    [sym_expansion] = STATE(3395),
    [sym_command_substitution] = STATE(3395),
    [sym_process_substitution] = STATE(3395),
    [aux_sym_command_repeat2] = STATE(3762),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_esac] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(7993),
    [anon_sym_EQ_EQ] = ACTIONS(7993),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_characters] = ACTIONS(7995),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(7997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7999),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [3400] = {
    [anon_sym_esac] = ACTIONS(8827),
    [anon_sym_SEMI_SEMI] = ACTIONS(8829),
    [sym_comment] = ACTIONS(57),
  },
  [3401] = {
    [anon_sym_esac] = ACTIONS(8831),
    [sym__special_characters] = ACTIONS(8833),
    [anon_sym_DQUOTE] = ACTIONS(8833),
    [anon_sym_DOLLAR] = ACTIONS(8835),
    [sym_raw_string] = ACTIONS(8833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8833),
    [anon_sym_BQUOTE] = ACTIONS(8833),
    [anon_sym_LT_LPAREN] = ACTIONS(8833),
    [anon_sym_GT_LPAREN] = ACTIONS(8833),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8835),
  },
  [3402] = {
    [anon_sym_esac] = ACTIONS(8837),
    [anon_sym_SEMI_SEMI] = ACTIONS(8839),
    [sym_comment] = ACTIONS(57),
  },
  [3403] = {
    [sym__statements] = STATE(3766),
    [sym_redirected_statement] = STATE(3767),
    [sym_for_statement] = STATE(3767),
    [sym_c_style_for_statement] = STATE(3767),
    [sym_while_statement] = STATE(3767),
    [sym_if_statement] = STATE(3767),
    [sym_case_statement] = STATE(3767),
    [sym_function_definition] = STATE(3767),
    [sym_compound_statement] = STATE(3767),
    [sym_subshell] = STATE(3767),
    [sym_pipeline] = STATE(3767),
    [sym_list] = STATE(3767),
    [sym_negated_command] = STATE(3767),
    [sym_test_command] = STATE(3767),
    [sym_declaration_command] = STATE(3767),
    [sym_unset_command] = STATE(3767),
    [sym_command] = STATE(3767),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(3768),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(3769),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(8841),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4292),
    [anon_sym_typeset] = ACTIONS(4292),
    [anon_sym_export] = ACTIONS(4292),
    [anon_sym_readonly] = ACTIONS(4292),
    [anon_sym_local] = ACTIONS(4292),
    [anon_sym_unset] = ACTIONS(4294),
    [anon_sym_unsetenv] = ACTIONS(4294),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3404] = {
    [aux_sym_case_item_repeat1] = STATE(2901),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(8843),
    [sym_comment] = ACTIONS(57),
  },
  [3405] = {
    [sym__statements] = STATE(3772),
    [sym_redirected_statement] = STATE(3767),
    [sym_for_statement] = STATE(3767),
    [sym_c_style_for_statement] = STATE(3767),
    [sym_while_statement] = STATE(3767),
    [sym_if_statement] = STATE(3767),
    [sym_case_statement] = STATE(3767),
    [sym_function_definition] = STATE(3767),
    [sym_compound_statement] = STATE(3767),
    [sym_subshell] = STATE(3767),
    [sym_pipeline] = STATE(3767),
    [sym_list] = STATE(3767),
    [sym_negated_command] = STATE(3767),
    [sym_test_command] = STATE(3767),
    [sym_declaration_command] = STATE(3767),
    [sym_unset_command] = STATE(3767),
    [sym_command] = STATE(3767),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(3768),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(3769),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(8845),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4292),
    [anon_sym_typeset] = ACTIONS(4292),
    [anon_sym_export] = ACTIONS(4292),
    [anon_sym_readonly] = ACTIONS(4292),
    [anon_sym_local] = ACTIONS(4292),
    [anon_sym_unset] = ACTIONS(4294),
    [anon_sym_unsetenv] = ACTIONS(4294),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3406] = {
    [aux_sym_case_item_repeat1] = STATE(2901),
    [anon_sym_PIPE] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(8847),
    [sym_comment] = ACTIONS(57),
  },
  [3407] = {
    [sym__simple_heredoc_body] = ACTIONS(8849),
    [sym__heredoc_body_beginning] = ACTIONS(8849),
    [sym_file_descriptor] = ACTIONS(8849),
    [ts_builtin_sym_end] = ACTIONS(8849),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_done] = ACTIONS(8849),
    [anon_sym_fi] = ACTIONS(8849),
    [anon_sym_elif] = ACTIONS(8849),
    [anon_sym_else] = ACTIONS(8849),
    [anon_sym_esac] = ACTIONS(8849),
    [anon_sym_PIPE] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8849),
    [anon_sym_SEMI_SEMI] = ACTIONS(8849),
    [anon_sym_PIPE_AMP] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8849),
    [anon_sym_PIPE_PIPE] = ACTIONS(8849),
    [anon_sym_LT] = ACTIONS(8851),
    [anon_sym_GT] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8849),
    [anon_sym_AMP_GT] = ACTIONS(8851),
    [anon_sym_AMP_GT_GT] = ACTIONS(8849),
    [anon_sym_LT_AMP] = ACTIONS(8849),
    [anon_sym_GT_AMP] = ACTIONS(8849),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_LT_LT_DASH] = ACTIONS(8849),
    [anon_sym_LT_LT_LT] = ACTIONS(8849),
    [anon_sym_BQUOTE] = ACTIONS(8849),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8849),
    [anon_sym_AMP] = ACTIONS(8851),
  },
  [3408] = {
    [sym__simple_heredoc_body] = ACTIONS(8853),
    [sym__heredoc_body_beginning] = ACTIONS(8853),
    [sym_file_descriptor] = ACTIONS(8853),
    [ts_builtin_sym_end] = ACTIONS(8853),
    [anon_sym_SEMI] = ACTIONS(8855),
    [anon_sym_done] = ACTIONS(8853),
    [anon_sym_fi] = ACTIONS(8853),
    [anon_sym_elif] = ACTIONS(8853),
    [anon_sym_else] = ACTIONS(8853),
    [anon_sym_esac] = ACTIONS(8853),
    [anon_sym_PIPE] = ACTIONS(8855),
    [anon_sym_RPAREN] = ACTIONS(8853),
    [anon_sym_SEMI_SEMI] = ACTIONS(8853),
    [anon_sym_PIPE_AMP] = ACTIONS(8853),
    [anon_sym_AMP_AMP] = ACTIONS(8853),
    [anon_sym_PIPE_PIPE] = ACTIONS(8853),
    [anon_sym_LT] = ACTIONS(8855),
    [anon_sym_GT] = ACTIONS(8855),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_AMP_GT] = ACTIONS(8855),
    [anon_sym_AMP_GT_GT] = ACTIONS(8853),
    [anon_sym_LT_AMP] = ACTIONS(8853),
    [anon_sym_GT_AMP] = ACTIONS(8853),
    [anon_sym_LT_LT] = ACTIONS(8855),
    [anon_sym_LT_LT_DASH] = ACTIONS(8853),
    [anon_sym_LT_LT_LT] = ACTIONS(8853),
    [anon_sym_BQUOTE] = ACTIONS(8853),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8853),
    [anon_sym_AMP] = ACTIONS(8855),
  },
  [3409] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_in] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8162),
  },
  [3410] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_in] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8166),
  },
  [3411] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5545),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3412] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5553),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3413] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8857),
    [sym_comment] = ACTIONS(57),
  },
  [3414] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8859),
    [sym_comment] = ACTIONS(57),
  },
  [3415] = {
    [anon_sym_RBRACE] = ACTIONS(8859),
    [sym_comment] = ACTIONS(57),
  },
  [3416] = {
    [sym_concatenation] = STATE(3777),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3777),
    [anon_sym_RBRACE] = ACTIONS(8861),
    [anon_sym_EQ] = ACTIONS(8863),
    [anon_sym_DASH] = ACTIONS(8863),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8863),
    [anon_sym_COLON_QMARK] = ACTIONS(8863),
    [anon_sym_COLON_DASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3417] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5597),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3418] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8861),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3419] = {
    [sym_concatenation] = STATE(3778),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3778),
    [anon_sym_RBRACE] = ACTIONS(8859),
    [anon_sym_EQ] = ACTIONS(8867),
    [anon_sym_DASH] = ACTIONS(8867),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8867),
    [anon_sym_COLON_QMARK] = ACTIONS(8867),
    [anon_sym_COLON_DASH] = ACTIONS(8867),
    [anon_sym_PERCENT] = ACTIONS(8867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3420] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8859),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3421] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5642),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3422] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8871),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3423] = {
    [sym__simple_heredoc_body] = ACTIONS(7163),
    [sym__heredoc_body_beginning] = ACTIONS(7163),
    [sym_file_descriptor] = ACTIONS(7163),
    [anon_sym_SEMI] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7165),
    [anon_sym_SEMI_SEMI] = ACTIONS(7163),
    [anon_sym_RBRACE] = ACTIONS(7163),
    [anon_sym_PIPE_AMP] = ACTIONS(7163),
    [anon_sym_AMP_AMP] = ACTIONS(7163),
    [anon_sym_PIPE_PIPE] = ACTIONS(7163),
    [anon_sym_LT] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7165),
    [anon_sym_GT_GT] = ACTIONS(7163),
    [anon_sym_AMP_GT] = ACTIONS(7165),
    [anon_sym_AMP_GT_GT] = ACTIONS(7163),
    [anon_sym_LT_AMP] = ACTIONS(7163),
    [anon_sym_GT_AMP] = ACTIONS(7163),
    [anon_sym_LT_LT] = ACTIONS(7165),
    [anon_sym_LT_LT_DASH] = ACTIONS(7163),
    [anon_sym_LT_LT_LT] = ACTIONS(7163),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7163),
    [anon_sym_AMP] = ACTIONS(7165),
  },
  [3424] = {
    [sym_do_group] = STATE(3780),
    [sym_compound_statement] = STATE(3780),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3425] = {
    [sym_do_group] = STATE(3780),
    [sym_compound_statement] = STATE(3780),
    [anon_sym_SEMI] = ACTIONS(8873),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3426] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(559),
  },
  [3427] = {
    [sym__simple_heredoc_body] = ACTIONS(7889),
    [sym__heredoc_body_beginning] = ACTIONS(7889),
    [sym_file_descriptor] = ACTIONS(7889),
    [anon_sym_SEMI] = ACTIONS(7891),
    [anon_sym_PIPE] = ACTIONS(7891),
    [anon_sym_SEMI_SEMI] = ACTIONS(7889),
    [anon_sym_RBRACE] = ACTIONS(7889),
    [anon_sym_PIPE_AMP] = ACTIONS(7889),
    [anon_sym_AMP_AMP] = ACTIONS(7889),
    [anon_sym_PIPE_PIPE] = ACTIONS(7889),
    [anon_sym_LT] = ACTIONS(7891),
    [anon_sym_GT] = ACTIONS(7891),
    [anon_sym_GT_GT] = ACTIONS(7889),
    [anon_sym_AMP_GT] = ACTIONS(7891),
    [anon_sym_AMP_GT_GT] = ACTIONS(7889),
    [anon_sym_LT_AMP] = ACTIONS(7889),
    [anon_sym_GT_AMP] = ACTIONS(7889),
    [anon_sym_LT_LT] = ACTIONS(7891),
    [anon_sym_LT_LT_DASH] = ACTIONS(7889),
    [anon_sym_LT_LT_LT] = ACTIONS(7889),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7889),
    [anon_sym_AMP] = ACTIONS(7891),
  },
  [3428] = {
    [sym__simple_heredoc_body] = ACTIONS(8016),
    [sym__heredoc_body_beginning] = ACTIONS(8016),
    [sym_file_descriptor] = ACTIONS(8016),
    [anon_sym_SEMI] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8018),
    [anon_sym_SEMI_SEMI] = ACTIONS(8016),
    [anon_sym_RBRACE] = ACTIONS(8016),
    [anon_sym_PIPE_AMP] = ACTIONS(8016),
    [anon_sym_AMP_AMP] = ACTIONS(8016),
    [anon_sym_PIPE_PIPE] = ACTIONS(8016),
    [anon_sym_LT] = ACTIONS(8018),
    [anon_sym_GT] = ACTIONS(8018),
    [anon_sym_GT_GT] = ACTIONS(8016),
    [anon_sym_AMP_GT] = ACTIONS(8018),
    [anon_sym_AMP_GT_GT] = ACTIONS(8016),
    [anon_sym_LT_AMP] = ACTIONS(8016),
    [anon_sym_GT_AMP] = ACTIONS(8016),
    [anon_sym_LT_LT] = ACTIONS(8018),
    [anon_sym_LT_LT_DASH] = ACTIONS(8016),
    [anon_sym_LT_LT_LT] = ACTIONS(8016),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8016),
    [anon_sym_AMP] = ACTIONS(8018),
  },
  [3429] = {
    [anon_sym_esac] = ACTIONS(8877),
    [sym_comment] = ACTIONS(57),
  },
  [3430] = {
    [sym__simple_heredoc_body] = ACTIONS(8026),
    [sym__heredoc_body_beginning] = ACTIONS(8026),
    [sym_file_descriptor] = ACTIONS(8026),
    [anon_sym_SEMI] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8028),
    [anon_sym_SEMI_SEMI] = ACTIONS(8026),
    [anon_sym_RBRACE] = ACTIONS(8026),
    [anon_sym_PIPE_AMP] = ACTIONS(8026),
    [anon_sym_AMP_AMP] = ACTIONS(8026),
    [anon_sym_PIPE_PIPE] = ACTIONS(8026),
    [anon_sym_LT] = ACTIONS(8028),
    [anon_sym_GT] = ACTIONS(8028),
    [anon_sym_GT_GT] = ACTIONS(8026),
    [anon_sym_AMP_GT] = ACTIONS(8028),
    [anon_sym_AMP_GT_GT] = ACTIONS(8026),
    [anon_sym_LT_AMP] = ACTIONS(8026),
    [anon_sym_GT_AMP] = ACTIONS(8026),
    [anon_sym_LT_LT] = ACTIONS(8028),
    [anon_sym_LT_LT_DASH] = ACTIONS(8026),
    [anon_sym_LT_LT_LT] = ACTIONS(8026),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8026),
    [anon_sym_AMP] = ACTIONS(8028),
  },
  [3431] = {
    [anon_sym_esac] = ACTIONS(8879),
    [sym_comment] = ACTIONS(57),
  },
  [3432] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_RBRACE] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7045),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3433] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7049),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3434] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7053),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3435] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3436] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8883),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3437] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_RBRACE] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7089),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3438] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_RBRACE] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7045),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3439] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7049),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3440] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7053),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3441] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8885),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3442] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8887),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3443] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_RBRACE] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7089),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3444] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_RBRACE] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8164),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8164),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3445] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8168),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3446] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_RBRACK] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8162),
    [anon_sym_EQ] = ACTIONS(8164),
    [anon_sym_PLUS_EQ] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8162),
    [anon_sym_PLUS] = ACTIONS(8164),
    [anon_sym_DASH] = ACTIONS(8164),
    [anon_sym_DASH_EQ] = ACTIONS(8162),
    [anon_sym_LT_EQ] = ACTIONS(8162),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_PLUS_PLUS] = ACTIONS(8162),
    [anon_sym_DASH_DASH] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8162),
  },
  [3447] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_RBRACK] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_EQ_EQ] = ACTIONS(8166),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_PLUS_EQ] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_PLUS] = ACTIONS(8168),
    [anon_sym_DASH] = ACTIONS(8168),
    [anon_sym_DASH_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8166),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_PLUS_PLUS] = ACTIONS(8166),
    [anon_sym_DASH_DASH] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8166),
  },
  [3448] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [ts_builtin_sym_end] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_RPAREN] = ACTIONS(8162),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3449] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [ts_builtin_sym_end] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3450] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [ts_builtin_sym_end] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_RPAREN] = ACTIONS(8162),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3451] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [ts_builtin_sym_end] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3452] = {
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_RPAREN] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8162),
  },
  [3453] = {
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8166),
  },
  [3454] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8164),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym__string_content] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8164),
    [anon_sym_BQUOTE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(343),
  },
  [3455] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym__string_content] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_comment] = ACTIONS(343),
  },
  [3456] = {
    [sym__concat] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
  },
  [3457] = {
    [sym__concat] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
  },
  [3458] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8889),
    [sym_comment] = ACTIONS(57),
  },
  [3459] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8891),
    [sym_comment] = ACTIONS(57),
  },
  [3460] = {
    [anon_sym_RBRACE] = ACTIONS(8891),
    [sym_comment] = ACTIONS(57),
  },
  [3461] = {
    [sym_concatenation] = STATE(3792),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3792),
    [anon_sym_RBRACE] = ACTIONS(8893),
    [anon_sym_EQ] = ACTIONS(8895),
    [anon_sym_DASH] = ACTIONS(8895),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8895),
    [anon_sym_COLON_QMARK] = ACTIONS(8895),
    [anon_sym_COLON_DASH] = ACTIONS(8895),
    [anon_sym_PERCENT] = ACTIONS(8895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3462] = {
    [sym__concat] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
  },
  [3463] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8893),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3464] = {
    [sym_concatenation] = STATE(3793),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3793),
    [anon_sym_RBRACE] = ACTIONS(8891),
    [anon_sym_EQ] = ACTIONS(8899),
    [anon_sym_DASH] = ACTIONS(8899),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8899),
    [anon_sym_COLON_QMARK] = ACTIONS(8899),
    [anon_sym_COLON_DASH] = ACTIONS(8899),
    [anon_sym_PERCENT] = ACTIONS(8899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3465] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8891),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3466] = {
    [sym__concat] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
  },
  [3467] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8903),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3468] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_RBRACE] = ACTIONS(7043),
    [anon_sym_EQ] = ACTIONS(7045),
    [anon_sym_DASH] = ACTIONS(7045),
    [sym__special_characters] = ACTIONS(7045),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_POUND] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_COLON] = ACTIONS(7045),
    [anon_sym_COLON_QMARK] = ACTIONS(7045),
    [anon_sym_COLON_DASH] = ACTIONS(7045),
    [anon_sym_PERCENT] = ACTIONS(7045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7045),
  },
  [3469] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [anon_sym_EQ] = ACTIONS(7049),
    [anon_sym_DASH] = ACTIONS(7049),
    [sym__special_characters] = ACTIONS(7049),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_POUND] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_COLON] = ACTIONS(7049),
    [anon_sym_COLON_QMARK] = ACTIONS(7049),
    [anon_sym_COLON_DASH] = ACTIONS(7049),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7049),
  },
  [3470] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [anon_sym_EQ] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [sym__special_characters] = ACTIONS(7053),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_POUND] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_COLON] = ACTIONS(7053),
    [anon_sym_COLON_QMARK] = ACTIONS(7053),
    [anon_sym_COLON_DASH] = ACTIONS(7053),
    [anon_sym_PERCENT] = ACTIONS(7053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7053),
  },
  [3471] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8905),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3472] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8907),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3473] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_RBRACE] = ACTIONS(7087),
    [anon_sym_EQ] = ACTIONS(7089),
    [anon_sym_DASH] = ACTIONS(7089),
    [sym__special_characters] = ACTIONS(7089),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_POUND] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_COLON] = ACTIONS(7089),
    [anon_sym_COLON_QMARK] = ACTIONS(7089),
    [anon_sym_COLON_DASH] = ACTIONS(7089),
    [anon_sym_PERCENT] = ACTIONS(7089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7089),
  },
  [3474] = {
    [sym__heredoc_body_middle] = ACTIONS(7043),
    [sym__heredoc_body_end] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
  },
  [3475] = {
    [sym__heredoc_body_middle] = ACTIONS(7047),
    [sym__heredoc_body_end] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
  },
  [3476] = {
    [sym__heredoc_body_middle] = ACTIONS(7051),
    [sym__heredoc_body_end] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
  },
  [3477] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8909),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3478] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8911),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3479] = {
    [sym__heredoc_body_middle] = ACTIONS(7087),
    [sym__heredoc_body_end] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
  },
  [3480] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7043),
  },
  [3481] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_RPAREN] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7047),
  },
  [3482] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_RPAREN] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7051),
  },
  [3483] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8913),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3484] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8915),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3485] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_RPAREN] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7087),
  },
  [3486] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [ts_builtin_sym_end] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_RPAREN] = ACTIONS(8162),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3487] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [ts_builtin_sym_end] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3488] = {
    [sym__simple_heredoc_body] = ACTIONS(8917),
    [sym__heredoc_body_beginning] = ACTIONS(8917),
    [sym_file_descriptor] = ACTIONS(8917),
    [ts_builtin_sym_end] = ACTIONS(8917),
    [anon_sym_SEMI] = ACTIONS(8919),
    [anon_sym_done] = ACTIONS(8917),
    [anon_sym_fi] = ACTIONS(8917),
    [anon_sym_elif] = ACTIONS(8917),
    [anon_sym_else] = ACTIONS(8917),
    [anon_sym_esac] = ACTIONS(8917),
    [anon_sym_PIPE] = ACTIONS(8919),
    [anon_sym_RPAREN] = ACTIONS(8917),
    [anon_sym_SEMI_SEMI] = ACTIONS(8917),
    [anon_sym_PIPE_AMP] = ACTIONS(8917),
    [anon_sym_AMP_AMP] = ACTIONS(8917),
    [anon_sym_PIPE_PIPE] = ACTIONS(8917),
    [anon_sym_LT] = ACTIONS(8919),
    [anon_sym_GT] = ACTIONS(8919),
    [anon_sym_GT_GT] = ACTIONS(8917),
    [anon_sym_AMP_GT] = ACTIONS(8919),
    [anon_sym_AMP_GT_GT] = ACTIONS(8917),
    [anon_sym_LT_AMP] = ACTIONS(8917),
    [anon_sym_GT_AMP] = ACTIONS(8917),
    [anon_sym_LT_LT] = ACTIONS(8919),
    [anon_sym_LT_LT_DASH] = ACTIONS(8917),
    [anon_sym_LT_LT_LT] = ACTIONS(8917),
    [anon_sym_BQUOTE] = ACTIONS(8917),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8917),
    [anon_sym_AMP] = ACTIONS(8919),
  },
  [3489] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8162),
    [anon_sym_EQ] = ACTIONS(8164),
    [anon_sym_PLUS_EQ] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8162),
    [anon_sym_PLUS] = ACTIONS(8164),
    [anon_sym_DASH] = ACTIONS(8164),
    [anon_sym_DASH_EQ] = ACTIONS(8162),
    [anon_sym_LT_EQ] = ACTIONS(8162),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_PLUS_PLUS] = ACTIONS(8162),
    [anon_sym_DASH_DASH] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8162),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3490] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_EQ_EQ] = ACTIONS(8166),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_PLUS_EQ] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_PLUS] = ACTIONS(8168),
    [anon_sym_DASH] = ACTIONS(8168),
    [anon_sym_DASH_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8166),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_PLUS_PLUS] = ACTIONS(8166),
    [anon_sym_DASH_DASH] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8166),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3491] = {
    [sym_do_group] = STATE(3801),
    [sym_compound_statement] = STATE(3801),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3492] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7043),
  },
  [3493] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7047),
  },
  [3494] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7051),
  },
  [3495] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8921),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3496] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8923),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3497] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7087),
  },
  [3498] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_RPAREN] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8162),
    [anon_sym_EQ_EQ] = ACTIONS(8162),
    [anon_sym_EQ] = ACTIONS(8164),
    [anon_sym_PLUS_EQ] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_BANG_EQ] = ACTIONS(8162),
    [anon_sym_PLUS] = ACTIONS(8164),
    [anon_sym_DASH] = ACTIONS(8164),
    [anon_sym_DASH_EQ] = ACTIONS(8162),
    [anon_sym_LT_EQ] = ACTIONS(8162),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_PLUS_PLUS] = ACTIONS(8162),
    [anon_sym_DASH_DASH] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8162),
  },
  [3499] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_EQ_EQ] = ACTIONS(8166),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_PLUS_EQ] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_PLUS] = ACTIONS(8168),
    [anon_sym_DASH] = ACTIONS(8168),
    [anon_sym_DASH_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8166),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_PLUS_PLUS] = ACTIONS(8166),
    [anon_sym_DASH_DASH] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8166),
  },
  [3500] = {
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3501] = {
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3502] = {
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3503] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3504] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8927),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3505] = {
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3506] = {
    [sym_file_descriptor] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI_SEMI] = ACTIONS(8222),
    [anon_sym_PIPE_AMP] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8222),
    [anon_sym_PIPE_PIPE] = ACTIONS(8222),
    [anon_sym_LT] = ACTIONS(8224),
    [anon_sym_GT] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8222),
    [anon_sym_AMP_GT] = ACTIONS(8224),
    [anon_sym_AMP_GT_GT] = ACTIONS(8222),
    [anon_sym_LT_AMP] = ACTIONS(8222),
    [anon_sym_GT_AMP] = ACTIONS(8222),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_LT_LT_DASH] = ACTIONS(8222),
    [anon_sym_LT_LT_LT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8224),
  },
  [3507] = {
    [sym_do_group] = STATE(3806),
    [sym_compound_statement] = STATE(3806),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3508] = {
    [sym_do_group] = STATE(3806),
    [sym_compound_statement] = STATE(3806),
    [anon_sym_SEMI] = ACTIONS(8929),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3509] = {
    [sym_file_descriptor] = ACTIONS(8849),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_PIPE] = ACTIONS(8851),
    [anon_sym_SEMI_SEMI] = ACTIONS(8849),
    [anon_sym_PIPE_AMP] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8849),
    [anon_sym_PIPE_PIPE] = ACTIONS(8849),
    [anon_sym_LT] = ACTIONS(8851),
    [anon_sym_GT] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8849),
    [anon_sym_AMP_GT] = ACTIONS(8851),
    [anon_sym_AMP_GT_GT] = ACTIONS(8849),
    [anon_sym_LT_AMP] = ACTIONS(8849),
    [anon_sym_GT_AMP] = ACTIONS(8849),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_LT_LT_DASH] = ACTIONS(8849),
    [anon_sym_LT_LT_LT] = ACTIONS(8849),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8849),
    [anon_sym_AMP] = ACTIONS(8851),
  },
  [3510] = {
    [sym_file_descriptor] = ACTIONS(8853),
    [anon_sym_SEMI] = ACTIONS(8855),
    [anon_sym_PIPE] = ACTIONS(8855),
    [anon_sym_SEMI_SEMI] = ACTIONS(8853),
    [anon_sym_PIPE_AMP] = ACTIONS(8853),
    [anon_sym_AMP_AMP] = ACTIONS(8853),
    [anon_sym_PIPE_PIPE] = ACTIONS(8853),
    [anon_sym_LT] = ACTIONS(8855),
    [anon_sym_GT] = ACTIONS(8855),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_AMP_GT] = ACTIONS(8855),
    [anon_sym_AMP_GT_GT] = ACTIONS(8853),
    [anon_sym_LT_AMP] = ACTIONS(8853),
    [anon_sym_GT_AMP] = ACTIONS(8853),
    [anon_sym_LT_LT] = ACTIONS(8855),
    [anon_sym_LT_LT_DASH] = ACTIONS(8853),
    [anon_sym_LT_LT_LT] = ACTIONS(8853),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8853),
    [anon_sym_AMP] = ACTIONS(8855),
  },
  [3511] = {
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3512] = {
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3513] = {
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3514] = {
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3515] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_done] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3516] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_done] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3517] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8931),
    [sym_comment] = ACTIONS(57),
  },
  [3518] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8933),
    [sym_comment] = ACTIONS(57),
  },
  [3519] = {
    [anon_sym_RBRACE] = ACTIONS(8933),
    [sym_comment] = ACTIONS(57),
  },
  [3520] = {
    [sym_concatenation] = STATE(3812),
    [sym_string] = STATE(3811),
    [sym_simple_expansion] = STATE(3811),
    [sym_string_expansion] = STATE(3811),
    [sym_expansion] = STATE(3811),
    [sym_command_substitution] = STATE(3811),
    [sym_process_substitution] = STATE(3811),
    [anon_sym_RBRACE] = ACTIONS(8933),
    [sym__special_characters] = ACTIONS(8935),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(8937),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8937),
  },
  [3521] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_done] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3522] = {
    [sym_concatenation] = STATE(3815),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3815),
    [sym_regex] = ACTIONS(8939),
    [anon_sym_RBRACE] = ACTIONS(8941),
    [anon_sym_EQ] = ACTIONS(8943),
    [anon_sym_DASH] = ACTIONS(8943),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8943),
    [anon_sym_COLON_QMARK] = ACTIONS(8943),
    [anon_sym_COLON_DASH] = ACTIONS(8943),
    [anon_sym_PERCENT] = ACTIONS(8943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3523] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8941),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3524] = {
    [sym_concatenation] = STATE(3817),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3817),
    [sym_regex] = ACTIONS(8947),
    [anon_sym_RBRACE] = ACTIONS(8933),
    [anon_sym_EQ] = ACTIONS(8949),
    [anon_sym_DASH] = ACTIONS(8949),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8949),
    [anon_sym_COLON_QMARK] = ACTIONS(8949),
    [anon_sym_COLON_DASH] = ACTIONS(8949),
    [anon_sym_PERCENT] = ACTIONS(8949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3525] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8933),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3526] = {
    [sym_concatenation] = STATE(3819),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3819),
    [anon_sym_RBRACE] = ACTIONS(8953),
    [anon_sym_EQ] = ACTIONS(8955),
    [anon_sym_DASH] = ACTIONS(8955),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8955),
    [anon_sym_COLON_QMARK] = ACTIONS(8955),
    [anon_sym_COLON_DASH] = ACTIONS(8955),
    [anon_sym_PERCENT] = ACTIONS(8955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3527] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3528] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8953),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3529] = {
    [sym_concatenation] = STATE(3817),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3817),
    [anon_sym_RBRACE] = ACTIONS(8933),
    [anon_sym_EQ] = ACTIONS(8949),
    [anon_sym_DASH] = ACTIONS(8949),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8949),
    [anon_sym_COLON_QMARK] = ACTIONS(8949),
    [anon_sym_COLON_DASH] = ACTIONS(8949),
    [anon_sym_PERCENT] = ACTIONS(8949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3530] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_done] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4354),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [3531] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_done] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3532] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_done] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3533] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8959),
    [sym_comment] = ACTIONS(57),
  },
  [3534] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [sym_comment] = ACTIONS(57),
  },
  [3535] = {
    [anon_sym_RBRACE] = ACTIONS(8961),
    [sym_comment] = ACTIONS(57),
  },
  [3536] = {
    [sym_concatenation] = STATE(3823),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3823),
    [anon_sym_RBRACE] = ACTIONS(8963),
    [anon_sym_EQ] = ACTIONS(8965),
    [anon_sym_DASH] = ACTIONS(8965),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8965),
    [anon_sym_COLON_QMARK] = ACTIONS(8965),
    [anon_sym_COLON_DASH] = ACTIONS(8965),
    [anon_sym_PERCENT] = ACTIONS(8965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3537] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_done] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3538] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8963),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3539] = {
    [sym_concatenation] = STATE(3824),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3824),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_EQ] = ACTIONS(8969),
    [anon_sym_DASH] = ACTIONS(8969),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8971),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8969),
    [anon_sym_COLON_QMARK] = ACTIONS(8969),
    [anon_sym_COLON_DASH] = ACTIONS(8969),
    [anon_sym_PERCENT] = ACTIONS(8969),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3540] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3541] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_done] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3542] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8973),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3543] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_done] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3544] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_done] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3545] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8975),
    [sym_comment] = ACTIONS(57),
  },
  [3546] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8977),
    [sym_comment] = ACTIONS(57),
  },
  [3547] = {
    [anon_sym_RBRACE] = ACTIONS(8977),
    [sym_comment] = ACTIONS(57),
  },
  [3548] = {
    [sym_concatenation] = STATE(3829),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3829),
    [anon_sym_RBRACE] = ACTIONS(8979),
    [anon_sym_EQ] = ACTIONS(8981),
    [anon_sym_DASH] = ACTIONS(8981),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8981),
    [anon_sym_COLON_QMARK] = ACTIONS(8981),
    [anon_sym_COLON_DASH] = ACTIONS(8981),
    [anon_sym_PERCENT] = ACTIONS(8981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3549] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_done] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3550] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8979),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3551] = {
    [sym_concatenation] = STATE(3830),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3830),
    [anon_sym_RBRACE] = ACTIONS(8977),
    [anon_sym_EQ] = ACTIONS(8985),
    [anon_sym_DASH] = ACTIONS(8985),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(8987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(8985),
    [anon_sym_COLON_QMARK] = ACTIONS(8985),
    [anon_sym_COLON_DASH] = ACTIONS(8985),
    [anon_sym_PERCENT] = ACTIONS(8985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3552] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8977),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3553] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_done] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3554] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8989),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3555] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_done] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7045),
    [anon_sym_EQ_EQ] = ACTIONS(7045),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3556] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_done] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7049),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3557] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_done] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_EQ_EQ] = ACTIONS(7053),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3558] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8991),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3559] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8993),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3560] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_done] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7089),
    [anon_sym_EQ_EQ] = ACTIONS(7089),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3561] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_done] = ACTIONS(4019),
    [anon_sym_fi] = ACTIONS(4019),
    [anon_sym_elif] = ACTIONS(4019),
    [anon_sym_else] = ACTIONS(4019),
    [anon_sym_esac] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3562] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_done] = ACTIONS(4033),
    [anon_sym_fi] = ACTIONS(4033),
    [anon_sym_elif] = ACTIONS(4033),
    [anon_sym_else] = ACTIONS(4033),
    [anon_sym_esac] = ACTIONS(4033),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3563] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8995),
    [sym_comment] = ACTIONS(57),
  },
  [3564] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(8997),
    [sym_comment] = ACTIONS(57),
  },
  [3565] = {
    [anon_sym_RBRACE] = ACTIONS(8997),
    [sym_comment] = ACTIONS(57),
  },
  [3566] = {
    [sym_concatenation] = STATE(3838),
    [sym_string] = STATE(3837),
    [sym_simple_expansion] = STATE(3837),
    [sym_string_expansion] = STATE(3837),
    [sym_expansion] = STATE(3837),
    [sym_command_substitution] = STATE(3837),
    [sym_process_substitution] = STATE(3837),
    [anon_sym_RBRACE] = ACTIONS(8997),
    [sym__special_characters] = ACTIONS(8999),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9001),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9001),
  },
  [3567] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_done] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_elif] = ACTIONS(4069),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_esac] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3568] = {
    [sym_concatenation] = STATE(3841),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3841),
    [sym_regex] = ACTIONS(9003),
    [anon_sym_RBRACE] = ACTIONS(9005),
    [anon_sym_EQ] = ACTIONS(9007),
    [anon_sym_DASH] = ACTIONS(9007),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9009),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9007),
    [anon_sym_COLON_QMARK] = ACTIONS(9007),
    [anon_sym_COLON_DASH] = ACTIONS(9007),
    [anon_sym_PERCENT] = ACTIONS(9007),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3569] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9005),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3570] = {
    [sym_concatenation] = STATE(3843),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3843),
    [sym_regex] = ACTIONS(9011),
    [anon_sym_RBRACE] = ACTIONS(8997),
    [anon_sym_EQ] = ACTIONS(9013),
    [anon_sym_DASH] = ACTIONS(9013),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9015),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9013),
    [anon_sym_COLON_QMARK] = ACTIONS(9013),
    [anon_sym_COLON_DASH] = ACTIONS(9013),
    [anon_sym_PERCENT] = ACTIONS(9013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3571] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(8997),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3572] = {
    [sym_concatenation] = STATE(3845),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3845),
    [anon_sym_RBRACE] = ACTIONS(9017),
    [anon_sym_EQ] = ACTIONS(9019),
    [anon_sym_DASH] = ACTIONS(9019),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9019),
    [anon_sym_COLON_QMARK] = ACTIONS(9019),
    [anon_sym_COLON_DASH] = ACTIONS(9019),
    [anon_sym_PERCENT] = ACTIONS(9019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3573] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4125),
    [anon_sym_fi] = ACTIONS(4125),
    [anon_sym_elif] = ACTIONS(4125),
    [anon_sym_else] = ACTIONS(4125),
    [anon_sym_esac] = ACTIONS(4125),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3574] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9017),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3575] = {
    [sym_concatenation] = STATE(3843),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3843),
    [anon_sym_RBRACE] = ACTIONS(8997),
    [anon_sym_EQ] = ACTIONS(9013),
    [anon_sym_DASH] = ACTIONS(9013),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9015),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9013),
    [anon_sym_COLON_QMARK] = ACTIONS(9013),
    [anon_sym_COLON_DASH] = ACTIONS(9013),
    [anon_sym_PERCENT] = ACTIONS(9013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3576] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_fi] = ACTIONS(4021),
    [anon_sym_elif] = ACTIONS(4021),
    [anon_sym_else] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3577] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_fi] = ACTIONS(4035),
    [anon_sym_elif] = ACTIONS(4035),
    [anon_sym_else] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3578] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9023),
    [sym_comment] = ACTIONS(57),
  },
  [3579] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9025),
    [sym_comment] = ACTIONS(57),
  },
  [3580] = {
    [anon_sym_RBRACE] = ACTIONS(9025),
    [sym_comment] = ACTIONS(57),
  },
  [3581] = {
    [sym_concatenation] = STATE(3850),
    [sym_string] = STATE(3849),
    [sym_simple_expansion] = STATE(3849),
    [sym_string_expansion] = STATE(3849),
    [sym_expansion] = STATE(3849),
    [sym_command_substitution] = STATE(3849),
    [sym_process_substitution] = STATE(3849),
    [anon_sym_RBRACE] = ACTIONS(9025),
    [sym__special_characters] = ACTIONS(9027),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9029),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9029),
  },
  [3582] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_fi] = ACTIONS(4071),
    [anon_sym_elif] = ACTIONS(4071),
    [anon_sym_else] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3583] = {
    [sym_concatenation] = STATE(3853),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3853),
    [sym_regex] = ACTIONS(9031),
    [anon_sym_RBRACE] = ACTIONS(9033),
    [anon_sym_EQ] = ACTIONS(9035),
    [anon_sym_DASH] = ACTIONS(9035),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9035),
    [anon_sym_COLON_QMARK] = ACTIONS(9035),
    [anon_sym_COLON_DASH] = ACTIONS(9035),
    [anon_sym_PERCENT] = ACTIONS(9035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3584] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9033),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3585] = {
    [sym_concatenation] = STATE(3855),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3855),
    [sym_regex] = ACTIONS(9039),
    [anon_sym_RBRACE] = ACTIONS(9025),
    [anon_sym_EQ] = ACTIONS(9041),
    [anon_sym_DASH] = ACTIONS(9041),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9041),
    [anon_sym_COLON_QMARK] = ACTIONS(9041),
    [anon_sym_COLON_DASH] = ACTIONS(9041),
    [anon_sym_PERCENT] = ACTIONS(9041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3586] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9025),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3587] = {
    [sym_concatenation] = STATE(3857),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3857),
    [anon_sym_RBRACE] = ACTIONS(9045),
    [anon_sym_EQ] = ACTIONS(9047),
    [anon_sym_DASH] = ACTIONS(9047),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9047),
    [anon_sym_COLON_QMARK] = ACTIONS(9047),
    [anon_sym_COLON_DASH] = ACTIONS(9047),
    [anon_sym_PERCENT] = ACTIONS(9047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3588] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_elif] = ACTIONS(4127),
    [anon_sym_else] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3589] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9045),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3590] = {
    [sym_concatenation] = STATE(3855),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3855),
    [anon_sym_RBRACE] = ACTIONS(9025),
    [anon_sym_EQ] = ACTIONS(9041),
    [anon_sym_DASH] = ACTIONS(9041),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9041),
    [anon_sym_COLON_QMARK] = ACTIONS(9041),
    [anon_sym_COLON_DASH] = ACTIONS(9041),
    [anon_sym_PERCENT] = ACTIONS(9041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3591] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_fi] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [3592] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3593] = {
    [aux_sym_concatenation_repeat1] = STATE(3593),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(9051),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3594] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_fi] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3595] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(9054),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3596] = {
    [sym_concatenation] = STATE(3862),
    [sym_string] = STATE(3861),
    [sym_simple_expansion] = STATE(3861),
    [sym_string_expansion] = STATE(3861),
    [sym_expansion] = STATE(3861),
    [sym_command_substitution] = STATE(3861),
    [sym_process_substitution] = STATE(3861),
    [anon_sym_RBRACE] = ACTIONS(9056),
    [sym__special_characters] = ACTIONS(9058),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9060),
  },
  [3597] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(9062),
    [sym_comment] = ACTIONS(57),
  },
  [3598] = {
    [sym_concatenation] = STATE(3866),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3866),
    [anon_sym_RBRACE] = ACTIONS(9064),
    [anon_sym_EQ] = ACTIONS(9066),
    [anon_sym_DASH] = ACTIONS(9066),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9070),
    [anon_sym_COLON] = ACTIONS(9066),
    [anon_sym_COLON_QMARK] = ACTIONS(9066),
    [anon_sym_COLON_DASH] = ACTIONS(9066),
    [anon_sym_PERCENT] = ACTIONS(9066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3599] = {
    [sym_concatenation] = STATE(3868),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3868),
    [anon_sym_RBRACE] = ACTIONS(9056),
    [anon_sym_EQ] = ACTIONS(9072),
    [anon_sym_DASH] = ACTIONS(9072),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9076),
    [anon_sym_COLON] = ACTIONS(9072),
    [anon_sym_COLON_QMARK] = ACTIONS(9072),
    [anon_sym_COLON_DASH] = ACTIONS(9072),
    [anon_sym_PERCENT] = ACTIONS(9072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3600] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_fi] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3601] = {
    [sym_concatenation] = STATE(3871),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3871),
    [sym_regex] = ACTIONS(9078),
    [anon_sym_RBRACE] = ACTIONS(9080),
    [anon_sym_EQ] = ACTIONS(9082),
    [anon_sym_DASH] = ACTIONS(9082),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9084),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9082),
    [anon_sym_COLON_QMARK] = ACTIONS(9082),
    [anon_sym_COLON_DASH] = ACTIONS(9082),
    [anon_sym_PERCENT] = ACTIONS(9082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3602] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9080),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3603] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_fi] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3604] = {
    [sym_concatenation] = STATE(3868),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3868),
    [sym_regex] = ACTIONS(9086),
    [anon_sym_RBRACE] = ACTIONS(9056),
    [anon_sym_EQ] = ACTIONS(9072),
    [anon_sym_DASH] = ACTIONS(9072),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9072),
    [anon_sym_COLON_QMARK] = ACTIONS(9072),
    [anon_sym_COLON_DASH] = ACTIONS(9072),
    [anon_sym_PERCENT] = ACTIONS(9072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3605] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9056),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3606] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_fi] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3607] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_fi] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3608] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_fi] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2666),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [3609] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(9088),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [3610] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_fi] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3611] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_fi] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3612] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9090),
    [sym_comment] = ACTIONS(57),
  },
  [3613] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9092),
    [sym_comment] = ACTIONS(57),
  },
  [3614] = {
    [anon_sym_RBRACE] = ACTIONS(9092),
    [sym_comment] = ACTIONS(57),
  },
  [3615] = {
    [sym_concatenation] = STATE(3878),
    [sym_string] = STATE(3877),
    [sym_simple_expansion] = STATE(3877),
    [sym_string_expansion] = STATE(3877),
    [sym_expansion] = STATE(3877),
    [sym_command_substitution] = STATE(3877),
    [sym_process_substitution] = STATE(3877),
    [anon_sym_RBRACE] = ACTIONS(9092),
    [sym__special_characters] = ACTIONS(9094),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9096),
  },
  [3616] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_fi] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3617] = {
    [sym_concatenation] = STATE(3881),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3881),
    [sym_regex] = ACTIONS(9098),
    [anon_sym_RBRACE] = ACTIONS(9100),
    [anon_sym_EQ] = ACTIONS(9102),
    [anon_sym_DASH] = ACTIONS(9102),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9102),
    [anon_sym_COLON_QMARK] = ACTIONS(9102),
    [anon_sym_COLON_DASH] = ACTIONS(9102),
    [anon_sym_PERCENT] = ACTIONS(9102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3618] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9100),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3619] = {
    [sym_concatenation] = STATE(3883),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3883),
    [sym_regex] = ACTIONS(9106),
    [anon_sym_RBRACE] = ACTIONS(9092),
    [anon_sym_EQ] = ACTIONS(9108),
    [anon_sym_DASH] = ACTIONS(9108),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9108),
    [anon_sym_COLON_QMARK] = ACTIONS(9108),
    [anon_sym_COLON_DASH] = ACTIONS(9108),
    [anon_sym_PERCENT] = ACTIONS(9108),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3620] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9092),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3621] = {
    [sym_concatenation] = STATE(3885),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3885),
    [anon_sym_RBRACE] = ACTIONS(9112),
    [anon_sym_EQ] = ACTIONS(9114),
    [anon_sym_DASH] = ACTIONS(9114),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9114),
    [anon_sym_COLON_QMARK] = ACTIONS(9114),
    [anon_sym_COLON_DASH] = ACTIONS(9114),
    [anon_sym_PERCENT] = ACTIONS(9114),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3622] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3623] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9112),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3624] = {
    [sym_concatenation] = STATE(3883),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3883),
    [anon_sym_RBRACE] = ACTIONS(9092),
    [anon_sym_EQ] = ACTIONS(9108),
    [anon_sym_DASH] = ACTIONS(9108),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9108),
    [anon_sym_COLON_QMARK] = ACTIONS(9108),
    [anon_sym_COLON_DASH] = ACTIONS(9108),
    [anon_sym_PERCENT] = ACTIONS(9108),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3625] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_fi] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3626] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_fi] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3627] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9118),
    [sym_comment] = ACTIONS(57),
  },
  [3628] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(57),
  },
  [3629] = {
    [anon_sym_RBRACE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(57),
  },
  [3630] = {
    [sym_concatenation] = STATE(3890),
    [sym_string] = STATE(3889),
    [sym_simple_expansion] = STATE(3889),
    [sym_string_expansion] = STATE(3889),
    [sym_expansion] = STATE(3889),
    [sym_command_substitution] = STATE(3889),
    [sym_process_substitution] = STATE(3889),
    [anon_sym_RBRACE] = ACTIONS(9120),
    [sym__special_characters] = ACTIONS(9122),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9124),
  },
  [3631] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_fi] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3632] = {
    [sym_concatenation] = STATE(3893),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3893),
    [sym_regex] = ACTIONS(9126),
    [anon_sym_RBRACE] = ACTIONS(9128),
    [anon_sym_EQ] = ACTIONS(9130),
    [anon_sym_DASH] = ACTIONS(9130),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9130),
    [anon_sym_COLON_QMARK] = ACTIONS(9130),
    [anon_sym_COLON_DASH] = ACTIONS(9130),
    [anon_sym_PERCENT] = ACTIONS(9130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3633] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9128),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3634] = {
    [sym_concatenation] = STATE(3895),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3895),
    [sym_regex] = ACTIONS(9134),
    [anon_sym_RBRACE] = ACTIONS(9120),
    [anon_sym_EQ] = ACTIONS(9136),
    [anon_sym_DASH] = ACTIONS(9136),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9136),
    [anon_sym_COLON_QMARK] = ACTIONS(9136),
    [anon_sym_COLON_DASH] = ACTIONS(9136),
    [anon_sym_PERCENT] = ACTIONS(9136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3635] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9120),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3636] = {
    [sym_concatenation] = STATE(3897),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3897),
    [anon_sym_RBRACE] = ACTIONS(9140),
    [anon_sym_EQ] = ACTIONS(9142),
    [anon_sym_DASH] = ACTIONS(9142),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9142),
    [anon_sym_COLON_QMARK] = ACTIONS(9142),
    [anon_sym_COLON_DASH] = ACTIONS(9142),
    [anon_sym_PERCENT] = ACTIONS(9142),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3637] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3638] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9140),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3639] = {
    [sym_concatenation] = STATE(3895),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3895),
    [anon_sym_RBRACE] = ACTIONS(9120),
    [anon_sym_EQ] = ACTIONS(9136),
    [anon_sym_DASH] = ACTIONS(9136),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9136),
    [anon_sym_COLON_QMARK] = ACTIONS(9136),
    [anon_sym_COLON_DASH] = ACTIONS(9136),
    [anon_sym_PERCENT] = ACTIONS(9136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3640] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_fi] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3641] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_fi] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3642] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9146),
    [sym_comment] = ACTIONS(57),
  },
  [3643] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9148),
    [sym_comment] = ACTIONS(57),
  },
  [3644] = {
    [anon_sym_RBRACE] = ACTIONS(9148),
    [sym_comment] = ACTIONS(57),
  },
  [3645] = {
    [sym_concatenation] = STATE(3901),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3901),
    [anon_sym_RBRACE] = ACTIONS(9150),
    [anon_sym_EQ] = ACTIONS(9152),
    [anon_sym_DASH] = ACTIONS(9152),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9152),
    [anon_sym_COLON_QMARK] = ACTIONS(9152),
    [anon_sym_COLON_DASH] = ACTIONS(9152),
    [anon_sym_PERCENT] = ACTIONS(9152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3646] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_fi] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5597),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3647] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9150),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3648] = {
    [sym_concatenation] = STATE(3902),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3902),
    [anon_sym_RBRACE] = ACTIONS(9148),
    [anon_sym_EQ] = ACTIONS(9156),
    [anon_sym_DASH] = ACTIONS(9156),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9158),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9156),
    [anon_sym_COLON_QMARK] = ACTIONS(9156),
    [anon_sym_COLON_DASH] = ACTIONS(9156),
    [anon_sym_PERCENT] = ACTIONS(9156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3649] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9148),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3650] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_fi] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3651] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9160),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3652] = {
    [aux_sym_concatenation_repeat1] = STATE(3652),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(8395),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_fi] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3653] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_fi] = ACTIONS(4354),
    [anon_sym_elif] = ACTIONS(4354),
    [anon_sym_else] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4354),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [3654] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_fi] = ACTIONS(5545),
    [anon_sym_elif] = ACTIONS(5545),
    [anon_sym_else] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3655] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_fi] = ACTIONS(5553),
    [anon_sym_elif] = ACTIONS(5553),
    [anon_sym_else] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3656] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9162),
    [sym_comment] = ACTIONS(57),
  },
  [3657] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9164),
    [sym_comment] = ACTIONS(57),
  },
  [3658] = {
    [anon_sym_RBRACE] = ACTIONS(9164),
    [sym_comment] = ACTIONS(57),
  },
  [3659] = {
    [sym_concatenation] = STATE(3907),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3907),
    [anon_sym_RBRACE] = ACTIONS(9166),
    [anon_sym_EQ] = ACTIONS(9168),
    [anon_sym_DASH] = ACTIONS(9168),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9168),
    [anon_sym_COLON_QMARK] = ACTIONS(9168),
    [anon_sym_COLON_DASH] = ACTIONS(9168),
    [anon_sym_PERCENT] = ACTIONS(9168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3660] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_fi] = ACTIONS(5597),
    [anon_sym_elif] = ACTIONS(5597),
    [anon_sym_else] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3661] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9166),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3662] = {
    [sym_concatenation] = STATE(3908),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3908),
    [anon_sym_RBRACE] = ACTIONS(9164),
    [anon_sym_EQ] = ACTIONS(9172),
    [anon_sym_DASH] = ACTIONS(9172),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9172),
    [anon_sym_COLON_QMARK] = ACTIONS(9172),
    [anon_sym_COLON_DASH] = ACTIONS(9172),
    [anon_sym_PERCENT] = ACTIONS(9172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3663] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9164),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3664] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_fi] = ACTIONS(5642),
    [anon_sym_elif] = ACTIONS(5642),
    [anon_sym_else] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3665] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9176),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3666] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_fi] = ACTIONS(5545),
    [anon_sym_elif] = ACTIONS(5545),
    [anon_sym_else] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3667] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_fi] = ACTIONS(5553),
    [anon_sym_elif] = ACTIONS(5553),
    [anon_sym_else] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3668] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9178),
    [sym_comment] = ACTIONS(57),
  },
  [3669] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9180),
    [sym_comment] = ACTIONS(57),
  },
  [3670] = {
    [anon_sym_RBRACE] = ACTIONS(9180),
    [sym_comment] = ACTIONS(57),
  },
  [3671] = {
    [sym_concatenation] = STATE(3913),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3913),
    [anon_sym_RBRACE] = ACTIONS(9182),
    [anon_sym_EQ] = ACTIONS(9184),
    [anon_sym_DASH] = ACTIONS(9184),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9186),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9184),
    [anon_sym_COLON_QMARK] = ACTIONS(9184),
    [anon_sym_COLON_DASH] = ACTIONS(9184),
    [anon_sym_PERCENT] = ACTIONS(9184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3672] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_fi] = ACTIONS(5597),
    [anon_sym_elif] = ACTIONS(5597),
    [anon_sym_else] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3673] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9182),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3674] = {
    [sym_concatenation] = STATE(3914),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3914),
    [anon_sym_RBRACE] = ACTIONS(9180),
    [anon_sym_EQ] = ACTIONS(9188),
    [anon_sym_DASH] = ACTIONS(9188),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9188),
    [anon_sym_COLON_QMARK] = ACTIONS(9188),
    [anon_sym_COLON_DASH] = ACTIONS(9188),
    [anon_sym_PERCENT] = ACTIONS(9188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3675] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9180),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3676] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_fi] = ACTIONS(5642),
    [anon_sym_elif] = ACTIONS(5642),
    [anon_sym_else] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3677] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3678] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_fi] = ACTIONS(7045),
    [anon_sym_elif] = ACTIONS(7045),
    [anon_sym_else] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7045),
    [anon_sym_EQ_EQ] = ACTIONS(7045),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3679] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_fi] = ACTIONS(7049),
    [anon_sym_elif] = ACTIONS(7049),
    [anon_sym_else] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7049),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3680] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_fi] = ACTIONS(7053),
    [anon_sym_elif] = ACTIONS(7053),
    [anon_sym_else] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_EQ_EQ] = ACTIONS(7053),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3681] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3682] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9196),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3683] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_fi] = ACTIONS(7089),
    [anon_sym_elif] = ACTIONS(7089),
    [anon_sym_else] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7089),
    [anon_sym_EQ_EQ] = ACTIONS(7089),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3684] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_esac] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [3685] = {
    [sym_concatenation] = STATE(3919),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(3919),
    [anon_sym_RPAREN] = ACTIONS(9198),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [3686] = {
    [aux_sym_concatenation_repeat1] = STATE(3921),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(9200),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_esac] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [3687] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(3924),
    [anon_sym_DQUOTE] = ACTIONS(9202),
    [anon_sym_DOLLAR] = ACTIONS(9204),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3688] = {
    [sym_string] = STATE(3926),
    [anon_sym_DASH] = ACTIONS(9206),
    [anon_sym_DQUOTE] = ACTIONS(8691),
    [anon_sym_DOLLAR] = ACTIONS(9206),
    [sym_raw_string] = ACTIONS(9208),
    [anon_sym_POUND] = ACTIONS(9206),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9210),
    [anon_sym_STAR] = ACTIONS(9212),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_0] = ACTIONS(9210),
    [anon_sym__] = ACTIONS(9210),
  },
  [3689] = {
    [aux_sym_concatenation_repeat1] = STATE(3921),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(9200),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_esac] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [3690] = {
    [sym_subscript] = STATE(3931),
    [sym_variable_name] = ACTIONS(9214),
    [anon_sym_BANG] = ACTIONS(9216),
    [anon_sym_DASH] = ACTIONS(9218),
    [anon_sym_DOLLAR] = ACTIONS(9218),
    [anon_sym_POUND] = ACTIONS(9216),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9220),
    [anon_sym_STAR] = ACTIONS(9222),
    [anon_sym_AT] = ACTIONS(9222),
    [anon_sym_QMARK] = ACTIONS(9222),
    [anon_sym_0] = ACTIONS(9220),
    [anon_sym__] = ACTIONS(9220),
  },
  [3691] = {
    [sym__statements] = STATE(3932),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(3933),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3692] = {
    [sym__statements] = STATE(3934),
    [sym_redirected_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_c_style_for_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_function_definition] = STATE(214),
    [sym_compound_statement] = STATE(214),
    [sym_subshell] = STATE(214),
    [sym_pipeline] = STATE(214),
    [sym_list] = STATE(214),
    [sym_negated_command] = STATE(214),
    [sym_test_command] = STATE(214),
    [sym_declaration_command] = STATE(214),
    [sym_unset_command] = STATE(214),
    [sym_command] = STATE(214),
    [sym_command_name] = STATE(215),
    [sym_variable_assignment] = STATE(216),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(219),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(219),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3693] = {
    [sym__statements] = STATE(3935),
    [sym_redirected_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_c_style_for_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_case_statement] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_compound_statement] = STATE(101),
    [sym_subshell] = STATE(101),
    [sym_pipeline] = STATE(101),
    [sym_list] = STATE(101),
    [sym_negated_command] = STATE(101),
    [sym_test_command] = STATE(101),
    [sym_declaration_command] = STATE(101),
    [sym_unset_command] = STATE(101),
    [sym_command] = STATE(101),
    [sym_command_name] = STATE(102),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(104),
    [sym_file_redirect] = STATE(106),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(105),
    [aux_sym_command_repeat1] = STATE(106),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3694] = {
    [sym_concatenation] = STATE(3936),
    [sym_string] = STATE(3939),
    [sym_array] = STATE(3936),
    [sym_simple_expansion] = STATE(3939),
    [sym_string_expansion] = STATE(3939),
    [sym_expansion] = STATE(3939),
    [sym_command_substitution] = STATE(3939),
    [sym_process_substitution] = STATE(3939),
    [sym__empty_value] = ACTIONS(9224),
    [anon_sym_LPAREN] = ACTIONS(9226),
    [sym__special_characters] = ACTIONS(9228),
    [anon_sym_DQUOTE] = ACTIONS(7909),
    [anon_sym_DOLLAR] = ACTIONS(7911),
    [sym_raw_string] = ACTIONS(9230),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7917),
    [anon_sym_BQUOTE] = ACTIONS(7919),
    [anon_sym_LT_LPAREN] = ACTIONS(7921),
    [anon_sym_GT_LPAREN] = ACTIONS(7921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9230),
  },
  [3695] = {
    [sym_string] = STATE(3940),
    [sym_simple_expansion] = STATE(3940),
    [sym_string_expansion] = STATE(3940),
    [sym_expansion] = STATE(3940),
    [sym_command_substitution] = STATE(3940),
    [sym_process_substitution] = STATE(3940),
    [sym__special_characters] = ACTIONS(9232),
    [anon_sym_DQUOTE] = ACTIONS(7909),
    [anon_sym_DOLLAR] = ACTIONS(7911),
    [sym_raw_string] = ACTIONS(9232),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7917),
    [anon_sym_BQUOTE] = ACTIONS(7919),
    [anon_sym_LT_LPAREN] = ACTIONS(7921),
    [anon_sym_GT_LPAREN] = ACTIONS(7921),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9232),
  },
  [3696] = {
    [aux_sym_concatenation_repeat1] = STATE(3941),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(8707),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_esac] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [3697] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_esac] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [3698] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(9234),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3699] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(9234),
    [anon_sym_DOLLAR] = ACTIONS(9236),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3700] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_esac] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [3701] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [3702] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [3703] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(9238),
    [sym_comment] = ACTIONS(57),
  },
  [3704] = {
    [sym_subscript] = STATE(3947),
    [sym_variable_name] = ACTIONS(9240),
    [anon_sym_DASH] = ACTIONS(9242),
    [anon_sym_DOLLAR] = ACTIONS(9242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9244),
    [anon_sym_STAR] = ACTIONS(9246),
    [anon_sym_AT] = ACTIONS(9246),
    [anon_sym_QMARK] = ACTIONS(9246),
    [anon_sym_0] = ACTIONS(9244),
    [anon_sym__] = ACTIONS(9244),
  },
  [3705] = {
    [sym_concatenation] = STATE(3950),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3950),
    [anon_sym_RBRACE] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(9250),
    [anon_sym_DASH] = ACTIONS(9250),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9252),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9254),
    [anon_sym_COLON] = ACTIONS(9250),
    [anon_sym_COLON_QMARK] = ACTIONS(9250),
    [anon_sym_COLON_DASH] = ACTIONS(9250),
    [anon_sym_PERCENT] = ACTIONS(9250),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3706] = {
    [sym_concatenation] = STATE(3953),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3953),
    [anon_sym_RBRACE] = ACTIONS(9256),
    [anon_sym_EQ] = ACTIONS(9258),
    [anon_sym_DASH] = ACTIONS(9258),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9262),
    [anon_sym_COLON] = ACTIONS(9258),
    [anon_sym_COLON_QMARK] = ACTIONS(9258),
    [anon_sym_COLON_DASH] = ACTIONS(9258),
    [anon_sym_PERCENT] = ACTIONS(9258),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3707] = {
    [anon_sym_RPAREN] = ACTIONS(9264),
    [sym_comment] = ACTIONS(57),
  },
  [3708] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9264),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3709] = {
    [anon_sym_BQUOTE] = ACTIONS(9264),
    [sym_comment] = ACTIONS(57),
  },
  [3710] = {
    [anon_sym_RPAREN] = ACTIONS(9266),
    [sym_comment] = ACTIONS(57),
  },
  [3711] = {
    [sym_variable_assignment] = STATE(3711),
    [sym_subscript] = STATE(3357),
    [sym_concatenation] = STATE(3711),
    [sym_string] = STATE(3352),
    [sym_simple_expansion] = STATE(3352),
    [sym_string_expansion] = STATE(3352),
    [sym_expansion] = STATE(3352),
    [sym_command_substitution] = STATE(3352),
    [sym_process_substitution] = STATE(3352),
    [aux_sym_declaration_command_repeat1] = STATE(3711),
    [sym__simple_heredoc_body] = ACTIONS(2163),
    [sym__heredoc_body_beginning] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2163),
    [sym_variable_name] = ACTIONS(9268),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_esac] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [sym__special_characters] = ACTIONS(9271),
    [anon_sym_DQUOTE] = ACTIONS(9274),
    [anon_sym_DOLLAR] = ACTIONS(9277),
    [sym_raw_string] = ACTIONS(9280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9286),
    [anon_sym_BQUOTE] = ACTIONS(9289),
    [anon_sym_LT_LPAREN] = ACTIONS(9292),
    [anon_sym_GT_LPAREN] = ACTIONS(9292),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9295),
    [sym_word] = ACTIONS(9298),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [3712] = {
    [sym_string] = STATE(3956),
    [sym_simple_expansion] = STATE(3956),
    [sym_string_expansion] = STATE(3956),
    [sym_expansion] = STATE(3956),
    [sym_command_substitution] = STATE(3956),
    [sym_process_substitution] = STATE(3956),
    [sym__special_characters] = ACTIONS(9301),
    [anon_sym_DQUOTE] = ACTIONS(7929),
    [anon_sym_DOLLAR] = ACTIONS(7931),
    [sym_raw_string] = ACTIONS(9301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7935),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7937),
    [anon_sym_BQUOTE] = ACTIONS(7939),
    [anon_sym_LT_LPAREN] = ACTIONS(7941),
    [anon_sym_GT_LPAREN] = ACTIONS(7941),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9301),
  },
  [3713] = {
    [aux_sym_concatenation_repeat1] = STATE(3957),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(8733),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_esac] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [3714] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_esac] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1055),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [3715] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(9303),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3716] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(9303),
    [anon_sym_DOLLAR] = ACTIONS(9305),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3717] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_esac] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [3718] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [3719] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [3720] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(9307),
    [sym_comment] = ACTIONS(57),
  },
  [3721] = {
    [sym_subscript] = STATE(3963),
    [sym_variable_name] = ACTIONS(9309),
    [anon_sym_DASH] = ACTIONS(9311),
    [anon_sym_DOLLAR] = ACTIONS(9311),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9313),
    [anon_sym_STAR] = ACTIONS(9315),
    [anon_sym_AT] = ACTIONS(9315),
    [anon_sym_QMARK] = ACTIONS(9315),
    [anon_sym_0] = ACTIONS(9313),
    [anon_sym__] = ACTIONS(9313),
  },
  [3722] = {
    [sym_concatenation] = STATE(3966),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3966),
    [anon_sym_RBRACE] = ACTIONS(9317),
    [anon_sym_EQ] = ACTIONS(9319),
    [anon_sym_DASH] = ACTIONS(9319),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9323),
    [anon_sym_COLON] = ACTIONS(9319),
    [anon_sym_COLON_QMARK] = ACTIONS(9319),
    [anon_sym_COLON_DASH] = ACTIONS(9319),
    [anon_sym_PERCENT] = ACTIONS(9319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3723] = {
    [sym_concatenation] = STATE(3969),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3969),
    [anon_sym_RBRACE] = ACTIONS(9325),
    [anon_sym_EQ] = ACTIONS(9327),
    [anon_sym_DASH] = ACTIONS(9327),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9331),
    [anon_sym_COLON] = ACTIONS(9327),
    [anon_sym_COLON_QMARK] = ACTIONS(9327),
    [anon_sym_COLON_DASH] = ACTIONS(9327),
    [anon_sym_PERCENT] = ACTIONS(9327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3724] = {
    [anon_sym_RPAREN] = ACTIONS(9333),
    [sym_comment] = ACTIONS(57),
  },
  [3725] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9333),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3726] = {
    [anon_sym_BQUOTE] = ACTIONS(9333),
    [sym_comment] = ACTIONS(57),
  },
  [3727] = {
    [anon_sym_RPAREN] = ACTIONS(9335),
    [sym_comment] = ACTIONS(57),
  },
  [3728] = {
    [sym_concatenation] = STATE(3728),
    [sym_string] = STATE(3362),
    [sym_simple_expansion] = STATE(3362),
    [sym_string_expansion] = STATE(3362),
    [sym_expansion] = STATE(3362),
    [sym_command_substitution] = STATE(3362),
    [sym_process_substitution] = STATE(3362),
    [aux_sym_unset_command_repeat1] = STATE(3728),
    [sym__simple_heredoc_body] = ACTIONS(2236),
    [sym__heredoc_body_beginning] = ACTIONS(2236),
    [sym_file_descriptor] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_esac] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [anon_sym_PIPE_AMP] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_AMP] = ACTIONS(2236),
    [anon_sym_GT_AMP] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(2236),
    [anon_sym_LT_LT_LT] = ACTIONS(2236),
    [sym__special_characters] = ACTIONS(9337),
    [anon_sym_DQUOTE] = ACTIONS(9340),
    [anon_sym_DOLLAR] = ACTIONS(9343),
    [sym_raw_string] = ACTIONS(9346),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9352),
    [anon_sym_BQUOTE] = ACTIONS(9355),
    [anon_sym_LT_LPAREN] = ACTIONS(9358),
    [anon_sym_GT_LPAREN] = ACTIONS(9358),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9361),
    [sym_word] = ACTIONS(9364),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2238),
  },
  [3729] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3730] = {
    [aux_sym_concatenation_repeat1] = STATE(3730),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(9367),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_EQ_TILDE] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3731] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_esac] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_EQ_TILDE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3732] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(9370),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3733] = {
    [sym_concatenation] = STATE(3976),
    [sym_string] = STATE(3975),
    [sym_simple_expansion] = STATE(3975),
    [sym_string_expansion] = STATE(3975),
    [sym_expansion] = STATE(3975),
    [sym_command_substitution] = STATE(3975),
    [sym_process_substitution] = STATE(3975),
    [anon_sym_RBRACE] = ACTIONS(9372),
    [sym__special_characters] = ACTIONS(9374),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9376),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9376),
  },
  [3734] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(9378),
    [sym_comment] = ACTIONS(57),
  },
  [3735] = {
    [sym_concatenation] = STATE(3980),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3980),
    [anon_sym_RBRACE] = ACTIONS(9380),
    [anon_sym_EQ] = ACTIONS(9382),
    [anon_sym_DASH] = ACTIONS(9382),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9384),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9386),
    [anon_sym_COLON] = ACTIONS(9382),
    [anon_sym_COLON_QMARK] = ACTIONS(9382),
    [anon_sym_COLON_DASH] = ACTIONS(9382),
    [anon_sym_PERCENT] = ACTIONS(9382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3736] = {
    [sym_concatenation] = STATE(3982),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3982),
    [anon_sym_RBRACE] = ACTIONS(9372),
    [anon_sym_EQ] = ACTIONS(9388),
    [anon_sym_DASH] = ACTIONS(9388),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9392),
    [anon_sym_COLON] = ACTIONS(9388),
    [anon_sym_COLON_QMARK] = ACTIONS(9388),
    [anon_sym_COLON_DASH] = ACTIONS(9388),
    [anon_sym_PERCENT] = ACTIONS(9388),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3737] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_esac] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_EQ_TILDE] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3738] = {
    [sym_concatenation] = STATE(3985),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3985),
    [sym_regex] = ACTIONS(9394),
    [anon_sym_RBRACE] = ACTIONS(9396),
    [anon_sym_EQ] = ACTIONS(9398),
    [anon_sym_DASH] = ACTIONS(9398),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9398),
    [anon_sym_COLON_QMARK] = ACTIONS(9398),
    [anon_sym_COLON_DASH] = ACTIONS(9398),
    [anon_sym_PERCENT] = ACTIONS(9398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3739] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9396),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3740] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_esac] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_EQ_TILDE] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3741] = {
    [sym_concatenation] = STATE(3982),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(3982),
    [sym_regex] = ACTIONS(9402),
    [anon_sym_RBRACE] = ACTIONS(9372),
    [anon_sym_EQ] = ACTIONS(9388),
    [anon_sym_DASH] = ACTIONS(9388),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9388),
    [anon_sym_COLON_QMARK] = ACTIONS(9388),
    [anon_sym_COLON_DASH] = ACTIONS(9388),
    [anon_sym_PERCENT] = ACTIONS(9388),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3742] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9372),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3743] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_esac] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_EQ_TILDE] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3744] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_esac] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_TILDE] = ACTIONS(2504),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3745] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(3988),
    [sym_simple_expansion] = STATE(3988),
    [sym_string_expansion] = STATE(3988),
    [sym_expansion] = STATE(3988),
    [sym_command_substitution] = STATE(3988),
    [sym_process_substitution] = STATE(3988),
    [sym__special_characters] = ACTIONS(9404),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(9406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9406),
  },
  [3746] = {
    [sym_file_redirect] = STATE(3392),
    [sym_heredoc_redirect] = STATE(3392),
    [sym_herestring_redirect] = STATE(3392),
    [aux_sym_redirected_statement_repeat1] = STATE(3392),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_esac] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3747] = {
    [sym_file_redirect] = STATE(3392),
    [sym_heredoc_redirect] = STATE(3392),
    [sym_herestring_redirect] = STATE(3392),
    [aux_sym_redirected_statement_repeat1] = STATE(3392),
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_esac] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3748] = {
    [sym_file_redirect] = STATE(3392),
    [sym_heredoc_redirect] = STATE(3392),
    [sym_herestring_redirect] = STATE(3392),
    [aux_sym_redirected_statement_repeat1] = STATE(3392),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_esac] = ACTIONS(2538),
    [anon_sym_PIPE] = ACTIONS(7979),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(7981),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_GT_GT] = ACTIONS(2538),
    [anon_sym_AMP_GT] = ACTIONS(2540),
    [anon_sym_AMP_GT_GT] = ACTIONS(2538),
    [anon_sym_LT_AMP] = ACTIONS(2538),
    [anon_sym_GT_AMP] = ACTIONS(2538),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [3749] = {
    [sym_file_redirect] = STATE(3392),
    [sym_heredoc_redirect] = STATE(3392),
    [sym_herestring_redirect] = STATE(3392),
    [aux_sym_redirected_statement_repeat1] = STATE(3392),
    [sym__simple_heredoc_body] = ACTIONS(2538),
    [sym__heredoc_body_beginning] = ACTIONS(2538),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_esac] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(7979),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_PIPE_AMP] = ACTIONS(7981),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2540),
    [anon_sym_LT_LT_DASH] = ACTIONS(2538),
    [anon_sym_LT_LT_LT] = ACTIONS(2538),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2540),
  },
  [3750] = {
    [aux_sym_concatenation_repeat1] = STATE(3989),
    [sym__simple_heredoc_body] = ACTIONS(1015),
    [sym__heredoc_body_beginning] = ACTIONS(1015),
    [sym_file_descriptor] = ACTIONS(1015),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_esac] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [3751] = {
    [aux_sym_concatenation_repeat1] = STATE(3989),
    [sym__simple_heredoc_body] = ACTIONS(1033),
    [sym__heredoc_body_beginning] = ACTIONS(1033),
    [sym_file_descriptor] = ACTIONS(1033),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_esac] = ACTIONS(1033),
    [anon_sym_PIPE] = ACTIONS(1035),
    [anon_sym_SEMI_SEMI] = ACTIONS(1033),
    [anon_sym_PIPE_AMP] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_AMP_GT] = ACTIONS(1035),
    [anon_sym_AMP_GT_GT] = ACTIONS(1033),
    [anon_sym_LT_AMP] = ACTIONS(1033),
    [anon_sym_GT_AMP] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_LT_LT_DASH] = ACTIONS(1033),
    [anon_sym_LT_LT_LT] = ACTIONS(1033),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [3752] = {
    [aux_sym_concatenation_repeat1] = STATE(3989),
    [sym__simple_heredoc_body] = ACTIONS(2546),
    [sym__heredoc_body_beginning] = ACTIONS(2546),
    [sym_file_descriptor] = ACTIONS(2546),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_esac] = ACTIONS(2546),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_PIPE_AMP] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2546),
    [anon_sym_AMP_GT] = ACTIONS(2548),
    [anon_sym_AMP_GT_GT] = ACTIONS(2546),
    [anon_sym_LT_AMP] = ACTIONS(2546),
    [anon_sym_GT_AMP] = ACTIONS(2546),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_LT_LT_DASH] = ACTIONS(2546),
    [anon_sym_LT_LT_LT] = ACTIONS(2546),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2548),
  },
  [3753] = {
    [aux_sym_concatenation_repeat1] = STATE(3989),
    [sym__simple_heredoc_body] = ACTIONS(2550),
    [sym__heredoc_body_beginning] = ACTIONS(2550),
    [sym_file_descriptor] = ACTIONS(2550),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_esac] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_SEMI_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE_AMP] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_AMP_GT] = ACTIONS(2552),
    [anon_sym_AMP_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_AMP] = ACTIONS(2550),
    [anon_sym_GT_AMP] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_LT_LT_DASH] = ACTIONS(2550),
    [anon_sym_LT_LT_LT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2552),
  },
  [3754] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_esac] = ACTIONS(6247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2556),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [3755] = {
    [sym_file_redirect] = STATE(3755),
    [sym_heredoc_redirect] = STATE(3755),
    [sym_herestring_redirect] = STATE(3755),
    [aux_sym_redirected_statement_repeat1] = STATE(3755),
    [sym__simple_heredoc_body] = ACTIONS(2560),
    [sym__heredoc_body_beginning] = ACTIONS(2560),
    [sym_file_descriptor] = ACTIONS(9408),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_esac] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(9411),
    [anon_sym_GT] = ACTIONS(9411),
    [anon_sym_GT_GT] = ACTIONS(9414),
    [anon_sym_AMP_GT] = ACTIONS(9411),
    [anon_sym_AMP_GT_GT] = ACTIONS(9414),
    [anon_sym_LT_AMP] = ACTIONS(9414),
    [anon_sym_GT_AMP] = ACTIONS(9414),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(9417),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [3756] = {
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_esac] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [3757] = {
    [aux_sym_concatenation_repeat1] = STATE(3369),
    [sym__simple_heredoc_body] = ACTIONS(2586),
    [sym__heredoc_body_beginning] = ACTIONS(2586),
    [sym_file_descriptor] = ACTIONS(2586),
    [sym__concat] = ACTIONS(7947),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_esac] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE_AMP] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_AMP] = ACTIONS(2586),
    [anon_sym_GT_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LT_LT_DASH] = ACTIONS(2586),
    [anon_sym_LT_LT_LT] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2586),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2586),
    [anon_sym_GT_LPAREN] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
    [anon_sym_LF] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [3758] = {
    [aux_sym_concatenation_repeat1] = STATE(3369),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [sym__concat] = ACTIONS(7947),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_esac] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2582),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [anon_sym_LT_LPAREN] = ACTIONS(2582),
    [anon_sym_GT_LPAREN] = ACTIONS(2582),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2584),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [3759] = {
    [sym_concatenation] = STATE(3759),
    [sym_string] = STATE(3395),
    [sym_simple_expansion] = STATE(3395),
    [sym_string_expansion] = STATE(3395),
    [sym_expansion] = STATE(3395),
    [sym_command_substitution] = STATE(3395),
    [sym_process_substitution] = STATE(3395),
    [aux_sym_command_repeat2] = STATE(3759),
    [sym__simple_heredoc_body] = ACTIONS(2582),
    [sym__heredoc_body_beginning] = ACTIONS(2582),
    [sym_file_descriptor] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_esac] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE_AMP] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_EQ_TILDE] = ACTIONS(9420),
    [anon_sym_EQ_EQ] = ACTIONS(9420),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_AMP] = ACTIONS(2582),
    [anon_sym_GT_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2582),
    [anon_sym_LT_LT_LT] = ACTIONS(2582),
    [sym__special_characters] = ACTIONS(9423),
    [anon_sym_DQUOTE] = ACTIONS(9426),
    [anon_sym_DOLLAR] = ACTIONS(9429),
    [sym_raw_string] = ACTIONS(9432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9438),
    [anon_sym_BQUOTE] = ACTIONS(9441),
    [anon_sym_LT_LPAREN] = ACTIONS(9444),
    [anon_sym_GT_LPAREN] = ACTIONS(9444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9447),
    [anon_sym_LF] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2584),
  },
  [3760] = {
    [sym_file_descriptor] = ACTIONS(1227),
    [sym_variable_name] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_esac] = ACTIONS(6247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2556),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_typeset] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1231),
    [anon_sym_local] = ACTIONS(1231),
    [anon_sym_unset] = ACTIONS(1231),
    [anon_sym_unsetenv] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_AMP] = ACTIONS(1227),
    [anon_sym_GT_AMP] = ACTIONS(1227),
    [sym__special_characters] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LT_LPAREN] = ACTIONS(1227),
    [anon_sym_GT_LPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1231),
  },
  [3761] = {
    [anon_sym_SEMI] = ACTIONS(9450),
    [anon_sym_esac] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2556),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9452),
    [anon_sym_AMP] = ACTIONS(9452),
  },
  [3762] = {
    [sym_concatenation] = STATE(3759),
    [sym_string] = STATE(3395),
    [sym_simple_expansion] = STATE(3395),
    [sym_string_expansion] = STATE(3395),
    [sym_expansion] = STATE(3395),
    [sym_command_substitution] = STATE(3395),
    [sym_process_substitution] = STATE(3395),
    [aux_sym_command_repeat2] = STATE(3759),
    [sym__simple_heredoc_body] = ACTIONS(2646),
    [sym__heredoc_body_beginning] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_esac] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(7993),
    [anon_sym_EQ_EQ] = ACTIONS(7993),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2646),
    [sym__special_characters] = ACTIONS(7995),
    [anon_sym_DQUOTE] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [sym_raw_string] = ACTIONS(7997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6723),
    [anon_sym_LT_LPAREN] = ACTIONS(6725),
    [anon_sym_GT_LPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7999),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [3763] = {
    [anon_sym_esac] = ACTIONS(9454),
    [sym__special_characters] = ACTIONS(9456),
    [anon_sym_DQUOTE] = ACTIONS(9456),
    [anon_sym_DOLLAR] = ACTIONS(9458),
    [sym_raw_string] = ACTIONS(9456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9456),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9456),
    [anon_sym_BQUOTE] = ACTIONS(9456),
    [anon_sym_LT_LPAREN] = ACTIONS(9456),
    [anon_sym_GT_LPAREN] = ACTIONS(9456),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9458),
  },
  [3764] = {
    [anon_sym_esac] = ACTIONS(9460),
    [sym__special_characters] = ACTIONS(9462),
    [anon_sym_DQUOTE] = ACTIONS(9462),
    [anon_sym_DOLLAR] = ACTIONS(9464),
    [sym_raw_string] = ACTIONS(9462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9462),
    [anon_sym_BQUOTE] = ACTIONS(9462),
    [anon_sym_LT_LPAREN] = ACTIONS(9462),
    [anon_sym_GT_LPAREN] = ACTIONS(9462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9464),
  },
  [3765] = {
    [sym__special_characters] = ACTIONS(7901),
    [anon_sym_DQUOTE] = ACTIONS(7901),
    [anon_sym_DOLLAR] = ACTIONS(7903),
    [sym_raw_string] = ACTIONS(7901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7901),
    [anon_sym_BQUOTE] = ACTIONS(7901),
    [anon_sym_LT_LPAREN] = ACTIONS(7901),
    [anon_sym_GT_LPAREN] = ACTIONS(7901),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7901),
  },
  [3766] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9466),
    [sym_comment] = ACTIONS(57),
  },
  [3767] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_heredoc_body] = STATE(3992),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2642),
    [anon_sym_AMP_GT] = ACTIONS(2640),
    [anon_sym_AMP_GT_GT] = ACTIONS(2642),
    [anon_sym_LT_AMP] = ACTIONS(2642),
    [anon_sym_GT_AMP] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [3768] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_heredoc_body] = STATE(3992),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [3769] = {
    [sym_redirected_statement] = STATE(3993),
    [sym_for_statement] = STATE(3993),
    [sym_c_style_for_statement] = STATE(3993),
    [sym_while_statement] = STATE(3993),
    [sym_if_statement] = STATE(3993),
    [sym_case_statement] = STATE(3993),
    [sym_function_definition] = STATE(3993),
    [sym_compound_statement] = STATE(3993),
    [sym_subshell] = STATE(3993),
    [sym_pipeline] = STATE(3993),
    [sym_list] = STATE(3993),
    [sym_negated_command] = STATE(3993),
    [sym_test_command] = STATE(3993),
    [sym_declaration_command] = STATE(3993),
    [sym_unset_command] = STATE(3993),
    [sym_command] = STATE(3993),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(3994),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(239),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4292),
    [anon_sym_typeset] = ACTIONS(4292),
    [anon_sym_export] = ACTIONS(4292),
    [anon_sym_readonly] = ACTIONS(4292),
    [anon_sym_local] = ACTIONS(4292),
    [anon_sym_unset] = ACTIONS(4294),
    [anon_sym_unsetenv] = ACTIONS(4294),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3770] = {
    [sym__statements] = STATE(3995),
    [sym_redirected_statement] = STATE(3767),
    [sym_for_statement] = STATE(3767),
    [sym_c_style_for_statement] = STATE(3767),
    [sym_while_statement] = STATE(3767),
    [sym_if_statement] = STATE(3767),
    [sym_case_statement] = STATE(3767),
    [sym_function_definition] = STATE(3767),
    [sym_compound_statement] = STATE(3767),
    [sym_subshell] = STATE(3767),
    [sym_pipeline] = STATE(3767),
    [sym_list] = STATE(3767),
    [sym_negated_command] = STATE(3767),
    [sym_test_command] = STATE(3767),
    [sym_declaration_command] = STATE(3767),
    [sym_unset_command] = STATE(3767),
    [sym_command] = STATE(3767),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(3768),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(3769),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(9466),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4292),
    [anon_sym_typeset] = ACTIONS(4292),
    [anon_sym_export] = ACTIONS(4292),
    [anon_sym_readonly] = ACTIONS(4292),
    [anon_sym_local] = ACTIONS(4292),
    [anon_sym_unset] = ACTIONS(4294),
    [anon_sym_unsetenv] = ACTIONS(4294),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3771] = {
    [sym__special_characters] = ACTIONS(8008),
    [anon_sym_DQUOTE] = ACTIONS(8008),
    [anon_sym_DOLLAR] = ACTIONS(8010),
    [sym_raw_string] = ACTIONS(8008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8008),
    [anon_sym_BQUOTE] = ACTIONS(8008),
    [anon_sym_LT_LPAREN] = ACTIONS(8008),
    [anon_sym_GT_LPAREN] = ACTIONS(8008),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8008),
  },
  [3772] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9468),
    [sym_comment] = ACTIONS(57),
  },
  [3773] = {
    [sym__statements] = STATE(3997),
    [sym_redirected_statement] = STATE(3767),
    [sym_for_statement] = STATE(3767),
    [sym_c_style_for_statement] = STATE(3767),
    [sym_while_statement] = STATE(3767),
    [sym_if_statement] = STATE(3767),
    [sym_case_statement] = STATE(3767),
    [sym_function_definition] = STATE(3767),
    [sym_compound_statement] = STATE(3767),
    [sym_subshell] = STATE(3767),
    [sym_pipeline] = STATE(3767),
    [sym_list] = STATE(3767),
    [sym_negated_command] = STATE(3767),
    [sym_test_command] = STATE(3767),
    [sym_declaration_command] = STATE(3767),
    [sym_unset_command] = STATE(3767),
    [sym_command] = STATE(3767),
    [sym_command_name] = STATE(664),
    [sym_variable_assignment] = STATE(3768),
    [sym_subscript] = STATE(217),
    [sym_file_redirect] = STATE(666),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_string_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(3769),
    [aux_sym_command_repeat1] = STATE(666),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(9468),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4292),
    [anon_sym_typeset] = ACTIONS(4292),
    [anon_sym_export] = ACTIONS(4292),
    [anon_sym_readonly] = ACTIONS(4292),
    [anon_sym_local] = ACTIONS(4292),
    [anon_sym_unset] = ACTIONS(4294),
    [anon_sym_unsetenv] = ACTIONS(4294),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3774] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_RBRACE] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7045),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3775] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7049),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3776] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7053),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3777] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9470),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3778] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9472),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3779] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_RBRACE] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7089),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3780] = {
    [sym__simple_heredoc_body] = ACTIONS(8222),
    [sym__heredoc_body_beginning] = ACTIONS(8222),
    [sym_file_descriptor] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_PIPE] = ACTIONS(8224),
    [anon_sym_SEMI_SEMI] = ACTIONS(8222),
    [anon_sym_RBRACE] = ACTIONS(8222),
    [anon_sym_PIPE_AMP] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8222),
    [anon_sym_PIPE_PIPE] = ACTIONS(8222),
    [anon_sym_LT] = ACTIONS(8224),
    [anon_sym_GT] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8222),
    [anon_sym_AMP_GT] = ACTIONS(8224),
    [anon_sym_AMP_GT_GT] = ACTIONS(8222),
    [anon_sym_LT_AMP] = ACTIONS(8222),
    [anon_sym_GT_AMP] = ACTIONS(8222),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_LT_LT_DASH] = ACTIONS(8222),
    [anon_sym_LT_LT_LT] = ACTIONS(8222),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8224),
  },
  [3781] = {
    [sym_do_group] = STATE(4000),
    [sym_compound_statement] = STATE(4000),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3782] = {
    [sym_do_group] = STATE(4000),
    [sym_compound_statement] = STATE(4000),
    [anon_sym_SEMI] = ACTIONS(9474),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3783] = {
    [sym__simple_heredoc_body] = ACTIONS(8849),
    [sym__heredoc_body_beginning] = ACTIONS(8849),
    [sym_file_descriptor] = ACTIONS(8849),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_PIPE] = ACTIONS(8851),
    [anon_sym_SEMI_SEMI] = ACTIONS(8849),
    [anon_sym_RBRACE] = ACTIONS(8849),
    [anon_sym_PIPE_AMP] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8849),
    [anon_sym_PIPE_PIPE] = ACTIONS(8849),
    [anon_sym_LT] = ACTIONS(8851),
    [anon_sym_GT] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8849),
    [anon_sym_AMP_GT] = ACTIONS(8851),
    [anon_sym_AMP_GT_GT] = ACTIONS(8849),
    [anon_sym_LT_AMP] = ACTIONS(8849),
    [anon_sym_GT_AMP] = ACTIONS(8849),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_LT_LT_DASH] = ACTIONS(8849),
    [anon_sym_LT_LT_LT] = ACTIONS(8849),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8849),
    [anon_sym_AMP] = ACTIONS(8851),
  },
  [3784] = {
    [sym__simple_heredoc_body] = ACTIONS(8853),
    [sym__heredoc_body_beginning] = ACTIONS(8853),
    [sym_file_descriptor] = ACTIONS(8853),
    [anon_sym_SEMI] = ACTIONS(8855),
    [anon_sym_PIPE] = ACTIONS(8855),
    [anon_sym_SEMI_SEMI] = ACTIONS(8853),
    [anon_sym_RBRACE] = ACTIONS(8853),
    [anon_sym_PIPE_AMP] = ACTIONS(8853),
    [anon_sym_AMP_AMP] = ACTIONS(8853),
    [anon_sym_PIPE_PIPE] = ACTIONS(8853),
    [anon_sym_LT] = ACTIONS(8855),
    [anon_sym_GT] = ACTIONS(8855),
    [anon_sym_GT_GT] = ACTIONS(8853),
    [anon_sym_AMP_GT] = ACTIONS(8855),
    [anon_sym_AMP_GT_GT] = ACTIONS(8853),
    [anon_sym_LT_AMP] = ACTIONS(8853),
    [anon_sym_GT_AMP] = ACTIONS(8853),
    [anon_sym_LT_LT] = ACTIONS(8855),
    [anon_sym_LT_LT_DASH] = ACTIONS(8853),
    [anon_sym_LT_LT_LT] = ACTIONS(8853),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8853),
    [anon_sym_AMP] = ACTIONS(8855),
  },
  [3785] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_RBRACE] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8164),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3786] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8168),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3787] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_RBRACE] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8164),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3788] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8168),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3789] = {
    [sym__concat] = ACTIONS(7043),
    [anon_sym_RBRACE] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
  },
  [3790] = {
    [sym__concat] = ACTIONS(7047),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
  },
  [3791] = {
    [sym__concat] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
  },
  [3792] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9476),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3793] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9478),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3794] = {
    [sym__concat] = ACTIONS(7087),
    [anon_sym_RBRACE] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
  },
  [3795] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_RBRACE] = ACTIONS(8162),
    [anon_sym_EQ] = ACTIONS(8164),
    [anon_sym_DASH] = ACTIONS(8164),
    [sym__special_characters] = ACTIONS(8164),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_POUND] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_COLON] = ACTIONS(8164),
    [anon_sym_COLON_QMARK] = ACTIONS(8164),
    [anon_sym_COLON_DASH] = ACTIONS(8164),
    [anon_sym_PERCENT] = ACTIONS(8164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(8164),
  },
  [3796] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_DASH] = ACTIONS(8168),
    [sym__special_characters] = ACTIONS(8168),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_POUND] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_COLON] = ACTIONS(8168),
    [anon_sym_COLON_QMARK] = ACTIONS(8168),
    [anon_sym_COLON_DASH] = ACTIONS(8168),
    [anon_sym_PERCENT] = ACTIONS(8168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(8168),
  },
  [3797] = {
    [sym__heredoc_body_middle] = ACTIONS(8162),
    [sym__heredoc_body_end] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
  },
  [3798] = {
    [sym__heredoc_body_middle] = ACTIONS(8166),
    [sym__heredoc_body_end] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
  },
  [3799] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_RPAREN] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8162),
  },
  [3800] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8166),
  },
  [3801] = {
    [sym__simple_heredoc_body] = ACTIONS(9480),
    [sym__heredoc_body_beginning] = ACTIONS(9480),
    [sym_file_descriptor] = ACTIONS(9480),
    [ts_builtin_sym_end] = ACTIONS(9480),
    [anon_sym_SEMI] = ACTIONS(9482),
    [anon_sym_done] = ACTIONS(9480),
    [anon_sym_fi] = ACTIONS(9480),
    [anon_sym_elif] = ACTIONS(9480),
    [anon_sym_else] = ACTIONS(9480),
    [anon_sym_esac] = ACTIONS(9480),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_RPAREN] = ACTIONS(9480),
    [anon_sym_SEMI_SEMI] = ACTIONS(9480),
    [anon_sym_PIPE_AMP] = ACTIONS(9480),
    [anon_sym_AMP_AMP] = ACTIONS(9480),
    [anon_sym_PIPE_PIPE] = ACTIONS(9480),
    [anon_sym_LT] = ACTIONS(9482),
    [anon_sym_GT] = ACTIONS(9482),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_AMP_GT] = ACTIONS(9482),
    [anon_sym_AMP_GT_GT] = ACTIONS(9480),
    [anon_sym_LT_AMP] = ACTIONS(9480),
    [anon_sym_GT_AMP] = ACTIONS(9480),
    [anon_sym_LT_LT] = ACTIONS(9482),
    [anon_sym_LT_LT_DASH] = ACTIONS(9480),
    [anon_sym_LT_LT_LT] = ACTIONS(9480),
    [anon_sym_BQUOTE] = ACTIONS(9480),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9480),
    [anon_sym_AMP] = ACTIONS(9482),
  },
  [3802] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8162),
  },
  [3803] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8166),
  },
  [3804] = {
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3805] = {
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3806] = {
    [sym_file_descriptor] = ACTIONS(8917),
    [anon_sym_SEMI] = ACTIONS(8919),
    [anon_sym_PIPE] = ACTIONS(8919),
    [anon_sym_SEMI_SEMI] = ACTIONS(8917),
    [anon_sym_PIPE_AMP] = ACTIONS(8917),
    [anon_sym_AMP_AMP] = ACTIONS(8917),
    [anon_sym_PIPE_PIPE] = ACTIONS(8917),
    [anon_sym_LT] = ACTIONS(8919),
    [anon_sym_GT] = ACTIONS(8919),
    [anon_sym_GT_GT] = ACTIONS(8917),
    [anon_sym_AMP_GT] = ACTIONS(8919),
    [anon_sym_AMP_GT_GT] = ACTIONS(8917),
    [anon_sym_LT_AMP] = ACTIONS(8917),
    [anon_sym_GT_AMP] = ACTIONS(8917),
    [anon_sym_LT_LT] = ACTIONS(8919),
    [anon_sym_LT_LT_DASH] = ACTIONS(8917),
    [anon_sym_LT_LT_LT] = ACTIONS(8917),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8917),
    [anon_sym_AMP] = ACTIONS(8919),
  },
  [3807] = {
    [sym_do_group] = STATE(4004),
    [sym_compound_statement] = STATE(4004),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3808] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_done] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3809] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_done] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3810] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9484),
    [sym_comment] = ACTIONS(57),
  },
  [3811] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [sym_comment] = ACTIONS(57),
  },
  [3812] = {
    [anon_sym_RBRACE] = ACTIONS(9486),
    [sym_comment] = ACTIONS(57),
  },
  [3813] = {
    [sym_concatenation] = STATE(4008),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4008),
    [anon_sym_RBRACE] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9490),
    [anon_sym_DASH] = ACTIONS(9490),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9490),
    [anon_sym_COLON_QMARK] = ACTIONS(9490),
    [anon_sym_COLON_DASH] = ACTIONS(9490),
    [anon_sym_PERCENT] = ACTIONS(9490),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3814] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_done] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3815] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3816] = {
    [sym_concatenation] = STATE(4009),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4009),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_EQ] = ACTIONS(9494),
    [anon_sym_DASH] = ACTIONS(9494),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9496),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9494),
    [anon_sym_COLON_QMARK] = ACTIONS(9494),
    [anon_sym_COLON_DASH] = ACTIONS(9494),
    [anon_sym_PERCENT] = ACTIONS(9494),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3817] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3818] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_done] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3819] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9498),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3820] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_done] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3821] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_done] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3822] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_done] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3823] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9500),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3824] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9502),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3825] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_done] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3826] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_done] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3827] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_done] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3828] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_done] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3829] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9504),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3830] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3831] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_done] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3832] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_done] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8164),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3833] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_done] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3834] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_done] = ACTIONS(5543),
    [anon_sym_fi] = ACTIONS(5543),
    [anon_sym_elif] = ACTIONS(5543),
    [anon_sym_else] = ACTIONS(5543),
    [anon_sym_esac] = ACTIONS(5543),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3835] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_done] = ACTIONS(5551),
    [anon_sym_fi] = ACTIONS(5551),
    [anon_sym_elif] = ACTIONS(5551),
    [anon_sym_else] = ACTIONS(5551),
    [anon_sym_esac] = ACTIONS(5551),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3836] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9508),
    [sym_comment] = ACTIONS(57),
  },
  [3837] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9510),
    [sym_comment] = ACTIONS(57),
  },
  [3838] = {
    [anon_sym_RBRACE] = ACTIONS(9510),
    [sym_comment] = ACTIONS(57),
  },
  [3839] = {
    [sym_concatenation] = STATE(4018),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4018),
    [anon_sym_RBRACE] = ACTIONS(9512),
    [anon_sym_EQ] = ACTIONS(9514),
    [anon_sym_DASH] = ACTIONS(9514),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9514),
    [anon_sym_COLON_QMARK] = ACTIONS(9514),
    [anon_sym_COLON_DASH] = ACTIONS(9514),
    [anon_sym_PERCENT] = ACTIONS(9514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3840] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_done] = ACTIONS(5595),
    [anon_sym_fi] = ACTIONS(5595),
    [anon_sym_elif] = ACTIONS(5595),
    [anon_sym_else] = ACTIONS(5595),
    [anon_sym_esac] = ACTIONS(5595),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3841] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9512),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3842] = {
    [sym_concatenation] = STATE(4019),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4019),
    [anon_sym_RBRACE] = ACTIONS(9510),
    [anon_sym_EQ] = ACTIONS(9518),
    [anon_sym_DASH] = ACTIONS(9518),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9518),
    [anon_sym_COLON_QMARK] = ACTIONS(9518),
    [anon_sym_COLON_DASH] = ACTIONS(9518),
    [anon_sym_PERCENT] = ACTIONS(9518),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3843] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9510),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3844] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_done] = ACTIONS(5640),
    [anon_sym_fi] = ACTIONS(5640),
    [anon_sym_elif] = ACTIONS(5640),
    [anon_sym_else] = ACTIONS(5640),
    [anon_sym_esac] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3845] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9522),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3846] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_fi] = ACTIONS(5545),
    [anon_sym_elif] = ACTIONS(5545),
    [anon_sym_else] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3847] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_fi] = ACTIONS(5553),
    [anon_sym_elif] = ACTIONS(5553),
    [anon_sym_else] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3848] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9524),
    [sym_comment] = ACTIONS(57),
  },
  [3849] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9526),
    [sym_comment] = ACTIONS(57),
  },
  [3850] = {
    [anon_sym_RBRACE] = ACTIONS(9526),
    [sym_comment] = ACTIONS(57),
  },
  [3851] = {
    [sym_concatenation] = STATE(4024),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4024),
    [anon_sym_RBRACE] = ACTIONS(9528),
    [anon_sym_EQ] = ACTIONS(9530),
    [anon_sym_DASH] = ACTIONS(9530),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9530),
    [anon_sym_COLON_QMARK] = ACTIONS(9530),
    [anon_sym_COLON_DASH] = ACTIONS(9530),
    [anon_sym_PERCENT] = ACTIONS(9530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3852] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_fi] = ACTIONS(5597),
    [anon_sym_elif] = ACTIONS(5597),
    [anon_sym_else] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3853] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9528),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3854] = {
    [sym_concatenation] = STATE(4025),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4025),
    [anon_sym_RBRACE] = ACTIONS(9526),
    [anon_sym_EQ] = ACTIONS(9534),
    [anon_sym_DASH] = ACTIONS(9534),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9534),
    [anon_sym_COLON_QMARK] = ACTIONS(9534),
    [anon_sym_COLON_DASH] = ACTIONS(9534),
    [anon_sym_PERCENT] = ACTIONS(9534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3855] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9526),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3856] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_fi] = ACTIONS(5642),
    [anon_sym_elif] = ACTIONS(5642),
    [anon_sym_else] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3857] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9538),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3858] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_fi] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3859] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_fi] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3860] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9540),
    [sym_comment] = ACTIONS(57),
  },
  [3861] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9542),
    [sym_comment] = ACTIONS(57),
  },
  [3862] = {
    [anon_sym_RBRACE] = ACTIONS(9542),
    [sym_comment] = ACTIONS(57),
  },
  [3863] = {
    [sym_concatenation] = STATE(4031),
    [sym_string] = STATE(4030),
    [sym_simple_expansion] = STATE(4030),
    [sym_string_expansion] = STATE(4030),
    [sym_expansion] = STATE(4030),
    [sym_command_substitution] = STATE(4030),
    [sym_process_substitution] = STATE(4030),
    [anon_sym_RBRACE] = ACTIONS(9542),
    [sym__special_characters] = ACTIONS(9544),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9546),
  },
  [3864] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_fi] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3865] = {
    [sym_concatenation] = STATE(4034),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4034),
    [sym_regex] = ACTIONS(9548),
    [anon_sym_RBRACE] = ACTIONS(9550),
    [anon_sym_EQ] = ACTIONS(9552),
    [anon_sym_DASH] = ACTIONS(9552),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9552),
    [anon_sym_COLON_QMARK] = ACTIONS(9552),
    [anon_sym_COLON_DASH] = ACTIONS(9552),
    [anon_sym_PERCENT] = ACTIONS(9552),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3866] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9550),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3867] = {
    [sym_concatenation] = STATE(4036),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4036),
    [sym_regex] = ACTIONS(9556),
    [anon_sym_RBRACE] = ACTIONS(9542),
    [anon_sym_EQ] = ACTIONS(9558),
    [anon_sym_DASH] = ACTIONS(9558),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9558),
    [anon_sym_COLON_QMARK] = ACTIONS(9558),
    [anon_sym_COLON_DASH] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3868] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9542),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3869] = {
    [sym_concatenation] = STATE(4038),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4038),
    [anon_sym_RBRACE] = ACTIONS(9562),
    [anon_sym_EQ] = ACTIONS(9564),
    [anon_sym_DASH] = ACTIONS(9564),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9566),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9564),
    [anon_sym_COLON_QMARK] = ACTIONS(9564),
    [anon_sym_COLON_DASH] = ACTIONS(9564),
    [anon_sym_PERCENT] = ACTIONS(9564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3870] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3871] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9562),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3872] = {
    [sym_concatenation] = STATE(4036),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4036),
    [anon_sym_RBRACE] = ACTIONS(9542),
    [anon_sym_EQ] = ACTIONS(9558),
    [anon_sym_DASH] = ACTIONS(9558),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9558),
    [anon_sym_COLON_QMARK] = ACTIONS(9558),
    [anon_sym_COLON_DASH] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3873] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_fi] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4354),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [3874] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_fi] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3875] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_fi] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3876] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9568),
    [sym_comment] = ACTIONS(57),
  },
  [3877] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9570),
    [sym_comment] = ACTIONS(57),
  },
  [3878] = {
    [anon_sym_RBRACE] = ACTIONS(9570),
    [sym_comment] = ACTIONS(57),
  },
  [3879] = {
    [sym_concatenation] = STATE(4042),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4042),
    [anon_sym_RBRACE] = ACTIONS(9572),
    [anon_sym_EQ] = ACTIONS(9574),
    [anon_sym_DASH] = ACTIONS(9574),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9574),
    [anon_sym_COLON_QMARK] = ACTIONS(9574),
    [anon_sym_COLON_DASH] = ACTIONS(9574),
    [anon_sym_PERCENT] = ACTIONS(9574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3880] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_fi] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3881] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9572),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3882] = {
    [sym_concatenation] = STATE(4043),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4043),
    [anon_sym_RBRACE] = ACTIONS(9570),
    [anon_sym_EQ] = ACTIONS(9578),
    [anon_sym_DASH] = ACTIONS(9578),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9578),
    [anon_sym_COLON_QMARK] = ACTIONS(9578),
    [anon_sym_COLON_DASH] = ACTIONS(9578),
    [anon_sym_PERCENT] = ACTIONS(9578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3883] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9570),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3884] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_fi] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3885] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9582),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3886] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_fi] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [3887] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_fi] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [3888] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9584),
    [sym_comment] = ACTIONS(57),
  },
  [3889] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9586),
    [sym_comment] = ACTIONS(57),
  },
  [3890] = {
    [anon_sym_RBRACE] = ACTIONS(9586),
    [sym_comment] = ACTIONS(57),
  },
  [3891] = {
    [sym_concatenation] = STATE(4048),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4048),
    [anon_sym_RBRACE] = ACTIONS(9588),
    [anon_sym_EQ] = ACTIONS(9590),
    [anon_sym_DASH] = ACTIONS(9590),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9590),
    [anon_sym_COLON_QMARK] = ACTIONS(9590),
    [anon_sym_COLON_DASH] = ACTIONS(9590),
    [anon_sym_PERCENT] = ACTIONS(9590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3892] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_fi] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [3893] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9588),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3894] = {
    [sym_concatenation] = STATE(4049),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4049),
    [anon_sym_RBRACE] = ACTIONS(9586),
    [anon_sym_EQ] = ACTIONS(9594),
    [anon_sym_DASH] = ACTIONS(9594),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9596),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9594),
    [anon_sym_COLON_QMARK] = ACTIONS(9594),
    [anon_sym_COLON_DASH] = ACTIONS(9594),
    [anon_sym_PERCENT] = ACTIONS(9594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3895] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9586),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3896] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_fi] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [3897] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9598),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3898] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_fi] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7045),
    [anon_sym_EQ_EQ] = ACTIONS(7045),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3899] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_fi] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7049),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3900] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_fi] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_EQ_EQ] = ACTIONS(7053),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3901] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9600),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3902] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3903] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_fi] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7089),
    [anon_sym_EQ_EQ] = ACTIONS(7089),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3904] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_fi] = ACTIONS(7045),
    [anon_sym_elif] = ACTIONS(7045),
    [anon_sym_else] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3905] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_fi] = ACTIONS(7049),
    [anon_sym_elif] = ACTIONS(7049),
    [anon_sym_else] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3906] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_fi] = ACTIONS(7053),
    [anon_sym_elif] = ACTIONS(7053),
    [anon_sym_else] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3907] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9604),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3908] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9606),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3909] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_fi] = ACTIONS(7089),
    [anon_sym_elif] = ACTIONS(7089),
    [anon_sym_else] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3910] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_fi] = ACTIONS(7045),
    [anon_sym_elif] = ACTIONS(7045),
    [anon_sym_else] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [3911] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_fi] = ACTIONS(7049),
    [anon_sym_elif] = ACTIONS(7049),
    [anon_sym_else] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [3912] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_fi] = ACTIONS(7053),
    [anon_sym_elif] = ACTIONS(7053),
    [anon_sym_else] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [3913] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3914] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9610),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3915] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_fi] = ACTIONS(7089),
    [anon_sym_elif] = ACTIONS(7089),
    [anon_sym_else] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [3916] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_fi] = ACTIONS(8164),
    [anon_sym_elif] = ACTIONS(8164),
    [anon_sym_else] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8164),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3917] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_fi] = ACTIONS(8168),
    [anon_sym_elif] = ACTIONS(8168),
    [anon_sym_else] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [3918] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_esac] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [3919] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(9612),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [3920] = {
    [sym_string] = STATE(4058),
    [sym_simple_expansion] = STATE(4058),
    [sym_string_expansion] = STATE(4058),
    [sym_expansion] = STATE(4058),
    [sym_command_substitution] = STATE(4058),
    [sym_process_substitution] = STATE(4058),
    [sym__special_characters] = ACTIONS(9614),
    [anon_sym_DQUOTE] = ACTIONS(8691),
    [anon_sym_DOLLAR] = ACTIONS(8693),
    [sym_raw_string] = ACTIONS(9614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8699),
    [anon_sym_BQUOTE] = ACTIONS(8701),
    [anon_sym_LT_LPAREN] = ACTIONS(8703),
    [anon_sym_GT_LPAREN] = ACTIONS(8703),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9614),
  },
  [3921] = {
    [aux_sym_concatenation_repeat1] = STATE(4059),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(9200),
    [sym_variable_name] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_esac] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [3922] = {
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(1053),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_esac] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1055),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [3923] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(9616),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3924] = {
    [sym_simple_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [aux_sym_string_repeat1] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(9616),
    [anon_sym_DOLLAR] = ACTIONS(9618),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3925] = {
    [sym__simple_heredoc_body] = ACTIONS(1087),
    [sym__heredoc_body_beginning] = ACTIONS(1087),
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_esac] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_LT_LT_LT] = ACTIONS(1087),
    [sym__special_characters] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [3926] = {
    [sym__simple_heredoc_body] = ACTIONS(1091),
    [sym__heredoc_body_beginning] = ACTIONS(1091),
    [sym_file_descriptor] = ACTIONS(1091),
    [sym__concat] = ACTIONS(1091),
    [sym_variable_name] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym__special_characters] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1091),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
  },
  [3927] = {
    [sym__simple_heredoc_body] = ACTIONS(1095),
    [sym__heredoc_body_beginning] = ACTIONS(1095),
    [sym_file_descriptor] = ACTIONS(1095),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym__special_characters] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1095),
    [anon_sym_GT_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [3928] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(9620),
    [sym_comment] = ACTIONS(57),
  },
  [3929] = {
    [sym_subscript] = STATE(4065),
    [sym_variable_name] = ACTIONS(9622),
    [anon_sym_DASH] = ACTIONS(9624),
    [anon_sym_DOLLAR] = ACTIONS(9624),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9626),
    [anon_sym_STAR] = ACTIONS(9628),
    [anon_sym_AT] = ACTIONS(9628),
    [anon_sym_QMARK] = ACTIONS(9628),
    [anon_sym_0] = ACTIONS(9626),
    [anon_sym__] = ACTIONS(9626),
  },
  [3930] = {
    [sym_concatenation] = STATE(4068),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4068),
    [anon_sym_RBRACE] = ACTIONS(9630),
    [anon_sym_EQ] = ACTIONS(9632),
    [anon_sym_DASH] = ACTIONS(9632),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9634),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9636),
    [anon_sym_COLON] = ACTIONS(9632),
    [anon_sym_COLON_QMARK] = ACTIONS(9632),
    [anon_sym_COLON_DASH] = ACTIONS(9632),
    [anon_sym_PERCENT] = ACTIONS(9632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3931] = {
    [sym_concatenation] = STATE(4071),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4071),
    [anon_sym_RBRACE] = ACTIONS(9638),
    [anon_sym_EQ] = ACTIONS(9640),
    [anon_sym_DASH] = ACTIONS(9640),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9640),
    [anon_sym_COLON_QMARK] = ACTIONS(9640),
    [anon_sym_COLON_DASH] = ACTIONS(9640),
    [anon_sym_PERCENT] = ACTIONS(9640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3932] = {
    [anon_sym_RPAREN] = ACTIONS(9646),
    [sym_comment] = ACTIONS(57),
  },
  [3933] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9646),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3934] = {
    [anon_sym_BQUOTE] = ACTIONS(9646),
    [sym_comment] = ACTIONS(57),
  },
  [3935] = {
    [anon_sym_RPAREN] = ACTIONS(9648),
    [sym_comment] = ACTIONS(57),
  },
  [3936] = {
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_esac] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [3937] = {
    [sym_concatenation] = STATE(4075),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(4075),
    [anon_sym_RPAREN] = ACTIONS(9650),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [3938] = {
    [aux_sym_concatenation_repeat1] = STATE(3696),
    [sym__simple_heredoc_body] = ACTIONS(1407),
    [sym__heredoc_body_beginning] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1407),
    [sym__concat] = ACTIONS(8707),
    [sym_variable_name] = ACTIONS(1407),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_esac] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [sym__special_characters] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(1411),
    [sym_raw_string] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(1407),
    [anon_sym_GT_LPAREN] = ACTIONS(1407),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1411),
    [sym_word] = ACTIONS(1411),
    [anon_sym_LF] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1411),
  },
  [3939] = {
    [aux_sym_concatenation_repeat1] = STATE(3696),
    [sym__simple_heredoc_body] = ACTIONS(1385),
    [sym__heredoc_body_beginning] = ACTIONS(1385),
    [sym_file_descriptor] = ACTIONS(1385),
    [sym__concat] = ACTIONS(8707),
    [sym_variable_name] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_esac] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_LT] = ACTIONS(1385),
    [sym__special_characters] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [sym_word] = ACTIONS(1387),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [3940] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3941] = {
    [aux_sym_concatenation_repeat1] = STATE(3941),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(9652),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3942] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_esac] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3943] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(9655),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3944] = {
    [sym_concatenation] = STATE(4080),
    [sym_string] = STATE(4079),
    [sym_simple_expansion] = STATE(4079),
    [sym_string_expansion] = STATE(4079),
    [sym_expansion] = STATE(4079),
    [sym_command_substitution] = STATE(4079),
    [sym_process_substitution] = STATE(4079),
    [anon_sym_RBRACE] = ACTIONS(9657),
    [sym__special_characters] = ACTIONS(9659),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9661),
  },
  [3945] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(9663),
    [sym_comment] = ACTIONS(57),
  },
  [3946] = {
    [sym_concatenation] = STATE(4084),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4084),
    [anon_sym_RBRACE] = ACTIONS(9665),
    [anon_sym_EQ] = ACTIONS(9667),
    [anon_sym_DASH] = ACTIONS(9667),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9671),
    [anon_sym_COLON] = ACTIONS(9667),
    [anon_sym_COLON_QMARK] = ACTIONS(9667),
    [anon_sym_COLON_DASH] = ACTIONS(9667),
    [anon_sym_PERCENT] = ACTIONS(9667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3947] = {
    [sym_concatenation] = STATE(4086),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4086),
    [anon_sym_RBRACE] = ACTIONS(9657),
    [anon_sym_EQ] = ACTIONS(9673),
    [anon_sym_DASH] = ACTIONS(9673),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9677),
    [anon_sym_COLON] = ACTIONS(9673),
    [anon_sym_COLON_QMARK] = ACTIONS(9673),
    [anon_sym_COLON_DASH] = ACTIONS(9673),
    [anon_sym_PERCENT] = ACTIONS(9673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3948] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_esac] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3949] = {
    [sym_concatenation] = STATE(4089),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4089),
    [sym_regex] = ACTIONS(9679),
    [anon_sym_RBRACE] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9683),
    [anon_sym_DASH] = ACTIONS(9683),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9685),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9683),
    [anon_sym_COLON_QMARK] = ACTIONS(9683),
    [anon_sym_COLON_DASH] = ACTIONS(9683),
    [anon_sym_PERCENT] = ACTIONS(9683),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3950] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3951] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_esac] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3952] = {
    [sym_concatenation] = STATE(4086),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4086),
    [sym_regex] = ACTIONS(9687),
    [anon_sym_RBRACE] = ACTIONS(9657),
    [anon_sym_EQ] = ACTIONS(9673),
    [anon_sym_DASH] = ACTIONS(9673),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9673),
    [anon_sym_COLON_QMARK] = ACTIONS(9673),
    [anon_sym_COLON_DASH] = ACTIONS(9673),
    [anon_sym_PERCENT] = ACTIONS(9673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3953] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9657),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3954] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_esac] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3955] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_esac] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3956] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3957] = {
    [aux_sym_concatenation_repeat1] = STATE(3957),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(9689),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2308),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [3958] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_esac] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2315),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [3959] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(9692),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [3960] = {
    [sym_concatenation] = STATE(4095),
    [sym_string] = STATE(4094),
    [sym_simple_expansion] = STATE(4094),
    [sym_string_expansion] = STATE(4094),
    [sym_expansion] = STATE(4094),
    [sym_command_substitution] = STATE(4094),
    [sym_process_substitution] = STATE(4094),
    [anon_sym_RBRACE] = ACTIONS(9694),
    [sym__special_characters] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9698),
  },
  [3961] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(9700),
    [sym_comment] = ACTIONS(57),
  },
  [3962] = {
    [sym_concatenation] = STATE(4099),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4099),
    [anon_sym_RBRACE] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9704),
    [anon_sym_DASH] = ACTIONS(9704),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9704),
    [anon_sym_COLON_QMARK] = ACTIONS(9704),
    [anon_sym_COLON_DASH] = ACTIONS(9704),
    [anon_sym_PERCENT] = ACTIONS(9704),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3963] = {
    [sym_concatenation] = STATE(4101),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4101),
    [anon_sym_RBRACE] = ACTIONS(9694),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_DASH] = ACTIONS(9710),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_COLON_QMARK] = ACTIONS(9710),
    [anon_sym_COLON_DASH] = ACTIONS(9710),
    [anon_sym_PERCENT] = ACTIONS(9710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3964] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_esac] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2408),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [3965] = {
    [sym_concatenation] = STATE(4104),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4104),
    [sym_regex] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9718),
    [anon_sym_EQ] = ACTIONS(9720),
    [anon_sym_DASH] = ACTIONS(9720),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9720),
    [anon_sym_COLON_QMARK] = ACTIONS(9720),
    [anon_sym_COLON_DASH] = ACTIONS(9720),
    [anon_sym_PERCENT] = ACTIONS(9720),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3966] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9718),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3967] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_esac] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [3968] = {
    [sym_concatenation] = STATE(4101),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4101),
    [sym_regex] = ACTIONS(9724),
    [anon_sym_RBRACE] = ACTIONS(9694),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_DASH] = ACTIONS(9710),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_COLON_QMARK] = ACTIONS(9710),
    [anon_sym_COLON_DASH] = ACTIONS(9710),
    [anon_sym_PERCENT] = ACTIONS(9710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3969] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9694),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3970] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_esac] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2466),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [3971] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_esac] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2504),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [3972] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_esac] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_EQ_TILDE] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [3973] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_esac] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_EQ_TILDE] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [3974] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9726),
    [sym_comment] = ACTIONS(57),
  },
  [3975] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [sym_comment] = ACTIONS(57),
  },
  [3976] = {
    [anon_sym_RBRACE] = ACTIONS(9728),
    [sym_comment] = ACTIONS(57),
  },
  [3977] = {
    [sym_concatenation] = STATE(4110),
    [sym_string] = STATE(4109),
    [sym_simple_expansion] = STATE(4109),
    [sym_string_expansion] = STATE(4109),
    [sym_expansion] = STATE(4109),
    [sym_command_substitution] = STATE(4109),
    [sym_process_substitution] = STATE(4109),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [sym__special_characters] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9732),
  },
  [3978] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_esac] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [3979] = {
    [sym_concatenation] = STATE(4113),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4113),
    [sym_regex] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_DASH] = ACTIONS(9738),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_COLON_QMARK] = ACTIONS(9738),
    [anon_sym_COLON_DASH] = ACTIONS(9738),
    [anon_sym_PERCENT] = ACTIONS(9738),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3980] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3981] = {
    [sym_concatenation] = STATE(4115),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4115),
    [sym_regex] = ACTIONS(9742),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_DASH] = ACTIONS(9744),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_COLON_QMARK] = ACTIONS(9744),
    [anon_sym_COLON_DASH] = ACTIONS(9744),
    [anon_sym_PERCENT] = ACTIONS(9744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3982] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3983] = {
    [sym_concatenation] = STATE(4117),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4117),
    [anon_sym_RBRACE] = ACTIONS(9748),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_DASH] = ACTIONS(9750),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_COLON_QMARK] = ACTIONS(9750),
    [anon_sym_COLON_DASH] = ACTIONS(9750),
    [anon_sym_PERCENT] = ACTIONS(9750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3984] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_esac] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3985] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9748),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3986] = {
    [sym_concatenation] = STATE(4115),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4115),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_DASH] = ACTIONS(9744),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_COLON_QMARK] = ACTIONS(9744),
    [anon_sym_COLON_DASH] = ACTIONS(9744),
    [anon_sym_PERCENT] = ACTIONS(9744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [3987] = {
    [aux_sym_concatenation_repeat1] = STATE(3989),
    [sym__simple_heredoc_body] = ACTIONS(1367),
    [sym__heredoc_body_beginning] = ACTIONS(1367),
    [sym_file_descriptor] = ACTIONS(1367),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_esac] = ACTIONS(1367),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SEMI_SEMI] = ACTIONS(1367),
    [anon_sym_PIPE_AMP] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_AMP] = ACTIONS(1367),
    [anon_sym_GT_AMP] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1367),
    [anon_sym_LT_LT_LT] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
  },
  [3988] = {
    [aux_sym_concatenation_repeat1] = STATE(3989),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_esac] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [3989] = {
    [aux_sym_concatenation_repeat1] = STATE(4118),
    [sym__simple_heredoc_body] = ACTIONS(1049),
    [sym__heredoc_body_beginning] = ACTIONS(1049),
    [sym_file_descriptor] = ACTIONS(1049),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_esac] = ACTIONS(1049),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_LT_LT_DASH] = ACTIONS(1049),
    [anon_sym_LT_LT_LT] = ACTIONS(1049),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
  },
  [3990] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_esac] = ACTIONS(7487),
    [anon_sym_SEMI_SEMI] = ACTIONS(4284),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_typeset] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_local] = ACTIONS(2558),
    [anon_sym_unset] = ACTIONS(2558),
    [anon_sym_unsetenv] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_GT] = ACTIONS(2558),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [sym__special_characters] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2558),
  },
  [3991] = {
    [sym__special_characters] = ACTIONS(8797),
    [anon_sym_DQUOTE] = ACTIONS(8797),
    [anon_sym_DOLLAR] = ACTIONS(8799),
    [sym_raw_string] = ACTIONS(8797),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8797),
    [anon_sym_BQUOTE] = ACTIONS(8797),
    [anon_sym_LT_LPAREN] = ACTIONS(8797),
    [anon_sym_GT_LPAREN] = ACTIONS(8797),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8797),
  },
  [3992] = {
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_SEMI_SEMI] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1245),
    [anon_sym_AMP] = ACTIONS(1245),
  },
  [3993] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_heredoc_body] = STATE(4119),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2642),
    [anon_sym_AMP_GT] = ACTIONS(2640),
    [anon_sym_AMP_GT_GT] = ACTIONS(2642),
    [anon_sym_LT_AMP] = ACTIONS(2642),
    [anon_sym_GT_AMP] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [3994] = {
    [sym_file_redirect] = STATE(1246),
    [sym_heredoc_redirect] = STATE(1246),
    [sym_heredoc_body] = STATE(4119),
    [sym_herestring_redirect] = STATE(1246),
    [aux_sym_redirected_statement_repeat1] = STATE(1246),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [sym__special_characters] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [3995] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9754),
    [sym_comment] = ACTIONS(57),
  },
  [3996] = {
    [sym__special_characters] = ACTIONS(8833),
    [anon_sym_DQUOTE] = ACTIONS(8833),
    [anon_sym_DOLLAR] = ACTIONS(8835),
    [sym_raw_string] = ACTIONS(8833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8833),
    [anon_sym_BQUOTE] = ACTIONS(8833),
    [anon_sym_LT_LPAREN] = ACTIONS(8833),
    [anon_sym_GT_LPAREN] = ACTIONS(8833),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8833),
  },
  [3997] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9756),
    [sym_comment] = ACTIONS(57),
  },
  [3998] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_RBRACE] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8164),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [3999] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8168),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4000] = {
    [sym__simple_heredoc_body] = ACTIONS(8917),
    [sym__heredoc_body_beginning] = ACTIONS(8917),
    [sym_file_descriptor] = ACTIONS(8917),
    [anon_sym_SEMI] = ACTIONS(8919),
    [anon_sym_PIPE] = ACTIONS(8919),
    [anon_sym_SEMI_SEMI] = ACTIONS(8917),
    [anon_sym_RBRACE] = ACTIONS(8917),
    [anon_sym_PIPE_AMP] = ACTIONS(8917),
    [anon_sym_AMP_AMP] = ACTIONS(8917),
    [anon_sym_PIPE_PIPE] = ACTIONS(8917),
    [anon_sym_LT] = ACTIONS(8919),
    [anon_sym_GT] = ACTIONS(8919),
    [anon_sym_GT_GT] = ACTIONS(8917),
    [anon_sym_AMP_GT] = ACTIONS(8919),
    [anon_sym_AMP_GT_GT] = ACTIONS(8917),
    [anon_sym_LT_AMP] = ACTIONS(8917),
    [anon_sym_GT_AMP] = ACTIONS(8917),
    [anon_sym_LT_LT] = ACTIONS(8919),
    [anon_sym_LT_LT_DASH] = ACTIONS(8917),
    [anon_sym_LT_LT_LT] = ACTIONS(8917),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8917),
    [anon_sym_AMP] = ACTIONS(8919),
  },
  [4001] = {
    [sym_do_group] = STATE(4122),
    [sym_compound_statement] = STATE(4122),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [4002] = {
    [sym__concat] = ACTIONS(8162),
    [anon_sym_RBRACE] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
  },
  [4003] = {
    [sym__concat] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
  },
  [4004] = {
    [sym_file_descriptor] = ACTIONS(9480),
    [anon_sym_SEMI] = ACTIONS(9482),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_SEMI_SEMI] = ACTIONS(9480),
    [anon_sym_PIPE_AMP] = ACTIONS(9480),
    [anon_sym_AMP_AMP] = ACTIONS(9480),
    [anon_sym_PIPE_PIPE] = ACTIONS(9480),
    [anon_sym_LT] = ACTIONS(9482),
    [anon_sym_GT] = ACTIONS(9482),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_AMP_GT] = ACTIONS(9482),
    [anon_sym_AMP_GT_GT] = ACTIONS(9480),
    [anon_sym_LT_AMP] = ACTIONS(9480),
    [anon_sym_GT_AMP] = ACTIONS(9480),
    [anon_sym_LT_LT] = ACTIONS(9482),
    [anon_sym_LT_LT_DASH] = ACTIONS(9480),
    [anon_sym_LT_LT_LT] = ACTIONS(9480),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9480),
    [anon_sym_AMP] = ACTIONS(9482),
  },
  [4005] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_done] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4006] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_done] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4007] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_done] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4008] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4009] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4010] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_done] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4011] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_done] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4012] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_done] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4013] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_done] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4014] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_done] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4015] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_done] = ACTIONS(7043),
    [anon_sym_fi] = ACTIONS(7043),
    [anon_sym_elif] = ACTIONS(7043),
    [anon_sym_else] = ACTIONS(7043),
    [anon_sym_esac] = ACTIONS(7043),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4016] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_done] = ACTIONS(7047),
    [anon_sym_fi] = ACTIONS(7047),
    [anon_sym_elif] = ACTIONS(7047),
    [anon_sym_else] = ACTIONS(7047),
    [anon_sym_esac] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4017] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_done] = ACTIONS(7051),
    [anon_sym_fi] = ACTIONS(7051),
    [anon_sym_elif] = ACTIONS(7051),
    [anon_sym_else] = ACTIONS(7051),
    [anon_sym_esac] = ACTIONS(7051),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4018] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4019] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9764),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4020] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_done] = ACTIONS(7087),
    [anon_sym_fi] = ACTIONS(7087),
    [anon_sym_elif] = ACTIONS(7087),
    [anon_sym_else] = ACTIONS(7087),
    [anon_sym_esac] = ACTIONS(7087),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4021] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_fi] = ACTIONS(7045),
    [anon_sym_elif] = ACTIONS(7045),
    [anon_sym_else] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4022] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_fi] = ACTIONS(7049),
    [anon_sym_elif] = ACTIONS(7049),
    [anon_sym_else] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4023] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_fi] = ACTIONS(7053),
    [anon_sym_elif] = ACTIONS(7053),
    [anon_sym_else] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4024] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9766),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4025] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9768),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4026] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_fi] = ACTIONS(7089),
    [anon_sym_elif] = ACTIONS(7089),
    [anon_sym_else] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4027] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_fi] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [4028] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_fi] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [4029] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9770),
    [sym_comment] = ACTIONS(57),
  },
  [4030] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9772),
    [sym_comment] = ACTIONS(57),
  },
  [4031] = {
    [anon_sym_RBRACE] = ACTIONS(9772),
    [sym_comment] = ACTIONS(57),
  },
  [4032] = {
    [sym_concatenation] = STATE(4132),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4132),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9776),
    [anon_sym_DASH] = ACTIONS(9776),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9776),
    [anon_sym_COLON_QMARK] = ACTIONS(9776),
    [anon_sym_COLON_DASH] = ACTIONS(9776),
    [anon_sym_PERCENT] = ACTIONS(9776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4033] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_fi] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [4034] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4035] = {
    [sym_concatenation] = STATE(4133),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4133),
    [anon_sym_RBRACE] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_DASH] = ACTIONS(9780),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9782),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_COLON_QMARK] = ACTIONS(9780),
    [anon_sym_COLON_DASH] = ACTIONS(9780),
    [anon_sym_PERCENT] = ACTIONS(9780),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4036] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4037] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_fi] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [4038] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4039] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_fi] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4040] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_fi] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4041] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_fi] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4042] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4043] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4044] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_fi] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4045] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_fi] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4046] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_fi] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4047] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_fi] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4048] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4049] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4050] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_fi] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4051] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_fi] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8164),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4052] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_fi] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4053] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_fi] = ACTIONS(8164),
    [anon_sym_elif] = ACTIONS(8164),
    [anon_sym_else] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4054] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_fi] = ACTIONS(8168),
    [anon_sym_elif] = ACTIONS(8168),
    [anon_sym_else] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4055] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_fi] = ACTIONS(8164),
    [anon_sym_elif] = ACTIONS(8164),
    [anon_sym_else] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4056] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_fi] = ACTIONS(8168),
    [anon_sym_elif] = ACTIONS(8168),
    [anon_sym_else] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4057] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_esac] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [4058] = {
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(2306),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [4059] = {
    [aux_sym_concatenation_repeat1] = STATE(4059),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(9794),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym__special_characters] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [sym_raw_string] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2306),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2306),
    [anon_sym_GT_LPAREN] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [4060] = {
    [sym__simple_heredoc_body] = ACTIONS(2313),
    [sym__heredoc_body_beginning] = ACTIONS(2313),
    [sym_file_descriptor] = ACTIONS(2313),
    [sym__concat] = ACTIONS(2313),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_esac] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_SEMI_SEMI] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_AMP_GT] = ACTIONS(2315),
    [anon_sym_AMP_GT_GT] = ACTIONS(2313),
    [anon_sym_LT_AMP] = ACTIONS(2313),
    [anon_sym_GT_AMP] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(2313),
    [anon_sym_LT_LT_LT] = ACTIONS(2313),
    [sym__special_characters] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_raw_string] = ACTIONS(2313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2313),
    [anon_sym_GT_LPAREN] = ACTIONS(2313),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2315),
  },
  [4061] = {
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(9797),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym__string_content] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1057),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_0] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
  },
  [4062] = {
    [sym_concatenation] = STATE(4143),
    [sym_string] = STATE(4142),
    [sym_simple_expansion] = STATE(4142),
    [sym_string_expansion] = STATE(4142),
    [sym_expansion] = STATE(4142),
    [sym_command_substitution] = STATE(4142),
    [sym_process_substitution] = STATE(4142),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [sym__special_characters] = ACTIONS(9801),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9803),
  },
  [4063] = {
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(9805),
    [sym_comment] = ACTIONS(57),
  },
  [4064] = {
    [sym_concatenation] = STATE(4147),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4147),
    [anon_sym_RBRACE] = ACTIONS(9807),
    [anon_sym_EQ] = ACTIONS(9809),
    [anon_sym_DASH] = ACTIONS(9809),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9813),
    [anon_sym_COLON] = ACTIONS(9809),
    [anon_sym_COLON_QMARK] = ACTIONS(9809),
    [anon_sym_COLON_DASH] = ACTIONS(9809),
    [anon_sym_PERCENT] = ACTIONS(9809),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4065] = {
    [sym_concatenation] = STATE(4149),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4149),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_EQ] = ACTIONS(9815),
    [anon_sym_DASH] = ACTIONS(9815),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(9819),
    [anon_sym_COLON] = ACTIONS(9815),
    [anon_sym_COLON_QMARK] = ACTIONS(9815),
    [anon_sym_COLON_DASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4066] = {
    [sym__simple_heredoc_body] = ACTIONS(2406),
    [sym__heredoc_body_beginning] = ACTIONS(2406),
    [sym_file_descriptor] = ACTIONS(2406),
    [sym__concat] = ACTIONS(2406),
    [sym_variable_name] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_esac] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_SEMI_SEMI] = ACTIONS(2406),
    [anon_sym_PIPE_AMP] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_AMP_GT] = ACTIONS(2408),
    [anon_sym_AMP_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_AMP] = ACTIONS(2406),
    [anon_sym_GT_AMP] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_LT_LT_DASH] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(2406),
    [sym__special_characters] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2406),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LPAREN] = ACTIONS(2406),
    [anon_sym_GT_LPAREN] = ACTIONS(2406),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2408),
    [anon_sym_LF] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
  },
  [4067] = {
    [sym_concatenation] = STATE(4152),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4152),
    [sym_regex] = ACTIONS(9821),
    [anon_sym_RBRACE] = ACTIONS(9823),
    [anon_sym_EQ] = ACTIONS(9825),
    [anon_sym_DASH] = ACTIONS(9825),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9827),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9825),
    [anon_sym_COLON_QMARK] = ACTIONS(9825),
    [anon_sym_COLON_DASH] = ACTIONS(9825),
    [anon_sym_PERCENT] = ACTIONS(9825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4068] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9823),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4069] = {
    [sym__simple_heredoc_body] = ACTIONS(2454),
    [sym__heredoc_body_beginning] = ACTIONS(2454),
    [sym_file_descriptor] = ACTIONS(2454),
    [sym__concat] = ACTIONS(2454),
    [sym_variable_name] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_esac] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_SEMI_SEMI] = ACTIONS(2454),
    [anon_sym_PIPE_AMP] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2454),
    [anon_sym_LT_LT_LT] = ACTIONS(2454),
    [sym__special_characters] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(2456),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2454),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LT_LPAREN] = ACTIONS(2454),
    [anon_sym_GT_LPAREN] = ACTIONS(2454),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2456),
    [anon_sym_LF] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
  },
  [4070] = {
    [sym_concatenation] = STATE(4149),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4149),
    [sym_regex] = ACTIONS(9829),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_EQ] = ACTIONS(9815),
    [anon_sym_DASH] = ACTIONS(9815),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9815),
    [anon_sym_COLON_QMARK] = ACTIONS(9815),
    [anon_sym_COLON_DASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4071] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4072] = {
    [sym__simple_heredoc_body] = ACTIONS(2464),
    [sym__heredoc_body_beginning] = ACTIONS(2464),
    [sym_file_descriptor] = ACTIONS(2464),
    [sym__concat] = ACTIONS(2464),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_esac] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE_AMP] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT] = ACTIONS(2466),
    [anon_sym_AMP_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_AMP] = ACTIONS(2464),
    [anon_sym_GT_AMP] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_LT_LT_DASH] = ACTIONS(2464),
    [anon_sym_LT_LT_LT] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [sym_raw_string] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LT_LPAREN] = ACTIONS(2464),
    [anon_sym_GT_LPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [4073] = {
    [sym__simple_heredoc_body] = ACTIONS(2502),
    [sym__heredoc_body_beginning] = ACTIONS(2502),
    [sym_file_descriptor] = ACTIONS(2502),
    [sym__concat] = ACTIONS(2502),
    [sym_variable_name] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_esac] = ACTIONS(2504),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_AMP] = ACTIONS(2502),
    [anon_sym_GT_AMP] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2504),
    [anon_sym_LT_LT_DASH] = ACTIONS(2502),
    [anon_sym_LT_LT_LT] = ACTIONS(2502),
    [sym__special_characters] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
  },
  [4074] = {
    [sym__simple_heredoc_body] = ACTIONS(2664),
    [sym__heredoc_body_beginning] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2664),
    [sym_variable_name] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_esac] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_GT_GT] = ACTIONS(2664),
    [anon_sym_AMP_GT] = ACTIONS(2666),
    [anon_sym_AMP_GT_GT] = ACTIONS(2664),
    [anon_sym_LT_AMP] = ACTIONS(2664),
    [anon_sym_GT_AMP] = ACTIONS(2664),
    [anon_sym_LT_LT] = ACTIONS(2666),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2664),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2666),
    [sym_word] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2666),
  },
  [4075] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_string_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_RPAREN] = ACTIONS(9831),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_DOLLAR] = ACTIONS(1395),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1401),
    [anon_sym_BQUOTE] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1405),
    [anon_sym_GT_LPAREN] = ACTIONS(1405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1397),
  },
  [4076] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_esac] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [4077] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_esac] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [4078] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9833),
    [sym_comment] = ACTIONS(57),
  },
  [4079] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9835),
    [sym_comment] = ACTIONS(57),
  },
  [4080] = {
    [anon_sym_RBRACE] = ACTIONS(9835),
    [sym_comment] = ACTIONS(57),
  },
  [4081] = {
    [sym_concatenation] = STATE(4159),
    [sym_string] = STATE(4158),
    [sym_simple_expansion] = STATE(4158),
    [sym_string_expansion] = STATE(4158),
    [sym_expansion] = STATE(4158),
    [sym_command_substitution] = STATE(4158),
    [sym_process_substitution] = STATE(4158),
    [anon_sym_RBRACE] = ACTIONS(9835),
    [sym__special_characters] = ACTIONS(9837),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9839),
  },
  [4082] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_esac] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [4083] = {
    [sym_concatenation] = STATE(4162),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4162),
    [sym_regex] = ACTIONS(9841),
    [anon_sym_RBRACE] = ACTIONS(9843),
    [anon_sym_EQ] = ACTIONS(9845),
    [anon_sym_DASH] = ACTIONS(9845),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9845),
    [anon_sym_COLON_QMARK] = ACTIONS(9845),
    [anon_sym_COLON_DASH] = ACTIONS(9845),
    [anon_sym_PERCENT] = ACTIONS(9845),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4084] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9843),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4085] = {
    [sym_concatenation] = STATE(4164),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4164),
    [sym_regex] = ACTIONS(9849),
    [anon_sym_RBRACE] = ACTIONS(9835),
    [anon_sym_EQ] = ACTIONS(9851),
    [anon_sym_DASH] = ACTIONS(9851),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9851),
    [anon_sym_COLON_QMARK] = ACTIONS(9851),
    [anon_sym_COLON_DASH] = ACTIONS(9851),
    [anon_sym_PERCENT] = ACTIONS(9851),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4086] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9835),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4087] = {
    [sym_concatenation] = STATE(4166),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4166),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_EQ] = ACTIONS(9857),
    [anon_sym_DASH] = ACTIONS(9857),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9859),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9857),
    [anon_sym_COLON_QMARK] = ACTIONS(9857),
    [anon_sym_COLON_DASH] = ACTIONS(9857),
    [anon_sym_PERCENT] = ACTIONS(9857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4088] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_esac] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [4089] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9855),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4090] = {
    [sym_concatenation] = STATE(4164),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4164),
    [anon_sym_RBRACE] = ACTIONS(9835),
    [anon_sym_EQ] = ACTIONS(9851),
    [anon_sym_DASH] = ACTIONS(9851),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9851),
    [anon_sym_COLON_QMARK] = ACTIONS(9851),
    [anon_sym_COLON_DASH] = ACTIONS(9851),
    [anon_sym_PERCENT] = ACTIONS(9851),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4091] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_esac] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4021),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [4092] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_esac] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4035),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [4093] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9861),
    [sym_comment] = ACTIONS(57),
  },
  [4094] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9863),
    [sym_comment] = ACTIONS(57),
  },
  [4095] = {
    [anon_sym_RBRACE] = ACTIONS(9863),
    [sym_comment] = ACTIONS(57),
  },
  [4096] = {
    [sym_concatenation] = STATE(4171),
    [sym_string] = STATE(4170),
    [sym_simple_expansion] = STATE(4170),
    [sym_string_expansion] = STATE(4170),
    [sym_expansion] = STATE(4170),
    [sym_command_substitution] = STATE(4170),
    [sym_process_substitution] = STATE(4170),
    [anon_sym_RBRACE] = ACTIONS(9863),
    [sym__special_characters] = ACTIONS(9865),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9867),
  },
  [4097] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_esac] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4071),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [4098] = {
    [sym_concatenation] = STATE(4174),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4174),
    [sym_regex] = ACTIONS(9869),
    [anon_sym_RBRACE] = ACTIONS(9871),
    [anon_sym_EQ] = ACTIONS(9873),
    [anon_sym_DASH] = ACTIONS(9873),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9873),
    [anon_sym_COLON_QMARK] = ACTIONS(9873),
    [anon_sym_COLON_DASH] = ACTIONS(9873),
    [anon_sym_PERCENT] = ACTIONS(9873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4099] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9871),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4100] = {
    [sym_concatenation] = STATE(4176),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4176),
    [sym_regex] = ACTIONS(9877),
    [anon_sym_RBRACE] = ACTIONS(9863),
    [anon_sym_EQ] = ACTIONS(9879),
    [anon_sym_DASH] = ACTIONS(9879),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9879),
    [anon_sym_COLON_QMARK] = ACTIONS(9879),
    [anon_sym_COLON_DASH] = ACTIONS(9879),
    [anon_sym_PERCENT] = ACTIONS(9879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4101] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9863),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4102] = {
    [sym_concatenation] = STATE(4178),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4178),
    [anon_sym_RBRACE] = ACTIONS(9883),
    [anon_sym_EQ] = ACTIONS(9885),
    [anon_sym_DASH] = ACTIONS(9885),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9885),
    [anon_sym_COLON_QMARK] = ACTIONS(9885),
    [anon_sym_COLON_DASH] = ACTIONS(9885),
    [anon_sym_PERCENT] = ACTIONS(9885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4103] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_esac] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [4104] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9883),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4105] = {
    [sym_concatenation] = STATE(4176),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4176),
    [anon_sym_RBRACE] = ACTIONS(9863),
    [anon_sym_EQ] = ACTIONS(9879),
    [anon_sym_DASH] = ACTIONS(9879),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9879),
    [anon_sym_COLON_QMARK] = ACTIONS(9879),
    [anon_sym_COLON_DASH] = ACTIONS(9879),
    [anon_sym_PERCENT] = ACTIONS(9879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4106] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_esac] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_EQ_TILDE] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [4107] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_esac] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_EQ_TILDE] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [4108] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9889),
    [sym_comment] = ACTIONS(57),
  },
  [4109] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9891),
    [sym_comment] = ACTIONS(57),
  },
  [4110] = {
    [anon_sym_RBRACE] = ACTIONS(9891),
    [sym_comment] = ACTIONS(57),
  },
  [4111] = {
    [sym_concatenation] = STATE(4182),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4182),
    [anon_sym_RBRACE] = ACTIONS(9893),
    [anon_sym_EQ] = ACTIONS(9895),
    [anon_sym_DASH] = ACTIONS(9895),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9895),
    [anon_sym_COLON_QMARK] = ACTIONS(9895),
    [anon_sym_COLON_DASH] = ACTIONS(9895),
    [anon_sym_PERCENT] = ACTIONS(9895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4112] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_esac] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_EQ_TILDE] = ACTIONS(5597),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [4113] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9893),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4114] = {
    [sym_concatenation] = STATE(4183),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4183),
    [anon_sym_RBRACE] = ACTIONS(9891),
    [anon_sym_EQ] = ACTIONS(9899),
    [anon_sym_DASH] = ACTIONS(9899),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9899),
    [anon_sym_COLON_QMARK] = ACTIONS(9899),
    [anon_sym_COLON_DASH] = ACTIONS(9899),
    [anon_sym_PERCENT] = ACTIONS(9899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4115] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9891),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4116] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_esac] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_EQ_TILDE] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [4117] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9903),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4118] = {
    [aux_sym_concatenation_repeat1] = STATE(4118),
    [sym__simple_heredoc_body] = ACTIONS(2306),
    [sym__heredoc_body_beginning] = ACTIONS(2306),
    [sym_file_descriptor] = ACTIONS(2306),
    [sym__concat] = ACTIONS(8395),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_esac] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_SEMI_SEMI] = ACTIONS(2306),
    [anon_sym_PIPE_AMP] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_AMP_GT] = ACTIONS(2308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2306),
    [anon_sym_LT_AMP] = ACTIONS(2306),
    [anon_sym_GT_AMP] = ACTIONS(2306),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2306),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
  },
  [4119] = {
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_SEMI_SEMI] = ACTIONS(2556),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2622),
  },
  [4120] = {
    [sym__special_characters] = ACTIONS(9456),
    [anon_sym_DQUOTE] = ACTIONS(9456),
    [anon_sym_DOLLAR] = ACTIONS(9458),
    [sym_raw_string] = ACTIONS(9456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9456),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9456),
    [anon_sym_BQUOTE] = ACTIONS(9456),
    [anon_sym_LT_LPAREN] = ACTIONS(9456),
    [anon_sym_GT_LPAREN] = ACTIONS(9456),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9456),
  },
  [4121] = {
    [sym__special_characters] = ACTIONS(9462),
    [anon_sym_DQUOTE] = ACTIONS(9462),
    [anon_sym_DOLLAR] = ACTIONS(9464),
    [sym_raw_string] = ACTIONS(9462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9462),
    [anon_sym_BQUOTE] = ACTIONS(9462),
    [anon_sym_LT_LPAREN] = ACTIONS(9462),
    [anon_sym_GT_LPAREN] = ACTIONS(9462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9462),
  },
  [4122] = {
    [sym__simple_heredoc_body] = ACTIONS(9480),
    [sym__heredoc_body_beginning] = ACTIONS(9480),
    [sym_file_descriptor] = ACTIONS(9480),
    [anon_sym_SEMI] = ACTIONS(9482),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_SEMI_SEMI] = ACTIONS(9480),
    [anon_sym_RBRACE] = ACTIONS(9480),
    [anon_sym_PIPE_AMP] = ACTIONS(9480),
    [anon_sym_AMP_AMP] = ACTIONS(9480),
    [anon_sym_PIPE_PIPE] = ACTIONS(9480),
    [anon_sym_LT] = ACTIONS(9482),
    [anon_sym_GT] = ACTIONS(9482),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_AMP_GT] = ACTIONS(9482),
    [anon_sym_AMP_GT_GT] = ACTIONS(9480),
    [anon_sym_LT_AMP] = ACTIONS(9480),
    [anon_sym_GT_AMP] = ACTIONS(9480),
    [anon_sym_LT_LT] = ACTIONS(9482),
    [anon_sym_LT_LT_DASH] = ACTIONS(9480),
    [anon_sym_LT_LT_LT] = ACTIONS(9480),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9480),
    [anon_sym_AMP] = ACTIONS(9482),
  },
  [4123] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_done] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4124] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_done] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4125] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_done] = ACTIONS(8162),
    [anon_sym_fi] = ACTIONS(8162),
    [anon_sym_elif] = ACTIONS(8162),
    [anon_sym_else] = ACTIONS(8162),
    [anon_sym_esac] = ACTIONS(8162),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4126] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_done] = ACTIONS(8166),
    [anon_sym_fi] = ACTIONS(8166),
    [anon_sym_elif] = ACTIONS(8166),
    [anon_sym_else] = ACTIONS(8166),
    [anon_sym_esac] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4127] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_fi] = ACTIONS(8164),
    [anon_sym_elif] = ACTIONS(8164),
    [anon_sym_else] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4128] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_fi] = ACTIONS(8168),
    [anon_sym_elif] = ACTIONS(8168),
    [anon_sym_else] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4129] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_fi] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4130] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_fi] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4131] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_fi] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4132] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9905),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4133] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9907),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4134] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_fi] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4135] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_fi] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4136] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_fi] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4137] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_fi] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4138] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_fi] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4139] = {
    [sym__simple_heredoc_body] = ACTIONS(4019),
    [sym__heredoc_body_beginning] = ACTIONS(4019),
    [sym_file_descriptor] = ACTIONS(4019),
    [sym__concat] = ACTIONS(4019),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4021),
    [anon_sym_esac] = ACTIONS(4021),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_SEMI_SEMI] = ACTIONS(4019),
    [anon_sym_PIPE_AMP] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_AMP_GT] = ACTIONS(4021),
    [anon_sym_AMP_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_AMP] = ACTIONS(4019),
    [anon_sym_GT_AMP] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_LT_LT_DASH] = ACTIONS(4019),
    [anon_sym_LT_LT_LT] = ACTIONS(4019),
    [sym__special_characters] = ACTIONS(4019),
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [sym_raw_string] = ACTIONS(4019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LT_LPAREN] = ACTIONS(4019),
    [anon_sym_GT_LPAREN] = ACTIONS(4019),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4021),
    [anon_sym_LF] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4021),
  },
  [4140] = {
    [sym__simple_heredoc_body] = ACTIONS(4033),
    [sym__heredoc_body_beginning] = ACTIONS(4033),
    [sym_file_descriptor] = ACTIONS(4033),
    [sym__concat] = ACTIONS(4033),
    [sym_variable_name] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_esac] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4035),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4035),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym__special_characters] = ACTIONS(4033),
    [anon_sym_DQUOTE] = ACTIONS(4033),
    [anon_sym_DOLLAR] = ACTIONS(4035),
    [sym_raw_string] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4033),
    [anon_sym_BQUOTE] = ACTIONS(4033),
    [anon_sym_LT_LPAREN] = ACTIONS(4033),
    [anon_sym_GT_LPAREN] = ACTIONS(4033),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4035),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4035),
  },
  [4141] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9909),
    [sym_comment] = ACTIONS(57),
  },
  [4142] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9911),
    [sym_comment] = ACTIONS(57),
  },
  [4143] = {
    [anon_sym_RBRACE] = ACTIONS(9911),
    [sym_comment] = ACTIONS(57),
  },
  [4144] = {
    [sym_concatenation] = STATE(4191),
    [sym_string] = STATE(4190),
    [sym_simple_expansion] = STATE(4190),
    [sym_string_expansion] = STATE(4190),
    [sym_expansion] = STATE(4190),
    [sym_command_substitution] = STATE(4190),
    [sym_process_substitution] = STATE(4190),
    [anon_sym_RBRACE] = ACTIONS(9911),
    [sym__special_characters] = ACTIONS(9913),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_DOLLAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(9915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2384),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [anon_sym_LT_LPAREN] = ACTIONS(2388),
    [anon_sym_GT_LPAREN] = ACTIONS(2388),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9915),
  },
  [4145] = {
    [sym__simple_heredoc_body] = ACTIONS(4069),
    [sym__heredoc_body_beginning] = ACTIONS(4069),
    [sym_file_descriptor] = ACTIONS(4069),
    [sym__concat] = ACTIONS(4069),
    [sym_variable_name] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_esac] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE_AMP] = ACTIONS(4069),
    [anon_sym_AMP_AMP] = ACTIONS(4069),
    [anon_sym_PIPE_PIPE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT_GT] = ACTIONS(4069),
    [anon_sym_LT_AMP] = ACTIONS(4069),
    [anon_sym_GT_AMP] = ACTIONS(4069),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_LT_LT_DASH] = ACTIONS(4069),
    [anon_sym_LT_LT_LT] = ACTIONS(4069),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4071),
    [sym_raw_string] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [anon_sym_LT_LPAREN] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(4069),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [4146] = {
    [sym_concatenation] = STATE(4194),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4194),
    [sym_regex] = ACTIONS(9917),
    [anon_sym_RBRACE] = ACTIONS(9919),
    [anon_sym_EQ] = ACTIONS(9921),
    [anon_sym_DASH] = ACTIONS(9921),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9921),
    [anon_sym_COLON_QMARK] = ACTIONS(9921),
    [anon_sym_COLON_DASH] = ACTIONS(9921),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4147] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9919),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4148] = {
    [sym_concatenation] = STATE(4196),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4196),
    [sym_regex] = ACTIONS(9925),
    [anon_sym_RBRACE] = ACTIONS(9911),
    [anon_sym_EQ] = ACTIONS(9927),
    [anon_sym_DASH] = ACTIONS(9927),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9927),
    [anon_sym_COLON_QMARK] = ACTIONS(9927),
    [anon_sym_COLON_DASH] = ACTIONS(9927),
    [anon_sym_PERCENT] = ACTIONS(9927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4149] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9911),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4150] = {
    [sym_concatenation] = STATE(4198),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4198),
    [anon_sym_RBRACE] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9933),
    [anon_sym_DASH] = ACTIONS(9933),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9933),
    [anon_sym_COLON_QMARK] = ACTIONS(9933),
    [anon_sym_COLON_DASH] = ACTIONS(9933),
    [anon_sym_PERCENT] = ACTIONS(9933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4151] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_esac] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [4152] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4153] = {
    [sym_concatenation] = STATE(4196),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4196),
    [anon_sym_RBRACE] = ACTIONS(9911),
    [anon_sym_EQ] = ACTIONS(9927),
    [anon_sym_DASH] = ACTIONS(9927),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9927),
    [anon_sym_COLON_QMARK] = ACTIONS(9927),
    [anon_sym_COLON_DASH] = ACTIONS(9927),
    [anon_sym_PERCENT] = ACTIONS(9927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4154] = {
    [sym__simple_heredoc_body] = ACTIONS(4352),
    [sym__heredoc_body_beginning] = ACTIONS(4352),
    [sym_file_descriptor] = ACTIONS(4352),
    [sym_variable_name] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_esac] = ACTIONS(4354),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_SEMI_SEMI] = ACTIONS(4352),
    [anon_sym_PIPE_AMP] = ACTIONS(4352),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(4352),
    [anon_sym_LT] = ACTIONS(4354),
    [anon_sym_GT] = ACTIONS(4354),
    [anon_sym_GT_GT] = ACTIONS(4352),
    [anon_sym_AMP_GT] = ACTIONS(4354),
    [anon_sym_AMP_GT_GT] = ACTIONS(4352),
    [anon_sym_LT_AMP] = ACTIONS(4352),
    [anon_sym_GT_AMP] = ACTIONS(4352),
    [anon_sym_LT_LT] = ACTIONS(4354),
    [anon_sym_LT_LT_DASH] = ACTIONS(4352),
    [anon_sym_LT_LT_LT] = ACTIONS(4352),
    [sym__special_characters] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4354),
    [sym_raw_string] = ACTIONS(4352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4352),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_LT_LPAREN] = ACTIONS(4352),
    [anon_sym_GT_LPAREN] = ACTIONS(4352),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4354),
    [sym_word] = ACTIONS(4354),
    [anon_sym_LF] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4354),
  },
  [4155] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_esac] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [4156] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_esac] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [4157] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9937),
    [sym_comment] = ACTIONS(57),
  },
  [4158] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9939),
    [sym_comment] = ACTIONS(57),
  },
  [4159] = {
    [anon_sym_RBRACE] = ACTIONS(9939),
    [sym_comment] = ACTIONS(57),
  },
  [4160] = {
    [sym_concatenation] = STATE(4202),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4202),
    [anon_sym_RBRACE] = ACTIONS(9941),
    [anon_sym_EQ] = ACTIONS(9943),
    [anon_sym_DASH] = ACTIONS(9943),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9943),
    [anon_sym_COLON_QMARK] = ACTIONS(9943),
    [anon_sym_COLON_DASH] = ACTIONS(9943),
    [anon_sym_PERCENT] = ACTIONS(9943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4161] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_esac] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [4162] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9941),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4163] = {
    [sym_concatenation] = STATE(4203),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4203),
    [anon_sym_RBRACE] = ACTIONS(9939),
    [anon_sym_EQ] = ACTIONS(9947),
    [anon_sym_DASH] = ACTIONS(9947),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9947),
    [anon_sym_COLON_QMARK] = ACTIONS(9947),
    [anon_sym_COLON_DASH] = ACTIONS(9947),
    [anon_sym_PERCENT] = ACTIONS(9947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4164] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9939),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4165] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_esac] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [4166] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9951),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4167] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_esac] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5545),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [4168] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_esac] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [4169] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9953),
    [sym_comment] = ACTIONS(57),
  },
  [4170] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9955),
    [sym_comment] = ACTIONS(57),
  },
  [4171] = {
    [anon_sym_RBRACE] = ACTIONS(9955),
    [sym_comment] = ACTIONS(57),
  },
  [4172] = {
    [sym_concatenation] = STATE(4208),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4208),
    [anon_sym_RBRACE] = ACTIONS(9957),
    [anon_sym_EQ] = ACTIONS(9959),
    [anon_sym_DASH] = ACTIONS(9959),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9959),
    [anon_sym_COLON_QMARK] = ACTIONS(9959),
    [anon_sym_COLON_DASH] = ACTIONS(9959),
    [anon_sym_PERCENT] = ACTIONS(9959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4173] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_esac] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5597),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [4174] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9957),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4175] = {
    [sym_concatenation] = STATE(4209),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4209),
    [anon_sym_RBRACE] = ACTIONS(9955),
    [anon_sym_EQ] = ACTIONS(9963),
    [anon_sym_DASH] = ACTIONS(9963),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9963),
    [anon_sym_COLON_QMARK] = ACTIONS(9963),
    [anon_sym_COLON_DASH] = ACTIONS(9963),
    [anon_sym_PERCENT] = ACTIONS(9963),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4176] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9955),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4177] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_esac] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5642),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [4178] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9967),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4179] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_esac] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_EQ_TILDE] = ACTIONS(7045),
    [anon_sym_EQ_EQ] = ACTIONS(7045),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4180] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_esac] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_EQ_TILDE] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7049),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4181] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_esac] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_EQ_EQ] = ACTIONS(7053),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4182] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9969),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4183] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4184] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_esac] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_EQ_TILDE] = ACTIONS(7089),
    [anon_sym_EQ_EQ] = ACTIONS(7089),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4185] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_fi] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4186] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_fi] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4187] = {
    [sym__simple_heredoc_body] = ACTIONS(5543),
    [sym__heredoc_body_beginning] = ACTIONS(5543),
    [sym_file_descriptor] = ACTIONS(5543),
    [sym__concat] = ACTIONS(5543),
    [sym_variable_name] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym_esac] = ACTIONS(5545),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_SEMI_SEMI] = ACTIONS(5543),
    [anon_sym_PIPE_AMP] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_GT] = ACTIONS(5545),
    [anon_sym_AMP_GT_GT] = ACTIONS(5543),
    [anon_sym_LT_AMP] = ACTIONS(5543),
    [anon_sym_GT_AMP] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_LT_LT_DASH] = ACTIONS(5543),
    [anon_sym_LT_LT_LT] = ACTIONS(5543),
    [sym__special_characters] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_DOLLAR] = ACTIONS(5545),
    [sym_raw_string] = ACTIONS(5543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5543),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_LT_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_LPAREN] = ACTIONS(5543),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5545),
    [anon_sym_LF] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5545),
  },
  [4188] = {
    [sym__simple_heredoc_body] = ACTIONS(5551),
    [sym__heredoc_body_beginning] = ACTIONS(5551),
    [sym_file_descriptor] = ACTIONS(5551),
    [sym__concat] = ACTIONS(5551),
    [sym_variable_name] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_esac] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_SEMI_SEMI] = ACTIONS(5551),
    [anon_sym_PIPE_AMP] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_AMP_GT] = ACTIONS(5553),
    [anon_sym_AMP_GT_GT] = ACTIONS(5551),
    [anon_sym_LT_AMP] = ACTIONS(5551),
    [anon_sym_GT_AMP] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_LT_LT_DASH] = ACTIONS(5551),
    [anon_sym_LT_LT_LT] = ACTIONS(5551),
    [sym__special_characters] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_DOLLAR] = ACTIONS(5553),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(5551),
    [anon_sym_LT_LPAREN] = ACTIONS(5551),
    [anon_sym_GT_LPAREN] = ACTIONS(5551),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5553),
    [anon_sym_LF] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [4189] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9973),
    [sym_comment] = ACTIONS(57),
  },
  [4190] = {
    [aux_sym_concatenation_repeat1] = STATE(1796),
    [sym__concat] = ACTIONS(4037),
    [anon_sym_RBRACE] = ACTIONS(9975),
    [sym_comment] = ACTIONS(57),
  },
  [4191] = {
    [anon_sym_RBRACE] = ACTIONS(9975),
    [sym_comment] = ACTIONS(57),
  },
  [4192] = {
    [sym_concatenation] = STATE(4216),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4216),
    [anon_sym_RBRACE] = ACTIONS(9977),
    [anon_sym_EQ] = ACTIONS(9979),
    [anon_sym_DASH] = ACTIONS(9979),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9981),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9979),
    [anon_sym_COLON_QMARK] = ACTIONS(9979),
    [anon_sym_COLON_DASH] = ACTIONS(9979),
    [anon_sym_PERCENT] = ACTIONS(9979),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4193] = {
    [sym__simple_heredoc_body] = ACTIONS(5595),
    [sym__heredoc_body_beginning] = ACTIONS(5595),
    [sym_file_descriptor] = ACTIONS(5595),
    [sym__concat] = ACTIONS(5595),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym_esac] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_SEMI_SEMI] = ACTIONS(5595),
    [anon_sym_PIPE_AMP] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_AMP_GT] = ACTIONS(5597),
    [anon_sym_AMP_GT_GT] = ACTIONS(5595),
    [anon_sym_LT_AMP] = ACTIONS(5595),
    [anon_sym_GT_AMP] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_LT_LT_DASH] = ACTIONS(5595),
    [anon_sym_LT_LT_LT] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5595),
    [anon_sym_BQUOTE] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(5595),
    [anon_sym_GT_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5597),
    [anon_sym_LF] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(5597),
  },
  [4194] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9977),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4195] = {
    [sym_concatenation] = STATE(4217),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(4217),
    [anon_sym_RBRACE] = ACTIONS(9975),
    [anon_sym_EQ] = ACTIONS(9983),
    [anon_sym_DASH] = ACTIONS(9983),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(9985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(9983),
    [anon_sym_COLON_QMARK] = ACTIONS(9983),
    [anon_sym_COLON_DASH] = ACTIONS(9983),
    [anon_sym_PERCENT] = ACTIONS(9983),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4196] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9975),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4197] = {
    [sym__simple_heredoc_body] = ACTIONS(5640),
    [sym__heredoc_body_beginning] = ACTIONS(5640),
    [sym_file_descriptor] = ACTIONS(5640),
    [sym__concat] = ACTIONS(5640),
    [sym_variable_name] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_esac] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE_AMP] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_AMP_GT] = ACTIONS(5642),
    [anon_sym_AMP_GT_GT] = ACTIONS(5640),
    [anon_sym_LT_AMP] = ACTIONS(5640),
    [anon_sym_GT_AMP] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_LT_LT_DASH] = ACTIONS(5640),
    [anon_sym_LT_LT_LT] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(5640),
    [anon_sym_DQUOTE] = ACTIONS(5640),
    [anon_sym_DOLLAR] = ACTIONS(5642),
    [sym_raw_string] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5640),
    [anon_sym_BQUOTE] = ACTIONS(5640),
    [anon_sym_LT_LPAREN] = ACTIONS(5640),
    [anon_sym_GT_LPAREN] = ACTIONS(5640),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5642),
    [anon_sym_LF] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5642),
  },
  [4198] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9987),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4199] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_esac] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4200] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_esac] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4201] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_esac] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4202] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9989),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4203] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9991),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4204] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_esac] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4205] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_esac] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7045),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4206] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_esac] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7049),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4207] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_esac] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7053),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4208] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9993),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4209] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9995),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4210] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_esac] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7089),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4211] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_esac] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_EQ_TILDE] = ACTIONS(8164),
    [anon_sym_EQ_EQ] = ACTIONS(8164),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4212] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_esac] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4213] = {
    [sym__simple_heredoc_body] = ACTIONS(7043),
    [sym__heredoc_body_beginning] = ACTIONS(7043),
    [sym_file_descriptor] = ACTIONS(7043),
    [sym__concat] = ACTIONS(7043),
    [sym_variable_name] = ACTIONS(7043),
    [anon_sym_SEMI] = ACTIONS(7045),
    [anon_sym_esac] = ACTIONS(7045),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_SEMI_SEMI] = ACTIONS(7043),
    [anon_sym_PIPE_AMP] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7043),
    [anon_sym_AMP_GT] = ACTIONS(7045),
    [anon_sym_AMP_GT_GT] = ACTIONS(7043),
    [anon_sym_LT_AMP] = ACTIONS(7043),
    [anon_sym_GT_AMP] = ACTIONS(7043),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_LT_LT_DASH] = ACTIONS(7043),
    [anon_sym_LT_LT_LT] = ACTIONS(7043),
    [sym__special_characters] = ACTIONS(7043),
    [anon_sym_DQUOTE] = ACTIONS(7043),
    [anon_sym_DOLLAR] = ACTIONS(7045),
    [sym_raw_string] = ACTIONS(7043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7043),
    [anon_sym_BQUOTE] = ACTIONS(7043),
    [anon_sym_LT_LPAREN] = ACTIONS(7043),
    [anon_sym_GT_LPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7045),
    [anon_sym_LF] = ACTIONS(7043),
    [anon_sym_AMP] = ACTIONS(7045),
  },
  [4214] = {
    [sym__simple_heredoc_body] = ACTIONS(7047),
    [sym__heredoc_body_beginning] = ACTIONS(7047),
    [sym_file_descriptor] = ACTIONS(7047),
    [sym__concat] = ACTIONS(7047),
    [sym_variable_name] = ACTIONS(7047),
    [anon_sym_SEMI] = ACTIONS(7049),
    [anon_sym_esac] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_SEMI_SEMI] = ACTIONS(7047),
    [anon_sym_PIPE_AMP] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7047),
    [anon_sym_AMP_GT] = ACTIONS(7049),
    [anon_sym_AMP_GT_GT] = ACTIONS(7047),
    [anon_sym_LT_AMP] = ACTIONS(7047),
    [anon_sym_GT_AMP] = ACTIONS(7047),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_LT_LT_DASH] = ACTIONS(7047),
    [anon_sym_LT_LT_LT] = ACTIONS(7047),
    [sym__special_characters] = ACTIONS(7047),
    [anon_sym_DQUOTE] = ACTIONS(7047),
    [anon_sym_DOLLAR] = ACTIONS(7049),
    [sym_raw_string] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(7047),
    [anon_sym_LT_LPAREN] = ACTIONS(7047),
    [anon_sym_GT_LPAREN] = ACTIONS(7047),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7049),
    [anon_sym_LF] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7049),
  },
  [4215] = {
    [sym__simple_heredoc_body] = ACTIONS(7051),
    [sym__heredoc_body_beginning] = ACTIONS(7051),
    [sym_file_descriptor] = ACTIONS(7051),
    [sym__concat] = ACTIONS(7051),
    [sym_variable_name] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7053),
    [anon_sym_esac] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7053),
    [anon_sym_SEMI_SEMI] = ACTIONS(7051),
    [anon_sym_PIPE_AMP] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_LT] = ACTIONS(7053),
    [anon_sym_GT] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7051),
    [anon_sym_AMP_GT] = ACTIONS(7053),
    [anon_sym_AMP_GT_GT] = ACTIONS(7051),
    [anon_sym_LT_AMP] = ACTIONS(7051),
    [anon_sym_GT_AMP] = ACTIONS(7051),
    [anon_sym_LT_LT] = ACTIONS(7053),
    [anon_sym_LT_LT_DASH] = ACTIONS(7051),
    [anon_sym_LT_LT_LT] = ACTIONS(7051),
    [sym__special_characters] = ACTIONS(7051),
    [anon_sym_DQUOTE] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(7053),
    [sym_raw_string] = ACTIONS(7051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7051),
    [anon_sym_BQUOTE] = ACTIONS(7051),
    [anon_sym_LT_LPAREN] = ACTIONS(7051),
    [anon_sym_GT_LPAREN] = ACTIONS(7051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7053),
    [anon_sym_LF] = ACTIONS(7051),
    [anon_sym_AMP] = ACTIONS(7053),
  },
  [4216] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9997),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4217] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(593),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [sym_process_substitution] = STATE(593),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(9999),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1135),
  },
  [4218] = {
    [sym__simple_heredoc_body] = ACTIONS(7087),
    [sym__heredoc_body_beginning] = ACTIONS(7087),
    [sym_file_descriptor] = ACTIONS(7087),
    [sym__concat] = ACTIONS(7087),
    [sym_variable_name] = ACTIONS(7087),
    [anon_sym_SEMI] = ACTIONS(7089),
    [anon_sym_esac] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_SEMI_SEMI] = ACTIONS(7087),
    [anon_sym_PIPE_AMP] = ACTIONS(7087),
    [anon_sym_AMP_AMP] = ACTIONS(7087),
    [anon_sym_PIPE_PIPE] = ACTIONS(7087),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_GT_GT] = ACTIONS(7087),
    [anon_sym_AMP_GT] = ACTIONS(7089),
    [anon_sym_AMP_GT_GT] = ACTIONS(7087),
    [anon_sym_LT_AMP] = ACTIONS(7087),
    [anon_sym_GT_AMP] = ACTIONS(7087),
    [anon_sym_LT_LT] = ACTIONS(7089),
    [anon_sym_LT_LT_DASH] = ACTIONS(7087),
    [anon_sym_LT_LT_LT] = ACTIONS(7087),
    [sym__special_characters] = ACTIONS(7087),
    [anon_sym_DQUOTE] = ACTIONS(7087),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [sym_raw_string] = ACTIONS(7087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7087),
    [anon_sym_BQUOTE] = ACTIONS(7087),
    [anon_sym_LT_LPAREN] = ACTIONS(7087),
    [anon_sym_GT_LPAREN] = ACTIONS(7087),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7089),
    [anon_sym_LF] = ACTIONS(7087),
    [anon_sym_AMP] = ACTIONS(7089),
  },
  [4219] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_esac] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4220] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_esac] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4221] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_esac] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8164),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4222] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_esac] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8168),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
  [4223] = {
    [sym__simple_heredoc_body] = ACTIONS(8162),
    [sym__heredoc_body_beginning] = ACTIONS(8162),
    [sym_file_descriptor] = ACTIONS(8162),
    [sym__concat] = ACTIONS(8162),
    [sym_variable_name] = ACTIONS(8162),
    [anon_sym_SEMI] = ACTIONS(8164),
    [anon_sym_esac] = ACTIONS(8164),
    [anon_sym_PIPE] = ACTIONS(8164),
    [anon_sym_SEMI_SEMI] = ACTIONS(8162),
    [anon_sym_PIPE_AMP] = ACTIONS(8162),
    [anon_sym_AMP_AMP] = ACTIONS(8162),
    [anon_sym_PIPE_PIPE] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(8164),
    [anon_sym_GT] = ACTIONS(8164),
    [anon_sym_GT_GT] = ACTIONS(8162),
    [anon_sym_AMP_GT] = ACTIONS(8164),
    [anon_sym_AMP_GT_GT] = ACTIONS(8162),
    [anon_sym_LT_AMP] = ACTIONS(8162),
    [anon_sym_GT_AMP] = ACTIONS(8162),
    [anon_sym_LT_LT] = ACTIONS(8164),
    [anon_sym_LT_LT_DASH] = ACTIONS(8162),
    [anon_sym_LT_LT_LT] = ACTIONS(8162),
    [sym__special_characters] = ACTIONS(8162),
    [anon_sym_DQUOTE] = ACTIONS(8162),
    [anon_sym_DOLLAR] = ACTIONS(8164),
    [sym_raw_string] = ACTIONS(8162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8162),
    [anon_sym_BQUOTE] = ACTIONS(8162),
    [anon_sym_LT_LPAREN] = ACTIONS(8162),
    [anon_sym_GT_LPAREN] = ACTIONS(8162),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8162),
    [anon_sym_AMP] = ACTIONS(8164),
  },
  [4224] = {
    [sym__simple_heredoc_body] = ACTIONS(8166),
    [sym__heredoc_body_beginning] = ACTIONS(8166),
    [sym_file_descriptor] = ACTIONS(8166),
    [sym__concat] = ACTIONS(8166),
    [sym_variable_name] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_esac] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI_SEMI] = ACTIONS(8166),
    [anon_sym_PIPE_AMP] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_AMP_GT] = ACTIONS(8168),
    [anon_sym_AMP_GT_GT] = ACTIONS(8166),
    [anon_sym_LT_AMP] = ACTIONS(8166),
    [anon_sym_GT_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_LT_LT_DASH] = ACTIONS(8166),
    [anon_sym_LT_LT_LT] = ACTIONS(8166),
    [sym__special_characters] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(8168),
    [sym_raw_string] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8166),
    [anon_sym_BQUOTE] = ACTIONS(8166),
    [anon_sym_LT_LPAREN] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(8166),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8168),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = true}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = true}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = true}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = false}, SHIFT(16),
  [37] = {.count = 1, .reusable = false}, SHIFT(17),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = false}, SHIFT(18),
  [43] = {.count = 1, .reusable = true}, SHIFT(19),
  [45] = {.count = 1, .reusable = false}, SHIFT(20),
  [47] = {.count = 1, .reusable = true}, SHIFT(21),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(23),
  [53] = {.count = 1, .reusable = true}, SHIFT(24),
  [55] = {.count = 1, .reusable = true}, SHIFT(25),
  [57] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [59] = {.count = 1, .reusable = false}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(36),
  [63] = {.count = 1, .reusable = true}, SHIFT(36),
  [65] = {.count = 1, .reusable = true}, SHIFT(37),
  [67] = {.count = 1, .reusable = true}, SHIFT(38),
  [69] = {.count = 1, .reusable = true}, SHIFT(39),
  [71] = {.count = 1, .reusable = true}, SHIFT(40),
  [73] = {.count = 1, .reusable = true}, SHIFT(41),
  [75] = {.count = 1, .reusable = false}, SHIFT(42),
  [77] = {.count = 1, .reusable = true}, SHIFT(43),
  [79] = {.count = 1, .reusable = true}, SHIFT(44),
  [81] = {.count = 1, .reusable = false}, SHIFT(45),
  [83] = {.count = 1, .reusable = true}, SHIFT(46),
  [85] = {.count = 1, .reusable = true}, SHIFT(47),
  [87] = {.count = 1, .reusable = true}, SHIFT(48),
  [89] = {.count = 1, .reusable = true}, SHIFT(49),
  [91] = {.count = 1, .reusable = true}, SHIFT(50),
  [93] = {.count = 1, .reusable = false}, SHIFT(46),
  [95] = {.count = 1, .reusable = true}, SHIFT(42),
  [97] = {.count = 1, .reusable = true}, SHIFT(52),
  [99] = {.count = 1, .reusable = false}, SHIFT(53),
  [101] = {.count = 1, .reusable = true}, SHIFT(54),
  [103] = {.count = 1, .reusable = false}, SHIFT(55),
  [105] = {.count = 1, .reusable = false}, SHIFT(56),
  [107] = {.count = 1, .reusable = false}, SHIFT(57),
  [109] = {.count = 1, .reusable = false}, SHIFT(58),
  [111] = {.count = 1, .reusable = false}, SHIFT(59),
  [113] = {.count = 1, .reusable = true}, SHIFT(60),
  [115] = {.count = 1, .reusable = false}, SHIFT(61),
  [117] = {.count = 1, .reusable = false}, SHIFT(62),
  [119] = {.count = 1, .reusable = true}, SHIFT(63),
  [121] = {.count = 1, .reusable = false}, SHIFT(64),
  [123] = {.count = 1, .reusable = false}, SHIFT(65),
  [125] = {.count = 1, .reusable = false}, SHIFT(66),
  [127] = {.count = 1, .reusable = true}, SHIFT(67),
  [129] = {.count = 1, .reusable = false}, SHIFT(68),
  [131] = {.count = 1, .reusable = true}, SHIFT(69),
  [133] = {.count = 1, .reusable = true}, SHIFT(70),
  [135] = {.count = 1, .reusable = true}, SHIFT(71),
  [137] = {.count = 1, .reusable = true}, SHIFT(72),
  [139] = {.count = 1, .reusable = true}, SHIFT(73),
  [141] = {.count = 1, .reusable = false}, SHIFT(74),
  [143] = {.count = 1, .reusable = true}, SHIFT(83),
  [145] = {.count = 1, .reusable = true}, SHIFT(84),
  [147] = {.count = 1, .reusable = false}, SHIFT(85),
  [149] = {.count = 1, .reusable = true}, SHIFT(86),
  [151] = {.count = 1, .reusable = true}, SHIFT(87),
  [153] = {.count = 1, .reusable = true}, SHIFT(88),
  [155] = {.count = 1, .reusable = true}, SHIFT(89),
  [157] = {.count = 1, .reusable = true}, SHIFT(90),
  [159] = {.count = 1, .reusable = true}, SHIFT(92),
  [161] = {.count = 1, .reusable = true}, SHIFT(93),
  [163] = {.count = 1, .reusable = false}, SHIFT(94),
  [165] = {.count = 1, .reusable = false}, SHIFT(95),
  [167] = {.count = 1, .reusable = false}, SHIFT(96),
  [169] = {.count = 1, .reusable = false}, SHIFT(97),
  [171] = {.count = 1, .reusable = true}, SHIFT(98),
  [173] = {.count = 1, .reusable = false}, SHIFT(99),
  [175] = {.count = 1, .reusable = true}, SHIFT(107),
  [177] = {.count = 1, .reusable = false}, SHIFT(108),
  [179] = {.count = 1, .reusable = true}, SHIFT(109),
  [181] = {.count = 1, .reusable = false}, SHIFT(110),
  [183] = {.count = 1, .reusable = false}, SHIFT(111),
  [185] = {.count = 1, .reusable = false}, SHIFT(112),
  [187] = {.count = 1, .reusable = false}, SHIFT(113),
  [189] = {.count = 1, .reusable = false}, SHIFT(114),
  [191] = {.count = 1, .reusable = true}, SHIFT(115),
  [193] = {.count = 1, .reusable = true}, SHIFT(116),
  [195] = {.count = 1, .reusable = false}, SHIFT(117),
  [197] = {.count = 1, .reusable = false}, SHIFT(118),
  [199] = {.count = 1, .reusable = true}, SHIFT(119),
  [201] = {.count = 1, .reusable = false}, SHIFT(120),
  [203] = {.count = 1, .reusable = false}, SHIFT(121),
  [205] = {.count = 1, .reusable = false}, SHIFT(122),
  [207] = {.count = 1, .reusable = true}, SHIFT(123),
  [209] = {.count = 1, .reusable = false}, SHIFT(124),
  [211] = {.count = 1, .reusable = true}, SHIFT(125),
  [213] = {.count = 1, .reusable = true}, SHIFT(126),
  [215] = {.count = 1, .reusable = true}, SHIFT(127),
  [217] = {.count = 1, .reusable = true}, SHIFT(128),
  [219] = {.count = 1, .reusable = true}, SHIFT(129),
  [221] = {.count = 1, .reusable = false}, SHIFT(130),
  [223] = {.count = 1, .reusable = true}, SHIFT(139),
  [225] = {.count = 1, .reusable = true}, SHIFT(142),
  [227] = {.count = 1, .reusable = false}, SHIFT(143),
  [229] = {.count = 1, .reusable = true}, SHIFT(144),
  [231] = {.count = 1, .reusable = true}, SHIFT(145),
  [233] = {.count = 1, .reusable = false}, SHIFT(146),
  [235] = {.count = 1, .reusable = true}, SHIFT(147),
  [237] = {.count = 1, .reusable = true}, SHIFT(148),
  [239] = {.count = 1, .reusable = true}, SHIFT(149),
  [241] = {.count = 1, .reusable = true}, SHIFT(150),
  [243] = {.count = 1, .reusable = true}, SHIFT(151),
  [245] = {.count = 1, .reusable = false}, SHIFT(147),
  [247] = {.count = 1, .reusable = true}, SHIFT(143),
  [249] = {.count = 1, .reusable = false}, SHIFT(153),
  [251] = {.count = 1, .reusable = true}, SHIFT(154),
  [253] = {.count = 1, .reusable = true}, SHIFT(155),
  [255] = {.count = 1, .reusable = false}, SHIFT(155),
  [257] = {.count = 1, .reusable = true}, SHIFT(153),
  [259] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [261] = {.count = 1, .reusable = true}, SHIFT(157),
  [263] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [265] = {.count = 1, .reusable = true}, SHIFT(158),
  [267] = {.count = 1, .reusable = true}, SHIFT(159),
  [269] = {.count = 1, .reusable = false}, SHIFT(160),
  [271] = {.count = 1, .reusable = true}, SHIFT(161),
  [273] = {.count = 1, .reusable = true}, SHIFT(162),
  [275] = {.count = 1, .reusable = true}, SHIFT(163),
  [277] = {.count = 1, .reusable = true}, SHIFT(164),
  [279] = {.count = 1, .reusable = true}, SHIFT(165),
  [281] = {.count = 1, .reusable = false}, SHIFT(167),
  [283] = {.count = 1, .reusable = false}, SHIFT(161),
  [285] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [287] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [289] = {.count = 1, .reusable = true}, SHIFT(168),
  [291] = {.count = 1, .reusable = true}, SHIFT(169),
  [293] = {.count = 1, .reusable = false}, SHIFT(170),
  [295] = {.count = 1, .reusable = true}, SHIFT(171),
  [297] = {.count = 1, .reusable = true}, SHIFT(172),
  [299] = {.count = 1, .reusable = true}, SHIFT(173),
  [301] = {.count = 1, .reusable = true}, SHIFT(174),
  [303] = {.count = 1, .reusable = true}, SHIFT(175),
  [305] = {.count = 1, .reusable = false}, SHIFT(176),
  [307] = {.count = 1, .reusable = false}, SHIFT(171),
  [309] = {.count = 1, .reusable = true}, SHIFT(177),
  [311] = {.count = 1, .reusable = true}, SHIFT(178),
  [313] = {.count = 1, .reusable = false}, SHIFT(179),
  [315] = {.count = 1, .reusable = true}, SHIFT(180),
  [317] = {.count = 1, .reusable = true}, SHIFT(181),
  [319] = {.count = 1, .reusable = true}, SHIFT(182),
  [321] = {.count = 1, .reusable = true}, SHIFT(183),
  [323] = {.count = 1, .reusable = true}, SHIFT(184),
  [325] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [327] = {.count = 1, .reusable = true}, SHIFT(186),
  [329] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [331] = {.count = 1, .reusable = false}, SHIFT(188),
  [333] = {.count = 1, .reusable = false}, SHIFT(189),
  [335] = {.count = 1, .reusable = true}, SHIFT(190),
  [337] = {.count = 1, .reusable = false}, SHIFT(191),
  [339] = {.count = 1, .reusable = false}, SHIFT(192),
  [341] = {.count = 1, .reusable = false}, SHIFT(193),
  [343] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [345] = {.count = 1, .reusable = true}, SHIFT(195),
  [347] = {.count = 1, .reusable = true}, SHIFT(196),
  [349] = {.count = 1, .reusable = false}, SHIFT(197),
  [351] = {.count = 1, .reusable = true}, SHIFT(197),
  [353] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [355] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [357] = {.count = 1, .reusable = true}, SHIFT(198),
  [359] = {.count = 1, .reusable = true}, SHIFT(199),
  [361] = {.count = 1, .reusable = true}, SHIFT(200),
  [363] = {.count = 1, .reusable = false}, SHIFT(201),
  [365] = {.count = 1, .reusable = true}, SHIFT(201),
  [367] = {.count = 1, .reusable = true}, SHIFT(202),
  [369] = {.count = 1, .reusable = false}, SHIFT(203),
  [371] = {.count = 1, .reusable = true}, SHIFT(203),
  [373] = {.count = 1, .reusable = true}, SHIFT(206),
  [375] = {.count = 1, .reusable = false}, SHIFT(207),
  [377] = {.count = 1, .reusable = false}, SHIFT(208),
  [379] = {.count = 1, .reusable = false}, SHIFT(209),
  [381] = {.count = 1, .reusable = false}, SHIFT(210),
  [383] = {.count = 1, .reusable = true}, SHIFT(211),
  [385] = {.count = 1, .reusable = false}, SHIFT(212),
  [387] = {.count = 1, .reusable = true}, SHIFT(221),
  [389] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [391] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [393] = {.count = 1, .reusable = true}, SHIFT(222),
  [395] = {.count = 1, .reusable = true}, SHIFT(223),
  [397] = {.count = 1, .reusable = true}, SHIFT(224),
  [399] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [401] = {.count = 1, .reusable = false}, SHIFT(225),
  [403] = {.count = 1, .reusable = false}, SHIFT(226),
  [405] = {.count = 1, .reusable = true}, SHIFT(225),
  [407] = {.count = 1, .reusable = true}, SHIFT(226),
  [409] = {.count = 1, .reusable = true}, SHIFT(227),
  [411] = {.count = 1, .reusable = false}, SHIFT(228),
  [413] = {.count = 1, .reusable = true}, SHIFT(228),
  [415] = {.count = 1, .reusable = false}, SHIFT(229),
  [417] = {.count = 1, .reusable = true}, SHIFT(229),
  [419] = {.count = 1, .reusable = true}, SHIFT(230),
  [421] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [423] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [425] = {.count = 1, .reusable = false}, SHIFT(233),
  [427] = {.count = 1, .reusable = true}, SHIFT(234),
  [429] = {.count = 1, .reusable = true}, SHIFT(235),
  [431] = {.count = 1, .reusable = false}, SHIFT(235),
  [433] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [435] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [437] = {.count = 1, .reusable = true}, SHIFT(18),
  [439] = {.count = 1, .reusable = true}, SHIFT(242),
  [441] = {.count = 1, .reusable = true}, SHIFT(243),
  [443] = {.count = 1, .reusable = true}, SHIFT(245),
  [445] = {.count = 1, .reusable = true}, SHIFT(246),
  [447] = {.count = 1, .reusable = true}, SHIFT(248),
  [449] = {.count = 1, .reusable = true}, SHIFT(249),
  [451] = {.count = 1, .reusable = true}, SHIFT(250),
  [453] = {.count = 1, .reusable = true}, SHIFT(251),
  [455] = {.count = 1, .reusable = false}, SHIFT(252),
  [457] = {.count = 1, .reusable = true}, SHIFT(253),
  [459] = {.count = 1, .reusable = true}, SHIFT(254),
  [461] = {.count = 1, .reusable = true}, SHIFT(255),
  [463] = {.count = 1, .reusable = true}, SHIFT(256),
  [465] = {.count = 1, .reusable = true}, SHIFT(257),
  [467] = {.count = 1, .reusable = false}, SHIFT(258),
  [469] = {.count = 1, .reusable = true}, SHIFT(258),
  [471] = {.count = 1, .reusable = true}, SHIFT(259),
  [473] = {.count = 1, .reusable = false}, SHIFT(260),
  [475] = {.count = 1, .reusable = true}, SHIFT(261),
  [477] = {.count = 1, .reusable = true}, SHIFT(262),
  [479] = {.count = 1, .reusable = false}, SHIFT(263),
  [481] = {.count = 1, .reusable = true}, SHIFT(264),
  [483] = {.count = 1, .reusable = true}, SHIFT(265),
  [485] = {.count = 1, .reusable = true}, SHIFT(266),
  [487] = {.count = 1, .reusable = true}, SHIFT(267),
  [489] = {.count = 1, .reusable = true}, SHIFT(268),
  [491] = {.count = 1, .reusable = false}, SHIFT(264),
  [493] = {.count = 1, .reusable = true}, SHIFT(260),
  [495] = {.count = 1, .reusable = true}, SHIFT(270),
  [497] = {.count = 1, .reusable = false}, SHIFT(271),
  [499] = {.count = 1, .reusable = true}, SHIFT(271),
  [501] = {.count = 1, .reusable = true}, SHIFT(272),
  [503] = {.count = 1, .reusable = false}, SHIFT(273),
  [505] = {.count = 1, .reusable = true}, SHIFT(274),
  [507] = {.count = 1, .reusable = true}, SHIFT(275),
  [509] = {.count = 1, .reusable = false}, SHIFT(276),
  [511] = {.count = 1, .reusable = true}, SHIFT(277),
  [513] = {.count = 1, .reusable = true}, SHIFT(278),
  [515] = {.count = 1, .reusable = true}, SHIFT(279),
  [517] = {.count = 1, .reusable = true}, SHIFT(280),
  [519] = {.count = 1, .reusable = true}, SHIFT(281),
  [521] = {.count = 1, .reusable = false}, SHIFT(277),
  [523] = {.count = 1, .reusable = true}, SHIFT(273),
  [525] = {.count = 1, .reusable = true}, SHIFT(284),
  [527] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [529] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [531] = {.count = 1, .reusable = false}, SHIFT(286),
  [533] = {.count = 1, .reusable = false}, SHIFT(287),
  [535] = {.count = 1, .reusable = true}, SHIFT(289),
  [537] = {.count = 1, .reusable = true}, SHIFT(290),
  [539] = {.count = 1, .reusable = false}, SHIFT(291),
  [541] = {.count = 1, .reusable = true}, SHIFT(291),
  [543] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [545] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [547] = {.count = 1, .reusable = true}, SHIFT(292),
  [549] = {.count = 1, .reusable = true}, SHIFT(293),
  [551] = {.count = 1, .reusable = true}, SHIFT(294),
  [553] = {.count = 1, .reusable = false}, SHIFT(295),
  [555] = {.count = 1, .reusable = true}, SHIFT(295),
  [557] = {.count = 1, .reusable = true}, SHIFT(300),
  [559] = {.count = 1, .reusable = true}, SHIFT(301),
  [561] = {.count = 1, .reusable = true}, SHIFT(302),
  [563] = {.count = 1, .reusable = false}, SHIFT(301),
  [565] = {.count = 1, .reusable = true}, SHIFT(303),
  [567] = {.count = 1, .reusable = true}, SHIFT(304),
  [569] = {.count = 1, .reusable = true}, SHIFT(305),
  [571] = {.count = 1, .reusable = true}, SHIFT(306),
  [573] = {.count = 1, .reusable = true}, SHIFT(310),
  [575] = {.count = 1, .reusable = true}, SHIFT(311),
  [577] = {.count = 1, .reusable = true}, SHIFT(313),
  [579] = {.count = 1, .reusable = true}, SHIFT(315),
  [581] = {.count = 1, .reusable = true}, SHIFT(320),
  [583] = {.count = 1, .reusable = true}, SHIFT(321),
  [585] = {.count = 1, .reusable = true}, SHIFT(322),
  [587] = {.count = 1, .reusable = false}, SHIFT(323),
  [589] = {.count = 1, .reusable = true}, SHIFT(324),
  [591] = {.count = 1, .reusable = true}, SHIFT(325),
  [593] = {.count = 1, .reusable = true}, SHIFT(326),
  [595] = {.count = 1, .reusable = true}, SHIFT(327),
  [597] = {.count = 1, .reusable = true}, SHIFT(328),
  [599] = {.count = 1, .reusable = false}, SHIFT(330),
  [601] = {.count = 1, .reusable = false}, SHIFT(324),
  [603] = {.count = 1, .reusable = true}, SHIFT(331),
  [605] = {.count = 1, .reusable = true}, SHIFT(332),
  [607] = {.count = 1, .reusable = false}, SHIFT(333),
  [609] = {.count = 1, .reusable = true}, SHIFT(334),
  [611] = {.count = 1, .reusable = true}, SHIFT(335),
  [613] = {.count = 1, .reusable = true}, SHIFT(336),
  [615] = {.count = 1, .reusable = true}, SHIFT(337),
  [617] = {.count = 1, .reusable = true}, SHIFT(338),
  [619] = {.count = 1, .reusable = false}, SHIFT(339),
  [621] = {.count = 1, .reusable = false}, SHIFT(334),
  [623] = {.count = 1, .reusable = true}, SHIFT(340),
  [625] = {.count = 1, .reusable = false}, SHIFT(342),
  [627] = {.count = 1, .reusable = false}, SHIFT(343),
  [629] = {.count = 1, .reusable = true}, SHIFT(345),
  [631] = {.count = 1, .reusable = true}, SHIFT(346),
  [633] = {.count = 1, .reusable = false}, SHIFT(347),
  [635] = {.count = 1, .reusable = true}, SHIFT(347),
  [637] = {.count = 1, .reusable = true}, SHIFT(348),
  [639] = {.count = 1, .reusable = true}, SHIFT(349),
  [641] = {.count = 1, .reusable = true}, SHIFT(350),
  [643] = {.count = 1, .reusable = false}, SHIFT(351),
  [645] = {.count = 1, .reusable = true}, SHIFT(351),
  [647] = {.count = 1, .reusable = true}, SHIFT(356),
  [649] = {.count = 1, .reusable = true}, SHIFT(357),
  [651] = {.count = 1, .reusable = true}, SHIFT(359),
  [653] = {.count = 1, .reusable = false}, SHIFT(360),
  [655] = {.count = 1, .reusable = false}, SHIFT(361),
  [657] = {.count = 1, .reusable = true}, SHIFT(360),
  [659] = {.count = 1, .reusable = true}, SHIFT(361),
  [661] = {.count = 1, .reusable = true}, SHIFT(362),
  [663] = {.count = 1, .reusable = false}, SHIFT(363),
  [665] = {.count = 1, .reusable = true}, SHIFT(363),
  [667] = {.count = 1, .reusable = false}, SHIFT(364),
  [669] = {.count = 1, .reusable = true}, SHIFT(364),
  [671] = {.count = 1, .reusable = true}, SHIFT(365),
  [673] = {.count = 1, .reusable = false}, SHIFT(367),
  [675] = {.count = 1, .reusable = true}, SHIFT(368),
  [677] = {.count = 1, .reusable = true}, SHIFT(369),
  [679] = {.count = 1, .reusable = false}, SHIFT(369),
  [681] = {.count = 1, .reusable = true}, SHIFT(66),
  [683] = {.count = 1, .reusable = true}, SHIFT(372),
  [685] = {.count = 1, .reusable = true}, SHIFT(373),
  [687] = {.count = 1, .reusable = true}, SHIFT(374),
  [689] = {.count = 1, .reusable = false}, SHIFT(375),
  [691] = {.count = 1, .reusable = true}, SHIFT(375),
  [693] = {.count = 1, .reusable = false}, SHIFT(377),
  [695] = {.count = 1, .reusable = false}, SHIFT(378),
  [697] = {.count = 1, .reusable = true}, SHIFT(380),
  [699] = {.count = 1, .reusable = true}, SHIFT(381),
  [701] = {.count = 1, .reusable = false}, SHIFT(382),
  [703] = {.count = 1, .reusable = true}, SHIFT(382),
  [705] = {.count = 1, .reusable = true}, SHIFT(383),
  [707] = {.count = 1, .reusable = false}, SHIFT(384),
  [709] = {.count = 1, .reusable = true}, SHIFT(384),
  [711] = {.count = 1, .reusable = true}, SHIFT(385),
  [713] = {.count = 1, .reusable = true}, SHIFT(386),
  [715] = {.count = 1, .reusable = true}, SHIFT(387),
  [717] = {.count = 1, .reusable = false}, SHIFT(388),
  [719] = {.count = 1, .reusable = true}, SHIFT(388),
  [721] = {.count = 1, .reusable = true}, SHIFT(393),
  [723] = {.count = 1, .reusable = true}, SHIFT(395),
  [725] = {.count = 1, .reusable = true}, SHIFT(396),
  [727] = {.count = 1, .reusable = true}, SHIFT(397),
  [729] = {.count = 1, .reusable = true}, SHIFT(398),
  [731] = {.count = 1, .reusable = false}, SHIFT(400),
  [733] = {.count = 1, .reusable = false}, SHIFT(398),
  [735] = {.count = 1, .reusable = true}, SHIFT(401),
  [737] = {.count = 1, .reusable = true}, SHIFT(402),
  [739] = {.count = 1, .reusable = false}, SHIFT(403),
  [741] = {.count = 1, .reusable = false}, SHIFT(402),
  [743] = {.count = 1, .reusable = true}, SHIFT(405),
  [745] = {.count = 1, .reusable = true}, SHIFT(406),
  [747] = {.count = 1, .reusable = false}, SHIFT(407),
  [749] = {.count = 1, .reusable = true}, SHIFT(407),
  [751] = {.count = 1, .reusable = true}, SHIFT(408),
  [753] = {.count = 1, .reusable = false}, SHIFT(409),
  [755] = {.count = 1, .reusable = true}, SHIFT(409),
  [757] = {.count = 1, .reusable = true}, SHIFT(410),
  [759] = {.count = 1, .reusable = false}, SHIFT(412),
  [761] = {.count = 1, .reusable = true}, SHIFT(413),
  [763] = {.count = 1, .reusable = true}, SHIFT(414),
  [765] = {.count = 1, .reusable = false}, SHIFT(414),
  [767] = {.count = 1, .reusable = true}, SHIFT(97),
  [769] = {.count = 1, .reusable = true}, SHIFT(419),
  [771] = {.count = 1, .reusable = true}, SHIFT(420),
  [773] = {.count = 1, .reusable = true}, SHIFT(421),
  [775] = {.count = 1, .reusable = true}, SHIFT(425),
  [777] = {.count = 1, .reusable = true}, SHIFT(426),
  [779] = {.count = 1, .reusable = true}, SHIFT(428),
  [781] = {.count = 1, .reusable = true}, SHIFT(430),
  [783] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [785] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [787] = {.count = 1, .reusable = true}, SHIFT(435),
  [789] = {.count = 1, .reusable = false}, SHIFT(436),
  [791] = {.count = 1, .reusable = true}, SHIFT(437),
  [793] = {.count = 1, .reusable = false}, SHIFT(438),
  [795] = {.count = 1, .reusable = true}, SHIFT(439),
  [797] = {.count = 1, .reusable = true}, SHIFT(440),
  [799] = {.count = 1, .reusable = true}, SHIFT(441),
  [801] = {.count = 1, .reusable = true}, SHIFT(442),
  [803] = {.count = 1, .reusable = true}, SHIFT(443),
  [805] = {.count = 1, .reusable = false}, SHIFT(445),
  [807] = {.count = 1, .reusable = false}, SHIFT(439),
  [809] = {.count = 1, .reusable = false}, SHIFT(446),
  [811] = {.count = 1, .reusable = true}, SHIFT(447),
  [813] = {.count = 1, .reusable = false}, SHIFT(448),
  [815] = {.count = 1, .reusable = true}, SHIFT(449),
  [817] = {.count = 1, .reusable = true}, SHIFT(450),
  [819] = {.count = 1, .reusable = true}, SHIFT(451),
  [821] = {.count = 1, .reusable = true}, SHIFT(452),
  [823] = {.count = 1, .reusable = true}, SHIFT(453),
  [825] = {.count = 1, .reusable = false}, SHIFT(454),
  [827] = {.count = 1, .reusable = false}, SHIFT(449),
  [829] = {.count = 1, .reusable = true}, SHIFT(455),
  [831] = {.count = 1, .reusable = false}, SHIFT(457),
  [833] = {.count = 1, .reusable = false}, SHIFT(458),
  [835] = {.count = 1, .reusable = true}, SHIFT(460),
  [837] = {.count = 1, .reusable = true}, SHIFT(461),
  [839] = {.count = 1, .reusable = false}, SHIFT(462),
  [841] = {.count = 1, .reusable = true}, SHIFT(462),
  [843] = {.count = 1, .reusable = true}, SHIFT(463),
  [845] = {.count = 1, .reusable = true}, SHIFT(464),
  [847] = {.count = 1, .reusable = true}, SHIFT(465),
  [849] = {.count = 1, .reusable = false}, SHIFT(466),
  [851] = {.count = 1, .reusable = true}, SHIFT(466),
  [853] = {.count = 1, .reusable = true}, SHIFT(471),
  [855] = {.count = 1, .reusable = true}, SHIFT(472),
  [857] = {.count = 1, .reusable = true}, SHIFT(473),
  [859] = {.count = 1, .reusable = true}, SHIFT(474),
  [861] = {.count = 1, .reusable = true}, SHIFT(475),
  [863] = {.count = 1, .reusable = false}, SHIFT(476),
  [865] = {.count = 1, .reusable = false}, SHIFT(477),
  [867] = {.count = 1, .reusable = true}, SHIFT(476),
  [869] = {.count = 1, .reusable = true}, SHIFT(477),
  [871] = {.count = 1, .reusable = true}, SHIFT(478),
  [873] = {.count = 1, .reusable = false}, SHIFT(479),
  [875] = {.count = 1, .reusable = true}, SHIFT(479),
  [877] = {.count = 1, .reusable = false}, SHIFT(480),
  [879] = {.count = 1, .reusable = true}, SHIFT(480),
  [881] = {.count = 1, .reusable = true}, SHIFT(481),
  [883] = {.count = 1, .reusable = false}, SHIFT(484),
  [885] = {.count = 1, .reusable = false}, SHIFT(485),
  [887] = {.count = 1, .reusable = true}, SHIFT(486),
  [889] = {.count = 1, .reusable = false}, SHIFT(486),
  [891] = {.count = 1, .reusable = true}, SHIFT(122),
  [893] = {.count = 1, .reusable = true}, SHIFT(491),
  [895] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [897] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [899] = {.count = 1, .reusable = true}, SHIFT(494),
  [901] = {.count = 1, .reusable = false}, SHIFT(496),
  [903] = {.count = 1, .reusable = false}, SHIFT(497),
  [905] = {.count = 1, .reusable = true}, SHIFT(499),
  [907] = {.count = 1, .reusable = true}, SHIFT(500),
  [909] = {.count = 1, .reusable = false}, SHIFT(501),
  [911] = {.count = 1, .reusable = true}, SHIFT(501),
  [913] = {.count = 1, .reusable = true}, SHIFT(502),
  [915] = {.count = 1, .reusable = true}, SHIFT(503),
  [917] = {.count = 1, .reusable = true}, SHIFT(504),
  [919] = {.count = 1, .reusable = false}, SHIFT(505),
  [921] = {.count = 1, .reusable = true}, SHIFT(505),
  [923] = {.count = 1, .reusable = true}, SHIFT(510),
  [925] = {.count = 1, .reusable = true}, SHIFT(511),
  [927] = {.count = 1, .reusable = false}, SHIFT(510),
  [929] = {.count = 1, .reusable = true}, SHIFT(512),
  [931] = {.count = 1, .reusable = true}, SHIFT(515),
  [933] = {.count = 1, .reusable = true}, SHIFT(516),
  [935] = {.count = 1, .reusable = false}, SHIFT(515),
  [937] = {.count = 1, .reusable = true}, SHIFT(517),
  [939] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [941] = {.count = 1, .reusable = true}, SHIFT(518),
  [943] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [945] = {.count = 1, .reusable = false}, SHIFT(520),
  [947] = {.count = 1, .reusable = false}, SHIFT(521),
  [949] = {.count = 1, .reusable = true}, SHIFT(523),
  [951] = {.count = 1, .reusable = true}, SHIFT(524),
  [953] = {.count = 1, .reusable = false}, SHIFT(525),
  [955] = {.count = 1, .reusable = true}, SHIFT(525),
  [957] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [959] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [961] = {.count = 1, .reusable = true}, SHIFT(526),
  [963] = {.count = 1, .reusable = true}, SHIFT(527),
  [965] = {.count = 1, .reusable = true}, SHIFT(528),
  [967] = {.count = 1, .reusable = false}, SHIFT(529),
  [969] = {.count = 1, .reusable = true}, SHIFT(529),
  [971] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [973] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [975] = {.count = 1, .reusable = false}, SHIFT(534),
  [977] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [979] = {.count = 1, .reusable = true}, SHIFT(535),
  [981] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [983] = {.count = 1, .reusable = false}, SHIFT(537),
  [985] = {.count = 1, .reusable = false}, SHIFT(538),
  [987] = {.count = 1, .reusable = true}, SHIFT(540),
  [989] = {.count = 1, .reusable = true}, SHIFT(541),
  [991] = {.count = 1, .reusable = false}, SHIFT(542),
  [993] = {.count = 1, .reusable = true}, SHIFT(542),
  [995] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [997] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [999] = {.count = 1, .reusable = true}, SHIFT(543),
  [1001] = {.count = 1, .reusable = true}, SHIFT(544),
  [1003] = {.count = 1, .reusable = true}, SHIFT(545),
  [1005] = {.count = 1, .reusable = false}, SHIFT(546),
  [1007] = {.count = 1, .reusable = true}, SHIFT(546),
  [1009] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [1011] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [1013] = {.count = 1, .reusable = false}, SHIFT(551),
  [1015] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [1017] = {.count = 1, .reusable = true}, SHIFT(552),
  [1019] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [1021] = {.count = 1, .reusable = false}, SHIFT(554),
  [1023] = {.count = 1, .reusable = false}, SHIFT(555),
  [1025] = {.count = 1, .reusable = true}, SHIFT(557),
  [1027] = {.count = 1, .reusable = true}, SHIFT(558),
  [1029] = {.count = 1, .reusable = false}, SHIFT(559),
  [1031] = {.count = 1, .reusable = true}, SHIFT(559),
  [1033] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [1035] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [1037] = {.count = 1, .reusable = true}, SHIFT(560),
  [1039] = {.count = 1, .reusable = true}, SHIFT(561),
  [1041] = {.count = 1, .reusable = true}, SHIFT(562),
  [1043] = {.count = 1, .reusable = false}, SHIFT(563),
  [1045] = {.count = 1, .reusable = true}, SHIFT(563),
  [1047] = {.count = 1, .reusable = true}, SHIFT(568),
  [1049] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [1051] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [1053] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1055] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1057] = {.count = 1, .reusable = true}, SHIFT(570),
  [1059] = {.count = 1, .reusable = false}, SHIFT(571),
  [1061] = {.count = 1, .reusable = false}, SHIFT(570),
  [1063] = {.count = 1, .reusable = false}, SHIFT(572),
  [1065] = {.count = 1, .reusable = false}, SHIFT(573),
  [1067] = {.count = 1, .reusable = true}, SHIFT(573),
  [1069] = {.count = 1, .reusable = true}, SHIFT(574),
  [1071] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [1073] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [1075] = {.count = 1, .reusable = true}, SHIFT(575),
  [1077] = {.count = 1, .reusable = true}, SHIFT(576),
  [1079] = {.count = 1, .reusable = true}, SHIFT(577),
  [1081] = {.count = 1, .reusable = false}, SHIFT(578),
  [1083] = {.count = 1, .reusable = true}, SHIFT(578),
  [1085] = {.count = 1, .reusable = false}, SHIFT(582),
  [1087] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [1089] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [1091] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [1093] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2),
  [1097] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2),
  [1099] = {.count = 1, .reusable = true}, SHIFT(584),
  [1101] = {.count = 1, .reusable = true}, SHIFT(585),
  [1103] = {.count = 1, .reusable = true}, SHIFT(586),
  [1105] = {.count = 1, .reusable = true}, SHIFT(587),
  [1107] = {.count = 1, .reusable = false}, SHIFT(588),
  [1109] = {.count = 1, .reusable = true}, SHIFT(588),
  [1111] = {.count = 1, .reusable = true}, SHIFT(589),
  [1113] = {.count = 1, .reusable = false}, SHIFT(599),
  [1115] = {.count = 1, .reusable = false}, SHIFT(590),
  [1117] = {.count = 1, .reusable = true}, SHIFT(591),
  [1119] = {.count = 1, .reusable = false}, SHIFT(592),
  [1121] = {.count = 1, .reusable = true}, SHIFT(593),
  [1123] = {.count = 1, .reusable = true}, SHIFT(599),
  [1125] = {.count = 1, .reusable = true}, SHIFT(594),
  [1127] = {.count = 1, .reusable = true}, SHIFT(595),
  [1129] = {.count = 1, .reusable = true}, SHIFT(596),
  [1131] = {.count = 1, .reusable = true}, SHIFT(597),
  [1133] = {.count = 1, .reusable = true}, SHIFT(598),
  [1135] = {.count = 1, .reusable = false}, SHIFT(593),
  [1137] = {.count = 1, .reusable = true}, SHIFT(600),
  [1139] = {.count = 1, .reusable = false}, SHIFT(602),
  [1141] = {.count = 1, .reusable = true}, SHIFT(602),
  [1143] = {.count = 1, .reusable = true}, SHIFT(601),
  [1145] = {.count = 1, .reusable = false}, SHIFT(603),
  [1147] = {.count = 1, .reusable = true}, SHIFT(603),
  [1149] = {.count = 1, .reusable = true}, SHIFT(604),
  [1151] = {.count = 1, .reusable = true}, SHIFT(605),
  [1153] = {.count = 1, .reusable = true}, SHIFT(606),
  [1155] = {.count = 1, .reusable = true}, SHIFT(607),
  [1157] = {.count = 1, .reusable = true}, SHIFT(608),
  [1159] = {.count = 1, .reusable = true}, SHIFT(609),
  [1161] = {.count = 1, .reusable = true}, SHIFT(610),
  [1163] = {.count = 1, .reusable = false}, SHIFT(612),
  [1165] = {.count = 1, .reusable = false}, SHIFT(610),
  [1167] = {.count = 1, .reusable = true}, SHIFT(613),
  [1169] = {.count = 1, .reusable = true}, SHIFT(614),
  [1171] = {.count = 1, .reusable = false}, SHIFT(615),
  [1173] = {.count = 1, .reusable = false}, SHIFT(614),
  [1175] = {.count = 1, .reusable = true}, SHIFT(617),
  [1177] = {.count = 1, .reusable = false}, SHIFT(618),
  [1179] = {.count = 1, .reusable = false}, SHIFT(619),
  [1181] = {.count = 1, .reusable = true}, SHIFT(618),
  [1183] = {.count = 1, .reusable = true}, SHIFT(619),
  [1185] = {.count = 1, .reusable = true}, SHIFT(620),
  [1187] = {.count = 1, .reusable = false}, SHIFT(621),
  [1189] = {.count = 1, .reusable = true}, SHIFT(621),
  [1191] = {.count = 1, .reusable = true}, SHIFT(622),
  [1193] = {.count = 1, .reusable = false}, SHIFT(625),
  [1195] = {.count = 1, .reusable = true}, SHIFT(626),
  [1197] = {.count = 1, .reusable = true}, SHIFT(627),
  [1199] = {.count = 1, .reusable = false}, SHIFT(627),
  [1201] = {.count = 1, .reusable = true}, SHIFT(210),
  [1203] = {.count = 1, .reusable = true}, SHIFT(632),
  [1205] = {.count = 1, .reusable = true}, SHIFT(633),
  [1207] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [1209] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [1211] = {.count = 1, .reusable = true}, SHIFT(639),
  [1213] = {.count = 1, .reusable = true}, SHIFT(634),
  [1215] = {.count = 1, .reusable = false}, SHIFT(635),
  [1217] = {.count = 1, .reusable = true}, SHIFT(636),
  [1219] = {.count = 1, .reusable = true}, SHIFT(637),
  [1221] = {.count = 1, .reusable = true}, SHIFT(638),
  [1223] = {.count = 1, .reusable = false}, SHIFT(640),
  [1225] = {.count = 1, .reusable = true}, SHIFT(640),
  [1227] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [1229] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [1231] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [1233] = {.count = 1, .reusable = true}, SHIFT(645),
  [1235] = {.count = 1, .reusable = true}, SHIFT(646),
  [1237] = {.count = 1, .reusable = true}, SHIFT(648),
  [1239] = {.count = 1, .reusable = true}, SHIFT(649),
  [1241] = {.count = 1, .reusable = true}, SHIFT(650),
  [1243] = {.count = 1, .reusable = false}, SHIFT(652),
  [1245] = {.count = 1, .reusable = true}, SHIFT(652),
  [1247] = {.count = 1, .reusable = true}, REDUCE(sym_redirected_statement, 2),
  [1249] = {.count = 1, .reusable = false}, REDUCE(sym_redirected_statement, 2),
  [1251] = {.count = 1, .reusable = true}, SHIFT(654),
  [1253] = {.count = 1, .reusable = true}, SHIFT(655),
  [1255] = {.count = 1, .reusable = true}, SHIFT(656),
  [1257] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1259] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1261] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [1263] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [1265] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [1267] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [1269] = {.count = 1, .reusable = false}, SHIFT(658),
  [1271] = {.count = 1, .reusable = true}, SHIFT(658),
  [1273] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [1276] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(206),
  [1279] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4),
  [1282] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(5),
  [1285] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6),
  [1288] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7),
  [1291] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8),
  [1294] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9),
  [1297] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(10),
  [1300] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11),
  [1303] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(660),
  [1306] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(13),
  [1309] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [1312] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(661),
  [1315] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(662),
  [1318] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1321] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1324] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(210),
  [1327] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(19),
  [1330] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(20),
  [1333] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(211),
  [1336] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(22),
  [1339] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(23),
  [1342] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(24),
  [1345] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(25),
  [1348] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(212),
  [1351] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(139),
  [1357] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [1360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [1363] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1365] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1367] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1369] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1371] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1373] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1375] = {.count = 1, .reusable = true}, SHIFT(668),
  [1377] = {.count = 1, .reusable = true}, SHIFT(669),
  [1379] = {.count = 1, .reusable = true}, SHIFT(671),
  [1381] = {.count = 1, .reusable = true}, SHIFT(672),
  [1383] = {.count = 1, .reusable = true}, SHIFT(673),
  [1385] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1387] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1389] = {.count = 1, .reusable = true}, SHIFT(674),
  [1391] = {.count = 1, .reusable = true}, SHIFT(675),
  [1393] = {.count = 1, .reusable = true}, SHIFT(676),
  [1395] = {.count = 1, .reusable = false}, SHIFT(677),
  [1397] = {.count = 1, .reusable = true}, SHIFT(678),
  [1399] = {.count = 1, .reusable = true}, SHIFT(679),
  [1401] = {.count = 1, .reusable = true}, SHIFT(680),
  [1403] = {.count = 1, .reusable = true}, SHIFT(681),
  [1405] = {.count = 1, .reusable = true}, SHIFT(682),
  [1407] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1409] = {.count = 1, .reusable = true}, SHIFT(684),
  [1411] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1413] = {.count = 1, .reusable = false}, SHIFT(686),
  [1415] = {.count = 1, .reusable = false}, SHIFT(687),
  [1417] = {.count = 1, .reusable = true}, SHIFT(689),
  [1419] = {.count = 1, .reusable = true}, SHIFT(690),
  [1421] = {.count = 1, .reusable = false}, SHIFT(691),
  [1423] = {.count = 1, .reusable = true}, SHIFT(691),
  [1425] = {.count = 1, .reusable = true}, SHIFT(692),
  [1427] = {.count = 1, .reusable = true}, SHIFT(693),
  [1429] = {.count = 1, .reusable = true}, SHIFT(694),
  [1431] = {.count = 1, .reusable = false}, SHIFT(695),
  [1433] = {.count = 1, .reusable = true}, SHIFT(695),
  [1435] = {.count = 1, .reusable = false}, SHIFT(700),
  [1437] = {.count = 1, .reusable = true}, SHIFT(700),
  [1439] = {.count = 1, .reusable = true}, SHIFT(704),
  [1441] = {.count = 1, .reusable = false}, SHIFT(706),
  [1443] = {.count = 1, .reusable = false}, SHIFT(707),
  [1445] = {.count = 1, .reusable = true}, SHIFT(709),
  [1447] = {.count = 1, .reusable = true}, SHIFT(710),
  [1449] = {.count = 1, .reusable = false}, SHIFT(711),
  [1451] = {.count = 1, .reusable = true}, SHIFT(711),
  [1453] = {.count = 1, .reusable = true}, SHIFT(712),
  [1455] = {.count = 1, .reusable = true}, SHIFT(713),
  [1457] = {.count = 1, .reusable = true}, SHIFT(714),
  [1459] = {.count = 1, .reusable = false}, SHIFT(715),
  [1461] = {.count = 1, .reusable = true}, SHIFT(715),
  [1463] = {.count = 1, .reusable = false}, SHIFT(720),
  [1465] = {.count = 1, .reusable = true}, SHIFT(720),
  [1467] = {.count = 1, .reusable = true}, SHIFT(721),
  [1469] = {.count = 1, .reusable = true}, SHIFT(722),
  [1471] = {.count = 1, .reusable = false}, SHIFT(721),
  [1473] = {.count = 1, .reusable = true}, SHIFT(723),
  [1475] = {.count = 1, .reusable = true}, SHIFT(724),
  [1477] = {.count = 1, .reusable = true}, SHIFT(725),
  [1479] = {.count = 1, .reusable = false}, SHIFT(726),
  [1481] = {.count = 1, .reusable = true}, SHIFT(727),
  [1483] = {.count = 1, .reusable = true}, SHIFT(728),
  [1485] = {.count = 1, .reusable = true}, SHIFT(729),
  [1487] = {.count = 1, .reusable = true}, SHIFT(730),
  [1489] = {.count = 1, .reusable = true}, SHIFT(731),
  [1491] = {.count = 1, .reusable = true}, SHIFT(736),
  [1493] = {.count = 1, .reusable = false}, SHIFT(738),
  [1495] = {.count = 1, .reusable = false}, SHIFT(739),
  [1497] = {.count = 1, .reusable = true}, SHIFT(741),
  [1499] = {.count = 1, .reusable = true}, SHIFT(742),
  [1501] = {.count = 1, .reusable = false}, SHIFT(743),
  [1503] = {.count = 1, .reusable = true}, SHIFT(743),
  [1505] = {.count = 1, .reusable = true}, SHIFT(744),
  [1507] = {.count = 1, .reusable = true}, SHIFT(745),
  [1509] = {.count = 1, .reusable = true}, SHIFT(746),
  [1511] = {.count = 1, .reusable = false}, SHIFT(747),
  [1513] = {.count = 1, .reusable = true}, SHIFT(747),
  [1515] = {.count = 1, .reusable = true}, SHIFT(752),
  [1517] = {.count = 1, .reusable = true}, SHIFT(753),
  [1519] = {.count = 1, .reusable = true}, SHIFT(754),
  [1521] = {.count = 1, .reusable = false}, SHIFT(753),
  [1523] = {.count = 1, .reusable = true}, SHIFT(755),
  [1525] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1527] = {.count = 1, .reusable = true}, SHIFT(756),
  [1529] = {.count = 1, .reusable = false}, SHIFT(758),
  [1531] = {.count = 1, .reusable = false}, SHIFT(759),
  [1533] = {.count = 1, .reusable = true}, SHIFT(760),
  [1535] = {.count = 1, .reusable = true}, SHIFT(761),
  [1537] = {.count = 1, .reusable = true}, SHIFT(762),
  [1539] = {.count = 1, .reusable = false}, SHIFT(763),
  [1541] = {.count = 1, .reusable = true}, SHIFT(763),
  [1543] = {.count = 1, .reusable = true}, SHIFT(764),
  [1545] = {.count = 1, .reusable = false}, SHIFT(766),
  [1547] = {.count = 1, .reusable = true}, SHIFT(766),
  [1549] = {.count = 1, .reusable = true}, SHIFT(765),
  [1551] = {.count = 1, .reusable = true}, SHIFT(767),
  [1553] = {.count = 1, .reusable = false}, SHIFT(769),
  [1555] = {.count = 1, .reusable = true}, SHIFT(769),
  [1557] = {.count = 1, .reusable = true}, SHIFT(768),
  [1559] = {.count = 1, .reusable = true}, SHIFT(770),
  [1561] = {.count = 1, .reusable = true}, SHIFT(771),
  [1563] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1565] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1567] = {.count = 1, .reusable = true}, SHIFT(773),
  [1569] = {.count = 1, .reusable = true}, REDUCE(sym_postfix_expression, 2),
  [1571] = {.count = 1, .reusable = false}, REDUCE(sym_postfix_expression, 2),
  [1573] = {.count = 1, .reusable = true}, SHIFT(774),
  [1575] = {.count = 1, .reusable = true}, SHIFT(775),
  [1577] = {.count = 1, .reusable = true}, SHIFT(776),
  [1579] = {.count = 1, .reusable = true}, SHIFT(777),
  [1581] = {.count = 1, .reusable = false}, SHIFT(778),
  [1583] = {.count = 1, .reusable = true}, SHIFT(779),
  [1585] = {.count = 1, .reusable = true}, SHIFT(780),
  [1587] = {.count = 1, .reusable = true}, SHIFT(781),
  [1589] = {.count = 1, .reusable = true}, SHIFT(782),
  [1591] = {.count = 1, .reusable = true}, SHIFT(783),
  [1593] = {.count = 1, .reusable = false}, SHIFT(784),
  [1595] = {.count = 1, .reusable = true}, SHIFT(784),
  [1597] = {.count = 1, .reusable = true}, SHIFT(786),
  [1599] = {.count = 1, .reusable = false}, SHIFT(787),
  [1601] = {.count = 1, .reusable = true}, SHIFT(787),
  [1603] = {.count = 1, .reusable = true}, SHIFT(788),
  [1605] = {.count = 1, .reusable = true}, SHIFT(789),
  [1607] = {.count = 1, .reusable = true}, SHIFT(791),
  [1609] = {.count = 1, .reusable = true}, SHIFT(792),
  [1611] = {.count = 1, .reusable = false}, SHIFT(793),
  [1613] = {.count = 1, .reusable = true}, SHIFT(793),
  [1615] = {.count = 1, .reusable = true}, SHIFT(794),
  [1617] = {.count = 1, .reusable = false}, SHIFT(795),
  [1619] = {.count = 1, .reusable = true}, SHIFT(795),
  [1621] = {.count = 1, .reusable = true}, SHIFT(796),
  [1623] = {.count = 1, .reusable = true}, SHIFT(798),
  [1625] = {.count = 1, .reusable = true}, SHIFT(799),
  [1627] = {.count = 1, .reusable = true}, SHIFT(800),
  [1629] = {.count = 1, .reusable = true}, SHIFT(801),
  [1631] = {.count = 1, .reusable = false}, SHIFT(803),
  [1633] = {.count = 1, .reusable = false}, SHIFT(804),
  [1635] = {.count = 1, .reusable = true}, SHIFT(806),
  [1637] = {.count = 1, .reusable = true}, SHIFT(807),
  [1639] = {.count = 1, .reusable = false}, SHIFT(808),
  [1641] = {.count = 1, .reusable = true}, SHIFT(808),
  [1643] = {.count = 1, .reusable = true}, SHIFT(809),
  [1645] = {.count = 1, .reusable = true}, SHIFT(810),
  [1647] = {.count = 1, .reusable = true}, SHIFT(811),
  [1649] = {.count = 1, .reusable = false}, SHIFT(812),
  [1651] = {.count = 1, .reusable = true}, SHIFT(812),
  [1653] = {.count = 1, .reusable = false}, SHIFT(817),
  [1655] = {.count = 1, .reusable = true}, SHIFT(818),
  [1657] = {.count = 1, .reusable = false}, SHIFT(820),
  [1659] = {.count = 1, .reusable = false}, SHIFT(821),
  [1661] = {.count = 1, .reusable = true}, SHIFT(823),
  [1663] = {.count = 1, .reusable = true}, SHIFT(824),
  [1665] = {.count = 1, .reusable = false}, SHIFT(825),
  [1667] = {.count = 1, .reusable = true}, SHIFT(825),
  [1669] = {.count = 1, .reusable = true}, SHIFT(826),
  [1671] = {.count = 1, .reusable = true}, SHIFT(827),
  [1673] = {.count = 1, .reusable = true}, SHIFT(828),
  [1675] = {.count = 1, .reusable = false}, SHIFT(829),
  [1677] = {.count = 1, .reusable = true}, SHIFT(829),
  [1679] = {.count = 1, .reusable = false}, SHIFT(834),
  [1681] = {.count = 1, .reusable = true}, SHIFT(835),
  [1683] = {.count = 1, .reusable = false}, SHIFT(837),
  [1685] = {.count = 1, .reusable = false}, SHIFT(838),
  [1687] = {.count = 1, .reusable = true}, SHIFT(839),
  [1689] = {.count = 1, .reusable = true}, SHIFT(840),
  [1691] = {.count = 1, .reusable = true}, SHIFT(841),
  [1693] = {.count = 1, .reusable = false}, SHIFT(842),
  [1695] = {.count = 1, .reusable = true}, SHIFT(842),
  [1697] = {.count = 1, .reusable = true}, SHIFT(843),
  [1699] = {.count = 1, .reusable = false}, SHIFT(845),
  [1701] = {.count = 1, .reusable = true}, SHIFT(845),
  [1703] = {.count = 1, .reusable = true}, SHIFT(844),
  [1705] = {.count = 1, .reusable = true}, SHIFT(846),
  [1707] = {.count = 1, .reusable = false}, SHIFT(848),
  [1709] = {.count = 1, .reusable = true}, SHIFT(848),
  [1711] = {.count = 1, .reusable = true}, SHIFT(847),
  [1713] = {.count = 1, .reusable = true}, SHIFT(849),
  [1715] = {.count = 1, .reusable = true}, SHIFT(850),
  [1717] = {.count = 1, .reusable = true}, SHIFT(851),
  [1719] = {.count = 1, .reusable = true}, SHIFT(852),
  [1721] = {.count = 1, .reusable = false}, SHIFT(853),
  [1723] = {.count = 1, .reusable = false}, SHIFT(854),
  [1725] = {.count = 1, .reusable = false}, SHIFT(855),
  [1727] = {.count = 1, .reusable = false}, SHIFT(856),
  [1729] = {.count = 1, .reusable = false}, SHIFT(857),
  [1731] = {.count = 1, .reusable = true}, SHIFT(858),
  [1733] = {.count = 1, .reusable = false}, SHIFT(859),
  [1735] = {.count = 1, .reusable = true}, SHIFT(860),
  [1737] = {.count = 1, .reusable = true}, SHIFT(861),
  [1739] = {.count = 1, .reusable = true}, SHIFT(862),
  [1741] = {.count = 1, .reusable = true}, SHIFT(863),
  [1743] = {.count = 1, .reusable = true}, SHIFT(864),
  [1745] = {.count = 1, .reusable = false}, SHIFT(865),
  [1747] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1749] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1751] = {.count = 1, .reusable = false}, SHIFT(874),
  [1753] = {.count = 1, .reusable = true}, SHIFT(874),
  [1755] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [1757] = {.count = 1, .reusable = true}, SHIFT(879),
  [1759] = {.count = 1, .reusable = true}, SHIFT(880),
  [1761] = {.count = 1, .reusable = true}, SHIFT(882),
  [1763] = {.count = 1, .reusable = true}, SHIFT(883),
  [1765] = {.count = 1, .reusable = true}, SHIFT(884),
  [1767] = {.count = 1, .reusable = true}, SHIFT(887),
  [1769] = {.count = 1, .reusable = true}, SHIFT(888),
  [1771] = {.count = 1, .reusable = true}, SHIFT(889),
  [1773] = {.count = 1, .reusable = true}, SHIFT(892),
  [1775] = {.count = 1, .reusable = false}, SHIFT(893),
  [1777] = {.count = 1, .reusable = false}, SHIFT(894),
  [1779] = {.count = 1, .reusable = false}, SHIFT(895),
  [1781] = {.count = 1, .reusable = false}, SHIFT(896),
  [1783] = {.count = 1, .reusable = false}, SHIFT(897),
  [1785] = {.count = 1, .reusable = false}, SHIFT(898),
  [1787] = {.count = 1, .reusable = false}, SHIFT(899),
  [1789] = {.count = 1, .reusable = true}, SHIFT(900),
  [1791] = {.count = 1, .reusable = false}, SHIFT(901),
  [1793] = {.count = 1, .reusable = true}, SHIFT(902),
  [1795] = {.count = 1, .reusable = true}, SHIFT(903),
  [1797] = {.count = 1, .reusable = true}, SHIFT(904),
  [1799] = {.count = 1, .reusable = true}, SHIFT(905),
  [1801] = {.count = 1, .reusable = true}, SHIFT(906),
  [1803] = {.count = 1, .reusable = false}, SHIFT(907),
  [1805] = {.count = 1, .reusable = true}, SHIFT(918),
  [1807] = {.count = 1, .reusable = false}, SHIFT(919),
  [1809] = {.count = 1, .reusable = true}, SHIFT(919),
  [1811] = {.count = 1, .reusable = true}, SHIFT(920),
  [1813] = {.count = 1, .reusable = false}, SHIFT(922),
  [1815] = {.count = 1, .reusable = false}, SHIFT(923),
  [1817] = {.count = 1, .reusable = false}, SHIFT(924),
  [1819] = {.count = 1, .reusable = true}, SHIFT(924),
  [1821] = {.count = 1, .reusable = true}, SHIFT(925),
  [1823] = {.count = 1, .reusable = true}, SHIFT(926),
  [1825] = {.count = 1, .reusable = true}, SHIFT(927),
  [1827] = {.count = 1, .reusable = true}, SHIFT(928),
  [1829] = {.count = 1, .reusable = false}, SHIFT(929),
  [1831] = {.count = 1, .reusable = true}, SHIFT(929),
  [1833] = {.count = 1, .reusable = true}, SHIFT(930),
  [1835] = {.count = 1, .reusable = false}, SHIFT(932),
  [1837] = {.count = 1, .reusable = true}, SHIFT(932),
  [1839] = {.count = 1, .reusable = true}, SHIFT(931),
  [1841] = {.count = 1, .reusable = true}, SHIFT(933),
  [1843] = {.count = 1, .reusable = false}, SHIFT(935),
  [1845] = {.count = 1, .reusable = true}, SHIFT(935),
  [1847] = {.count = 1, .reusable = true}, SHIFT(934),
  [1849] = {.count = 1, .reusable = true}, SHIFT(936),
  [1851] = {.count = 1, .reusable = true}, SHIFT(937),
  [1853] = {.count = 1, .reusable = true}, SHIFT(938),
  [1855] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1857] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1859] = {.count = 1, .reusable = true}, SHIFT(939),
  [1861] = {.count = 1, .reusable = true}, SHIFT(940),
  [1863] = {.count = 1, .reusable = true}, SHIFT(941),
  [1865] = {.count = 1, .reusable = false}, SHIFT(943),
  [1867] = {.count = 1, .reusable = false}, SHIFT(945),
  [1869] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1871] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1873] = {.count = 1, .reusable = false}, SHIFT(947),
  [1875] = {.count = 1, .reusable = true}, SHIFT(947),
  [1877] = {.count = 1, .reusable = true}, SHIFT(952),
  [1879] = {.count = 1, .reusable = true}, SHIFT(953),
  [1881] = {.count = 1, .reusable = true}, SHIFT(954),
  [1883] = {.count = 1, .reusable = true}, SHIFT(955),
  [1885] = {.count = 1, .reusable = true}, SHIFT(957),
  [1887] = {.count = 1, .reusable = true}, SHIFT(958),
  [1889] = {.count = 1, .reusable = true}, SHIFT(961),
  [1891] = {.count = 1, .reusable = true}, SHIFT(962),
  [1893] = {.count = 1, .reusable = true}, SHIFT(963),
  [1895] = {.count = 1, .reusable = true}, SHIFT(964),
  [1897] = {.count = 1, .reusable = false}, SHIFT(965),
  [1899] = {.count = 1, .reusable = true}, SHIFT(966),
  [1901] = {.count = 1, .reusable = true}, SHIFT(967),
  [1903] = {.count = 1, .reusable = true}, SHIFT(968),
  [1905] = {.count = 1, .reusable = true}, SHIFT(969),
  [1907] = {.count = 1, .reusable = true}, SHIFT(970),
  [1909] = {.count = 1, .reusable = false}, SHIFT(971),
  [1911] = {.count = 1, .reusable = true}, SHIFT(971),
  [1913] = {.count = 1, .reusable = true}, SHIFT(973),
  [1915] = {.count = 1, .reusable = false}, SHIFT(974),
  [1917] = {.count = 1, .reusable = true}, SHIFT(974),
  [1919] = {.count = 1, .reusable = true}, SHIFT(975),
  [1921] = {.count = 1, .reusable = true}, SHIFT(976),
  [1923] = {.count = 1, .reusable = true}, SHIFT(978),
  [1925] = {.count = 1, .reusable = true}, SHIFT(979),
  [1927] = {.count = 1, .reusable = false}, SHIFT(980),
  [1929] = {.count = 1, .reusable = true}, SHIFT(980),
  [1931] = {.count = 1, .reusable = true}, SHIFT(981),
  [1933] = {.count = 1, .reusable = false}, SHIFT(982),
  [1935] = {.count = 1, .reusable = true}, SHIFT(982),
  [1937] = {.count = 1, .reusable = true}, SHIFT(983),
  [1939] = {.count = 1, .reusable = true}, SHIFT(985),
  [1941] = {.count = 1, .reusable = true}, SHIFT(986),
  [1943] = {.count = 1, .reusable = true}, SHIFT(987),
  [1945] = {.count = 1, .reusable = true}, SHIFT(988),
  [1947] = {.count = 1, .reusable = false}, SHIFT(990),
  [1949] = {.count = 1, .reusable = false}, SHIFT(991),
  [1951] = {.count = 1, .reusable = true}, SHIFT(993),
  [1953] = {.count = 1, .reusable = true}, SHIFT(994),
  [1955] = {.count = 1, .reusable = false}, SHIFT(995),
  [1957] = {.count = 1, .reusable = true}, SHIFT(995),
  [1959] = {.count = 1, .reusable = true}, SHIFT(996),
  [1961] = {.count = 1, .reusable = true}, SHIFT(997),
  [1963] = {.count = 1, .reusable = true}, SHIFT(998),
  [1965] = {.count = 1, .reusable = false}, SHIFT(999),
  [1967] = {.count = 1, .reusable = true}, SHIFT(999),
  [1969] = {.count = 1, .reusable = false}, SHIFT(1004),
  [1971] = {.count = 1, .reusable = true}, SHIFT(1005),
  [1973] = {.count = 1, .reusable = false}, SHIFT(1007),
  [1975] = {.count = 1, .reusable = false}, SHIFT(1008),
  [1977] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1979] = {.count = 1, .reusable = true}, SHIFT(1011),
  [1981] = {.count = 1, .reusable = false}, SHIFT(1012),
  [1983] = {.count = 1, .reusable = true}, SHIFT(1012),
  [1985] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1987] = {.count = 1, .reusable = true}, SHIFT(1014),
  [1989] = {.count = 1, .reusable = true}, SHIFT(1015),
  [1991] = {.count = 1, .reusable = false}, SHIFT(1016),
  [1993] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1995] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1997] = {.count = 1, .reusable = true}, SHIFT(1022),
  [1999] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2001] = {.count = 1, .reusable = false}, SHIFT(1025),
  [2003] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2005] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2007] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2009] = {.count = 1, .reusable = false}, SHIFT(1029),
  [2011] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2013] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2015] = {.count = 1, .reusable = false}, SHIFT(1032),
  [2017] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2019] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2021] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2023] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2025] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2027] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2029] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2031] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2035] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [2037] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2041] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2043] = {.count = 1, .reusable = false}, SHIFT(1041),
  [2045] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2047] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2049] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2051] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2053] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2055] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2057] = {.count = 1, .reusable = false}, SHIFT(1053),
  [2059] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2061] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2063] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2067] = {.count = 1, .reusable = false}, SHIFT(1059),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2071] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2075] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2081] = {.count = 1, .reusable = true}, SHIFT(1067),
  [2083] = {.count = 1, .reusable = false}, SHIFT(1069),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1070),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2089] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2091] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2095] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2097] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2099] = {.count = 1, .reusable = false}, SHIFT(1077),
  [2101] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2103] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2105] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2107] = {.count = 1, .reusable = false}, SHIFT(1080),
  [2109] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2111] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2113] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2115] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2117] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2119] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2121] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2123] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2125] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2129] = {.count = 1, .reusable = false}, SHIFT(1092),
  [2131] = {.count = 1, .reusable = false}, SHIFT(1093),
  [2133] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2135] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2137] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2139] = {.count = 1, .reusable = false}, SHIFT(1097),
  [2141] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2143] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2145] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2147] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2149] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2151] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2153] = {.count = 1, .reusable = false}, SHIFT(1103),
  [2155] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2157] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2159] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2161] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2163] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2165] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(157),
  [2168] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2170] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(158),
  [2173] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(159),
  [2176] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(160),
  [2179] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(161),
  [2182] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(162),
  [2185] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(163),
  [2188] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(164),
  [2191] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(165),
  [2194] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(534),
  [2197] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(161),
  [2200] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2202] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2204] = {.count = 1, .reusable = false}, SHIFT(1109),
  [2206] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2208] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2210] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2212] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2214] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2216] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2218] = {.count = 1, .reusable = false}, SHIFT(1116),
  [2220] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2222] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2224] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2226] = {.count = 1, .reusable = false}, SHIFT(1119),
  [2228] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2232] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2234] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2236] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [2238] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [2240] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(168),
  [2243] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(169),
  [2246] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(170),
  [2249] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(171),
  [2252] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(172),
  [2255] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(173),
  [2258] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(174),
  [2261] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(175),
  [2264] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(551),
  [2267] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(171),
  [2270] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2272] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2274] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2276] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2280] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2282] = {.count = 1, .reusable = false}, SHIFT(1129),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2288] = {.count = 1, .reusable = false}, SHIFT(1132),
  [2290] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2292] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2296] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2298] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2300] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2302] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2304] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2306] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2308] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2310] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(186),
  [2313] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [2315] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2319] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [2321] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [2323] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2329] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2333] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2335] = {.count = 1, .reusable = false}, SHIFT(1145),
  [2337] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1148),
  [2345] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2349] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2351] = {.count = 1, .reusable = false}, SHIFT(1150),
  [2353] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1151),
  [2356] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(190),
  [2359] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(191),
  [2362] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(192),
  [2365] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(193),
  [2368] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2370] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2372] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2374] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2376] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2378] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2380] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2382] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2384] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2386] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2388] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2390] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2392] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2394] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2396] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2398] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2400] = {.count = 1, .reusable = false}, SHIFT(1170),
  [2402] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2406] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [2408] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [2410] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2412] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [2414] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [2416] = {.count = 1, .reusable = false}, SHIFT(1173),
  [2418] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2424] = {.count = 1, .reusable = false}, SHIFT(1178),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2428] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [2430] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [2432] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2434] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2436] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2438] = {.count = 1, .reusable = false}, SHIFT(1182),
  [2440] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2442] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2444] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2446] = {.count = 1, .reusable = false}, SHIFT(1185),
  [2448] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2450] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2452] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2454] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [2456] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2460] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2462] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2464] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [2466] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2474] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2476] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2478] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2482] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2484] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2486] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2488] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2490] = {.count = 1, .reusable = false}, SHIFT(1212),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2494] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2498] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2500] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2502] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [2504] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [2506] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [2508] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [2510] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2512] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2514] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2516] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2518] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2520] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2522] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2524] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2526] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2528] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2530] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2532] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2534] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [2536] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [2538] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [2540] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [2542] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [2544] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [2546] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [2548] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [2550] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [2552] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [2554] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 3),
  [2556] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 3),
  [2558] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 3),
  [2560] = {.count = 1, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [2562] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(224),
  [2565] = {.count = 1, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [2567] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(228),
  [2570] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(228),
  [2573] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(229),
  [2576] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(229),
  [2579] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(230),
  [2582] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [2584] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [2586] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2588] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2590] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(233),
  [2593] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(234),
  [2596] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(19),
  [2599] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [2602] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(235),
  [2605] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2608] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(23),
  [2611] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(24),
  [2614] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(25),
  [2617] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(235),
  [2620] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2622] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2624] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2626] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2628] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2630] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2632] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2634] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2636] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2638] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2640] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2642] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2644] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2646] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [2648] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [2650] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2652] = {.count = 1, .reusable = false}, SHIFT(1067),
  [2654] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2656] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [2658] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2660] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2662] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2664] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2666] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2668] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2670] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2672] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2674] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2676] = {.count = 1, .reusable = false}, SHIFT(1257),
  [2678] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2680] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2682] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2686] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2688] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2690] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2696] = {.count = 1, .reusable = false}, SHIFT(1265),
  [2698] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2700] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2704] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2706] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2708] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2714] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2716] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2718] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2720] = {.count = 1, .reusable = false}, SHIFT(1282),
  [2722] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2724] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2726] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2728] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2730] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2736] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2738] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2740] = {.count = 1, .reusable = false}, SHIFT(1290),
  [2742] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2744] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2746] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [2748] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2750] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2752] = {.count = 1, .reusable = false}, SHIFT(1295),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2756] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2758] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2760] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2762] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2764] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2766] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2768] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2770] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2772] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2774] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2776] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2778] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2780] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2782] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2784] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2786] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2788] = {.count = 1, .reusable = false}, SHIFT(1313),
  [2790] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2792] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2796] = {.count = 1, .reusable = false}, SHIFT(1318),
  [2798] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2800] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2802] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2804] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2806] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2808] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2810] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2812] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2814] = {.count = 1, .reusable = false}, SHIFT(727),
  [2816] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4),
  [2818] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2822] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2824] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2826] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2828] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2830] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2832] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2834] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2836] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2838] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2840] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2842] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2844] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2846] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2848] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2850] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2852] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2854] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2856] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2858] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2860] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2862] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2864] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(284),
  [2867] = {.count = 1, .reusable = false}, SHIFT(1348),
  [2869] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2871] = {.count = 1, .reusable = false}, SHIFT(1350),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2879] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2885] = {.count = 1, .reusable = false}, SHIFT(1358),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2891] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2895] = {.count = 1, .reusable = false}, SHIFT(1361),
  [2897] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2901] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2903] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2907] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2909] = {.count = 1, .reusable = false}, SHIFT(1367),
  [2911] = {.count = 1, .reusable = false}, SHIFT(1368),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1371),
  [2917] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1372),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1373),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1375),
  [2927] = {.count = 1, .reusable = false}, SHIFT(1376),
  [2929] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1381),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2935] = {.count = 1, .reusable = false}, SHIFT(1383),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1386),
  [2941] = {.count = 1, .reusable = false}, SHIFT(1388),
  [2943] = {.count = 1, .reusable = false}, SHIFT(1392),
  [2945] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2947] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2949] = {.count = 1, .reusable = false}, SHIFT(1394),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2953] = {.count = 1, .reusable = true}, SHIFT(1395),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1396),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1397),
  [2959] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2965] = {.count = 1, .reusable = true}, SHIFT(1401),
  [2967] = {.count = 1, .reusable = false}, SHIFT(1403),
  [2969] = {.count = 1, .reusable = false}, SHIFT(1404),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1406),
  [2975] = {.count = 1, .reusable = true}, SHIFT(1407),
  [2977] = {.count = 1, .reusable = false}, SHIFT(1408),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1408),
  [2981] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2983] = {.count = 1, .reusable = false}, SHIFT(1411),
  [2985] = {.count = 1, .reusable = true}, SHIFT(1411),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1410),
  [2989] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2991] = {.count = 1, .reusable = false}, SHIFT(1414),
  [2993] = {.count = 1, .reusable = true}, SHIFT(1414),
  [2995] = {.count = 1, .reusable = true}, SHIFT(1413),
  [2997] = {.count = 1, .reusable = true}, SHIFT(1415),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3001] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(320),
  [3004] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(321),
  [3007] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(322),
  [3010] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(323),
  [3013] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(324),
  [3016] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(325),
  [3019] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(326),
  [3022] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(327),
  [3025] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(328),
  [3028] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(817),
  [3031] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(324),
  [3034] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3036] = {.count = 1, .reusable = false}, SHIFT(1419),
  [3038] = {.count = 1, .reusable = false}, SHIFT(1420),
  [3040] = {.count = 1, .reusable = true}, SHIFT(1421),
  [3042] = {.count = 1, .reusable = true}, SHIFT(1422),
  [3044] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3046] = {.count = 1, .reusable = false}, SHIFT(1424),
  [3048] = {.count = 1, .reusable = true}, SHIFT(1424),
  [3050] = {.count = 1, .reusable = true}, SHIFT(1425),
  [3052] = {.count = 1, .reusable = false}, SHIFT(1427),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3056] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3060] = {.count = 1, .reusable = false}, SHIFT(1430),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1430),
  [3064] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3070] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(331),
  [3073] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(332),
  [3076] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(333),
  [3079] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(334),
  [3082] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(335),
  [3085] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(336),
  [3088] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(337),
  [3091] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(338),
  [3094] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(834),
  [3097] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(334),
  [3100] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(340),
  [3103] = {.count = 1, .reusable = false}, SHIFT(1433),
  [3105] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3107] = {.count = 1, .reusable = false}, SHIFT(1435),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1441),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1443),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1442),
  [3127] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3131] = {.count = 1, .reusable = false}, SHIFT(1446),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3139] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [3141] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3149] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3161] = {.count = 1, .reusable = false}, SHIFT(1460),
  [3163] = {.count = 1, .reusable = false}, SHIFT(1454),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1461),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3169] = {.count = 1, .reusable = false}, SHIFT(1463),
  [3171] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3175] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3179] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3181] = {.count = 1, .reusable = false}, SHIFT(1469),
  [3183] = {.count = 1, .reusable = false}, SHIFT(1464),
  [3185] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3187] = {.count = 1, .reusable = false}, SHIFT(1472),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1473),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3193] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3195] = {.count = 1, .reusable = false}, SHIFT(1477),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3199] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3201] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3203] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3205] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3211] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3213] = {.count = 1, .reusable = false}, SHIFT(1488),
  [3215] = {.count = 1, .reusable = false}, SHIFT(1489),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3223] = {.count = 1, .reusable = false}, SHIFT(1491),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3229] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3231] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3233] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3235] = {.count = 1, .reusable = false}, SHIFT(1497),
  [3237] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [3239] = {.count = 1, .reusable = true}, SHIFT(857),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3243] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3245] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(359),
  [3248] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(363),
  [3251] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(363),
  [3254] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(364),
  [3257] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(364),
  [3260] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(365),
  [3263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(367),
  [3266] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(368),
  [3269] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(67),
  [3272] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(68),
  [3275] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(369),
  [3278] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(70),
  [3281] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(71),
  [3284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(72),
  [3287] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(73),
  [3290] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(369),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3295] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [3297] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [3299] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3301] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [3303] = {.count = 1, .reusable = false}, SHIFT(1509),
  [3305] = {.count = 1, .reusable = false}, SHIFT(1510),
  [3307] = {.count = 1, .reusable = false}, SHIFT(1511),
  [3309] = {.count = 1, .reusable = false}, SHIFT(1512),
  [3311] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3313] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3319] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3325] = {.count = 1, .reusable = false}, SHIFT(1520),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3329] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3333] = {.count = 1, .reusable = false}, SHIFT(1532),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3337] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3345] = {.count = 1, .reusable = false}, SHIFT(1539),
  [3347] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3353] = {.count = 1, .reusable = false}, SHIFT(1542),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3365] = {.count = 1, .reusable = false}, SHIFT(1548),
  [3367] = {.count = 1, .reusable = false}, SHIFT(1543),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3371] = {.count = 1, .reusable = false}, SHIFT(1551),
  [3373] = {.count = 1, .reusable = false}, SHIFT(1552),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3381] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3385] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3387] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3389] = {.count = 1, .reusable = false}, SHIFT(1560),
  [3391] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3393] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3395] = {.count = 1, .reusable = true}, SHIFT(894),
  [3397] = {.count = 1, .reusable = true}, SHIFT(895),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3401] = {.count = 1, .reusable = false}, SHIFT(1569),
  [3403] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3405] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3411] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3417] = {.count = 1, .reusable = false}, SHIFT(1576),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3423] = {.count = 1, .reusable = false}, SHIFT(1578),
  [3425] = {.count = 1, .reusable = true}, SHIFT(899),
  [3427] = {.count = 1, .reusable = false}, SHIFT(1584),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3433] = {.count = 1, .reusable = false}, SHIFT(1586),
  [3435] = {.count = 1, .reusable = false}, SHIFT(1590),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3439] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(373),
  [3442] = {.count = 1, .reusable = false}, SHIFT(1591),
  [3444] = {.count = 1, .reusable = false}, SHIFT(1592),
  [3446] = {.count = 1, .reusable = false}, SHIFT(1595),
  [3448] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3450] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3452] = {.count = 1, .reusable = false}, SHIFT(1597),
  [3454] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3456] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3458] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3460] = {.count = 1, .reusable = false}, SHIFT(1603),
  [3462] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3464] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3466] = {.count = 1, .reusable = false}, SHIFT(1605),
  [3468] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3470] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3472] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3476] = {.count = 1, .reusable = false}, SHIFT(1608),
  [3478] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3482] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3484] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3486] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(396),
  [3489] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(397),
  [3492] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(398),
  [3495] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(943),
  [3498] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(398),
  [3501] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(401),
  [3504] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(402),
  [3507] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(945),
  [3510] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(402),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3515] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3517] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(406),
  [3520] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(409),
  [3523] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(409),
  [3526] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(410),
  [3529] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(412),
  [3532] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(413),
  [3535] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(414),
  [3538] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(414),
  [3541] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3543] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3545] = {.count = 1, .reusable = false}, SHIFT(1623),
  [3547] = {.count = 1, .reusable = false}, SHIFT(1624),
  [3549] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3551] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3553] = {.count = 1, .reusable = false}, SHIFT(1628),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3563] = {.count = 1, .reusable = false}, SHIFT(1632),
  [3565] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3567] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3571] = {.count = 1, .reusable = false}, SHIFT(1639),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3575] = {.count = 1, .reusable = false}, SHIFT(1642),
  [3577] = {.count = 1, .reusable = false}, SHIFT(1644),
  [3579] = {.count = 1, .reusable = false}, SHIFT(1648),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3585] = {.count = 1, .reusable = false}, SHIFT(1650),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3603] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3605] = {.count = 1, .reusable = false}, SHIFT(1660),
  [3607] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3609] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3613] = {.count = 1, .reusable = false}, SHIFT(1664),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3619] = {.count = 1, .reusable = false}, SHIFT(1667),
  [3621] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3627] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3629] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3631] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3637] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(435),
  [3640] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(436),
  [3643] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(437),
  [3646] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(438),
  [3649] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(439),
  [3652] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(440),
  [3655] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(441),
  [3658] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(442),
  [3661] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(443),
  [3664] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1004),
  [3667] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(439),
  [3670] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3672] = {.count = 1, .reusable = false}, SHIFT(1675),
  [3674] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3676] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3678] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3680] = {.count = 1, .reusable = true}, SHIFT(1679),
  [3682] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3684] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3686] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3688] = {.count = 1, .reusable = false}, SHIFT(1683),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3692] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3696] = {.count = 1, .reusable = false}, SHIFT(1686),
  [3698] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3700] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3702] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3704] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3706] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(446),
  [3709] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(447),
  [3712] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(448),
  [3715] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(449),
  [3718] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(450),
  [3721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(451),
  [3724] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(452),
  [3727] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(453),
  [3730] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1021),
  [3733] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(449),
  [3736] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(455),
  [3739] = {.count = 1, .reusable = false}, SHIFT(1689),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3743] = {.count = 1, .reusable = false}, SHIFT(1691),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3747] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3749] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3751] = {.count = 1, .reusable = false}, SHIFT(1697),
  [3753] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3755] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3757] = {.count = 1, .reusable = false}, SHIFT(1699),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3761] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3765] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3767] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3771] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3775] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3779] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(475),
  [3782] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(479),
  [3785] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(479),
  [3788] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(480),
  [3791] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(480),
  [3794] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(481),
  [3797] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(484),
  [3800] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(485),
  [3803] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(123),
  [3806] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(124),
  [3809] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(486),
  [3812] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(126),
  [3815] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(127),
  [3818] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(128),
  [3821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(129),
  [3824] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(486),
  [3827] = {.count = 1, .reusable = false}, SHIFT(1710),
  [3829] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3833] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(494),
  [3836] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3838] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3840] = {.count = 1, .reusable = false}, SHIFT(1715),
  [3842] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3844] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3846] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3848] = {.count = 1, .reusable = false}, SHIFT(1721),
  [3850] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3852] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3854] = {.count = 1, .reusable = false}, SHIFT(1723),
  [3856] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3858] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3860] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3862] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3864] = {.count = 1, .reusable = false}, SHIFT(1726),
  [3866] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3868] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3870] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3872] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(518),
  [3875] = {.count = 1, .reusable = false}, SHIFT(1730),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3879] = {.count = 1, .reusable = false}, SHIFT(1732),
  [3881] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3883] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3885] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3887] = {.count = 1, .reusable = false}, SHIFT(1738),
  [3889] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3891] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3893] = {.count = 1, .reusable = false}, SHIFT(1740),
  [3895] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1739),
  [3899] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3903] = {.count = 1, .reusable = false}, SHIFT(1743),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1743),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3909] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(535),
  [3912] = {.count = 1, .reusable = false}, SHIFT(1745),
  [3914] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3916] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3918] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3920] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3922] = {.count = 1, .reusable = true}, SHIFT(1751),
  [3924] = {.count = 1, .reusable = false}, SHIFT(1753),
  [3926] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3928] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3930] = {.count = 1, .reusable = false}, SHIFT(1755),
  [3932] = {.count = 1, .reusable = true}, SHIFT(1755),
  [3934] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3936] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3940] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1759),
  [3946] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(552),
  [3949] = {.count = 1, .reusable = false}, SHIFT(1760),
  [3951] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3953] = {.count = 1, .reusable = false}, SHIFT(1762),
  [3955] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3957] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3959] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3961] = {.count = 1, .reusable = false}, SHIFT(1768),
  [3963] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3965] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3967] = {.count = 1, .reusable = false}, SHIFT(1770),
  [3969] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3975] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3977] = {.count = 1, .reusable = false}, SHIFT(1773),
  [3979] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3981] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3983] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [3985] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [3987] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3989] = {.count = 1, .reusable = false}, SHIFT(1776),
  [3991] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3993] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3995] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3997] = {.count = 1, .reusable = false}, SHIFT(1782),
  [3999] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4001] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4003] = {.count = 1, .reusable = false}, SHIFT(1784),
  [4005] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4007] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4009] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4011] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4013] = {.count = 1, .reusable = false}, SHIFT(1787),
  [4015] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4017] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4019] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [4021] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [4023] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4025] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4027] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4029] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4031] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4033] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [4035] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [4037] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4039] = {.count = 1, .reusable = true}, SHIFT(1795),
  [4041] = {.count = 1, .reusable = false}, SHIFT(1797),
  [4043] = {.count = 1, .reusable = false}, SHIFT(1798),
  [4045] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4047] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4049] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4051] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4053] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4055] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4057] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4059] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4061] = {.count = 1, .reusable = false}, SHIFT(1807),
  [4063] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4065] = {.count = 1, .reusable = false}, SHIFT(1812),
  [4067] = {.count = 1, .reusable = true}, SHIFT(1813),
  [4069] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [4071] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [4073] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4075] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4077] = {.count = 1, .reusable = false}, SHIFT(1817),
  [4079] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4081] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4083] = {.count = 1, .reusable = false}, SHIFT(1819),
  [4085] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4087] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4089] = {.count = 1, .reusable = false}, SHIFT(1822),
  [4091] = {.count = 1, .reusable = false}, SHIFT(1823),
  [4093] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4095] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4097] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4099] = {.count = 1, .reusable = false}, SHIFT(1827),
  [4101] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4103] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4105] = {.count = 1, .reusable = false}, SHIFT(1830),
  [4107] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4109] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4111] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4113] = {.count = 1, .reusable = false}, SHIFT(1833),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4117] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4119] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4121] = {.count = 1, .reusable = false}, SHIFT(1835),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4125] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [4127] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [4129] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4133] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [4135] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(1190),
  [4138] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(590),
  [4141] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(591),
  [4144] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(592),
  [4147] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(593),
  [4150] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(1190),
  [4153] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(594),
  [4156] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(596),
  [4159] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(597),
  [4162] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(598),
  [4165] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(593),
  [4168] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4172] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(608),
  [4175] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(609),
  [4178] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(610),
  [4181] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1199),
  [4184] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(610),
  [4187] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(613),
  [4190] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(614),
  [4193] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1201),
  [4196] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(614),
  [4199] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4201] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4203] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(617),
  [4206] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(621),
  [4209] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(621),
  [4212] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(622),
  [4215] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(625),
  [4218] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(626),
  [4221] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(627),
  [4224] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(627),
  [4227] = {.count = 1, .reusable = false}, SHIFT(1847),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4231] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [4233] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [4235] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4237] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4239] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4241] = {.count = 1, .reusable = false}, SHIFT(1851),
  [4243] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4245] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4247] = {.count = 1, .reusable = false}, SHIFT(1854),
  [4249] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4251] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4253] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4255] = {.count = 1, .reusable = false}, SHIFT(1857),
  [4257] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4259] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4261] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4263] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [4265] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [4267] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1231),
  [4270] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [4272] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(635),
  [4275] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(636),
  [4278] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(637),
  [4281] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(638),
  [4284] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 4),
  [4286] = {.count = 1, .reusable = false}, SHIFT(1860),
  [4288] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4290] = {.count = 1, .reusable = false}, SHIFT(660),
  [4292] = {.count = 1, .reusable = false}, SHIFT(661),
  [4294] = {.count = 1, .reusable = false}, SHIFT(662),
  [4296] = {.count = 1, .reusable = true}, SHIFT(1865),
  [4298] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4300] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4302] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4304] = {.count = 1, .reusable = false}, SHIFT(1869),
  [4306] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4308] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4310] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [4312] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4314] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [4316] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4318] = {.count = 1, .reusable = false}, SHIFT(1876),
  [4320] = {.count = 1, .reusable = false}, SHIFT(1877),
  [4322] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4324] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4326] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4328] = {.count = 1, .reusable = false}, SHIFT(1881),
  [4330] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4332] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4334] = {.count = 1, .reusable = false}, SHIFT(1884),
  [4336] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4338] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4340] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4342] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4344] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4346] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4348] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4350] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4352] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [4354] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [4356] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(675),
  [4361] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(676),
  [4364] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(677),
  [4367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(678),
  [4370] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(679),
  [4373] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(680),
  [4376] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(681),
  [4379] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(682),
  [4382] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(684),
  [4385] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4387] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4389] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4391] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4393] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4395] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4397] = {.count = 1, .reusable = false}, SHIFT(1898),
  [4399] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4401] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4403] = {.count = 1, .reusable = false}, SHIFT(1900),
  [4405] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4409] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4411] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4413] = {.count = 1, .reusable = false}, SHIFT(1903),
  [4415] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4417] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4419] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4421] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4423] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(704),
  [4426] = {.count = 1, .reusable = false}, SHIFT(1909),
  [4428] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4430] = {.count = 1, .reusable = false}, SHIFT(1911),
  [4432] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4434] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4436] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4438] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4440] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4442] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4444] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4446] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4448] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4450] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4452] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4454] = {.count = 1, .reusable = false}, SHIFT(1922),
  [4456] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4458] = {.count = 1, .reusable = true}, SHIFT(1923),
  [4460] = {.count = 1, .reusable = false}, SHIFT(1924),
  [4462] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4464] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4466] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4468] = {.count = 1, .reusable = false}, SHIFT(1928),
  [4470] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4472] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4474] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4476] = {.count = 1, .reusable = false}, SHIFT(1932),
  [4478] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4480] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4482] = {.count = 1, .reusable = false}, SHIFT(1935),
  [4484] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4486] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4488] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4490] = {.count = 1, .reusable = false}, SHIFT(1938),
  [4492] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4494] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4496] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4498] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4500] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4502] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(724),
  [4505] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(725),
  [4508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(726),
  [4511] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(727),
  [4514] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(728),
  [4517] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(729),
  [4520] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(730),
  [4523] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(731),
  [4526] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(727),
  [4529] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(736),
  [4532] = {.count = 1, .reusable = false}, SHIFT(1942),
  [4534] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4536] = {.count = 1, .reusable = false}, SHIFT(1944),
  [4538] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4540] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4542] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4544] = {.count = 1, .reusable = false}, SHIFT(1950),
  [4546] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4550] = {.count = 1, .reusable = false}, SHIFT(1952),
  [4552] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4558] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4560] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4562] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4566] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4568] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4570] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4572] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4574] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4576] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4578] = {.count = 1, .reusable = false}, SHIFT(1964),
  [4580] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4582] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4584] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4586] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4588] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4590] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4592] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4594] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4596] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4598] = {.count = 1, .reusable = false}, SHIFT(1972),
  [4600] = {.count = 1, .reusable = false}, SHIFT(1973),
  [4602] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4604] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4606] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4608] = {.count = 1, .reusable = false}, SHIFT(1977),
  [4610] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4612] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4614] = {.count = 1, .reusable = false}, SHIFT(1980),
  [4616] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4618] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4620] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4622] = {.count = 1, .reusable = false}, SHIFT(1983),
  [4624] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4626] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4628] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4630] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4632] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4634] = {.count = 1, .reusable = false}, SHIFT(1988),
  [4636] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4638] = {.count = 1, .reusable = false}, SHIFT(1990),
  [4640] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4642] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4644] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4646] = {.count = 1, .reusable = false}, SHIFT(1995),
  [4648] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4650] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4652] = {.count = 1, .reusable = false}, SHIFT(1999),
  [4654] = {.count = 1, .reusable = false}, SHIFT(2002),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4658] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4660] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(801),
  [4663] = {.count = 1, .reusable = false}, SHIFT(2006),
  [4665] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4667] = {.count = 1, .reusable = false}, SHIFT(2008),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4671] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4673] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4675] = {.count = 1, .reusable = false}, SHIFT(2014),
  [4677] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4679] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4681] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4683] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4685] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4687] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4689] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4691] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4695] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4697] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(818),
  [4700] = {.count = 1, .reusable = false}, SHIFT(2021),
  [4702] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4704] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4706] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4708] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4710] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4712] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4714] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4716] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4718] = {.count = 1, .reusable = false}, SHIFT(2031),
  [4720] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4722] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4724] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4726] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4728] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4730] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4734] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4736] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4738] = {.count = 1, .reusable = false}, SHIFT(2038),
  [4740] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4742] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4744] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4746] = {.count = 1, .reusable = false}, SHIFT(2043),
  [4748] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4750] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4752] = {.count = 1, .reusable = false}, SHIFT(2045),
  [4754] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4756] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4758] = {.count = 1, .reusable = false}, SHIFT(2047),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4762] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4764] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4766] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4768] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4770] = {.count = 1, .reusable = false}, SHIFT(2052),
  [4772] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4774] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4776] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4778] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4780] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4782] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4784] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4786] = {.count = 1, .reusable = false}, SHIFT(2061),
  [4788] = {.count = 1, .reusable = false}, SHIFT(2062),
  [4790] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4792] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4794] = {.count = 1, .reusable = false}, SHIFT(2066),
  [4796] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4798] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4800] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4802] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4804] = {.count = 1, .reusable = false}, SHIFT(2070),
  [4806] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4808] = {.count = 1, .reusable = false}, SHIFT(2075),
  [4810] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4812] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4814] = {.count = 1, .reusable = false}, SHIFT(2079),
  [4816] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4818] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4820] = {.count = 1, .reusable = false}, SHIFT(2083),
  [4822] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4826] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4828] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4830] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4832] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4834] = {.count = 1, .reusable = false}, SHIFT(2092),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4838] = {.count = 1, .reusable = false}, SHIFT(2095),
  [4840] = {.count = 1, .reusable = false}, SHIFT(2096),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4844] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4848] = {.count = 1, .reusable = false}, SHIFT(2100),
  [4850] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4854] = {.count = 1, .reusable = false}, SHIFT(2103),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4860] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4862] = {.count = 1, .reusable = false}, SHIFT(2106),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4866] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4868] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4872] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [4874] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [4876] = {.count = 1, .reusable = false}, SHIFT(2109),
  [4878] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4880] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 2),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4884] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4886] = {.count = 1, .reusable = false}, SHIFT(2116),
  [4888] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4890] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4892] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4894] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4896] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4898] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4900] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4902] = {.count = 1, .reusable = false}, SHIFT(2124),
  [4904] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4906] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4908] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4910] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4912] = {.count = 1, .reusable = false}, SHIFT(2130),
  [4914] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4916] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4918] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4920] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4924] = {.count = 1, .reusable = false}, SHIFT(2138),
  [4926] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4928] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4930] = {.count = 1, .reusable = true}, SHIFT(2141),
  [4932] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4934] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4936] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4938] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4940] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4942] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4944] = {.count = 1, .reusable = true}, SHIFT(2148),
  [4946] = {.count = 1, .reusable = false}, SHIFT(2149),
  [4948] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4950] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4952] = {.count = 1, .reusable = true}, SHIFT(2152),
  [4954] = {.count = 1, .reusable = true}, SHIFT(2153),
  [4956] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4958] = {.count = 1, .reusable = false}, SHIFT(2156),
  [4960] = {.count = 1, .reusable = false}, SHIFT(2150),
  [4962] = {.count = 1, .reusable = true}, SHIFT(2157),
  [4964] = {.count = 1, .reusable = true}, SHIFT(2158),
  [4966] = {.count = 1, .reusable = false}, SHIFT(2159),
  [4968] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4970] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4972] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4974] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4976] = {.count = 1, .reusable = true}, SHIFT(2164),
  [4978] = {.count = 1, .reusable = false}, SHIFT(2165),
  [4980] = {.count = 1, .reusable = false}, SHIFT(2160),
  [4982] = {.count = 1, .reusable = true}, SHIFT(2166),
  [4984] = {.count = 1, .reusable = false}, SHIFT(2168),
  [4986] = {.count = 1, .reusable = false}, SHIFT(2169),
  [4988] = {.count = 1, .reusable = true}, SHIFT(2171),
  [4990] = {.count = 1, .reusable = true}, SHIFT(2172),
  [4992] = {.count = 1, .reusable = false}, SHIFT(2173),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2173),
  [4996] = {.count = 1, .reusable = true}, SHIFT(2174),
  [4998] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2176),
  [5002] = {.count = 1, .reusable = false}, SHIFT(2177),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5006] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 2),
  [5008] = {.count = 1, .reusable = true}, SHIFT(2182),
  [5010] = {.count = 1, .reusable = false}, SHIFT(2183),
  [5012] = {.count = 1, .reusable = false}, SHIFT(2184),
  [5014] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5016] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5020] = {.count = 1, .reusable = false}, SHIFT(2186),
  [5022] = {.count = 1, .reusable = true}, SHIFT(2186),
  [5024] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5026] = {.count = 1, .reusable = false}, SHIFT(2190),
  [5028] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5030] = {.count = 1, .reusable = true}, SHIFT(2192),
  [5032] = {.count = 1, .reusable = false}, SHIFT(2192),
  [5034] = {.count = 1, .reusable = true}, SHIFT(1512),
  [5036] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5038] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5040] = {.count = 1, .reusable = false}, SHIFT(2200),
  [5042] = {.count = 1, .reusable = false}, SHIFT(2201),
  [5044] = {.count = 1, .reusable = true}, SHIFT(2203),
  [5046] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5048] = {.count = 1, .reusable = false}, SHIFT(2205),
  [5050] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5052] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5054] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5056] = {.count = 1, .reusable = true}, SHIFT(2208),
  [5058] = {.count = 1, .reusable = false}, SHIFT(2209),
  [5060] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5062] = {.count = 1, .reusable = false}, SHIFT(2214),
  [5064] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5066] = {.count = 1, .reusable = false}, SHIFT(2217),
  [5068] = {.count = 1, .reusable = false}, SHIFT(2218),
  [5070] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5074] = {.count = 1, .reusable = false}, SHIFT(2222),
  [5076] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5080] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5082] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5084] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5086] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5088] = {.count = 1, .reusable = false}, SHIFT(2231),
  [5090] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5092] = {.count = 1, .reusable = false}, SHIFT(2234),
  [5094] = {.count = 1, .reusable = false}, SHIFT(2235),
  [5096] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5098] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5100] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5102] = {.count = 1, .reusable = false}, SHIFT(2239),
  [5104] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5106] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5108] = {.count = 1, .reusable = false}, SHIFT(2242),
  [5110] = {.count = 1, .reusable = true}, SHIFT(2242),
  [5112] = {.count = 1, .reusable = true}, SHIFT(2241),
  [5114] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5116] = {.count = 1, .reusable = false}, SHIFT(2245),
  [5118] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5122] = {.count = 1, .reusable = true}, SHIFT(2246),
  [5124] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5126] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [5128] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [5130] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5132] = {.count = 1, .reusable = false}, SHIFT(2250),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5136] = {.count = 1, .reusable = true}, SHIFT(2255),
  [5138] = {.count = 1, .reusable = true}, SHIFT(2256),
  [5140] = {.count = 1, .reusable = true}, SHIFT(2257),
  [5142] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5144] = {.count = 1, .reusable = false}, SHIFT(2259),
  [5146] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5148] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5150] = {.count = 1, .reusable = true}, SHIFT(2262),
  [5152] = {.count = 1, .reusable = true}, SHIFT(2263),
  [5154] = {.count = 1, .reusable = false}, SHIFT(2265),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5158] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [5160] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(894),
  [5163] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [5165] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [5167] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5169] = {.count = 1, .reusable = true}, SHIFT(2269),
  [5171] = {.count = 1, .reusable = true}, SHIFT(2272),
  [5173] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5175] = {.count = 1, .reusable = false}, SHIFT(2274),
  [5177] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [5179] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [5181] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5183] = {.count = 1, .reusable = false}, SHIFT(2278),
  [5185] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5187] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5189] = {.count = 1, .reusable = false}, SHIFT(2283),
  [5191] = {.count = 1, .reusable = true}, SHIFT(2284),
  [5193] = {.count = 1, .reusable = true}, SHIFT(2286),
  [5195] = {.count = 1, .reusable = true}, SHIFT(2287),
  [5197] = {.count = 1, .reusable = false}, SHIFT(2288),
  [5199] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5201] = {.count = 1, .reusable = true}, SHIFT(2289),
  [5203] = {.count = 1, .reusable = false}, SHIFT(2290),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5207] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5209] = {.count = 1, .reusable = false}, SHIFT(2292),
  [5211] = {.count = 1, .reusable = true}, SHIFT(2292),
  [5213] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [5215] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [5217] = {.count = 1, .reusable = true}, SHIFT(2295),
  [5219] = {.count = 1, .reusable = true}, SHIFT(2296),
  [5221] = {.count = 1, .reusable = false}, SHIFT(2298),
  [5223] = {.count = 1, .reusable = false}, SHIFT(2299),
  [5225] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5227] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5229] = {.count = 1, .reusable = true}, SHIFT(2302),
  [5231] = {.count = 1, .reusable = false}, SHIFT(2303),
  [5233] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5235] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5237] = {.count = 1, .reusable = false}, SHIFT(2306),
  [5239] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5241] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5243] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5245] = {.count = 1, .reusable = false}, SHIFT(2309),
  [5247] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5249] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5251] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5253] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5255] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5257] = {.count = 1, .reusable = false}, SHIFT(2314),
  [5259] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5261] = {.count = 1, .reusable = false}, SHIFT(2316),
  [5263] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5265] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5267] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5269] = {.count = 1, .reusable = false}, SHIFT(2321),
  [5271] = {.count = 1, .reusable = false}, SHIFT(2324),
  [5273] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5275] = {.count = 1, .reusable = false}, SHIFT(2325),
  [5277] = {.count = 1, .reusable = false}, SHIFT(2328),
  [5279] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5281] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(988),
  [5286] = {.count = 1, .reusable = false}, SHIFT(2332),
  [5288] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5290] = {.count = 1, .reusable = false}, SHIFT(2334),
  [5292] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5294] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5296] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5298] = {.count = 1, .reusable = false}, SHIFT(2340),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5302] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5304] = {.count = 1, .reusable = false}, SHIFT(2342),
  [5306] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5308] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5310] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5312] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5314] = {.count = 1, .reusable = false}, SHIFT(2345),
  [5316] = {.count = 1, .reusable = true}, SHIFT(2345),
  [5318] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5320] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1005),
  [5323] = {.count = 1, .reusable = false}, SHIFT(2347),
  [5325] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5327] = {.count = 1, .reusable = false}, SHIFT(2349),
  [5329] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5331] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5333] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5335] = {.count = 1, .reusable = false}, SHIFT(2355),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5339] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5341] = {.count = 1, .reusable = false}, SHIFT(2357),
  [5343] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5345] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5349] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5351] = {.count = 1, .reusable = false}, SHIFT(2360),
  [5353] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5357] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5361] = {.count = 1, .reusable = false}, SHIFT(2364),
  [5363] = {.count = 1, .reusable = true}, SHIFT(2365),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5367] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5369] = {.count = 1, .reusable = false}, SHIFT(2369),
  [5371] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5375] = {.count = 1, .reusable = false}, SHIFT(2371),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5381] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5383] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5389] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5391] = {.count = 1, .reusable = false}, SHIFT(2378),
  [5393] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5395] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5397] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5399] = {.count = 1, .reusable = false}, SHIFT(2383),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5405] = {.count = 1, .reusable = false}, SHIFT(2385),
  [5407] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5411] = {.count = 1, .reusable = false}, SHIFT(2387),
  [5413] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5417] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5419] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5421] = {.count = 1, .reusable = false}, SHIFT(2391),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5425] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5429] = {.count = 1, .reusable = false}, SHIFT(2396),
  [5431] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5433] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5435] = {.count = 1, .reusable = false}, SHIFT(2398),
  [5437] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5439] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5441] = {.count = 1, .reusable = false}, SHIFT(2400),
  [5443] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5445] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5447] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5449] = {.count = 1, .reusable = false}, SHIFT(2403),
  [5451] = {.count = 1, .reusable = true}, SHIFT(2404),
  [5453] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5455] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5457] = {.count = 1, .reusable = false}, SHIFT(2408),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5463] = {.count = 1, .reusable = false}, SHIFT(2410),
  [5465] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5469] = {.count = 1, .reusable = false}, SHIFT(2412),
  [5471] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5473] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5475] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5477] = {.count = 1, .reusable = false}, SHIFT(2415),
  [5479] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5481] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5483] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5485] = {.count = 1, .reusable = false}, SHIFT(2420),
  [5487] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5489] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5491] = {.count = 1, .reusable = false}, SHIFT(2422),
  [5493] = {.count = 1, .reusable = true}, SHIFT(2422),
  [5495] = {.count = 1, .reusable = true}, SHIFT(2423),
  [5497] = {.count = 1, .reusable = false}, SHIFT(2424),
  [5499] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5501] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5503] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5505] = {.count = 1, .reusable = false}, SHIFT(2427),
  [5507] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5509] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5511] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5513] = {.count = 1, .reusable = false}, SHIFT(2432),
  [5515] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5517] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5519] = {.count = 1, .reusable = false}, SHIFT(2434),
  [5521] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5523] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5525] = {.count = 1, .reusable = false}, SHIFT(2436),
  [5527] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5529] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5531] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5533] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [5535] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5537] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5539] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5543] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [5545] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [5547] = {.count = 1, .reusable = false}, SHIFT(2443),
  [5549] = {.count = 1, .reusable = false}, SHIFT(2444),
  [5551] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [5553] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [5555] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5557] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5561] = {.count = 1, .reusable = false}, SHIFT(2448),
  [5563] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5565] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5567] = {.count = 1, .reusable = false}, SHIFT(2451),
  [5569] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5571] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5573] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5575] = {.count = 1, .reusable = false}, SHIFT(2454),
  [5577] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5579] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5581] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5583] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5585] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5587] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2459),
  [5591] = {.count = 1, .reusable = false}, SHIFT(2460),
  [5593] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5595] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [5597] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [5599] = {.count = 1, .reusable = false}, SHIFT(2461),
  [5601] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5603] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1171),
  [5606] = {.count = 1, .reusable = false}, SHIFT(2462),
  [5608] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5610] = {.count = 1, .reusable = false}, SHIFT(2464),
  [5612] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5614] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5618] = {.count = 1, .reusable = false}, SHIFT(2470),
  [5620] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5624] = {.count = 1, .reusable = false}, SHIFT(2472),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5634] = {.count = 1, .reusable = false}, SHIFT(2475),
  [5636] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5640] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [5642] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [5644] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5648] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5652] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5656] = {.count = 1, .reusable = false}, SHIFT(2487),
  [5658] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5660] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5662] = {.count = 1, .reusable = false}, SHIFT(2489),
  [5664] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5668] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5670] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5672] = {.count = 1, .reusable = false}, SHIFT(2492),
  [5674] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5676] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5678] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5682] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1239),
  [5685] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1243),
  [5688] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1243),
  [5691] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1244),
  [5694] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [5696] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [5698] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1254),
  [5701] = {.count = 1, .reusable = false}, SHIFT(2497),
  [5703] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5705] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5707] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5709] = {.count = 1, .reusable = true}, SHIFT(2502),
  [5711] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5713] = {.count = 1, .reusable = false}, SHIFT(2505),
  [5715] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2504),
  [5719] = {.count = 1, .reusable = false}, SHIFT(2507),
  [5721] = {.count = 1, .reusable = true}, SHIFT(2507),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5725] = {.count = 1, .reusable = true}, SHIFT(2508),
  [5727] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5729] = {.count = 1, .reusable = false}, SHIFT(2510),
  [5731] = {.count = 1, .reusable = true}, SHIFT(2510),
  [5733] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5735] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5737] = {.count = 1, .reusable = true}, SHIFT(2513),
  [5739] = {.count = 1, .reusable = false}, SHIFT(2514),
  [5741] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5743] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5745] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5747] = {.count = 1, .reusable = false}, SHIFT(2519),
  [5749] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5751] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5753] = {.count = 1, .reusable = false}, SHIFT(2521),
  [5755] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5757] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5759] = {.count = 1, .reusable = false}, SHIFT(2523),
  [5761] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5763] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [5765] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [5767] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5769] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5771] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5773] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5775] = {.count = 1, .reusable = false}, SHIFT(2529),
  [5777] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5779] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5781] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5783] = {.count = 1, .reusable = false}, SHIFT(2534),
  [5785] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5787] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5789] = {.count = 1, .reusable = false}, SHIFT(2536),
  [5791] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5793] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5795] = {.count = 1, .reusable = false}, SHIFT(2538),
  [5797] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5799] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1311),
  [5802] = {.count = 1, .reusable = false}, SHIFT(2540),
  [5804] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5806] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5812] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5814] = {.count = 1, .reusable = false}, SHIFT(2548),
  [5816] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5820] = {.count = 1, .reusable = false}, SHIFT(2550),
  [5822] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5824] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5826] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5830] = {.count = 1, .reusable = false}, SHIFT(2553),
  [5832] = {.count = 1, .reusable = true}, SHIFT(2553),
  [5834] = {.count = 1, .reusable = true}, SHIFT(2554),
  [5836] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [5838] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5842] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5844] = {.count = 1, .reusable = false}, SHIFT(2557),
  [5846] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5850] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5852] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5854] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5856] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5858] = {.count = 1, .reusable = false}, SHIFT(2564),
  [5860] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5862] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5864] = {.count = 1, .reusable = false}, SHIFT(2566),
  [5866] = {.count = 1, .reusable = true}, SHIFT(2566),
  [5868] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5870] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5872] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5874] = {.count = 1, .reusable = false}, SHIFT(2570),
  [5876] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5878] = {.count = 1, .reusable = false}, SHIFT(2571),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5882] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5884] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1365),
  [5887] = {.count = 1, .reusable = false}, SHIFT(2573),
  [5889] = {.count = 1, .reusable = true}, SHIFT(2574),
  [5891] = {.count = 1, .reusable = false}, SHIFT(2575),
  [5893] = {.count = 1, .reusable = true}, SHIFT(2576),
  [5895] = {.count = 1, .reusable = true}, SHIFT(2578),
  [5897] = {.count = 1, .reusable = true}, SHIFT(2579),
  [5899] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5901] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5903] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5905] = {.count = 1, .reusable = false}, SHIFT(2583),
  [5907] = {.count = 1, .reusable = true}, SHIFT(2583),
  [5909] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5911] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5913] = {.count = 1, .reusable = true}, SHIFT(2585),
  [5915] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5917] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5919] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5921] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5923] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5925] = {.count = 1, .reusable = false}, SHIFT(2592),
  [5927] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5929] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5931] = {.count = 1, .reusable = true}, SHIFT(2596),
  [5933] = {.count = 1, .reusable = false}, SHIFT(2596),
  [5935] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5937] = {.count = 1, .reusable = false}, SHIFT(2599),
  [5939] = {.count = 1, .reusable = true}, SHIFT(2602),
  [5941] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5943] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5945] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5947] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5949] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5951] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5953] = {.count = 1, .reusable = false}, SHIFT(2610),
  [5955] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5957] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5959] = {.count = 1, .reusable = false}, SHIFT(2612),
  [5961] = {.count = 1, .reusable = true}, SHIFT(2612),
  [5963] = {.count = 1, .reusable = true}, SHIFT(2613),
  [5965] = {.count = 1, .reusable = false}, SHIFT(2614),
  [5967] = {.count = 1, .reusable = true}, SHIFT(2614),
  [5969] = {.count = 1, .reusable = true}, SHIFT(2615),
  [5971] = {.count = 1, .reusable = true}, SHIFT(2616),
  [5973] = {.count = 1, .reusable = false}, SHIFT(2617),
  [5975] = {.count = 1, .reusable = true}, SHIFT(2618),
  [5977] = {.count = 1, .reusable = true}, SHIFT(2620),
  [5979] = {.count = 1, .reusable = true}, SHIFT(2621),
  [5981] = {.count = 1, .reusable = false}, SHIFT(2622),
  [5983] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5985] = {.count = 1, .reusable = true}, SHIFT(2623),
  [5987] = {.count = 1, .reusable = false}, SHIFT(2624),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2624),
  [5991] = {.count = 1, .reusable = true}, SHIFT(2625),
  [5993] = {.count = 1, .reusable = false}, SHIFT(2626),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2626),
  [5997] = {.count = 1, .reusable = true}, SHIFT(2627),
  [5999] = {.count = 1, .reusable = true}, SHIFT(2628),
  [6001] = {.count = 1, .reusable = true}, SHIFT(2629),
  [6003] = {.count = 1, .reusable = false}, SHIFT(2630),
  [6005] = {.count = 1, .reusable = true}, SHIFT(2630),
  [6007] = {.count = 1, .reusable = false}, SHIFT(2631),
  [6009] = {.count = 1, .reusable = true}, SHIFT(2631),
  [6011] = {.count = 1, .reusable = true}, SHIFT(2632),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2633),
  [6015] = {.count = 1, .reusable = true}, SHIFT(2635),
  [6017] = {.count = 1, .reusable = false}, SHIFT(2637),
  [6019] = {.count = 1, .reusable = false}, SHIFT(2638),
  [6021] = {.count = 1, .reusable = true}, SHIFT(2640),
  [6023] = {.count = 1, .reusable = true}, SHIFT(2641),
  [6025] = {.count = 1, .reusable = false}, SHIFT(2642),
  [6027] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2643),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2645),
  [6035] = {.count = 1, .reusable = false}, SHIFT(2646),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6039] = {.count = 1, .reusable = true}, SHIFT(2651),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6043] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6045] = {.count = 1, .reusable = true}, SHIFT(2654),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6049] = {.count = 1, .reusable = false}, SHIFT(2657),
  [6051] = {.count = 1, .reusable = false}, SHIFT(2658),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2659),
  [6055] = {.count = 1, .reusable = true}, SHIFT(2660),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2661),
  [6059] = {.count = 1, .reusable = false}, SHIFT(2662),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6063] = {.count = 1, .reusable = true}, SHIFT(2663),
  [6065] = {.count = 1, .reusable = false}, SHIFT(2665),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2665),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2664),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2666),
  [6073] = {.count = 1, .reusable = false}, SHIFT(2668),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2668),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2667),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2669),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2670),
  [6083] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1450),
  [6086] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1451),
  [6089] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1452),
  [6092] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1453),
  [6095] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1454),
  [6098] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1455),
  [6101] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1456),
  [6104] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1457),
  [6107] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1458),
  [6110] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2075),
  [6113] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1454),
  [6116] = {.count = 1, .reusable = true}, SHIFT(2671),
  [6118] = {.count = 1, .reusable = false}, SHIFT(2673),
  [6120] = {.count = 1, .reusable = false}, SHIFT(2674),
  [6122] = {.count = 1, .reusable = true}, SHIFT(2675),
  [6124] = {.count = 1, .reusable = true}, SHIFT(2676),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2677),
  [6128] = {.count = 1, .reusable = false}, SHIFT(2678),
  [6130] = {.count = 1, .reusable = true}, SHIFT(2678),
  [6132] = {.count = 1, .reusable = true}, SHIFT(2679),
  [6134] = {.count = 1, .reusable = false}, SHIFT(2681),
  [6136] = {.count = 1, .reusable = true}, SHIFT(2681),
  [6138] = {.count = 1, .reusable = true}, SHIFT(2680),
  [6140] = {.count = 1, .reusable = true}, SHIFT(2682),
  [6142] = {.count = 1, .reusable = false}, SHIFT(2684),
  [6144] = {.count = 1, .reusable = true}, SHIFT(2684),
  [6146] = {.count = 1, .reusable = true}, SHIFT(2683),
  [6148] = {.count = 1, .reusable = true}, SHIFT(2685),
  [6150] = {.count = 1, .reusable = true}, SHIFT(2686),
  [6152] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1461),
  [6155] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1462),
  [6158] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1463),
  [6161] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1464),
  [6164] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1465),
  [6167] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1466),
  [6170] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1467),
  [6173] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1468),
  [6176] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2092),
  [6179] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1464),
  [6182] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1470),
  [6185] = {.count = 1, .reusable = false}, SHIFT(2687),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2688),
  [6189] = {.count = 1, .reusable = false}, SHIFT(2689),
  [6191] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6193] = {.count = 1, .reusable = true}, SHIFT(2692),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6197] = {.count = 1, .reusable = false}, SHIFT(2695),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2695),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6203] = {.count = 1, .reusable = false}, SHIFT(2697),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2697),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6213] = {.count = 1, .reusable = false}, SHIFT(2700),
  [6215] = {.count = 1, .reusable = true}, SHIFT(2700),
  [6217] = {.count = 1, .reusable = true}, SHIFT(2701),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2702),
  [6221] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6223] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6225] = {.count = 1, .reusable = false}, SHIFT(2706),
  [6227] = {.count = 1, .reusable = false}, SHIFT(2707),
  [6229] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6231] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6233] = {.count = 1, .reusable = false}, SHIFT(2711),
  [6235] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6237] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6239] = {.count = 1, .reusable = true}, SHIFT(2713),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6243] = {.count = 1, .reusable = false}, SHIFT(2715),
  [6245] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6247] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 3),
  [6249] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1487),
  [6252] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1491),
  [6255] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1491),
  [6258] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1492),
  [6261] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1495),
  [6264] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1496),
  [6267] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(858),
  [6270] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(859),
  [6273] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1497),
  [6276] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(861),
  [6279] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(862),
  [6282] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(863),
  [6285] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(864),
  [6288] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1497),
  [6291] = {.count = 1, .reusable = false}, SHIFT(2720),
  [6293] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6295] = {.count = 1, .reusable = true}, SHIFT(2721),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2723),
  [6299] = {.count = 1, .reusable = false}, SHIFT(2725),
  [6301] = {.count = 1, .reusable = false}, SHIFT(2726),
  [6303] = {.count = 1, .reusable = true}, SHIFT(2728),
  [6305] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6307] = {.count = 1, .reusable = false}, SHIFT(2730),
  [6309] = {.count = 1, .reusable = true}, SHIFT(2730),
  [6311] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6313] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6315] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6317] = {.count = 1, .reusable = false}, SHIFT(2734),
  [6319] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6321] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [6323] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6325] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2743),
  [6331] = {.count = 1, .reusable = false}, SHIFT(2744),
  [6333] = {.count = 1, .reusable = true}, SHIFT(2745),
  [6335] = {.count = 1, .reusable = true}, SHIFT(2746),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2747),
  [6339] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6341] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6343] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6347] = {.count = 1, .reusable = false}, SHIFT(2753),
  [6349] = {.count = 1, .reusable = false}, SHIFT(2754),
  [6351] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6353] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6355] = {.count = 1, .reusable = false}, SHIFT(2758),
  [6357] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6359] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6361] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6363] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6365] = {.count = 1, .reusable = false}, SHIFT(2762),
  [6367] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6369] = {.count = 1, .reusable = false}, SHIFT(2767),
  [6371] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6373] = {.count = 1, .reusable = false}, SHIFT(2770),
  [6375] = {.count = 1, .reusable = false}, SHIFT(2771),
  [6377] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6379] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6381] = {.count = 1, .reusable = false}, SHIFT(2775),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6387] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6389] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6391] = {.count = 1, .reusable = false}, SHIFT(2779),
  [6393] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6395] = {.count = 1, .reusable = false}, SHIFT(2784),
  [6397] = {.count = 1, .reusable = true}, SHIFT(2785),
  [6399] = {.count = 1, .reusable = false}, SHIFT(2787),
  [6401] = {.count = 1, .reusable = false}, SHIFT(2788),
  [6403] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6405] = {.count = 1, .reusable = true}, SHIFT(2790),
  [6407] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6409] = {.count = 1, .reusable = false}, SHIFT(2792),
  [6411] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6413] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6415] = {.count = 1, .reusable = false}, SHIFT(2795),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6419] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6421] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6423] = {.count = 1, .reusable = false}, SHIFT(2798),
  [6425] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6427] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6429] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6431] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6433] = {.count = 1, .reusable = false}, SHIFT(2801),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6441] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6445] = {.count = 1, .reusable = false}, SHIFT(2810),
  [6447] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6449] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6451] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6453] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6455] = {.count = 1, .reusable = false}, SHIFT(2816),
  [6457] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6469] = {.count = 1, .reusable = false}, SHIFT(2825),
  [6471] = {.count = 1, .reusable = false}, SHIFT(2826),
  [6473] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6475] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6477] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6479] = {.count = 1, .reusable = false}, SHIFT(2830),
  [6481] = {.count = 1, .reusable = true}, SHIFT(2830),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6485] = {.count = 1, .reusable = false}, SHIFT(2833),
  [6487] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2832),
  [6491] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6493] = {.count = 1, .reusable = false}, SHIFT(2836),
  [6495] = {.count = 1, .reusable = true}, SHIFT(2836),
  [6497] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6501] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6503] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1529),
  [6506] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1530),
  [6509] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1531),
  [6512] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1532),
  [6515] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1533),
  [6518] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1534),
  [6521] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1535),
  [6524] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1536),
  [6527] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1537),
  [6530] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2214),
  [6533] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1533),
  [6536] = {.count = 1, .reusable = true}, SHIFT(2839),
  [6538] = {.count = 1, .reusable = false}, SHIFT(2841),
  [6540] = {.count = 1, .reusable = false}, SHIFT(2842),
  [6542] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6544] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6546] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6548] = {.count = 1, .reusable = false}, SHIFT(2846),
  [6550] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6552] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6554] = {.count = 1, .reusable = false}, SHIFT(2849),
  [6556] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6558] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6560] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6562] = {.count = 1, .reusable = false}, SHIFT(2852),
  [6564] = {.count = 1, .reusable = true}, SHIFT(2852),
  [6566] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6568] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6570] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6572] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1540),
  [6575] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1541),
  [6578] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1542),
  [6581] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1543),
  [6584] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1544),
  [6587] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1545),
  [6590] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1546),
  [6593] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1547),
  [6596] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2231),
  [6599] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1543),
  [6602] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1549),
  [6605] = {.count = 1, .reusable = false}, SHIFT(2855),
  [6607] = {.count = 1, .reusable = true}, SHIFT(2856),
  [6609] = {.count = 1, .reusable = false}, SHIFT(2857),
  [6611] = {.count = 1, .reusable = true}, SHIFT(2858),
  [6613] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6615] = {.count = 1, .reusable = true}, SHIFT(2861),
  [6617] = {.count = 1, .reusable = false}, SHIFT(2863),
  [6619] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6621] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6623] = {.count = 1, .reusable = false}, SHIFT(2865),
  [6625] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6627] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6629] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6631] = {.count = 1, .reusable = true}, SHIFT(2867),
  [6633] = {.count = 1, .reusable = false}, SHIFT(2868),
  [6635] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6637] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6639] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [6641] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [6643] = {.count = 1, .reusable = true}, SHIFT(2870),
  [6645] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6647] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6649] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1568),
  [6652] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1572),
  [6655] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1572),
  [6658] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1573),
  [6661] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1576),
  [6664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1577),
  [6667] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(900),
  [6670] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(901),
  [6673] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1578),
  [6676] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(903),
  [6679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(904),
  [6682] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(905),
  [6685] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(906),
  [6688] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1578),
  [6691] = {.count = 1, .reusable = false}, SHIFT(2874),
  [6693] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6695] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6697] = {.count = 1, .reusable = true}, SHIFT(2876),
  [6699] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6701] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [6703] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6705] = {.count = 1, .reusable = false}, SHIFT(2880),
  [6707] = {.count = 1, .reusable = false}, SHIFT(2881),
  [6709] = {.count = 1, .reusable = false}, SHIFT(2882),
  [6711] = {.count = 1, .reusable = false}, SHIFT(2883),
  [6713] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6715] = {.count = 1, .reusable = false}, SHIFT(2885),
  [6717] = {.count = 1, .reusable = true}, SHIFT(2886),
  [6719] = {.count = 1, .reusable = true}, SHIFT(2887),
  [6721] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6723] = {.count = 1, .reusable = true}, SHIFT(2889),
  [6725] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6727] = {.count = 1, .reusable = false}, SHIFT(2891),
  [6729] = {.count = 1, .reusable = true}, SHIFT(2900),
  [6731] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [6733] = {.count = 1, .reusable = true}, SHIFT(2903),
  [6735] = {.count = 1, .reusable = true}, SHIFT(2905),
  [6737] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [6739] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [6741] = {.count = 1, .reusable = true}, SHIFT(2906),
  [6743] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2907),
  [6746] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(275),
  [6749] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(276),
  [6752] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2908),
  [6755] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(278),
  [6758] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(279),
  [6761] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(280),
  [6764] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(281),
  [6767] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [6769] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [6771] = {.count = 1, .reusable = true}, SHIFT(2911),
  [6773] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6775] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6777] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6779] = {.count = 1, .reusable = false}, SHIFT(2916),
  [6781] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6783] = {.count = 1, .reusable = false}, SHIFT(2917),
  [6785] = {.count = 1, .reusable = true}, SHIFT(2917),
  [6787] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6789] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1621),
  [6792] = {.count = 1, .reusable = false}, SHIFT(2919),
  [6794] = {.count = 1, .reusable = true}, SHIFT(2920),
  [6796] = {.count = 1, .reusable = false}, SHIFT(2921),
  [6798] = {.count = 1, .reusable = true}, SHIFT(2922),
  [6800] = {.count = 1, .reusable = true}, SHIFT(2924),
  [6802] = {.count = 1, .reusable = true}, SHIFT(2925),
  [6804] = {.count = 1, .reusable = false}, SHIFT(2927),
  [6806] = {.count = 1, .reusable = true}, SHIFT(2927),
  [6808] = {.count = 1, .reusable = true}, SHIFT(2926),
  [6810] = {.count = 1, .reusable = false}, SHIFT(2929),
  [6812] = {.count = 1, .reusable = true}, SHIFT(2929),
  [6814] = {.count = 1, .reusable = true}, SHIFT(2928),
  [6816] = {.count = 1, .reusable = true}, SHIFT(2930),
  [6818] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6820] = {.count = 1, .reusable = false}, SHIFT(2932),
  [6822] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6824] = {.count = 1, .reusable = true}, SHIFT(2933),
  [6826] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6828] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6830] = {.count = 1, .reusable = false}, SHIFT(2938),
  [6832] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6834] = {.count = 1, .reusable = true}, SHIFT(2940),
  [6836] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6838] = {.count = 1, .reusable = false}, SHIFT(2942),
  [6840] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6842] = {.count = 1, .reusable = false}, SHIFT(2945),
  [6844] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6846] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6848] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6850] = {.count = 1, .reusable = false}, SHIFT(2951),
  [6852] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6854] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6856] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6858] = {.count = 1, .reusable = false}, SHIFT(2956),
  [6860] = {.count = 1, .reusable = true}, SHIFT(2956),
  [6862] = {.count = 1, .reusable = true}, SHIFT(2957),
  [6864] = {.count = 1, .reusable = false}, SHIFT(2958),
  [6866] = {.count = 1, .reusable = true}, SHIFT(2958),
  [6868] = {.count = 1, .reusable = true}, SHIFT(2959),
  [6870] = {.count = 1, .reusable = false}, SHIFT(2960),
  [6872] = {.count = 1, .reusable = true}, SHIFT(2960),
  [6874] = {.count = 1, .reusable = true}, SHIFT(2961),
  [6876] = {.count = 1, .reusable = true}, SHIFT(2962),
  [6878] = {.count = 1, .reusable = false}, SHIFT(2963),
  [6880] = {.count = 1, .reusable = true}, SHIFT(2964),
  [6882] = {.count = 1, .reusable = true}, SHIFT(2966),
  [6884] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6886] = {.count = 1, .reusable = false}, SHIFT(2968),
  [6888] = {.count = 1, .reusable = true}, SHIFT(2968),
  [6890] = {.count = 1, .reusable = true}, SHIFT(2969),
  [6892] = {.count = 1, .reusable = false}, SHIFT(2970),
  [6894] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6896] = {.count = 1, .reusable = true}, SHIFT(2971),
  [6898] = {.count = 1, .reusable = false}, SHIFT(2972),
  [6900] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6902] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6904] = {.count = 1, .reusable = true}, SHIFT(2974),
  [6906] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6908] = {.count = 1, .reusable = false}, SHIFT(2976),
  [6910] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6912] = {.count = 1, .reusable = false}, SHIFT(2977),
  [6914] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6916] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6918] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6920] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6922] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6924] = {.count = 1, .reusable = false}, SHIFT(2982),
  [6926] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6928] = {.count = 1, .reusable = false}, SHIFT(2983),
  [6930] = {.count = 1, .reusable = true}, SHIFT(2983),
  [6932] = {.count = 1, .reusable = true}, SHIFT(2984),
  [6934] = {.count = 1, .reusable = true}, SHIFT(2985),
  [6936] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6938] = {.count = 1, .reusable = true}, SHIFT(2987),
  [6940] = {.count = 1, .reusable = false}, SHIFT(2988),
  [6942] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6944] = {.count = 1, .reusable = false}, SHIFT(2989),
  [6946] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6948] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6950] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6952] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6954] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6956] = {.count = 1, .reusable = false}, SHIFT(2994),
  [6958] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6960] = {.count = 1, .reusable = false}, SHIFT(2995),
  [6962] = {.count = 1, .reusable = true}, SHIFT(2995),
  [6964] = {.count = 1, .reusable = true}, SHIFT(2996),
  [6966] = {.count = 1, .reusable = true}, SHIFT(2997),
  [6968] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6970] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6972] = {.count = 1, .reusable = false}, SHIFT(3000),
  [6974] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6976] = {.count = 1, .reusable = false}, SHIFT(3001),
  [6978] = {.count = 1, .reusable = true}, SHIFT(3001),
  [6980] = {.count = 1, .reusable = true}, SHIFT(3002),
  [6982] = {.count = 1, .reusable = true}, SHIFT(3003),
  [6984] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6986] = {.count = 1, .reusable = true}, SHIFT(3005),
  [6988] = {.count = 1, .reusable = false}, SHIFT(3006),
  [6990] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6992] = {.count = 1, .reusable = false}, SHIFT(3007),
  [6994] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6996] = {.count = 1, .reusable = true}, SHIFT(3008),
  [6998] = {.count = 1, .reusable = true}, SHIFT(3009),
  [7000] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [7002] = {.count = 1, .reusable = true}, SHIFT(3010),
  [7004] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [7006] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1794),
  [7009] = {.count = 1, .reusable = false}, SHIFT(3011),
  [7011] = {.count = 1, .reusable = true}, SHIFT(3012),
  [7013] = {.count = 1, .reusable = false}, SHIFT(3013),
  [7015] = {.count = 1, .reusable = true}, SHIFT(3014),
  [7017] = {.count = 1, .reusable = true}, SHIFT(3016),
  [7019] = {.count = 1, .reusable = true}, SHIFT(3017),
  [7021] = {.count = 1, .reusable = false}, SHIFT(3019),
  [7023] = {.count = 1, .reusable = true}, SHIFT(3019),
  [7025] = {.count = 1, .reusable = true}, SHIFT(3018),
  [7027] = {.count = 1, .reusable = false}, SHIFT(3021),
  [7029] = {.count = 1, .reusable = true}, SHIFT(3021),
  [7031] = {.count = 1, .reusable = true}, SHIFT(3020),
  [7033] = {.count = 1, .reusable = true}, SHIFT(3022),
  [7035] = {.count = 1, .reusable = true}, SHIFT(3023),
  [7037] = {.count = 1, .reusable = false}, SHIFT(3024),
  [7039] = {.count = 1, .reusable = true}, SHIFT(3024),
  [7041] = {.count = 1, .reusable = true}, SHIFT(3025),
  [7043] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [7045] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [7047] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [7049] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [7051] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [7053] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [7055] = {.count = 1, .reusable = true}, SHIFT(3026),
  [7057] = {.count = 1, .reusable = true}, SHIFT(3027),
  [7059] = {.count = 1, .reusable = true}, SHIFT(3028),
  [7061] = {.count = 1, .reusable = true}, SHIFT(3029),
  [7063] = {.count = 1, .reusable = false}, SHIFT(3030),
  [7065] = {.count = 1, .reusable = true}, SHIFT(3031),
  [7067] = {.count = 1, .reusable = true}, SHIFT(3033),
  [7069] = {.count = 1, .reusable = true}, SHIFT(3034),
  [7071] = {.count = 1, .reusable = false}, SHIFT(3035),
  [7073] = {.count = 1, .reusable = true}, SHIFT(3035),
  [7075] = {.count = 1, .reusable = true}, SHIFT(3036),
  [7077] = {.count = 1, .reusable = false}, SHIFT(3037),
  [7079] = {.count = 1, .reusable = true}, SHIFT(3037),
  [7081] = {.count = 1, .reusable = true}, SHIFT(3038),
  [7083] = {.count = 1, .reusable = false}, SHIFT(3039),
  [7085] = {.count = 1, .reusable = true}, SHIFT(3039),
  [7087] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [7089] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [7091] = {.count = 1, .reusable = true}, SHIFT(3040),
  [7093] = {.count = 1, .reusable = true}, SHIFT(3041),
  [7095] = {.count = 1, .reusable = false}, SHIFT(3042),
  [7097] = {.count = 1, .reusable = true}, SHIFT(3043),
  [7099] = {.count = 1, .reusable = true}, SHIFT(3045),
  [7101] = {.count = 1, .reusable = true}, SHIFT(3046),
  [7103] = {.count = 1, .reusable = false}, SHIFT(3047),
  [7105] = {.count = 1, .reusable = true}, SHIFT(3047),
  [7107] = {.count = 1, .reusable = true}, SHIFT(3048),
  [7109] = {.count = 1, .reusable = false}, SHIFT(3049),
  [7111] = {.count = 1, .reusable = true}, SHIFT(3049),
  [7113] = {.count = 1, .reusable = true}, SHIFT(3050),
  [7115] = {.count = 1, .reusable = false}, SHIFT(3051),
  [7117] = {.count = 1, .reusable = true}, SHIFT(3051),
  [7119] = {.count = 1, .reusable = true}, SHIFT(3053),
  [7121] = {.count = 1, .reusable = true}, SHIFT(3054),
  [7123] = {.count = 1, .reusable = false}, SHIFT(3055),
  [7125] = {.count = 1, .reusable = true}, SHIFT(3056),
  [7127] = {.count = 1, .reusable = true}, SHIFT(3058),
  [7129] = {.count = 1, .reusable = true}, SHIFT(3059),
  [7131] = {.count = 1, .reusable = false}, SHIFT(3060),
  [7133] = {.count = 1, .reusable = true}, SHIFT(3060),
  [7135] = {.count = 1, .reusable = true}, SHIFT(3061),
  [7137] = {.count = 1, .reusable = false}, SHIFT(3062),
  [7139] = {.count = 1, .reusable = true}, SHIFT(3062),
  [7141] = {.count = 1, .reusable = true}, SHIFT(3063),
  [7143] = {.count = 1, .reusable = false}, SHIFT(3064),
  [7145] = {.count = 1, .reusable = true}, SHIFT(3064),
  [7147] = {.count = 1, .reusable = true}, SHIFT(3065),
  [7149] = {.count = 1, .reusable = true}, SHIFT(3066),
  [7151] = {.count = 1, .reusable = true}, SHIFT(3067),
  [7153] = {.count = 1, .reusable = false}, SHIFT(3068),
  [7155] = {.count = 1, .reusable = true}, SHIFT(3068),
  [7157] = {.count = 1, .reusable = false}, SHIFT(3069),
  [7159] = {.count = 1, .reusable = true}, SHIFT(3069),
  [7161] = {.count = 1, .reusable = true}, SHIFT(3070),
  [7163] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [7165] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [7167] = {.count = 1, .reusable = true}, SHIFT(3072),
  [7169] = {.count = 1, .reusable = true}, SHIFT(3073),
  [7171] = {.count = 1, .reusable = true}, SHIFT(3074),
  [7173] = {.count = 1, .reusable = true}, SHIFT(3075),
  [7175] = {.count = 1, .reusable = false}, SHIFT(3076),
  [7177] = {.count = 1, .reusable = true}, SHIFT(3076),
  [7179] = {.count = 1, .reusable = false}, SHIFT(3077),
  [7181] = {.count = 1, .reusable = true}, SHIFT(3077),
  [7183] = {.count = 1, .reusable = true}, SHIFT(3078),
  [7185] = {.count = 1, .reusable = true}, SHIFT(3079),
  [7187] = {.count = 1, .reusable = true}, SHIFT(3080),
  [7189] = {.count = 1, .reusable = true}, SHIFT(3081),
  [7191] = {.count = 1, .reusable = false}, SHIFT(3082),
  [7193] = {.count = 1, .reusable = true}, SHIFT(3083),
  [7195] = {.count = 1, .reusable = true}, SHIFT(3085),
  [7197] = {.count = 1, .reusable = true}, SHIFT(3086),
  [7199] = {.count = 1, .reusable = false}, SHIFT(3087),
  [7201] = {.count = 1, .reusable = true}, SHIFT(3087),
  [7203] = {.count = 1, .reusable = true}, SHIFT(3088),
  [7205] = {.count = 1, .reusable = false}, SHIFT(3089),
  [7207] = {.count = 1, .reusable = true}, SHIFT(3089),
  [7209] = {.count = 1, .reusable = true}, SHIFT(3090),
  [7211] = {.count = 1, .reusable = false}, SHIFT(3091),
  [7213] = {.count = 1, .reusable = true}, SHIFT(3091),
  [7215] = {.count = 1, .reusable = true}, SHIFT(3092),
  [7217] = {.count = 1, .reusable = true}, SHIFT(3093),
  [7219] = {.count = 1, .reusable = true}, SHIFT(3094),
  [7221] = {.count = 1, .reusable = false}, SHIFT(3095),
  [7223] = {.count = 1, .reusable = true}, SHIFT(3095),
  [7225] = {.count = 1, .reusable = false}, SHIFT(3096),
  [7227] = {.count = 1, .reusable = true}, SHIFT(3096),
  [7229] = {.count = 1, .reusable = true}, SHIFT(3097),
  [7231] = {.count = 1, .reusable = true}, SHIFT(3098),
  [7233] = {.count = 1, .reusable = true}, SHIFT(3099),
  [7235] = {.count = 1, .reusable = true}, SHIFT(3100),
  [7237] = {.count = 1, .reusable = true}, SHIFT(3101),
  [7239] = {.count = 1, .reusable = false}, SHIFT(3102),
  [7241] = {.count = 1, .reusable = true}, SHIFT(3103),
  [7243] = {.count = 1, .reusable = true}, SHIFT(3105),
  [7245] = {.count = 1, .reusable = true}, SHIFT(3106),
  [7247] = {.count = 1, .reusable = false}, SHIFT(3107),
  [7249] = {.count = 1, .reusable = true}, SHIFT(3107),
  [7251] = {.count = 1, .reusable = true}, SHIFT(3108),
  [7253] = {.count = 1, .reusable = false}, SHIFT(3109),
  [7255] = {.count = 1, .reusable = true}, SHIFT(3109),
  [7257] = {.count = 1, .reusable = true}, SHIFT(3110),
  [7259] = {.count = 1, .reusable = false}, SHIFT(3111),
  [7261] = {.count = 1, .reusable = true}, SHIFT(3111),
  [7263] = {.count = 1, .reusable = true}, SHIFT(3113),
  [7265] = {.count = 1, .reusable = true}, SHIFT(3114),
  [7267] = {.count = 1, .reusable = true}, SHIFT(3116),
  [7269] = {.count = 1, .reusable = true}, SHIFT(3117),
  [7271] = {.count = 1, .reusable = true}, SHIFT(3119),
  [7273] = {.count = 1, .reusable = true}, SHIFT(3121),
  [7275] = {.count = 1, .reusable = true}, SHIFT(3122),
  [7277] = {.count = 1, .reusable = true}, SHIFT(3123),
  [7279] = {.count = 1, .reusable = false}, SHIFT(3124),
  [7281] = {.count = 1, .reusable = true}, SHIFT(3124),
  [7283] = {.count = 1, .reusable = false}, SHIFT(3125),
  [7285] = {.count = 1, .reusable = true}, SHIFT(3125),
  [7287] = {.count = 1, .reusable = true}, SHIFT(3126),
  [7289] = {.count = 1, .reusable = true}, SHIFT(3127),
  [7291] = {.count = 1, .reusable = true}, SHIFT(3128),
  [7293] = {.count = 1, .reusable = true}, SHIFT(3129),
  [7295] = {.count = 1, .reusable = false}, SHIFT(3130),
  [7297] = {.count = 1, .reusable = true}, SHIFT(3130),
  [7299] = {.count = 1, .reusable = false}, SHIFT(3131),
  [7301] = {.count = 1, .reusable = true}, SHIFT(3131),
  [7303] = {.count = 1, .reusable = true}, SHIFT(3132),
  [7305] = {.count = 1, .reusable = true}, SHIFT(3133),
  [7307] = {.count = 1, .reusable = true}, SHIFT(3134),
  [7309] = {.count = 1, .reusable = true}, SHIFT(3135),
  [7311] = {.count = 1, .reusable = true}, SHIFT(3136),
  [7313] = {.count = 1, .reusable = false}, SHIFT(3138),
  [7315] = {.count = 1, .reusable = false}, SHIFT(3139),
  [7317] = {.count = 1, .reusable = true}, SHIFT(3140),
  [7319] = {.count = 1, .reusable = true}, SHIFT(3141),
  [7321] = {.count = 1, .reusable = true}, SHIFT(3142),
  [7323] = {.count = 1, .reusable = false}, SHIFT(3143),
  [7325] = {.count = 1, .reusable = true}, SHIFT(3143),
  [7327] = {.count = 1, .reusable = true}, SHIFT(3144),
  [7329] = {.count = 1, .reusable = false}, SHIFT(3146),
  [7331] = {.count = 1, .reusable = true}, SHIFT(3146),
  [7333] = {.count = 1, .reusable = true}, SHIFT(3145),
  [7335] = {.count = 1, .reusable = true}, SHIFT(3147),
  [7337] = {.count = 1, .reusable = false}, SHIFT(3149),
  [7339] = {.count = 1, .reusable = true}, SHIFT(3149),
  [7341] = {.count = 1, .reusable = true}, SHIFT(3148),
  [7343] = {.count = 1, .reusable = true}, SHIFT(3150),
  [7345] = {.count = 1, .reusable = true}, SHIFT(3151),
  [7347] = {.count = 1, .reusable = true}, SHIFT(3152),
  [7349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2059),
  [7352] = {.count = 1, .reusable = false}, SHIFT(3154),
  [7354] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7356] = {.count = 1, .reusable = false}, SHIFT(3156),
  [7358] = {.count = 1, .reusable = true}, SHIFT(3157),
  [7360] = {.count = 1, .reusable = true}, SHIFT(3159),
  [7362] = {.count = 1, .reusable = true}, SHIFT(3160),
  [7364] = {.count = 1, .reusable = false}, SHIFT(3162),
  [7366] = {.count = 1, .reusable = true}, SHIFT(3162),
  [7368] = {.count = 1, .reusable = true}, SHIFT(3161),
  [7370] = {.count = 1, .reusable = false}, SHIFT(3164),
  [7372] = {.count = 1, .reusable = true}, SHIFT(3164),
  [7374] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7376] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7378] = {.count = 1, .reusable = true}, SHIFT(3166),
  [7380] = {.count = 1, .reusable = false}, SHIFT(3167),
  [7382] = {.count = 1, .reusable = true}, SHIFT(3167),
  [7384] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7386] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2076),
  [7389] = {.count = 1, .reusable = false}, SHIFT(3169),
  [7391] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7393] = {.count = 1, .reusable = false}, SHIFT(3171),
  [7395] = {.count = 1, .reusable = true}, SHIFT(3172),
  [7397] = {.count = 1, .reusable = true}, SHIFT(3174),
  [7399] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7401] = {.count = 1, .reusable = false}, SHIFT(3177),
  [7403] = {.count = 1, .reusable = true}, SHIFT(3177),
  [7405] = {.count = 1, .reusable = true}, SHIFT(3176),
  [7407] = {.count = 1, .reusable = false}, SHIFT(3179),
  [7409] = {.count = 1, .reusable = true}, SHIFT(3179),
  [7411] = {.count = 1, .reusable = true}, SHIFT(3178),
  [7413] = {.count = 1, .reusable = true}, SHIFT(3180),
  [7415] = {.count = 1, .reusable = true}, SHIFT(3181),
  [7417] = {.count = 1, .reusable = false}, SHIFT(3182),
  [7419] = {.count = 1, .reusable = true}, SHIFT(3182),
  [7421] = {.count = 1, .reusable = true}, SHIFT(3183),
  [7423] = {.count = 1, .reusable = true}, SHIFT(3184),
  [7425] = {.count = 1, .reusable = true}, SHIFT(3185),
  [7427] = {.count = 1, .reusable = false}, SHIFT(3186),
  [7429] = {.count = 1, .reusable = true}, SHIFT(3187),
  [7431] = {.count = 1, .reusable = true}, SHIFT(3189),
  [7433] = {.count = 1, .reusable = true}, SHIFT(3190),
  [7435] = {.count = 1, .reusable = false}, SHIFT(3191),
  [7437] = {.count = 1, .reusable = true}, SHIFT(3191),
  [7439] = {.count = 1, .reusable = true}, SHIFT(3192),
  [7441] = {.count = 1, .reusable = false}, SHIFT(3193),
  [7443] = {.count = 1, .reusable = true}, SHIFT(3193),
  [7445] = {.count = 1, .reusable = true}, SHIFT(3194),
  [7447] = {.count = 1, .reusable = false}, SHIFT(3195),
  [7449] = {.count = 1, .reusable = true}, SHIFT(3195),
  [7451] = {.count = 1, .reusable = true}, SHIFT(3196),
  [7453] = {.count = 1, .reusable = false}, SHIFT(3198),
  [7455] = {.count = 1, .reusable = false}, SHIFT(3199),
  [7457] = {.count = 1, .reusable = true}, SHIFT(3200),
  [7459] = {.count = 1, .reusable = true}, SHIFT(3201),
  [7461] = {.count = 1, .reusable = true}, SHIFT(3202),
  [7463] = {.count = 1, .reusable = false}, SHIFT(3203),
  [7465] = {.count = 1, .reusable = true}, SHIFT(3203),
  [7467] = {.count = 1, .reusable = true}, SHIFT(3204),
  [7469] = {.count = 1, .reusable = false}, SHIFT(3206),
  [7471] = {.count = 1, .reusable = true}, SHIFT(3206),
  [7473] = {.count = 1, .reusable = true}, SHIFT(3205),
  [7475] = {.count = 1, .reusable = true}, SHIFT(3207),
  [7477] = {.count = 1, .reusable = false}, SHIFT(3209),
  [7479] = {.count = 1, .reusable = true}, SHIFT(3209),
  [7481] = {.count = 1, .reusable = true}, SHIFT(3208),
  [7483] = {.count = 1, .reusable = true}, SHIFT(3210),
  [7485] = {.count = 1, .reusable = true}, SHIFT(3211),
  [7487] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 4),
  [7489] = {.count = 1, .reusable = true}, SHIFT(3212),
  [7491] = {.count = 1, .reusable = true}, SHIFT(3213),
  [7493] = {.count = 1, .reusable = false}, SHIFT(3215),
  [7495] = {.count = 1, .reusable = false}, SHIFT(3216),
  [7497] = {.count = 1, .reusable = true}, SHIFT(3217),
  [7499] = {.count = 1, .reusable = true}, SHIFT(3218),
  [7501] = {.count = 1, .reusable = true}, SHIFT(3219),
  [7503] = {.count = 1, .reusable = false}, SHIFT(3220),
  [7505] = {.count = 1, .reusable = true}, SHIFT(3220),
  [7507] = {.count = 1, .reusable = true}, SHIFT(3221),
  [7509] = {.count = 1, .reusable = false}, SHIFT(3223),
  [7511] = {.count = 1, .reusable = true}, SHIFT(3223),
  [7513] = {.count = 1, .reusable = true}, SHIFT(3222),
  [7515] = {.count = 1, .reusable = true}, SHIFT(3224),
  [7517] = {.count = 1, .reusable = false}, SHIFT(3226),
  [7519] = {.count = 1, .reusable = true}, SHIFT(3226),
  [7521] = {.count = 1, .reusable = true}, SHIFT(3225),
  [7523] = {.count = 1, .reusable = true}, SHIFT(3227),
  [7525] = {.count = 1, .reusable = true}, SHIFT(3228),
  [7527] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4),
  [7529] = {.count = 1, .reusable = true}, SHIFT(3229),
  [7531] = {.count = 1, .reusable = true}, SHIFT(3231),
  [7533] = {.count = 1, .reusable = false}, SHIFT(3233),
  [7535] = {.count = 1, .reusable = false}, SHIFT(3234),
  [7537] = {.count = 1, .reusable = true}, SHIFT(3236),
  [7539] = {.count = 1, .reusable = true}, SHIFT(3237),
  [7541] = {.count = 1, .reusable = false}, SHIFT(3238),
  [7543] = {.count = 1, .reusable = true}, SHIFT(3238),
  [7545] = {.count = 1, .reusable = true}, SHIFT(3239),
  [7547] = {.count = 1, .reusable = true}, SHIFT(3240),
  [7549] = {.count = 1, .reusable = true}, SHIFT(3241),
  [7551] = {.count = 1, .reusable = false}, SHIFT(3242),
  [7553] = {.count = 1, .reusable = true}, SHIFT(3242),
  [7555] = {.count = 1, .reusable = true}, SHIFT(3247),
  [7557] = {.count = 1, .reusable = true}, SHIFT(3248),
  [7559] = {.count = 1, .reusable = true}, SHIFT(3249),
  [7561] = {.count = 1, .reusable = true}, SHIFT(3250),
  [7563] = {.count = 1, .reusable = true}, SHIFT(3251),
  [7565] = {.count = 1, .reusable = false}, SHIFT(3253),
  [7567] = {.count = 1, .reusable = false}, SHIFT(3254),
  [7569] = {.count = 1, .reusable = true}, SHIFT(3255),
  [7571] = {.count = 1, .reusable = true}, SHIFT(3256),
  [7573] = {.count = 1, .reusable = true}, SHIFT(3257),
  [7575] = {.count = 1, .reusable = false}, SHIFT(3258),
  [7577] = {.count = 1, .reusable = true}, SHIFT(3258),
  [7579] = {.count = 1, .reusable = true}, SHIFT(3259),
  [7581] = {.count = 1, .reusable = false}, SHIFT(3261),
  [7583] = {.count = 1, .reusable = true}, SHIFT(3261),
  [7585] = {.count = 1, .reusable = true}, SHIFT(3260),
  [7587] = {.count = 1, .reusable = true}, SHIFT(3262),
  [7589] = {.count = 1, .reusable = false}, SHIFT(3264),
  [7591] = {.count = 1, .reusable = true}, SHIFT(3264),
  [7593] = {.count = 1, .reusable = true}, SHIFT(3263),
  [7595] = {.count = 1, .reusable = true}, SHIFT(3265),
  [7597] = {.count = 1, .reusable = true}, SHIFT(3266),
  [7599] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2146),
  [7602] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2147),
  [7605] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2148),
  [7608] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2149),
  [7611] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2150),
  [7614] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2151),
  [7617] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2152),
  [7620] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2153),
  [7623] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2154),
  [7626] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2767),
  [7629] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2150),
  [7632] = {.count = 1, .reusable = true}, SHIFT(3267),
  [7634] = {.count = 1, .reusable = false}, SHIFT(3269),
  [7636] = {.count = 1, .reusable = false}, SHIFT(3270),
  [7638] = {.count = 1, .reusable = true}, SHIFT(3271),
  [7640] = {.count = 1, .reusable = true}, SHIFT(3272),
  [7642] = {.count = 1, .reusable = true}, SHIFT(3273),
  [7644] = {.count = 1, .reusable = false}, SHIFT(3274),
  [7646] = {.count = 1, .reusable = true}, SHIFT(3274),
  [7648] = {.count = 1, .reusable = true}, SHIFT(3275),
  [7650] = {.count = 1, .reusable = false}, SHIFT(3277),
  [7652] = {.count = 1, .reusable = true}, SHIFT(3277),
  [7654] = {.count = 1, .reusable = true}, SHIFT(3276),
  [7656] = {.count = 1, .reusable = true}, SHIFT(3278),
  [7658] = {.count = 1, .reusable = false}, SHIFT(3280),
  [7660] = {.count = 1, .reusable = true}, SHIFT(3280),
  [7662] = {.count = 1, .reusable = true}, SHIFT(3279),
  [7664] = {.count = 1, .reusable = true}, SHIFT(3281),
  [7666] = {.count = 1, .reusable = true}, SHIFT(3282),
  [7668] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2157),
  [7671] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2158),
  [7674] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2159),
  [7677] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2160),
  [7680] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2161),
  [7683] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2162),
  [7686] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2163),
  [7689] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2164),
  [7692] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2784),
  [7695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2160),
  [7698] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2166),
  [7701] = {.count = 1, .reusable = false}, SHIFT(3283),
  [7703] = {.count = 1, .reusable = true}, SHIFT(3284),
  [7705] = {.count = 1, .reusable = false}, SHIFT(3285),
  [7707] = {.count = 1, .reusable = true}, SHIFT(3286),
  [7709] = {.count = 1, .reusable = true}, SHIFT(3288),
  [7711] = {.count = 1, .reusable = true}, SHIFT(3289),
  [7713] = {.count = 1, .reusable = false}, SHIFT(3291),
  [7715] = {.count = 1, .reusable = true}, SHIFT(3291),
  [7717] = {.count = 1, .reusable = true}, SHIFT(3290),
  [7719] = {.count = 1, .reusable = false}, SHIFT(3293),
  [7721] = {.count = 1, .reusable = true}, SHIFT(3293),
  [7723] = {.count = 1, .reusable = true}, SHIFT(3292),
  [7725] = {.count = 1, .reusable = true}, SHIFT(3294),
  [7727] = {.count = 1, .reusable = true}, SHIFT(3295),
  [7729] = {.count = 1, .reusable = false}, SHIFT(3296),
  [7731] = {.count = 1, .reusable = true}, SHIFT(3296),
  [7733] = {.count = 1, .reusable = true}, SHIFT(3297),
  [7735] = {.count = 1, .reusable = true}, SHIFT(3298),
  [7737] = {.count = 1, .reusable = true}, SHIFT(3299),
  [7739] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2182),
  [7742] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2186),
  [7745] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2186),
  [7748] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2187),
  [7751] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2190),
  [7754] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2191),
  [7757] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1513),
  [7760] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1514),
  [7763] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2192),
  [7766] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1516),
  [7769] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1517),
  [7772] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1518),
  [7775] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1519),
  [7778] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2192),
  [7781] = {.count = 1, .reusable = false}, SHIFT(3301),
  [7783] = {.count = 1, .reusable = true}, SHIFT(3301),
  [7785] = {.count = 1, .reusable = true}, SHIFT(3302),
  [7787] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2198),
  [7790] = {.count = 1, .reusable = false}, SHIFT(3304),
  [7792] = {.count = 1, .reusable = true}, SHIFT(3305),
  [7794] = {.count = 1, .reusable = false}, SHIFT(3306),
  [7796] = {.count = 1, .reusable = true}, SHIFT(3307),
  [7798] = {.count = 1, .reusable = true}, SHIFT(3309),
  [7800] = {.count = 1, .reusable = true}, SHIFT(3310),
  [7802] = {.count = 1, .reusable = false}, SHIFT(3312),
  [7804] = {.count = 1, .reusable = true}, SHIFT(3312),
  [7806] = {.count = 1, .reusable = true}, SHIFT(3311),
  [7808] = {.count = 1, .reusable = false}, SHIFT(3314),
  [7810] = {.count = 1, .reusable = true}, SHIFT(3314),
  [7812] = {.count = 1, .reusable = true}, SHIFT(3313),
  [7814] = {.count = 1, .reusable = true}, SHIFT(3315),
  [7816] = {.count = 1, .reusable = true}, SHIFT(3316),
  [7818] = {.count = 1, .reusable = false}, SHIFT(3317),
  [7820] = {.count = 1, .reusable = true}, SHIFT(3317),
  [7822] = {.count = 1, .reusable = true}, SHIFT(3318),
  [7824] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2215),
  [7827] = {.count = 1, .reusable = false}, SHIFT(3319),
  [7829] = {.count = 1, .reusable = true}, SHIFT(3320),
  [7831] = {.count = 1, .reusable = false}, SHIFT(3321),
  [7833] = {.count = 1, .reusable = true}, SHIFT(3322),
  [7835] = {.count = 1, .reusable = true}, SHIFT(3324),
  [7837] = {.count = 1, .reusable = true}, SHIFT(3325),
  [7839] = {.count = 1, .reusable = false}, SHIFT(3327),
  [7841] = {.count = 1, .reusable = true}, SHIFT(3327),
  [7843] = {.count = 1, .reusable = true}, SHIFT(3326),
  [7845] = {.count = 1, .reusable = false}, SHIFT(3329),
  [7847] = {.count = 1, .reusable = true}, SHIFT(3329),
  [7849] = {.count = 1, .reusable = true}, SHIFT(3328),
  [7851] = {.count = 1, .reusable = true}, SHIFT(3330),
  [7853] = {.count = 1, .reusable = true}, SHIFT(3331),
  [7855] = {.count = 1, .reusable = false}, SHIFT(3332),
  [7857] = {.count = 1, .reusable = true}, SHIFT(3332),
  [7859] = {.count = 1, .reusable = true}, SHIFT(3333),
  [7861] = {.count = 1, .reusable = true}, SHIFT(3334),
  [7863] = {.count = 1, .reusable = true}, SHIFT(3335),
  [7865] = {.count = 1, .reusable = false}, SHIFT(3336),
  [7867] = {.count = 1, .reusable = true}, SHIFT(3337),
  [7869] = {.count = 1, .reusable = true}, SHIFT(3339),
  [7871] = {.count = 1, .reusable = true}, SHIFT(3340),
  [7873] = {.count = 1, .reusable = false}, SHIFT(3341),
  [7875] = {.count = 1, .reusable = true}, SHIFT(3341),
  [7877] = {.count = 1, .reusable = true}, SHIFT(3342),
  [7879] = {.count = 1, .reusable = false}, SHIFT(3343),
  [7881] = {.count = 1, .reusable = true}, SHIFT(3343),
  [7883] = {.count = 1, .reusable = true}, SHIFT(3344),
  [7885] = {.count = 1, .reusable = false}, SHIFT(3345),
  [7887] = {.count = 1, .reusable = true}, SHIFT(3345),
  [7889] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [7891] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [7893] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 2),
  [7895] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [7897] = {.count = 1, .reusable = true}, SHIFT(3347),
  [7899] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [7901] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [7903] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [7905] = {.count = 1, .reusable = true}, SHIFT(3348),
  [7907] = {.count = 1, .reusable = true}, SHIFT(3349),
  [7909] = {.count = 1, .reusable = true}, SHIFT(3350),
  [7911] = {.count = 1, .reusable = false}, SHIFT(3351),
  [7913] = {.count = 1, .reusable = true}, SHIFT(3352),
  [7915] = {.count = 1, .reusable = true}, SHIFT(3353),
  [7917] = {.count = 1, .reusable = true}, SHIFT(3354),
  [7919] = {.count = 1, .reusable = true}, SHIFT(3355),
  [7921] = {.count = 1, .reusable = true}, SHIFT(3356),
  [7923] = {.count = 1, .reusable = false}, SHIFT(3358),
  [7925] = {.count = 1, .reusable = false}, SHIFT(3352),
  [7927] = {.count = 1, .reusable = true}, SHIFT(3359),
  [7929] = {.count = 1, .reusable = true}, SHIFT(3360),
  [7931] = {.count = 1, .reusable = false}, SHIFT(3361),
  [7933] = {.count = 1, .reusable = true}, SHIFT(3362),
  [7935] = {.count = 1, .reusable = true}, SHIFT(3363),
  [7937] = {.count = 1, .reusable = true}, SHIFT(3364),
  [7939] = {.count = 1, .reusable = true}, SHIFT(3365),
  [7941] = {.count = 1, .reusable = true}, SHIFT(3366),
  [7943] = {.count = 1, .reusable = false}, SHIFT(3367),
  [7945] = {.count = 1, .reusable = false}, SHIFT(3362),
  [7947] = {.count = 1, .reusable = true}, SHIFT(3368),
  [7949] = {.count = 1, .reusable = false}, SHIFT(3370),
  [7951] = {.count = 1, .reusable = false}, SHIFT(3371),
  [7953] = {.count = 1, .reusable = true}, SHIFT(3373),
  [7955] = {.count = 1, .reusable = true}, SHIFT(3374),
  [7957] = {.count = 1, .reusable = false}, SHIFT(3375),
  [7959] = {.count = 1, .reusable = true}, SHIFT(3375),
  [7961] = {.count = 1, .reusable = true}, SHIFT(3376),
  [7963] = {.count = 1, .reusable = true}, SHIFT(3377),
  [7965] = {.count = 1, .reusable = true}, SHIFT(3378),
  [7967] = {.count = 1, .reusable = false}, SHIFT(3379),
  [7969] = {.count = 1, .reusable = true}, SHIFT(3379),
  [7971] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [7973] = {.count = 1, .reusable = true}, SHIFT(3384),
  [7975] = {.count = 1, .reusable = true}, SHIFT(3385),
  [7977] = {.count = 1, .reusable = false}, SHIFT(3386),
  [7979] = {.count = 1, .reusable = false}, SHIFT(3387),
  [7981] = {.count = 1, .reusable = true}, SHIFT(3387),
  [7983] = {.count = 1, .reusable = true}, SHIFT(3388),
  [7985] = {.count = 1, .reusable = false}, SHIFT(3389),
  [7987] = {.count = 1, .reusable = true}, SHIFT(3389),
  [7989] = {.count = 1, .reusable = true}, SHIFT(3390),
  [7991] = {.count = 1, .reusable = true}, SHIFT(3386),
  [7993] = {.count = 1, .reusable = false}, SHIFT(3393),
  [7995] = {.count = 1, .reusable = true}, SHIFT(3394),
  [7997] = {.count = 1, .reusable = true}, SHIFT(3395),
  [7999] = {.count = 1, .reusable = false}, SHIFT(3395),
  [8001] = {.count = 1, .reusable = true}, SHIFT(2883),
  [8003] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(2268),
  [8006] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [8008] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [8010] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [8012] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [8014] = {.count = 1, .reusable = true}, SHIFT(3401),
  [8016] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [8018] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [8020] = {.count = 1, .reusable = true}, SHIFT(3403),
  [8022] = {.count = 1, .reusable = true}, SHIFT(3405),
  [8024] = {.count = 1, .reusable = true}, SHIFT(3407),
  [8026] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7),
  [8028] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7),
  [8030] = {.count = 1, .reusable = true}, SHIFT(3408),
  [8032] = {.count = 1, .reusable = true}, SHIFT(3409),
  [8034] = {.count = 1, .reusable = true}, SHIFT(3410),
  [8036] = {.count = 1, .reusable = true}, SHIFT(3411),
  [8038] = {.count = 1, .reusable = true}, SHIFT(3412),
  [8040] = {.count = 1, .reusable = false}, SHIFT(3413),
  [8042] = {.count = 1, .reusable = true}, SHIFT(3414),
  [8044] = {.count = 1, .reusable = true}, SHIFT(3416),
  [8046] = {.count = 1, .reusable = true}, SHIFT(3417),
  [8048] = {.count = 1, .reusable = false}, SHIFT(3418),
  [8050] = {.count = 1, .reusable = true}, SHIFT(3418),
  [8052] = {.count = 1, .reusable = true}, SHIFT(3419),
  [8054] = {.count = 1, .reusable = false}, SHIFT(3420),
  [8056] = {.count = 1, .reusable = true}, SHIFT(3420),
  [8058] = {.count = 1, .reusable = true}, SHIFT(3421),
  [8060] = {.count = 1, .reusable = false}, SHIFT(3422),
  [8062] = {.count = 1, .reusable = true}, SHIFT(3422),
  [8064] = {.count = 1, .reusable = true}, SHIFT(3424),
  [8066] = {.count = 1, .reusable = true}, SHIFT(3425),
  [8068] = {.count = 1, .reusable = true}, SHIFT(3427),
  [8070] = {.count = 1, .reusable = true}, SHIFT(3428),
  [8072] = {.count = 1, .reusable = true}, SHIFT(3430),
  [8074] = {.count = 1, .reusable = true}, SHIFT(3432),
  [8076] = {.count = 1, .reusable = true}, SHIFT(3433),
  [8078] = {.count = 1, .reusable = true}, SHIFT(3434),
  [8080] = {.count = 1, .reusable = false}, SHIFT(3435),
  [8082] = {.count = 1, .reusable = true}, SHIFT(3435),
  [8084] = {.count = 1, .reusable = false}, SHIFT(3436),
  [8086] = {.count = 1, .reusable = true}, SHIFT(3436),
  [8088] = {.count = 1, .reusable = true}, SHIFT(3437),
  [8090] = {.count = 1, .reusable = true}, SHIFT(3438),
  [8092] = {.count = 1, .reusable = true}, SHIFT(3439),
  [8094] = {.count = 1, .reusable = true}, SHIFT(3440),
  [8096] = {.count = 1, .reusable = false}, SHIFT(3441),
  [8098] = {.count = 1, .reusable = true}, SHIFT(3441),
  [8100] = {.count = 1, .reusable = false}, SHIFT(3442),
  [8102] = {.count = 1, .reusable = true}, SHIFT(3442),
  [8104] = {.count = 1, .reusable = true}, SHIFT(3443),
  [8106] = {.count = 1, .reusable = true}, SHIFT(3444),
  [8108] = {.count = 1, .reusable = true}, SHIFT(3445),
  [8110] = {.count = 1, .reusable = true}, SHIFT(3446),
  [8112] = {.count = 1, .reusable = true}, SHIFT(3447),
  [8114] = {.count = 1, .reusable = true}, SHIFT(3448),
  [8116] = {.count = 1, .reusable = true}, SHIFT(3449),
  [8118] = {.count = 1, .reusable = true}, SHIFT(3450),
  [8120] = {.count = 1, .reusable = true}, SHIFT(3451),
  [8122] = {.count = 1, .reusable = true}, SHIFT(3452),
  [8124] = {.count = 1, .reusable = true}, SHIFT(3453),
  [8126] = {.count = 1, .reusable = true}, SHIFT(3454),
  [8128] = {.count = 1, .reusable = true}, SHIFT(3455),
  [8130] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [8132] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [8134] = {.count = 1, .reusable = true}, SHIFT(3456),
  [8136] = {.count = 1, .reusable = true}, SHIFT(3457),
  [8138] = {.count = 1, .reusable = false}, SHIFT(3458),
  [8140] = {.count = 1, .reusable = true}, SHIFT(3459),
  [8142] = {.count = 1, .reusable = true}, SHIFT(3461),
  [8144] = {.count = 1, .reusable = true}, SHIFT(3462),
  [8146] = {.count = 1, .reusable = false}, SHIFT(3463),
  [8148] = {.count = 1, .reusable = true}, SHIFT(3463),
  [8150] = {.count = 1, .reusable = true}, SHIFT(3464),
  [8152] = {.count = 1, .reusable = false}, SHIFT(3465),
  [8154] = {.count = 1, .reusable = true}, SHIFT(3465),
  [8156] = {.count = 1, .reusable = true}, SHIFT(3466),
  [8158] = {.count = 1, .reusable = false}, SHIFT(3467),
  [8160] = {.count = 1, .reusable = true}, SHIFT(3467),
  [8162] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [8164] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [8166] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7),
  [8168] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7),
  [8170] = {.count = 1, .reusable = true}, SHIFT(3468),
  [8172] = {.count = 1, .reusable = true}, SHIFT(3469),
  [8174] = {.count = 1, .reusable = true}, SHIFT(3470),
  [8176] = {.count = 1, .reusable = false}, SHIFT(3471),
  [8178] = {.count = 1, .reusable = true}, SHIFT(3471),
  [8180] = {.count = 1, .reusable = false}, SHIFT(3472),
  [8182] = {.count = 1, .reusable = true}, SHIFT(3472),
  [8184] = {.count = 1, .reusable = true}, SHIFT(3473),
  [8186] = {.count = 1, .reusable = true}, SHIFT(3474),
  [8188] = {.count = 1, .reusable = true}, SHIFT(3475),
  [8190] = {.count = 1, .reusable = true}, SHIFT(3476),
  [8192] = {.count = 1, .reusable = false}, SHIFT(3477),
  [8194] = {.count = 1, .reusable = true}, SHIFT(3477),
  [8196] = {.count = 1, .reusable = false}, SHIFT(3478),
  [8198] = {.count = 1, .reusable = true}, SHIFT(3478),
  [8200] = {.count = 1, .reusable = true}, SHIFT(3479),
  [8202] = {.count = 1, .reusable = true}, SHIFT(3480),
  [8204] = {.count = 1, .reusable = true}, SHIFT(3481),
  [8206] = {.count = 1, .reusable = true}, SHIFT(3482),
  [8208] = {.count = 1, .reusable = false}, SHIFT(3483),
  [8210] = {.count = 1, .reusable = true}, SHIFT(3483),
  [8212] = {.count = 1, .reusable = false}, SHIFT(3484),
  [8214] = {.count = 1, .reusable = true}, SHIFT(3484),
  [8216] = {.count = 1, .reusable = true}, SHIFT(3485),
  [8218] = {.count = 1, .reusable = true}, SHIFT(3486),
  [8220] = {.count = 1, .reusable = true}, SHIFT(3487),
  [8222] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [8224] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [8226] = {.count = 1, .reusable = true}, SHIFT(3489),
  [8228] = {.count = 1, .reusable = true}, SHIFT(3490),
  [8230] = {.count = 1, .reusable = true}, SHIFT(3491),
  [8232] = {.count = 1, .reusable = true}, SHIFT(3492),
  [8234] = {.count = 1, .reusable = true}, SHIFT(3493),
  [8236] = {.count = 1, .reusable = true}, SHIFT(3494),
  [8238] = {.count = 1, .reusable = false}, SHIFT(3495),
  [8240] = {.count = 1, .reusable = true}, SHIFT(3495),
  [8242] = {.count = 1, .reusable = false}, SHIFT(3496),
  [8244] = {.count = 1, .reusable = true}, SHIFT(3496),
  [8246] = {.count = 1, .reusable = true}, SHIFT(3497),
  [8248] = {.count = 1, .reusable = true}, SHIFT(3498),
  [8250] = {.count = 1, .reusable = true}, SHIFT(3499),
  [8252] = {.count = 1, .reusable = true}, SHIFT(3500),
  [8254] = {.count = 1, .reusable = true}, SHIFT(3501),
  [8256] = {.count = 1, .reusable = true}, SHIFT(3502),
  [8258] = {.count = 1, .reusable = false}, SHIFT(3503),
  [8260] = {.count = 1, .reusable = true}, SHIFT(3503),
  [8262] = {.count = 1, .reusable = false}, SHIFT(3504),
  [8264] = {.count = 1, .reusable = true}, SHIFT(3504),
  [8266] = {.count = 1, .reusable = true}, SHIFT(3505),
  [8268] = {.count = 1, .reusable = true}, SHIFT(3507),
  [8270] = {.count = 1, .reusable = true}, SHIFT(3508),
  [8272] = {.count = 1, .reusable = true}, SHIFT(3509),
  [8274] = {.count = 1, .reusable = true}, SHIFT(3510),
  [8276] = {.count = 1, .reusable = true}, SHIFT(3511),
  [8278] = {.count = 1, .reusable = true}, SHIFT(3512),
  [8280] = {.count = 1, .reusable = true}, SHIFT(3513),
  [8282] = {.count = 1, .reusable = true}, SHIFT(3514),
  [8284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2635),
  [8287] = {.count = 1, .reusable = false}, SHIFT(3515),
  [8289] = {.count = 1, .reusable = true}, SHIFT(3516),
  [8291] = {.count = 1, .reusable = false}, SHIFT(3517),
  [8293] = {.count = 1, .reusable = true}, SHIFT(3518),
  [8295] = {.count = 1, .reusable = true}, SHIFT(3520),
  [8297] = {.count = 1, .reusable = true}, SHIFT(3521),
  [8299] = {.count = 1, .reusable = false}, SHIFT(3523),
  [8301] = {.count = 1, .reusable = true}, SHIFT(3523),
  [8303] = {.count = 1, .reusable = true}, SHIFT(3522),
  [8305] = {.count = 1, .reusable = false}, SHIFT(3525),
  [8307] = {.count = 1, .reusable = true}, SHIFT(3525),
  [8309] = {.count = 1, .reusable = true}, SHIFT(3524),
  [8311] = {.count = 1, .reusable = true}, SHIFT(3526),
  [8313] = {.count = 1, .reusable = true}, SHIFT(3527),
  [8315] = {.count = 1, .reusable = false}, SHIFT(3528),
  [8317] = {.count = 1, .reusable = true}, SHIFT(3528),
  [8319] = {.count = 1, .reusable = true}, SHIFT(3529),
  [8321] = {.count = 1, .reusable = true}, SHIFT(3530),
  [8323] = {.count = 1, .reusable = true}, SHIFT(3531),
  [8325] = {.count = 1, .reusable = true}, SHIFT(3532),
  [8327] = {.count = 1, .reusable = false}, SHIFT(3533),
  [8329] = {.count = 1, .reusable = true}, SHIFT(3534),
  [8331] = {.count = 1, .reusable = true}, SHIFT(3536),
  [8333] = {.count = 1, .reusable = true}, SHIFT(3537),
  [8335] = {.count = 1, .reusable = false}, SHIFT(3538),
  [8337] = {.count = 1, .reusable = true}, SHIFT(3538),
  [8339] = {.count = 1, .reusable = true}, SHIFT(3539),
  [8341] = {.count = 1, .reusable = false}, SHIFT(3540),
  [8343] = {.count = 1, .reusable = true}, SHIFT(3540),
  [8345] = {.count = 1, .reusable = true}, SHIFT(3541),
  [8347] = {.count = 1, .reusable = false}, SHIFT(3542),
  [8349] = {.count = 1, .reusable = true}, SHIFT(3542),
  [8351] = {.count = 1, .reusable = true}, SHIFT(3543),
  [8353] = {.count = 1, .reusable = true}, SHIFT(3544),
  [8355] = {.count = 1, .reusable = false}, SHIFT(3545),
  [8357] = {.count = 1, .reusable = true}, SHIFT(3546),
  [8359] = {.count = 1, .reusable = true}, SHIFT(3548),
  [8361] = {.count = 1, .reusable = true}, SHIFT(3549),
  [8363] = {.count = 1, .reusable = false}, SHIFT(3550),
  [8365] = {.count = 1, .reusable = true}, SHIFT(3550),
  [8367] = {.count = 1, .reusable = true}, SHIFT(3551),
  [8369] = {.count = 1, .reusable = false}, SHIFT(3552),
  [8371] = {.count = 1, .reusable = true}, SHIFT(3552),
  [8373] = {.count = 1, .reusable = true}, SHIFT(3553),
  [8375] = {.count = 1, .reusable = false}, SHIFT(3554),
  [8377] = {.count = 1, .reusable = true}, SHIFT(3554),
  [8379] = {.count = 1, .reusable = true}, SHIFT(3555),
  [8381] = {.count = 1, .reusable = true}, SHIFT(3556),
  [8383] = {.count = 1, .reusable = true}, SHIFT(3557),
  [8385] = {.count = 1, .reusable = false}, SHIFT(3558),
  [8387] = {.count = 1, .reusable = true}, SHIFT(3558),
  [8389] = {.count = 1, .reusable = false}, SHIFT(3559),
  [8391] = {.count = 1, .reusable = true}, SHIFT(3559),
  [8393] = {.count = 1, .reusable = true}, SHIFT(3560),
  [8395] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2704),
  [8398] = {.count = 1, .reusable = false}, SHIFT(3561),
  [8400] = {.count = 1, .reusable = true}, SHIFT(3562),
  [8402] = {.count = 1, .reusable = false}, SHIFT(3563),
  [8404] = {.count = 1, .reusable = true}, SHIFT(3564),
  [8406] = {.count = 1, .reusable = true}, SHIFT(3566),
  [8408] = {.count = 1, .reusable = true}, SHIFT(3567),
  [8410] = {.count = 1, .reusable = false}, SHIFT(3569),
  [8412] = {.count = 1, .reusable = true}, SHIFT(3569),
  [8414] = {.count = 1, .reusable = true}, SHIFT(3568),
  [8416] = {.count = 1, .reusable = false}, SHIFT(3571),
  [8418] = {.count = 1, .reusable = true}, SHIFT(3571),
  [8420] = {.count = 1, .reusable = true}, SHIFT(3570),
  [8422] = {.count = 1, .reusable = true}, SHIFT(3572),
  [8424] = {.count = 1, .reusable = true}, SHIFT(3573),
  [8426] = {.count = 1, .reusable = false}, SHIFT(3574),
  [8428] = {.count = 1, .reusable = true}, SHIFT(3574),
  [8430] = {.count = 1, .reusable = true}, SHIFT(3575),
  [8432] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2723),
  [8435] = {.count = 1, .reusable = false}, SHIFT(3576),
  [8437] = {.count = 1, .reusable = true}, SHIFT(3577),
  [8439] = {.count = 1, .reusable = false}, SHIFT(3578),
  [8441] = {.count = 1, .reusable = true}, SHIFT(3579),
  [8443] = {.count = 1, .reusable = true}, SHIFT(3581),
  [8445] = {.count = 1, .reusable = true}, SHIFT(3582),
  [8447] = {.count = 1, .reusable = false}, SHIFT(3584),
  [8449] = {.count = 1, .reusable = true}, SHIFT(3584),
  [8451] = {.count = 1, .reusable = true}, SHIFT(3583),
  [8453] = {.count = 1, .reusable = false}, SHIFT(3586),
  [8455] = {.count = 1, .reusable = true}, SHIFT(3586),
  [8457] = {.count = 1, .reusable = true}, SHIFT(3585),
  [8459] = {.count = 1, .reusable = true}, SHIFT(3587),
  [8461] = {.count = 1, .reusable = true}, SHIFT(3588),
  [8463] = {.count = 1, .reusable = false}, SHIFT(3589),
  [8465] = {.count = 1, .reusable = true}, SHIFT(3589),
  [8467] = {.count = 1, .reusable = true}, SHIFT(3590),
  [8469] = {.count = 1, .reusable = true}, SHIFT(3591),
  [8471] = {.count = 1, .reusable = true}, SHIFT(3592),
  [8473] = {.count = 1, .reusable = false}, SHIFT(3594),
  [8475] = {.count = 1, .reusable = false}, SHIFT(3595),
  [8477] = {.count = 1, .reusable = true}, SHIFT(3596),
  [8479] = {.count = 1, .reusable = true}, SHIFT(3597),
  [8481] = {.count = 1, .reusable = true}, SHIFT(3598),
  [8483] = {.count = 1, .reusable = false}, SHIFT(3599),
  [8485] = {.count = 1, .reusable = true}, SHIFT(3599),
  [8487] = {.count = 1, .reusable = true}, SHIFT(3600),
  [8489] = {.count = 1, .reusable = false}, SHIFT(3602),
  [8491] = {.count = 1, .reusable = true}, SHIFT(3602),
  [8493] = {.count = 1, .reusable = true}, SHIFT(3601),
  [8495] = {.count = 1, .reusable = true}, SHIFT(3603),
  [8497] = {.count = 1, .reusable = false}, SHIFT(3605),
  [8499] = {.count = 1, .reusable = true}, SHIFT(3605),
  [8501] = {.count = 1, .reusable = true}, SHIFT(3604),
  [8503] = {.count = 1, .reusable = true}, SHIFT(3606),
  [8505] = {.count = 1, .reusable = true}, SHIFT(3607),
  [8507] = {.count = 1, .reusable = true}, SHIFT(3608),
  [8509] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2751),
  [8512] = {.count = 1, .reusable = false}, SHIFT(3610),
  [8514] = {.count = 1, .reusable = true}, SHIFT(3611),
  [8516] = {.count = 1, .reusable = false}, SHIFT(3612),
  [8518] = {.count = 1, .reusable = true}, SHIFT(3613),
  [8520] = {.count = 1, .reusable = true}, SHIFT(3615),
  [8522] = {.count = 1, .reusable = true}, SHIFT(3616),
  [8524] = {.count = 1, .reusable = false}, SHIFT(3618),
  [8526] = {.count = 1, .reusable = true}, SHIFT(3618),
  [8528] = {.count = 1, .reusable = true}, SHIFT(3617),
  [8530] = {.count = 1, .reusable = false}, SHIFT(3620),
  [8532] = {.count = 1, .reusable = true}, SHIFT(3620),
  [8534] = {.count = 1, .reusable = true}, SHIFT(3619),
  [8536] = {.count = 1, .reusable = true}, SHIFT(3621),
  [8538] = {.count = 1, .reusable = true}, SHIFT(3622),
  [8540] = {.count = 1, .reusable = false}, SHIFT(3623),
  [8542] = {.count = 1, .reusable = true}, SHIFT(3623),
  [8544] = {.count = 1, .reusable = true}, SHIFT(3624),
  [8546] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2768),
  [8549] = {.count = 1, .reusable = false}, SHIFT(3625),
  [8551] = {.count = 1, .reusable = true}, SHIFT(3626),
  [8553] = {.count = 1, .reusable = false}, SHIFT(3627),
  [8555] = {.count = 1, .reusable = true}, SHIFT(3628),
  [8557] = {.count = 1, .reusable = true}, SHIFT(3630),
  [8559] = {.count = 1, .reusable = true}, SHIFT(3631),
  [8561] = {.count = 1, .reusable = false}, SHIFT(3633),
  [8563] = {.count = 1, .reusable = true}, SHIFT(3633),
  [8565] = {.count = 1, .reusable = true}, SHIFT(3632),
  [8567] = {.count = 1, .reusable = false}, SHIFT(3635),
  [8569] = {.count = 1, .reusable = true}, SHIFT(3635),
  [8571] = {.count = 1, .reusable = true}, SHIFT(3634),
  [8573] = {.count = 1, .reusable = true}, SHIFT(3636),
  [8575] = {.count = 1, .reusable = true}, SHIFT(3637),
  [8577] = {.count = 1, .reusable = false}, SHIFT(3638),
  [8579] = {.count = 1, .reusable = true}, SHIFT(3638),
  [8581] = {.count = 1, .reusable = true}, SHIFT(3639),
  [8583] = {.count = 1, .reusable = true}, SHIFT(3640),
  [8585] = {.count = 1, .reusable = true}, SHIFT(3641),
  [8587] = {.count = 1, .reusable = false}, SHIFT(3642),
  [8589] = {.count = 1, .reusable = true}, SHIFT(3643),
  [8591] = {.count = 1, .reusable = true}, SHIFT(3645),
  [8593] = {.count = 1, .reusable = true}, SHIFT(3646),
  [8595] = {.count = 1, .reusable = false}, SHIFT(3647),
  [8597] = {.count = 1, .reusable = true}, SHIFT(3647),
  [8599] = {.count = 1, .reusable = true}, SHIFT(3648),
  [8601] = {.count = 1, .reusable = false}, SHIFT(3649),
  [8603] = {.count = 1, .reusable = true}, SHIFT(3649),
  [8605] = {.count = 1, .reusable = true}, SHIFT(3650),
  [8607] = {.count = 1, .reusable = false}, SHIFT(3651),
  [8609] = {.count = 1, .reusable = true}, SHIFT(3651),
  [8611] = {.count = 1, .reusable = true}, SHIFT(3653),
  [8613] = {.count = 1, .reusable = true}, SHIFT(3654),
  [8615] = {.count = 1, .reusable = true}, SHIFT(3655),
  [8617] = {.count = 1, .reusable = false}, SHIFT(3656),
  [8619] = {.count = 1, .reusable = true}, SHIFT(3657),
  [8621] = {.count = 1, .reusable = true}, SHIFT(3659),
  [8623] = {.count = 1, .reusable = true}, SHIFT(3660),
  [8625] = {.count = 1, .reusable = false}, SHIFT(3661),
  [8627] = {.count = 1, .reusable = true}, SHIFT(3661),
  [8629] = {.count = 1, .reusable = true}, SHIFT(3662),
  [8631] = {.count = 1, .reusable = false}, SHIFT(3663),
  [8633] = {.count = 1, .reusable = true}, SHIFT(3663),
  [8635] = {.count = 1, .reusable = true}, SHIFT(3664),
  [8637] = {.count = 1, .reusable = false}, SHIFT(3665),
  [8639] = {.count = 1, .reusable = true}, SHIFT(3665),
  [8641] = {.count = 1, .reusable = true}, SHIFT(3666),
  [8643] = {.count = 1, .reusable = true}, SHIFT(3667),
  [8645] = {.count = 1, .reusable = false}, SHIFT(3668),
  [8647] = {.count = 1, .reusable = true}, SHIFT(3669),
  [8649] = {.count = 1, .reusable = true}, SHIFT(3671),
  [8651] = {.count = 1, .reusable = true}, SHIFT(3672),
  [8653] = {.count = 1, .reusable = false}, SHIFT(3673),
  [8655] = {.count = 1, .reusable = true}, SHIFT(3673),
  [8657] = {.count = 1, .reusable = true}, SHIFT(3674),
  [8659] = {.count = 1, .reusable = false}, SHIFT(3675),
  [8661] = {.count = 1, .reusable = true}, SHIFT(3675),
  [8663] = {.count = 1, .reusable = true}, SHIFT(3676),
  [8665] = {.count = 1, .reusable = false}, SHIFT(3677),
  [8667] = {.count = 1, .reusable = true}, SHIFT(3677),
  [8669] = {.count = 1, .reusable = true}, SHIFT(3678),
  [8671] = {.count = 1, .reusable = true}, SHIFT(3679),
  [8673] = {.count = 1, .reusable = true}, SHIFT(3680),
  [8675] = {.count = 1, .reusable = false}, SHIFT(3681),
  [8677] = {.count = 1, .reusable = true}, SHIFT(3681),
  [8679] = {.count = 1, .reusable = false}, SHIFT(3682),
  [8681] = {.count = 1, .reusable = true}, SHIFT(3682),
  [8683] = {.count = 1, .reusable = true}, SHIFT(3683),
  [8685] = {.count = 1, .reusable = true}, SHIFT(3684),
  [8687] = {.count = 1, .reusable = true}, SHIFT(3685),
  [8689] = {.count = 1, .reusable = true}, SHIFT(3686),
  [8691] = {.count = 1, .reusable = true}, SHIFT(3687),
  [8693] = {.count = 1, .reusable = false}, SHIFT(3688),
  [8695] = {.count = 1, .reusable = true}, SHIFT(3689),
  [8697] = {.count = 1, .reusable = true}, SHIFT(3690),
  [8699] = {.count = 1, .reusable = true}, SHIFT(3691),
  [8701] = {.count = 1, .reusable = true}, SHIFT(3692),
  [8703] = {.count = 1, .reusable = true}, SHIFT(3693),
  [8705] = {.count = 1, .reusable = true}, SHIFT(3694),
  [8707] = {.count = 1, .reusable = true}, SHIFT(3695),
  [8709] = {.count = 1, .reusable = false}, SHIFT(3697),
  [8711] = {.count = 1, .reusable = false}, SHIFT(3698),
  [8713] = {.count = 1, .reusable = true}, SHIFT(3700),
  [8715] = {.count = 1, .reusable = true}, SHIFT(3701),
  [8717] = {.count = 1, .reusable = false}, SHIFT(3702),
  [8719] = {.count = 1, .reusable = true}, SHIFT(3702),
  [8721] = {.count = 1, .reusable = true}, SHIFT(3703),
  [8723] = {.count = 1, .reusable = true}, SHIFT(3704),
  [8725] = {.count = 1, .reusable = true}, SHIFT(3705),
  [8727] = {.count = 1, .reusable = false}, SHIFT(3706),
  [8729] = {.count = 1, .reusable = true}, SHIFT(3706),
  [8731] = {.count = 1, .reusable = false}, SHIFT(3711),
  [8733] = {.count = 1, .reusable = true}, SHIFT(3712),
  [8735] = {.count = 1, .reusable = false}, SHIFT(3714),
  [8737] = {.count = 1, .reusable = false}, SHIFT(3715),
  [8739] = {.count = 1, .reusable = true}, SHIFT(3717),
  [8741] = {.count = 1, .reusable = true}, SHIFT(3718),
  [8743] = {.count = 1, .reusable = false}, SHIFT(3719),
  [8745] = {.count = 1, .reusable = true}, SHIFT(3719),
  [8747] = {.count = 1, .reusable = true}, SHIFT(3720),
  [8749] = {.count = 1, .reusable = true}, SHIFT(3721),
  [8751] = {.count = 1, .reusable = true}, SHIFT(3722),
  [8753] = {.count = 1, .reusable = false}, SHIFT(3723),
  [8755] = {.count = 1, .reusable = true}, SHIFT(3723),
  [8757] = {.count = 1, .reusable = false}, SHIFT(3728),
  [8759] = {.count = 1, .reusable = true}, SHIFT(3729),
  [8761] = {.count = 1, .reusable = false}, SHIFT(3731),
  [8763] = {.count = 1, .reusable = false}, SHIFT(3732),
  [8765] = {.count = 1, .reusable = true}, SHIFT(3733),
  [8767] = {.count = 1, .reusable = true}, SHIFT(3734),
  [8769] = {.count = 1, .reusable = true}, SHIFT(3735),
  [8771] = {.count = 1, .reusable = false}, SHIFT(3736),
  [8773] = {.count = 1, .reusable = true}, SHIFT(3736),
  [8775] = {.count = 1, .reusable = true}, SHIFT(3737),
  [8777] = {.count = 1, .reusable = false}, SHIFT(3739),
  [8779] = {.count = 1, .reusable = true}, SHIFT(3739),
  [8781] = {.count = 1, .reusable = true}, SHIFT(3738),
  [8783] = {.count = 1, .reusable = true}, SHIFT(3740),
  [8785] = {.count = 1, .reusable = false}, SHIFT(3742),
  [8787] = {.count = 1, .reusable = true}, SHIFT(3742),
  [8789] = {.count = 1, .reusable = true}, SHIFT(3741),
  [8791] = {.count = 1, .reusable = true}, SHIFT(3743),
  [8793] = {.count = 1, .reusable = true}, SHIFT(3744),
  [8795] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [8797] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [8799] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [8801] = {.count = 1, .reusable = false}, SHIFT(3745),
  [8803] = {.count = 1, .reusable = true}, SHIFT(3745),
  [8805] = {.count = 1, .reusable = true}, SHIFT(3750),
  [8807] = {.count = 1, .reusable = true}, SHIFT(3751),
  [8809] = {.count = 1, .reusable = true}, SHIFT(3752),
  [8811] = {.count = 1, .reusable = true}, SHIFT(3753),
  [8813] = {.count = 1, .reusable = false}, SHIFT(3754),
  [8815] = {.count = 1, .reusable = true}, SHIFT(3754),
  [8817] = {.count = 1, .reusable = true}, SHIFT(3756),
  [8819] = {.count = 1, .reusable = true}, SHIFT(3757),
  [8821] = {.count = 1, .reusable = true}, SHIFT(3758),
  [8823] = {.count = 1, .reusable = false}, SHIFT(3760),
  [8825] = {.count = 1, .reusable = true}, SHIFT(3760),
  [8827] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [8829] = {.count = 1, .reusable = true}, SHIFT(3763),
  [8831] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [8833] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [8835] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [8837] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [8839] = {.count = 1, .reusable = true}, SHIFT(3764),
  [8841] = {.count = 1, .reusable = true}, SHIFT(3765),
  [8843] = {.count = 1, .reusable = true}, SHIFT(3770),
  [8845] = {.count = 1, .reusable = true}, SHIFT(3771),
  [8847] = {.count = 1, .reusable = true}, SHIFT(3773),
  [8849] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [8851] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [8853] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8),
  [8855] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8),
  [8857] = {.count = 1, .reusable = true}, SHIFT(3774),
  [8859] = {.count = 1, .reusable = true}, SHIFT(3775),
  [8861] = {.count = 1, .reusable = true}, SHIFT(3776),
  [8863] = {.count = 1, .reusable = false}, SHIFT(3777),
  [8865] = {.count = 1, .reusable = true}, SHIFT(3777),
  [8867] = {.count = 1, .reusable = false}, SHIFT(3778),
  [8869] = {.count = 1, .reusable = true}, SHIFT(3778),
  [8871] = {.count = 1, .reusable = true}, SHIFT(3779),
  [8873] = {.count = 1, .reusable = true}, SHIFT(3781),
  [8875] = {.count = 1, .reusable = true}, SHIFT(3782),
  [8877] = {.count = 1, .reusable = true}, SHIFT(3783),
  [8879] = {.count = 1, .reusable = true}, SHIFT(3784),
  [8881] = {.count = 1, .reusable = true}, SHIFT(3785),
  [8883] = {.count = 1, .reusable = true}, SHIFT(3786),
  [8885] = {.count = 1, .reusable = true}, SHIFT(3787),
  [8887] = {.count = 1, .reusable = true}, SHIFT(3788),
  [8889] = {.count = 1, .reusable = true}, SHIFT(3789),
  [8891] = {.count = 1, .reusable = true}, SHIFT(3790),
  [8893] = {.count = 1, .reusable = true}, SHIFT(3791),
  [8895] = {.count = 1, .reusable = false}, SHIFT(3792),
  [8897] = {.count = 1, .reusable = true}, SHIFT(3792),
  [8899] = {.count = 1, .reusable = false}, SHIFT(3793),
  [8901] = {.count = 1, .reusable = true}, SHIFT(3793),
  [8903] = {.count = 1, .reusable = true}, SHIFT(3794),
  [8905] = {.count = 1, .reusable = true}, SHIFT(3795),
  [8907] = {.count = 1, .reusable = true}, SHIFT(3796),
  [8909] = {.count = 1, .reusable = true}, SHIFT(3797),
  [8911] = {.count = 1, .reusable = true}, SHIFT(3798),
  [8913] = {.count = 1, .reusable = true}, SHIFT(3799),
  [8915] = {.count = 1, .reusable = true}, SHIFT(3800),
  [8917] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [8919] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [8921] = {.count = 1, .reusable = true}, SHIFT(3802),
  [8923] = {.count = 1, .reusable = true}, SHIFT(3803),
  [8925] = {.count = 1, .reusable = true}, SHIFT(3804),
  [8927] = {.count = 1, .reusable = true}, SHIFT(3805),
  [8929] = {.count = 1, .reusable = true}, SHIFT(3807),
  [8931] = {.count = 1, .reusable = true}, SHIFT(3808),
  [8933] = {.count = 1, .reusable = true}, SHIFT(3809),
  [8935] = {.count = 1, .reusable = false}, SHIFT(3810),
  [8937] = {.count = 1, .reusable = true}, SHIFT(3811),
  [8939] = {.count = 1, .reusable = true}, SHIFT(3813),
  [8941] = {.count = 1, .reusable = true}, SHIFT(3814),
  [8943] = {.count = 1, .reusable = false}, SHIFT(3815),
  [8945] = {.count = 1, .reusable = true}, SHIFT(3815),
  [8947] = {.count = 1, .reusable = true}, SHIFT(3816),
  [8949] = {.count = 1, .reusable = false}, SHIFT(3817),
  [8951] = {.count = 1, .reusable = true}, SHIFT(3817),
  [8953] = {.count = 1, .reusable = true}, SHIFT(3818),
  [8955] = {.count = 1, .reusable = false}, SHIFT(3819),
  [8957] = {.count = 1, .reusable = true}, SHIFT(3819),
  [8959] = {.count = 1, .reusable = true}, SHIFT(3820),
  [8961] = {.count = 1, .reusable = true}, SHIFT(3821),
  [8963] = {.count = 1, .reusable = true}, SHIFT(3822),
  [8965] = {.count = 1, .reusable = false}, SHIFT(3823),
  [8967] = {.count = 1, .reusable = true}, SHIFT(3823),
  [8969] = {.count = 1, .reusable = false}, SHIFT(3824),
  [8971] = {.count = 1, .reusable = true}, SHIFT(3824),
  [8973] = {.count = 1, .reusable = true}, SHIFT(3825),
  [8975] = {.count = 1, .reusable = true}, SHIFT(3826),
  [8977] = {.count = 1, .reusable = true}, SHIFT(3827),
  [8979] = {.count = 1, .reusable = true}, SHIFT(3828),
  [8981] = {.count = 1, .reusable = false}, SHIFT(3829),
  [8983] = {.count = 1, .reusable = true}, SHIFT(3829),
  [8985] = {.count = 1, .reusable = false}, SHIFT(3830),
  [8987] = {.count = 1, .reusable = true}, SHIFT(3830),
  [8989] = {.count = 1, .reusable = true}, SHIFT(3831),
  [8991] = {.count = 1, .reusable = true}, SHIFT(3832),
  [8993] = {.count = 1, .reusable = true}, SHIFT(3833),
  [8995] = {.count = 1, .reusable = true}, SHIFT(3834),
  [8997] = {.count = 1, .reusable = true}, SHIFT(3835),
  [8999] = {.count = 1, .reusable = false}, SHIFT(3836),
  [9001] = {.count = 1, .reusable = true}, SHIFT(3837),
  [9003] = {.count = 1, .reusable = true}, SHIFT(3839),
  [9005] = {.count = 1, .reusable = true}, SHIFT(3840),
  [9007] = {.count = 1, .reusable = false}, SHIFT(3841),
  [9009] = {.count = 1, .reusable = true}, SHIFT(3841),
  [9011] = {.count = 1, .reusable = true}, SHIFT(3842),
  [9013] = {.count = 1, .reusable = false}, SHIFT(3843),
  [9015] = {.count = 1, .reusable = true}, SHIFT(3843),
  [9017] = {.count = 1, .reusable = true}, SHIFT(3844),
  [9019] = {.count = 1, .reusable = false}, SHIFT(3845),
  [9021] = {.count = 1, .reusable = true}, SHIFT(3845),
  [9023] = {.count = 1, .reusable = true}, SHIFT(3846),
  [9025] = {.count = 1, .reusable = true}, SHIFT(3847),
  [9027] = {.count = 1, .reusable = false}, SHIFT(3848),
  [9029] = {.count = 1, .reusable = true}, SHIFT(3849),
  [9031] = {.count = 1, .reusable = true}, SHIFT(3851),
  [9033] = {.count = 1, .reusable = true}, SHIFT(3852),
  [9035] = {.count = 1, .reusable = false}, SHIFT(3853),
  [9037] = {.count = 1, .reusable = true}, SHIFT(3853),
  [9039] = {.count = 1, .reusable = true}, SHIFT(3854),
  [9041] = {.count = 1, .reusable = false}, SHIFT(3855),
  [9043] = {.count = 1, .reusable = true}, SHIFT(3855),
  [9045] = {.count = 1, .reusable = true}, SHIFT(3856),
  [9047] = {.count = 1, .reusable = false}, SHIFT(3857),
  [9049] = {.count = 1, .reusable = true}, SHIFT(3857),
  [9051] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3231),
  [9054] = {.count = 1, .reusable = false}, SHIFT(3858),
  [9056] = {.count = 1, .reusable = true}, SHIFT(3859),
  [9058] = {.count = 1, .reusable = false}, SHIFT(3860),
  [9060] = {.count = 1, .reusable = true}, SHIFT(3861),
  [9062] = {.count = 1, .reusable = true}, SHIFT(3863),
  [9064] = {.count = 1, .reusable = true}, SHIFT(3864),
  [9066] = {.count = 1, .reusable = false}, SHIFT(3866),
  [9068] = {.count = 1, .reusable = true}, SHIFT(3866),
  [9070] = {.count = 1, .reusable = true}, SHIFT(3865),
  [9072] = {.count = 1, .reusable = false}, SHIFT(3868),
  [9074] = {.count = 1, .reusable = true}, SHIFT(3868),
  [9076] = {.count = 1, .reusable = true}, SHIFT(3867),
  [9078] = {.count = 1, .reusable = true}, SHIFT(3869),
  [9080] = {.count = 1, .reusable = true}, SHIFT(3870),
  [9082] = {.count = 1, .reusable = false}, SHIFT(3871),
  [9084] = {.count = 1, .reusable = true}, SHIFT(3871),
  [9086] = {.count = 1, .reusable = true}, SHIFT(3872),
  [9088] = {.count = 1, .reusable = true}, SHIFT(3873),
  [9090] = {.count = 1, .reusable = true}, SHIFT(3874),
  [9092] = {.count = 1, .reusable = true}, SHIFT(3875),
  [9094] = {.count = 1, .reusable = false}, SHIFT(3876),
  [9096] = {.count = 1, .reusable = true}, SHIFT(3877),
  [9098] = {.count = 1, .reusable = true}, SHIFT(3879),
  [9100] = {.count = 1, .reusable = true}, SHIFT(3880),
  [9102] = {.count = 1, .reusable = false}, SHIFT(3881),
  [9104] = {.count = 1, .reusable = true}, SHIFT(3881),
  [9106] = {.count = 1, .reusable = true}, SHIFT(3882),
  [9108] = {.count = 1, .reusable = false}, SHIFT(3883),
  [9110] = {.count = 1, .reusable = true}, SHIFT(3883),
  [9112] = {.count = 1, .reusable = true}, SHIFT(3884),
  [9114] = {.count = 1, .reusable = false}, SHIFT(3885),
  [9116] = {.count = 1, .reusable = true}, SHIFT(3885),
  [9118] = {.count = 1, .reusable = true}, SHIFT(3886),
  [9120] = {.count = 1, .reusable = true}, SHIFT(3887),
  [9122] = {.count = 1, .reusable = false}, SHIFT(3888),
  [9124] = {.count = 1, .reusable = true}, SHIFT(3889),
  [9126] = {.count = 1, .reusable = true}, SHIFT(3891),
  [9128] = {.count = 1, .reusable = true}, SHIFT(3892),
  [9130] = {.count = 1, .reusable = false}, SHIFT(3893),
  [9132] = {.count = 1, .reusable = true}, SHIFT(3893),
  [9134] = {.count = 1, .reusable = true}, SHIFT(3894),
  [9136] = {.count = 1, .reusable = false}, SHIFT(3895),
  [9138] = {.count = 1, .reusable = true}, SHIFT(3895),
  [9140] = {.count = 1, .reusable = true}, SHIFT(3896),
  [9142] = {.count = 1, .reusable = false}, SHIFT(3897),
  [9144] = {.count = 1, .reusable = true}, SHIFT(3897),
  [9146] = {.count = 1, .reusable = true}, SHIFT(3898),
  [9148] = {.count = 1, .reusable = true}, SHIFT(3899),
  [9150] = {.count = 1, .reusable = true}, SHIFT(3900),
  [9152] = {.count = 1, .reusable = false}, SHIFT(3901),
  [9154] = {.count = 1, .reusable = true}, SHIFT(3901),
  [9156] = {.count = 1, .reusable = false}, SHIFT(3902),
  [9158] = {.count = 1, .reusable = true}, SHIFT(3902),
  [9160] = {.count = 1, .reusable = true}, SHIFT(3903),
  [9162] = {.count = 1, .reusable = true}, SHIFT(3904),
  [9164] = {.count = 1, .reusable = true}, SHIFT(3905),
  [9166] = {.count = 1, .reusable = true}, SHIFT(3906),
  [9168] = {.count = 1, .reusable = false}, SHIFT(3907),
  [9170] = {.count = 1, .reusable = true}, SHIFT(3907),
  [9172] = {.count = 1, .reusable = false}, SHIFT(3908),
  [9174] = {.count = 1, .reusable = true}, SHIFT(3908),
  [9176] = {.count = 1, .reusable = true}, SHIFT(3909),
  [9178] = {.count = 1, .reusable = true}, SHIFT(3910),
  [9180] = {.count = 1, .reusable = true}, SHIFT(3911),
  [9182] = {.count = 1, .reusable = true}, SHIFT(3912),
  [9184] = {.count = 1, .reusable = false}, SHIFT(3913),
  [9186] = {.count = 1, .reusable = true}, SHIFT(3913),
  [9188] = {.count = 1, .reusable = false}, SHIFT(3914),
  [9190] = {.count = 1, .reusable = true}, SHIFT(3914),
  [9192] = {.count = 1, .reusable = true}, SHIFT(3915),
  [9194] = {.count = 1, .reusable = true}, SHIFT(3916),
  [9196] = {.count = 1, .reusable = true}, SHIFT(3917),
  [9198] = {.count = 1, .reusable = true}, SHIFT(3918),
  [9200] = {.count = 1, .reusable = true}, SHIFT(3920),
  [9202] = {.count = 1, .reusable = false}, SHIFT(3922),
  [9204] = {.count = 1, .reusable = false}, SHIFT(3923),
  [9206] = {.count = 1, .reusable = true}, SHIFT(3925),
  [9208] = {.count = 1, .reusable = true}, SHIFT(3926),
  [9210] = {.count = 1, .reusable = false}, SHIFT(3927),
  [9212] = {.count = 1, .reusable = true}, SHIFT(3927),
  [9214] = {.count = 1, .reusable = true}, SHIFT(3928),
  [9216] = {.count = 1, .reusable = true}, SHIFT(3929),
  [9218] = {.count = 1, .reusable = true}, SHIFT(3930),
  [9220] = {.count = 1, .reusable = false}, SHIFT(3931),
  [9222] = {.count = 1, .reusable = true}, SHIFT(3931),
  [9224] = {.count = 1, .reusable = true}, SHIFT(3936),
  [9226] = {.count = 1, .reusable = true}, SHIFT(3937),
  [9228] = {.count = 1, .reusable = true}, SHIFT(3938),
  [9230] = {.count = 1, .reusable = true}, SHIFT(3939),
  [9232] = {.count = 1, .reusable = true}, SHIFT(3940),
  [9234] = {.count = 1, .reusable = false}, SHIFT(3942),
  [9236] = {.count = 1, .reusable = false}, SHIFT(3943),
  [9238] = {.count = 1, .reusable = true}, SHIFT(3944),
  [9240] = {.count = 1, .reusable = true}, SHIFT(3945),
  [9242] = {.count = 1, .reusable = true}, SHIFT(3946),
  [9244] = {.count = 1, .reusable = false}, SHIFT(3947),
  [9246] = {.count = 1, .reusable = true}, SHIFT(3947),
  [9248] = {.count = 1, .reusable = true}, SHIFT(3948),
  [9250] = {.count = 1, .reusable = false}, SHIFT(3950),
  [9252] = {.count = 1, .reusable = true}, SHIFT(3950),
  [9254] = {.count = 1, .reusable = true}, SHIFT(3949),
  [9256] = {.count = 1, .reusable = true}, SHIFT(3951),
  [9258] = {.count = 1, .reusable = false}, SHIFT(3953),
  [9260] = {.count = 1, .reusable = true}, SHIFT(3953),
  [9262] = {.count = 1, .reusable = true}, SHIFT(3952),
  [9264] = {.count = 1, .reusable = true}, SHIFT(3954),
  [9266] = {.count = 1, .reusable = true}, SHIFT(3955),
  [9268] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3348),
  [9271] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3349),
  [9274] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3350),
  [9277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3351),
  [9280] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3352),
  [9283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3353),
  [9286] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3354),
  [9289] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3355),
  [9292] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3356),
  [9295] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3711),
  [9298] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3352),
  [9301] = {.count = 1, .reusable = true}, SHIFT(3956),
  [9303] = {.count = 1, .reusable = false}, SHIFT(3958),
  [9305] = {.count = 1, .reusable = false}, SHIFT(3959),
  [9307] = {.count = 1, .reusable = true}, SHIFT(3960),
  [9309] = {.count = 1, .reusable = true}, SHIFT(3961),
  [9311] = {.count = 1, .reusable = true}, SHIFT(3962),
  [9313] = {.count = 1, .reusable = false}, SHIFT(3963),
  [9315] = {.count = 1, .reusable = true}, SHIFT(3963),
  [9317] = {.count = 1, .reusable = true}, SHIFT(3964),
  [9319] = {.count = 1, .reusable = false}, SHIFT(3966),
  [9321] = {.count = 1, .reusable = true}, SHIFT(3966),
  [9323] = {.count = 1, .reusable = true}, SHIFT(3965),
  [9325] = {.count = 1, .reusable = true}, SHIFT(3967),
  [9327] = {.count = 1, .reusable = false}, SHIFT(3969),
  [9329] = {.count = 1, .reusable = true}, SHIFT(3969),
  [9331] = {.count = 1, .reusable = true}, SHIFT(3968),
  [9333] = {.count = 1, .reusable = true}, SHIFT(3970),
  [9335] = {.count = 1, .reusable = true}, SHIFT(3971),
  [9337] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3359),
  [9340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3360),
  [9343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3361),
  [9346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3362),
  [9349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3363),
  [9352] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3364),
  [9355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3365),
  [9358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3366),
  [9361] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3728),
  [9364] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3362),
  [9367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3368),
  [9370] = {.count = 1, .reusable = false}, SHIFT(3972),
  [9372] = {.count = 1, .reusable = true}, SHIFT(3973),
  [9374] = {.count = 1, .reusable = false}, SHIFT(3974),
  [9376] = {.count = 1, .reusable = true}, SHIFT(3975),
  [9378] = {.count = 1, .reusable = true}, SHIFT(3977),
  [9380] = {.count = 1, .reusable = true}, SHIFT(3978),
  [9382] = {.count = 1, .reusable = false}, SHIFT(3980),
  [9384] = {.count = 1, .reusable = true}, SHIFT(3980),
  [9386] = {.count = 1, .reusable = true}, SHIFT(3979),
  [9388] = {.count = 1, .reusable = false}, SHIFT(3982),
  [9390] = {.count = 1, .reusable = true}, SHIFT(3982),
  [9392] = {.count = 1, .reusable = true}, SHIFT(3981),
  [9394] = {.count = 1, .reusable = true}, SHIFT(3983),
  [9396] = {.count = 1, .reusable = true}, SHIFT(3984),
  [9398] = {.count = 1, .reusable = false}, SHIFT(3985),
  [9400] = {.count = 1, .reusable = true}, SHIFT(3985),
  [9402] = {.count = 1, .reusable = true}, SHIFT(3986),
  [9404] = {.count = 1, .reusable = true}, SHIFT(3987),
  [9406] = {.count = 1, .reusable = true}, SHIFT(3988),
  [9408] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3385),
  [9411] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3389),
  [9414] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3389),
  [9417] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3390),
  [9420] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3393),
  [9423] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3394),
  [9426] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2884),
  [9429] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2885),
  [9432] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3395),
  [9435] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2887),
  [9438] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2888),
  [9441] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2889),
  [9444] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2890),
  [9447] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3395),
  [9450] = {.count = 1, .reusable = false}, SHIFT(3990),
  [9452] = {.count = 1, .reusable = true}, SHIFT(3990),
  [9454] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [9456] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [9458] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [9460] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [9462] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [9464] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [9466] = {.count = 1, .reusable = true}, SHIFT(3991),
  [9468] = {.count = 1, .reusable = true}, SHIFT(3996),
  [9470] = {.count = 1, .reusable = true}, SHIFT(3998),
  [9472] = {.count = 1, .reusable = true}, SHIFT(3999),
  [9474] = {.count = 1, .reusable = true}, SHIFT(4001),
  [9476] = {.count = 1, .reusable = true}, SHIFT(4002),
  [9478] = {.count = 1, .reusable = true}, SHIFT(4003),
  [9480] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 10),
  [9482] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 10),
  [9484] = {.count = 1, .reusable = true}, SHIFT(4005),
  [9486] = {.count = 1, .reusable = true}, SHIFT(4006),
  [9488] = {.count = 1, .reusable = true}, SHIFT(4007),
  [9490] = {.count = 1, .reusable = false}, SHIFT(4008),
  [9492] = {.count = 1, .reusable = true}, SHIFT(4008),
  [9494] = {.count = 1, .reusable = false}, SHIFT(4009),
  [9496] = {.count = 1, .reusable = true}, SHIFT(4009),
  [9498] = {.count = 1, .reusable = true}, SHIFT(4010),
  [9500] = {.count = 1, .reusable = true}, SHIFT(4011),
  [9502] = {.count = 1, .reusable = true}, SHIFT(4012),
  [9504] = {.count = 1, .reusable = true}, SHIFT(4013),
  [9506] = {.count = 1, .reusable = true}, SHIFT(4014),
  [9508] = {.count = 1, .reusable = true}, SHIFT(4015),
  [9510] = {.count = 1, .reusable = true}, SHIFT(4016),
  [9512] = {.count = 1, .reusable = true}, SHIFT(4017),
  [9514] = {.count = 1, .reusable = false}, SHIFT(4018),
  [9516] = {.count = 1, .reusable = true}, SHIFT(4018),
  [9518] = {.count = 1, .reusable = false}, SHIFT(4019),
  [9520] = {.count = 1, .reusable = true}, SHIFT(4019),
  [9522] = {.count = 1, .reusable = true}, SHIFT(4020),
  [9524] = {.count = 1, .reusable = true}, SHIFT(4021),
  [9526] = {.count = 1, .reusable = true}, SHIFT(4022),
  [9528] = {.count = 1, .reusable = true}, SHIFT(4023),
  [9530] = {.count = 1, .reusable = false}, SHIFT(4024),
  [9532] = {.count = 1, .reusable = true}, SHIFT(4024),
  [9534] = {.count = 1, .reusable = false}, SHIFT(4025),
  [9536] = {.count = 1, .reusable = true}, SHIFT(4025),
  [9538] = {.count = 1, .reusable = true}, SHIFT(4026),
  [9540] = {.count = 1, .reusable = true}, SHIFT(4027),
  [9542] = {.count = 1, .reusable = true}, SHIFT(4028),
  [9544] = {.count = 1, .reusable = false}, SHIFT(4029),
  [9546] = {.count = 1, .reusable = true}, SHIFT(4030),
  [9548] = {.count = 1, .reusable = true}, SHIFT(4032),
  [9550] = {.count = 1, .reusable = true}, SHIFT(4033),
  [9552] = {.count = 1, .reusable = false}, SHIFT(4034),
  [9554] = {.count = 1, .reusable = true}, SHIFT(4034),
  [9556] = {.count = 1, .reusable = true}, SHIFT(4035),
  [9558] = {.count = 1, .reusable = false}, SHIFT(4036),
  [9560] = {.count = 1, .reusable = true}, SHIFT(4036),
  [9562] = {.count = 1, .reusable = true}, SHIFT(4037),
  [9564] = {.count = 1, .reusable = false}, SHIFT(4038),
  [9566] = {.count = 1, .reusable = true}, SHIFT(4038),
  [9568] = {.count = 1, .reusable = true}, SHIFT(4039),
  [9570] = {.count = 1, .reusable = true}, SHIFT(4040),
  [9572] = {.count = 1, .reusable = true}, SHIFT(4041),
  [9574] = {.count = 1, .reusable = false}, SHIFT(4042),
  [9576] = {.count = 1, .reusable = true}, SHIFT(4042),
  [9578] = {.count = 1, .reusable = false}, SHIFT(4043),
  [9580] = {.count = 1, .reusable = true}, SHIFT(4043),
  [9582] = {.count = 1, .reusable = true}, SHIFT(4044),
  [9584] = {.count = 1, .reusable = true}, SHIFT(4045),
  [9586] = {.count = 1, .reusable = true}, SHIFT(4046),
  [9588] = {.count = 1, .reusable = true}, SHIFT(4047),
  [9590] = {.count = 1, .reusable = false}, SHIFT(4048),
  [9592] = {.count = 1, .reusable = true}, SHIFT(4048),
  [9594] = {.count = 1, .reusable = false}, SHIFT(4049),
  [9596] = {.count = 1, .reusable = true}, SHIFT(4049),
  [9598] = {.count = 1, .reusable = true}, SHIFT(4050),
  [9600] = {.count = 1, .reusable = true}, SHIFT(4051),
  [9602] = {.count = 1, .reusable = true}, SHIFT(4052),
  [9604] = {.count = 1, .reusable = true}, SHIFT(4053),
  [9606] = {.count = 1, .reusable = true}, SHIFT(4054),
  [9608] = {.count = 1, .reusable = true}, SHIFT(4055),
  [9610] = {.count = 1, .reusable = true}, SHIFT(4056),
  [9612] = {.count = 1, .reusable = true}, SHIFT(4057),
  [9614] = {.count = 1, .reusable = true}, SHIFT(4058),
  [9616] = {.count = 1, .reusable = false}, SHIFT(4060),
  [9618] = {.count = 1, .reusable = false}, SHIFT(4061),
  [9620] = {.count = 1, .reusable = true}, SHIFT(4062),
  [9622] = {.count = 1, .reusable = true}, SHIFT(4063),
  [9624] = {.count = 1, .reusable = true}, SHIFT(4064),
  [9626] = {.count = 1, .reusable = false}, SHIFT(4065),
  [9628] = {.count = 1, .reusable = true}, SHIFT(4065),
  [9630] = {.count = 1, .reusable = true}, SHIFT(4066),
  [9632] = {.count = 1, .reusable = false}, SHIFT(4068),
  [9634] = {.count = 1, .reusable = true}, SHIFT(4068),
  [9636] = {.count = 1, .reusable = true}, SHIFT(4067),
  [9638] = {.count = 1, .reusable = true}, SHIFT(4069),
  [9640] = {.count = 1, .reusable = false}, SHIFT(4071),
  [9642] = {.count = 1, .reusable = true}, SHIFT(4071),
  [9644] = {.count = 1, .reusable = true}, SHIFT(4070),
  [9646] = {.count = 1, .reusable = true}, SHIFT(4072),
  [9648] = {.count = 1, .reusable = true}, SHIFT(4073),
  [9650] = {.count = 1, .reusable = true}, SHIFT(4074),
  [9652] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3695),
  [9655] = {.count = 1, .reusable = false}, SHIFT(4076),
  [9657] = {.count = 1, .reusable = true}, SHIFT(4077),
  [9659] = {.count = 1, .reusable = false}, SHIFT(4078),
  [9661] = {.count = 1, .reusable = true}, SHIFT(4079),
  [9663] = {.count = 1, .reusable = true}, SHIFT(4081),
  [9665] = {.count = 1, .reusable = true}, SHIFT(4082),
  [9667] = {.count = 1, .reusable = false}, SHIFT(4084),
  [9669] = {.count = 1, .reusable = true}, SHIFT(4084),
  [9671] = {.count = 1, .reusable = true}, SHIFT(4083),
  [9673] = {.count = 1, .reusable = false}, SHIFT(4086),
  [9675] = {.count = 1, .reusable = true}, SHIFT(4086),
  [9677] = {.count = 1, .reusable = true}, SHIFT(4085),
  [9679] = {.count = 1, .reusable = true}, SHIFT(4087),
  [9681] = {.count = 1, .reusable = true}, SHIFT(4088),
  [9683] = {.count = 1, .reusable = false}, SHIFT(4089),
  [9685] = {.count = 1, .reusable = true}, SHIFT(4089),
  [9687] = {.count = 1, .reusable = true}, SHIFT(4090),
  [9689] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3712),
  [9692] = {.count = 1, .reusable = false}, SHIFT(4091),
  [9694] = {.count = 1, .reusable = true}, SHIFT(4092),
  [9696] = {.count = 1, .reusable = false}, SHIFT(4093),
  [9698] = {.count = 1, .reusable = true}, SHIFT(4094),
  [9700] = {.count = 1, .reusable = true}, SHIFT(4096),
  [9702] = {.count = 1, .reusable = true}, SHIFT(4097),
  [9704] = {.count = 1, .reusable = false}, SHIFT(4099),
  [9706] = {.count = 1, .reusable = true}, SHIFT(4099),
  [9708] = {.count = 1, .reusable = true}, SHIFT(4098),
  [9710] = {.count = 1, .reusable = false}, SHIFT(4101),
  [9712] = {.count = 1, .reusable = true}, SHIFT(4101),
  [9714] = {.count = 1, .reusable = true}, SHIFT(4100),
  [9716] = {.count = 1, .reusable = true}, SHIFT(4102),
  [9718] = {.count = 1, .reusable = true}, SHIFT(4103),
  [9720] = {.count = 1, .reusable = false}, SHIFT(4104),
  [9722] = {.count = 1, .reusable = true}, SHIFT(4104),
  [9724] = {.count = 1, .reusable = true}, SHIFT(4105),
  [9726] = {.count = 1, .reusable = true}, SHIFT(4106),
  [9728] = {.count = 1, .reusable = true}, SHIFT(4107),
  [9730] = {.count = 1, .reusable = false}, SHIFT(4108),
  [9732] = {.count = 1, .reusable = true}, SHIFT(4109),
  [9734] = {.count = 1, .reusable = true}, SHIFT(4111),
  [9736] = {.count = 1, .reusable = true}, SHIFT(4112),
  [9738] = {.count = 1, .reusable = false}, SHIFT(4113),
  [9740] = {.count = 1, .reusable = true}, SHIFT(4113),
  [9742] = {.count = 1, .reusable = true}, SHIFT(4114),
  [9744] = {.count = 1, .reusable = false}, SHIFT(4115),
  [9746] = {.count = 1, .reusable = true}, SHIFT(4115),
  [9748] = {.count = 1, .reusable = true}, SHIFT(4116),
  [9750] = {.count = 1, .reusable = false}, SHIFT(4117),
  [9752] = {.count = 1, .reusable = true}, SHIFT(4117),
  [9754] = {.count = 1, .reusable = true}, SHIFT(4120),
  [9756] = {.count = 1, .reusable = true}, SHIFT(4121),
  [9758] = {.count = 1, .reusable = true}, SHIFT(4123),
  [9760] = {.count = 1, .reusable = true}, SHIFT(4124),
  [9762] = {.count = 1, .reusable = true}, SHIFT(4125),
  [9764] = {.count = 1, .reusable = true}, SHIFT(4126),
  [9766] = {.count = 1, .reusable = true}, SHIFT(4127),
  [9768] = {.count = 1, .reusable = true}, SHIFT(4128),
  [9770] = {.count = 1, .reusable = true}, SHIFT(4129),
  [9772] = {.count = 1, .reusable = true}, SHIFT(4130),
  [9774] = {.count = 1, .reusable = true}, SHIFT(4131),
  [9776] = {.count = 1, .reusable = false}, SHIFT(4132),
  [9778] = {.count = 1, .reusable = true}, SHIFT(4132),
  [9780] = {.count = 1, .reusable = false}, SHIFT(4133),
  [9782] = {.count = 1, .reusable = true}, SHIFT(4133),
  [9784] = {.count = 1, .reusable = true}, SHIFT(4134),
  [9786] = {.count = 1, .reusable = true}, SHIFT(4135),
  [9788] = {.count = 1, .reusable = true}, SHIFT(4136),
  [9790] = {.count = 1, .reusable = true}, SHIFT(4137),
  [9792] = {.count = 1, .reusable = true}, SHIFT(4138),
  [9794] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3920),
  [9797] = {.count = 1, .reusable = false}, SHIFT(4139),
  [9799] = {.count = 1, .reusable = true}, SHIFT(4140),
  [9801] = {.count = 1, .reusable = false}, SHIFT(4141),
  [9803] = {.count = 1, .reusable = true}, SHIFT(4142),
  [9805] = {.count = 1, .reusable = true}, SHIFT(4144),
  [9807] = {.count = 1, .reusable = true}, SHIFT(4145),
  [9809] = {.count = 1, .reusable = false}, SHIFT(4147),
  [9811] = {.count = 1, .reusable = true}, SHIFT(4147),
  [9813] = {.count = 1, .reusable = true}, SHIFT(4146),
  [9815] = {.count = 1, .reusable = false}, SHIFT(4149),
  [9817] = {.count = 1, .reusable = true}, SHIFT(4149),
  [9819] = {.count = 1, .reusable = true}, SHIFT(4148),
  [9821] = {.count = 1, .reusable = true}, SHIFT(4150),
  [9823] = {.count = 1, .reusable = true}, SHIFT(4151),
  [9825] = {.count = 1, .reusable = false}, SHIFT(4152),
  [9827] = {.count = 1, .reusable = true}, SHIFT(4152),
  [9829] = {.count = 1, .reusable = true}, SHIFT(4153),
  [9831] = {.count = 1, .reusable = true}, SHIFT(4154),
  [9833] = {.count = 1, .reusable = true}, SHIFT(4155),
  [9835] = {.count = 1, .reusable = true}, SHIFT(4156),
  [9837] = {.count = 1, .reusable = false}, SHIFT(4157),
  [9839] = {.count = 1, .reusable = true}, SHIFT(4158),
  [9841] = {.count = 1, .reusable = true}, SHIFT(4160),
  [9843] = {.count = 1, .reusable = true}, SHIFT(4161),
  [9845] = {.count = 1, .reusable = false}, SHIFT(4162),
  [9847] = {.count = 1, .reusable = true}, SHIFT(4162),
  [9849] = {.count = 1, .reusable = true}, SHIFT(4163),
  [9851] = {.count = 1, .reusable = false}, SHIFT(4164),
  [9853] = {.count = 1, .reusable = true}, SHIFT(4164),
  [9855] = {.count = 1, .reusable = true}, SHIFT(4165),
  [9857] = {.count = 1, .reusable = false}, SHIFT(4166),
  [9859] = {.count = 1, .reusable = true}, SHIFT(4166),
  [9861] = {.count = 1, .reusable = true}, SHIFT(4167),
  [9863] = {.count = 1, .reusable = true}, SHIFT(4168),
  [9865] = {.count = 1, .reusable = false}, SHIFT(4169),
  [9867] = {.count = 1, .reusable = true}, SHIFT(4170),
  [9869] = {.count = 1, .reusable = true}, SHIFT(4172),
  [9871] = {.count = 1, .reusable = true}, SHIFT(4173),
  [9873] = {.count = 1, .reusable = false}, SHIFT(4174),
  [9875] = {.count = 1, .reusable = true}, SHIFT(4174),
  [9877] = {.count = 1, .reusable = true}, SHIFT(4175),
  [9879] = {.count = 1, .reusable = false}, SHIFT(4176),
  [9881] = {.count = 1, .reusable = true}, SHIFT(4176),
  [9883] = {.count = 1, .reusable = true}, SHIFT(4177),
  [9885] = {.count = 1, .reusable = false}, SHIFT(4178),
  [9887] = {.count = 1, .reusable = true}, SHIFT(4178),
  [9889] = {.count = 1, .reusable = true}, SHIFT(4179),
  [9891] = {.count = 1, .reusable = true}, SHIFT(4180),
  [9893] = {.count = 1, .reusable = true}, SHIFT(4181),
  [9895] = {.count = 1, .reusable = false}, SHIFT(4182),
  [9897] = {.count = 1, .reusable = true}, SHIFT(4182),
  [9899] = {.count = 1, .reusable = false}, SHIFT(4183),
  [9901] = {.count = 1, .reusable = true}, SHIFT(4183),
  [9903] = {.count = 1, .reusable = true}, SHIFT(4184),
  [9905] = {.count = 1, .reusable = true}, SHIFT(4185),
  [9907] = {.count = 1, .reusable = true}, SHIFT(4186),
  [9909] = {.count = 1, .reusable = true}, SHIFT(4187),
  [9911] = {.count = 1, .reusable = true}, SHIFT(4188),
  [9913] = {.count = 1, .reusable = false}, SHIFT(4189),
  [9915] = {.count = 1, .reusable = true}, SHIFT(4190),
  [9917] = {.count = 1, .reusable = true}, SHIFT(4192),
  [9919] = {.count = 1, .reusable = true}, SHIFT(4193),
  [9921] = {.count = 1, .reusable = false}, SHIFT(4194),
  [9923] = {.count = 1, .reusable = true}, SHIFT(4194),
  [9925] = {.count = 1, .reusable = true}, SHIFT(4195),
  [9927] = {.count = 1, .reusable = false}, SHIFT(4196),
  [9929] = {.count = 1, .reusable = true}, SHIFT(4196),
  [9931] = {.count = 1, .reusable = true}, SHIFT(4197),
  [9933] = {.count = 1, .reusable = false}, SHIFT(4198),
  [9935] = {.count = 1, .reusable = true}, SHIFT(4198),
  [9937] = {.count = 1, .reusable = true}, SHIFT(4199),
  [9939] = {.count = 1, .reusable = true}, SHIFT(4200),
  [9941] = {.count = 1, .reusable = true}, SHIFT(4201),
  [9943] = {.count = 1, .reusable = false}, SHIFT(4202),
  [9945] = {.count = 1, .reusable = true}, SHIFT(4202),
  [9947] = {.count = 1, .reusable = false}, SHIFT(4203),
  [9949] = {.count = 1, .reusable = true}, SHIFT(4203),
  [9951] = {.count = 1, .reusable = true}, SHIFT(4204),
  [9953] = {.count = 1, .reusable = true}, SHIFT(4205),
  [9955] = {.count = 1, .reusable = true}, SHIFT(4206),
  [9957] = {.count = 1, .reusable = true}, SHIFT(4207),
  [9959] = {.count = 1, .reusable = false}, SHIFT(4208),
  [9961] = {.count = 1, .reusable = true}, SHIFT(4208),
  [9963] = {.count = 1, .reusable = false}, SHIFT(4209),
  [9965] = {.count = 1, .reusable = true}, SHIFT(4209),
  [9967] = {.count = 1, .reusable = true}, SHIFT(4210),
  [9969] = {.count = 1, .reusable = true}, SHIFT(4211),
  [9971] = {.count = 1, .reusable = true}, SHIFT(4212),
  [9973] = {.count = 1, .reusable = true}, SHIFT(4213),
  [9975] = {.count = 1, .reusable = true}, SHIFT(4214),
  [9977] = {.count = 1, .reusable = true}, SHIFT(4215),
  [9979] = {.count = 1, .reusable = false}, SHIFT(4216),
  [9981] = {.count = 1, .reusable = true}, SHIFT(4216),
  [9983] = {.count = 1, .reusable = false}, SHIFT(4217),
  [9985] = {.count = 1, .reusable = true}, SHIFT(4217),
  [9987] = {.count = 1, .reusable = true}, SHIFT(4218),
  [9989] = {.count = 1, .reusable = true}, SHIFT(4219),
  [9991] = {.count = 1, .reusable = true}, SHIFT(4220),
  [9993] = {.count = 1, .reusable = true}, SHIFT(4221),
  [9995] = {.count = 1, .reusable = true}, SHIFT(4222),
  [9997] = {.count = 1, .reusable = true}, SHIFT(4223),
  [9999] = {.count = 1, .reusable = true}, SHIFT(4224),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
